/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/base/common/types","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/observableInternal/base","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/assert","vs/base/common/equals","vs/base/common/map","vs/base/common/numbers","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/observable","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(se){for(var t=[],i=0,T=se.length;i<T;i++)t[i]=be[se[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:Kt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Rt}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,i,T){return t.apply(i,T)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Rt||(Rt=function(t,i){return new t(...i)});const oi=ct(Array.prototype.forEach),zt=ct(Array.prototype.pop),wt=ct(Array.prototype.push),Dt=ct(String.prototype.toLowerCase),It=ct(String.prototype.toString),ai=ct(String.prototype.match),dt=ct(String.prototype.replace),li=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),vt=ui(TypeError);function ct(se){return function(t){for(var i=arguments.length,T=new Array(i>1?i-1:0),O=1;O<i;O++)T[O-1]=arguments[O];return Nt(se,t,T)}}function ui(se){return function(){for(var t=arguments.length,i=new Array(t),T=0;T<t;T++)i[T]=arguments[T];return Rt(se,i)}}function xe(se,t,i){var T;i=(T=i)!==null&&T!==void 0?T:Dt,Kt&&Kt(se,null);let O=t.length;for(;O--;){let H=t[O];if(typeof H=="string"){const S=i(H);S!==H&&(ii(t)||(t[O]=S),H=S)}se[H]=!0}return se}function bt(se){const t=ri(null);for(const[i,T]of Bt(se))t[i]=T;return t}function Et(se,t){for(;se!==null;){const T=si(se,t);if(T){if(T.get)return ct(T.get);if(typeof T.value=="function")return ct(T.value)}se=ni(se)}function i(T){return console.warn("fallback value for",T),null}return i}const xt=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Mt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),jt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ht=ot(["#text"]),Wt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ot=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Vt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),St=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),qt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Gt=ft(/^html$/i);var Yt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Gt});const vi=()=>typeof window>"u"?null:window,yi=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let T=null;const O="data-tt-policy-suffix";i&&i.hasAttribute(O)&&(T=i.getAttribute(O));const H="dompurify"+(T?"#"+T:"");try{return t.createPolicy(H,{createHTML(S){return S},createScriptURL(S){return S}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function Xt(){let se=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Be=>Xt(Be);if(t.version="3.0.5",t.removed=[],!se||!se.document||se.document.nodeType!==9)return t.isSupported=!1,t;const i=se.document,T=i.currentScript;let{document:O}=se;const{DocumentFragment:H,HTMLTemplateElement:S,Node:A,Element:m,NodeFilter:b,NamedNodeMap:p=se.NamedNodeMap||se.MozNamedAttrMap,HTMLFormElement:j,DOMParser:c,trustedTypes:f}=se,e=m.prototype,n=Et(e,"cloneNode"),r=Et(e,"nextSibling"),h=Et(e,"childNodes"),g=Et(e,"parentNode");if(typeof S=="function"){const Be=O.createElement("template");Be.content&&Be.content.ownerDocument&&(O=Be.content.ownerDocument)}let y,o="";const{implementation:d,createNodeIterator:a,createDocumentFragment:k,getElementsByTagName:N}=O,{importNode:R}=i;let L={};t.isSupported=typeof Bt=="function"&&typeof g=="function"&&d&&d.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:P,ERB_EXPR:E,TMPLIT_EXPR:z,DATA_ATTR:W,ARIA_ATTR:F,IS_SCRIPT_OR_DATA:K,ATTR_WHITESPACE:B}=Yt;let{IS_ALLOWED_URI:G}=Yt,V=null;const ae=xe({},[...xt,...Lt,...Mt,...jt,...Ht]);let ie=null;const ee=xe({},[...Wt,...Ot,...Vt,...St]);let ge=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Ee=null,De=null,Le=!0,he=!0,_=!1,ue=!0,le=!1,Q=!1,U=!1,re=!1,me=!1,ve=!1,Ne=!1,Te=!0,Me=!1;const x="user-content-";let u=!0,v=!1,l={},w=null;const C=xe({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let s=null;const D=xe({},["audio","video","img","source","image","track"]);let $=null;const I=xe({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),M="http://www.w3.org/1998/Math/MathML",Y="http://www.w3.org/2000/svg",J="http://www.w3.org/1999/xhtml";let oe=J,we=!1,fe=null;const Ie=xe({},[M,Y,J],It);let ke;const Oe=["application/xhtml+xml","text/html"],Se="text/html";let Ce,He=null;const Ue=O.createElement("form"),Xe=function(ce){return ce instanceof RegExp||ce instanceof Function},_e=function(ce){if(!(He&&He===ce)){if((!ce||typeof ce!="object")&&(ce={}),ce=bt(ce),ke=Oe.indexOf(ce.PARSER_MEDIA_TYPE)===-1?ke=Se:ke=ce.PARSER_MEDIA_TYPE,Ce=ke==="application/xhtml+xml"?It:Dt,V="ALLOWED_TAGS"in ce?xe({},ce.ALLOWED_TAGS,Ce):ae,ie="ALLOWED_ATTR"in ce?xe({},ce.ALLOWED_ATTR,Ce):ee,fe="ALLOWED_NAMESPACES"in ce?xe({},ce.ALLOWED_NAMESPACES,It):Ie,$="ADD_URI_SAFE_ATTR"in ce?xe(bt(I),ce.ADD_URI_SAFE_ATTR,Ce):I,s="ADD_DATA_URI_TAGS"in ce?xe(bt(D),ce.ADD_DATA_URI_TAGS,Ce):D,w="FORBID_CONTENTS"in ce?xe({},ce.FORBID_CONTENTS,Ce):C,Ee="FORBID_TAGS"in ce?xe({},ce.FORBID_TAGS,Ce):{},De="FORBID_ATTR"in ce?xe({},ce.FORBID_ATTR,Ce):{},l="USE_PROFILES"in ce?ce.USE_PROFILES:!1,Le=ce.ALLOW_ARIA_ATTR!==!1,he=ce.ALLOW_DATA_ATTR!==!1,_=ce.ALLOW_UNKNOWN_PROTOCOLS||!1,ue=ce.ALLOW_SELF_CLOSE_IN_ATTR!==!1,le=ce.SAFE_FOR_TEMPLATES||!1,Q=ce.WHOLE_DOCUMENT||!1,me=ce.RETURN_DOM||!1,ve=ce.RETURN_DOM_FRAGMENT||!1,Ne=ce.RETURN_TRUSTED_TYPE||!1,re=ce.FORCE_BODY||!1,Te=ce.SANITIZE_DOM!==!1,Me=ce.SANITIZE_NAMED_PROPS||!1,u=ce.KEEP_CONTENT!==!1,v=ce.IN_PLACE||!1,G=ce.ALLOWED_URI_REGEXP||qt,oe=ce.NAMESPACE||J,ge=ce.CUSTOM_ELEMENT_HANDLING||{},ce.CUSTOM_ELEMENT_HANDLING&&Xe(ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ge.tagNameCheck=ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&Xe(ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ge.attributeNameCheck=ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&typeof ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ge.allowCustomizedBuiltInElements=ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),le&&(he=!1),ve&&(me=!0),l&&(V=xe({},[...Ht]),ie=[],l.html===!0&&(xe(V,xt),xe(ie,Wt)),l.svg===!0&&(xe(V,Lt),xe(ie,Ot),xe(ie,St)),l.svgFilters===!0&&(xe(V,Mt),xe(ie,Ot),xe(ie,St)),l.mathMl===!0&&(xe(V,jt),xe(ie,Vt),xe(ie,St))),ce.ADD_TAGS&&(V===ae&&(V=bt(V)),xe(V,ce.ADD_TAGS,Ce)),ce.ADD_ATTR&&(ie===ee&&(ie=bt(ie)),xe(ie,ce.ADD_ATTR,Ce)),ce.ADD_URI_SAFE_ATTR&&xe($,ce.ADD_URI_SAFE_ATTR,Ce),ce.FORBID_CONTENTS&&(w===C&&(w=bt(w)),xe(w,ce.FORBID_CONTENTS,Ce)),u&&(V["#text"]=!0),Q&&xe(V,["html","head","body"]),V.table&&(xe(V,["tbody"]),delete Ee.tbody),ce.TRUSTED_TYPES_POLICY){if(typeof ce.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ce.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');y=ce.TRUSTED_TYPES_POLICY,o=y.createHTML("")}else y===void 0&&(y=yi(f,T)),y!==null&&typeof o=="string"&&(o=y.createHTML(""));ot&&ot(ce),He=ce}},Z=xe({},["mi","mo","mn","ms","mtext"]),ne=xe({},["foreignobject","desc","title","annotation-xml"]),pe=xe({},["title","style","font","a","script"]),ye=xe({},Lt);xe(ye,Mt),xe(ye,ci);const Re=xe({},jt);xe(Re,fi);const ze=function(ce){let Fe=g(ce);(!Fe||!Fe.tagName)&&(Fe={namespaceURI:oe,tagName:"template"});const je=Dt(ce.tagName),Ge=Dt(Fe.tagName);return fe[ce.namespaceURI]?ce.namespaceURI===Y?Fe.namespaceURI===J?je==="svg":Fe.namespaceURI===M?je==="svg"&&(Ge==="annotation-xml"||Z[Ge]):!!ye[je]:ce.namespaceURI===M?Fe.namespaceURI===J?je==="math":Fe.namespaceURI===Y?je==="math"&&ne[Ge]:!!Re[je]:ce.namespaceURI===J?Fe.namespaceURI===Y&&!ne[Ge]||Fe.namespaceURI===M&&!Z[Ge]?!1:!Re[je]&&(pe[je]||!ye[je]):!!(ke==="application/xhtml+xml"&&fe[ce.namespaceURI]):!1},We=function(ce){wt(t.removed,{element:ce});try{ce.parentNode.removeChild(ce)}catch{ce.remove()}},et=function(ce,Fe){try{wt(t.removed,{attribute:Fe.getAttributeNode(ce),from:Fe})}catch{wt(t.removed,{attribute:null,from:Fe})}if(Fe.removeAttribute(ce),ce==="is"&&!ie[ce])if(me||ve)try{We(Fe)}catch{}else try{Fe.setAttribute(ce,"")}catch{}},it=function(ce){let Fe,je;if(re)ce="<remove></remove>"+ce;else{const lt=ai(ce,/^[\r\n\t ]+/);je=lt&&lt[0]}ke==="application/xhtml+xml"&&oe===J&&(ce='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ce+"</body></html>");const Ge=y?y.createHTML(ce):ce;if(oe===J)try{Fe=new c().parseFromString(Ge,ke)}catch{}if(!Fe||!Fe.documentElement){Fe=d.createDocument(oe,"template",null);try{Fe.documentElement.innerHTML=we?o:Ge}catch{}}const nt=Fe.body||Fe.documentElement;return ce&&je&&nt.insertBefore(O.createTextNode(je),nt.childNodes[0]||null),oe===J?N.call(Fe,Q?"html":"body")[0]:Q?Fe.documentElement:nt},st=function(ce){return a.call(ce.ownerDocument||ce,ce,b.SHOW_ELEMENT|b.SHOW_COMMENT|b.SHOW_TEXT,null,!1)},Qe=function(ce){return ce instanceof j&&(typeof ce.nodeName!="string"||typeof ce.textContent!="string"||typeof ce.removeChild!="function"||!(ce.attributes instanceof p)||typeof ce.removeAttribute!="function"||typeof ce.setAttribute!="function"||typeof ce.namespaceURI!="string"||typeof ce.insertBefore!="function"||typeof ce.hasChildNodes!="function")},rt=function(ce){return typeof A=="object"?ce instanceof A:ce&&typeof ce=="object"&&typeof ce.nodeType=="number"&&typeof ce.nodeName=="string"},tt=function(ce,Fe,je){L[ce]&&oi(L[ce],Ge=>{Ge.call(t,Fe,je,He)})},mt=function(ce){let Fe;if(tt("beforeSanitizeElements",ce,null),Qe(ce))return We(ce),!0;const je=Ce(ce.nodeName);if(tt("uponSanitizeElement",ce,{tagName:je,allowedTags:V}),ce.hasChildNodes()&&!rt(ce.firstElementChild)&&(!rt(ce.content)||!rt(ce.content.firstElementChild))&&ht(/<[/\w]/g,ce.innerHTML)&&ht(/<[/\w]/g,ce.textContent))return We(ce),!0;if(!V[je]||Ee[je]){if(!Ee[je]&&At(je)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,je)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(je)))return!1;if(u&&!w[je]){const Ge=g(ce)||ce.parentNode,nt=h(ce)||ce.childNodes;if(nt&&Ge){const lt=nt.length;for(let Ze=lt-1;Ze>=0;--Ze)Ge.insertBefore(n(nt[Ze],!0),r(ce))}}return We(ce),!0}return ce instanceof m&&!ze(ce)||(je==="noscript"||je==="noembed"||je==="noframes")&&ht(/<\/no(script|embed|frames)/i,ce.innerHTML)?(We(ce),!0):(le&&ce.nodeType===3&&(Fe=ce.textContent,Fe=dt(Fe,P," "),Fe=dt(Fe,E," "),Fe=dt(Fe,z," "),ce.textContent!==Fe&&(wt(t.removed,{element:ce.cloneNode()}),ce.textContent=Fe)),tt("afterSanitizeElements",ce,null),!1)},gt=function(ce,Fe,je){if(Te&&(Fe==="id"||Fe==="name")&&(je in O||je in Ue))return!1;if(!(he&&!De[Fe]&&ht(W,Fe))){if(!(Le&&ht(F,Fe))){if(!ie[Fe]||De[Fe]){if(!(At(ce)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,ce)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(ce))&&(ge.attributeNameCheck instanceof RegExp&&ht(ge.attributeNameCheck,Fe)||ge.attributeNameCheck instanceof Function&&ge.attributeNameCheck(Fe))||Fe==="is"&&ge.allowCustomizedBuiltInElements&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,je)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(je))))return!1}else if(!$[Fe]){if(!ht(G,dt(je,B,""))){if(!((Fe==="src"||Fe==="xlink:href"||Fe==="href")&&ce!=="script"&&li(je,"data:")===0&&s[ce])){if(!(_&&!ht(K,dt(je,B,"")))){if(je)return!1}}}}}}return!0},At=function(ce){return ce.indexOf("-")>0},kt=function(ce){let Fe,je,Ge,nt;tt("beforeSanitizeAttributes",ce,null);const{attributes:lt}=ce;if(!lt)return;const Ze={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ie};for(nt=lt.length;nt--;){Fe=lt[nt];const{name:ut,namespaceURI:$t}=Fe;if(je=ut==="value"?Fe.value:hi(Fe.value),Ge=Ce(ut),Ze.attrName=Ge,Ze.attrValue=je,Ze.keepAttr=!0,Ze.forceKeepAttr=void 0,tt("uponSanitizeAttribute",ce,Ze),je=Ze.attrValue,Ze.forceKeepAttr||(et(ut,ce),!Ze.keepAttr))continue;if(!ue&&ht(/\/>/i,je)){et(ut,ce);continue}le&&(je=dt(je,P," "),je=dt(je,E," "),je=dt(je,z," "));const Ct=Ce(ce.nodeName);if(gt(Ct,Ge,je)){if(Me&&(Ge==="id"||Ge==="name")&&(et(ut,ce),je=x+je),y&&typeof f=="object"&&typeof f.getAttributeType=="function"&&!$t)switch(f.getAttributeType(Ct,Ge)){case"TrustedHTML":{je=y.createHTML(je);break}case"TrustedScriptURL":{je=y.createScriptURL(je);break}}try{$t?ce.setAttributeNS($t,ut,je):ce.setAttribute(ut,je),zt(t.removed)}catch{}}}tt("afterSanitizeAttributes",ce,null)},Tt=function Be(ce){let Fe;const je=st(ce);for(tt("beforeSanitizeShadowDOM",ce,null);Fe=je.nextNode();)tt("uponSanitizeShadowNode",Fe,null),!mt(Fe)&&(Fe.content instanceof H&&Be(Fe.content),kt(Fe));tt("afterSanitizeShadowDOM",ce,null)};return t.sanitize=function(Be){let ce=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Fe,je,Ge,nt;if(we=!Be,we&&(Be="<!-->"),typeof Be!="string"&&!rt(Be))if(typeof Be.toString=="function"){if(Be=Be.toString(),typeof Be!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!t.isSupported)return Be;if(U||_e(ce),t.removed=[],typeof Be=="string"&&(v=!1),v){if(Be.nodeName){const ut=Ce(Be.nodeName);if(!V[ut]||Ee[ut])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(Be instanceof A)Fe=it("<!---->"),je=Fe.ownerDocument.importNode(Be,!0),je.nodeType===1&&je.nodeName==="BODY"||je.nodeName==="HTML"?Fe=je:Fe.appendChild(je);else{if(!me&&!le&&!Q&&Be.indexOf("<")===-1)return y&&Ne?y.createHTML(Be):Be;if(Fe=it(Be),!Fe)return me?null:Ne?o:""}Fe&&re&&We(Fe.firstChild);const lt=st(v?Be:Fe);for(;Ge=lt.nextNode();)mt(Ge)||(Ge.content instanceof H&&Tt(Ge.content),kt(Ge));if(v)return Be;if(me){if(ve)for(nt=k.call(Fe.ownerDocument);Fe.firstChild;)nt.appendChild(Fe.firstChild);else nt=Fe;return(ie.shadowroot||ie.shadowrootmode)&&(nt=R.call(i,nt,!0)),nt}let Ze=Q?Fe.outerHTML:Fe.innerHTML;return Q&&V["!doctype"]&&Fe.ownerDocument&&Fe.ownerDocument.doctype&&Fe.ownerDocument.doctype.name&&ht(Gt,Fe.ownerDocument.doctype.name)&&(Ze="<!DOCTYPE "+Fe.ownerDocument.doctype.name+`>
`+Ze),le&&(Ze=dt(Ze,P," "),Ze=dt(Ze,E," "),Ze=dt(Ze,z," ")),y&&Ne?y.createHTML(Ze):Ze},t.setConfig=function(Be){_e(Be),U=!0},t.clearConfig=function(){He=null,U=!1},t.isValidAttribute=function(Be,ce,Fe){He||_e({});const je=Ce(Be),Ge=Ce(ce);return gt(je,Ge,Fe)},t.addHook=function(Be,ce){typeof ce=="function"&&(L[Be]=L[Be]||[],wt(L[Be],ce))},t.removeHook=function(Be){if(L[Be])return zt(L[Be])},t.removeHooks=function(Be){L[Be]&&(L[Be]=[])},t.removeAllHooks=function(){L={}},t}var Di=Xt();define("vs/base/browser/dompurify/dompurify",function(){return Di}),define(be[51],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eT=void 0,t.$fT=O;class i{constructor(S){this.domNode=S,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(S){const A=T(S);this.a!==A&&(this.a=A,this.domNode.style.maxWidth=this.a)}setWidth(S){const A=T(S);this.b!==A&&(this.b=A,this.domNode.style.width=this.b)}setHeight(S){const A=T(S);this.c!==A&&(this.c=A,this.domNode.style.height=this.c)}setTop(S){const A=T(S);this.d!==A&&(this.d=A,this.domNode.style.top=this.d)}setLeft(S){const A=T(S);this.e!==A&&(this.e=A,this.domNode.style.left=this.e)}setBottom(S){const A=T(S);this.f!==A&&(this.f=A,this.domNode.style.bottom=this.f)}setRight(S){const A=T(S);this.g!==A&&(this.g=A,this.domNode.style.right=this.g)}setPaddingTop(S){const A=T(S);this.h!==A&&(this.h=A,this.domNode.style.paddingTop=this.h)}setPaddingLeft(S){const A=T(S);this.i!==A&&(this.i=A,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(S){const A=T(S);this.j!==A&&(this.j=A,this.domNode.style.paddingBottom=this.j)}setPaddingRight(S){const A=T(S);this.k!==A&&(this.k=A,this.domNode.style.paddingRight=this.k)}setFontFamily(S){this.l!==S&&(this.l=S,this.domNode.style.fontFamily=this.l)}setFontWeight(S){this.m!==S&&(this.m=S,this.domNode.style.fontWeight=this.m)}setFontSize(S){const A=T(S);this.n!==A&&(this.n=A,this.domNode.style.fontSize=this.n)}setFontStyle(S){this.o!==S&&(this.o=S,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(S){this.p!==S&&(this.p=S,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(S){this.q!==S&&(this.q=S,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(S){this.r!==S&&(this.r=S,this.domNode.style.textDecoration=this.r)}setLineHeight(S){const A=T(S);this.s!==A&&(this.s=A,this.domNode.style.lineHeight=this.s)}setLetterSpacing(S){const A=T(S);this.t!==A&&(this.t=A,this.domNode.style.letterSpacing=this.t)}setClassName(S){this.u!==S&&(this.u=S,this.domNode.className=this.u)}toggleClassName(S,A){this.domNode.classList.toggle(S,A),this.u=this.domNode.className}setDisplay(S){this.v!==S&&(this.v=S,this.domNode.style.display=this.v)}setPosition(S){this.w!==S&&(this.w=S,this.domNode.style.position=this.w)}setVisibility(S){this.x!==S&&(this.x=S,this.domNode.style.visibility=this.x)}setColor(S){this.y!==S&&(this.y=S,this.domNode.style.color=this.y)}setBackgroundColor(S){this.z!==S&&(this.z=S,this.domNode.style.backgroundColor=this.z)}setLayerHinting(S){this.A!==S&&(this.A=S,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(S){this.C!==S&&(this.C=S,this.domNode.style.boxShadow=S)}setContain(S){this.B!==S&&(this.B=S,this.domNode.style.contain=this.B)}setAttribute(S,A){this.domNode.setAttribute(S,A)}removeAttribute(S){this.domNode.removeAttribute(S)}appendChild(S){this.domNode.appendChild(S.domNode)}removeChild(S){this.domNode.removeChild(S.domNode)}}t.$eT=i;function T(H){return typeof H=="number"?`${H}px`:H}function O(H){return new i(H)}}),define(be[79],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wR=void 0,t.$xR=H;const i=new WeakMap;function T(A){if(!A.parent||A.parent===A)return null;try{const m=A.location,b=A.parent.location;if(m.origin!=="null"&&b.origin!=="null"&&m.origin!==b.origin)return null}catch{return null}return A.parent}class O{static a(m){let b=i.get(m);if(!b){b=[],i.set(m,b);let p=m,j;do j=T(p),j?b.push({window:new WeakRef(p),iframeElement:p.frameElement||null}):b.push({window:new WeakRef(p),iframeElement:null}),p=j;while(p)}return b.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(m,b){if(!b||m===b)return{top:0,left:0};let p=0,j=0;const c=this.a(m);for(const f of c){const e=f.window.deref();if(p+=e?.scrollY??0,j+=e?.scrollX??0,e===b||!f.iframeElement)break;const n=f.iframeElement.getBoundingClientRect();p+=n.top,j+=n.left}return{top:p,left:j}}}t.$wR=O;async function H(A,m){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const b=JSON.stringify({parentOrigin:A,salt:m}),j=new TextEncoder().encode(b),c=await crypto.subtle.digest("sha-256",j);return S(c)}function S(A){const b=Array.from(new Uint8Array(A)).map(p=>p.toString(16).padStart(2,"0")).join("");return BigInt(`0x${b}`).toString(32).padStart(52,"0")}}),define(be[29],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jU=T,t.$kU=O;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupUpdatableHover:()=>null};function T(H){i=H}function O(){return i}}),define(be[80],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YT=t.$XT=t.$WT=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(S){S[S.Copy=0]="Copy",S[S.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var T;(function(S){S.Over="drop-target",S.Before="drop-target-before",S.After="drop-target-after"})(T||(t.ListDragOverEffectPosition=T={})),t.$WT={reject(){return{accept:!1}},accept(){return{accept:!0}}};class O extends Error{constructor(A,m){super(`ListError [${A}] ${m}`)}}t.$XT=O;class H{constructor(){this.c=new WeakMap}getHeight(A){return this.c.get(A)??this.d(A)}setDynamicHeight(A,m){m>0&&this.c.set(A,m)}}t.$YT=H}),define(be[81],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MT=void 0;class i{constructor(O){this.a=O}splice(O,H,S){this.a.forEach(A=>A.splice(O,H,S))}}t.$MT=i}),define(be[52],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kT=void 0;const i=20;class T{constructor(H,S,A,m,b,p){this.a=Math.round(S),this.b=Math.round(A),this.c=Math.round(H),this.d=m,this.e=b,this.f=p,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new T(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const S=Math.round(H);return this.d!==S?(this.d=S,this.m(),!0):!1}setScrollSize(H){const S=Math.round(H);return this.e!==S?(this.e=S,this.m(),!0):!1}setScrollPosition(H){const S=Math.round(H);return this.f!==S?(this.f=S,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,S,A,m,b){const p=Math.max(0,A-H),j=Math.max(0,p-2*S),c=m>0&&m>A;if(!c)return{computedAvailableSize:Math.round(p),computedIsNeeded:c,computedSliderSize:Math.round(j),computedSliderRatio:0,computedSliderPosition:0};const f=Math.round(Math.max(i,Math.floor(A*j/m))),e=(j-f)/(m-A),n=b*e;return{computedAvailableSize:Math.round(p),computedIsNeeded:c,computedSliderSize:Math.round(f),computedSliderRatio:e,computedSliderPosition:Math.round(n)}}m(){const H=T.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const S=H-this.c-this.i/2;return Math.round(S/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const S=H-this.c;let A=this.f;return S<this.k?A-=this.d:A+=this.d,A}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const S=this.k+H;return Math.round(S/this.j)}}t.$kT=T}),define(be[30],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TV=t.$SV=t.$RV=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var i;(function(m){m[m.Hidden=0]="Hidden",m[m.Visible=1]="Visible",m[m.Recurse=2]="Recurse"})(i||(t.TreeVisibility=i={}));var T;(function(m){m[m.Expanded=0]="Expanded",m[m.Collapsed=1]="Collapsed",m[m.PreserveOrExpanded=2]="PreserveOrExpanded",m[m.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(T||(t.ObjectTreeElementCollapseState=T={}));var O;(function(m){m[m.Unknown=0]="Unknown",m[m.Twistie=1]="Twistie",m[m.Element=2]="Element",m[m.Filter=3]="Filter"})(O||(t.TreeMouseEventTarget=O={}));var H;(function(m){m[m.Down=0]="Down",m[m.Up=1]="Up"})(H||(t.TreeDragOverBubble=H={})),t.$RV={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(m=!1){return{accept:!0,bubble:0,autoExpand:m}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(m=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:m}}};class S extends Error{constructor(b,p){super(`TreeError [${b}] ${p}`)}}t.$SV=S;class A{constructor(b){this.a=b,this.b=new WeakMap}map(b){let p=this.b.get(b);return p||(p=this.a(b),this.b.set(b,p)),p}}t.$TV=A}),define(be[22],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aR=void 0,t.$_Q=i,t.$bR=T;function i(O,H){const S=O;typeof S.vscodeWindowId!="number"&&Object.defineProperty(S,"vscodeWindowId",{get:()=>H})}t.$aR=window;function T(O){return O===t.$aR?!1:typeof O?.vscodeWindowId=="number"}}),define(be[82],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=T,t.$hb=O,t.$ib=H,t.$jb=S,t.$kb=A,t.$lb=m,t.$nb=p,t.$ob=j,t.$pb=c,t.$qb=f,t.$rb=e;function i(n,r){const h=T(n,r);if(h!==-1)return n[h]}function T(n,r,h=n.length-1){for(let g=h;g>=0;g--){const y=n[g];if(r(y))return g}return-1}function O(n,r){const h=H(n,r);return h===-1?void 0:n[h]}function H(n,r,h=0,g=n.length){let y=h,o=g;for(;y<o;){const d=Math.floor((y+o)/2);r(n[d])?y=d+1:o=d}return y-1}function S(n,r){const h=A(n,r);return h===n.length?void 0:n[h]}function A(n,r,h=0,g=n.length){let y=h,o=g;for(;y<o;){const d=Math.floor((y+o)/2);r(n[d])?o=d:y=d+1}return y}function m(n,r,h=0,g=n.length){const y=A(n,r,h,g);return y===n.length?-1:y}class b{static{this.assertInvariants=!1}constructor(r){this.e=r,this.c=0}findLastMonotonous(r){if(b.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!r(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=r}const h=H(this.e,r,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}t.$mb=b;function p(n,r){if(n.length===0)return;let h=n[0];for(let g=1;g<n.length;g++){const y=n[g];r(y,h)>0&&(h=y)}return h}function j(n,r){if(n.length===0)return;let h=n[0];for(let g=1;g<n.length;g++){const y=n[g];r(y,h)>=0&&(h=y)}return h}function c(n,r){return p(n,(h,g)=>-r(h,g))}function f(n,r){if(n.length===0)return-1;let h=0;for(let g=1;g<n.length;g++){const y=n[g];r(y,n[h])>0&&(h=g)}return h}function e(n,r){for(const h of n){const g=r(h);if(g!==void 0)return g}}}),define(be[83],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=T,t.$M=O,t.$N=H;function i(S,A){const m=Object.create(null);for(const b of S){const p=A(b);let j=m[p];j||(j=m[p]=[]),j.push(b)}return m}function T(S,A){const m=[],b=[];for(const p of S)A.has(p)||m.push(p);for(const p of A)S.has(p)||b.push(p);return{removed:m,added:b}}function O(S,A){const m=[],b=[];for(const[p,j]of S)A.has(p)||m.push(j);for(const[p,j]of A)S.has(p)||b.push(j);return{removed:m,added:b}}function H(S,A){const m=new Set;for(const b of A)S.has(b)&&m.add(b);return m}}),define(be[84],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ft=t.$Et=t.$Dt=t.$Ct=void 0;function i(A,m){const b=Math.pow(10,m);return Math.round(A*b)/b}class T{constructor(m,b,p,j=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,b))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=i(Math.max(Math.min(1,j),0),3)}static equals(m,b){return m.r===b.r&&m.g===b.g&&m.b===b.b&&m.a===b.a}}t.$Ct=T;class O{constructor(m,b,p,j){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=i(Math.max(Math.min(1,b),0),3),this.l=i(Math.max(Math.min(1,p),0),3),this.a=i(Math.max(Math.min(1,j),0),3)}static equals(m,b){return m.h===b.h&&m.s===b.s&&m.l===b.l&&m.a===b.a}static fromRGBA(m){const b=m.r/255,p=m.g/255,j=m.b/255,c=m.a,f=Math.max(b,p,j),e=Math.min(b,p,j);let n=0,r=0;const h=(e+f)/2,g=f-e;if(g>0){switch(r=Math.min(h<=.5?g/(2*h):g/(2-2*h),1),f){case b:n=(p-j)/g+(p<j?6:0);break;case p:n=(j-b)/g+2;break;case j:n=(b-p)/g+4;break}n*=60,n=Math.round(n)}return new O(n,r,h,c)}static i(m,b,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?m+(b-m)*6*p:p<1/2?b:p<2/3?m+(b-m)*(2/3-p)*6:m}static toRGBA(m){const b=m.h/360,{s:p,l:j,a:c}=m;let f,e,n;if(p===0)f=e=n=j;else{const r=j<.5?j*(1+p):j+p-j*p,h=2*j-r;f=O.i(h,r,b+1/3),e=O.i(h,r,b),n=O.i(h,r,b-1/3)}return new T(Math.round(f*255),Math.round(e*255),Math.round(n*255),c)}}t.$Dt=O;class H{constructor(m,b,p,j){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=i(Math.max(Math.min(1,b),0),3),this.v=i(Math.max(Math.min(1,p),0),3),this.a=i(Math.max(Math.min(1,j),0),3)}static equals(m,b){return m.h===b.h&&m.s===b.s&&m.v===b.v&&m.a===b.a}static fromRGBA(m){const b=m.r/255,p=m.g/255,j=m.b/255,c=Math.max(b,p,j),f=Math.min(b,p,j),e=c-f,n=c===0?0:e/c;let r;return e===0?r=0:c===b?r=((p-j)/e%6+6)%6:c===p?r=(j-b)/e+2:r=(b-p)/e+4,new H(Math.round(r*60),n,c,m.a)}static toRGBA(m){const{h:b,s:p,v:j,a:c}=m,f=j*p,e=f*(1-Math.abs(b/60%2-1)),n=j-f;let[r,h,g]=[0,0,0];return b<60?(r=f,h=e):b<120?(r=e,h=f):b<180?(h=f,g=e):b<240?(h=e,g=f):b<300?(r=e,g=f):b<=360&&(r=f,g=e),r=Math.round((r+n)*255),h=Math.round((h+n)*255),g=Math.round((g+n)*255),new T(r,h,g,c)}}t.$Et=H;class S{static fromHex(m){return S.Format.CSS.parseHex(m)||S.red}static equals(m,b){return!m&&!b?!0:!m||!b?!1:m.equals(b)}get hsla(){return this.i?this.i:O.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(m){if(m)if(m instanceof T)this.rgba=m;else if(m instanceof O)this.i=m,this.rgba=O.toRGBA(m);else if(m instanceof H)this.j=m,this.rgba=H.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(m){return!!m&&T.equals(this.rgba,m.rgba)&&O.equals(this.hsla,m.hsla)&&H.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=S.k(this.rgba.r),b=S.k(this.rgba.g),p=S.k(this.rgba.b),j=.2126*m+.7152*b+.0722*p;return i(j,4)}static k(m){const b=m/255;return b<=.03928?b/12.92:Math.pow((b+.055)/1.055,2.4)}getContrastRatio(m){const b=this.getRelativeLuminance(),p=m.getRelativeLuminance();return b>p?(b+.05)/(p+.05):(p+.05)/(b+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const b=this.getRelativeLuminance(),p=m.getRelativeLuminance();return b>p}isDarkerThan(m){const b=this.getRelativeLuminance(),p=m.getRelativeLuminance();return b<p}lighten(m){return new S(new O(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new S(new O(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:b,g:p,b:j,a:c}=this.rgba;return new S(new T(b,p,j,c*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new S(new T(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const b=m.rgba,p=this.rgba.a,j=b.a,c=p+j*(1-p);if(c<1e-6)return S.transparent;const f=this.rgba.r*p/c+b.r*j*(1-p)/c,e=this.rgba.g*p/c+b.g*j*(1-p)/c,n=this.rgba.b*p/c+b.b*j*(1-p)/c;return new S(new T(f,e,n,c))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:b,g:p,b:j,a:c}=this.rgba;return new S(new T(m.rgba.r-c*(m.rgba.r-b),m.rgba.g-c*(m.rgba.g-p),m.rgba.b-c*(m.rgba.b-j),1))}flatten(...m){const b=m.reduceRight((p,j)=>S.o(j,p));return S.o(this,b)}static o(m,b){const p=1-m.rgba.a;return new S(new T(p*b.rgba.r+m.rgba.a*m.rgba.r,p*b.rgba.g+m.rgba.a*m.rgba.g,p*b.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this.u||(this.u=S.Format.CSS.format(this)),this.u}static getLighterColor(m,b,p){if(m.isLighterThan(b))return m;p=p||.5;const j=m.getRelativeLuminance(),c=b.getRelativeLuminance();return p=p*(c-j)/c,m.lighten(p)}static getDarkerColor(m,b,p){if(m.isDarkerThan(b))return m;p=p||.5;const j=m.getRelativeLuminance(),c=b.getRelativeLuminance();return p=p*(j-c)/j,m.darken(p)}static{this.white=new S(new T(255,255,255,1))}static{this.black=new S(new T(0,0,0,1))}static{this.red=new S(new T(255,0,0,1))}static{this.blue=new S(new T(0,0,255,1))}static{this.green=new S(new T(0,255,0,1))}static{this.cyan=new S(new T(0,255,255,1))}static{this.lightgrey=new S(new T(211,211,211,1))}static{this.transparent=new S(new T(0,0,0,0))}}t.$Ft=S,function(A){let m;(function(b){let p;(function(j){function c(a){return a.rgba.a===1?`rgb(${a.rgba.r}, ${a.rgba.g}, ${a.rgba.b})`:A.Format.CSS.formatRGBA(a)}j.formatRGB=c;function f(a){return`rgba(${a.rgba.r}, ${a.rgba.g}, ${a.rgba.b}, ${+a.rgba.a.toFixed(2)})`}j.formatRGBA=f;function e(a){return a.hsla.a===1?`hsl(${a.hsla.h}, ${(a.hsla.s*100).toFixed(2)}%, ${(a.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(a)}j.formatHSL=e;function n(a){return`hsla(${a.hsla.h}, ${(a.hsla.s*100).toFixed(2)}%, ${(a.hsla.l*100).toFixed(2)}%, ${a.hsla.a.toFixed(2)})`}j.formatHSLA=n;function r(a){const k=a.toString(16);return k.length!==2?"0"+k:k}function h(a){return`#${r(a.rgba.r)}${r(a.rgba.g)}${r(a.rgba.b)}`}j.formatHex=h;function g(a,k=!1){return k&&a.rgba.a===1?A.Format.CSS.formatHex(a):`#${r(a.rgba.r)}${r(a.rgba.g)}${r(a.rgba.b)}${r(Math.round(a.rgba.a*255))}`}j.formatHexA=g;function y(a){return a.isOpaque()?A.Format.CSS.formatHex(a):A.Format.CSS.formatRGBA(a)}j.format=y;function o(a){const k=a.length;if(k===0||a.charCodeAt(0)!==35)return null;if(k===7){const N=16*d(a.charCodeAt(1))+d(a.charCodeAt(2)),R=16*d(a.charCodeAt(3))+d(a.charCodeAt(4)),L=16*d(a.charCodeAt(5))+d(a.charCodeAt(6));return new A(new T(N,R,L,1))}if(k===9){const N=16*d(a.charCodeAt(1))+d(a.charCodeAt(2)),R=16*d(a.charCodeAt(3))+d(a.charCodeAt(4)),L=16*d(a.charCodeAt(5))+d(a.charCodeAt(6)),P=16*d(a.charCodeAt(7))+d(a.charCodeAt(8));return new A(new T(N,R,L,P/255))}if(k===4){const N=d(a.charCodeAt(1)),R=d(a.charCodeAt(2)),L=d(a.charCodeAt(3));return new A(new T(16*N+N,16*R+R,16*L+L))}if(k===5){const N=d(a.charCodeAt(1)),R=d(a.charCodeAt(2)),L=d(a.charCodeAt(3)),P=d(a.charCodeAt(4));return new A(new T(16*N+N,16*R+R,16*L+L,(16*P+P)/255))}return null}j.parseHex=o;function d(a){switch(a){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=b.CSS||(b.CSS={}))})(m=A.Format||(A.Format={}))}(S||(t.$Ft=S={}))}),define(be[31],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uh=T,t.$Vh=O,t.$Wh=H;function i(S){return(A,m,b)=>{let p=null,j=null;if(typeof b.value=="function"?(p="value",j=b.value):typeof b.get=="function"&&(p="get",j=b.get),!j)throw new Error("not supported");b[p]=S(j,m)}}function T(S,A,m){let b=null,p=null;if(typeof m.value=="function"?(b="value",p=m.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(b="get",p=m.get),!p)throw new Error("not supported");const j=`$memoize$${A}`;m[b]=function(...c){return this.hasOwnProperty(j)||Object.defineProperty(this,j,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,c)}),this[j]}}function O(S,A,m){return i((b,p)=>{const j=`$debounce$${p}`,c=`$debounce$result$${p}`;return function(...f){this[c]||(this[c]=m?m():void 0),clearTimeout(this[j]),A&&(this[c]=A(this[c],...f),f=[this[c]]),this[j]=setTimeout(()=>{b.apply(this,f),this[c]=m?m():void 0},S)}})}function H(S,A,m){return i((b,p)=>{const j=`$throttle$timer$${p}`,c=`$throttle$result$${p}`,f=`$throttle$lastRun$${p}`,e=`$throttle$pending$${p}`;return function(...n){if(this[c]||(this[c]=m?m():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),A&&(this[c]=A(this[c],...n)),this[e])return;const r=this[f]+S;r<=Date.now()?(this[f]=Date.now(),b.apply(this,[this[c]]),this[c]=m?m():void 0):(this[e]=!0,this[j]=setTimeout(()=>{this[e]=!1,this[f]=Date.now(),b.apply(this,[this[c]]),this[c]=m?m():void 0},r-Date.now()))}})}}),define(be[85],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nt=void 0;class i{constructor(O,H,S,A){this.originalStart=O,this.originalLength=H,this.modifiedStart=S,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$nt=i}),define(be[6],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=T,t.$Z=O,t.$1=H,t.$2=S,t.$3=A,t.$4=b,t.$6=j,t.$7=c,t.$8=f,t.$0=n;class i{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?y.isErrorNoTelemetry(a)?new y(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(k=>{k(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}t.$W=i,t.$X=new i;function T(d){t.$X.setUnexpectedErrorHandler(d)}function O(d){if(!d||typeof d!="object")return!1;const a=d;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}function H(d){b(d)||t.$X.onUnexpectedError(d)}function S(d){b(d)||t.$X.onUnexpectedExternalError(d)}function A(d){if(d instanceof Error){const{name:a,message:k}=d,N=d.stacktrace||d.stack;return{$isError:!0,name:a,message:k,stack:N,noTelemetry:y.isErrorNoTelemetry(d)}}return d}const m="Canceled";function b(d){return d instanceof p?!0:d instanceof Error&&d.name===m&&d.message===m}class p extends Error{constructor(){super(m),this.name=this.message}}t.$5=p;function j(){const d=new Error(m);return d.name=d.message,d}function c(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}function f(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}class e extends TypeError{constructor(a){super(a?`${a} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function n(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}class r extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}t.$$=r;class h extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}t.$_=h;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=g;class y extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof y)return a;const k=new y;return k.message=a.message,k.stack=a.stack,k}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}t.$bb=y;class o extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}t.$cb=o}),define(be[8],$e([1,0,6,82]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=O,t.$tb=H,t.$ub=S,t.$vb=A,t.$wb=m,t.$xb=b,t.$yb=p,t.$zb=j,t.$Ab=c,t.$Bb=f,t.$Cb=e,t.$Db=n,t.$Eb=r,t.top=h,t.$Gb=g,t.$Hb=o,t.$Ib=d,t.$Jb=a,t.$Kb=k,t.$Lb=N,t.$Mb=R,t.$Nb=L,t.$Ob=P,t.$Pb=E,t.$Qb=z,t.$Rb=W,t.$Sb=F,t.$Tb=K,t.$Ub=B,t.$Vb=G,t.$Wb=V,t.$Xb=ae,t.$Yb=ie,t.$Zb=ee,t.$1b=ge,t.$2b=Ee,t.$3b=De,t.$4b=Le,t.$5b=he,t.$6b=_,t.$7b=Q,t.$8b=U,t.$$b=ve;function O(x,u=0){return x[x.length-(1+u)]}function H(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function S(x,u,v=(l,w)=>l===w){if(x===u)return!0;if(!x||!u||x.length!==u.length)return!1;for(let l=0,w=x.length;l<w;l++)if(!v(x[l],u[l]))return!1;return!0}function A(x,u){const v=x.length-1;u<v&&(x[u]=x[v]),x.pop()}function m(x,u,v){return b(x.length,l=>v(x[l],u))}function b(x,u){let v=0,l=x-1;for(;v<=l;){const w=(v+l)/2|0,C=u(w);if(C<0)v=w+1;else if(C>0)l=w-1;else return w}return-(v+1)}function p(x,u,v){if(x=x|0,x>=u.length)throw new TypeError("invalid index");const l=u[Math.floor(u.length*Math.random())],w=[],C=[],s=[];for(const D of u){const $=v(D,l);$<0?w.push(D):$>0?C.push(D):s.push(D)}return x<w.length?p(x,w,v):x<w.length+s.length?s[0]:p(x-(w.length+s.length),C,v)}function j(x,u){const v=[];let l;for(const w of x.slice(0).sort(u))!l||u(l[0],w)!==0?(l=[w],v.push(l)):l.push(w);return v}function*c(x,u){let v,l;for(const w of x)l!==void 0&&u(l,w)?v.push(w):(v&&(yield v),v=[w]),l=w;v&&(yield v)}function f(x,u){for(let v=0;v<=x.length;v++)u(v===0?void 0:x[v-1],v===x.length?void 0:x[v])}function e(x,u){for(let v=0;v<x.length;v++)u(v===0?void 0:x[v-1],x[v],v+1===x.length?void 0:x[v+1])}function n(x,u,v){const l=[];function w(D,$,I){if($===0&&I.length===0)return;const M=l[l.length-1];M&&M.start+M.deleteCount===D?(M.deleteCount+=$,M.toInsert.push(...I)):l.push({start:D,deleteCount:$,toInsert:I})}let C=0,s=0;for(;;){if(C===x.length){w(C,0,u.slice(s));break}if(s===u.length){w(C,x.length-C,[]);break}const D=x[C],$=u[s],I=v(D,$);I===0?(C+=1,s+=1):I<0?(w(C,1,[]),C+=1):I>0&&(w(C,0,[$]),s+=1)}return l}function r(x,u,v){const l=n(x,u,v),w=[],C=[];for(const s of l)w.push(...x.slice(s.start,s.start+s.deleteCount)),C.push(...s.toInsert);return{removed:w,added:C}}function h(x,u,v){if(v===0)return[];const l=x.slice(0,v).sort(u);return y(x,u,l,v,x.length),l}function g(x,u,v,l,w){return v===0?Promise.resolve([]):new Promise((C,s)=>{(async()=>{const D=x.length,$=x.slice(0,v).sort(u);for(let I=v,M=Math.min(v+l,D);I<D;I=M,M=Math.min(M+l,D)){if(I>v&&await new Promise(Y=>setTimeout(Y)),w&&w.isCancellationRequested)throw new i.$5;y(x,u,$,I,M)}return $})().then(C,s)})}function y(x,u,v,l,w){for(const C=v.length;l<w;l++){const s=x[l];if(u(s,v[C-1])<0){v.pop();const D=(0,T.$kb)(v,$=>u(s,$)<0);v.splice(D,0,s)}}}function o(x){return x.filter(u=>!!u)}function d(x){let u=0;for(let v=0;v<x.length;v++)x[v]&&(x[u]=x[v],u+=1);x.length=u}function a(x,u,v){x.splice(v,0,x.splice(u,1)[0])}function k(x){return!Array.isArray(x)||x.length===0}function N(x){return Array.isArray(x)&&x.length>0}function R(x,u=v=>v){const v=new Set;return x.filter(l=>{const w=u(l);return v.has(w)?!1:(v.add(w),!0)})}function L(x){const u=new Set;return v=>{const l=x(v);return u.has(l)?!1:(u.add(l),!0)}}function P(x,u){return x.length>0?x[0]:u}function E(x,u){return x.length>0?x[x.length-1]:u}function z(x,u,v=(l,w)=>l===w){let l=0;for(let w=0,C=Math.min(x.length,u.length);w<C&&v(x[w],u[w]);w++)l++;return l}function W(x){return[].concat(...x)}function F(x,u){let v=typeof u=="number"?x:0;typeof u=="number"?v=x:(v=0,u=x);const l=[];if(v<=u)for(let w=v;w<u;w++)l.push(w);else for(let w=v;w>u;w--)l.push(w);return l}function K(x,u,v){return x.reduce((l,w)=>(l[u(w)]=v?v(w):w,l),Object.create(null))}function B(x,u){return x.push(u),()=>G(x,u)}function G(x,u){const v=x.indexOf(u);if(v>-1)return x.splice(v,1),u}function V(x,u,v){const l=x.slice(0,u),w=x.slice(u);return l.concat(v,w)}function ae(x,u){let v;if(typeof u=="number"){let l=u;v=()=>{const w=Math.sin(l++)*179426549;return w-Math.floor(w)}}else v=Math.random;for(let l=x.length-1;l>0;l-=1){const w=Math.floor(v()*(l+1)),C=x[l];x[l]=x[w],x[w]=C}}function ie(x,u){const v=x.indexOf(u);v>-1&&(x.splice(v,1),x.unshift(u))}function ee(x,u){const v=x.indexOf(u);v>-1&&(x.splice(v,1),x.push(u))}function ge(x,u){for(const v of u)x.push(v)}function Ee(x,u){return Array.isArray(x)?x.map(u):u(x)}function De(x){return Array.isArray(x)?x:[x]}function Le(x){return x[Math.floor(Math.random()*x.length)]}function he(x,u,v){const l=ue(x,u),w=x.length,C=v.length;x.length=w+C;for(let s=w-1;s>=l;s--)x[s+C]=x[s];for(let s=0;s<C;s++)x[s+l]=v[s]}function _(x,u,v,l){const w=ue(x,u);let C=x.splice(w,v);return C===void 0&&(C=[]),he(x,w,l),C}function ue(x,u){return u<0?Math.max(u+x.length,0):Math.min(u,x.length)}var le;(function(x){function u(C){return C<0}x.isLessThan=u;function v(C){return C<=0}x.isLessThanOrEqual=v;function l(C){return C>0}x.isGreaterThan=l;function w(C){return C===0}x.isNeitherLessOrGreaterThan=w,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(le||(t.CompareResult=le={}));function Q(x,u){return(v,l)=>u(x(v),x(l))}function U(...x){return(u,v)=>{for(const l of x){const w=l(u,v);if(!le.isNeitherLessOrGreaterThan(w))return w}return le.neitherLessOrGreaterThan}}const re=(x,u)=>x-u;t.$9b=re;const me=(x,u)=>(0,t.$9b)(x?1:0,u?1:0);t.$0b=me;function ve(x){return(u,v)=>-x(u,v)}class Ne{constructor(u){this.g=u,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(u){let v=this.c;for(;v<this.g.length&&u(this.g[v]);)v++;const l=v===this.c?null:this.g.slice(this.c,v);return this.c=v,l}takeFromEndWhile(u){let v=this.d;for(;v>=0&&u(this.g[v]);)v--;const l=v===this.d?null:this.g.slice(v+1,this.d+1);return this.d=v,l}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const u=this.g[this.c];return this.c++,u}removeLast(){const u=this.g[this.d];return this.d--,u}takeCount(u){const v=this.g.slice(this.c,this.c+u);return this.c+=u,v}}t.$_b=Ne;class Te{static{this.empty=new Te(u=>{})}constructor(u){this.iterate=u}forEach(u){this.iterate(v=>(u(v),!0))}toArray(){const u=[];return this.iterate(v=>(u.push(v),!0)),u}filter(u){return new Te(v=>this.iterate(l=>u(l)?v(l):!0))}map(u){return new Te(v=>this.iterate(l=>v(u(l))))}some(u){let v=!1;return this.iterate(l=>(v=u(l),!v)),v}findFirst(u){let v;return this.iterate(l=>u(l)?(v=l,!1):!0),v}findLast(u){let v;return this.iterate(l=>(u(l)&&(v=l),!0)),v}findLastMaxBy(u){let v,l=!0;return this.iterate(w=>((l||le.isGreaterThan(u(w,v)))&&(l=!1,v=w),!0)),v}}t.$ac=Te;class Me{constructor(u){this.c=u}static createSortPermutation(u,v){const l=Array.from(u.keys()).sort((w,C)=>v(u[w],u[C]));return new Me(l)}apply(u){return u.map((v,l)=>u[this.c[l]])}inverse(){const u=this.c.slice();for(let v=0;v<this.c.length;v++)u[this.c[v]]=v;return new Me(u)}}t.$bc=Me}),define(be[37],$e([1,0,6]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=T,t.$cd=O,t.$dd=H,t.$ed=S,t.$fd=A,t.$gd=m;function T(b,p){if(!b)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}function O(b,p="Unreachable"){throw new Error(p)}function H(b){if(!b)throw new i.$cb("Assertion Failed")}function S(b){b||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function A(b){if(!b()){debugger;b(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function m(b,p){let j=0;for(;j<b.length-1;){const c=b[j],f=b[j+1];if(!p(c,f))return!1;j++}return!0}}),define(be[38],$e([1,0,8]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0,t.$7c=O,t.$8c=H,t.$9c=S,t.$0c=A;const T=(m,b)=>m===b;t.$6c=T;function O(m=t.$6c){return(b,p)=>i.$ub(b,p,m)}function H(){return(m,b)=>JSON.stringify(m)===JSON.stringify(b)}function S(){return(m,b)=>m.equals(b)}function A(m,b,p){return!m||!b?m===b:p(m,b)}}),define(be[53],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(T,O){const H=this;let S=!1,A;return function(){if(S)return A;if(S=!0,O)try{A=T.apply(H,arguments)}finally{O()}else A=T.apply(H,arguments);return A}}}),define(be[86],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jP=t.$iP=void 0;class i{constructor(O){this.a=O,this.b=0}nextId(){return this.a+ ++this.b}}t.$iP=i,t.$jP=new i("id#")}),define(be[32],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(T){function O(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}T.is=O;const H=Object.freeze([]);function S(){return H}T.empty=S;function*A(a){yield a}T.single=A;function m(a){return O(a)?a:A(a)}T.wrap=m;function b(a){return a||H}T.from=b;function*p(a){for(let k=a.length-1;k>=0;k--)yield a[k]}T.reverse=p;function j(a){return!a||a[Symbol.iterator]().next().done===!0}T.isEmpty=j;function c(a){return a[Symbol.iterator]().next().value}T.first=c;function f(a,k){for(const N of a)if(k(N))return!0;return!1}T.some=f;function e(a,k){for(const N of a)if(k(N))return N}T.find=e;function*n(a,k){for(const N of a)k(N)&&(yield N)}T.filter=n;function*r(a,k){let N=0;for(const R of a)yield k(R,N++)}T.map=r;function*h(...a){for(const k of a)yield*k}T.concat=h;function g(a,k,N){let R=N;for(const L of a)R=k(R,L);return R}T.reduce=g;function*y(a,k,N=a.length){for(k<0&&(k+=a.length),N<0?N+=a.length:N>a.length&&(N=a.length);k<N;k++)yield a[k]}T.slice=y;function o(a,k=Number.POSITIVE_INFINITY){const N=[];if(k===0)return[N,a];const R=a[Symbol.iterator]();for(let L=0;L<k;L++){const P=R.next();if(P.done)return[N,T.empty()];N.push(P.value)}return[N,{[Symbol.iterator](){return R}}]}T.consume=o;async function d(a){const k=[];for await(const N of a)k.push(N);return Promise.resolve(k)}T.asyncToArray=d})(i||(t.Iterable=i={}))}),define(be[54],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$vr=t.$ur=t.$tr=t.$sr=t.$rr=t.ScanCode=t.KeyCode=void 0,t.$wr=f;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(T||(t.ScanCode=T={}));class O{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(n,r){this._keyCodeToStr[n]=r,this._strToKeyCode[r.toLowerCase()]=n}keyCodeToStr(n){return this._keyCodeToStr[n]}strToKeyCode(n){return this._strToKeyCode[n.toLowerCase()]||0}}const H=new O,S=new O,A=new O;t.$rr=new Array(230),t.$sr={};const m=[],b=Object.create(null),p=Object.create(null);t.$tr={lowerCaseToEnum:e=>p[e]||0,toEnum:e=>b[e]||0,toString:e=>m[e]||"None"},t.$ur=[],t.$vr=[];for(let e=0;e<=193;e++)t.$ur[e]=-1;for(let e=0;e<=132;e++)t.$vr[e]=-1;(function(){const e="",n=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],r=[],h=[];for(const g of n){const[y,o,d,a,k,N,R,L,P]=g;if(h[o]||(h[o]=!0,m[o]=d,b[d]=o,p[d.toLowerCase()]=o,y&&(t.$ur[o]=a,a!==0&&a!==3&&a!==5&&a!==4&&a!==6&&a!==57&&(t.$vr[a]=o))),!r[a]){if(r[a]=!0,!k)throw new Error(`String representation missing for key code ${a} around scan code ${d}`);H.define(a,k),S.define(a,L||k),A.define(a,P||L||k)}N&&(t.$rr[N]=a),R&&(t.$sr[R]=a)}t.$vr[3]=46})();var j;(function(e){function n(d){return H.keyCodeToStr(d)}e.toString=n;function r(d){return H.strToKeyCode(d)}e.fromString=r;function h(d){return S.keyCodeToStr(d)}e.toUserSettingsUS=h;function g(d){return A.keyCodeToStr(d)}e.toUserSettingsGeneral=g;function y(d){return S.strToKeyCode(d)||A.strToKeyCode(d)}e.fromUserSettings=y;function o(d){if(d>=98&&d<=113)return null;switch(d){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(d)}e.toElectronAccelerator=o})(j||(t.KeyCodeUtils=j={}));var c;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(c||(t.KeyMod=c={}));function f(e,n){const r=(n&65535)<<16>>>0;return(e|r)>>>0}}),define(be[87],$e([1,0,6]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dr=t.$Cr=t.$Br=t.$Ar=t.$zr=void 0,t.$xr=O,t.$yr=H;var T;(function(j){j[j.CtrlCmd=2048]="CtrlCmd",j[j.Shift=1024]="Shift",j[j.Alt=512]="Alt",j[j.WinCtrl=256]="WinCtrl",j[j.KeyCode=255]="KeyCode"})(T||(T={}));function O(j,c){if(typeof j=="number"){if(j===0)return null;const f=(j&65535)>>>0,e=(j&4294901760)>>>16;return e!==0?new m([H(f,c),H(e,c)]):new m([H(f,c)])}else{const f=[];for(let e=0;e<j.length;e++)f.push(H(j[e],c));return new m(f)}}function H(j,c){const f=!!(j&2048),e=!!(j&256),n=c===2?e:f,r=!!(j&1024),h=!!(j&512),g=c===2?f:e,y=j&255;return new S(n,r,h,g,y)}class S{constructor(c,f,e,n,r){this.ctrlKey=c,this.shiftKey=f,this.altKey=e,this.metaKey=n,this.keyCode=r}equals(c){return c instanceof S&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`K${c}${f}${e}${n}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$zr=S;class A{constructor(c,f,e,n,r){this.ctrlKey=c,this.shiftKey=f,this.altKey=e,this.metaKey=n,this.scanCode=r}equals(c){return c instanceof A&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.scanCode===c.scanCode}getHashCode(){const c=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`S${c}${f}${e}${n}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Ar=A;class m{constructor(c){if(c.length===0)throw(0,i.$7)("chords");this.chords=c}getHashCode(){let c="";for(let f=0,e=this.chords.length;f<e;f++)f!==0&&(c+=";"),c+=this.chords[f].getHashCode();return c}equals(c){if(c===null||this.chords.length!==c.chords.length)return!1;for(let f=0;f<this.chords.length;f++)if(!this.chords[f].equals(c.chords[f]))return!1;return!0}}t.$Br=m;class b{constructor(c,f,e,n,r,h){this.ctrlKey=c,this.shiftKey=f,this.altKey=e,this.metaKey=n,this.keyLabel=r,this.keyAriaLabel=h}}t.$Cr=b;class p{}t.$Dr=p}),define(be[23],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(O){this.d=O,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(O){this.c=O}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),define(be[14],$e([1,0,23]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xT=A,t.$yT=m,t.$zT=b;let O=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const H=new i.$V(()=>O("mouse",!1)),S=new i.$V(()=>O("element",!1));function A(p){O=p}function m(p){return p==="element"?S.value:H.value}function b(){return O("element",!0)}}),define(be[55],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(H){this.element=H,this.next=i.Undefined,this.prev=i.Undefined}}class T{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let H=this.a;for(;H!==i.Undefined;){const S=H.next;H.prev=i.Undefined,H.next=i.Undefined,H=S}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,S){const A=new i(H);if(this.a===i.Undefined)this.a=A,this.b=A;else if(S){const b=this.b;this.b=A,A.prev=b,b.next=A}else{const b=this.a;this.a=A,A.next=b,b.prev=A}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(A))}}shift(){if(this.a!==i.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==i.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==i.Undefined&&H.next!==i.Undefined){const S=H.prev;S.next=H.next,H.next.prev=S}else H.prev===i.Undefined&&H.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):H.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):H.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==i.Undefined;)yield H.element,H=H.next}}t.$5c=T}),define(be[39],$e([1,0]),function(se,t){"use strict";var i,T,O;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=H,t.$zc=S,t.$Ac=A,t.$Ic=g;function H(y,o,d){let a=y.get(o);return a===void 0&&(a=d,y.set(o,a)),a}function S(y){const o=[];return y.forEach((d,a)=>{o.push(`${a} => ${d}`)}),`Map(${y.size}) {${o.join(", ")}}`}function A(y){const o=[];return y.forEach(d=>{o.push(d)}),`Set(${y.size}) {${o.join(", ")}}`}class m{constructor(o,d){this.uri=o,this.value=d}}function b(y){return Array.isArray(y)}class p{static{this.c=o=>o.toString()}constructor(o,d){if(this[i]="ResourceMap",o instanceof p)this.d=new Map(o.d),this.e=d??p.c;else if(b(o)){this.d=new Map,this.e=d??p.c;for(const[a,k]of o)this.set(a,k)}else this.d=new Map,this.e=o??p.c}set(o,d){return this.d.set(this.e(o),new m(o,d)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,d){typeof d<"u"&&(o=o.bind(d));for(const[a,k]of this.d)o(k.value,k.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}t.$Bc=p;class j{constructor(o,d){this[T]="ResourceSet",!o||typeof o=="function"?this.c=new p(o):(this.c=new p(d),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,d){this.c.forEach((a,k)=>o.call(d,k,k,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=j;var c;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(c||(t.Touch=c={}));class f{constructor(){this[O]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,d=0){const a=this.c.get(o);if(a)return d!==0&&this.l(a,d),a.value}set(o,d,a=0){let k=this.c.get(o);if(k)k.value=d,a!==0&&this.l(k,a);else{switch(k={key:o,value:d,next:void 0,previous:void 0},a){case 0:this.j(k);break;case 1:this.i(k);break;case 2:this.j(k);break;default:this.j(k);break}this.c.set(o,k),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const d=this.c.get(o);if(d)return this.c.delete(o),this.k(d),this.f--,d.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.k(o),this.f--,o.value}forEach(o,d){const a=this.g;let k=this.d;for(;k;){if(d?o.bind(d)(k.value,k.key,this):o(k.value,k.key,this),this.g!==a)throw new Error("LinkedMap got modified during iteration.");k=k.next}}keys(){const o=this,d=this.g;let a=this.d;const k={[Symbol.iterator](){return k},next(){if(o.g!==d)throw new Error("LinkedMap got modified during iteration.");if(a){const N={value:a.key,done:!1};return a=a.next,N}else return{value:void 0,done:!0}}};return k}values(){const o=this,d=this.g;let a=this.d;const k={[Symbol.iterator](){return k},next(){if(o.g!==d)throw new Error("LinkedMap got modified during iteration.");if(a){const N={value:a.value,done:!1};return a=a.next,N}else return{value:void 0,done:!0}}};return k}entries(){const o=this,d=this.g;let a=this.d;const k={[Symbol.iterator](){return k},next(){if(o.g!==d)throw new Error("LinkedMap got modified during iteration.");if(a){const N={value:[a.key,a.value],done:!1};return a=a.next,N}else return{value:void 0,done:!0}}};return k}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let d=this.d,a=this.size;for(;d&&a>o;)this.c.delete(d.key),d=d.next,a--;this.d=d,this.f=a,d&&(d.previous=void 0),this.g++}i(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}j(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}k(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const d=o.next,a=o.previous;if(!d||!a)throw new Error("Invalid list");d.previous=a,a.next=d}o.next=void 0,o.previous=void 0,this.g++}l(o,d){if(!this.d||!this.e)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(o===this.d)return;const a=o.next,k=o.previous;o===this.e?(k.next=void 0,this.e=k):(a.previous=k,k.next=a),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(d===2){if(o===this.e)return;const a=o.next,k=o.previous;o===this.d?(a.previous=void 0,this.d=a):(a.previous=k,k.next=a),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((d,a)=>{o.push([a,d])}),o}fromJSON(o){this.clear();for(const[d,a]of o)this.set(d,a)}}t.$Dc=f;class e extends f{constructor(o,d=1){super(),this.m=o,this.n=Math.min(Math.max(0,d),1)}get limit(){return this.m}set limit(o){this.m=o,this.o()}get ratio(){return this.n}set ratio(o){this.n=Math.min(Math.max(0,o),1),this.o()}get(o,d=2){return super.get(o,d)}peek(o){return super.get(o,0)}set(o,d){return super.set(o,d,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Ec=e;class n{constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let d=this.c.get(o)||0;return d===0?!1:(d--,d===0?this.c.delete(o):this.c.set(o,d),!0)}has(o){return this.c.has(o)}}t.$Fc=n;class r{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[d,a]of o)this.set(d,a)}clear(){this.c.clear(),this.d.clear()}set(o,d){this.c.set(o,d),this.d.set(d,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const d=this.c.get(o);return d===void 0?!1:(this.c.delete(o),this.d.delete(d),!0)}forEach(o,d){this.c.forEach((a,k)=>{o.call(d,a,k,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=r;class h{constructor(){this.c=new Map}add(o,d){let a=this.c.get(o);a||(a=new Set,this.c.set(o,a)),a.add(d)}delete(o,d){const a=this.c.get(o);a&&(a.delete(d),a.size===0&&this.c.delete(o))}forEach(o,d){const a=this.c.get(o);a&&a.forEach(d)}get(o){const d=this.c.get(o);return d||new Set}}t.$Hc=h;function g(y,o){if(y===o)return!0;if(y.size!==o.size)return!1;for(const[d,a]of y)if(!o.has(d)||o.get(d)!==a)return!1;for(const[d]of o)if(!y.has(d))return!1;return!0}}),define(be[2],$e([1,0,8,83,39,53,32]),function(se,t,i,T,O,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=p,t.$Lc=j,t.$Mc=c,t.$Nc=n,t.$Oc=r,t.$Pc=h,t.$Qc=g,t.$Rc=y,t.$Sc=o,t.$3c=W;const A=!1;let m=null;class b{constructor(){this.b=new Map}static{this.a=0}c(B){let G=this.b.get(B);return G||(G={parent:null,source:null,isSingleton:!1,value:B,idx:b.a++},this.b.set(B,G)),G}trackDisposable(B){const G=this.c(B);G.source||(G.source=new Error().stack)}setParent(B,G){const V=this.c(B);V.parent=G}markAsDisposed(B){this.b.delete(B)}markAsSingleton(B){this.c(B).isSingleton=!0}f(B,G){const V=G.get(B);if(V)return V;const ae=B.parent?this.f(this.c(B.parent),G):B;return G.set(B,ae),ae}getTrackedDisposables(){const B=new Map;return[...this.b.entries()].filter(([,V])=>V.source!==null&&!this.f(V,B).isSingleton).flatMap(([V])=>V)}computeLeakingDisposables(B=10,G){let V;if(G)V=G;else{const Ee=new Map,De=[...this.b.values()].filter(he=>he.source!==null&&!this.f(he,Ee).isSingleton);if(De.length===0)return;const Le=new Set(De.map(he=>he.value));if(V=De.filter(he=>!(he.parent&&Le.has(he.parent))),V.length===0)throw new Error("There are cyclic diposable chains!")}if(!V)return;function ae(Ee){function De(he,_){for(;he.length>0&&_.some(ue=>typeof ue=="string"?ue===he[0]:he[0].match(ue));)he.shift()}const Le=Ee.source.split(`
`).map(he=>he.trim().replace("at ","")).filter(he=>he!=="");return De(Le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Le.reverse()}const ie=new O.$Hc;for(const Ee of V){const De=ae(Ee);for(let Le=0;Le<=De.length;Le++)ie.add(De.slice(0,Le).join(`
`),Ee)}V.sort((0,i.$7b)(Ee=>Ee.idx,i.$9b));let ee="",ge=0;for(const Ee of V.slice(0,B)){ge++;const De=ae(Ee),Le=[];for(let he=0;he<De.length;he++){let _=De[he];_=`(shared with ${ie.get(De.slice(0,he+1).join(`
`)).size}/${V.length} leaks) at ${_}`;const le=ie.get(De.slice(0,he).join(`
`)),Q=(0,T.$K)([...le].map(U=>ae(U)[he]),U=>U);delete Q[De[he]];for(const[U,re]of Object.entries(Q))Le.unshift(`    - stacktraces of ${re.length} other leaks continue with ${U}`);Le.unshift(_)}ee+=`


==================== Leaking disposable ${ge}/${V.length}: ${Ee.value.constructor.name} ====================
${Le.join(`
`)}
============================================================

`}return V.length>B&&(ee+=`


... and ${V.length-B} more leaking disposables

`),{leaks:V,details:ee}}}t.$Jc=b;function p(K){m=K}if(A){const K="__is_disposable_tracked__";p(new class{trackDisposable(B){const G=new Error("Potentially leaked disposable").stack;setTimeout(()=>{B[K]||console.log(G)},3e3)}setParent(B,G){if(B&&B!==a.None)try{B[K]=!0}catch{}}markAsDisposed(B){if(B&&B!==a.None)try{B[K]=!0}catch{}}markAsSingleton(B){}})}function j(K){return m?.trackDisposable(K),K}function c(K){m?.markAsDisposed(K)}function f(K,B){m?.setParent(K,B)}function e(K,B){if(m)for(const G of K)m.setParent(G,B)}function n(K){return m?.markAsSingleton(K),K}function r(K){return typeof K=="object"&&K!==null&&typeof K.dispose=="function"&&K.dispose.length===0}function h(K){if(S.Iterable.is(K)){const B=[];for(const G of K)if(G)try{G.dispose()}catch(V){B.push(V)}if(B.length===1)throw B[0];if(B.length>1)throw new AggregateError(B,"Encountered errors while disposing of store");return Array.isArray(K)?[]:K}else if(K)return K.dispose(),K}function g(K){for(const B of K)r(B)&&B.dispose();return[]}function y(...K){const B=o(()=>h(K));return e(K,B),B}function o(K){const B=j({dispose:(0,H.$db)(()=>{c(B),K()})});return B}class d{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,j(this)}dispose(){this.g||(c(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(B){if(!B)return B;if(B===this)throw new Error("Cannot register a disposable on itself!");return f(B,this),this.g?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(B),B}delete(B){if(B){if(B===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(B),B.dispose()}}deleteAndLeak(B){B&&this.f.has(B)&&(this.f.delete(B),f(B,null))}}t.$Tc=d;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new d,j(this),f(this.q,this)}dispose(){c(this),this.q.dispose()}B(B){if(B===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(B)}}t.$Uc=a;class k{constructor(){this.b=!1,j(this)}get value(){return this.b?void 0:this.a}set value(B){this.b||B===this.a||(this.a?.dispose(),B&&f(B,this),this.a=B)}clear(){this.value=void 0}dispose(){this.b=!0,c(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const B=this.a;return this.a=void 0,B&&f(B,null),B}}t.$Vc=k;class N{constructor(B){this.a=new k,this.b=!1,this.a.value=B}get value(){return this.a.value}set value(B){this.b||B===this.a.value||(this.a.value=B)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=N;class R{constructor(B){this.b=B,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=R;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,j(this)}set(B){let G=B;return this.unset=()=>G=void 0,this.isset=()=>G!==void 0,this.dispose=()=>{G&&(G(),G=void 0,c(this))},this}}t.$Yc=L;class P{constructor(){this.a=new Map}acquire(B,...G){let V=this.a.get(B);V||(V={counter:0,object:this.b(B,...G)},this.a.set(B,V));const{object:ae}=V,ie=(0,H.$db)(()=>{--V.counter===0&&(this.c(B,V.object),this.a.delete(B))});return V.counter++,{object:ae,dispose:ie}}}t.$Zc=P;class E{constructor(B){this.a=B}async acquire(B,...G){const V=this.a.acquire(B,...G);try{return{object:await V.object,dispose:()=>V.dispose()}}catch(ae){throw V.dispose(),ae}}}t.$1c=E;class z{constructor(B){this.object=B}dispose(){}}t.$2c=z;function W(K){const B=new d;try{K(B)}finally{B.dispose()}}class F{constructor(){this.a=new Map,this.b=!1,j(this)}dispose(){c(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(B){return this.a.has(B)}get size(){return this.a.size}get(B){return this.a.get(B)}set(B,G,V=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),V||this.a.get(B)?.dispose(),this.a.set(B,G)}deleteAndDispose(B){this.a.get(B)?.dispose(),this.a.delete(B)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=F}),function(se,t){typeof define=="function"&&define.amd?define(be[88],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(se=typeof globalThis<"u"?globalThis:se||self,t(se.marked={}))}(this,function(se){"use strict";function t(x,u){for(var v=0;v<u.length;v++){var l=u[v];l.enumerable=l.enumerable||!1,l.configurable=!0,"value"in l&&(l.writable=!0),Object.defineProperty(x,l.key,l)}}function i(x,u,v){return u&&t(x.prototype,u),v&&t(x,v),Object.defineProperty(x,"prototype",{writable:!1}),x}function T(x,u){if(x){if(typeof x=="string")return O(x,u);var v=Object.prototype.toString.call(x).slice(8,-1);if(v==="Object"&&x.constructor&&(v=x.constructor.name),v==="Map"||v==="Set")return Array.from(x);if(v==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(v))return O(x,u)}}function O(x,u){(u==null||u>x.length)&&(u=x.length);for(var v=0,l=new Array(u);v<u;v++)l[v]=x[v];return l}function H(x,u){var v=typeof Symbol<"u"&&x[Symbol.iterator]||x["@@iterator"];if(v)return(v=v.call(x)).next.bind(v);if(Array.isArray(x)||(v=T(x))||u&&x&&typeof x.length=="number"){v&&(x=v);var l=0;return function(){return l>=x.length?{done:!0}:{done:!1,value:x[l++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=S();function A(x){se.defaults=x}var m=/[&<>"']/,b=/[&<>"']/g,p=/[<>"']|&(?!#?\w+;)/,j=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(u){return c[u]};function e(x,u){if(u){if(m.test(x))return x.replace(b,f)}else if(p.test(x))return x.replace(j,f);return x}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(x){return x.replace(n,function(u,v){return v=v.toLowerCase(),v==="colon"?":":v.charAt(0)==="#"?v.charAt(1)==="x"?String.fromCharCode(parseInt(v.substring(2),16)):String.fromCharCode(+v.substring(1)):""})}var h=/(^|[^\[])\^/g;function g(x,u){x=typeof x=="string"?x:x.source,u=u||"";var v={replace:function(w,C){return C=C.source||C,C=C.replace(h,"$1"),x=x.replace(w,C),v},getRegex:function(){return new RegExp(x,u)}};return v}var y=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(x,u,v){if(x){var l;try{l=decodeURIComponent(r(v)).replace(y,"").toLowerCase()}catch{return null}if(l.indexOf("javascript:")===0||l.indexOf("vbscript:")===0||l.indexOf("data:")===0)return null}u&&!o.test(v)&&(v=L(u,v));try{v=encodeURI(v).replace(/%25/g,"%")}catch{return null}return v}var a={},k=/^[^:]+:\/*[^/]*$/,N=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function L(x,u){a[" "+x]||(k.test(x)?a[" "+x]=x+"/":a[" "+x]=W(x,"/",!0)),x=a[" "+x];var v=x.indexOf(":")===-1;return u.substring(0,2)==="//"?v?u:x.replace(N,"$1")+u:u.charAt(0)==="/"?v?u:x.replace(R,"$1")+u:x+u}var P={exec:function(){}};function E(x){for(var u=1,v,l;u<arguments.length;u++){v=arguments[u];for(l in v)Object.prototype.hasOwnProperty.call(v,l)&&(x[l]=v[l])}return x}function z(x,u){var v=x.replace(/\|/g,function(C,s,D){for(var $=!1,I=s;--I>=0&&D[I]==="\\";)$=!$;return $?"|":" |"}),l=v.split(/ \|/),w=0;if(l[0].trim()||l.shift(),l.length>0&&!l[l.length-1].trim()&&l.pop(),l.length>u)l.splice(u);else for(;l.length<u;)l.push("");for(;w<l.length;w++)l[w]=l[w].trim().replace(/\\\|/g,"|");return l}function W(x,u,v){var l=x.length;if(l===0)return"";for(var w=0;w<l;){var C=x.charAt(l-w-1);if(C===u&&!v)w++;else if(C!==u&&v)w++;else break}return x.slice(0,l-w)}function F(x,u){if(x.indexOf(u[1])===-1)return-1;for(var v=x.length,l=0,w=0;w<v;w++)if(x[w]==="\\")w++;else if(x[w]===u[0])l++;else if(x[w]===u[1]&&(l--,l<0))return w;return-1}function K(x){x&&x.sanitize&&!x.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(x,u){if(u<1)return"";for(var v="";u>1;)u&1&&(v+=x),u>>=1,x+=x;return v+x}function G(x,u,v,l){var w=u.href,C=u.title?e(u.title):null,s=x[1].replace(/\\([\[\]])/g,"$1");if(x[0].charAt(0)!=="!"){l.state.inLink=!0;var D={type:"link",raw:v,href:w,title:C,text:s,tokens:l.inlineTokens(s)};return l.state.inLink=!1,D}return{type:"image",raw:v,href:w,title:C,text:e(s)}}function V(x,u){var v=x.match(/^(\s+)(?:```)/);if(v===null)return u;var l=v[1];return u.split(`
`).map(function(w){var C=w.match(/^\s+/);if(C===null)return w;var s=C[0];return s.length>=l.length?w.slice(l.length):w}).join(`
`)}var ae=function(){function x(v){this.options=v||se.defaults}var u=x.prototype;return u.space=function(l){var w=this.rules.block.newline.exec(l);if(w&&w[0].length>0)return{type:"space",raw:w[0]}},u.code=function(l){var w=this.rules.block.code.exec(l);if(w){var C=w[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:w[0],codeBlockStyle:"indented",text:this.options.pedantic?C:W(C,`
`)}}},u.fences=function(l){var w=this.rules.block.fences.exec(l);if(w){var C=w[0],s=V(C,w[3]||"");return{type:"code",raw:C,lang:w[2]?w[2].trim():w[2],text:s}}},u.heading=function(l){var w=this.rules.block.heading.exec(l);if(w){var C=w[2].trim();if(/#$/.test(C)){var s=W(C,"#");(this.options.pedantic||!s||/ $/.test(s))&&(C=s.trim())}return{type:"heading",raw:w[0],depth:w[1].length,text:C,tokens:this.lexer.inline(C)}}},u.hr=function(l){var w=this.rules.block.hr.exec(l);if(w)return{type:"hr",raw:w[0]}},u.blockquote=function(l){var w=this.rules.block.blockquote.exec(l);if(w){var C=w[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:w[0],tokens:this.lexer.blockTokens(C,[]),text:C}}},u.list=function(l){var w=this.rules.block.list.exec(l);if(w){var C,s,D,$,I,M,Y,J,oe,we,fe,Ie,ke=w[1].trim(),Oe=ke.length>1,Se={type:"list",raw:"",ordered:Oe,start:Oe?+ke.slice(0,-1):"",loose:!1,items:[]};ke=Oe?"\\d{1,9}\\"+ke.slice(-1):"\\"+ke,this.options.pedantic&&(ke=Oe?ke:"[*+-]");for(var Ce=new RegExp("^( {0,3}"+ke+")((?:[	 ][^\\n]*)?(?:\\n|$))");l&&(Ie=!1,!(!(w=Ce.exec(l))||this.rules.block.hr.test(l)));){if(C=w[0],l=l.substring(C.length),J=w[2].split(`
`,1)[0],oe=l.split(`
`,1)[0],this.options.pedantic?($=2,fe=J.trimLeft()):($=w[2].search(/[^ ]/),$=$>4?1:$,fe=J.slice($),$+=w[1].length),M=!1,!J&&/^ *$/.test(oe)&&(C+=oe+`
`,l=l.substring(oe.length+1),Ie=!0),!Ie)for(var He=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ue=new RegExp("^ {0,"+Math.min(3,$-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Xe=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:```|~~~)"),_e=new RegExp("^ {0,"+Math.min(3,$-1)+"}#");l&&(we=l.split(`
`,1)[0],J=we,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Xe.test(J)||_e.test(J)||He.test(J)||Ue.test(l)));){if(J.search(/[^ ]/)>=$||!J.trim())fe+=`
`+J.slice($);else if(!M)fe+=`
`+J;else break;!M&&!J.trim()&&(M=!0),C+=we+`
`,l=l.substring(we.length+1)}Se.loose||(Y?Se.loose=!0:/\n *\n *$/.test(C)&&(Y=!0)),this.options.gfm&&(s=/^\[[ xX]\] /.exec(fe),s&&(D=s[0]!=="[ ] ",fe=fe.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:C,task:!!s,checked:D,loose:!1,text:fe}),Se.raw+=C}Se.items[Se.items.length-1].raw=C.trimRight(),Se.items[Se.items.length-1].text=fe.trimRight(),Se.raw=Se.raw.trimRight();var Z=Se.items.length;for(I=0;I<Z;I++){this.lexer.state.top=!1,Se.items[I].tokens=this.lexer.blockTokens(Se.items[I].text,[]);var ne=Se.items[I].tokens.filter(function(ye){return ye.type==="space"}),pe=ne.every(function(ye){for(var Re=ye.raw.split(""),ze=0,We=H(Re),et;!(et=We()).done;){var it=et.value;if(it===`
`&&(ze+=1),ze>1)return!0}return!1});!Se.loose&&ne.length&&pe&&(Se.loose=!0,Se.items[I].loose=!0)}return Se}},u.html=function(l){var w=this.rules.block.html.exec(l);if(w){var C={type:"html",raw:w[0],pre:!this.options.sanitizer&&(w[1]==="pre"||w[1]==="script"||w[1]==="style"),text:w[0]};if(this.options.sanitize){var s=this.options.sanitizer?this.options.sanitizer(w[0]):e(w[0]);C.type="paragraph",C.text=s,C.tokens=this.lexer.inline(s)}return C}},u.def=function(l){var w=this.rules.block.def.exec(l);if(w){w[3]&&(w[3]=w[3].substring(1,w[3].length-1));var C=w[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:C,raw:w[0],href:w[2],title:w[3]}}},u.table=function(l){var w=this.rules.block.table.exec(l);if(w){var C={type:"table",header:z(w[1]).map(function(Y){return{text:Y}}),align:w[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:w[3]&&w[3].trim()?w[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(C.header.length===C.align.length){C.raw=w[0];var s=C.align.length,D,$,I,M;for(D=0;D<s;D++)/^ *-+: *$/.test(C.align[D])?C.align[D]="right":/^ *:-+: *$/.test(C.align[D])?C.align[D]="center":/^ *:-+ *$/.test(C.align[D])?C.align[D]="left":C.align[D]=null;for(s=C.rows.length,D=0;D<s;D++)C.rows[D]=z(C.rows[D],C.header.length).map(function(Y){return{text:Y}});for(s=C.header.length,$=0;$<s;$++)C.header[$].tokens=this.lexer.inline(C.header[$].text);for(s=C.rows.length,$=0;$<s;$++)for(M=C.rows[$],I=0;I<M.length;I++)M[I].tokens=this.lexer.inline(M[I].text);return C}}},u.lheading=function(l){var w=this.rules.block.lheading.exec(l);if(w)return{type:"heading",raw:w[0],depth:w[2].charAt(0)==="="?1:2,text:w[1],tokens:this.lexer.inline(w[1])}},u.paragraph=function(l){var w=this.rules.block.paragraph.exec(l);if(w){var C=w[1].charAt(w[1].length-1)===`
`?w[1].slice(0,-1):w[1];return{type:"paragraph",raw:w[0],text:C,tokens:this.lexer.inline(C)}}},u.text=function(l){var w=this.rules.block.text.exec(l);if(w)return{type:"text",raw:w[0],text:w[0],tokens:this.lexer.inline(w[0])}},u.escape=function(l){var w=this.rules.inline.escape.exec(l);if(w)return{type:"escape",raw:w[0],text:e(w[1])}},u.tag=function(l){var w=this.rules.inline.tag.exec(l);if(w)return!this.lexer.state.inLink&&/^<a /i.test(w[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(w[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(w[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(w[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:w[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(w[0]):e(w[0]):w[0]}},u.link=function(l){var w=this.rules.inline.link.exec(l);if(w){var C=w[2].trim();if(!this.options.pedantic&&/^</.test(C)){if(!/>$/.test(C))return;var s=W(C.slice(0,-1),"\\");if((C.length-s.length)%2===0)return}else{var D=F(w[2],"()");if(D>-1){var $=w[0].indexOf("!")===0?5:4,I=$+w[1].length+D;w[2]=w[2].substring(0,D),w[0]=w[0].substring(0,I).trim(),w[3]=""}}var M=w[2],Y="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(M);J&&(M=J[1],Y=J[3])}else Y=w[3]?w[3].slice(1,-1):"";return M=M.trim(),/^</.test(M)&&(this.options.pedantic&&!/>$/.test(C)?M=M.slice(1):M=M.slice(1,-1)),G(w,{href:M&&M.replace(this.rules.inline._escapes,"$1"),title:Y&&Y.replace(this.rules.inline._escapes,"$1")},w[0],this.lexer)}},u.reflink=function(l,w){var C;if((C=this.rules.inline.reflink.exec(l))||(C=this.rules.inline.nolink.exec(l))){var s=(C[2]||C[1]).replace(/\s+/g," ");if(s=w[s.toLowerCase()],!s||!s.href){var D=C[0].charAt(0);return{type:"text",raw:D,text:D}}return G(C,s,C[0],this.lexer)}},u.emStrong=function(l,w,C){C===void 0&&(C="");var s=this.rules.inline.emStrong.lDelim.exec(l);if(s&&!(s[3]&&C.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var D=s[1]||s[2]||"";if(!D||D&&(C===""||this.rules.inline.punctuation.exec(C))){var $=s[0].length-1,I,M,Y=$,J=0,oe=s[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,w=w.slice(-1*l.length+$);(s=oe.exec(w))!=null;)if(I=s[1]||s[2]||s[3]||s[4]||s[5]||s[6],!!I){if(M=I.length,s[3]||s[4]){Y+=M;continue}else if((s[5]||s[6])&&$%3&&!(($+M)%3)){J+=M;continue}if(Y-=M,!(Y>0)){if(M=Math.min(M,M+Y+J),Math.min($,M)%2){var we=l.slice(1,$+s.index+M);return{type:"em",raw:l.slice(0,$+s.index+M+1),text:we,tokens:this.lexer.inlineTokens(we)}}var fe=l.slice(2,$+s.index+M-1);return{type:"strong",raw:l.slice(0,$+s.index+M+1),text:fe,tokens:this.lexer.inlineTokens(fe)}}}}}},u.codespan=function(l){var w=this.rules.inline.code.exec(l);if(w){var C=w[2].replace(/\n/g," "),s=/[^ ]/.test(C),D=/^ /.test(C)&&/ $/.test(C);return s&&D&&(C=C.substring(1,C.length-1)),C=e(C,!0),{type:"codespan",raw:w[0],text:C}}},u.br=function(l){var w=this.rules.inline.br.exec(l);if(w)return{type:"br",raw:w[0]}},u.del=function(l){var w=this.rules.inline.del.exec(l);if(w)return{type:"del",raw:w[0],text:w[2],tokens:this.lexer.inlineTokens(w[2])}},u.autolink=function(l,w){var C=this.rules.inline.autolink.exec(l);if(C){var s,D;return C[2]==="@"?(s=e(this.options.mangle?w(C[1]):C[1]),D="mailto:"+s):(s=e(C[1]),D=s),{type:"link",raw:C[0],text:s,href:D,tokens:[{type:"text",raw:s,text:s}]}}},u.url=function(l,w){var C;if(C=this.rules.inline.url.exec(l)){var s,D;if(C[2]==="@")s=e(this.options.mangle?w(C[0]):C[0]),D="mailto:"+s;else{var $;do $=C[0],C[0]=this.rules.inline._backpedal.exec(C[0])[0];while($!==C[0]);s=e(C[0]),C[1]==="www."?D="http://"+s:D=s}return{type:"link",raw:C[0],text:s,href:D,tokens:[{type:"text",raw:s,text:s}]}}},u.inlineText=function(l,w){var C=this.rules.inline.text.exec(l);if(C){var s;return this.lexer.state.inRawBlock?s=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(C[0]):e(C[0]):C[0]:s=e(this.options.smartypants?w(C[0]):C[0]),{type:"text",raw:C[0],text:s}}},x}(),ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:P,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=g(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=g(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=g(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=g(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=g(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=g(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=E({},ie),ie.gfm=E({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=g(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.paragraph=g(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ie.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=E({},ie.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:P,paragraph:g(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:P,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:P,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=g(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=g(ie._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=g(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=g(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=g(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=g(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=g(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=g(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=g(ee.reflink).replace("label",ee._label).replace("ref",ie._label).getRegex(),ee.nolink=g(ee.nolink).replace("ref",ie._label).getRegex(),ee.reflinkSearch=g(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=E({},ee),ee.pedantic=E({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=E({},ee.normal,{escape:g(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=g(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=E({},ee.gfm,{br:g(ee.br).replace("{2,}","*").getRegex(),text:g(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(x){return x.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ee(x){var u="",v,l,w=x.length;for(v=0;v<w;v++)l=x.charCodeAt(v),Math.random()>.5&&(l="x"+l.toString(16)),u+="&#"+l+";";return u}var De=function(){function x(v){this.tokens=[],this.tokens.links=Object.create(null),this.options=v||se.defaults,this.options.tokenizer=this.options.tokenizer||new ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var l={block:ie.normal,inline:ee.normal};this.options.pedantic?(l.block=ie.pedantic,l.inline=ee.pedantic):this.options.gfm&&(l.block=ie.gfm,this.options.breaks?l.inline=ee.breaks:l.inline=ee.gfm),this.tokenizer.rules=l}x.lex=function(l,w){var C=new x(w);return C.lex(l)},x.lexInline=function(l,w){var C=new x(w);return C.inlineTokens(l)};var u=x.prototype;return u.lex=function(l){l=l.replace(/\r\n|\r/g,`
`),this.blockTokens(l,this.tokens);for(var w;w=this.inlineQueue.shift();)this.inlineTokens(w.src,w.tokens);return this.tokens},u.blockTokens=function(l,w){var C=this;w===void 0&&(w=[]),this.options.pedantic?l=l.replace(/\t/g,"    ").replace(/^ +$/gm,""):l=l.replace(/^( *)(\t+)/gm,function(Y,J,oe){return J+"    ".repeat(oe.length)});for(var s,D,$,I;l;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Y){return(s=Y.call({lexer:C},l,w))?(l=l.substring(s.raw.length),w.push(s),!0):!1}))){if(s=this.tokenizer.space(l)){l=l.substring(s.raw.length),s.raw.length===1&&w.length>0?w[w.length-1].raw+=`
`:w.push(s);continue}if(s=this.tokenizer.code(l)){l=l.substring(s.raw.length),D=w[w.length-1],D&&(D.type==="paragraph"||D.type==="text")?(D.raw+=`
`+s.raw,D.text+=`
`+s.text,this.inlineQueue[this.inlineQueue.length-1].src=D.text):w.push(s);continue}if(s=this.tokenizer.fences(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.heading(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.hr(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.blockquote(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.list(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.html(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.def(l)){l=l.substring(s.raw.length),D=w[w.length-1],D&&(D.type==="paragraph"||D.type==="text")?(D.raw+=`
`+s.raw,D.text+=`
`+s.raw,this.inlineQueue[this.inlineQueue.length-1].src=D.text):this.tokens.links[s.tag]||(this.tokens.links[s.tag]={href:s.href,title:s.title});continue}if(s=this.tokenizer.table(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.lheading(l)){l=l.substring(s.raw.length),w.push(s);continue}if($=l,this.options.extensions&&this.options.extensions.startBlock&&function(){var Y=1/0,J=l.slice(1),oe=void 0;C.options.extensions.startBlock.forEach(function(we){oe=we.call({lexer:this},J),typeof oe=="number"&&oe>=0&&(Y=Math.min(Y,oe))}),Y<1/0&&Y>=0&&($=l.substring(0,Y+1))}(),this.state.top&&(s=this.tokenizer.paragraph($))){D=w[w.length-1],I&&D.type==="paragraph"?(D.raw+=`
`+s.raw,D.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=D.text):w.push(s),I=$.length!==l.length,l=l.substring(s.raw.length);continue}if(s=this.tokenizer.text(l)){l=l.substring(s.raw.length),D=w[w.length-1],D&&D.type==="text"?(D.raw+=`
`+s.raw,D.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=D.text):w.push(s);continue}if(l){var M="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(M);break}else throw new Error(M)}}return this.state.top=!0,w},u.inline=function(l,w){return w===void 0&&(w=[]),this.inlineQueue.push({src:l,tokens:w}),w},u.inlineTokens=function(l,w){var C=this;w===void 0&&(w=[]);var s,D,$,I=l,M,Y,J;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(M=this.tokenizer.rules.inline.reflinkSearch.exec(I))!=null;)oe.includes(M[0].slice(M[0].lastIndexOf("[")+1,-1))&&(I=I.slice(0,M.index)+"["+B("a",M[0].length-2)+"]"+I.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(M=this.tokenizer.rules.inline.blockSkip.exec(I))!=null;)I=I.slice(0,M.index)+"["+B("a",M[0].length-2)+"]"+I.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(M=this.tokenizer.rules.inline.escapedEmSt.exec(I))!=null;)I=I.slice(0,M.index)+"++"+I.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;l;)if(Y||(J=""),Y=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(fe){return(s=fe.call({lexer:C},l,w))?(l=l.substring(s.raw.length),w.push(s),!0):!1}))){if(s=this.tokenizer.escape(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.tag(l)){l=l.substring(s.raw.length),D=w[w.length-1],D&&s.type==="text"&&D.type==="text"?(D.raw+=s.raw,D.text+=s.text):w.push(s);continue}if(s=this.tokenizer.link(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.reflink(l,this.tokens.links)){l=l.substring(s.raw.length),D=w[w.length-1],D&&s.type==="text"&&D.type==="text"?(D.raw+=s.raw,D.text+=s.text):w.push(s);continue}if(s=this.tokenizer.emStrong(l,I,J)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.codespan(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.br(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.del(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.autolink(l,Ee)){l=l.substring(s.raw.length),w.push(s);continue}if(!this.state.inLink&&(s=this.tokenizer.url(l,Ee))){l=l.substring(s.raw.length),w.push(s);continue}if($=l,this.options.extensions&&this.options.extensions.startInline&&function(){var fe=1/0,Ie=l.slice(1),ke=void 0;C.options.extensions.startInline.forEach(function(Oe){ke=Oe.call({lexer:this},Ie),typeof ke=="number"&&ke>=0&&(fe=Math.min(fe,ke))}),fe<1/0&&fe>=0&&($=l.substring(0,fe+1))}(),s=this.tokenizer.inlineText($,ge)){l=l.substring(s.raw.length),s.raw.slice(-1)!=="_"&&(J=s.raw.slice(-1)),Y=!0,D=w[w.length-1],D&&D.type==="text"?(D.raw+=s.raw,D.text+=s.text):w.push(s);continue}if(l){var we="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return w},i(x,null,[{key:"rules",get:function(){return{block:ie,inline:ee}}}]),x}(),Le=function(){function x(v){this.options=v||se.defaults}var u=x.prototype;return u.code=function(l,w,C){var s=(w||"").match(/\S*/)[0];if(this.options.highlight){var D=this.options.highlight(l,s);D!=null&&D!==l&&(C=!0,l=D)}return l=l.replace(/\n$/,"")+`
`,s?'<pre><code class="'+this.options.langPrefix+e(s,!0)+'">'+(C?l:e(l,!0))+`</code></pre>
`:"<pre><code>"+(C?l:e(l,!0))+`</code></pre>
`},u.blockquote=function(l){return`<blockquote>
`+l+`</blockquote>
`},u.html=function(l){return l},u.heading=function(l,w,C,s){if(this.options.headerIds){var D=this.options.headerPrefix+s.slug(C);return"<h"+w+' id="'+D+'">'+l+"</h"+w+`>
`}return"<h"+w+">"+l+"</h"+w+`>
`},u.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},u.list=function(l,w,C){var s=w?"ol":"ul",D=w&&C!==1?' start="'+C+'"':"";return"<"+s+D+`>
`+l+"</"+s+`>
`},u.listitem=function(l){return"<li>"+l+`</li>
`},u.checkbox=function(l){return"<input "+(l?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},u.paragraph=function(l){return"<p>"+l+`</p>
`},u.table=function(l,w){return w&&(w="<tbody>"+w+"</tbody>"),`<table>
<thead>
`+l+`</thead>
`+w+`</table>
`},u.tablerow=function(l){return`<tr>
`+l+`</tr>
`},u.tablecell=function(l,w){var C=w.header?"th":"td",s=w.align?"<"+C+' align="'+w.align+'">':"<"+C+">";return s+l+("</"+C+`>
`)},u.strong=function(l){return"<strong>"+l+"</strong>"},u.em=function(l){return"<em>"+l+"</em>"},u.codespan=function(l){return"<code>"+l+"</code>"},u.br=function(){return this.options.xhtml?"<br/>":"<br>"},u.del=function(l){return"<del>"+l+"</del>"},u.link=function(l,w,C){if(l=d(this.options.sanitize,this.options.baseUrl,l),l===null)return C;var s='<a href="'+e(l)+'"';return w&&(s+=' title="'+w+'"'),s+=">"+C+"</a>",s},u.image=function(l,w,C){if(l=d(this.options.sanitize,this.options.baseUrl,l),l===null)return C;var s='<img src="'+l+'" alt="'+C+'"';return w&&(s+=' title="'+w+'"'),s+=this.options.xhtml?"/>":">",s},u.text=function(l){return l},x}(),he=function(){function x(){}var u=x.prototype;return u.strong=function(l){return l},u.em=function(l){return l},u.codespan=function(l){return l},u.del=function(l){return l},u.html=function(l){return l},u.text=function(l){return l},u.link=function(l,w,C){return""+C},u.image=function(l,w,C){return""+C},u.br=function(){return""},x}(),_=function(){function x(){this.seen={}}var u=x.prototype;return u.serialize=function(l){return l.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},u.getNextSafeSlug=function(l,w){var C=l,s=0;if(this.seen.hasOwnProperty(C)){s=this.seen[l];do s++,C=l+"-"+s;while(this.seen.hasOwnProperty(C))}return w||(this.seen[l]=s,this.seen[C]=0),C},u.slug=function(l,w){w===void 0&&(w={});var C=this.serialize(l);return this.getNextSafeSlug(C,w.dryrun)},x}(),ue=function(){function x(v){this.options=v||se.defaults,this.options.renderer=this.options.renderer||new Le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new he,this.slugger=new _}x.parse=function(l,w){var C=new x(w);return C.parse(l)},x.parseInline=function(l,w){var C=new x(w);return C.parseInline(l)};var u=x.prototype;return u.parse=function(l,w){w===void 0&&(w=!0);var C="",s,D,$,I,M,Y,J,oe,we,fe,Ie,ke,Oe,Se,Ce,He,Ue,Xe,_e,Z=l.length;for(s=0;s<Z;s++){if(fe=l[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(_e=this.options.extensions.renderers[fe.type].call({parser:this},fe),_e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(fe.type))){C+=_e||"";continue}switch(fe.type){case"space":continue;case"hr":{C+=this.renderer.hr();continue}case"heading":{C+=this.renderer.heading(this.parseInline(fe.tokens),fe.depth,r(this.parseInline(fe.tokens,this.textRenderer)),this.slugger);continue}case"code":{C+=this.renderer.code(fe.text,fe.lang,fe.escaped);continue}case"table":{for(oe="",J="",I=fe.header.length,D=0;D<I;D++)J+=this.renderer.tablecell(this.parseInline(fe.header[D].tokens),{header:!0,align:fe.align[D]});for(oe+=this.renderer.tablerow(J),we="",I=fe.rows.length,D=0;D<I;D++){for(Y=fe.rows[D],J="",M=Y.length,$=0;$<M;$++)J+=this.renderer.tablecell(this.parseInline(Y[$].tokens),{header:!1,align:fe.align[$]});we+=this.renderer.tablerow(J)}C+=this.renderer.table(oe,we);continue}case"blockquote":{we=this.parse(fe.tokens),C+=this.renderer.blockquote(we);continue}case"list":{for(Ie=fe.ordered,ke=fe.start,Oe=fe.loose,I=fe.items.length,we="",D=0;D<I;D++)Ce=fe.items[D],He=Ce.checked,Ue=Ce.task,Se="",Ce.task&&(Xe=this.renderer.checkbox(He),Oe?Ce.tokens.length>0&&Ce.tokens[0].type==="paragraph"?(Ce.tokens[0].text=Xe+" "+Ce.tokens[0].text,Ce.tokens[0].tokens&&Ce.tokens[0].tokens.length>0&&Ce.tokens[0].tokens[0].type==="text"&&(Ce.tokens[0].tokens[0].text=Xe+" "+Ce.tokens[0].tokens[0].text)):Ce.tokens.unshift({type:"text",text:Xe}):Se+=Xe),Se+=this.parse(Ce.tokens,Oe),we+=this.renderer.listitem(Se,Ue,He);C+=this.renderer.list(we,Ie,ke);continue}case"html":{C+=this.renderer.html(fe.text);continue}case"paragraph":{C+=this.renderer.paragraph(this.parseInline(fe.tokens));continue}case"text":{for(we=fe.tokens?this.parseInline(fe.tokens):fe.text;s+1<Z&&l[s+1].type==="text";)fe=l[++s],we+=`
`+(fe.tokens?this.parseInline(fe.tokens):fe.text);C+=w?this.renderer.paragraph(we):we;continue}default:{var ne='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return C},u.parseInline=function(l,w){w=w||this.renderer;var C="",s,D,$,I=l.length;for(s=0;s<I;s++){if(D=l[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[D.type]&&($=this.options.extensions.renderers[D.type].call({parser:this},D),$!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(D.type))){C+=$||"";continue}switch(D.type){case"escape":{C+=w.text(D.text);break}case"html":{C+=w.html(D.text);break}case"link":{C+=w.link(D.href,D.title,this.parseInline(D.tokens,w));break}case"image":{C+=w.image(D.href,D.title,D.text);break}case"strong":{C+=w.strong(this.parseInline(D.tokens,w));break}case"em":{C+=w.em(this.parseInline(D.tokens,w));break}case"codespan":{C+=w.codespan(D.text);break}case"br":{C+=w.br();break}case"del":{C+=w.del(this.parseInline(D.tokens,w));break}case"text":{C+=w.text(D.text);break}default:{var M='Token with "'+D.type+'" type was not found.';if(this.options.silent){console.error(M);return}else throw new Error(M)}}}return C},x}();function le(x,u,v){if(typeof x>"u"||x===null)throw new Error("marked(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");if(typeof u=="function"&&(v=u,u=null),u=E({},le.defaults,u||{}),K(u),v){var l=u.highlight,w;try{w=De.lex(x,u)}catch(I){return v(I)}var C=function(M){var Y;if(!M)try{u.walkTokens&&le.walkTokens(w,u.walkTokens),Y=ue.parse(w,u)}catch(J){M=J}return u.highlight=l,M?v(M):v(null,Y)};if(!l||l.length<3||(delete u.highlight,!w.length))return C();var s=0;le.walkTokens(w,function(I){I.type==="code"&&(s++,setTimeout(function(){l(I.text,I.lang,function(M,Y){if(M)return C(M);Y!=null&&Y!==I.text&&(I.text=Y,I.escaped=!0),s--,s===0&&C()})},0))}),s===0&&C();return}function D(I){if(I.message+=`
Please report this to https://github.com/markedjs/marked.`,u.silent)return"<p>An error occurred:</p><pre>"+e(I.message+"",!0)+"</pre>";throw I}try{var $=De.lex(x,u);if(u.walkTokens){if(u.async)return Promise.all(le.walkTokens($,u.walkTokens)).then(function(){return ue.parse($,u)}).catch(D);le.walkTokens($,u.walkTokens)}return ue.parse($,u)}catch(I){D(I)}}le.options=le.setOptions=function(x){return E(le.defaults,x),A(le.defaults),le},le.getDefaults=S,le.defaults=se.defaults,le.use=function(){for(var x=arguments.length,u=new Array(x),v=0;v<x;v++)u[v]=arguments[v];var l=E.apply(void 0,[{}].concat(u)),w=le.defaults.extensions||{renderers:{},childTokens:{}},C;u.forEach(function(s){if(s.extensions&&(C=!0,s.extensions.forEach(function($){if(!$.name)throw new Error("extension name required");if($.renderer){var I=w.renderers?w.renderers[$.name]:null;I?w.renderers[$.name]=function(){for(var M=arguments.length,Y=new Array(M),J=0;J<M;J++)Y[J]=arguments[J];var oe=$.renderer.apply(this,Y);return oe===!1&&(oe=I.apply(this,Y)),oe}:w.renderers[$.name]=$.renderer}if($.tokenizer){if(!$.level||$.level!=="block"&&$.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");w[$.level]?w[$.level].unshift($.tokenizer):w[$.level]=[$.tokenizer],$.start&&($.level==="block"?w.startBlock?w.startBlock.push($.start):w.startBlock=[$.start]:$.level==="inline"&&(w.startInline?w.startInline.push($.start):w.startInline=[$.start]))}$.childTokens&&(w.childTokens[$.name]=$.childTokens)})),s.renderer&&function(){var $=le.defaults.renderer||new Le,I=function(J){var oe=$[J];$[J]=function(){for(var we=arguments.length,fe=new Array(we),Ie=0;Ie<we;Ie++)fe[Ie]=arguments[Ie];var ke=s.renderer[J].apply($,fe);return ke===!1&&(ke=oe.apply($,fe)),ke}};for(var M in s.renderer)I(M);l.renderer=$}(),s.tokenizer&&function(){var $=le.defaults.tokenizer||new ae,I=function(J){var oe=$[J];$[J]=function(){for(var we=arguments.length,fe=new Array(we),Ie=0;Ie<we;Ie++)fe[Ie]=arguments[Ie];var ke=s.tokenizer[J].apply($,fe);return ke===!1&&(ke=oe.apply($,fe)),ke}};for(var M in s.tokenizer)I(M);l.tokenizer=$}(),s.walkTokens){var D=le.defaults.walkTokens;l.walkTokens=function($){var I=[];return I.push(s.walkTokens.call(this,$)),D&&(I=I.concat(D.call(this,$))),I}}C&&(l.extensions=w),le.setOptions(l)})},le.walkTokens=function(x,u){for(var v=[],l=function(){var D=C.value;switch(v=v.concat(u.call(le,D)),D.type){case"table":{for(var $=H(D.header),I;!(I=$()).done;){var M=I.value;v=v.concat(le.walkTokens(M.tokens,u))}for(var Y=H(D.rows),J;!(J=Y()).done;)for(var oe=J.value,we=H(oe),fe;!(fe=we()).done;){var Ie=fe.value;v=v.concat(le.walkTokens(Ie.tokens,u))}break}case"list":{v=v.concat(le.walkTokens(D.items,u));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[D.type]?le.defaults.extensions.childTokens[D.type].forEach(function(ke){v=v.concat(le.walkTokens(D[ke],u))}):D.tokens&&(v=v.concat(le.walkTokens(D.tokens,u)))}},w=H(x),C;!(C=w()).done;)l();return v},le.parseInline=function(x,u){if(typeof x>"u"||x===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");u=E({},le.defaults,u||{}),K(u);try{var v=De.lexInline(x,u);return u.walkTokens&&le.walkTokens(v,u.walkTokens),ue.parseInline(v,u)}catch(l){if(l.message+=`
Please report this to https://github.com/markedjs/marked.`,u.silent)return"<p>An error occurred:</p><pre>"+e(l.message+"",!0)+"</pre>";throw l}},le.Parser=ue,le.parser=ue.parse,le.Renderer=Le,le.TextRenderer=he,le.Lexer=De,le.lexer=De.lex,le.Tokenizer=ae,le.Slugger=_,le.parse=le;var Q=le.options,U=le.setOptions,re=le.use,me=le.walkTokens,ve=le.parseInline,Ne=le,Te=ue.parse,Me=De.lex;se.Lexer=De,se.Parser=ue,se.Renderer=Le,se.Slugger=_,se.TextRenderer=he,se.Tokenizer=ae,se.getDefaults=S,se.lexer=Me,se.marked=le,se.options=Q,se.parse=Ne,se.parseInline=ve,se.parser=Te,se.setOptions=U,se.use=re,se.walkTokens=me,Object.defineProperty(se,"__esModule",{value:!0})}),define(be[89],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pk=i;function i(n){const r=H(n);if(r&&r.length>0)return new Uint32Array(r)}let T=0;const O=new Uint32Array(10);function H(n){if(T=0,S(n,j,4352),T>0||(S(n,c,4449),T>0)||(S(n,f,4520),T>0)||(S(n,e,12593),T))return O.subarray(0,T);if(n>=44032&&n<=55203){const r=n-44032,h=r%588,g=Math.floor(r/588),y=Math.floor(h/28),o=h%28-1;if(g<j.length?S(g,j,0):4352+g-12593<e.length&&S(4352+g,e,12593),y<c.length?S(y,c,0):4449+y-12593<e.length&&S(4449+y-12593,e,12593),o>=0&&(o<f.length?S(o,f,0):4520+o-12593<e.length&&S(4520+o-12593,e,12593)),T>0)return O.subarray(0,T)}}function S(n,r,h){n>=h&&n<h+r.length&&A(r[n-h])}function A(n){n!==0&&(O[T++]=n&255,n>>8&&(O[T++]=n>>8&255),n>>16&&(O[T++]=n>>16&255))}var m;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var b;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(b||(b={}));var p;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(p||(p={}));const j=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),c=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),f=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(be[90],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$U=void 0;class i{constructor(O,H=0,S=O.length,A=H-1){this.a=O,this.b=H,this.c=S,this.d=A}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$$U=i}),define(be[91],$e([1,0,90]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aV=t.$_U=void 0;class T{constructor(S=[],A=10){this.h(S),this.b=A,this.d()}getHistory(){return this.j}add(S){this.a.delete(S),this.a.add(S),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(S){return this.a.has(S)}clear(){this.h([]),this.d()}d(){this.f();const S=this.j;this.c=new i.$$U(S,0,S.length,S.length)}f(){const S=this.j;S.length>this.b&&this.h(S.slice(S.length-this.b))}g(){const S=this.c.current();return S?this.j.indexOf(S):-1}h(S){this.a=new Set;for(const A of S)this.a.add(A)}get j(){const S=[];return this.a.forEach(A=>S.push(A)),S}}t.$_U=T;class O{get size(){return this.f}constructor(S,A=10){if(this.g=A,S.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:S[0],previous:void 0,next:void 0},this.a=new Set([S[0]]);for(let m=1;m<S.length;m++)this.add(S[m])}add(S){const A={value:S,previous:this.c,next:void 0};for(this.c.next=A,this.c=A,this.d=this.c,this.f++,this.a.has(S)?this.h(S):this.a.add(S);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(S){if(this.c.value===S)return S;const A=this.c.value;return this.a.delete(A),this.c.value=S,this.a.has(S)?this.h(S):this.a.add(S),A}prepend(S){if(this.f===this.g||this.a.has(S))return;const A={value:S,previous:void 0,next:this.b};this.b.previous=A,this.b=A,this.f++,this.a.add(S)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(S){return this.a.has(S)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let S=this.b;for(;S;)yield S.value,S=S.next}h(S){let A=this.b;for(;A!==this.c;)A.value===S&&(A===this.b?(this.b=this.b.next,this.b.previous=void 0):(A.previous.next=A.next,A.next.previous=A.previous),this.f--),A=A.next}}t.$aV=O}),define(be[40],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zm=t.$ym=t.$xm=void 0,t.$vm=i,t.rot=T;function i(A,m,b){return Math.min(Math.max(A,m),b)}function T(A,m){return(m+A%m)%m}class O{constructor(){this.a=0}getNext(){return this.a++}}t.$xm=O;class H{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$ym=H;class S{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const b=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$zm=S}),define(be[26],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$c=void 0,t.$_c=H,t.$ad=c;class i{constructor(e,n,r){this.owner=e,this.debugNameSource=n,this.referenceFn=r}getDebugName(e){return H(e,this)}}t.$$c=i;const T=new Map,O=new WeakMap;function H(f,e){const n=O.get(f);if(n)return n;const r=S(f,e);if(r){let h=T.get(r)??0;h++,T.set(r,h);const g=h===1?r:`${r}#${h}`;return O.set(f,g),g}}function S(f,e){const n=O.get(f);if(n)return n;const r=e.owner?p(e.owner)+".":"";let h;const g=e.debugNameSource;if(g!==void 0)if(typeof g=="function"){if(h=g(),h!==void 0)return r+h}else return r+g;const y=e.referenceFn;if(y!==void 0&&(h=c(y),h!==void 0))return r+h;if(e.owner!==void 0){const o=A(e.owner,f);if(o!==void 0)return r+o}}function A(f,e){for(const n in f)if(f[n]===e)return n}const m=new Map,b=new WeakMap;function p(f){const e=b.get(f);if(e)return e;const n=j(f);let r=m.get(n)??0;r++,m.set(n,r);const h=r===1?n:`${n}#${r}`;return b.set(f,h),h}function j(f){const e=f.constructor;return e?e.name:"Object"}function c(f){const e=f.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(r?r[1]:void 0)?.trim()}}),define(be[27],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hd=void 0,t.$Fd=T,t.$Gd=O;let i;function T(n){i=n}function O(){return i}class H{constructor(){this.a=0,this.d=new WeakMap}b(r){return S([A(f("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[A(" "),b(p(r.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),b(p(r.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),b(p(r.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(r,h){console.log(...this.b([m("observable value changed"),b(r.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(r){if(r.size!==0)return b(" (changed deps: "+[...r].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(g,y)=>(this.d.get(r).add(g),h.apply(r,[g,y]))}handleDerivedRecomputed(r,h){const g=this.d.get(r);console.log(...this.b([m("derived recomputed"),b(r.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(g),{data:[{fn:r._computeFn}]}])),g.clear()}handleFromEventObservableTriggered(r,h){console.log(...this.b([m("observable from event triggered"),b(r.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(g,y)=>(this.d.get(r).add(g),h.apply(r,[g,y]))}handleAutorunTriggered(r){const h=this.d.get(r);console.log(...this.b([m("autorun"),b(r.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:r._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let h=r.getDebugName();h===void 0&&(h=""),console.log(...this.b([m("transaction"),b(h,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Hd=H;function S(n){const r=new Array,h=[];let g="";function y(d){if("length"in d)for(const a of d)a&&y(a);else"text"in d?(g+=`%c${d.text}`,r.push(d.style),d.data&&h.push(...d.data)):"data"in d&&h.push(...d.data)}y(n);const o=[g,...r];return o.push(...h),o}function A(n){return b(n,{color:"black"})}function m(n){return b(e(`${n}: `,10),{color:"black",bold:!0})}function b(n,r={color:"black"}){function h(y){return Object.entries(y).reduce((o,[d,a])=>`${o}${d}:${a};`,"")}const g={color:r.color};return r.strikeThrough&&(g["text-decoration"]="line-through"),r.bold&&(g["font-weight"]="bold"),{text:n,style:h(g)}}function p(n,r){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=r?`"${n}"`:`"${n.substr(0,r-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?j(n,r):c(n,r);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function j(n,r){let h="[ ",g=!0;for(const y of n){if(g||(h+=", "),h.length-5>r){h+="...";break}g=!1,h+=`${p(y,r-h.length)}`}return h+=" ]",h}function c(n,r){let h="{ ",g=!0;for(const[y,o]of Object.entries(n)){if(g||(h+=", "),h.length-5>r){h+="...";break}g=!1,h+=`${y}: ${p(o,r-h.length)}`}return h+=" }",h}function f(n,r){let h="";for(let g=1;g<=r;g++)h+=n;return h}function e(n,r){for(;n.length<r;)n+=" ";return n}}),define(be[41],$e([1,0,37,2,26,27]),function(se,t,i,T,O,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nd=void 0,t.$hd=S,t.$id=A,t.$jd=m,t.$kd=b,t.$ld=p,t.$md=j;function S(e){return new f(new O.$$c(void 0,void 0,e),e,void 0,void 0)}function A(e,n){return new f(new O.$$c(e.owner,e.debugName,e.debugReferenceFn??n),n,void 0,void 0)}function m(e,n){return new f(new O.$$c(e.owner,e.debugName,e.debugReferenceFn??n),n,e.createEmptyChangeSummary,e.handleChange)}function b(e,n){const r=new T.$Tc,h=m({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(g,y)=>{r.clear(),n(g,y,r)});return(0,T.$Sc)(()=>{h.dispose(),r.dispose()})}function p(e){const n=new T.$Tc,r=A({owner:void 0,debugName:void 0,debugReferenceFn:e},h=>{n.clear(),e(h,n)});return(0,T.$Sc)(()=>{r.dispose(),n.dispose()})}function j(e,n){let r;return A({debugReferenceFn:n},h=>{const g=e.read(h),y=r;r=g,n({lastValue:y,newValue:g})})}var c;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(c||(c={}));class f{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(n,r,h,g){this.h=n,this._runFn=r,this.i=h,this.j=g,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,H.$Gd)()?.handleAutorunCreated(this),this.k(),(0,T.$Lc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,T.$Mc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const r=this.c;try{if(!r){(0,H.$Gd)()?.handleAutorunTriggered(this);const h=this.g;this.g=this.i?.(),this._runFn(this,h)}}finally{r||(0,H.$Gd)()?.handleAutorunFinished(this);for(const h of this.f)h.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,i.$fd)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,r){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:r,didChange:g=>g===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const r=n.get();return this.e.add(n),this.f.delete(n),r}}t.$nd=f,function(e){e.Observer=f}(S||(t.$hd=S={}))}),define(be[33],$e([1,0,38,26,27]),function(se,t,i,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=t.$1d=t.$Xd=t.$Sd=t.$Rd=void 0,t.$Od=S,t.$Pd=m,t.$Qd=p,t.$Td=f,t.$Ud=n,t.$Vd=r,t.$Wd=h,t.$Yd=y,t.$Zd=o,t.$2d=a;let H;function S(N){H=N}let A;function m(N){A=N}let b;function p(N){b=N}class j{get TChange(){return null}reportChanges(){this.get()}read(R){return R?R.readObservable(this):this.get()}map(R,L){const P=L===void 0?void 0:R,E=L===void 0?R:L;return b({owner:P,debugName:()=>{const z=(0,T.$ad)(E);if(z!==void 0)return z;const F=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(F)return`${this.debugName}.${F[2]}`;if(!P)return`${this.debugName} (mapped)`},debugReferenceFn:E},z=>E(this.read(z),z))}recomputeInitiallyAndOnChange(R,L){return R.add(H(this,L)),this}keepObserved(R){return R.add(A(this)),this}get a(){return this.get()}}t.$Rd=j;class c extends j{constructor(){super(...arguments),this.b=new Set}addObserver(R){const L=this.b.size;this.b.add(R),L===0&&this.c()}removeObserver(R){this.b.delete(R)&&this.b.size===0&&this.f()}c(){}f(){}}t.$Sd=c;function f(N,R){const L=new g(N,R);try{N(L)}finally{L.finish()}}let e;function n(N){if(e)N(e);else{const R=new g(N,void 0);e=R;try{N(R)}finally{R.finish(),e=void 0}}}async function r(N,R){const L=new g(N,R);try{await N(L)}finally{L.finish()}}function h(N,R,L){N?R(N):f(R,L)}class g{constructor(R,L){this._fn=R,this.b=L,this.a=[],(0,O.$Gd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,T.$ad)(this._fn)}updateObserver(R,L){this.a.push({observer:R,observable:L}),R.beginUpdate(L)}finish(){const R=this.a;for(let L=0;L<R.length;L++){const{observer:P,observable:E}=R[L];P.endUpdate(E)}this.a=null,(0,O.$Gd)()?.handleEndTransaction()}}t.$Xd=g;function y(N,R){let L;return typeof N=="string"?L=new T.$$c(void 0,N,void 0):L=new T.$$c(N,void 0,void 0),new d(L,R,i.$6c)}function o(N,R){return new d(new T.$$c(N.owner,N.debugName,void 0),R,N.equalsFn??i.$6c)}class d extends c{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(R,L,P){super(),this.e=R,this.g=P,this.d=L}get(){return this.d}set(R,L,P){if(this.g(this.d,R))return;let E;L||(L=E=new g(()=>{},()=>`Setting ${this.debugName}`));try{const z=this.d;this.h(R),(0,O.$Gd)()?.handleObservableChanged(this,{oldValue:z,newValue:R,change:P,didChange:!0,hadValue:!0});for(const W of this.b)L.updateObserver(W,this),W.handleChange(this,P)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(R){this.d=R}}t.$1d=d;function a(N,R){let L;return typeof N=="string"?L=new T.$$c(void 0,N,void 0):L=new T.$$c(N,void 0,void 0),new k(L,R,i.$6c)}class k extends d{h(R){this.d!==R&&(this.d&&this.d.dispose(),this.d=R)}dispose(){this.d?.dispose()}}t.$3d=k}),define(be[42],$e([1,0,37,38,2,33,26,27]),function(se,t,i,T,O,H,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nd=void 0,t.$Id=m,t.$Jd=b,t.$Kd=p,t.$Ld=j,t.$Md=c;function m(n,r){return r!==void 0?new e(new S.$$c(n,void 0,r),r,void 0,void 0,void 0,T.$6c):new e(new S.$$c(void 0,void 0,n),n,void 0,void 0,void 0,T.$6c)}function b(n,r){return new e(new S.$$c(n.owner,n.debugName,n.debugReferenceFn),r,void 0,void 0,n.onLastObserverRemoved,n.equalsFn??T.$6c)}(0,H.$Qd)(b);function p(n,r){return new e(new S.$$c(n.owner,n.debugName,void 0),r,n.createEmptyChangeSummary,n.handleChange,void 0,n.equalityComparer??T.$6c)}function j(n,r){let h,g;r===void 0?(h=n,g=void 0):(g=n,h=r);const y=new O.$Tc;return new e(new S.$$c(g,void 0,h),o=>(y.clear(),h(o,y)),void 0,void 0,()=>y.dispose(),T.$6c)}function c(n,r){let h,g;r===void 0?(h=n,g=void 0):(g=n,h=r);const y=new O.$Tc;return new e(new S.$$c(g,void 0,h),o=>{y.clear();const d=h(o);return d&&y.add(d),d},void 0,void 0,()=>y.dispose(),T.$6c)}var f;(function(n){n[n.initial=0]="initial",n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(f||(f={}));class e extends H.$Sd{get debugName(){return this.m.getDebugName(this)??"(anonymous)"}constructor(r,h,g,y,o=void 0,d){super(),this.m=r,this._computeFn=h,this.n=g,this.p=y,this.q=o,this.s=d,this.e=0,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,A.$Gd)()?.handleDerivedCreated(this)}f(){this.e=0,this.g=void 0;for(const r of this.j)r.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.b.size===0){const r=this._computeFn(this,this.n?.());return this.f(),r}else{do{if(this.e===1){for(const r of this.j)if(r.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.u()}while(this.e!==3);return this.g}}u(){if(this.e===3)return;const r=this.k;this.k=this.j,this.j=r;const h=this.e!==0,g=this.g;this.e=3;const y=this.l;this.l=this.n?.();try{this.g=this._computeFn(this,y)}finally{for(const d of this.k)d.removeObserver(this);this.k.clear()}const o=h&&!this.s(g,this.g);if((0,A.$Gd)()?.handleDerivedRecomputed(this,{oldValue:g,newValue:this.g,change:void 0,didChange:o,hadValue:h}),o)for(const d of this.b)d.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(r){this.h++;const h=this.h===1;if(this.e===3&&(this.e=1,!h))for(const g of this.b)g.handlePossibleChange(this);if(h)for(const g of this.b)g.beginUpdate(this)}endUpdate(r){if(this.h--,this.h===0){const h=[...this.b];for(const g of h)g.endUpdate(this)}(0,i.$fd)(()=>this.h>=0)}handlePossibleChange(r){if(this.e===3&&this.j.has(r)&&!this.k.has(r)){this.e=1;for(const h of this.b)h.handlePossibleChange(this)}}handleChange(r,h){if(this.j.has(r)&&!this.k.has(r)){const g=this.p?this.p({changedObservable:r,change:h,didChange:o=>o===r},this.l):!0,y=this.e===3;if(g&&(this.e===1||y)&&(this.e=2,y))for(const o of this.b)o.handlePossibleChange(this)}}readObservable(r){r.addObserver(this);const h=r.get();return this.j.add(r),this.k.delete(r),h}addObserver(r){const h=!this.b.has(r)&&this.h>0;super.addObserver(r),h&&r.beginUpdate(this)}removeObserver(r){const h=this.b.has(r)&&this.h>0;super.removeObserver(r),h&&r.endUpdate(this)}}t.$Nd=e}),define(be[56],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(T){function O(m,b){if(m.start>=b.end||b.start>=m.end)return{start:0,end:0};const p=Math.max(m.start,b.start),j=Math.min(m.end,b.end);return j-p<=0?{start:0,end:0}:{start:p,end:j}}T.intersect=O;function H(m){return m.end-m.start<=0}T.isEmpty=H;function S(m,b){return!H(O(m,b))}T.intersects=S;function A(m,b){const p=[],j={start:m.start,end:Math.min(b.start,m.end)},c={start:Math.max(b.end,m.start),end:m.end};return H(j)||p.push(j),H(c)||p.push(c),p}T.relativeComplement=A})(i||(t.Range=i={}))}),define(be[92],$e([1,0,56]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QT=void 0,t.$NT=T,t.$OT=O,t.$PT=H;function T(m,b){const p=[];for(const j of b){if(m.start>=j.range.end)continue;if(m.end<j.range.start)break;const c=i.Range.intersect(m,j.range);i.Range.isEmpty(c)||p.push({range:c,size:j.size})}return p}function O({start:m,end:b},p){return{start:m+p,end:b+p}}function H(m){const b=[];let p=null;for(const j of m){const c=j.range.start,f=j.range.end,e=j.size;if(p&&e===p.size){p.range.end=f;continue}p={range:{start:c,end:f},size:e},b.push(p)}return b}function S(...m){return H(m.reduce((b,p)=>b.concat(p),[]))}class A{get paddingTop(){return this.c}set paddingTop(b){this.b=this.b+b-this.c,this.c=b}constructor(b){this.a=[],this.b=0,this.c=0,this.c=b??0,this.b=this.c}splice(b,p,j=[]){const c=j.length-p,f=T({start:0,end:b},this.a),e=T({start:b+p,end:Number.POSITIVE_INFINITY},this.a).map(r=>({range:O(r.range,c),size:r.size})),n=j.map((r,h)=>({range:{start:b+h,end:b+h+1},size:r.size}));this.a=S(f,n,e),this.b=this.c+this.a.reduce((r,h)=>r+h.size*(h.range.end-h.range.start),0)}get count(){const b=this.a.length;return b?this.a[b-1].range.end:0}get size(){return this.b}indexAt(b){if(b<0)return-1;if(b<this.c)return 0;let p=0,j=this.c;for(const c of this.a){const f=c.range.end-c.range.start,e=j+f*c.size;if(b<e)return p+Math.floor((b-j)/c.size);p+=f,j=e}return p}indexAfter(b){return Math.min(this.indexAt(b)+1,this.count)}positionAt(b){if(b<0)return-1;let p=0,j=0;for(const c of this.a){const f=c.range.end-c.range.start,e=j+f;if(b<e)return this.c+p+(b-j)*c.size;p+=f*c.size,j=e}return-1}}t.$QT=A}),define(be[93],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(H){return new T(H)}constructor(H){this.c=i&&H===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$0d=T}),define(be[3],$e([1,0,6,53,2,55,93]),function(se,t,i,T,O,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$_d=t.Event=void 0,t.$ae=f;const A=!1,m=!1,b=!1;var p;(function(G){G.None=()=>O.$Uc.None;function V(D){if(b){const{onDidAddListener:$}=D,I=n.create();let M=0;D.onDidAddListener=()=>{++M===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),I.print()),$?.()}}}function ae(D,$){return le(D,()=>{},0,void 0,!0,void 0,$)}G.defer=ae;function ie(D){return($,I=null,M)=>{let Y=!1,J;return J=D(oe=>{if(!Y)return J?J.dispose():Y=!0,$.call(I,oe)},null,M),Y&&J.dispose(),J}}G.once=ie;function ee(D,$,I){return _((M,Y=null,J)=>D(oe=>M.call(Y,$(oe)),null,J),I)}G.map=ee;function ge(D,$,I){return _((M,Y=null,J)=>D(oe=>{$(oe),M.call(Y,oe)},null,J),I)}G.forEach=ge;function Ee(D,$,I){return _((M,Y=null,J)=>D(oe=>$(oe)&&M.call(Y,oe),null,J),I)}G.filter=Ee;function De(D){return D}G.signal=De;function Le(...D){return($,I=null,M)=>{const Y=(0,O.$Rc)(...D.map(J=>J(oe=>$.call(I,oe))));return ue(Y,M)}}G.any=Le;function he(D,$,I,M){let Y=I;return ee(D,J=>(Y=$(Y,J),Y),M)}G.reduce=he;function _(D,$){let I;const M={onWillAddFirstListener(){I=D(Y.fire,Y)},onDidRemoveLastListener(){I?.dispose()}};$||V(M);const Y=new d(M);return $?.add(Y),Y.event}function ue(D,$){return $ instanceof Array?$.push(D):$&&$.add(D),D}function le(D,$,I=100,M=!1,Y=!1,J,oe){let we,fe,Ie,ke=0,Oe;const Se={leakWarningThreshold:J,onWillAddFirstListener(){we=D(He=>{ke++,fe=$(fe,He),M&&!Ie&&(Ce.fire(fe),fe=void 0),Oe=()=>{const Ue=fe;fe=void 0,Ie=void 0,(!M||ke>1)&&Ce.fire(Ue),ke=0},typeof I=="number"?(clearTimeout(Ie),Ie=setTimeout(Oe,I)):Ie===void 0&&(Ie=0,queueMicrotask(Oe))})},onWillRemoveListener(){Y&&ke>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,we.dispose()}};oe||V(Se);const Ce=new d(Se);return oe?.add(Ce),Ce.event}G.debounce=le;function Q(D,$=0,I){return G.debounce(D,(M,Y)=>M?(M.push(Y),M):[Y],$,void 0,!0,void 0,I)}G.accumulate=Q;function U(D,$=(M,Y)=>M===Y,I){let M=!0,Y;return Ee(D,J=>{const oe=M||!$(J,Y);return M=!1,Y=J,oe},I)}G.latch=U;function re(D,$,I){return[G.filter(D,$,I),G.filter(D,M=>!$(M),I)]}G.split=re;function me(D,$=!1,I=[],M){let Y=I.slice(),J=D(fe=>{Y?Y.push(fe):we.fire(fe)});M&&M.add(J);const oe=()=>{Y?.forEach(fe=>we.fire(fe)),Y=null},we=new d({onWillAddFirstListener(){J||(J=D(fe=>we.fire(fe)),M&&M.add(J))},onDidAddFirstListener(){Y&&($?setTimeout(oe):oe())},onDidRemoveLastListener(){J&&J.dispose(),J=null}});return M&&M.add(we),we.event}G.buffer=me;function ve(D,$){return(M,Y,J)=>{const oe=$(new Te);return D(function(we){const fe=oe.evaluate(we);fe!==Ne&&M.call(Y,fe)},void 0,J)}}G.chain=ve;const Ne=Symbol("HaltChainable");class Te{constructor(){this.f=[]}map($){return this.f.push($),this}forEach($){return this.f.push(I=>($(I),I)),this}filter($){return this.f.push(I=>$(I)?I:Ne),this}reduce($,I){let M=I;return this.f.push(Y=>(M=$(M,Y),M)),this}latch($=(I,M)=>I===M){let I=!0,M;return this.f.push(Y=>{const J=I||!$(Y,M);return I=!1,M=Y,J?Y:Ne}),this}evaluate($){for(const I of this.f)if($=I($),$===Ne)break;return $}}function Me(D,$,I=M=>M){const M=(...we)=>oe.fire(I(...we)),Y=()=>D.on($,M),J=()=>D.removeListener($,M),oe=new d({onWillAddFirstListener:Y,onDidRemoveLastListener:J});return oe.event}G.fromNodeEventEmitter=Me;function x(D,$,I=M=>M){const M=(...we)=>oe.fire(I(...we)),Y=()=>D.addEventListener($,M),J=()=>D.removeEventListener($,M),oe=new d({onWillAddFirstListener:Y,onDidRemoveLastListener:J});return oe.event}G.fromDOMEventEmitter=x;function u(D){return new Promise($=>ie(D)($))}G.toPromise=u;function v(D){const $=new d;return D.then(I=>{$.fire(I)},()=>{$.fire(void 0)}).finally(()=>{$.dispose()}),$.event}G.fromPromise=v;function l(D,$,I){return $(I),D(M=>$(M))}G.runAndSubscribe=l;class w{constructor($,I){this._observable=$,this.f=0,this.g=!1;const M={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};I||V(M),this.emitter=new d(M),I&&I.add(this.emitter)}beginUpdate($){this.f++}handlePossibleChange($){}handleChange($,I){this.g=!0}endUpdate($){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function C(D,$){return new w(D,$).emitter.event}G.fromObservable=C;function s(D){return($,I,M)=>{let Y=0,J=!1;const oe={beginUpdate(){Y++},endUpdate(){Y--,Y===0&&(D.reportChanges(),J&&(J=!1,$.call(I)))},handlePossibleChange(){},handleChange(){J=!0}};D.addObserver(oe),D.reportChanges();const we={dispose(){D.removeObserver(oe)}};return M instanceof O.$Tc?M.add(we):Array.isArray(M)&&M.push(we),we}}G.fromObservableLight=s})(p||(t.Event=p={}));class j{static{this.all=new Set}static{this.f=0}constructor(V){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${V}_${j.f++}`,j.all.add(this)}start(V){this.g=new S.$0d,this.listenerCount=V}stop(){if(this.g){const V=this.g.elapsed();this.durations.push(V),this.elapsedOverall+=V,this.invocationCount+=1,this.g=void 0}}}t.$_d=j;let c=-1;function f(G){const V=c;return c=G,{dispose(){c=V}}}class e{constructor(V,ae=Math.random().toString(18).slice(2,5)){this.threshold=V,this.name=ae,this.g=0}dispose(){this.f?.clear()}check(V,ae){const ie=this.threshold;if(ie<=0||ae<ie)return;this.f||(this.f=new Map);const ee=this.f.get(V.value)||0;if(this.f.set(V.value,ee+1),this.g-=1,this.g<=0){this.g=ie*.5;let ge,Ee=0;for(const[De,Le]of this.f)(!ge||Ee<Le)&&(ge=De,Ee=Le);console.warn(`[${this.name}] potential listener LEAK detected, having ${ae} listeners already. MOST frequent listener (${Ee}):`),console.warn(ge)}return()=>{const ge=this.f.get(V.value)||0;this.f.set(V.value,ge-1)}}}class n{static create(){return new n(new Error().stack??"")}constructor(V){this.value=V}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let r=0;class h{constructor(V){this.value=V,this.id=r++}}const g=2,y=(G,V)=>{if(G instanceof h)V(G);else for(let ae=0;ae<G.length;ae++){const ie=G[ae];ie&&V(ie)}},o=A?new FinalizationRegistry(G=>{typeof G=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(G))}):void 0;class d{constructor(V){this.w=0,this.f=V,this.g=c>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??c):void 0,this.j=this.f?._profName?new j(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const V=this.t;queueMicrotask(()=>{y(V,ae=>ae.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(V,ae,ie)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),O.$Uc.None;if(this.m)return O.$Uc.None;ae&&(V=V.bind(ae));const ee=new h(V);let ge,Ee;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ee.stack=n.create(),ge=this.g.check(ee.stack,this.w+1)),m&&(ee.stack=Ee??n.create()),this.t?this.t instanceof h?(this.u??=new k,this.t=[this.t,ee]):this.t.push(ee):(this.f?.onWillAddFirstListener?.(this),this.t=ee,this.f?.onDidAddFirstListener?.(this)),this.w++;const De=(0,O.$Sc)(()=>{o?.unregister(De),ge?.(),this.x(ee)});if(ie instanceof O.$Tc?ie.add(De):Array.isArray(ie)&&ie.push(De),o){const Le=new Error().stack.split(`
`).slice(2).join(`
`).trim();o.register(De,Le,De)}return De},this.q}x(V){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const ae=this.t,ie=ae.indexOf(V);if(ie===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,ae[ie]=void 0;const ee=this.u.current===this;if(this.w*g<=ae.length){let ge=0;for(let Ee=0;Ee<ae.length;Ee++)ae[Ee]?ae[ge++]=ae[Ee]:ee&&(this.u.end--,ge<this.u.i&&this.u.i--);ae.length=ge}}y(V,ae){if(!V)return;const ie=this.f?.onListenerError||i.$1;if(!ie){V.value(ae);return}try{V.value(ae)}catch(ee){ie(ee)}}z(V){const ae=V.current.t;for(;V.i<V.end;)this.y(ae[V.i++],V.value);V.reset()}fire(V){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,V);else{const ae=this.u;ae.enqueue(this,V,this.t.length),this.z(ae)}this.j?.stop()}hasListeners(){return this.w>0}}t.$be=d;const a=()=>new k;t.$ce=a;class k{constructor(){this.i=-1,this.end=0}enqueue(V,ae,ie){this.i=0,this.end=ie,this.current=V,this.value=ae}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class N extends d{async fireAsync(V,ae,ie){if(this.t)for(this.h||(this.h=new H.$5c),y(this.t,ee=>this.h.push([ee.value,V]));this.h.size>0&&!ae.isCancellationRequested;){const[ee,ge]=this.h.shift(),Ee=[],De={...ge,token:ae,waitUntil:Le=>{if(Object.isFrozen(Ee))throw new Error("waitUntil can NOT be called asynchronous");ie&&(Le=ie(Le,ee)),Ee.push(Le)}};try{ee(De)}catch(Le){(0,i.$1)(Le);continue}Object.freeze(Ee),await Promise.allSettled(Ee).then(Le=>{for(const he of Le)he.status==="rejected"&&(0,i.$1)(he.reason)})}}}t.$de=N;class R extends d{get isPaused(){return this.h!==0}constructor(V){super(V),this.h=0,this.s=new H.$5c,this.A=V?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const V=Array.from(this.s);this.s.clear(),super.fire(this.A(V))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(V){this.w&&(this.h!==0?this.s.push(V):super.fire(V))}}t.$ee=R;class L extends R{constructor(V){super(V),this.k=V.delay??100}fire(V){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(V)}}t.$fe=L;class P extends d{constructor(V){super(V),this.h=[],this.k=V?.merge}fire(V){this.hasListeners()&&(this.h.push(V),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ae=>super.fire(ae)),this.h=[]}))}}t.$ge=P;class E{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(V){const ae={event:V,listener:null};this.h.push(ae),this.g&&this.m(ae);const ie=()=>{this.g&&this.o(ae);const ee=this.h.indexOf(ae);this.h.splice(ee,1)};return(0,O.$Sc)((0,T.$db)(ie))}j(){this.g=!0,this.h.forEach(V=>this.m(V))}k(){this.g=!1,this.h.forEach(V=>this.o(V))}m(V){V.listener=V.event(ae=>this.f.fire(ae))}o(V){V.listener?.dispose(),V.listener=null}dispose(){this.f.dispose();for(const V of this.h)V.listener?.dispose();this.h=[]}}t.$he=E;class z{constructor(V,ae,ie,ee){this.f=new O.$Tc;const ge=this.f.add(new E),Ee=this.f.add(new O.$4c);function De(Le){Ee.set(Le,ge.add(ee(Le)))}for(const Le of V)De(Le);this.f.add(ae(Le=>{De(Le)})),this.f.add(ie(Le=>{Ee.deleteAndDispose(Le)})),this.event=ge.event}dispose(){this.f.dispose()}}t.$ie=z;class W{constructor(){this.f=[]}wrapEvent(V){return(ae,ie,ee)=>V(ge=>{const Ee=this.f[this.f.length-1];Ee?Ee.push(()=>ae.call(ie,ge)):ae.call(ie,ge)},void 0,ee)}bufferEvents(V){const ae=[];this.f.push(ae);const ie=V();return this.f.pop(),ae.forEach(ee=>ee()),ie}}t.$je=W;class F{constructor(){this.f=!1,this.g=p.None,this.h=O.$Uc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(V){this.g=V,this.f&&(this.h.dispose(),this.h=V(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ke=F;class K{static const(V){return new B(V)}constructor(V){this.g=V,this.f=new d,this.onDidChange=this.f.event}get value(){return this.g}set value(V){V!==this.g&&(this.g=V,this.f.fire(void 0))}}t.$le=K;class B{constructor(V){this.value=V,this.onDidChange=p.None}}}),define(be[17],$e([1,0,22,3]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sR=t.$rR=t.$qR=t.$pR=t.$oR=t.$nR=t.$mR=t.$lR=t.$gR=void 0,t.$dR=H,t.$eR=S,t.$fR=A,t.$hR=m,t.$iR=b,t.$jR=p,t.$kR=j,t.$tR=e,t.$uR=n;class O{constructor(){this.a=new Map,this.b=new T.$be,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new T.$be,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new O}getZoomLevel(h){return this.a.get(this.f(h))??0}setZoomLevel(h,g){if(this.getZoomLevel(g)===h)return;const y=this.f(g);this.a.set(y,h),this.b.fire(y)}getZoomFactor(h){return this.c.get(this.f(h))??1}setZoomFactor(h,g){this.c.set(this.f(g),h)}setFullscreen(h,g){if(this.isFullscreen(g)===h)return;const y=this.f(g);this.e.set(y,h),this.d.fire(y)}isFullscreen(h){return!!this.e.get(this.f(h))}f(h){return h.vscodeWindowId}}function H(r,h,g){typeof h=="string"&&(h=r.matchMedia(h)),h.addEventListener("change",g)}function S(r,h){O.INSTANCE.setZoomLevel(r,h)}function A(r){return O.INSTANCE.getZoomLevel(r)}t.$gR=O.INSTANCE.onDidChangeZoomLevel;function m(r){return O.INSTANCE.getZoomFactor(r)}function b(r,h){O.INSTANCE.setZoomFactor(r,h)}function p(r,h){O.INSTANCE.setFullscreen(r,h)}function j(r){return O.INSTANCE.isFullscreen(r)}t.$lR=O.INSTANCE.onDidChangeFullscreen;const c=navigator.userAgent;t.$mR=c.indexOf("Firefox")>=0,t.$nR=c.indexOf("AppleWebKit")>=0,t.$oR=c.indexOf("Chrome")>=0,t.$pR=!t.$oR&&c.indexOf("Safari")>=0,t.$qR=!t.$oR&&!t.$pR&&t.$nR,t.$rR=c.indexOf("Electron/")>=0,t.$sR=c.indexOf("Android")>=0;let f=!1;if(typeof i.$aR.matchMedia=="function"){const r=i.$aR.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),h=i.$aR.matchMedia("(display-mode: fullscreen)");f=r.matches,H(i.$aR,r,({matches:g})=>{f&&h.matches||(f=g)})}function e(){return f}function n(){return navigator?.windowControlsOverlay?.visible}}),define(be[24],$e([1,0,3]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IT=void 0;class T{get event(){return this.a.event}constructor(H,S,A){const m=b=>this.a.fire(b);this.a=new i.$be({onWillAddFirstListener:()=>H.addEventListener(S,m,A),onDidRemoveLastListener:()=>H.removeEventListener(S,m,A)})}dispose(){this.a.dispose()}}t.$IT=T}),define(be[34],$e([1,0,3]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$me=t.CancellationToken=void 0;const T=Object.freeze(function(A,m){const b=setTimeout(A.bind(m),0);return{dispose(){clearTimeout(b)}}});var O;(function(A){function m(b){return b===A.None||b===A.Cancelled||b instanceof H?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}A.isCancellationToken=m,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(O||(t.CancellationToken=O={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new i.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class S{constructor(m){this.f=void 0,this.g=void 0,this.g=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new H),this.f}cancel(){this.f?this.f instanceof H&&this.f.cancel():this.f=O.Cancelled}dispose(m=!1){m&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof H&&this.f.dispose():this.f=O.None}}t.$me=S}),define(be[94],$e([1,0,34]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ze=t.$Ye=t.$Xe=void 0;class T{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new i.$me,m=this.b(A.token);return this.a={promise:m,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}t.$Xe=T;class O{constructor(A,m=JSON.stringify){this.c=A,this.d=m,this.a=void 0,this.b=void 0}get(A){const m=this.d(A);return this.b!==m&&(this.b=m,this.a=this.c(A)),this.a}}t.$Ye=O;class H{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const m=this.b(A);return this.a.set(A,m),m}}t.$Ze=H}),define(be[95],$e([1,0,41,33,42,34,26,38]),function(se,t,i,T,O,H,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7d=t.$6d=t.$5d=t.$4d=void 0,t.$8d=c,t.$9d=f;class m{get cachedValue(){return this.a}constructor(n){this.b=n,this.a=(0,T.$Yd)(this,void 0)}getValue(){let n=this.a.get();return n||(n=this.b(),this.a.set(n,void 0)),n}}t.$4d=m;class b{constructor(n){this.a=(0,T.$Yd)(this,void 0),this.promiseResult=this.a,this.promise=n.then(r=>((0,T.$Td)(h=>{this.a.set(new p(r,void 0),h)}),r),r=>{throw(0,T.$Td)(h=>{this.a.set(new p(void 0,r),h)}),r})}}t.$5d=b;class p{constructor(n,r){this.data=n,this.error=r}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$6d=p;class j{constructor(n){this.b=n,this.a=new m(()=>new b(this.b())),this.cachedPromiseResult=(0,O.$Id)(this,r=>this.a.cachedValue.read(r)?.promiseResult.read(r))}getPromise(){return this.a.getValue().promise}}t.$7d=j;function c(e,n,r){return n||(n=h=>h!=null),new Promise((h,g)=>{let y=!0,o=!1;const d=e.map(k=>({isFinished:n(k),error:r?r(k):!1,state:k})),a=(0,i.$hd)(k=>{const{isFinished:N,error:R,state:L}=d.read(k);(N||R)&&(y?o=!0:a.dispose(),R?g(R===!0?L:R):h(L))});y=!1,o&&a.dispose()})}function f(e,n){let r,h;n===void 0?(r=e,h=void 0):(h=e,r=n);let g;return new O.$Nd(new S.$$c(h,void 0,r),y=>(g&&g.dispose(!0),g=new H.$me,r(y,g.token)),void 0,void 0,()=>g?.dispose(),A.$6c)}}),define(be[96],$e([1,0,3,2,41,33,26,42,27]),function(se,t,i,T,O,H,S,A,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dd=t.$zd=t.$rd=void 0,t.$od=b,t.$pd=j,t.$qd=c,t.$sd=e,t.$td=r,t.$ud=g,t.$vd=y,t.$wd=o,t.$xd=d,t.$yd=a,t.$Ad=N,t.$Bd=R,t.$Cd=L,t.$Ed=z;function b(W){return new p(W)}class p extends H.$Rd{constructor(F){super(),this.b=F}get debugName(){return this.toString()}get(){return this.b}addObserver(F){}removeObserver(F){}toString(){return`Const: ${this.b}`}}function j(W){const F=(0,H.$Yd)("promiseValue",{});return W.then(K=>{F.set({value:K},void 0)}),F}function c(W,F){return new f(W,F)}class f extends H.$Sd{constructor(F,K){super(),this.j=F,this._getValue=K,this.g=!1,this.n=B=>{const G=this._getValue(B),V=this.e,ae=!this.g||V!==G;let ie=!1;ae&&(this.e=G,this.g&&(ie=!0,(0,H.$Wd)(f.globalTransaction,ee=>{(0,m.$Gd)()?.handleFromEventObservableTriggered(this,{oldValue:V,newValue:G,change:void 0,didChange:ae,hadValue:this.g});for(const ge of this.b)ee.updateObserver(ge,this),ge.handleChange(this,void 0)},()=>{const ee=this.k();return"Event fired"+(ee?`: ${ee}`:"")})),this.g=!0),ie||(0,m.$Gd)()?.handleFromEventObservableTriggered(this,{oldValue:V,newValue:G,change:void 0,didChange:ae,hadValue:this.g})}}k(){return(0,S.$ad)(this._getValue)}get debugName(){const F=this.k();return"From Event"+(F?`: ${F}`:"")}c(){this.h=this.j(this.n)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.n(void 0),this.e):this._getValue(void 0)}}t.$rd=f,function(W){W.Observer=f;function F(K,B){let G=!1;f.globalTransaction===void 0&&(f.globalTransaction=K,G=!0);try{B()}finally{G&&(f.globalTransaction=void 0)}}W.batchEventsGlobally=F}(c||(t.$qd=c={}));function e(W,F){return new n(W,F)}class n extends H.$Sd{constructor(F,K){super(),this.debugName=F,this.g=K,this.j=()=>{(0,H.$Td)(B=>{for(const G of this.b)B.updateObserver(G,this),G.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function r(W){return typeof W=="string"?new h(W):new h(void 0,W)}class h extends H.$Sd{get debugName(){return new S.$$c(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}constructor(F,K){super(),this.e=F,this.g=K}trigger(F,K){if(!F){(0,H.$Td)(B=>{this.trigger(B,K)},()=>`Trigger signal ${this.debugName}`);return}for(const B of this.b)F.updateObserver(B,this),B.handleChange(this,K)}get(){}}function g(W,F,K){const B=(0,H.$Yd)("debounced",void 0);let G;return K.add((0,O.$hd)(V=>{const ae=W.read(V);G&&clearTimeout(G),G=setTimeout(()=>{(0,H.$Td)(ie=>{B.set(ae,ie)})},F)})),B}function y(W,F){let K=!1,B,G;return c(V=>{const ae=(0,O.$hd)(ie=>{const ee=W.read(ie);K?(G&&clearTimeout(G),G=setTimeout(()=>{B=ee,V()},F)):(K=!0,B=ee)});return{dispose(){ae.dispose(),K=!1,B=void 0}}},()=>K?B:W.get())}function o(W,F,K){const B=(0,H.$Yd)("triggeredRecently",!1);let G;return K.add(W(()=>{B.set(!0,void 0),G&&clearTimeout(G),G=setTimeout(()=>{B.set(!1,void 0)},F)})),B}function d(W){const F=new k(!1,void 0);return W.addObserver(F),(0,T.$Sc)(()=>{W.removeObserver(F)})}(0,H.$Pd)(d);function a(W,F){const K=new k(!0,F);return W.addObserver(K),F?F(W.get()):W.reportChanges(),(0,T.$Sc)(()=>{W.removeObserver(K)})}(0,H.$Od)(a);class k{constructor(F,K){this.b=F,this.c=K,this.a=0}beginUpdate(F){this.a++}endUpdate(F){this.a--,this.a===0&&this.b&&(this.c?this.c(F.get()):F.reportChanges())}handlePossibleChange(F){}handleChange(F,K){}}t.$zd=k;function N(W,F){let K;return(0,A.$Id)(W,G=>(K=F(G,K),K))}function R(W,F){let K;const B=r("derivedObservableWithWritableCache"),G=(0,A.$Id)(W,V=>(B.read(V),K=F(V,K),K));return Object.assign(G,{clearCache:V=>{K=void 0,B.trigger(V)},setCache:(V,ae)=>{K=V,B.trigger(ae)}})}function L(W,F,K,B){let G=new P(K,B);return(0,A.$Jd)({debugReferenceFn:K,owner:W,onLastObserverRemoved:()=>{G.dispose(),G=new P(K)}},ae=>(G.setItems(F.read(ae)),G.getItems()))}class P{constructor(F,K){this.c=F,this.e=K,this.a=new Map,this.b=[]}dispose(){this.a.forEach(F=>F.store.dispose()),this.a.clear()}setItems(F){const K=[],B=new Set(this.a.keys());for(const G of F){const V=this.e?this.e(G):G;let ae=this.a.get(V);if(ae)B.delete(V);else{const ie=new T.$Tc;ae={out:this.c(G,ie),store:ie},this.a.set(V,ae)}K.push(ae.out)}for(const G of B)this.a.get(G).store.dispose(),this.a.delete(G);this.b=K}getItems(){return this.b}}class E{constructor(F){this.observable=F}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.$Dd=E;function z(W,F){return F instanceof E?F.observable:c(F.onDidChange,()=>F.value)}}),define(be[57],$e([1,0,33,42,41,96,95,27]),function(se,t,i,T,O,H,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.$Yd}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.$2d}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.$Td}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.$Wd}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return T.$Id}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return T.$Jd}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return T.$Kd}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return T.$Ld}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return O.$hd}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return O.$md}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return O.$jd}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return O.$ld}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return O.$id}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return O.$kd}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return H.$od}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return H.$ud}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return H.$Ad}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return H.$Bd}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return H.$xd}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return H.$yd}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return H.$qd}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return H.$pd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return H.$td}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return H.$sd}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return H.$wd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return S.$4d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return S.$7d}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return S.$5d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return S.$6d}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return S.$8d}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return S.$9d}}),!1&&(0,A.$Fd)(new A.$Hd)}),define(be[58],$e([1,0,3,2]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ps=t.$Os=t.$Ns=t.$Ms=t.ScrollbarVisibility=void 0;var O;(function(f){f[f.Auto=1]="Auto",f[f.Hidden=2]="Hidden",f[f.Visible=3]="Visible"})(O||(t.ScrollbarVisibility=O={}));class H{constructor(e,n,r,h,g,y,o){this.c=e,this._scrollStateBrand=void 0,this.c&&(n=n|0,r=r|0,h=h|0,g=g|0,y=y|0,o=o|0),this.rawScrollLeft=h,this.rawScrollTop=o,n<0&&(n=0),h+n>r&&(h=r-n),h<0&&(h=0),g<0&&(g=0),o+g>y&&(o=y-g),o<0&&(o=0),this.width=n,this.scrollWidth=r,this.scrollLeft=h,this.height=g,this.scrollHeight=y,this.scrollTop=o}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,n){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,n){const r=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,g=this.scrollLeft!==e.scrollLeft,y=this.height!==e.height,o=this.scrollHeight!==e.scrollHeight,d=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:n,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:h,scrollLeftChanged:g,heightChanged:y,scrollHeightChanged:o,scrollTopChanged:d}}}t.$Ms=H;class S extends T.$Uc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$be),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,n){const r=this.g.withScrollDimensions(e,n);this.n(r,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const n=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(e,n){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const r=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===r.scrollLeft&&this.h.to.scrollTop===r.scrollTop)return;let h;n?h=new p(this.h.from,r,this.h.startTime,this.h.duration):h=this.h.combine(this.g,r,this.c),this.h.dispose(),this.h=h}else{const r=this.g.withScrollPosition(e);this.h=p.start(this.g,r,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),n=this.g.withScrollPosition(e);if(this.n(n,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,n){const r=this.g;r.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(r,n)))}}t.$Ns=S;class A{constructor(e,n,r){this.scrollLeft=e,this.scrollTop=n,this.isDone=r}}t.$Os=A;function m(f,e){const n=e-f;return function(r){return f+n*c(r)}}function b(f,e,n){return function(r){return r<n?f(r/n):e((r-n)/(1-n))}}class p{constructor(e,n,r,h){this.from=e,this.to=n,this.duration=h,this.startTime=r,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,n,r){if(Math.abs(e-n)>2.5*r){let g,y;return e<n?(g=e+.75*r,y=n-.75*r):(g=e-.75*r,y=n+.75*r),b(m(e,g),m(y,n),.33)}return m(e,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const n=(e-this.startTime)/this.duration;if(n<1){const r=this.c(n),h=this.d(n);return new A(r,h,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,n,r){return p.start(e,n,r)}static start(e,n,r){r=r+10;const h=Date.now()-10;return new p(e,n,h,r)}}t.$Ps=p;function j(f){return Math.pow(f,3)}function c(f){return 1-j(1-f)}}),define(be[97],$e([1,0,6,2]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ne=O,t.$oe=H,t.$pe=S,t.$qe=A,t.$re=b,t.$se=p,t.$te=j,t.$ue=c,t.$ve=f,t.$we=e,t.$xe=n,t.$ye=r,t.$ze=h,t.$Ae=g,t.$Be=y;function O(o){const d=o;return d?typeof d.read=="function":!1}function H(o){const d=o;return d?[d.on,d.pause,d.resume,d.destroy].every(a=>typeof a=="function"):!1}function S(o){const d=o;return d?H(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}function A(o,d){return new m(o,d)}class m{constructor(d,a){this.e=d,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(a=>a(d))}h(d){this.c.error.length===0?(0,i.$1)(d):this.c.error.slice(0).forEach(a=>a(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,a){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(d,a){if(this.a.destroyed)return;let k;switch(d){case"data":k=this.c.data;break;case"end":k=this.c.end;break;case"error":k=this.c.error;break}if(k){const N=k.indexOf(a);N>=0&&k.splice(N,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(k=>k())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(o,d){const a=[];let k;for(;(k=o.read())!==null;)a.push(k);return d(a)}function p(o,d,a){const k=[];let N;for(;(N=o.read())!==null&&k.length<a;)k.push(N);return N===null&&k.length>0?d(k):{read:()=>{if(k.length>0)return k.shift();if(typeof N<"u"){const R=N;return N=void 0,R}return o.read()}}}function j(o,d){return new Promise((a,k)=>{const N=[];c(o,{onData:R=>{d&&N.push(R)},onError:R=>{d?k(R):a(void 0)},onEnd:()=>{a(d?d(N):void 0)}})})}function c(o,d,a){o.on("error",k=>{a?.isCancellationRequested||d.onError(k)}),o.on("end",()=>{a?.isCancellationRequested||d.onEnd()}),o.on("data",k=>{a?.isCancellationRequested||d.onData(k)})}function f(o,d){return new Promise((a,k)=>{const N=new T.$Tc,R=[],L=z=>{if(R.push(z),R.length>d)return N.dispose(),o.pause(),a({stream:o,buffer:R,ended:!1})},P=z=>(N.dispose(),k(z)),E=()=>(N.dispose(),a({stream:o,buffer:R,ended:!0}));N.add((0,T.$Sc)(()=>o.removeListener("error",P))),o.on("error",P),N.add((0,T.$Sc)(()=>o.removeListener("end",E))),o.on("end",E),N.add((0,T.$Sc)(()=>o.removeListener("data",L))),o.on("data",L)})}function e(o,d){const a=A(d);return a.end(o),a}function n(){const o=A(()=>{throw new Error("not supported")});return o.end(),o}function r(o){let d=!1;return{read:()=>d?null:(d=!0,o)}}function h(o,d,a){const k=A(a);return c(o,{onData:N=>k.write(d.data(N)),onError:N=>k.error(d.error?d.error(N):N),onEnd:()=>k.end()}),k}function g(o,d,a){let k=!1;return{read:()=>{const N=d.read();return k?N:(k=!0,N!==null?a([o,N]):o)}}}function y(o,d,a){let k=!1;const N=A(a);return c(d,{onData:R=>k?N.write(R):(k=!0,N.write(a([o,R]))),onError:R=>N.error(R),onEnd:()=>{k||(k=!0,N.write(o)),N.end()}}),N}}),define(be[43],$e([1,0,23,97]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ce=void 0,t.$De=b,t.$Ee=p,t.$Fe=j,t.$Ge=c,t.$He=f,t.$Ie=e,t.$Je=n,t.$Ke=r,t.$Le=h,t.$Me=g,t.$Ne=y,t.$Oe=o,t.$Pe=d,t.$Qe=a,t.$Re=k,t.$Se=N,t.$Te=R,t.$Ue=L,t.$Ve=P,t.$We=W;const O=typeof Buffer<"u",H=new i.$V(()=>new Uint8Array(256));let S,A;class m{static alloc(K){return O?new m(Buffer.allocUnsafe(K)):new m(new Uint8Array(K))}static wrap(K){return O&&!Buffer.isBuffer(K)&&(K=Buffer.from(K.buffer,K.byteOffset,K.byteLength)),new m(K)}static fromString(K,B){return!(B?.dontUseNodeBuffer||!1)&&O?new m(Buffer.from(K)):(S||(S=new TextEncoder),new m(S.encode(K)))}static fromByteArray(K){const B=m.alloc(K.length);for(let G=0,V=K.length;G<V;G++)B.buffer[G]=K[G];return B}static concat(K,B){if(typeof B>"u"){B=0;for(let ae=0,ie=K.length;ae<ie;ae++)B+=K[ae].byteLength}const G=m.alloc(B);let V=0;for(let ae=0,ie=K.length;ae<ie;ae++){const ee=K[ae];G.set(ee,V),V+=ee.byteLength}return G}constructor(K){this.buffer=K,this.byteLength=this.buffer.byteLength}clone(){const K=m.alloc(this.byteLength);return K.set(this),K}toString(){return O?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(K,B){return new m(this.buffer.subarray(K,B))}set(K,B){if(K instanceof m)this.buffer.set(K.buffer,B);else if(K instanceof Uint8Array)this.buffer.set(K,B);else if(K instanceof ArrayBuffer)this.buffer.set(new Uint8Array(K),B);else if(ArrayBuffer.isView(K))this.buffer.set(new Uint8Array(K.buffer,K.byteOffset,K.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(K){return c(this.buffer,K)}writeUInt32BE(K,B){f(this.buffer,K,B)}readUInt32LE(K){return e(this.buffer,K)}writeUInt32LE(K,B){n(this.buffer,K,B)}readUInt8(K){return r(this.buffer,K)}writeUInt8(K,B){h(this.buffer,K,B)}indexOf(K,B=0){return b(this.buffer,K instanceof m?K.buffer:K,B)}}t.$Ce=m;function b(F,K,B=0){const G=K.byteLength,V=F.byteLength;if(G===0)return 0;if(G===1)return F.indexOf(K[0]);if(G>V-B)return-1;const ae=H.value;ae.fill(K.length);for(let Ee=0;Ee<K.length;Ee++)ae[K[Ee]]=K.length-Ee-1;let ie=B+K.length-1,ee=ie,ge=-1;for(;ie<V;)if(F[ie]===K[ee]){if(ee===0){ge=ie;break}ie--,ee--}else ie+=Math.max(K.length-ee,ae[F[ie]]),ee=K.length-1;return ge}function p(F,K){return F[K+0]<<0>>>0|F[K+1]<<8>>>0}function j(F,K,B){F[B+0]=K&255,K=K>>>8,F[B+1]=K&255}function c(F,K){return F[K]*2**24+F[K+1]*2**16+F[K+2]*2**8+F[K+3]}function f(F,K,B){F[B+3]=K,K=K>>>8,F[B+2]=K,K=K>>>8,F[B+1]=K,K=K>>>8,F[B]=K}function e(F,K){return F[K+0]<<0>>>0|F[K+1]<<8>>>0|F[K+2]<<16>>>0|F[K+3]<<24>>>0}function n(F,K,B){F[B+0]=K&255,K=K>>>8,F[B+1]=K&255,K=K>>>8,F[B+2]=K&255,K=K>>>8,F[B+3]=K&255}function r(F,K){return F[K]}function h(F,K,B){F[B]=K}function g(F){return T.$re(F,K=>m.concat(K))}function y(F){return T.$ye(F)}function o(F){return T.$te(F,K=>m.concat(K))}async function d(F){return F.ended?m.concat(F.buffer):m.concat([...F.buffer,await o(F.stream)])}function a(F){return T.$we(F,K=>m.concat(K))}function k(F){return T.$ze(F,{data:K=>typeof K=="string"?m.fromString(K):m.wrap(K)},K=>m.concat(K))}function N(F){return T.$qe(K=>m.concat(K),F)}function R(F,K){return T.$Ae(F,K,B=>m.concat(B))}function L(F,K){return T.$Be(F,K,B=>m.concat(B))}function P(F){let K=0,B=0,G=0;const V=new Uint8Array(Math.floor(F.length/4*3)),ae=ee=>{switch(B){case 3:V[G++]=K|ee,B=0;break;case 2:V[G++]=K|ee>>>2,K=ee<<6,B=3;break;case 1:V[G++]=K|ee>>>4,K=ee<<4,B=2;break;default:K=ee<<2,B=1}};for(let ee=0;ee<F.length;ee++){const ge=F.charCodeAt(ee);if(ge>=65&&ge<=90)ae(ge-65);else if(ge>=97&&ge<=122)ae(ge-97+26);else if(ge>=48&&ge<=57)ae(ge-48+52);else if(ge===43||ge===45)ae(62);else if(ge===47||ge===95)ae(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${F[ee]}`)}}const ie=G;for(;B>0;)ae(0);return m.wrap(V).slice(0,ie)}const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function W({buffer:F},K=!0,B=!1){const G=B?z:E;let V="";const ae=F.byteLength%3;let ie=0;for(;ie<F.byteLength-ae;ie+=3){const ee=F[ie+0],ge=F[ie+1],Ee=F[ie+2];V+=G[ee>>>2],V+=G[(ee<<4|ge>>>4)&63],V+=G[(ge<<2|Ee>>>6)&63],V+=G[Ee&63]}if(ae===1){const ee=F[ie+0];V+=G[ee>>>2],V+=G[ee<<4&63],K&&(V+="==")}else if(ae===2){const ee=F[ie+0],ge=F[ie+1];V+=G[ee>>>2],V+=G[(ee<<4|ge>>>4)&63],V+=G[ge<<2&63],K&&(V+="=")}return V}}),define(be[9],$e([1,0,94,23]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3f=t.$2f=t.$1f=t.GraphemeBreakType=t.$Qf=t.$Jf=t.$Cf=t.$Bf=void 0,t.$3e=O,t.$4e=S,t.$5e=m,t.$6e=b,t.$7e=p,t.$8e=j,t.$9e=c,t.$0e=f,t.$$e=e,t.$_e=n,t.$af=r,t.$bf=h,t.$cf=g,t.$df=y,t.$ef=o,t.$ff=d,t.$gf=a,t.$hf=k,t.$if=N,t.$jf=R,t.$kf=L,t.$lf=P,t.$mf=E,t.$nf=z,t.$of=W,t.$pf=F,t.$qf=K,t.$rf=B,t.$sf=G,t.$tf=V,t.$uf=ae,t.$vf=ie,t.$wf=ee,t.$xf=ge,t.$yf=Ee,t.$zf=De,t.$Af=Le,t.$Df=le,t.$Ef=Q,t.$Ff=U,t.$Gf=re,t.$Hf=Ne,t.$If=Me,t.$Kf=x,t.$Lf=u,t.$Mf=v,t.$Nf=l,t.$Of=C,t.$Pf=s,t.$Rf=D,t.$Sf=$,t.$Tf=I,t.$Uf=M,t.$Vf=Y,t.$Wf=J,t.$Xf=oe,t.$Yf=we,t.$Zf=Se;function O(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}const H=/{(\d+)}/g;function S(Z,...ne){return ne.length===0?Z:Z.replace(H,function(pe,ye){const Re=parseInt(ye,10);return isNaN(Re)||Re<0||Re>=ne.length?pe:ne[Re]})}const A=/{([^}]+)}/g;function m(Z,ne){return Object.keys(ne).length===0?Z:Z.replace(A,(pe,ye)=>ne[ye]??pe)}function b(Z){return Z.replace(/[<>"'&]/g,ne=>{switch(ne){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ne})}function p(Z){return Z.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}function j(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(Z,ne){let pe=0;const ye=ne.charCodeAt(0);for(let Re=Z.length-1;Re>=0;Re--)Z.charCodeAt(Re)===ye&&pe++;return pe}function f(Z,ne,pe="\u2026"){return Z.length<=ne?Z:`${Z.substr(0,ne)}${pe}`}function e(Z,ne,pe="\u2026"){if(Z.length<=ne)return Z;const ye=Math.ceil(ne/2)-pe.length/2,Re=Math.floor(ne/2)-pe.length/2;return`${Z.substr(0,ye)}${pe}${Z.substr(Z.length-Re)}`}function n(Z,ne=" "){const pe=r(Z,ne);return h(pe,ne)}function r(Z,ne){if(!Z||!ne)return Z;const pe=ne.length;if(pe===0||Z.length===0)return Z;let ye=0;for(;Z.indexOf(ne,ye)===ye;)ye=ye+pe;return Z.substring(ye)}function h(Z,ne){if(!Z||!ne)return Z;const pe=ne.length,ye=Z.length;if(pe===0||ye===0)return Z;let Re=ye,ze=-1;for(;ze=Z.lastIndexOf(ne,Re-1),!(ze===-1||ze+pe!==Re);){if(ze===0)return"";Re=ze}return Z.substring(0,Re)}function g(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function y(Z){return Z.replace(/\*/g,"")}function o(Z,ne,pe={}){if(!Z)throw new Error("Cannot create regex from empty string");ne||(Z=j(Z)),pe.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(Z,ye)}function d(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}function a(Z){return Z.split(/\r\n|\r|\n/)}function k(Z){const ne=[],pe=Z.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ne.push(pe[2*ye]+(pe[2*ye+1]??""));return ne}function N(Z){for(let ne=0,pe=Z.length;ne<pe;ne++){const ye=Z.charCodeAt(ne);if(ye!==32&&ye!==9)return ne}return-1}function R(Z,ne=0,pe=Z.length){for(let ye=ne;ye<pe;ye++){const Re=Z.charCodeAt(ye);if(Re!==32&&Re!==9)return Z.substring(ne,ye)}return Z.substring(ne,pe)}function L(Z,ne=Z.length-1){for(let pe=ne;pe>=0;pe--){const ye=Z.charCodeAt(pe);if(ye!==32&&ye!==9)return pe}return-1}function P(Z,ne,pe){const ye=[];let Re=0;for(const ze of Z.matchAll(ne)){if(ye.push(Z.slice(Re,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Re=ze.index+ze[0].length,ye.push(pe(ze[0],...ze.slice(1),ze.index,Z,ze.groups))}return ye.push(Z.slice(Re)),Promise.all(ye).then(ze=>ze.join(""))}function E(Z,ne){return Z<ne?-1:Z>ne?1:0}function z(Z,ne,pe=0,ye=Z.length,Re=0,ze=ne.length){for(;pe<ye&&Re<ze;pe++,Re++){const it=Z.charCodeAt(pe),st=ne.charCodeAt(Re);if(it<st)return-1;if(it>st)return 1}const We=ye-pe,et=ze-Re;return We<et?-1:We>et?1:0}function W(Z,ne){return F(Z,ne,0,Z.length,0,ne.length)}function F(Z,ne,pe=0,ye=Z.length,Re=0,ze=ne.length){for(;pe<ye&&Re<ze;pe++,Re++){let it=Z.charCodeAt(pe),st=ne.charCodeAt(Re);if(it===st)continue;if(it>=128||st>=128)return z(Z.toLowerCase(),ne.toLowerCase(),pe,ye,Re,ze);B(it)&&(it-=32),B(st)&&(st-=32);const Qe=it-st;if(Qe!==0)return Qe}const We=ye-pe,et=ze-Re;return We<et?-1:We>et?1:0}function K(Z){return Z>=48&&Z<=57}function B(Z){return Z>=97&&Z<=122}function G(Z){return Z>=65&&Z<=90}function V(Z,ne){return Z.length===ne.length&&F(Z,ne)===0}function ae(Z,ne){const pe=ne.length;return ne.length>Z.length?!1:F(Z,ne,0,pe)===0}function ie(Z,ne){const pe=Math.min(Z.length,ne.length);let ye;for(ye=0;ye<pe;ye++)if(Z.charCodeAt(ye)!==ne.charCodeAt(ye))return ye;return pe}function ee(Z,ne){const pe=Math.min(Z.length,ne.length);let ye;const Re=Z.length-1,ze=ne.length-1;for(ye=0;ye<pe;ye++)if(Z.charCodeAt(Re-ye)!==ne.charCodeAt(ze-ye))return ye;return pe}function ge(Z){return 55296<=Z&&Z<=56319}function Ee(Z){return 56320<=Z&&Z<=57343}function De(Z,ne){return(Z-55296<<10)+(ne-56320)+65536}function Le(Z,ne,pe){const ye=Z.charCodeAt(pe);if(ge(ye)&&pe+1<ne){const Re=Z.charCodeAt(pe+1);if(Ee(Re))return De(ye,Re)}return ye}function he(Z,ne){const pe=Z.charCodeAt(ne-1);if(Ee(pe)&&ne>1){const ye=Z.charCodeAt(ne-2);if(ge(ye))return De(ye,pe)}return pe}class _{get offset(){return this.e}constructor(ne,pe=0){this.c=ne,this.d=ne.length,this.e=pe}setOffset(ne){this.e=ne}prevCodePoint(){const ne=he(this.c,this.e);return this.e-=ne>=65536?2:1,ne}nextCodePoint(){const ne=Le(this.c,this.d,this.e);return this.e+=ne>=65536?2:1,ne}eol(){return this.e>=this.d}}t.$Bf=_;class ue{get offset(){return this.c.offset}constructor(ne,pe=0){this.c=new _(ne,pe)}nextGraphemeLength(){const ne=ke.getInstance(),pe=this.c,ye=pe.offset;let Re=ne.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const ze=pe.offset,We=ne.getGraphemeBreakType(pe.nextCodePoint());if(fe(Re,We)){pe.setOffset(ze);break}Re=We}return pe.offset-ye}prevGraphemeLength(){const ne=ke.getInstance(),pe=this.c,ye=pe.offset;let Re=ne.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const ze=pe.offset,We=ne.getGraphemeBreakType(pe.prevCodePoint());if(fe(We,Re)){pe.setOffset(ze);break}Re=We}return ye-pe.offset}eol(){return this.c.eol()}}t.$Cf=ue;function le(Z,ne){return new ue(Z,ne).nextGraphemeLength()}function Q(Z,ne){return new ue(Z,ne).prevGraphemeLength()}function U(Z,ne){ne>0&&Ee(Z.charCodeAt(ne))&&ne--;const pe=ne+le(Z,ne);return[pe-Q(Z,pe),pe]}function re(Z){const ne=new ue(Z);let pe=0;for(;!ne.eol();)pe++,ne.nextGraphemeLength();return pe}let me;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ne(Z){return me||(me=ve()),me.test(Z)}const Te=/^[\t\n\r\x20-\x7E]*$/;function Me(Z){return Te.test(Z)}t.$Jf=/[\u2028\u2029]/;function x(Z){return t.$Jf.test(Z)}function u(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}function v(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}function l(Z,ne,pe=""){const ye=Z.trimStart();if(ye.length<ne)return ye;const Re=/\b/g;let ze=0;for(;Re.test(ye)&&!(ye.length-Re.lastIndex<ne);)ze=Re.lastIndex,Re.lastIndex+=1;return ze===0?ye:pe+ye.substring(ze).trimStart()}const w=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*C(Z){let ne=0;for(const pe of Z.matchAll(w))ne!==pe.index&&(yield{isCode:!1,str:Z.substring(ne,pe.index)}),yield{isCode:!0,str:pe[0]},ne=pe.index+pe[0].length;ne!==Z.length&&(yield{isCode:!1,str:Z.substring(ne)})}function s(Z){return Z&&(Z=Z.replace(w,"")),Z}t.$Qf="\uFEFF";function D(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}function $(Z){return D(Z)?Z.substr(1):Z}function I(Z,ne){if(!Z||!ne||Z.length<ne.length)return!1;const pe=ne.length,ye=Z.toLowerCase();let Re=0,ze=-1;for(;Re<pe;){const We=ye.indexOf(ne[Re],ze+1);if(We<0)return!1;ze=We,Re++}return!0}function M(Z,ne=!1){return Z?(ne&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}function Y(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}function J(Z,ne=1){if(ne===0)return"";let pe=-1;do pe=Z.indexOf(`
`,pe+1),ne--;while(ne>0&&pe>=0);return pe===-1?Z:(Z[pe-1]==="\r"&&pe--,Z.substr(0,pe))}function oe(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}function we(Z){return ke.getInstance().getGraphemeBreakType(Z)}function fe(Z,ne){return Z===0?ne!==5&&ne!==7:Z===2&&ne===3?!1:Z===4||Z===2||Z===3||ne===4||ne===2||ne===3?!0:!(Z===8&&(ne===8||ne===9||ne===11||ne===12)||(Z===11||Z===9)&&(ne===9||ne===10)||(Z===12||Z===10)&&ne===10||ne===5||ne===13||ne===7||Z===1||Z===13&&ne===14||Z===6&&ne===6)}var Ie;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(Ie||(t.GraphemeBreakType=Ie={}));class ke{static{this.c=null}static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=Oe()}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const pe=this.d,ye=pe.length/3;let Re=1;for(;Re<=ye;)if(ne<pe[3*Re])Re=2*Re;else if(ne>pe[3*Re+1])Re=2*Re+1;else return pe[3*Re+2];return 0}}function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(Z,ne){if(Z===0)return 0;const pe=Ce(Z,ne);if(pe!==void 0)return pe;const ye=new _(ne,Z);return ye.prevCodePoint(),ye.offset}function Ce(Z,ne){const pe=new _(ne,Z);let ye=pe.prevCodePoint();for(;He(ye)||ye===65039||ye===8419;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!v(ye))return;let Re=pe.offset;return Re>0&&pe.prevCodePoint()===8205&&(Re=pe.offset),Re}function He(Z){return 127995<=Z&&Z<=127999}var Ue;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),t.$1f="\xA0";class Xe{static{this.c=new T.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Ye(ne=>{function pe(Qe){const rt=new Map;for(let tt=0;tt<Qe.length;tt+=2)rt.set(Qe[tt],Qe[tt+1]);return rt}function ye(Qe,rt){const tt=new Map(Qe);for(const[mt,gt]of rt)tt.set(mt,gt);return tt}function Re(Qe,rt){if(!Qe)return rt;const tt=new Map;for(const[mt,gt]of Qe)rt.has(mt)&&tt.set(mt,gt);return tt}const ze=this.c.value;let We=ne.filter(Qe=>!Qe.startsWith("_")&&Qe in ze);We.length===0&&(We=["_default"]);let et;for(const Qe of We){const rt=pe(ze[Qe]);et=Re(et,rt)}const it=pe(ze._common),st=ye(it,et);return new Xe(st)})}static getInstance(ne){return Xe.d.get(Array.from(ne))}static{this.e=new T.$V(()=>Object.keys(Xe.c.value).filter(ne=>!ne.startsWith("_")))}static getLocales(){return Xe.e.value}constructor(ne){this.f=ne}isAmbiguous(ne){return this.f.has(ne)}getPrimaryConfusable(ne){return this.f.get(ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$2f=Xe;class _e{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(_e.c())),this.d}static isInvisibleCharacter(ne){return _e.e().has(ne)}static get codePoints(){return _e.e()}}t.$3f=_e}),define(be[44],$e([1,0,39,89,9]),function(se,t,i,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dk=t.FuzzyScore=t.$sk=t.$rk=void 0,t.or=H,t.$tk=A,t.$uk=m,t.$vk=j,t.$wk=P,t.$xk=E,t.$yk=G,t.$zk=V,t.$Ak=ae,t.$Bk=ie,t.$Ck=Ne,t.$Ek=u,t.$Fk=w,t.$Gk=C;function H(...$){return function(I,M){for(let Y=0,J=$.length;Y<J;Y++){const oe=$[Y](I,M);if(oe)return oe}return null}}t.$rk=S.bind(void 0,!1),t.$sk=S.bind(void 0,!0);function S($,I,M){if(!M||M.length<I.length)return null;let Y;return $?Y=O.$uf(M,I):Y=M.indexOf(I)===0,Y?I.length>0?[{start:0,end:I.length}]:[]:null}function A($,I){const M=I.toLowerCase().indexOf($.toLowerCase());return M===-1?null:[{start:M,end:M+$.length}]}function m($,I){return b($.toLowerCase(),I.toLowerCase(),0,0)}function b($,I,M,Y){if(M===$.length)return[];if(Y===I.length)return null;if($[M]===I[Y]){let J=null;return(J=b($,I,M+1,Y+1))?o({start:Y,end:Y+1},J):null}return b($,I,M,Y+1)}function p($){return 97<=$&&$<=122}function j($){return 65<=$&&$<=90}function c($){return 48<=$&&$<=57}function f($){return $===32||$===9||$===10||$===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach($=>e.add($.charCodeAt(0)));function n($){return f($)||e.has($)}function r($,I){return $===I||n($)&&n(I)}const h=new Map;function g($){if(h.has($))return h.get($);let I;const M=(0,T.$pk)($);return M&&(I=M),h.set($,I),I}function y($){return p($)||j($)||c($)}function o($,I){return I.length===0?I=[$]:$.end===I[0].start?I[0].start=$.start:I.unshift($),I}function d($,I){for(let M=I;M<$.length;M++){const Y=$.charCodeAt(M);if(j(Y)||c(Y)||M>0&&!y($.charCodeAt(M-1)))return M}return $.length}function a($,I,M,Y){if(M===$.length)return[];if(Y===I.length)return null;if($[M]!==I[Y].toLowerCase())return null;{let J=null,oe=Y+1;for(J=a($,I,M+1,Y+1);!J&&(oe=d(I,oe))<I.length;)J=a($,I,M+1,oe),oe++;return J===null?null:o({start:Y,end:Y+1},J)}}function k($){let I=0,M=0,Y=0,J=0,oe=0;for(let Oe=0;Oe<$.length;Oe++)oe=$.charCodeAt(Oe),j(oe)&&I++,p(oe)&&M++,y(oe)&&Y++,c(oe)&&J++;const we=I/$.length,fe=M/$.length,Ie=Y/$.length,ke=J/$.length;return{upperPercent:we,lowerPercent:fe,alphaPercent:Ie,numericPercent:ke}}function N($){const{upperPercent:I,lowerPercent:M}=$;return M===0&&I>.6}function R($){const{upperPercent:I,lowerPercent:M,alphaPercent:Y,numericPercent:J}=$;return M>.2&&I<.8&&Y>.6&&J<.2}function L($){let I=0,M=0,Y=0,J=0;for(let oe=0;oe<$.length;oe++)Y=$.charCodeAt(oe),j(Y)&&I++,p(Y)&&M++,f(Y)&&J++;return(I===0||M===0)&&J===0?$.length<=30:I<=5}function P($,I){if(!I||(I=I.trim(),I.length===0)||!L($))return null;I.length>60&&(I=I.substring(0,60));const M=k(I);if(!R(M)){if(!N(M))return null;I=I.toLowerCase()}let Y=null,J=0;for($=$.toLowerCase();J<I.length&&(Y=a($,I,0,J))===null;)J=d(I,J+1);return Y}function E($,I,M=!1){if(!I||I.length===0)return null;let Y=null,J=0;for($=$.toLowerCase(),I=I.toLowerCase();J<I.length&&(Y=z($,I,0,J,M),Y===null);)J=W(I,J+1);return Y}function z($,I,M,Y,J){let oe=0;if(M===$.length)return[];if(Y===I.length)return null;if(!r($.charCodeAt(M),I.charCodeAt(Y))){const Ie=g($.charCodeAt(M));if(!Ie)return null;for(let ke=0;ke<Ie.length;ke++)if(!r(Ie[ke],I.charCodeAt(Y+ke)))return null;oe+=Ie.length-1}let we=null,fe=Y+oe+1;if(we=z($,I,M+1,fe,J),!J)for(;!we&&(fe=W(I,fe))<I.length;)we=z($,I,M+1,fe,J),fe++;if(!we)return null;if($.charCodeAt(M)!==I.charCodeAt(Y)){const Ie=g($.charCodeAt(M));if(!Ie)return we;for(let ke=0;ke<Ie.length;ke++)if(Ie[ke]!==I.charCodeAt(Y+ke))return we}return o({start:Y,end:Y+oe+1},we)}function W($,I){for(let M=I;M<$.length;M++)if(n($.charCodeAt(M))||M>0&&n($.charCodeAt(M-1)))return M;return $.length}const F=H(t.$sk,P,A),K=H(t.$sk,P,m),B=new i.$Ec(1e4);function G($,I,M=!1){if(typeof $!="string"||typeof I!="string")return null;let Y=B.get($);Y||(Y=new RegExp(O.$cf($),"i"),B.set($,Y));const J=Y.exec(I);return J?[{start:J.index,end:J.index+J[0].length}]:M?K($,I):F($,I)}function V($,I){const M=u($,$.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return M?ie(M):null}function ae($,I,M,Y,J,oe){const we=Math.min(13,$.length);for(;M<we;M++){const fe=u($,I,M,Y,J,oe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,oe]}function ie($){if(typeof $>"u")return[];const I=[],M=$[1];for(let Y=$.length-1;Y>1;Y--){const J=$[Y]+M,oe=I[I.length-1];oe&&oe.end===J?oe.end=J+1:I.push({start:J,end:J+1})}return I}const ee=128;function ge(){const $=[],I=[];for(let M=0;M<=ee;M++)I[M]=0;for(let M=0;M<=ee;M++)$.push(I.slice(0));return $}function Ee($){const I=[];for(let M=0;M<=$;M++)I[M]=0;return I}const De=Ee(2*ee),Le=Ee(2*ee),he=ge(),_=ge(),ue=ge(),le=!1;function Q($,I,M,Y,J){function oe(fe,Ie,ke=" "){for(;fe.length<Ie;)fe=ke+fe;return fe}let we=` |   |${Y.split("").map(fe=>oe(fe,3)).join("|")}
`;for(let fe=0;fe<=M;fe++)fe===0?we+=" |":we+=`${I[fe-1]}|`,we+=$[fe].slice(0,J+1).map(Ie=>oe(Ie.toString(),3)).join("|")+`
`;return we}function U($,I,M,Y){$=$.substr(I),M=M.substr(Y),console.log(Q(_,$,$.length,M,M.length)),console.log(Q(ue,$,$.length,M,M.length)),console.log(Q(he,$,$.length,M,M.length))}function re($,I){if(I<0||I>=$.length)return!1;const M=$.codePointAt(I);switch(M){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$Mf(M)}}function me($,I){if(I<0||I>=$.length)return!1;switch($.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function ve($,I,M){return I[$]!==M[$]}function Ne($,I,M,Y,J,oe,we=!1){for(;I<M&&J<oe;)$[I]===Y[J]&&(we&&(De[I]=J),I+=1),J+=1;return I===M}var Te;(function($){$[$.Diag=1]="Diag",$[$.Left=2]="Left",$[$.LeftLeft=3]="LeftLeft"})(Te||(Te={}));var Me;(function($){$.Default=[-100,0];function I(M){return!M||M.length===2&&M[0]===-100&&M[1]===0}$.isDefault=I})(Me||(t.FuzzyScore=Me={}));class x{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(I,M){this.firstMatchCanBeWeak=I,this.boostFullMatch=M}}t.$Dk=x;function u($,I,M,Y,J,oe,we=x.default){const fe=$.length>ee?ee:$.length,Ie=Y.length>ee?ee:Y.length;if(M>=fe||oe>=Ie||fe-M>Ie-oe||!Ne(I,M,fe,J,oe,Ie,!0))return;v(fe,Ie,M,oe,I,J);let ke=1,Oe=1,Se=M,Ce=oe;const He=[!1];for(ke=1,Se=M;Se<fe;ke++,Se++){const ne=De[Se],pe=Le[Se],ye=Se+1<fe?Le[Se+1]:Ie;for(Oe=ne-oe+1,Ce=ne;Ce<ye;Oe++,Ce++){let Re=Number.MIN_SAFE_INTEGER,ze=!1;Ce<=pe&&(Re=l($,I,Se,M,Y,J,Ce,Ie,oe,he[ke-1][Oe-1]===0,He));let We=0;Re!==Number.MAX_SAFE_INTEGER&&(ze=!0,We=Re+_[ke-1][Oe-1]);const et=Ce>ne,it=et?_[ke][Oe-1]+(he[ke][Oe-1]>0?-5:0):0,st=Ce>ne+1&&he[ke][Oe-1]>0,Qe=st?_[ke][Oe-2]+(he[ke][Oe-2]>0?-5:0):0;if(st&&(!et||Qe>=it)&&(!ze||Qe>=We))_[ke][Oe]=Qe,ue[ke][Oe]=3,he[ke][Oe]=0;else if(et&&(!ze||it>=We))_[ke][Oe]=it,ue[ke][Oe]=2,he[ke][Oe]=0;else if(ze)_[ke][Oe]=We,ue[ke][Oe]=1,he[ke][Oe]=he[ke-1][Oe-1]+1;else throw new Error("not possible")}}if(le&&U($,M,Y,oe),!He[0]&&!we.firstMatchCanBeWeak)return;ke--,Oe--;const Ue=[_[ke][Oe],oe];let Xe=0,_e=0;for(;ke>=1;){let ne=Oe;do{const pe=ue[ke][ne];if(pe===3)ne=ne-2;else if(pe===2)ne=ne-1;else break}while(ne>=1);Xe>1&&I[M+ke-1]===J[oe+Oe-1]&&!ve(ne+oe-1,Y,J)&&Xe+1>he[ke][ne]&&(ne=Oe),ne===Oe?Xe++:Xe=1,_e||(_e=ne),ke--,Oe=ne-1,Ue.push(Oe)}Ie===fe&&we.boostFullMatch&&(Ue[0]+=2);const Z=_e-fe;return Ue[0]-=Z,Ue}function v($,I,M,Y,J,oe){let we=$-1,fe=I-1;for(;we>=M&&fe>=Y;)J[we]===oe[fe]&&(Le[we]=fe,we--),fe--}function l($,I,M,Y,J,oe,we,fe,Ie,ke,Oe){if(I[M]!==oe[we])return Number.MIN_SAFE_INTEGER;let Se=1,Ce=!1;return we===M-Y?Se=$[M]===J[we]?7:5:ve(we,J,oe)&&(we===0||!ve(we-1,J,oe))?(Se=$[M]===J[we]?7:5,Ce=!0):re(oe,we)&&(we===0||!re(oe,we-1))?Se=5:(re(oe,we-1)||me(oe,we-1))&&(Se=5,Ce=!0),Se>1&&M===Y&&(Oe[0]=!0),Ce||(Ce=ve(we,J,oe)||re(oe,we-1)||me(oe,we-1)),M===Y?we>Ie&&(Se-=Ce?3:5):ke?Se+=Ce?2:0:Se+=Ce?0:1,we+1===fe&&(Se-=Ce?3:5),Se}function w($,I,M,Y,J,oe,we){return s($,I,M,Y,J,oe,!0,we)}function C($,I,M,Y,J,oe,we){return s($,I,M,Y,J,oe,!1,we)}function s($,I,M,Y,J,oe,we,fe){let Ie=u($,I,M,Y,J,oe,fe);if(Ie&&!we)return Ie;if($.length>=3){const ke=Math.min(7,$.length-1);for(let Oe=M+1;Oe<ke;Oe++){const Se=D($,Oe);if(Se){const Ce=u(Se,Se.toLowerCase(),M,Y,J,oe,fe);Ce&&(Ce[0]-=3,(!Ie||Ce[0]>Ie[0])&&(Ie=Ce))}}}return Ie}function D($,I){if(I+1>=$.length)return;const M=$[I],Y=$[I+1];if(M!==Y)return $.slice(0,I)+Y+M+$.slice(I+2)}}),define(be[59],$e([1,0,9]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kj=t.$ij=void 0,t.$ej=T,t.$fj=O,t.$gj=H,t.$hj=A,t.$jj=n;function T(h){return O(h,0)}function O(h,g){switch(typeof h){case"object":return h===null?H(349,g):Array.isArray(h)?m(h,g):b(h,g);case"string":return A(h,g);case"boolean":return S(h,g);case"number":return H(h,g);case"undefined":return H(937,g);default:return H(617,g)}}function H(h,g){return(g<<5)-g+h|0}function S(h,g){return H(h?433:863,g)}function A(h,g){g=H(149417,g);for(let y=0,o=h.length;y<o;y++)g=H(h.charCodeAt(y),g);return g}function m(h,g){return g=H(104579,g),h.reduce((y,o)=>O(o,y),g)}function b(h,g){return g=H(181387,g),Object.keys(h).sort().reduce((y,o)=>(y=A(o,y),O(h[o],y)),g)}class p{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=O(g,this.g),this.g}}t.$ij=p;var j;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(j||(j={}));function c(h,g,y=32){const o=y-g,d=~((1<<o)-1);return(h<<g|(d&h)>>>o)>>>0}function f(h,g=0,y=h.byteLength,o=0){for(let d=0;d<y;d++)h[g+d]=o}function e(h,g,y="0"){for(;h.length<g;)h=y+h;return h}function n(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(y=>y.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),g/4)}class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const y=g.length;if(y===0)return;const o=this.p;let d=this.r,a=this.u,k,N;for(a!==0?(k=a,N=-1,a=0):(k=g.charCodeAt(0),N=0);;){let R=k;if(i.$xf(k))if(N+1<y){const L=g.charCodeAt(N+1);i.$yf(L)?(N++,R=i.$zf(k,L)):R=65533}else{a=k;break}else i.$yf(k)&&(R=65533);if(d=this.w(o,d,R),N++,N<y)k=g.charCodeAt(N);else break}this.r=d,this.u=a}w(g,y,o){return o<128?g[y++]=o:o<2048?(g[y++]=192|(o&1984)>>>6,g[y++]=128|(o&63)>>>0):o<65536?(g[y++]=224|(o&61440)>>>12,g[y++]=128|(o&4032)>>>6,g[y++]=128|(o&63)>>>0):(g[y++]=240|(o&1835008)>>>18,g[y++]=128|(o&258048)>>>12,g[y++]=128|(o&4032)>>>6,g[y++]=128|(o&63)>>>0),y>=64&&(this.y(),y-=64,this.t+=64,g[0]=g[64],g[1]=g[65],g[2]=g[66]),y}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),n(this.h)+n(this.l)+n(this.m)+n(this.n)+n(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=r.g,y=this.q;for(let E=0;E<64;E+=4)g.setUint32(E,y.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)g.setUint32(E,c(g.getUint32(E-12,!1)^g.getUint32(E-32,!1)^g.getUint32(E-56,!1)^g.getUint32(E-64,!1),1),!1);let o=this.h,d=this.l,a=this.m,k=this.n,N=this.o,R,L,P;for(let E=0;E<80;E++)E<20?(R=d&a|~d&k,L=1518500249):E<40?(R=d^a^k,L=1859775393):E<60?(R=d&a|d&k|a&k,L=2400959708):(R=d^a^k,L=3395469782),P=c(o,5)+R+N+L+g.getUint32(E*4,!1)&4294967295,N=k,k=a,a=c(d,30),d=o,o=P;this.h=this.h+o&4294967295,this.l=this.l+d&4294967295,this.m=this.m+a&4294967295,this.n=this.n+k&4294967295,this.o=this.o+N&4294967295}}t.$kj=r}),define(be[98],$e([1,0,85,59]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qt=t.$ot=void 0,t.$pt=H;class O{constructor(c){this.a=c}getElements(){const c=this.a,f=new Int32Array(c.length);for(let e=0,n=c.length;e<n;e++)f[e]=c.charCodeAt(e);return f}}t.$ot=O;function H(j,c,f){return new p(new O(j),new O(c)).ComputeDiff(f).changes}class S{static Assert(c,f){if(!c)throw new Error(f)}}class A{static Copy(c,f,e,n,r){for(let h=0;h<r;h++)e[n+h]=c[f+h]}static Copy2(c,f,e,n,r){for(let h=0;h<r;h++)e[n+h]=c[f+h]}}var m;(function(j){j[j.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(m||(m={}));class b{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$nt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(c,f){this.b=Math.min(this.b,c),this.c=Math.min(this.c,f),this.d++}AddModifiedElement(c,f){this.b=Math.min(this.b,c),this.c=Math.min(this.c,f),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class p{constructor(c,f,e=null){this.a=e,this.b=c,this.c=f;const[n,r,h]=p.o(c),[g,y,o]=p.o(f);this.d=h&&o,this.e=n,this.f=r,this.g=g,this.h=y,this.k=[],this.m=[]}static n(c){return c.length>0&&typeof c[0]=="string"}static o(c){const f=c.getElements();if(p.n(f)){const e=new Int32Array(f.length);for(let n=0,r=f.length;n<r;n++)e[n]=(0,T.$hj)(f[n],0);return[f,e,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}p(c,f){return this.f[c]!==this.h[f]?!1:this.d?this.e[c]===this.g[f]:!0}q(c,f){if(!this.p(c,f))return!1;const e=p.r(this.b,c),n=p.r(this.c,f);return e===n}static r(c,f){return typeof c.getStrictElement=="function"?c.getStrictElement(f):null}s(c,f){return this.f[c]!==this.f[f]?!1:this.d?this.e[c]===this.e[f]:!0}u(c,f){return this.h[c]!==this.h[f]?!1:this.d?this.g[c]===this.g[f]:!0}ComputeDiff(c){return this.v(0,this.f.length-1,0,this.h.length-1,c)}v(c,f,e,n,r){const h=[!1];let g=this.w(c,f,e,n,h);return r&&(g=this.z(g)),{quitEarly:h[0],changes:g}}w(c,f,e,n,r){for(r[0]=!1;c<=f&&e<=n&&this.p(c,e);)c++,e++;for(;f>=c&&n>=e&&this.p(f,n);)f--,n--;if(c>f||e>n){let a;return e<=n?(S.Assert(c===f+1,"originalStart should only be one more than originalEnd"),a=[new i.$nt(c,0,e,n-e+1)]):c<=f?(S.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),a=[new i.$nt(c,f-c+1,e,0)]):(S.Assert(c===f+1,"originalStart should only be one more than originalEnd"),S.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),a=[]),a}const h=[0],g=[0],y=this.y(c,f,e,n,h,g,r),o=h[0],d=g[0];if(y!==null)return y;if(!r[0]){const a=this.w(c,o,e,d,r);let k=[];return r[0]?k=[new i.$nt(o+1,f-(o+1)+1,d+1,n-(d+1)+1)]:k=this.w(o+1,f,d+1,n,r),this.H(a,k)}return[new i.$nt(c,f-c+1,e,n-e+1)]}x(c,f,e,n,r,h,g,y,o,d,a,k,N,R,L,P,E,z){let W=null,F=null,K=new b,B=f,G=e,V=N[0]-P[0]-n,ae=-1073741824,ie=this.k.length-1;do{const ee=V+c;ee===B||ee<G&&o[ee-1]<o[ee+1]?(a=o[ee+1],R=a-V-n,a<ae&&K.MarkNextChange(),ae=a,K.AddModifiedElement(a+1,R),V=ee+1-c):(a=o[ee-1]+1,R=a-V-n,a<ae&&K.MarkNextChange(),ae=a-1,K.AddOriginalElement(a,R+1),V=ee-1-c),ie>=0&&(o=this.k[ie],c=o[0],B=1,G=o.length-1)}while(--ie>=-1);if(W=K.getReverseChanges(),z[0]){let ee=N[0]+1,ge=P[0]+1;if(W!==null&&W.length>0){const Ee=W[W.length-1];ee=Math.max(ee,Ee.getOriginalEnd()),ge=Math.max(ge,Ee.getModifiedEnd())}F=[new i.$nt(ee,k-ee+1,ge,L-ge+1)]}else{K=new b,B=h,G=g,V=N[0]-P[0]-y,ae=1073741824,ie=E?this.m.length-1:this.m.length-2;do{const ee=V+r;ee===B||ee<G&&d[ee-1]>=d[ee+1]?(a=d[ee+1]-1,R=a-V-y,a>ae&&K.MarkNextChange(),ae=a+1,K.AddOriginalElement(a+1,R+1),V=ee+1-r):(a=d[ee-1],R=a-V-y,a>ae&&K.MarkNextChange(),ae=a,K.AddModifiedElement(a+1,R+1),V=ee-1-r),ie>=0&&(d=this.m[ie],r=d[0],B=1,G=d.length-1)}while(--ie>=-1);F=K.getChanges()}return this.H(W,F)}y(c,f,e,n,r,h,g){let y=0,o=0,d=0,a=0,k=0,N=0;c--,e--,r[0]=0,h[0]=0,this.k=[],this.m=[];const R=f-c+(n-e),L=R+1,P=new Int32Array(L),E=new Int32Array(L),z=n-e,W=f-c,F=c-e,K=f-n,G=(W-z)%2===0;P[z]=c,E[W]=f,g[0]=!1;for(let V=1;V<=R/2+1;V++){let ae=0,ie=0;d=this.J(z-V,V,z,L),a=this.J(z+V,V,z,L);for(let ge=d;ge<=a;ge+=2){ge===d||ge<a&&P[ge-1]<P[ge+1]?y=P[ge+1]:y=P[ge-1]+1,o=y-(ge-z)-F;const Ee=y;for(;y<f&&o<n&&this.p(y+1,o+1);)y++,o++;if(P[ge]=y,y+o>ae+ie&&(ae=y,ie=o),!G&&Math.abs(ge-W)<=V-1&&y>=E[ge])return r[0]=y,h[0]=o,Ee<=E[ge]&&1447>0&&V<=1448?this.x(z,d,a,F,W,k,N,K,P,E,y,f,r,o,n,h,G,g):null}const ee=(ae-c+(ie-e)-V)/2;if(this.a!==null&&!this.a(ae,ee))return g[0]=!0,r[0]=ae,h[0]=ie,ee>0&&1447>0&&V<=1448?this.x(z,d,a,F,W,k,N,K,P,E,y,f,r,o,n,h,G,g):(c++,e++,[new i.$nt(c,f-c+1,e,n-e+1)]);k=this.J(W-V,V,W,L),N=this.J(W+V,V,W,L);for(let ge=k;ge<=N;ge+=2){ge===k||ge<N&&E[ge-1]>=E[ge+1]?y=E[ge+1]-1:y=E[ge-1],o=y-(ge-W)-K;const Ee=y;for(;y>c&&o>e&&this.p(y,o);)y--,o--;if(E[ge]=y,G&&Math.abs(ge-z)<=V&&y<=P[ge])return r[0]=y,h[0]=o,Ee>=P[ge]&&1447>0&&V<=1448?this.x(z,d,a,F,W,k,N,K,P,E,y,f,r,o,n,h,G,g):null}if(V<=1447){let ge=new Int32Array(a-d+2);ge[0]=z-d+1,A.Copy2(P,d,ge,1,a-d+1),this.k.push(ge),ge=new Int32Array(N-k+2),ge[0]=W-k+1,A.Copy2(E,k,ge,1,N-k+1),this.m.push(ge)}}return this.x(z,d,a,F,W,k,N,K,P,E,y,f,r,o,n,h,G,g)}z(c){for(let f=0;f<c.length;f++){const e=c[f],n=f<c.length-1?c[f+1].originalStart:this.f.length,r=f<c.length-1?c[f+1].modifiedStart:this.h.length,h=e.originalLength>0,g=e.modifiedLength>0;for(;e.originalStart+e.originalLength<n&&e.modifiedStart+e.modifiedLength<r&&(!h||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!g||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const o=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!o)break;e.originalStart++,e.modifiedStart++}const y=[null];if(f<c.length-1&&this.I(c[f],c[f+1],y)){c[f]=y[0],c.splice(f+1,1),f--;continue}}for(let f=c.length-1;f>=0;f--){const e=c[f];let n=0,r=0;if(f>0){const a=c[f-1];n=a.originalStart+a.originalLength,r=a.modifiedStart+a.modifiedLength}const h=e.originalLength>0,g=e.modifiedLength>0;let y=0,o=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let a=1;;a++){const k=e.originalStart-a,N=e.modifiedStart-a;if(k<n||N<r||h&&!this.s(k,k+e.originalLength)||g&&!this.u(N,N+e.modifiedLength))break;const L=(k===n&&N===r?5:0)+this.G(k,e.originalLength,N,e.modifiedLength);L>o&&(o=L,y=a)}e.originalStart-=y,e.modifiedStart-=y;const d=[null];if(f>0&&this.I(c[f-1],c[f],d)){c[f-1]=d[0],c.splice(f,1),f++;continue}}if(this.d)for(let f=1,e=c.length;f<e;f++){const n=c[f-1],r=c[f],h=r.originalStart-n.originalStart-n.originalLength,g=n.originalStart,y=r.originalStart+r.originalLength,o=y-g,d=n.modifiedStart,a=r.modifiedStart+r.modifiedLength,k=a-d;if(h<5&&o<20&&k<20){const N=this.A(g,o,d,k,h);if(N){const[R,L]=N;(R!==n.originalStart+n.originalLength||L!==n.modifiedStart+n.modifiedLength)&&(n.originalLength=R-n.originalStart,n.modifiedLength=L-n.modifiedStart,r.originalStart=R+h,r.modifiedStart=L+h,r.originalLength=y-r.originalStart,r.modifiedLength=a-r.modifiedStart)}}}return c}A(c,f,e,n,r){if(f<r||n<r)return null;const h=c+f-r+1,g=e+n-r+1;let y=0,o=0,d=0;for(let a=c;a<h;a++)for(let k=e;k<g;k++){const N=this.B(a,k,r);N>0&&N>y&&(y=N,o=a,d=k)}return y>0?[o,d]:null}B(c,f,e){let n=0;for(let r=0;r<e;r++){if(!this.p(c+r,f+r))return 0;n+=this.e[c+r].length}return n}C(c){return c<=0||c>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[c])}D(c,f){if(this.C(c)||this.C(c-1))return!0;if(f>0){const e=c+f;if(this.C(e-1)||this.C(e))return!0}return!1}E(c){return c<=0||c>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[c])}F(c,f){if(this.E(c)||this.E(c-1))return!0;if(f>0){const e=c+f;if(this.E(e-1)||this.E(e))return!0}return!1}G(c,f,e,n){const r=this.D(c,f)?1:0,h=this.F(e,n)?1:0;return r+h}H(c,f){const e=[];if(c.length===0||f.length===0)return f.length>0?f:c;if(this.I(c[c.length-1],f[0],e)){const n=new Array(c.length+f.length-1);return A.Copy(c,0,n,0,c.length-1),n[c.length-1]=e[0],A.Copy(f,1,n,c.length,f.length-1),n}else{const n=new Array(c.length+f.length);return A.Copy(c,0,n,0,c.length),A.Copy(f,0,n,c.length,f.length),n}}I(c,f,e){if(S.Assert(c.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),S.Assert(c.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=f.originalStart||c.modifiedStart+c.modifiedLength>=f.modifiedStart){const n=c.originalStart;let r=c.originalLength;const h=c.modifiedStart;let g=c.modifiedLength;return c.originalStart+c.originalLength>=f.originalStart&&(r=f.originalStart+f.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=f.modifiedStart&&(g=f.modifiedStart+f.modifiedLength-c.modifiedStart),e[0]=new i.$nt(n,r,h,g),!0}else return e[0]=null,!1}J(c,f,e,n){if(c>=0&&c<n)return c;const r=e,h=n-e-1,g=f%2===0;if(c<0){const y=r%2===0;return g===y?0:1}else{const y=h%2===0;return g===y?n-1:n-2}}}t.$qt=p}),define(be[60],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$d=void 0,t.$$d=Symbol("MicrotaskDelay")}),define(be[99],$e([1,0,8,9]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wi=t.$vi=t.$ui=t.$ti=t.$si=void 0;class O{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const e=f.charCodeAt(0),n=this.b.charCodeAt(this.c);return e-n}value(){return this.b[this.c]}}t.$si=O;class H{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,T.$nf)(f,this.b,0,f.length,this.c,this.d):(0,T.$pf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$ti=H;class S{constructor(f=!0,e=!0){this.f=f,this.g=e}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let e=f.length-1;e>=0;e--,this.c--){const n=this.b.charCodeAt(e);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,T.$nf)(f,this.b,0,f.length,this.d,this.e):(0,T.$pf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$ui=S;var A;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(A||(A={}));class m{constructor(f,e){this.f=f,this.g=e,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,T.$of)(f,this.c.scheme);if(this.d[this.e]===2)return(0,T.$of)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,T.$mf)(f,this.c.query);if(this.d[this.e]===5)return(0,T.$mf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$vi=m;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(p||(p={}));class j{static forUris(f=()=>!1,e=()=>!1){return new j(new m(f,e))}static forPaths(f=!1){return new j(new S(void 0,!f))}static forStrings(){return new j(new O)}static forConfigKeys(){return new j(new H)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,e){if(e){const n=e.slice(0);(0,i.$Xb)(n);for(const r of n)this.set(r,f)}else{const n=f.slice(0);(0,i.$Xb)(n);for(const r of n)this.set(r[0],r[1])}}set(f,e){const n=this.b.reset(f);let r;this.c||(this.c=new b,this.c.segment=n.value());const h=[];for(r=this.c;;){const y=n.cmp(r.segment);if(y>0)r.left||(r.left=new b,r.left.segment=n.value()),h.push([-1,r]),r=r.left;else if(y<0)r.right||(r.right=new b,r.right.segment=n.value()),h.push([1,r]),r=r.right;else if(n.hasNext())n.next(),r.mid||(r.mid=new b,r.mid.segment=n.value()),h.push([0,r]),r=r.mid;else break}const g=r.value;r.value=e,r.key=f;for(let y=h.length-1;y>=0;y--){const o=h[y][1];o.updateHeight();const d=o.balanceFactor();if(d<-1||d>1){const a=h[y][0],k=h[y+1][0];if(a===1&&k===1)h[y][1]=o.rotateLeft();else if(a===-1&&k===-1)h[y][1]=o.rotateRight();else if(a===1&&k===-1)o.right=h[y+1][1]=h[y+1][1].rotateRight(),h[y][1]=o.rotateLeft();else if(a===-1&&k===1)o.left=h[y+1][1]=h[y+1][1].rotateLeft(),h[y][1]=o.rotateRight();else throw new Error;if(y>0)switch(h[y-1][0]){case-1:h[y-1][1].left=h[y][1];break;case 1:h[y-1][1].right=h[y][1];break;case 0:h[y-1][1].mid=h[y][1];break}else this.c=h[0][1]}}return g}get(f){return this.d(f)?.value}d(f){const e=this.b.reset(f);let n=this.c;for(;n;){const r=e.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(e.hasNext())e.next(),n=n.mid;else break}return n}has(f){const e=this.d(f);return!(e?.value===void 0&&e?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,e){const n=this.b.reset(f),r=[];let h=this.c;for(;h;){const g=n.cmp(h.segment);if(g>0)r.push([-1,h]),h=h.left;else if(g<0)r.push([1,h]),h=h.right;else if(n.hasNext())n.next(),r.push([0,h]),h=h.mid;else break}if(h){if(e?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this.f(h.right);if(g.key){const{key:y,value:o,segment:d}=g;this.e(g.key,!1),h.key=y,h.value=o,h.segment=d}}else{const g=h.left??h.right;if(r.length>0){const[y,o]=r[r.length-1];switch(y){case-1:o.left=g;break;case 0:o.mid=g;break;case 1:o.right=g;break}}else this.c=g}for(let g=r.length-1;g>=0;g--){const y=r[g][1];y.updateHeight();const o=y.balanceFactor();if(o>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),r[g][1]=y.rotateLeft()):o<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),r[g][1]=y.rotateRight()),g>0)switch(r[g-1][0]){case-1:r[g-1][1].left=r[g][1];break;case 1:r[g-1][1].right=r[g][1];break;case 0:r[g-1][1].mid=r[g][1];break}else this.c=r[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const e=this.b.reset(f);let n=this.c,r;for(;n;){const h=e.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(e.hasNext())e.next(),r=n.value||r,n=n.mid;else break}return n&&n.value||r}findSuperstr(f){return this.g(f,!1)}g(f,e){const n=this.b.reset(f);let r=this.c;for(;r;){const h=n.cmp(r.segment);if(h>0)r=r.left;else if(h<0)r=r.right;else if(n.hasNext())n.next(),r=r.mid;else return r.mid?this.h(r.mid):e?r.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[e,n]of this)f(n,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const e=[];return this.j(f,e),e[Symbol.iterator]()}j(f,e){f&&(f.left&&this.j(f.left,e),f.value&&e.push([f.key,f.value]),f.mid&&this.j(f.mid,e),f.right&&this.j(f.right,e))}_isBalanced(){const f=e=>{if(!e)return!0;const n=e.balanceFactor();return n<-1||n>1?!1:f(e.left)&&f(e.right)};return f(this.c)}}t.$wi=j}),define(be[10],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4f=i,t.$5f=T,t.$6f=O,t.$7f=H,t.$8f=S,t.$9f=A,t.$0f=m,t.$$f=b,t.$_f=p,t.$ag=j,t.$bg=c,t.$cg=f,t.$dg=e,t.$eg=r,t.$fg=h,t.$gg=g,t.$hg=y,t.$ig=o;function i(d){return typeof d=="string"}function T(d){return Array.isArray(d)&&d.every(a=>i(a))}function O(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}function H(d){const a=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof a}function S(d){return typeof d=="number"&&!isNaN(d)}function A(d){return!!d&&typeof d[Symbol.iterator]=="function"}function m(d){return d===!0||d===!1}function b(d){return typeof d>"u"}function p(d){return!j(d)}function j(d){return b(d)||d===null}function c(d,a){if(!d)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}function f(d){if(j(d))throw new Error("Assertion Failed: argument is undefined or null");return d}function e(...d){const a=[];for(let k=0;k<d.length;k++){const N=d[k];if(j(N))throw new Error(`Assertion Failed: argument at index ${k} is undefined or null`);a.push(N)}return a}const n=Object.prototype.hasOwnProperty;function r(d){if(!O(d))return!1;for(const a in d)if(n.call(d,a))return!1;return!0}function h(d){return typeof d=="function"}function g(...d){return d.length>0&&d.every(h)}function y(d,a){const k=Math.min(d.length,a.length);for(let N=0;N<k;N++)o(d[N],a[N])}function o(d,a){if(i(a)){if(typeof d!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(h(a)){try{if(d instanceof a)return}catch{}if(!j(d)&&d.constructor===a||a.length===1&&a.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(be[45],$e([1,0,10]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kj=O,t.$Lj=H;const T=Object.create(null);function O(S,A){if((0,i.$4f)(A)){const m=T[A];if(m===void 0)throw new Error(`${S} references an unknown codicon: ${A}`);A=m}return T[S]=A,{id:S}}function H(){return T}}),define(be[100],$e([1,0,45]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mj=void 0,t.$Mj={add:(0,i.$Kj)("add",6e4),plus:(0,i.$Kj)("plus",6e4),gistNew:(0,i.$Kj)("gist-new",6e4),repoCreate:(0,i.$Kj)("repo-create",6e4),lightbulb:(0,i.$Kj)("lightbulb",60001),lightBulb:(0,i.$Kj)("light-bulb",60001),repo:(0,i.$Kj)("repo",60002),repoDelete:(0,i.$Kj)("repo-delete",60002),gistFork:(0,i.$Kj)("gist-fork",60003),repoForked:(0,i.$Kj)("repo-forked",60003),gitPullRequest:(0,i.$Kj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Kj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Kj)("record-keys",60005),keyboard:(0,i.$Kj)("keyboard",60005),tag:(0,i.$Kj)("tag",60006),gitPullRequestLabel:(0,i.$Kj)("git-pull-request-label",60006),tagAdd:(0,i.$Kj)("tag-add",60006),tagRemove:(0,i.$Kj)("tag-remove",60006),person:(0,i.$Kj)("person",60007),personFollow:(0,i.$Kj)("person-follow",60007),personOutline:(0,i.$Kj)("person-outline",60007),personFilled:(0,i.$Kj)("person-filled",60007),gitBranch:(0,i.$Kj)("git-branch",60008),gitBranchCreate:(0,i.$Kj)("git-branch-create",60008),gitBranchDelete:(0,i.$Kj)("git-branch-delete",60008),sourceControl:(0,i.$Kj)("source-control",60008),mirror:(0,i.$Kj)("mirror",60009),mirrorPublic:(0,i.$Kj)("mirror-public",60009),star:(0,i.$Kj)("star",60010),starAdd:(0,i.$Kj)("star-add",60010),starDelete:(0,i.$Kj)("star-delete",60010),starEmpty:(0,i.$Kj)("star-empty",60010),comment:(0,i.$Kj)("comment",60011),commentAdd:(0,i.$Kj)("comment-add",60011),alert:(0,i.$Kj)("alert",60012),warning:(0,i.$Kj)("warning",60012),search:(0,i.$Kj)("search",60013),searchSave:(0,i.$Kj)("search-save",60013),logOut:(0,i.$Kj)("log-out",60014),signOut:(0,i.$Kj)("sign-out",60014),logIn:(0,i.$Kj)("log-in",60015),signIn:(0,i.$Kj)("sign-in",60015),eye:(0,i.$Kj)("eye",60016),eyeUnwatch:(0,i.$Kj)("eye-unwatch",60016),eyeWatch:(0,i.$Kj)("eye-watch",60016),circleFilled:(0,i.$Kj)("circle-filled",60017),primitiveDot:(0,i.$Kj)("primitive-dot",60017),closeDirty:(0,i.$Kj)("close-dirty",60017),debugBreakpoint:(0,i.$Kj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Kj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Kj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Kj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Kj)("primitive-square",60018),edit:(0,i.$Kj)("edit",60019),pencil:(0,i.$Kj)("pencil",60019),info:(0,i.$Kj)("info",60020),issueOpened:(0,i.$Kj)("issue-opened",60020),gistPrivate:(0,i.$Kj)("gist-private",60021),gitForkPrivate:(0,i.$Kj)("git-fork-private",60021),lock:(0,i.$Kj)("lock",60021),mirrorPrivate:(0,i.$Kj)("mirror-private",60021),close:(0,i.$Kj)("close",60022),removeClose:(0,i.$Kj)("remove-close",60022),x:(0,i.$Kj)("x",60022),repoSync:(0,i.$Kj)("repo-sync",60023),sync:(0,i.$Kj)("sync",60023),clone:(0,i.$Kj)("clone",60024),desktopDownload:(0,i.$Kj)("desktop-download",60024),beaker:(0,i.$Kj)("beaker",60025),microscope:(0,i.$Kj)("microscope",60025),vm:(0,i.$Kj)("vm",60026),deviceDesktop:(0,i.$Kj)("device-desktop",60026),file:(0,i.$Kj)("file",60027),fileText:(0,i.$Kj)("file-text",60027),more:(0,i.$Kj)("more",60028),ellipsis:(0,i.$Kj)("ellipsis",60028),kebabHorizontal:(0,i.$Kj)("kebab-horizontal",60028),mailReply:(0,i.$Kj)("mail-reply",60029),reply:(0,i.$Kj)("reply",60029),organization:(0,i.$Kj)("organization",60030),organizationFilled:(0,i.$Kj)("organization-filled",60030),organizationOutline:(0,i.$Kj)("organization-outline",60030),newFile:(0,i.$Kj)("new-file",60031),fileAdd:(0,i.$Kj)("file-add",60031),newFolder:(0,i.$Kj)("new-folder",60032),fileDirectoryCreate:(0,i.$Kj)("file-directory-create",60032),trash:(0,i.$Kj)("trash",60033),trashcan:(0,i.$Kj)("trashcan",60033),history:(0,i.$Kj)("history",60034),clock:(0,i.$Kj)("clock",60034),folder:(0,i.$Kj)("folder",60035),fileDirectory:(0,i.$Kj)("file-directory",60035),symbolFolder:(0,i.$Kj)("symbol-folder",60035),logoGithub:(0,i.$Kj)("logo-github",60036),markGithub:(0,i.$Kj)("mark-github",60036),github:(0,i.$Kj)("github",60036),terminal:(0,i.$Kj)("terminal",60037),console:(0,i.$Kj)("console",60037),repl:(0,i.$Kj)("repl",60037),zap:(0,i.$Kj)("zap",60038),symbolEvent:(0,i.$Kj)("symbol-event",60038),error:(0,i.$Kj)("error",60039),stop:(0,i.$Kj)("stop",60039),variable:(0,i.$Kj)("variable",60040),symbolVariable:(0,i.$Kj)("symbol-variable",60040),array:(0,i.$Kj)("array",60042),symbolArray:(0,i.$Kj)("symbol-array",60042),symbolModule:(0,i.$Kj)("symbol-module",60043),symbolPackage:(0,i.$Kj)("symbol-package",60043),symbolNamespace:(0,i.$Kj)("symbol-namespace",60043),symbolObject:(0,i.$Kj)("symbol-object",60043),symbolMethod:(0,i.$Kj)("symbol-method",60044),symbolFunction:(0,i.$Kj)("symbol-function",60044),symbolConstructor:(0,i.$Kj)("symbol-constructor",60044),symbolBoolean:(0,i.$Kj)("symbol-boolean",60047),symbolNull:(0,i.$Kj)("symbol-null",60047),symbolNumeric:(0,i.$Kj)("symbol-numeric",60048),symbolNumber:(0,i.$Kj)("symbol-number",60048),symbolStructure:(0,i.$Kj)("symbol-structure",60049),symbolStruct:(0,i.$Kj)("symbol-struct",60049),symbolParameter:(0,i.$Kj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Kj)("symbol-type-parameter",60050),symbolKey:(0,i.$Kj)("symbol-key",60051),symbolText:(0,i.$Kj)("symbol-text",60051),symbolReference:(0,i.$Kj)("symbol-reference",60052),goToFile:(0,i.$Kj)("go-to-file",60052),symbolEnum:(0,i.$Kj)("symbol-enum",60053),symbolValue:(0,i.$Kj)("symbol-value",60053),symbolRuler:(0,i.$Kj)("symbol-ruler",60054),symbolUnit:(0,i.$Kj)("symbol-unit",60054),activateBreakpoints:(0,i.$Kj)("activate-breakpoints",60055),archive:(0,i.$Kj)("archive",60056),arrowBoth:(0,i.$Kj)("arrow-both",60057),arrowDown:(0,i.$Kj)("arrow-down",60058),arrowLeft:(0,i.$Kj)("arrow-left",60059),arrowRight:(0,i.$Kj)("arrow-right",60060),arrowSmallDown:(0,i.$Kj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Kj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Kj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Kj)("arrow-small-up",60064),arrowUp:(0,i.$Kj)("arrow-up",60065),bell:(0,i.$Kj)("bell",60066),bold:(0,i.$Kj)("bold",60067),book:(0,i.$Kj)("book",60068),bookmark:(0,i.$Kj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Kj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Kj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Kj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Kj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Kj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Kj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Kj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Kj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Kj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Kj)("briefcase",60076),broadcast:(0,i.$Kj)("broadcast",60077),browser:(0,i.$Kj)("browser",60078),bug:(0,i.$Kj)("bug",60079),calendar:(0,i.$Kj)("calendar",60080),caseSensitive:(0,i.$Kj)("case-sensitive",60081),check:(0,i.$Kj)("check",60082),checklist:(0,i.$Kj)("checklist",60083),chevronDown:(0,i.$Kj)("chevron-down",60084),chevronLeft:(0,i.$Kj)("chevron-left",60085),chevronRight:(0,i.$Kj)("chevron-right",60086),chevronUp:(0,i.$Kj)("chevron-up",60087),chromeClose:(0,i.$Kj)("chrome-close",60088),chromeMaximize:(0,i.$Kj)("chrome-maximize",60089),chromeMinimize:(0,i.$Kj)("chrome-minimize",60090),chromeRestore:(0,i.$Kj)("chrome-restore",60091),circleOutline:(0,i.$Kj)("circle-outline",60092),circle:(0,i.$Kj)("circle",60092),debugBreakpointUnverified:(0,i.$Kj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Kj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Kj)("circle-slash",60093),circuitBoard:(0,i.$Kj)("circuit-board",60094),clearAll:(0,i.$Kj)("clear-all",60095),clippy:(0,i.$Kj)("clippy",60096),closeAll:(0,i.$Kj)("close-all",60097),cloudDownload:(0,i.$Kj)("cloud-download",60098),cloudUpload:(0,i.$Kj)("cloud-upload",60099),code:(0,i.$Kj)("code",60100),collapseAll:(0,i.$Kj)("collapse-all",60101),colorMode:(0,i.$Kj)("color-mode",60102),commentDiscussion:(0,i.$Kj)("comment-discussion",60103),creditCard:(0,i.$Kj)("credit-card",60105),dash:(0,i.$Kj)("dash",60108),dashboard:(0,i.$Kj)("dashboard",60109),database:(0,i.$Kj)("database",60110),debugContinue:(0,i.$Kj)("debug-continue",60111),debugDisconnect:(0,i.$Kj)("debug-disconnect",60112),debugPause:(0,i.$Kj)("debug-pause",60113),debugRestart:(0,i.$Kj)("debug-restart",60114),debugStart:(0,i.$Kj)("debug-start",60115),debugStepInto:(0,i.$Kj)("debug-step-into",60116),debugStepOut:(0,i.$Kj)("debug-step-out",60117),debugStepOver:(0,i.$Kj)("debug-step-over",60118),debugStop:(0,i.$Kj)("debug-stop",60119),debug:(0,i.$Kj)("debug",60120),deviceCameraVideo:(0,i.$Kj)("device-camera-video",60121),deviceCamera:(0,i.$Kj)("device-camera",60122),deviceMobile:(0,i.$Kj)("device-mobile",60123),diffAdded:(0,i.$Kj)("diff-added",60124),diffIgnored:(0,i.$Kj)("diff-ignored",60125),diffModified:(0,i.$Kj)("diff-modified",60126),diffRemoved:(0,i.$Kj)("diff-removed",60127),diffRenamed:(0,i.$Kj)("diff-renamed",60128),diff:(0,i.$Kj)("diff",60129),diffSidebyside:(0,i.$Kj)("diff-sidebyside",60129),discard:(0,i.$Kj)("discard",60130),editorLayout:(0,i.$Kj)("editor-layout",60131),emptyWindow:(0,i.$Kj)("empty-window",60132),exclude:(0,i.$Kj)("exclude",60133),extensions:(0,i.$Kj)("extensions",60134),eyeClosed:(0,i.$Kj)("eye-closed",60135),fileBinary:(0,i.$Kj)("file-binary",60136),fileCode:(0,i.$Kj)("file-code",60137),fileMedia:(0,i.$Kj)("file-media",60138),filePdf:(0,i.$Kj)("file-pdf",60139),fileSubmodule:(0,i.$Kj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Kj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Kj)("file-symlink-file",60142),fileZip:(0,i.$Kj)("file-zip",60143),files:(0,i.$Kj)("files",60144),filter:(0,i.$Kj)("filter",60145),flame:(0,i.$Kj)("flame",60146),foldDown:(0,i.$Kj)("fold-down",60147),foldUp:(0,i.$Kj)("fold-up",60148),fold:(0,i.$Kj)("fold",60149),folderActive:(0,i.$Kj)("folder-active",60150),folderOpened:(0,i.$Kj)("folder-opened",60151),gear:(0,i.$Kj)("gear",60152),gift:(0,i.$Kj)("gift",60153),gistSecret:(0,i.$Kj)("gist-secret",60154),gist:(0,i.$Kj)("gist",60155),gitCommit:(0,i.$Kj)("git-commit",60156),gitCompare:(0,i.$Kj)("git-compare",60157),compareChanges:(0,i.$Kj)("compare-changes",60157),gitMerge:(0,i.$Kj)("git-merge",60158),githubAction:(0,i.$Kj)("github-action",60159),githubAlt:(0,i.$Kj)("github-alt",60160),globe:(0,i.$Kj)("globe",60161),grabber:(0,i.$Kj)("grabber",60162),graph:(0,i.$Kj)("graph",60163),gripper:(0,i.$Kj)("gripper",60164),heart:(0,i.$Kj)("heart",60165),home:(0,i.$Kj)("home",60166),horizontalRule:(0,i.$Kj)("horizontal-rule",60167),hubot:(0,i.$Kj)("hubot",60168),inbox:(0,i.$Kj)("inbox",60169),issueReopened:(0,i.$Kj)("issue-reopened",60171),issues:(0,i.$Kj)("issues",60172),italic:(0,i.$Kj)("italic",60173),jersey:(0,i.$Kj)("jersey",60174),json:(0,i.$Kj)("json",60175),kebabVertical:(0,i.$Kj)("kebab-vertical",60176),key:(0,i.$Kj)("key",60177),law:(0,i.$Kj)("law",60178),lightbulbAutofix:(0,i.$Kj)("lightbulb-autofix",60179),linkExternal:(0,i.$Kj)("link-external",60180),link:(0,i.$Kj)("link",60181),listOrdered:(0,i.$Kj)("list-ordered",60182),listUnordered:(0,i.$Kj)("list-unordered",60183),liveShare:(0,i.$Kj)("live-share",60184),loading:(0,i.$Kj)("loading",60185),location:(0,i.$Kj)("location",60186),mailRead:(0,i.$Kj)("mail-read",60187),mail:(0,i.$Kj)("mail",60188),markdown:(0,i.$Kj)("markdown",60189),megaphone:(0,i.$Kj)("megaphone",60190),mention:(0,i.$Kj)("mention",60191),milestone:(0,i.$Kj)("milestone",60192),gitPullRequestMilestone:(0,i.$Kj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Kj)("mortar-board",60193),move:(0,i.$Kj)("move",60194),multipleWindows:(0,i.$Kj)("multiple-windows",60195),mute:(0,i.$Kj)("mute",60196),noNewline:(0,i.$Kj)("no-newline",60197),note:(0,i.$Kj)("note",60198),octoface:(0,i.$Kj)("octoface",60199),openPreview:(0,i.$Kj)("open-preview",60200),package:(0,i.$Kj)("package",60201),paintcan:(0,i.$Kj)("paintcan",60202),pin:(0,i.$Kj)("pin",60203),play:(0,i.$Kj)("play",60204),run:(0,i.$Kj)("run",60204),plug:(0,i.$Kj)("plug",60205),preserveCase:(0,i.$Kj)("preserve-case",60206),preview:(0,i.$Kj)("preview",60207),project:(0,i.$Kj)("project",60208),pulse:(0,i.$Kj)("pulse",60209),question:(0,i.$Kj)("question",60210),quote:(0,i.$Kj)("quote",60211),radioTower:(0,i.$Kj)("radio-tower",60212),reactions:(0,i.$Kj)("reactions",60213),references:(0,i.$Kj)("references",60214),refresh:(0,i.$Kj)("refresh",60215),regex:(0,i.$Kj)("regex",60216),remoteExplorer:(0,i.$Kj)("remote-explorer",60217),remote:(0,i.$Kj)("remote",60218),remove:(0,i.$Kj)("remove",60219),replaceAll:(0,i.$Kj)("replace-all",60220),replace:(0,i.$Kj)("replace",60221),repoClone:(0,i.$Kj)("repo-clone",60222),repoForcePush:(0,i.$Kj)("repo-force-push",60223),repoPull:(0,i.$Kj)("repo-pull",60224),repoPush:(0,i.$Kj)("repo-push",60225),report:(0,i.$Kj)("report",60226),requestChanges:(0,i.$Kj)("request-changes",60227),rocket:(0,i.$Kj)("rocket",60228),rootFolderOpened:(0,i.$Kj)("root-folder-opened",60229),rootFolder:(0,i.$Kj)("root-folder",60230),rss:(0,i.$Kj)("rss",60231),ruby:(0,i.$Kj)("ruby",60232),saveAll:(0,i.$Kj)("save-all",60233),saveAs:(0,i.$Kj)("save-as",60234),save:(0,i.$Kj)("save",60235),screenFull:(0,i.$Kj)("screen-full",60236),screenNormal:(0,i.$Kj)("screen-normal",60237),searchStop:(0,i.$Kj)("search-stop",60238),server:(0,i.$Kj)("server",60240),settingsGear:(0,i.$Kj)("settings-gear",60241),settings:(0,i.$Kj)("settings",60242),shield:(0,i.$Kj)("shield",60243),smiley:(0,i.$Kj)("smiley",60244),sortPrecedence:(0,i.$Kj)("sort-precedence",60245),splitHorizontal:(0,i.$Kj)("split-horizontal",60246),splitVertical:(0,i.$Kj)("split-vertical",60247),squirrel:(0,i.$Kj)("squirrel",60248),starFull:(0,i.$Kj)("star-full",60249),starHalf:(0,i.$Kj)("star-half",60250),symbolClass:(0,i.$Kj)("symbol-class",60251),symbolColor:(0,i.$Kj)("symbol-color",60252),symbolConstant:(0,i.$Kj)("symbol-constant",60253),symbolEnumMember:(0,i.$Kj)("symbol-enum-member",60254),symbolField:(0,i.$Kj)("symbol-field",60255),symbolFile:(0,i.$Kj)("symbol-file",60256),symbolInterface:(0,i.$Kj)("symbol-interface",60257),symbolKeyword:(0,i.$Kj)("symbol-keyword",60258),symbolMisc:(0,i.$Kj)("symbol-misc",60259),symbolOperator:(0,i.$Kj)("symbol-operator",60260),symbolProperty:(0,i.$Kj)("symbol-property",60261),wrench:(0,i.$Kj)("wrench",60261),wrenchSubaction:(0,i.$Kj)("wrench-subaction",60261),symbolSnippet:(0,i.$Kj)("symbol-snippet",60262),tasklist:(0,i.$Kj)("tasklist",60263),telescope:(0,i.$Kj)("telescope",60264),textSize:(0,i.$Kj)("text-size",60265),threeBars:(0,i.$Kj)("three-bars",60266),thumbsdown:(0,i.$Kj)("thumbsdown",60267),thumbsup:(0,i.$Kj)("thumbsup",60268),tools:(0,i.$Kj)("tools",60269),triangleDown:(0,i.$Kj)("triangle-down",60270),triangleLeft:(0,i.$Kj)("triangle-left",60271),triangleRight:(0,i.$Kj)("triangle-right",60272),triangleUp:(0,i.$Kj)("triangle-up",60273),twitter:(0,i.$Kj)("twitter",60274),unfold:(0,i.$Kj)("unfold",60275),unlock:(0,i.$Kj)("unlock",60276),unmute:(0,i.$Kj)("unmute",60277),unverified:(0,i.$Kj)("unverified",60278),verified:(0,i.$Kj)("verified",60279),versions:(0,i.$Kj)("versions",60280),vmActive:(0,i.$Kj)("vm-active",60281),vmOutline:(0,i.$Kj)("vm-outline",60282),vmRunning:(0,i.$Kj)("vm-running",60283),watch:(0,i.$Kj)("watch",60284),whitespace:(0,i.$Kj)("whitespace",60285),wholeWord:(0,i.$Kj)("whole-word",60286),window:(0,i.$Kj)("window",60287),wordWrap:(0,i.$Kj)("word-wrap",60288),zoomIn:(0,i.$Kj)("zoom-in",60289),zoomOut:(0,i.$Kj)("zoom-out",60290),listFilter:(0,i.$Kj)("list-filter",60291),listFlat:(0,i.$Kj)("list-flat",60292),listSelection:(0,i.$Kj)("list-selection",60293),selection:(0,i.$Kj)("selection",60293),listTree:(0,i.$Kj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Kj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Kj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Kj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Kj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Kj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Kj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Kj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Kj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Kj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Kj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Kj)("symbol-string",60301),debugReverseContinue:(0,i.$Kj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Kj)("debug-step-back",60303),debugRestartFrame:(0,i.$Kj)("debug-restart-frame",60304),debugAlt:(0,i.$Kj)("debug-alt",60305),callIncoming:(0,i.$Kj)("call-incoming",60306),callOutgoing:(0,i.$Kj)("call-outgoing",60307),menu:(0,i.$Kj)("menu",60308),expandAll:(0,i.$Kj)("expand-all",60309),feedback:(0,i.$Kj)("feedback",60310),gitPullRequestReviewer:(0,i.$Kj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Kj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Kj)("ungroup-by-ref-type",60312),account:(0,i.$Kj)("account",60313),gitPullRequestAssignee:(0,i.$Kj)("git-pull-request-assignee",60313),bellDot:(0,i.$Kj)("bell-dot",60314),debugConsole:(0,i.$Kj)("debug-console",60315),library:(0,i.$Kj)("library",60316),output:(0,i.$Kj)("output",60317),runAll:(0,i.$Kj)("run-all",60318),syncIgnored:(0,i.$Kj)("sync-ignored",60319),pinned:(0,i.$Kj)("pinned",60320),githubInverted:(0,i.$Kj)("github-inverted",60321),serverProcess:(0,i.$Kj)("server-process",60322),serverEnvironment:(0,i.$Kj)("server-environment",60323),pass:(0,i.$Kj)("pass",60324),issueClosed:(0,i.$Kj)("issue-closed",60324),stopCircle:(0,i.$Kj)("stop-circle",60325),playCircle:(0,i.$Kj)("play-circle",60326),record:(0,i.$Kj)("record",60327),debugAltSmall:(0,i.$Kj)("debug-alt-small",60328),vmConnect:(0,i.$Kj)("vm-connect",60329),cloud:(0,i.$Kj)("cloud",60330),merge:(0,i.$Kj)("merge",60331),export:(0,i.$Kj)("export",60332),graphLeft:(0,i.$Kj)("graph-left",60333),magnet:(0,i.$Kj)("magnet",60334),notebook:(0,i.$Kj)("notebook",60335),redo:(0,i.$Kj)("redo",60336),checkAll:(0,i.$Kj)("check-all",60337),pinnedDirty:(0,i.$Kj)("pinned-dirty",60338),passFilled:(0,i.$Kj)("pass-filled",60339),circleLargeFilled:(0,i.$Kj)("circle-large-filled",60340),circleLarge:(0,i.$Kj)("circle-large",60341),circleLargeOutline:(0,i.$Kj)("circle-large-outline",60341),combine:(0,i.$Kj)("combine",60342),gather:(0,i.$Kj)("gather",60342),table:(0,i.$Kj)("table",60343),variableGroup:(0,i.$Kj)("variable-group",60344),typeHierarchy:(0,i.$Kj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Kj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Kj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Kj)("git-pull-request-create",60348),runAbove:(0,i.$Kj)("run-above",60349),runBelow:(0,i.$Kj)("run-below",60350),notebookTemplate:(0,i.$Kj)("notebook-template",60351),debugRerun:(0,i.$Kj)("debug-rerun",60352),workspaceTrusted:(0,i.$Kj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Kj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Kj)("workspace-unknown",60355),terminalCmd:(0,i.$Kj)("terminal-cmd",60356),terminalDebian:(0,i.$Kj)("terminal-debian",60357),terminalLinux:(0,i.$Kj)("terminal-linux",60358),terminalPowershell:(0,i.$Kj)("terminal-powershell",60359),terminalTmux:(0,i.$Kj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Kj)("terminal-ubuntu",60361),terminalBash:(0,i.$Kj)("terminal-bash",60362),arrowSwap:(0,i.$Kj)("arrow-swap",60363),copy:(0,i.$Kj)("copy",60364),personAdd:(0,i.$Kj)("person-add",60365),filterFilled:(0,i.$Kj)("filter-filled",60366),wand:(0,i.$Kj)("wand",60367),debugLineByLine:(0,i.$Kj)("debug-line-by-line",60368),inspect:(0,i.$Kj)("inspect",60369),layers:(0,i.$Kj)("layers",60370),layersDot:(0,i.$Kj)("layers-dot",60371),layersActive:(0,i.$Kj)("layers-active",60372),compass:(0,i.$Kj)("compass",60373),compassDot:(0,i.$Kj)("compass-dot",60374),compassActive:(0,i.$Kj)("compass-active",60375),azure:(0,i.$Kj)("azure",60376),issueDraft:(0,i.$Kj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Kj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Kj)("git-pull-request-draft",60379),debugAll:(0,i.$Kj)("debug-all",60380),debugCoverage:(0,i.$Kj)("debug-coverage",60381),runErrors:(0,i.$Kj)("run-errors",60382),folderLibrary:(0,i.$Kj)("folder-library",60383),debugContinueSmall:(0,i.$Kj)("debug-continue-small",60384),beakerStop:(0,i.$Kj)("beaker-stop",60385),graphLine:(0,i.$Kj)("graph-line",60386),graphScatter:(0,i.$Kj)("graph-scatter",60387),pieChart:(0,i.$Kj)("pie-chart",60388),bracket:(0,i.$Kj)("bracket",60175),bracketDot:(0,i.$Kj)("bracket-dot",60389),bracketError:(0,i.$Kj)("bracket-error",60390),lockSmall:(0,i.$Kj)("lock-small",60391),azureDevops:(0,i.$Kj)("azure-devops",60392),verifiedFilled:(0,i.$Kj)("verified-filled",60393),newline:(0,i.$Kj)("newline",60394),layout:(0,i.$Kj)("layout",60395),layoutActivitybarLeft:(0,i.$Kj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Kj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Kj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Kj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Kj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Kj)("layout-panel-right",60401),layoutPanel:(0,i.$Kj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Kj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Kj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Kj)("layout-statusbar",60405),layoutMenubar:(0,i.$Kj)("layout-menubar",60406),layoutCentered:(0,i.$Kj)("layout-centered",60407),target:(0,i.$Kj)("target",60408),indent:(0,i.$Kj)("indent",60409),recordSmall:(0,i.$Kj)("record-small",60410),errorSmall:(0,i.$Kj)("error-small",60411),terminalDecorationError:(0,i.$Kj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Kj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Kj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Kj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Kj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Kj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Kj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Kj)("layout-sidebar-left-off",60418),blank:(0,i.$Kj)("blank",60419),heartFilled:(0,i.$Kj)("heart-filled",60420),map:(0,i.$Kj)("map",60421),mapHorizontal:(0,i.$Kj)("map-horizontal",60421),foldHorizontal:(0,i.$Kj)("fold-horizontal",60421),mapFilled:(0,i.$Kj)("map-filled",60422),mapHorizontalFilled:(0,i.$Kj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Kj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Kj)("circle-small",60423),bellSlash:(0,i.$Kj)("bell-slash",60424),bellSlashDot:(0,i.$Kj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Kj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Kj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Kj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Kj)("search-fuzzy",60429),commentDraft:(0,i.$Kj)("comment-draft",60430),send:(0,i.$Kj)("send",60431),sparkle:(0,i.$Kj)("sparkle",60432),insert:(0,i.$Kj)("insert",60433),mic:(0,i.$Kj)("mic",60434),thumbsdownFilled:(0,i.$Kj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Kj)("thumbsup-filled",60436),coffee:(0,i.$Kj)("coffee",60437),snake:(0,i.$Kj)("snake",60438),game:(0,i.$Kj)("game",60439),vr:(0,i.$Kj)("vr",60440),chip:(0,i.$Kj)("chip",60441),piano:(0,i.$Kj)("piano",60442),music:(0,i.$Kj)("music",60443),micFilled:(0,i.$Kj)("mic-filled",60444),repoFetch:(0,i.$Kj)("repo-fetch",60445),copilot:(0,i.$Kj)("copilot",60446),lightbulbSparkle:(0,i.$Kj)("lightbulb-sparkle",60447),robot:(0,i.$Kj)("robot",60448),sparkleFilled:(0,i.$Kj)("sparkle-filled",60449),diffSingle:(0,i.$Kj)("diff-single",60450),diffMultiple:(0,i.$Kj)("diff-multiple",60451),surroundWith:(0,i.$Kj)("surround-with",60452),share:(0,i.$Kj)("share",60453),gitStash:(0,i.$Kj)("git-stash",60454),gitStashApply:(0,i.$Kj)("git-stash-apply",60455),gitStashPop:(0,i.$Kj)("git-stash-pop",60456),vscode:(0,i.$Kj)("vscode",60457),vscodeInsiders:(0,i.$Kj)("vscode-insiders",60458),codeOss:(0,i.$Kj)("code-oss",60459),runCoverage:(0,i.$Kj)("run-coverage",60460),runAllCoverage:(0,i.$Kj)("run-all-coverage",60461),coverage:(0,i.$Kj)("coverage",60462),githubProject:(0,i.$Kj)("github-project",60463),mapVertical:(0,i.$Kj)("map-vertical",60464),foldVertical:(0,i.$Kj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Kj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Kj)("fold-vertical-filled",60465),goToSearch:(0,i.$Kj)("go-to-search",60466),percentage:(0,i.$Kj)("percentage",60467),sortPercentage:(0,i.$Kj)("sort-percentage",60467)}}),define(be[18],$e([1,0,45,100]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pj=t.$Oj=void 0,t.$Nj=O;function O(){return Object.values(t.$Pj)}t.$Oj={dialogError:(0,i.$Kj)("dialog-error","error"),dialogWarning:(0,i.$Kj)("dialog-warning","warning"),dialogInfo:(0,i.$Kj)("dialog-info","info"),dialogClose:(0,i.$Kj)("dialog-close","close"),treeItemExpanded:(0,i.$Kj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Kj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Kj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Kj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Kj)("tree-item-loading","loading"),menuSelection:(0,i.$Kj)("menu-selection","check"),menuSubmenu:(0,i.$Kj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Kj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Kj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Kj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Kj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Kj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Kj)("toolbar-more","more"),quickInputBack:(0,i.$Kj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Kj)("drop-down-button",60084),symbolCustomColor:(0,i.$Kj)("symbol-customcolor",60252),exportIcon:(0,i.$Kj)("export",60332),workspaceUnspecified:(0,i.$Kj)("workspace-unspecified",60355),newLine:(0,i.$Kj)("newline",60394),thumbsDownFilled:(0,i.$Kj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Kj)("thumbsup-filled",60436),gitFetch:(0,i.$Kj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Kj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Kj)("debug-breakpoint-pending",60377)},t.$Pj={...T.$Mj,...t.$Oj}}),define(be[61],$e([1,0,10]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wn=T,t.$Xn=O,t.$Yn=S,t.$Zn=m,t.$1n=b,t.$2n=p,t.$3n=j,t.$4n=c,t.$5n=f,t.$6n=e,t.$7n=n,t.$8n=r;function T(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([y,o])=>{g[y]=o&&typeof o=="object"?T(o):o}),g}function O(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const y=g.shift();Object.freeze(y);for(const o in y)if(H.call(y,o)){const d=y[o];typeof d=="object"&&!Object.isFrozen(d)&&!(0,i.$7f)(d)&&g.push(d)}}return h}const H=Object.prototype.hasOwnProperty;function S(h,g){return A(h,g,new Set)}function A(h,g,y){if((0,i.$ag)(h))return h;const o=g(h);if(typeof o<"u")return o;if(Array.isArray(h)){const d=[];for(const a of h)d.push(A(a,g,y));return d}if((0,i.$6f)(h)){if(y.has(h))throw new Error("Cannot clone recursive data-structure");y.add(h);const d={};for(const a in h)H.call(h,a)&&(d[a]=A(h[a],g,y));return y.delete(h),d}return h}function m(h,g,y=!0){return(0,i.$6f)(h)?((0,i.$6f)(g)&&Object.keys(g).forEach(o=>{o in h?y&&((0,i.$6f)(h[o])&&(0,i.$6f)(g[o])?m(h[o],g[o],y):h[o]=g[o]):h[o]=g[o]}),h):g}function b(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let y,o;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(y=0;y<h.length;y++)if(!b(h[y],g[y]))return!1}else{const d=[];for(o in h)d.push(o);d.sort();const a=[];for(o in g)a.push(o);if(a.sort(),!b(d,a))return!1;for(y=0;y<d.length;y++)if(!b(h[d[y]],g[d[y]]))return!1}return!0}function p(h){const g=new Set;return JSON.stringify(h,(y,o)=>{if((0,i.$6f)(o)||Array.isArray(o)){if(g.has(o))return"[Circular]";g.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function j(h,g){const y=Object.create(null);return!h||!g||Object.keys(g).forEach(d=>{const a=h[d],k=g[d];b(a,k)||(y[d]=k)}),y}function c(h,g){const y=g.toLowerCase(),o=Object.keys(h).find(d=>d.toLowerCase()===y);return o?h[o]:h[g]}function f(h,g){const y=Object.create(null);for(const[o,d]of Object.entries(h))g(o,d)&&(y[o]=d);return y}function e(h){let g=[];for(;Object.prototype!==h;)g=g.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return g}function n(h){const g=[];for(const y of e(h))typeof h[y]=="function"&&g.push(y);return g}function r(h,g){const y=d=>function(){const a=Array.prototype.slice.call(arguments,0);return g(d,a)},o={};for(const d of h)o[d]=y(d);return o}}),define(be[19],$e([1,0,18]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$Qj=O;var T;(function(S){function A(m){return m&&typeof m=="object"&&typeof m.id=="string"}S.isThemeColor=A})(T||(t.ThemeColor=T={}));function O(S){return{id:S}}var H;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function m(g){const y=A.exec(g.id);if(!y)return m(i.$Pj.error);const[,o,d]=y,a=["codicon","codicon-"+o];return d&&a.push("codicon-modifier-"+d.substring(1)),a}S.asClassNameArray=m;function b(g){return m(g).join(" ")}S.asClassName=b;function p(g){return"."+m(g).join(".")}S.asCSSSelector=p;function j(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||T.isThemeColor(g.color))}S.isThemeIcon=j;const c=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function f(g){const y=c.exec(g);if(!y)return;const[,o]=y;return{id:o}}S.fromString=f;function e(g){return{id:g}}S.fromId=e;function n(g,y){let o=g.id;const d=o.lastIndexOf("~");return d!==-1&&(o=o.substring(0,d)),y&&(o=`${o}~${y}`),{id:o}}S.modify=n;function r(g){const y=g.id.lastIndexOf("~");if(y!==-1)return g.id.substring(y+1)}S.getModifier=r;function h(g,y){return g.id===y.id&&g.color?.id===y.color?.id}S.isEqual=h})(H||(t.ThemeIcon=H={}))}),define(be[62],$e([1,0,44,9,19]),function(se,t,i,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hk=m,t.$Ik=p,t.$Jk=c,t.$Kk=f,t.$Lk=n,t.$Mk=r;const H="$(",S=new RegExp(`\\$\\(${O.ThemeIcon.iconNameExpression}(?:${O.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${S.source}`,"g");function m(h){return h.replace(A,(g,y)=>y?g:`\\${g}`)}const b=new RegExp(`\\\\${S.source}`,"g");function p(h){return h.replace(b,g=>`\\${g}`)}const j=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function c(h){return h.indexOf(H)===-1?h:h.replace(j,(g,y,o,d)=>o?g:y||d||"")}function f(h){return h?h.replace(/\$\((.*?)\)/g,(g,y)=>` ${y} `).trim():""}const e=new RegExp(`\\$\\(${O.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(h){e.lastIndex=0;let g="";const y=[];let o=0;for(;;){const d=e.lastIndex,a=e.exec(h),k=h.substring(d,a?.index);if(k.length>0){g+=k;for(let N=0;N<k.length;N++)y.push(o)}if(!a)break;o+=a[0].length}return{text:g,iconOffsets:y}}function r(h,g,y=!1){const{text:o,iconOffsets:d}=g;if(!d||d.length===0)return(0,i.$yk)(h,o,y);const a=(0,T.$af)(o," "),k=o.length-a.length,N=(0,i.$yk)(h,a,y);if(N)for(const R of N){const L=d[R.start+k]+k;R.start+=L,R.end+=L}return N}}),define(be[101],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DW=t.$CW=void 0,t.$CW="vscode:contextmenu",t.$DW="vscode:onCloseContextMenu"}),define(be[102],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KW=void 0;class i{constructor(O,H){this.a=O,this.onMessage=H}send(O){try{this.a.send("vscode:message",O.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$KW=i}),define(be[35],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const i=globalThis.vscode;t.$O=i.ipcRenderer,t.$P=i.ipcMessagePort,t.$Q=i.webFrame,t.$R=i.process,t.$S=i.context}),define(be[103],$e([1,0,101,35]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GW=H;let O=0;function H(A,m,b){const p=[],j=O++,c=`vscode:onContextMenu${j}`,f=(e,n,r)=>{p[n].click?.(r)};T.$O.once(c,f),T.$O.once(i.$DW,(e,n)=>{n===j&&(T.$O.removeListener(c,f),b?.())}),T.$O.send(i.$CW,j,A.map(e=>S(e,p)),c,m)}function S(A,m){const b={id:m.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return m.push(A),Array.isArray(A.submenu)&&(b.submenu=A.submenu.map(p=>S(p,m))),b}}),define(be[63],$e([7]),{}),define(be[104],$e([7]),{}),define(be[105],$e([7]),{}),define(be[106],$e([7]),{}),define(be[107],$e([1,0,105,106]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[108],$e([7]),{}),define(be[109],$e([7]),{}),define(be[110],$e([7]),{}),define(be[111],$e([7]),{}),define(be[112],$e([7]),{}),define(be[113],$e([7]),{}),define(be[114],$e([7]),{}),define(be[115],$e([7]),{}),define(be[116],$e([7]),{}),define(be[117],$e([13,12]),function(se,t){return se.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[118],$e([13,12]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[119],$e([13,12]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[120],$e([13,12]),function(se,t){return se.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[121],$e([13,12]),function(se,t){return se.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[122],$e([13,12]),function(se,t){return se.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[123],$e([13,12]),function(se,t){return se.create("vs/base/common/actions",t)}),define(be[46],$e([1,0,3,2,123]),function(se,t,i,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_i=t.$$i=t.$0i=t.$9i=t.$8i=void 0,t.$aj=p;class H extends T.$Uc{constructor(c,f="",e="",n=!0,r){super(),this.h=this.B(new i.$be),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=f,this.u=e,this.w=n,this.C=r}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,f){this.C&&await this.C(c)}}t.$8i=H;class S extends T.$Uc{constructor(){super(...arguments),this.f=this.B(new i.$be),this.onWillRun=this.f.event,this.m=this.B(new i.$be),this.onDidRun=this.m.event}async run(c,f){if(!c.enabled)return;this.f.fire({action:c});let e;try{await this.u(c,f)}catch(n){e=n}this.m.fire({action:c,error:e})}async u(c,f){await c.run(f)}}t.$9i=S;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let f=[];for(const e of c)e.length&&(f.length?f=[...f,new A,...e]:f=e);return f}static{this.ID="vs.actions.separator"}async run(){}}t.$0i=A;class m{get actions(){return this.a}constructor(c,f,e,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=f,this.class=n,this.a=e}async run(){}}t.$$i=m;class b extends H{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,O.localize(0,null),void 0,!1)}}t.$_i=b;function p(j){return{id:j.id,label:j.label,class:j.class,enabled:j.enabled??!0,checked:j.checked,run:async(...c)=>j.run(...c),tooltip:j.label}}}),define(be[124],$e([13,12]),function(se,t){return se.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,124]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=k,t.$D=z,t.$J=W,t.$g="en";let T=!1,O=!1,H=!1,S=!1,A=!1,m=!1,b=!1,p=!1,j=!1,c=!1,f,e=t.$g,n=t.$g,r,h;const g=globalThis;let y;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?y=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(y=process);const o=typeof y?.versions?.electron=="string",d=o&&y?.type==="renderer";if(typeof y=="object"){T=y.platform==="win32",O=y.platform==="darwin",H=y.platform==="linux",S=H&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,b=o,j=!!y.env.CI||!!y.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t.$g,e=t.$g;const F=y.env.VSCODE_NLS_CONFIG;if(F)try{const K=JSON.parse(F),B=K.availableLanguages["*"];f=K.locale,n=K.osLocale,e=B||t.$g,r=K._translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!d?(h=navigator.userAgent,T=h.indexOf("Windows")>=0,O=h.indexOf("Macintosh")>=0,p=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=h.indexOf("Linux")>=0,c=h?.indexOf("Mobi")>=0,m=!0,f=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=f,n=navigator.language):console.error("Unable to resolve platform.");var a;(function(F){F[F.Web=0]="Web",F[F.Mac=1]="Mac",F[F.Linux=2]="Linux",F[F.Windows=3]="Windows"})(a||(t.Platform=a={}));function k(F){switch(F){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let N=0;O?N=1:T?N=3:H&&(N=2),t.$i=T,t.$j=O,t.$k=H,t.$l=S,t.$m=A,t.$n=b,t.$o=m,t.$p=m&&typeof g.importScripts=="function",t.$q=t.$p?g.origin:void 0,t.$r=p,t.$s=c,t.$t=j,t.$u=N,t.$v=h,t.$w=e;var R;(function(F){function K(){return t.$w}F.value=K;function B(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}F.isDefaultVariant=B;function G(){return t.$w==="en"}F.isDefault=G})(R||(t.Language=R={})),t.$x=f,t.$y=n,t.$z=r,t.$A=typeof g.postMessage=="function"&&!g.importScripts,t.$B=(()=>{if(t.$A){const F=[];g.addEventListener("message",B=>{if(B.data&&B.data.vscodeScheduleAsyncWork)for(let G=0,V=F.length;G<V;G++){const ae=F[G];if(ae.id===B.data.vscodeScheduleAsyncWork){F.splice(G,1),ae.callback();return}}});let K=0;return B=>{const G=++K;F.push({id:G,callback:B}),g.postMessage({vscodeScheduleAsyncWork:G},"*")}}return F=>setTimeout(F)})();var L;(function(F){F[F.Windows=1]="Windows",F[F.Macintosh=2]="Macintosh",F[F.Linux=3]="Linux"})(L||(t.OperatingSystem=L={})),t.OS=O||p?2:T?1:3;let P=!0,E=!1;function z(){if(!E){E=!0;const F=new Uint8Array(2);F[0]=1,F[1]=2,P=new Uint16Array(F.buffer)[0]===513}return P}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function W(F){return parseFloat(F)>=20}}),define(be[125],$e([1,0,17,22,5]),function(se,t,i,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vR=t.KeyboardSupport=void 0;var H;(function(S){S[S.Always=0]="Always",S[S.FullScreen=1]="FullScreen",S[S.None=2]="None"})(H||(t.KeyboardSupport=H={})),t.$vR={clipboard:{writeText:O.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:O.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:O.$m||i.$tR()?0:navigator.keyboard||i.$pR?1:2,touch:"ontouchstart"in T.$aR||navigator.maxTouchPoints>0,pointerEvents:T.$aR.PointerEvent&&("ontouchstart"in T.$aR||navigator.maxTouchPoints>0)}}),define(be[15],$e([1,0,17,54,87,5]),function(se,t,i,T,O,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DR=void 0,t.$BR=j,t.$CR=c;function S(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return T.KeyCodeUtils.fromString(r)}const n=e.keyCode;if(n===3)return 7;if(i.$mR)switch(n){case 59:return 85;case 60:if(H.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(H.$j)return 57;break}else if(i.$nR){if(H.$j&&n===93)return 57;if(!H.$j&&n===92)return 57}return T.$rr[n]||0}const A=H.$j?256:2048,m=512,b=1024,p=H.$j?2048:256;function j(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function c(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${T.KeyCodeUtils.toString(e.keyCode)}')`}class f{constructor(n){this._standardKeyboardEventBrand=!0;const r=n;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState?.("AltGraph"),this.keyCode=S(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(n){return this.a===n}c(){let n=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode);let r=0;return this.ctrlKey&&(r|=A),this.altKey&&(r|=m),this.shiftKey&&(r|=b),this.metaKey&&(r|=p),r|=n,r}d(){let n=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode),new O.$zr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,n)}}t.$DR=f}),define(be[20],$e([1,0,17,79,5]),function(se,t,i,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AR=t.$zR=t.$yR=void 0;class H{constructor(b,p){this.timestamp=Date.now(),this.browserEvent=p,this.leftButton=p.button===0,this.middleButton=p.button===1,this.rightButton=p.button===2,this.buttons=p.buttons,this.target=p.target,this.detail=p.detail||1,p.type==="dblclick"&&(this.detail=2),this.ctrlKey=p.ctrlKey,this.shiftKey=p.shiftKey,this.altKey=p.altKey,this.metaKey=p.metaKey,typeof p.pageX=="number"?(this.posx=p.pageX,this.posy=p.pageY):(this.posx=p.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=p.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const j=T.$wR.getPositionOfChildWindowRelativeToAncestorWindow(b,p.view);this.posx-=j.left,this.posy-=j.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$yR=H;class S extends H{constructor(b,p){super(b,p),this.dataTransfer=p.dataTransfer}}t.$zR=S;class A{constructor(b,p=0,j=0){this.browserEvent=b||null,this.target=b?b.target||b.targetNode||b.srcElement:null,this.deltaY=j,this.deltaX=p;let c=!1;if(i.$oR){const f=navigator.userAgent.match(/Chrome\/(\d+)/);c=(f?parseInt(f[1]):123)<=122}if(b){const f=b,e=b,n=b.view?.devicePixelRatio||1;if(typeof f.wheelDeltaY<"u")c?this.deltaY=f.wheelDeltaY/(120*n):this.deltaY=f.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(b.type==="wheel"){const r=b;r.deltaMode===r.DOM_DELTA_LINE?i.$mR&&!O.$j?this.deltaY=-b.deltaY/3:this.deltaY=-b.deltaY:this.deltaY=-b.deltaY/40}if(typeof f.wheelDeltaX<"u")i.$pR&&O.$i?this.deltaX=-(f.wheelDeltaX/120):c?this.deltaX=f.wheelDeltaX/(120*n):this.deltaX=f.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-b.detail/3;else if(b.type==="wheel"){const r=b;r.deltaMode===r.DOM_DELTA_LINE?i.$mR&&!O.$j?this.deltaX=-b.deltaX/3:this.deltaX=-b.deltaX:this.deltaX=-b.deltaX/40}this.deltaY===0&&this.deltaX===0&&b.wheelDelta&&(c?this.deltaY=b.wheelDelta/(120*n):this.deltaY=b.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$AR=A}),define(be[126],$e([1,0,5]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let T;const O=globalThis.vscode;if(typeof O<"u"&&typeof O.process<"u"){const H=O.process;T={get platform(){return H.platform},get arch(){return H.arch},get env(){return H.env},cwd(){return H.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=T.cwd,t.env=T.env,t.$ec=T.platform,t.$fc=T.arch}),define(be[25],$e([1,0,126]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const T=65,O=97,H=90,S=122,A=46,m=47,b=92,p=58,j=63;class c extends Error{constructor(k,N,R){let L;typeof N=="string"&&N.indexOf("not ")===0?(L="must not be",N=N.replace(/^not /,"")):L="must be";const P=k.indexOf(".")!==-1?"property":"argument";let E=`The "${k}" ${P} ${L} of type ${N}`;E+=`. Received type ${typeof R}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function f(a,k){if(a===null||typeof a!="object")throw new c(k,"Object",a)}function e(a,k){if(typeof a!="string")throw new c(k,"string",a)}const n=i.$ec==="win32";function r(a){return a===m||a===b}function h(a){return a===m}function g(a){return a>=T&&a<=H||a>=O&&a<=S}function y(a,k,N,R){let L="",P=0,E=-1,z=0,W=0;for(let F=0;F<=a.length;++F){if(F<a.length)W=a.charCodeAt(F);else{if(R(W))break;W=m}if(R(W)){if(!(E===F-1||z===1))if(z===2){if(L.length<2||P!==2||L.charCodeAt(L.length-1)!==A||L.charCodeAt(L.length-2)!==A){if(L.length>2){const K=L.lastIndexOf(N);K===-1?(L="",P=0):(L=L.slice(0,K),P=L.length-1-L.lastIndexOf(N)),E=F,z=0;continue}else if(L.length!==0){L="",P=0,E=F,z=0;continue}}k&&(L+=L.length>0?`${N}..`:"..",P=2)}else L.length>0?L+=`${N}${a.slice(E+1,F)}`:L=a.slice(E+1,F),P=F-E-1;E=F,z=0}else W===A&&z!==-1?++z:z=-1}return L}function o(a,k){f(k,"pathObject");const N=k.dir||k.root,R=k.base||`${k.name||""}${k.ext||""}`;return N?N===k.root?`${N}${R}`:`${N}${a}${R}`:R}t.$gc={resolve(...a){let k="",N="",R=!1;for(let L=a.length-1;L>=-1;L--){let P;if(L>=0){if(P=a[L],e(P,"path"),P.length===0)continue}else k.length===0?P=i.cwd():(P=i.env[`=${k}`]||i.cwd(),(P===void 0||P.slice(0,2).toLowerCase()!==k.toLowerCase()&&P.charCodeAt(2)===b)&&(P=`${k}\\`));const E=P.length;let z=0,W="",F=!1;const K=P.charCodeAt(0);if(E===1)r(K)&&(z=1,F=!0);else if(r(K))if(F=!0,r(P.charCodeAt(1))){let B=2,G=B;for(;B<E&&!r(P.charCodeAt(B));)B++;if(B<E&&B!==G){const V=P.slice(G,B);for(G=B;B<E&&r(P.charCodeAt(B));)B++;if(B<E&&B!==G){for(G=B;B<E&&!r(P.charCodeAt(B));)B++;(B===E||B!==G)&&(W=`\\\\${V}\\${P.slice(G,B)}`,z=B)}}}else z=1;else g(K)&&P.charCodeAt(1)===p&&(W=P.slice(0,2),z=2,E>2&&r(P.charCodeAt(2))&&(F=!0,z=3));if(W.length>0)if(k.length>0){if(W.toLowerCase()!==k.toLowerCase())continue}else k=W;if(R){if(k.length>0)break}else if(N=`${P.slice(z)}\\${N}`,R=F,F&&k.length>0)break}return N=y(N,!R,"\\",r),R?`${k}\\${N}`:`${k}${N}`||"."},normalize(a){e(a,"path");const k=a.length;if(k===0)return".";let N=0,R,L=!1;const P=a.charCodeAt(0);if(k===1)return h(P)?"\\":a;if(r(P))if(L=!0,r(a.charCodeAt(1))){let z=2,W=z;for(;z<k&&!r(a.charCodeAt(z));)z++;if(z<k&&z!==W){const F=a.slice(W,z);for(W=z;z<k&&r(a.charCodeAt(z));)z++;if(z<k&&z!==W){for(W=z;z<k&&!r(a.charCodeAt(z));)z++;if(z===k)return`\\\\${F}\\${a.slice(W)}\\`;z!==W&&(R=`\\\\${F}\\${a.slice(W,z)}`,N=z)}}}else N=1;else g(P)&&a.charCodeAt(1)===p&&(R=a.slice(0,2),N=2,k>2&&r(a.charCodeAt(2))&&(L=!0,N=3));let E=N<k?y(a.slice(N),!L,"\\",r):"";return E.length===0&&!L&&(E="."),E.length>0&&r(a.charCodeAt(k-1))&&(E+="\\"),R===void 0?L?`\\${E}`:E:L?`${R}\\${E}`:`${R}${E}`},isAbsolute(a){e(a,"path");const k=a.length;if(k===0)return!1;const N=a.charCodeAt(0);return r(N)||k>2&&g(N)&&a.charCodeAt(1)===p&&r(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let k,N;for(let P=0;P<a.length;++P){const E=a[P];e(E,"path"),E.length>0&&(k===void 0?k=N=E:k+=`\\${E}`)}if(k===void 0)return".";let R=!0,L=0;if(typeof N=="string"&&r(N.charCodeAt(0))){++L;const P=N.length;P>1&&r(N.charCodeAt(1))&&(++L,P>2&&(r(N.charCodeAt(2))?++L:R=!1))}if(R){for(;L<k.length&&r(k.charCodeAt(L));)L++;L>=2&&(k=`\\${k.slice(L)}`)}return t.$gc.normalize(k)},relative(a,k){if(e(a,"from"),e(k,"to"),a===k)return"";const N=t.$gc.resolve(a),R=t.$gc.resolve(k);if(N===R||(a=N.toLowerCase(),k=R.toLowerCase(),a===k))return"";let L=0;for(;L<a.length&&a.charCodeAt(L)===b;)L++;let P=a.length;for(;P-1>L&&a.charCodeAt(P-1)===b;)P--;const E=P-L;let z=0;for(;z<k.length&&k.charCodeAt(z)===b;)z++;let W=k.length;for(;W-1>z&&k.charCodeAt(W-1)===b;)W--;const F=W-z,K=E<F?E:F;let B=-1,G=0;for(;G<K;G++){const ae=a.charCodeAt(L+G);if(ae!==k.charCodeAt(z+G))break;ae===b&&(B=G)}if(G!==K){if(B===-1)return R}else{if(F>K){if(k.charCodeAt(z+G)===b)return R.slice(z+G+1);if(G===2)return R.slice(z+G)}E>K&&(a.charCodeAt(L+G)===b?B=G:G===2&&(B=3)),B===-1&&(B=0)}let V="";for(G=L+B+1;G<=P;++G)(G===P||a.charCodeAt(G)===b)&&(V+=V.length===0?"..":"\\..");return z+=B,V.length>0?`${V}${R.slice(z,W)}`:(R.charCodeAt(z)===b&&++z,R.slice(z,W))},toNamespacedPath(a){if(typeof a!="string"||a.length===0)return a;const k=t.$gc.resolve(a);if(k.length<=2)return a;if(k.charCodeAt(0)===b){if(k.charCodeAt(1)===b){const N=k.charCodeAt(2);if(N!==j&&N!==A)return`\\\\?\\UNC\\${k.slice(2)}`}}else if(g(k.charCodeAt(0))&&k.charCodeAt(1)===p&&k.charCodeAt(2)===b)return`\\\\?\\${k}`;return a},dirname(a){e(a,"path");const k=a.length;if(k===0)return".";let N=-1,R=0;const L=a.charCodeAt(0);if(k===1)return r(L)?a:".";if(r(L)){if(N=R=1,r(a.charCodeAt(1))){let z=2,W=z;for(;z<k&&!r(a.charCodeAt(z));)z++;if(z<k&&z!==W){for(W=z;z<k&&r(a.charCodeAt(z));)z++;if(z<k&&z!==W){for(W=z;z<k&&!r(a.charCodeAt(z));)z++;if(z===k)return a;z!==W&&(N=R=z+1)}}}}else g(L)&&a.charCodeAt(1)===p&&(N=k>2&&r(a.charCodeAt(2))?3:2,R=N);let P=-1,E=!0;for(let z=k-1;z>=R;--z)if(r(a.charCodeAt(z))){if(!E){P=z;break}}else E=!1;if(P===-1){if(N===-1)return".";P=N}return a.slice(0,P)},basename(a,k){k!==void 0&&e(k,"ext"),e(a,"path");let N=0,R=-1,L=!0,P;if(a.length>=2&&g(a.charCodeAt(0))&&a.charCodeAt(1)===p&&(N=2),k!==void 0&&k.length>0&&k.length<=a.length){if(k===a)return"";let E=k.length-1,z=-1;for(P=a.length-1;P>=N;--P){const W=a.charCodeAt(P);if(r(W)){if(!L){N=P+1;break}}else z===-1&&(L=!1,z=P+1),E>=0&&(W===k.charCodeAt(E)?--E===-1&&(R=P):(E=-1,R=z))}return N===R?R=z:R===-1&&(R=a.length),a.slice(N,R)}for(P=a.length-1;P>=N;--P)if(r(a.charCodeAt(P))){if(!L){N=P+1;break}}else R===-1&&(L=!1,R=P+1);return R===-1?"":a.slice(N,R)},extname(a){e(a,"path");let k=0,N=-1,R=0,L=-1,P=!0,E=0;a.length>=2&&a.charCodeAt(1)===p&&g(a.charCodeAt(0))&&(k=R=2);for(let z=a.length-1;z>=k;--z){const W=a.charCodeAt(z);if(r(W)){if(!P){R=z+1;break}continue}L===-1&&(P=!1,L=z+1),W===A?N===-1?N=z:E!==1&&(E=1):N!==-1&&(E=-1)}return N===-1||L===-1||E===0||E===1&&N===L-1&&N===R+1?"":a.slice(N,L)},format:o.bind(null,"\\"),parse(a){e(a,"path");const k={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return k;const N=a.length;let R=0,L=a.charCodeAt(0);if(N===1)return r(L)?(k.root=k.dir=a,k):(k.base=k.name=a,k);if(r(L)){if(R=1,r(a.charCodeAt(1))){let B=2,G=B;for(;B<N&&!r(a.charCodeAt(B));)B++;if(B<N&&B!==G){for(G=B;B<N&&r(a.charCodeAt(B));)B++;if(B<N&&B!==G){for(G=B;B<N&&!r(a.charCodeAt(B));)B++;B===N?R=B:B!==G&&(R=B+1)}}}}else if(g(L)&&a.charCodeAt(1)===p){if(N<=2)return k.root=k.dir=a,k;if(R=2,r(a.charCodeAt(2))){if(N===3)return k.root=k.dir=a,k;R=3}}R>0&&(k.root=a.slice(0,R));let P=-1,E=R,z=-1,W=!0,F=a.length-1,K=0;for(;F>=R;--F){if(L=a.charCodeAt(F),r(L)){if(!W){E=F+1;break}continue}z===-1&&(W=!1,z=F+1),L===A?P===-1?P=F:K!==1&&(K=1):P!==-1&&(K=-1)}return z!==-1&&(P===-1||K===0||K===1&&P===z-1&&P===E+1?k.base=k.name=a.slice(E,z):(k.name=a.slice(E,P),k.base=a.slice(E,z),k.ext=a.slice(P,z))),E>0&&E!==R?k.dir=a.slice(0,E-1):k.dir=k.root,k},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(n){const a=/\\/g;return()=>{const k=i.cwd().replace(a,"/");return k.slice(k.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...a){let k="",N=!1;for(let R=a.length-1;R>=-1&&!N;R--){const L=R>=0?a[R]:d();e(L,"path"),L.length!==0&&(k=`${L}/${k}`,N=L.charCodeAt(0)===m)}return k=y(k,!N,"/",h),N?`/${k}`:k.length>0?k:"."},normalize(a){if(e(a,"path"),a.length===0)return".";const k=a.charCodeAt(0)===m,N=a.charCodeAt(a.length-1)===m;return a=y(a,!k,"/",h),a.length===0?k?"/":N?"./":".":(N&&(a+="/"),k?`/${a}`:a)},isAbsolute(a){return e(a,"path"),a.length>0&&a.charCodeAt(0)===m},join(...a){if(a.length===0)return".";let k;for(let N=0;N<a.length;++N){const R=a[N];e(R,"path"),R.length>0&&(k===void 0?k=R:k+=`/${R}`)}return k===void 0?".":t.$hc.normalize(k)},relative(a,k){if(e(a,"from"),e(k,"to"),a===k||(a=t.$hc.resolve(a),k=t.$hc.resolve(k),a===k))return"";const N=1,R=a.length,L=R-N,P=1,E=k.length-P,z=L<E?L:E;let W=-1,F=0;for(;F<z;F++){const B=a.charCodeAt(N+F);if(B!==k.charCodeAt(P+F))break;B===m&&(W=F)}if(F===z)if(E>z){if(k.charCodeAt(P+F)===m)return k.slice(P+F+1);if(F===0)return k.slice(P+F)}else L>z&&(a.charCodeAt(N+F)===m?W=F:F===0&&(W=0));let K="";for(F=N+W+1;F<=R;++F)(F===R||a.charCodeAt(F)===m)&&(K+=K.length===0?"..":"/..");return`${K}${k.slice(P+W)}`},toNamespacedPath(a){return a},dirname(a){if(e(a,"path"),a.length===0)return".";const k=a.charCodeAt(0)===m;let N=-1,R=!0;for(let L=a.length-1;L>=1;--L)if(a.charCodeAt(L)===m){if(!R){N=L;break}}else R=!1;return N===-1?k?"/":".":k&&N===1?"//":a.slice(0,N)},basename(a,k){k!==void 0&&e(k,"ext"),e(a,"path");let N=0,R=-1,L=!0,P;if(k!==void 0&&k.length>0&&k.length<=a.length){if(k===a)return"";let E=k.length-1,z=-1;for(P=a.length-1;P>=0;--P){const W=a.charCodeAt(P);if(W===m){if(!L){N=P+1;break}}else z===-1&&(L=!1,z=P+1),E>=0&&(W===k.charCodeAt(E)?--E===-1&&(R=P):(E=-1,R=z))}return N===R?R=z:R===-1&&(R=a.length),a.slice(N,R)}for(P=a.length-1;P>=0;--P)if(a.charCodeAt(P)===m){if(!L){N=P+1;break}}else R===-1&&(L=!1,R=P+1);return R===-1?"":a.slice(N,R)},extname(a){e(a,"path");let k=-1,N=0,R=-1,L=!0,P=0;for(let E=a.length-1;E>=0;--E){const z=a.charCodeAt(E);if(z===m){if(!L){N=E+1;break}continue}R===-1&&(L=!1,R=E+1),z===A?k===-1?k=E:P!==1&&(P=1):k!==-1&&(P=-1)}return k===-1||R===-1||P===0||P===1&&k===R-1&&k===N+1?"":a.slice(k,R)},format:o.bind(null,"/"),parse(a){e(a,"path");const k={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return k;const N=a.charCodeAt(0)===m;let R;N?(k.root="/",R=1):R=0;let L=-1,P=0,E=-1,z=!0,W=a.length-1,F=0;for(;W>=R;--W){const K=a.charCodeAt(W);if(K===m){if(!z){P=W+1;break}continue}E===-1&&(z=!1,E=W+1),K===A?L===-1?L=W:F!==1&&(F=1):L!==-1&&(F=-1)}if(E!==-1){const K=P===0&&N?1:P;L===-1||F===0||F===1&&L===E-1&&L===P+1?k.base=k.name=a.slice(K,E):(k.name=a.slice(K,L),k.base=a.slice(K,E),k.ext=a.slice(L,E))}return P>0?k.dir=a.slice(0,P-1):N&&(k.dir="/"),k},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=n?t.$gc.normalize:t.$hc.normalize,t.$jc=n?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=n?t.$gc.join:t.$hc.join,t.$lc=n?t.$gc.resolve:t.$hc.resolve,t.$mc=n?t.$gc.relative:t.$hc.relative,t.$nc=n?t.$gc.dirname:t.$hc.dirname,t.$oc=n?t.$gc.basename:t.$hc.basename,t.$pc=n?t.$gc.extname:t.$hc.extname,t.$qc=n?t.$gc.format:t.$hc.format,t.$rc=n?t.$gc.parse:t.$hc.parse,t.$sc=n?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=n?t.$gc.sep:t.$hc.sep,t.$uc=n?t.$gc.delimiter:t.$hc.delimiter}),define(be[127],$e([1,0,25,5,9,10]),function(se,t,i,T,O,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jg=S,t.$kg=A,t.$lg=m,t.$mg=b,t.$ng=p,t.$og=e,t.$pg=n,t.$qg=r,t.$rg=h,t.$sg=g,t.$tg=y,t.$ug=o,t.$vg=d,t.$wg=a,t.$xg=k,t.$yg=L;function S(P){return P===47||P===92}function A(P){return P.replace(/[\\/]/g,i.$hc.sep)}function m(P){return P.indexOf("/")===-1&&(P=A(P)),/^[a-zA-Z]:(\/|$)/.test(P)&&(P="/"+P),P}function b(P,E=i.$hc.sep){if(!P)return"";const z=P.length,W=P.charCodeAt(0);if(S(W)){if(S(P.charCodeAt(1))&&!S(P.charCodeAt(2))){let K=3;const B=K;for(;K<z&&!S(P.charCodeAt(K));K++);if(B!==K&&!S(P.charCodeAt(K+1))){for(K+=1;K<z;K++)if(S(P.charCodeAt(K)))return P.slice(0,K+1).replace(/[\\/]/g,E)}}return E}else if(h(W)&&P.charCodeAt(1)===58)return S(P.charCodeAt(2))?P.slice(0,2)+E:P.slice(0,2);let F=P.indexOf("://");if(F!==-1){for(F+=3;F<z;F++)if(S(P.charCodeAt(F)))return P.slice(0,F+1)}return""}function p(P){if(!T.$i||!P||P.length<5)return!1;let E=P.charCodeAt(0);if(E!==92||(E=P.charCodeAt(1),E!==92))return!1;let z=2;const W=z;for(;z<P.length&&(E=P.charCodeAt(z),E!==92);z++);return!(W===z||(E=P.charCodeAt(z+1),isNaN(E)||E===92))}const j=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(P,E=T.$i){const z=E?j:c;return!(!P||P.length===0||/^\s+$/.test(P)||(z.lastIndex=0,z.test(P))||E&&f.test(P)||P==="."||P===".."||E&&P[P.length-1]==="."||E&&P.length!==P.trim().length||P.length>255)}function n(P,E,z){const W=P===E;return!z||W?W:!P||!E?!1:(0,O.$tf)(P,E)}function r(P,E,z,W=i.sep){if(P===E)return!0;if(!P||!E||E.length>P.length)return!1;if(z){if(!(0,O.$uf)(P,E))return!1;if(E.length===P.length)return!0;let K=E.length;return E.charAt(E.length-1)===W&&K--,P.charAt(K)===W}return E.charAt(E.length-1)!==W&&(E+=W),P.indexOf(E)===0}function h(P){return P>=65&&P<=90||P>=97&&P<=122}function g(P,E){return T.$i&&P.endsWith(":")&&(P+=i.sep),(0,i.$jc)(P)||(P=(0,i.$kc)(E,P)),P=(0,i.$ic)(P),T.$i?(P=(0,O.$bf)(P,i.sep),P.endsWith(":")&&(P+=i.sep)):(P=(0,O.$bf)(P,i.sep),P||(P=i.sep)),P}function y(P){const E=(0,i.$ic)(P);return T.$i?P.length>3?!1:o(E)&&(P.length===2||E.charCodeAt(2)===92):E===i.$hc.sep}function o(P,E=T.$i){return E?h(P.charCodeAt(0))&&P.charCodeAt(1)===58:!1}function d(P,E=T.$i){return o(P,E)?P[0]:void 0}function a(P,E,z){return E.length>P.length?-1:P===E?0:(z&&(P=P.toLowerCase(),E=E.toLowerCase()),P.indexOf(E))}function k(P){const E=P.split(":");let z,W,F;for(const K of E){const B=Number(K);(0,H.$8f)(B)?W===void 0?W=B:F===void 0&&(F=B):z=z?[z,K].join(":"):K}if(!z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:z,line:W!==void 0?W:void 0,column:F!==void 0?F:W!==void 0?1:void 0}}const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function L(P,E,z=8){let W="";for(let K=0;K<z;K++){let B;K===0&&T.$i&&!E&&(z===3||z===4)?B=R:B=N,W+=B.charAt(Math.floor(Math.random()*B.length))}let F;return E?F=`${E}-${W}`:F=W,P?(0,i.$kc)(P,F):F}}),define(be[128],$e([1,0,25]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hs=void 0,t.$Is=H,t.$Js=S,t.$Ks=A,t.$Ls=b,t.$Hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},O={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(p){const j=(0,i.$pc)(p),c=T[j.toLowerCase()];return c!==void 0?c:S(p)}function S(p){const j=(0,i.$pc)(p);return O[j.toLowerCase()]}function A(p){for(const j in O)if(O[j]===p)return j}const m=/^(.+)\/(.+?)(;.+)?$/;function b(p,j){const c=m.exec(p);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:j?void 0:p}}),define(be[16],$e([1,0,25,5]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=o;const O=/^\w[\w\d+.-]*$/,H=/^\//,S=/^\/\//;function A(R,L){if(!R.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!O.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!H.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(R,L){return!R&&!L?"file":R}function b(R,L){switch(R){case"https":case"http":case"file":L?L[0]!==j&&(L=j+L):L=j;break}return L}const p="",j="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(L){return L instanceof f?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,P,E,z,W,F=!1){typeof L=="object"?(this.scheme=L.scheme||p,this.authority=L.authority||p,this.path=L.path||p,this.query=L.query||p,this.fragment=L.fragment||p):(this.scheme=m(L,F),this.authority=P||p,this.path=b(this.scheme,E||p),this.query=z||p,this.fragment=W||p,A(this,F))}get fsPath(){return o(this,!1)}with(L){if(!L)return this;let{scheme:P,authority:E,path:z,query:W,fragment:F}=L;return P===void 0?P=this.scheme:P===null&&(P=p),E===void 0?E=this.authority:E===null&&(E=p),z===void 0?z=this.path:z===null&&(z=p),W===void 0?W=this.query:W===null&&(W=p),F===void 0?F=this.fragment:F===null&&(F=p),P===this.scheme&&E===this.authority&&z===this.path&&W===this.query&&F===this.fragment?this:new r(P,E,z,W,F)}static parse(L,P=!1){const E=c.exec(L);return E?new r(E[2]||p,N(E[4]||p),N(E[5]||p),N(E[7]||p),N(E[9]||p),P):new r(p,p,p,p,p)}static file(L){let P=p;if(T.$i&&(L=L.replace(/\\/g,j)),L[0]===j&&L[1]===j){const E=L.indexOf(j,2);E===-1?(P=L.substring(2),L=j):(P=L.substring(2,E),L=L.substring(E)||j)}return new r("file",P,L,p,p)}static from(L,P){return new r(L.scheme,L.authority,L.path,L.query,L.fragment,P)}static joinPath(L,...P){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return T.$i&&L.scheme==="file"?E=f.file(i.$gc.join(o(L,!0),...P)).path:E=i.$hc.join(L.path,...P),L.with({path:E})}toString(L=!1){return d(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof f)return L;{const P=new r(L);return P._formatted=L.external??null,P._fsPath=L._sep===n?L.fsPath??null:null,P}}else return L}}t.URI=f;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}const n=T.$i?1:void 0;class r extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(L=!1){return L?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=n),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const h={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function g(R,L,P){let E,z=-1;for(let W=0;W<R.length;W++){const F=R.charCodeAt(W);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||L&&F===47||P&&F===91||P&&F===93||P&&F===58)z!==-1&&(E+=encodeURIComponent(R.substring(z,W)),z=-1),E!==void 0&&(E+=R.charAt(W));else{E===void 0&&(E=R.substr(0,W));const K=h[F];K!==void 0?(z!==-1&&(E+=encodeURIComponent(R.substring(z,W)),z=-1),E+=K):z===-1&&(z=W)}}return z!==-1&&(E+=encodeURIComponent(R.substring(z))),E!==void 0?E:R}function y(R){let L;for(let P=0;P<R.length;P++){const E=R.charCodeAt(P);E===35||E===63?(L===void 0&&(L=R.substr(0,P)),L+=h[E]):L!==void 0&&(L+=R[P])}return L!==void 0?L:R}function o(R,L){let P;return R.authority&&R.path.length>1&&R.scheme==="file"?P=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?L?P=R.path.substr(1):P=R.path[1].toLowerCase()+R.path.substr(2):P=R.path,T.$i&&(P=P.replace(/\//g,"\\")),P}function d(R,L){const P=L?y:g;let E="",{scheme:z,authority:W,path:F,query:K,fragment:B}=R;if(z&&(E+=z,E+=":"),(W||z==="file")&&(E+=j,E+=j),W){let G=W.indexOf("@");if(G!==-1){const V=W.substr(0,G);W=W.substr(G+1),G=V.lastIndexOf(":"),G===-1?E+=P(V,!1,!1):(E+=P(V.substr(0,G),!1,!1),E+=":",E+=P(V.substr(G+1),!1,!0)),E+="@"}W=W.toLowerCase(),G=W.lastIndexOf(":"),G===-1?E+=P(W,!1,!0):(E+=P(W.substr(0,G),!1,!0),E+=W.substr(G))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const G=F.charCodeAt(1);G>=65&&G<=90&&(F=`/${String.fromCharCode(G+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const G=F.charCodeAt(0);G>=65&&G<=90&&(F=`${String.fromCharCode(G+32)}:${F.substr(2)}`)}E+=P(F,!0,!1)}return K&&(E+="?",E+=P(K,!1,!1)),B&&(E+="#",E+=L?B:g(B,!1,!1)),E}function a(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+a(R.substr(3)):R}}const k=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(R){return R.match(k)?R.replace(k,L=>a(L)):R}}),define(be[64],$e([1,0,43,16]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xh=O,t.$Yh=H,t.$Zh=A;function O(m){return JSON.stringify(m,S)}function H(m){let b=JSON.parse(m);return b=A(b),b}function S(m,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function A(m,b=0){if(!m||b>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return T.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof i.$Ce||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let p=0;p<m.length;++p)m[p]=A(m[p],b+1);else for(const p in m)Object.hasOwnProperty.call(m,p)&&(m[p]=A(m[p],b+1))}return m}}),define(be[36],$e([1,0,6,5,9,16,25]),function(se,t,i,T,O,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Dg=t.$Cg=t.$Bg=t.Schemas=void 0,t.$zg=m,t.$Ag=b,t.$Eg=j;var A;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(A||(t.Schemas=A={}));function m(e,n){return H.URI.isUri(e)?(0,O.$tf)(e.scheme,n):(0,O.$uf)(e,n+":")}function b(e,...n){return n.some(r=>m(e,r))}t.$Bg="vscode-tkn",t.$Cg="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,r){this.f=j(n,r)}getServerRootPath(){return this.f}get g(){return S.$hc.join(this.f,A.vscodeRemoteResource)}set(n,r,h){this.a[n]=r,this.b[n]=h}setConnectionToken(n,r){this.c[n]=r}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(d){return i.$1(d),n}const r=n.authority;let h=this.a[r];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const g=this.b[r],y=this.c[r];let o=`path=${encodeURIComponent(n.path)}`;return typeof y=="string"&&(o+=`&${t.$Cg}=${encodeURIComponent(y)}`),H.URI.from({scheme:T.$o?this.d:A.vscodeRemoteResource,authority:`${h}:${g}`,path:this.g,query:o})}}t.$Dg=new p;function j(e,n){return S.$hc.join(n??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Fg="vs/../../extensions",t.$Gg="vs/../../node_modules",t.$Hg="vs/../../node_modules.asar",t.$Ig="vs/../../node_modules.asar.unpacked",t.$Jg="vscode-app";class c{static{this.a=t.$Jg}asBrowserUri(n){const r=this.b(n,se);return this.uriToBrowserUri(r)}uriToBrowserUri(n){return n.scheme===A.vscodeRemote?t.$Dg.rewrite(n):n.scheme===A.file&&(T.$m||T.$q===`${A.vscodeFileResource}://${c.a}`)?n.with({scheme:A.vscodeFileResource,authority:n.authority||c.a,query:null,fragment:null}):n}asFileUri(n){const r=this.b(n,se);return this.uriToFileUri(r)}uriToFileUri(n){return n.scheme===A.vscodeFileResource?n.with({scheme:A.file,authority:n.authority!==c.a?n.authority:null,query:null,fragment:null}):n}b(n,r){return H.URI.isUri(n)?n:H.URI.parse(r.toUrl(n))}}t.$Kg=new c;var f;(function(e){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(n.get("3"));const r="vscode-coi";function h(y){let o;typeof y=="string"?o=new URL(y).searchParams:y instanceof URL?o=y.searchParams:H.URI.isUri(y)&&(o=new URL(y.toString(!0)).searchParams);const d=o?.get(r);if(d)return n.get(d)}e.getHeadersFromQuery=h;function g(y,o,d){if(!globalThis.crossOriginIsolated)return;const a=o&&d?"3":d?"2":"1";y instanceof URLSearchParams?y.set(r,a):y[r]=a}e.addSearchParam=g})(f||(t.COI=f={}))}),define(be[47],$e([1,0,127,36,25,5,9,16]),function(se,t,i,T,O,H,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=void 0,t.$Rg=m,t.$ah=p,t.$bh=c;function m(f){return(0,A.$xc)(f,!0)}class b{constructor(e){this.a=e}compare(e,n,r=!1){return e===n?0:(0,S.$mf)(this.getComparisonKey(e,r),this.getComparisonKey(n,r))}isEqual(e,n,r=!1){return e===n?!0:!e||!n?!1:this.getComparisonKey(e,r)===this.getComparisonKey(n,r)}getComparisonKey(e,n=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,n,r=!1){if(e.scheme===n.scheme){if(e.scheme===T.Schemas.file)return i.$qg(m(e),m(n),this.a(e))&&e.query===n.query&&(r||e.fragment===n.fragment);if((0,t.$9g)(e.authority,n.authority))return i.$qg(e.path,n.path,this.a(e),"/")&&e.query===n.query&&(r||e.fragment===n.fragment)}return!1}joinPath(e,...n){return A.URI.joinPath(e,...n)}basenameOrAuthority(e){return(0,t.$1g)(e)||e.authority}basename(e){return O.$hc.basename(e.path)}extname(e){return O.$hc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let n;return e.scheme===T.Schemas.file?n=A.URI.file(O.$nc(m(e))).path:(n=O.$hc.dirname(e.path),e.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),n="/")),e.with({path:n})}normalizePath(e){if(!e.path.length)return e;let n;return e.scheme===T.Schemas.file?n=A.URI.file(O.$ic(m(e))).path:n=O.$hc.normalize(e.path),e.with({path:n})}relativePath(e,n){if(e.scheme!==n.scheme||!(0,t.$9g)(e.authority,n.authority))return;if(e.scheme===T.Schemas.file){const g=O.$mc(m(e),m(n));return H.$i?i.$kg(g):g}let r=e.path||"/";const h=n.path||"/";if(this.a(e)){let g=0;for(const y=Math.min(r.length,h.length);g<y&&!(r.charCodeAt(g)!==h.charCodeAt(g)&&r.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);r=h.substr(0,g)+r.substr(g)}return O.$hc.relative(r,h)}resolvePath(e,n){if(e.scheme===T.Schemas.file){const r=A.URI.file(O.$lc(m(e),n));return e.with({authority:r.authority,path:r.path})}return n=i.$lg(n),e.with({path:O.$hc.resolve(e.path,n)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,n){return e===n||e!==void 0&&n!==void 0&&(0,S.$tf)(e,n)}hasTrailingPathSeparator(e,n=O.sep){if(e.scheme===T.Schemas.file){const r=m(e);return r.length>i.$mg(r).length&&r[r.length-1]===n}else{const r=e.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,n=O.sep){return(0,t.$0g)(e,n)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,n=O.sep){let r=!1;if(e.scheme===T.Schemas.file){const h=m(e);r=h!==void 0&&h.length===i.$mg(h).length&&h[h.length-1]===n}else{n="/";const h=e.path;r=h.length===1&&h.charCodeAt(h.length-1)===47}return!r&&!(0,t.$0g)(e,n)?e.with({path:e.path+"/"}):e}}t.$Sg=b,t.$Tg=new b(()=>!1),t.$Ug=new b(f=>f.scheme===T.Schemas.file?!H.$k:!0),t.$Vg=new b(f=>!0),t.$Wg=t.$Tg.isEqual.bind(t.$Tg),t.$Xg=t.$Tg.isEqualOrParent.bind(t.$Tg),t.$Yg=t.$Tg.getComparisonKey.bind(t.$Tg),t.$Zg=t.$Tg.basenameOrAuthority.bind(t.$Tg),t.$1g=t.$Tg.basename.bind(t.$Tg),t.$2g=t.$Tg.extname.bind(t.$Tg),t.$3g=t.$Tg.dirname.bind(t.$Tg),t.$4g=t.$Tg.joinPath.bind(t.$Tg),t.$5g=t.$Tg.normalizePath.bind(t.$Tg),t.$6g=t.$Tg.relativePath.bind(t.$Tg),t.$7g=t.$Tg.resolvePath.bind(t.$Tg),t.$8g=t.$Tg.isAbsolutePath.bind(t.$Tg),t.$9g=t.$Tg.isEqualAuthority.bind(t.$Tg),t.$0g=t.$Tg.hasTrailingPathSeparator.bind(t.$Tg),t.$$g=t.$Tg.removeTrailingPathSeparator.bind(t.$Tg),t.$_g=t.$Tg.addTrailingPathSeparator.bind(t.$Tg);function p(f,e){const n=[];for(let r=0;r<f.length;r++){const h=e(f[r]);f.some((g,y)=>y===r?!1:(0,t.$Xg)(h,e(g)))||n.push(f[r])}return n}var j;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function e(n){const r=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(y=>{const[o,d]=y.split(":");o&&d&&r.set(o,d)});const g=n.path.substring(0,n.path.indexOf(";"));return g&&r.set(f.META_DATA_MIME,g),r}f.parseMetaData=e})(j||(t.DataUri=j={}));function c(f,e,n){if(e){let r=f.path;return r&&r[0]!==O.$hc.sep&&(r=O.$hc.sep+r),f.with({scheme:n,authority:e,path:r})}return f.with({scheme:n})}}),define(be[11],$e([1,0,34,6,3,2,47,5,60,23]),function(se,t,i,T,O,H,S,A,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Th=t.$Rh=t.$Qh=t.$Ph=t.$Oh=t.Promises=t.$Nh=t.$Mh=t.$Lh=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.$Fh=t.$Eh=t.$Dh=t.$Ch=t.$Bh=t.$Ah=t.$zh=t.$yh=t.$xh=t.$wh=t.$qh=t.$ph=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=void 0,t.$ch=p,t.$dh=j,t.$eh=c,t.$fh=f,t.$gh=e,t.$hh=n,t.$ih=r,t.$jh=h,t.$rh=P,t.$sh=E,t.$th=z,t.$uh=W,t.$vh=F,t.$Kh=_,t.$Sh=x;function p(v){return!!v&&typeof v.then=="function"}function j(v){const l=new i.$me,w=v(l.token),C=new Promise((s,D)=>{const $=l.token.onCancellationRequested(()=>{$.dispose(),D(new T.$5)});Promise.resolve(w).then(I=>{$.dispose(),l.dispose(),s(I)},I=>{$.dispose(),l.dispose(),D(I)})});return new class{cancel(){l.cancel(),l.dispose()}then(s,D){return C.then(s,D)}catch(s){return this.then(void 0,s)}finally(s){return C.finally(s)}}}function c(v,l,w){return new Promise((C,s)=>{const D=l.onCancellationRequested(()=>{D.dispose(),C(w)});v.then(C,s).finally(()=>D.dispose())})}function f(v,l){return new Promise((w,C)=>{const s=l.onCancellationRequested(()=>{s.dispose(),C(new T.$5)});v.then(w,C).finally(()=>s.dispose())})}async function e(v){let l=-1;const w=v.map((C,s)=>C.then(D=>(l=s,D)));try{return await Promise.race(w)}finally{v.forEach((C,s)=>{s!==l&&C.cancel()})}}function n(v,l,w){let C;const s=setTimeout(()=>{C?.(void 0),w?.()},l);return Promise.race([v.finally(()=>clearTimeout(s)),new Promise(D=>C=D)])}function r(v){return new Promise((l,w)=>{const C=v();p(C)?C.then(l,w):l(C)})}function h(){let v,l;return{promise:new Promise((C,s)=>{v=C,l=s}),resolve:v,reject:l}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(l){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=l,!this.b){const w=()=>{if(this.b=null,this.f)return;const C=this.queue(this.d);return this.d=null,C};this.b=new Promise(C=>{this.a.then(w,w).then(C)})}return new Promise((w,C)=>{this.b.then(w,C)})}return this.a=l(),new Promise((w,C)=>{this.a.then(s=>{this.a=null,w(s)},s=>{this.a=null,C(s)})})}dispose(){this.f=!0}}t.$kh=g;class y{constructor(){this.a=Promise.resolve(null)}queue(l){return this.a=this.a.then(()=>l(),()=>l())}}t.$lh=y;class o{constructor(){this.a=new Map}queue(l,w){const s=(this.a.get(l)??Promise.resolve()).catch(()=>{}).then(w).finally(()=>{this.a.get(l)===s&&this.a.delete(l)});return this.a.set(l,s),s}}t.$mh=o;const d=(v,l)=>{let w=!0;const C=setTimeout(()=>{w=!1,l()},v);return{isTriggered:()=>w,dispose:()=>{clearTimeout(C),w=!1}}},a=v=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,v())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class k{constructor(l){this.defaultDelay=l,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(l,w=this.defaultDelay){this.g=l,this.h(),this.b||(this.b=new Promise((s,D)=>{this.d=s,this.f=D}).then(()=>{if(this.b=null,this.d=null,this.g){const s=this.g;return this.g=null,s()}}));const C=()=>{this.a=null,this.d?.(null)};return this.a=w===m.$$d?a(C):d(w,C),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$nh=k;class N{constructor(l){this.a=new k(l),this.b=new g}trigger(l,w){return this.a.trigger(()=>this.b.queue(l),w)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$oh=N;class R{constructor(){this.a=!1,this.b=new Promise((l,w)=>{this.d=l})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$ph=R;class L extends R{constructor(l){super(),this.f=setTimeout(()=>this.open(),l)}open(){clearTimeout(this.f),super.open()}}t.$qh=L;function P(v,l){return l?new Promise((w,C)=>{const s=setTimeout(()=>{D.dispose(),w()},v),D=l.onCancellationRequested(()=>{clearTimeout(s),D.dispose(),C(new T.$5)})}):j(w=>P(v,w))}function E(v,l=0,w){const C=setTimeout(()=>{v(),w&&s.dispose()},l),s=(0,H.$Sc)(()=>{clearTimeout(C),w?.deleteAndLeak(s)});return w?.add(s),s}function z(v){const l=[];let w=0;const C=v.length;function s(){return w<C?v[w++]():null}function D($){$!=null&&l.push($);const I=s();return I?I.then(D):Promise.resolve(l)}return Promise.resolve(null).then(D)}function W(v,l=C=>!!C,w=null){let C=0;const s=v.length,D=()=>{if(C>=s)return Promise.resolve(w);const $=v[C++];return Promise.resolve($()).then(M=>l(M)?Promise.resolve(M):D())};return D()}function F(v,l=C=>!!C,w=null){if(v.length===0)return Promise.resolve(w);let C=v.length;const s=()=>{C=-1;for(const D of v)D.cancel?.()};return new Promise((D,$)=>{for(const I of v)I.then(M=>{--C>=0&&l(M)?(s(),D(M)):C===0&&D(w)}).catch(M=>{--C>=0&&(s(),$(M))})})}class K{constructor(l){this.a=0,this.b=!1,this.f=l,this.g=[],this.d=0,this.h=new O.$be}whenIdle(){return this.size>0?O.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(l){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((w,C)=>{this.g.push({factory:l,c:w,e:C}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const l=this.g.shift();this.d++;const w=l.factory();w.then(l.c,l.e),w.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$wh=K;class B extends K{constructor(){super(1)}}t.$xh=B;class G{constructor(){this.a=new ue,this.b=0}queue(l){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,l())):this.a.run(this.b++,l())}}t.$yh=G;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const l=new U;return this.b.add(l),l.p}g(){for(const[,l]of this.a)if(l.size>0)return!1;return!0}queueSize(l,w=S.$Tg){const C=w.getComparisonKey(l);return this.a.get(C)?.size??0}queueFor(l,w,C=S.$Tg){const s=C.getComparisonKey(l);let D=this.a.get(s);if(!D){D=new B;const $=this.f++,I=O.Event.once(D.onDrained)(()=>{D?.dispose(),this.a.delete(s),this.h(),this.d?.deleteAndDispose($),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new H.$4c),this.d.set($,I),this.a.set(s,D)}return D.queue(w)}h(){this.g()&&this.j()}j(){for(const l of this.b)l.complete();this.b.clear()}dispose(){for(const[,l]of this.a)l.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$zh=V;class ae{constructor(l,w){this.a=-1,typeof l=="function"&&typeof w=="number"&&this.setIfNotSet(l,w)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(l,w){this.cancel(),this.a=setTimeout(()=>{this.a=-1,l()},w)}setIfNotSet(l,w){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,l()},w))}}t.$Ah=ae;class ie{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(l,w,C=globalThis){this.cancel();const s=C.setInterval(()=>{l()},w);this.d=(0,H.$Sc)(()=>{C.clearInterval(s),this.d=void 0})}dispose(){this.cancel()}}t.$Bh=ie;class ee{constructor(l,w){this.b=-1,this.a=l,this.d=w,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(l=this.d){this.cancel(),this.b=setTimeout(this.f,l)}get delay(){return this.d}set delay(l){this.d=l}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Ch=ee;class ge{constructor(l,w){w%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${w}ms is not a multiple of 1000ms.`),this.a=l,this.b=w,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(l=this.b){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(l/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Dh=ge;class Ee extends ee{constructor(l,w){super(l,w),this.j=[]}work(l){this.j.push(l),this.isScheduled()||this.schedule()}h(){const l=this.j;this.j=[],this.a?.(l)}dispose(){this.j=[],super.dispose()}}t.$Eh=Ee;class De extends H.$Uc{constructor(l,w){super(),this.g=l,this.h=w,this.a=[],this.b=this.B(new H.$Vc),this.f=!1}get pending(){return this.a.length}work(l){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+l.length>this.g.maxBufferedWork)return!1}else if(this.pending+l.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const w of l)this.a.push(w);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Fh=De,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Hh=(v,l)=>{(0,A.$B)(()=>{if(w)return;const C=Date.now()+15;l(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let w=!1;return{dispose(){w||(w=!0)}}}:t.$Hh=(v,l,w)=>{const C=v.requestIdleCallback(l,typeof w=="number"?{timeout:w}:void 0);let s=!1;return{dispose(){s||(s=!0,v.cancelIdleCallback(C))}}},t.$Gh=v=>(0,t.$Hh)(globalThis,v)}();class Le{constructor(l,w){this.g=!1,this.d=()=>{try{this.j=w()}catch(C){this.l=C}finally{this.g=!0}},this.f=(0,t.$Hh)(l,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Ih=Le;class he extends Le{constructor(l){super(globalThis,l)}}t.$Jh=he;async function _(v,l,w){let C;for(let s=0;s<w;s++)try{return await v()}catch(D){C=D,await P(l)}throw C}class ue{isRunning(l){return typeof l=="number"?this.a?.taskId===l:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(l,w,C){return this.a={taskId:l,cancel:()=>C?.(),promise:w},w.then(()=>this.d(l),()=>this.d(l)),w}d(l){this.a&&l===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const l=this.b;this.b=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this.b)this.b.run=l;else{const{promise:w,resolve:C,reject:s}=h();this.b={run:l,promise:w,promiseResolve:C,promiseReject:s}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Lh=ue;class le{constructor(l,w=()=>Date.now()){this.d=l,this.f=w,this.a=0,this.b=0}increment(){const l=this.f();return l-this.a>this.d&&(this.a=l,this.b=0),this.b++,this.b}}t.$Mh=le;var Q;(function(v){v[v.Resolved=0]="Resolved",v[v.Rejected=1]="Rejected"})(Q||(Q={}));class U{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((l,w)=>{this.a=l,this.b=w})}complete(l){return new Promise(w=>{this.a(l),this.d={outcome:0,value:l},w()})}error(l){return new Promise(w=>{this.b(l),this.d={outcome:1,value:l},w()})}cancel(){return this.error(new T.$5)}}t.$Nh=U;var re;(function(v){async function l(C){let s;const D=await Promise.all(C.map($=>$.then(I=>I,I=>{s||(s=I)})));if(typeof s<"u")throw s;return D}v.settled=l;function w(C){return new Promise(async(s,D)=>{try{await C(s,D)}catch($){D($)}})}v.withAsyncBody=w})(re||(t.Promises=re={}));class me{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(l){this.a=void 0,this.b=void 0,this.d=!1,this.promise=l.then(w=>(this.a=w,this.d=!0,w),w=>{throw this.b=w,this.d=!0,w})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$Oh=me;class ve{constructor(l){this.b=l,this.a=new b.$V(()=>new me(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$Ph=ve;var Ne;(function(v){v[v.Initial=0]="Initial",v[v.DoneOK=1]="DoneOK",v[v.DoneError=2]="DoneError"})(Ne||(Ne={}));class Te{static fromArray(l){return new Te(w=>{w.emitMany(l)})}static fromPromise(l){return new Te(async w=>{w.emitMany(await l)})}static fromPromises(l){return new Te(async w=>{await Promise.all(l.map(async C=>w.emitOne(await C)))})}static merge(l){return new Te(async w=>{await Promise.all(l.map(async C=>{for await(const s of C)w.emitOne(s)}))})}static{this.EMPTY=Te.fromArray([])}constructor(l,w){this.a=0,this.b=[],this.d=null,this.f=w,this.g=new O.$be,queueMicrotask(async()=>{const C={emitOne:s=>this.h(s),emitMany:s=>this.j(s),reject:s=>this.l(s)};try{await Promise.resolve(l(C)),this.k()}catch(s){this.l(s)}finally{C.emitOne=void 0,C.emitMany=void 0,C.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(l<this.b.length)return{done:!1,value:this.b[l++]};if(this.a===1)return{done:!0,value:void 0};await O.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(l,w){return new Te(async C=>{for await(const s of l)C.emitOne(w(s))})}map(l){return Te.map(this,l)}static filter(l,w){return new Te(async C=>{for await(const s of l)w(s)&&C.emitOne(s)})}filter(l){return Te.filter(this,l)}static coalesce(l){return Te.filter(l,w=>!!w)}coalesce(){return Te.coalesce(this)}static async toPromise(l){const w=[];for await(const C of l)w.push(C);return w}toPromise(){return Te.toPromise(this)}h(l){this.a===0&&(this.b.push(l),this.g.fire())}j(l){this.a===0&&(this.b=this.b.concat(l),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(l){this.a===0&&(this.a=2,this.d=l,this.g.fire())}}t.$Qh=Te;class Me extends Te{constructor(l,w){super(w),this.m=l}cancel(){this.m.cancel()}}t.$Rh=Me;function x(v){const l=new i.$me,w=v(l.token);return new Me(l,async C=>{const s=l.token.onCancellationRequested(()=>{s.dispose(),l.dispose(),C.reject(new T.$5)});try{for await(const D of w){if(l.token.isCancellationRequested)return;C.emitOne(D)}s.dispose(),l.dispose()}catch(D){s.dispose(),l.dispose(),C.reject(D)}})}class u{constructor(l){this.a=new U,this.b=new Te(s=>{if(w){s.reject(w);return}return C&&s.emitMany(C),this.d=D=>s.reject(D),this.f=D=>s.emitOne(D),this.a.p},l);let w,C;this.f=s=>{C||(C=[]),C.push(s)},this.d=s=>{w||(w=s)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(l){this.d(l),this.a.complete()}emitOne(l){this.f(l)}}t.$Th=u}),define(be[4],$e([1,0,17,125,15,20,11,6,3,129,2,36,5,16,59,22]),function(se,t,i,T,O,H,S,A,m,b,p,j,c,f,e,n){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.$9S=t.$7S=t.$4S=t.DetectedFullscreenMode=t.Namespace=t.$BS=t.$zS=t.$qS=t.$YR=t.$SR=t.$QR=t.$PR=t.$OR=t.$JR=t.$IR=t.$HR=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$FR=h,t.$GR=y,t.$KR=R,t.$LR=L,t.$MR=P,t.$NR=E,t.$RR=W,t.$TR=B,t.$UR=G,t.$VR=ee,t.$WR=ge,t.$XR=Ee,t.$ZR=he,t.$1R=_,t.$2R=ue,t.$3R=le,t.$4R=Q,t.$5R=U,t.$6R=re,t.$7R=me,t.$8R=ve,t.$9R=Ne,t.$0R=Me,t.$$R=x,t.$_R=v,t.$aS=w,t.$bS=C,t.$cS=s,t.$dS=D,t.$eS=$,t.$fS=I,t.$gS=M,t.$hS=Y,t.$iS=J,t.$jS=oe,t.$kS=we,t.$lS=fe,t.$mS=ke,t.$nS=Oe,t.$oS=Ce,t.$pS=He,t.$rS=Xe,t.$sS=_e,t.$tS=Re,t.$uS=ze,t.$vS=et,t.$wS=it,t.$xS=st,t.$yS=Qe,t.$AS=rt,t.$CS=tt,t.$DS=mt,t.$ES=At,t.$FS=kt,t.$GS=Tt,t.$HS=Be,t.$IS=ce,t.$=nt,t.$KS=lt,t.$LS=Ze,t.$MS=ut,t.$NS=$t,t.$OS=Ut,t.$PS=Si,t.$QS=Ai,t.$RS=ki,t.$SS=Ti,t.$TS=Ci,t.$US=Fi,t.$VS=Ni,t.$WS=Ri,t.$XS=Ii,t.$YS=Qt,t.$ZS=Li,t.$1S=Mi,t.$2S=ji,t.$3S=_t,t.$5S=Bi,t.$6S=zi,t.$8S=xi,t.h=Vi,t.$$S=ti,t.$_S=Gi,r=function(){const q=new Map;(0,n.$_Q)(n.$aR,1);const X={window:n.$aR,disposables:new p.$Tc};q.set(n.$aR.vscodeWindowId,X);const te=new m.$be,de=new m.$be,Ae=new m.$be;function Ke(Pe,Ve){return(typeof Pe=="number"?q.get(Pe):void 0)??(Ve?X:void 0)}return{onDidRegisterWindow:te.event,onWillUnregisterWindow:Ae.event,onDidUnregisterWindow:de.event,registerWindow(Pe){if(q.has(Pe.vscodeWindowId))return p.$Uc.None;const Ve=new p.$Tc,qe={window:Pe,disposables:Ve.add(new p.$Tc)};return q.set(Pe.vscodeWindowId,qe),Ve.add((0,p.$Sc)(()=>{q.delete(Pe.vscodeWindowId),de.fire(Pe)})),Ve.add(y(Pe,t.$zS.BEFORE_UNLOAD,()=>{Ae.fire(Pe)})),te.fire(qe),Ve},getWindows(){return q.values()},getWindowsCount(){return q.size},getWindowId(Pe){return Pe.vscodeWindowId},hasWindow(Pe){return q.has(Pe)},getWindowById:Ke,getWindow(Pe){const Ve=Pe;if(Ve?.ownerDocument?.defaultView)return Ve.ownerDocument.defaultView.window;const qe=Pe;return qe?.view?qe.view.window:n.$aR},getDocument(Pe){const Ve=Pe;return(0,t.getWindow)(Ve).document}}}(),t.registerWindow=r.registerWindow,t.getWindow=r.getWindow,t.getDocument=r.getDocument,t.getWindows=r.getWindows,t.getWindowsCount=r.getWindowsCount,t.getWindowId=r.getWindowId,t.getWindowById=r.getWindowById,t.hasWindow=r.hasWindow,t.onDidRegisterWindow=r.onDidRegisterWindow,t.onWillUnregisterWindow=r.onWillUnregisterWindow,t.onDidUnregisterWindow=r.onDidUnregisterWindow;function h(q){for(;q.firstChild;)q.firstChild.remove()}class g{constructor(X,te,de,Ae){this.f=X,this.g=te,this.d=de,this.j=Ae||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function y(q,X,te,de){return new g(q,X,te,de)}function o(q,X){return function(te){return X(new H.$yR(q,te))}}function d(q){return function(X){return q(new O.$DR(X))}}const a=function(X,te,de,Ae){let Ke=de;return te==="click"||te==="mousedown"?Ke=o((0,t.getWindow)(X),de):(te==="keydown"||te==="keypress"||te==="keyup")&&(Ke=d(de)),y(X,te,Ke,Ae)};t.$HR=a;const k=function(X,te,de){const Ae=o((0,t.getWindow)(X),te);return R(X,Ae,de)};t.$IR=k;const N=function(X,te,de){const Ae=o((0,t.getWindow)(X),te);return P(X,Ae,de)};t.$JR=N;function R(q,X,te){return y(q,c.$r&&T.$vR.pointerEvents?t.$zS.POINTER_DOWN:t.$zS.MOUSE_DOWN,X,te)}function L(q,X,te){return y(q,c.$r&&T.$vR.pointerEvents?t.$zS.POINTER_MOVE:t.$zS.MOUSE_MOVE,X,te)}function P(q,X,te){return y(q,c.$r&&T.$vR.pointerEvents?t.$zS.POINTER_UP:t.$zS.MOUSE_UP,X,te)}function E(q,X,te){return(0,S.$Hh)(q,X,te)}class z extends S.$Ih{constructor(X,te){super(X,te)}}t.$OR=z;function W(q,X,te,de){let Ae=0;const Ke=q.setInterval(()=>{Ae++,(typeof de=="number"&&Ae>=de||X()===!0)&&Pe.dispose()},te),Pe=(0,p.$Sc)(()=>{q.clearInterval(Ke)});return Pe}class F extends S.$Bh{constructor(X){super(),this.f=X&&(0,t.getWindow)(X)}cancelAndSet(X,te,de){return super.cancelAndSet(X,te,de??this.f)}}t.$SR=F;class K{constructor(X,te=0){this.d=X,this.priority=te,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(X){(0,A.$1)(X)}}static sort(X,te){return te.priority-X.priority}}(function(){const q=new Map,X=new Map,te=new Map,de=new Map,Ae=Ke=>{te.set(Ke,!1);const Pe=q.get(Ke)??[];for(X.set(Ke,Pe),q.set(Ke,[]),de.set(Ke,!0);Pe.length>0;)Pe.sort(K.sort),Pe.shift().execute();de.set(Ke,!1)};t.$QR=(Ke,Pe,Ve=0)=>{const qe=(0,t.getWindowId)(Ke),Ye=new K(Pe,Ve);let at=q.get(qe);return at||(at=[],q.set(qe,at)),at.push(Ye),te.get(qe)||(te.set(qe,!0),Ke.requestAnimationFrame(()=>Ae(qe))),Ye},t.$PR=(Ke,Pe,Ve)=>{const qe=(0,t.getWindowId)(Ke);if(de.get(qe)){const Ye=new K(Pe,Ve);let at=X.get(qe);return at||(at=[],X.set(qe,at)),at.push(Ye),Ye}else return(0,t.$QR)(Ke,Pe,Ve)}})();function B(q,X){return(0,t.$QR)(q,X,1e4)}function G(q,X){return(0,t.$QR)(q,X,-1e4)}const V=8,ae=function(q,X){return X};class ie extends p.$Uc{constructor(X,te,de,Ae=ae,Ke=V){super();let Pe=null,Ve=0;const qe=this.B(new S.$Ah),Ye=()=>{Ve=new Date().getTime(),de(Pe),Pe=null};this.B(y(X,te,at=>{Pe=Ae(Pe,at);const Ft=new Date().getTime()-Ve;Ft>=Ke?(qe.cancel(),Ye()):qe.setIfNotSet(Ye,Ke-Ft)}))}}function ee(q,X,te,de,Ae){return new ie(q,X,te,de,Ae)}function ge(q){return(0,t.getWindow)(q).getComputedStyle(q,null)}function Ee(q,X){const te=(0,t.getWindow)(q),de=te.document;if(q!==de.body)return new Le(q.clientWidth,q.clientHeight);if(c.$r&&te?.visualViewport)return new Le(te.visualViewport.width,te.visualViewport.height);if(te?.innerWidth&&te.innerHeight)return new Le(te.innerWidth,te.innerHeight);if(de.body&&de.body.clientWidth&&de.body.clientHeight)return new Le(de.body.clientWidth,de.body.clientHeight);if(de.documentElement&&de.documentElement.clientWidth&&de.documentElement.clientHeight)return new Le(de.documentElement.clientWidth,de.documentElement.clientHeight);if(X)return Ee(X);throw new Error("Unable to figure out browser width and height")}class De{static d(X,te){return parseFloat(te)||0}static f(X,te,de){const Ae=ge(X),Ke=Ae?Ae.getPropertyValue(te):"0";return De.d(X,Ke)}static getBorderLeftWidth(X){return De.f(X,"border-left-width","borderLeftWidth")}static getBorderRightWidth(X){return De.f(X,"border-right-width","borderRightWidth")}static getBorderTopWidth(X){return De.f(X,"border-top-width","borderTopWidth")}static getBorderBottomWidth(X){return De.f(X,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(X){return De.f(X,"padding-left","paddingLeft")}static getPaddingRight(X){return De.f(X,"padding-right","paddingRight")}static getPaddingTop(X){return De.f(X,"padding-top","paddingTop")}static getPaddingBottom(X){return De.f(X,"padding-bottom","paddingBottom")}static getMarginLeft(X){return De.f(X,"margin-left","marginLeft")}static getMarginTop(X){return De.f(X,"margin-top","marginTop")}static getMarginRight(X){return De.f(X,"margin-right","marginRight")}static getMarginBottom(X){return De.f(X,"margin-bottom","marginBottom")}}class Le{static{this.None=new Le(0,0)}constructor(X,te){this.width=X,this.height=te}with(X=this.width,te=this.height){return X!==this.width||te!==this.height?new Le(X,te):this}static is(X){return typeof X=="object"&&typeof X.height=="number"&&typeof X.width=="number"}static lift(X){return X instanceof Le?X:new Le(X.width,X.height)}static equals(X,te){return X===te?!0:!X||!te?!1:X.width===te.width&&X.height===te.height}}t.$YR=Le;function he(q){let X=q.offsetParent,te=q.offsetTop,de=q.offsetLeft;for(;(q=q.parentNode)!==null&&q!==q.ownerDocument.body&&q!==q.ownerDocument.documentElement;){te-=q.scrollTop;const Ae=D(q)?null:ge(q);Ae&&(de-=Ae.direction!=="rtl"?q.scrollLeft:-q.scrollLeft),q===X&&(de+=De.getBorderLeftWidth(q),te+=De.getBorderTopWidth(q),te+=q.offsetTop,de+=q.offsetLeft,X=q.offsetParent)}return{left:de,top:te}}function _(q,X,te){typeof X=="number"&&(q.style.width=`${X}px`),typeof te=="number"&&(q.style.height=`${te}px`)}function ue(q,X,te,de,Ae,Ke="absolute"){typeof X=="number"&&(q.style.top=`${X}px`),typeof te=="number"&&(q.style.right=`${te}px`),typeof de=="number"&&(q.style.bottom=`${de}px`),typeof Ae=="number"&&(q.style.left=`${Ae}px`),q.style.position=Ke}function le(q){const X=q.getBoundingClientRect(),te=(0,t.getWindow)(q);return{left:X.left+te.scrollX,top:X.top+te.scrollY,width:X.width,height:X.height}}function Q(q){let X=q,te=1;do{const de=ge(X).zoom;de!=null&&de!=="1"&&(te*=de),X=X.parentElement}while(X!==null&&X!==X.ownerDocument.documentElement);return te}function U(q){const X=De.getMarginLeft(q)+De.getMarginRight(q);return q.offsetWidth+X}function re(q){const X=De.getBorderLeftWidth(q)+De.getBorderRightWidth(q),te=De.getPaddingLeft(q)+De.getPaddingRight(q);return q.offsetWidth-X-te}function me(q){const X=De.getMarginLeft(q)+De.getMarginRight(q);return q.scrollWidth+X}function ve(q){const X=De.getBorderTopWidth(q)+De.getBorderBottomWidth(q),te=De.getPaddingTop(q)+De.getPaddingBottom(q);return q.offsetHeight-X-te}function Ne(q){const X=De.getMarginTop(q)+De.getMarginBottom(q);return q.offsetHeight+X}function Te(q,X){if(q===null)return 0;const te=he(q),de=he(X);return te.left-de.left}function Me(q,X){const te=X.map(Ae=>Math.max(me(Ae),U(Ae))+Te(Ae,q)||0);return Math.max(...te)}function x(q,X){return!!X?.contains(q)}const u="parentFlowToElementId";function v(q,X){q.dataset[u]=X.id}function l(q){const X=q.dataset[u];return typeof X=="string"?q.ownerDocument.getElementById(X):null}function w(q,X){let te=q;for(;te;){if(te===X)return!0;if(te instanceof HTMLElement){const de=l(te);if(de){te=de;continue}}te=te.parentNode}return!1}function C(q,X,te){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q.classList.contains(X))return q;if(te){if(typeof te=="string"){if(q.classList.contains(te))return null}else if(q===te)return null}q=q.parentNode}return null}function s(q,X,te){return!!C(q,X,te)}function D(q){return q&&!!q.host&&!!q.mode}function $(q){return!!I(q)}function I(q){for(;q.parentNode;){if(q===q.ownerDocument?.body)return null;q=q.parentNode}return D(q)?q:null}function M(){let q=we().activeElement;for(;q?.shadowRoot;)q=q.shadowRoot.activeElement;return q}function Y(q){return M()===q}function J(q){return x(M(),q)}function oe(q){return q.ownerDocument===we()}function we(){return(0,t.getWindowsCount)()<=1?n.$aR.document:Array.from((0,t.getWindows)()).map(({window:X})=>X.document).find(X=>X.hasFocus())??n.$aR.document}function fe(){return we().defaultView?.window??n.$aR}const Ie=new Map;function ke(q){return Ie.has(q)}function Oe(){return new Se}class Se{constructor(){this.d="",this.f=void 0}setStyle(X){X!==this.d&&(this.d=X,this.f?this.f.innerText=X:this.f=Ce(n.$aR.document.head,te=>te.innerText=X))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Ce(q=n.$aR.document.head,X,te){const de=document.createElement("style");if(de.type="text/css",de.media="screen",X?.(de),q.appendChild(de),te&&te.add((0,p.$Sc)(()=>q.removeChild(de))),q===n.$aR.document.head){const Ae=new Set;Ie.set(de,Ae);for(const{window:Ke,disposables:Pe}of(0,t.getWindows)()){if(Ke===n.$aR)continue;const Ve=Pe.add(Ue(de,Ae,Ke));te?.add(Ve)}}return de}function He(q){const X=new p.$Tc;for(const[te,de]of Ie)X.add(Ue(te,de,q));return X}function Ue(q,X,te){const de=new p.$Tc,Ae=q.cloneNode(!0);te.document.head.appendChild(Ae),de.add((0,p.$Sc)(()=>te.document.head.removeChild(Ae)));for(const Ke of ye(q))Ae.sheet?.insertRule(Ke.cssText,Ae.sheet?.cssRules.length);return de.add(t.$qS.observe(q,de,{childList:!0})(()=>{Ae.textContent=q.textContent})),X.add(Ae),de.add((0,p.$Sc)(()=>X.delete(Ae))),de}t.$qS=new class{constructor(){this.mutationObservers=new Map}observe(q,X,te){let de=this.mutationObservers.get(q);de||(de=new Map,this.mutationObservers.set(q,de));const Ae=(0,e.$ej)(te);let Ke=de.get(Ae);if(Ke)Ke.users+=1;else{const Pe=new m.$be,Ve=new MutationObserver(Ye=>Pe.fire(Ye));Ve.observe(q,te);const qe=Ke={users:1,observer:Ve,onDidMutate:Pe.event};X.add((0,p.$Sc)(()=>{qe.users-=1,qe.users===0&&(Pe.dispose(),Ve.disconnect(),de?.delete(Ae),de?.size===0&&this.mutationObservers.delete(q))})),de.set(Ae,Ke)}return Ke.onDidMutate}};function Xe(q=n.$aR.document.head){return Z("meta",q)}function _e(q=n.$aR.document.head){return Z("link",q)}function Z(q,X=n.$aR.document.head){const te=document.createElement(q);return X.appendChild(te),te}let ne=null;function pe(){return ne||(ne=Ce()),ne}function ye(q){return q?.sheet?.rules?q.sheet.rules:q?.sheet?.cssRules?q.sheet.cssRules:[]}function Re(q,X,te=pe()){if(!(!te||!X)){te.sheet?.insertRule(`${q} {${X}}`,0);for(const de of Ie.get(te)??[])Re(q,X,de)}}function ze(q,X=pe()){if(!X)return;const te=ye(X),de=[];for(let Ae=0;Ae<te.length;Ae++){const Ke=te[Ae];We(Ke)&&Ke.selectorText.indexOf(q)!==-1&&de.push(Ae)}for(let Ae=de.length-1;Ae>=0;Ae--)X.sheet?.deleteRule(de[Ae]);for(const Ae of Ie.get(X)??[])ze(q,Ae)}function We(q){return typeof q.selectorText=="string"}function et(q){return q instanceof MouseEvent||q instanceof(0,t.getWindow)(q).MouseEvent}function it(q){return q instanceof KeyboardEvent||q instanceof(0,t.getWindow)(q).KeyboardEvent}function st(q){return q instanceof PointerEvent||q instanceof(0,t.getWindow)(q).PointerEvent}function Qe(q){return q instanceof DragEvent||q instanceof(0,t.getWindow)(q).DragEvent}t.$zS={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$nR?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$nR?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$nR?"webkitAnimationIteration":"animationiteration"};function rt(q){const X=q;return!!(X&&typeof X.preventDefault=="function"&&typeof X.stopPropagation=="function")}t.$BS={stop:(q,X)=>(q.preventDefault(),X&&q.stopPropagation(),q)};function tt(q){const X=[];for(let te=0;q&&q.nodeType===q.ELEMENT_NODE;te++)X[te]=q.scrollTop,q=q.parentNode;return X}function mt(q,X){for(let te=0;q&&q.nodeType===q.ELEMENT_NODE;te++)q.scrollTop!==X[te]&&(q.scrollTop=X[te]),q=q.parentNode}class gt extends p.$Uc{static m(X){if(X instanceof HTMLElement){const te=I(X),de=te?te.activeElement:X.ownerDocument.activeElement;return x(de,X)}else{const te=X;return x(te.document.activeElement,te.document)}}constructor(X){super(),this.f=this.B(new m.$be),this.onDidFocus=this.f.event,this.g=this.B(new m.$be),this.onDidBlur=this.g.event;let te=gt.m(X),de=!1;const Ae=()=>{de=!1,te||(te=!0,this.f.fire())},Ke=()=>{te&&(de=!0,(X instanceof HTMLElement?(0,t.getWindow)(X):X).setTimeout(()=>{de&&(de=!1,te=!1,this.g.fire())},0))};this.j=()=>{gt.m(X)!==te&&(te?Ke():Ae())},this.B(y(X,t.$zS.FOCUS,Ae,!0)),this.B(y(X,t.$zS.BLUR,Ke,!0)),X instanceof HTMLElement&&(this.B(y(X,t.$zS.FOCUS_IN,()=>this.j())),this.B(y(X,t.$zS.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function At(q){return new gt(q)}function kt(q,X){return q.after(X),X}function Tt(q,...X){if(q.append(...X),X.length===1&&typeof X[0]!="string")return X[0]}function Be(q,X){return q.insertBefore(X,q.firstChild),X}function ce(q,...X){q.innerText="",Tt(q,...X)}const Fe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var je;(function(q){q.HTML="http://www.w3.org/1999/xhtml",q.SVG="http://www.w3.org/2000/svg"})(je||(t.Namespace=je={}));function Ge(q,X,te,...de){const Ae=Fe.exec(X);if(!Ae)throw new Error("Bad use of emmet");const Ke=Ae[1]||"div";let Pe;return q!==je.HTML?Pe=document.createElementNS(q,Ke):Pe=document.createElement(Ke),Ae[3]&&(Pe.id=Ae[3]),Ae[4]&&(Pe.className=Ae[4].replace(/\./g," ").trim()),te&&Object.entries(te).forEach(([Ve,qe])=>{typeof qe>"u"||(/^on\w+$/.test(Ve)?Pe[Ve]=qe:Ve==="selected"?qe&&Pe.setAttribute(Ve,"true"):Pe.setAttribute(Ve,qe))}),Pe.append(...de),Pe}function nt(q,X,...te){return Ge(je.HTML,q,X,...te)}nt.SVG=function(q,X,...te){return Ge(je.SVG,q,X,...te)};function lt(q,X){const te=[];return q.forEach((de,Ae)=>{Ae>0&&(X instanceof Node?te.push(X.cloneNode()):te.push(document.createTextNode(X))),te.push(de)}),te}function Ze(q,...X){q?ut(...X):$t(...X)}function ut(...q){for(const X of q)X.style.display="",X.removeAttribute("aria-hidden")}function $t(...q){for(const X of q)X.style.display="none",X.setAttribute("aria-hidden","true")}function Ct(q,X){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q instanceof HTMLElement&&q.hasAttribute(X))return q;q=q.parentNode}return null}function Ut(q){!q||!q.hasAttribute("tabIndex")||(q.ownerDocument.activeElement===q&&Ct(q.parentElement,"tabIndex")?.focus(),q.removeAttribute("tabindex"))}function Si(q){return X=>{X.preventDefault(),X.stopPropagation(),q(X)}}function Ai(q){return new Promise(X=>{if(q.document.readyState==="complete"||q.document&&q.document.body!==null)X(void 0);else{const de=()=>{q.window.removeEventListener("DOMContentLoaded",de,!1),X()};q.window.addEventListener("DOMContentLoaded",de,!1)}})}function ki(q,X){const te=q.devicePixelRatio*X;return Math.max(1,Math.floor(te))/q.devicePixelRatio}function Ti(q){n.$aR.open(q,"_blank","noopener")}const Zt=780,Jt=640;function Ci(q){const X=Math.floor(n.$aR.screenLeft+n.$aR.innerWidth/2-Zt/2),te=Math.floor(n.$aR.screenTop+n.$aR.innerHeight/2-Jt/2);n.$aR.open(q,"_blank",`width=${Zt},height=${Jt},top=${te},left=${X}`)}function Fi(q,X=!0){const te=n.$aR.open();return te?(X&&(te.opener=null),te.location.href=q,!0):!1}function Ni(q,X){const te=()=>{X(),de=(0,t.$QR)(q,te)};let de=(0,t.$QR)(q,te);return(0,p.$Sc)(()=>de.dispose())}j.$Dg.setPreferredWebSchema(/^https:/.test(n.$aR.location.href)?"https":"http");function Ri(q){return q?`url('${j.$Kg.uriToBrowserUri(q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Ii(q){return`'${q.replace(/'/g,"%27")}'`}function Qt(q,X){if(q!==void 0){const te=q.match(/^\s*var\((.+)\)$/);if(te){const de=te[1].split(",",2);return de.length===2&&(X=Qt(de[1].trim(),X)),`var(${de[0]}, ${X})`}return q}return X}function Li(q,X){let te;if(f.URI.isUri(q))te=q.toString(!0);else{const Ke=new Blob([q]);te=URL.createObjectURL(Ke),setTimeout(()=>URL.revokeObjectURL(te))}const de=fe(),Ae=document.createElement("a");de.document.body.appendChild(Ae),Ae.download=X,Ae.href=te,Ae.click(),setTimeout(()=>de.document.body.removeChild(Ae))}function Mi(){return new Promise(q=>{const X=fe(),te=document.createElement("input");X.document.body.appendChild(te),te.type="file",te.multiple=!0,m.Event.once(m.Event.fromDOMEventEmitter(te,"input"))(()=>{q(te.files??void 0)}),te.click(),setTimeout(()=>X.document.body.removeChild(te))})}var yt;(function(q){q[q.DOCUMENT=1]="DOCUMENT",q[q.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function ji(q){return q.document.fullscreenElement||q.document.webkitFullscreenElement||q.document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:q.innerHeight===q.screen.height?{mode:yt.BROWSER,guess:!1}:(c.$j||c.$k)&&q.outerHeight===q.screen.height&&q.outerWidth===q.screen.width?{mode:yt.BROWSER,guess:!0}:null}function _t(q,X=!1){const te=document.createElement("a");return b.addHook("afterSanitizeAttributes",de=>{for(const Ae of["href","src"])if(de.hasAttribute(Ae)){const Ke=de.getAttribute(Ae);if(Ae==="href"&&Ke.startsWith("#"))continue;if(te.href=Ke,!q.includes(te.protocol.replace(/:$/,""))){if(X&&Ae==="src"&&te.href.startsWith("data:"))continue;de.removeAttribute(Ae)}}}),(0,p.$Sc)(()=>{b.removeHook("afterSanitizeAttributes")})}const Oi=[j.Schemas.http,j.Schemas.https,j.Schemas.command];t.$4S=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Pi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(q,X){const te=_t(Oi);try{const de=b.sanitize(X,Pi);q.innerHTML=de}finally{te.dispose()}}function Ki(q){const X=new Uint16Array(q.length);for(let Ae=0;Ae<X.length;Ae++)X[Ae]=q.charCodeAt(Ae);let te="";const de=new Uint8Array(X.buffer);for(let Ae=0;Ae<de.length;Ae++)te+=String.fromCharCode(de[Ae]);return te}function zi(q){return btoa(Ki(q))}class pt extends m.$be{constructor(){super(),this.o=new p.$Tc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(m.Event.runAndSubscribe(t.onDidRegisterWindow,({window:X,disposables:te})=>this.C(X,te),{window:n.$aR,disposables:this.o}))}C(X,te){te.add(y(X,"keydown",de=>{if(de.defaultPrevented)return;const Ae=new O.$DR(de);if(!(Ae.keyCode===6&&de.repeat)){if(de.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(de.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(de.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(de.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Ae.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyPressed&&(this.A.event=de,this.fire(this.A))}},!0)),te.add(y(X,"keyup",de=>{de.defaultPrevented||(!de.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!de.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!de.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!de.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyReleased&&(this.A.event=de,this.fire(this.A)))},!0)),te.add(y(X.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(y(X.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(y(X.document.body,"mousemove",de=>{de.buttons&&(this.A.lastKeyPressed=void 0)},!0)),te.add(y(X,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}t.$7S=pt;function xi(q){const X=document.cookie.match("(^|[^;]+)\\s*"+q+"\\s*=\\s*([^;]+)");return X?X.pop():void 0}class Hi extends p.$Uc{constructor(X,te){super(),this.j=X,this.m=te,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(y(this.j,t.$zS.DRAG_START,X=>{this.m.onDragStart?.(X)})),this.m.onDrag&&this.B(y(this.j,t.$zS.DRAG,X=>{this.m.onDrag?.(X)})),this.B(y(this.j,t.$zS.DRAG_ENTER,X=>{this.f++,this.g=X.timeStamp,this.m.onDragEnter?.(X)})),this.B(y(this.j,t.$zS.DRAG_OVER,X=>{X.preventDefault(),this.m.onDragOver?.(X,X.timeStamp-this.g)})),this.B(y(this.j,t.$zS.DRAG_LEAVE,X=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(X))})),this.B(y(this.j,t.$zS.DRAG_END,X=>{this.f=0,this.g=0,this.m.onDragEnd?.(X)})),this.B(y(this.j,t.$zS.DROP,X=>{this.f=0,this.g=0,this.m.onDrop?.(X)}))}}t.$9S=Hi;const Wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Vi(q,...X){let te,de;Array.isArray(X[0])?(te={},de=X[0]):(te=X[0]||{},de=X[1]);const Ae=Wi.exec(q);if(!Ae||!Ae.groups)throw new Error("Bad use of h");const Ke=Ae.groups.tag||"div",Pe=document.createElement(Ke);Ae.groups.id&&(Pe.id=Ae.groups.id);const Ve=[];if(Ae.groups.class)for(const Ye of Ae.groups.class.split("."))Ye!==""&&Ve.push(Ye);if(te.className!==void 0)for(const Ye of te.className.split("."))Ye!==""&&Ve.push(Ye);Ve.length>0&&(Pe.className=Ve.join(" "));const qe={};if(Ae.groups.name&&(qe[Ae.groups.name]=Pe),de)for(const Ye of de)Ye instanceof HTMLElement?Pe.appendChild(Ye):typeof Ye=="string"?Pe.append(Ye):"root"in Ye&&(Object.assign(qe,Ye),Pe.appendChild(Ye.root));for(const[Ye,at]of Object.entries(te))if(Ye!=="className")if(Ye==="style")for(const[Ft,Pt]of Object.entries(at))Pe.style.setProperty(ei(Ft),typeof Pt=="number"?Pt+"px":""+Pt);else Ye==="tabIndex"?Pe.tabIndex=at:Pe.setAttribute(ei(Ye),at.toString());return qe.root=Pe,qe}function ei(q){return q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(q,X,te){for(const{name:de,value:Ae}of q.attributes)(!te||te.includes(de))&&X.setAttribute(de,Ae)}function qi(q,X,te){const de=q.getAttribute(te);de?X.setAttribute(te,de):X.removeAttribute(te)}function Gi(q,X,te){ti(q,X,te);const de=new p.$Tc;return de.add(t.$qS.observe(q,de,{attributes:!0,attributeFilter:te})(Ae=>{for(const Ke of Ae)Ke.type==="attributes"&&Ke.attributeName&&qi(q,X,Ke.attributeName)})),de}}),define(be[65],$e([1,0,4,2,128]),function(se,t,i,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bT=t.$aT=void 0,t.$cT=S;class H extends T.$Uc{constructor(m,b){super(),this.B((0,i.$GR)(m,"dragover",p=>{p.preventDefault(),this.a||(this.a=setTimeout(()=>{b(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(p=>{this.B((0,i.$GR)(m,p,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$aT=H,t.$bT={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:O.$Hs.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function S(A,m,b,p,j){const c=document.createElement("div");if(c.className=b,c.textContent=m,j&&(c.style.color=j),p&&(c.style.background=p),A.dataTransfer){const f=(0,i.getWindow)(A).document;f.body.appendChild(c),A.dataTransfer.setDragImage(c,-10,-10),setTimeout(()=>f.body.removeChild(c),0)}}}),define(be[66],$e([1,0,4]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FT=T,t.$GT=O,t.$HT=H;function T(c,f={}){const e=H(f);return e.textContent=c,e}function O(c,f={}){const e=H(f);return m(e,b(c,!!f.renderCodeSegments),f.actionHandler,f.renderCodeSegments),e}function H(c){const f=c.inline?"span":"div",e=document.createElement(f);return c.className&&(e.className=c.className),e}class S{constructor(f){this.b=f,this.c=0}eos(){return this.c>=this.b.length}next(){const f=this.peek();return this.advance(),f}peek(){return this.b[this.c]}advance(){this.c++}}var A;(function(c){c[c.Invalid=0]="Invalid",c[c.Root=1]="Root",c[c.Text=2]="Text",c[c.Bold=3]="Bold",c[c.Italics=4]="Italics",c[c.Action=5]="Action",c[c.ActionClose=6]="ActionClose",c[c.Code=7]="Code",c[c.NewLine=8]="NewLine"})(A||(A={}));function m(c,f,e,n){let r;if(f.type===2)r=document.createTextNode(f.content||"");else if(f.type===3)r=document.createElement("b");else if(f.type===4)r=document.createElement("i");else if(f.type===7&&n)r=document.createElement("code");else if(f.type===5&&e){const h=document.createElement("a");e.disposables.add(i.$HR(h,"click",g=>{e.callback(String(f.index),g)})),r=h}else f.type===8?r=document.createElement("br"):f.type===1&&(r=c);r&&c!==r&&c.appendChild(r),r&&Array.isArray(f.children)&&f.children.forEach(h=>{m(r,h,e,n)})}function b(c,f){const e={type:1,children:[]};let n=0,r=e;const h=[],g=new S(c);for(;!g.eos();){let y=g.next();const o=y==="\\"&&j(g.peek(),f)!==0;if(o&&(y=g.next()),!o&&p(y,f)&&y===g.peek()){g.advance(),r.type===2&&(r=h.pop());const d=j(y,f);if(r.type===d||r.type===5&&d===6)r=h.pop();else{const a={type:d,children:[]};d===5&&(a.index=n,n++),r.children.push(a),h.push(r),r=a}}else if(y===`
`)r.type===2&&(r=h.pop()),r.children.push({type:8});else if(r.type!==2){const d={type:2,content:y};r.children.push(d),h.push(r),r=d}else r.content+=y}return r.type===2&&(r=h.pop()),h.length,e}function p(c,f){return j(c,f)!==0}function j(c,f){switch(c){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return f?7:0;default:return 0}}}),define(be[67],$e([1,0,4,2]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gT=void 0;class O{constructor(){this.a=new T.$Tc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(S,A){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const m=this.c;this.c=null,S&&m&&m(A)}isMonitoring(){return!!this.b}startMonitoring(S,A,m,b,p){this.isMonitoring()&&this.stopMonitoring(!1),this.b=b,this.c=p;let j=S;try{S.setPointerCapture(A),this.a.add((0,T.$Sc)(()=>{try{S.releasePointerCapture(A)}catch{}}))}catch{j=i.getWindow(S)}this.a.add(i.$GR(j,i.$zS.POINTER_MOVE,c=>{if(c.buttons!==m){this.stopMonitoring(!0);return}c.preventDefault(),this.b(c)})),this.a.add(i.$GR(j,i.$zS.POINTER_UP,c=>this.stopMonitoring(!0)))}}t.$gT=O});var Je=this&&this.__decorate||function(se,t,i,T){var O=arguments.length,H=O<3?t:T===null?T=Object.getOwnPropertyDescriptor(t,i):T,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(se,t,i,T);else for(var A=se.length-1;A>=0;A--)(S=se[A])&&(H=(O<3?S(H):O>3?S(t,i,H):S(t,i))||H);return O>3&&H&&Object.defineProperty(t,i,H),H};define(be[28],$e([1,0,4,22,8,31,3,2,55]),function(se,t,i,T,O,H,S,A,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dT=t.EventType=void 0;var b;(function(j){j.Tap="-monaco-gesturetap",j.Change="-monaco-gesturechange",j.Start="-monaco-gesturestart",j.End="-monaco-gesturesend",j.Contextmenu="-monaco-gesturecontextmenu"})(b||(t.EventType=b={}));class p extends A.$Uc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new m.$5c,this.m=new m.$5c,this.r={},this.n=null,this.s=0,this.B(S.Event.runAndSubscribe(i.onDidRegisterWindow,({window:c,disposables:f})=>{f.add(i.$GR(c.document,"touchstart",e=>this.w(e),{passive:!1})),f.add(i.$GR(c.document,"touchend",e=>this.z(c,e))),f.add(i.$GR(c.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:T.$aR,disposables:this.q}))}static addTarget(c){if(!p.isTouchDevice())return A.$Uc.None;p.f||(p.f=(0,A.$Nc)(new p));const f=p.f.j.push(c);return(0,A.$Sc)(f)}static ignoreTarget(c){if(!p.isTouchDevice())return A.$Uc.None;p.f||(p.f=(0,A.$Nc)(new p));const f=p.f.m.push(c);return(0,A.$Sc)(f)}static isTouchDevice(){return"ontouchstart"in T.$aR||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w(c){const f=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,n=c.targetTouches.length;e<n;e++){const r=c.targetTouches.item(e);this.r[r.identifier]={id:r.identifier,initialTarget:r.target,initialTimeStamp:f,initialPageX:r.pageX,initialPageY:r.pageY,rollingTimestamps:[f],rollingPageX:[r.pageX],rollingPageY:[r.pageY]};const h=this.C(b.Start,r.target);h.pageX=r.pageX,h.pageY=r.pageY,this.D(h)}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}z(c,f){const e=Date.now(),n=Object.keys(this.r).length;for(let r=0,h=f.changedTouches.length;r<h;r++){const g=f.changedTouches.item(r);if(!this.r.hasOwnProperty(String(g.identifier))){console.warn("move of an UNKNOWN touch",g);continue}const y=this.r[g.identifier],o=Date.now()-y.initialTimeStamp;if(o<p.g&&Math.abs(y.initialPageX-O.$sb(y.rollingPageX))<30&&Math.abs(y.initialPageY-O.$sb(y.rollingPageY))<30){const d=this.C(b.Tap,y.initialTarget);d.pageX=O.$sb(y.rollingPageX),d.pageY=O.$sb(y.rollingPageY),this.D(d)}else if(o>=p.g&&Math.abs(y.initialPageX-O.$sb(y.rollingPageX))<30&&Math.abs(y.initialPageY-O.$sb(y.rollingPageY))<30){const d=this.C(b.Contextmenu,y.initialTarget);d.pageX=O.$sb(y.rollingPageX),d.pageY=O.$sb(y.rollingPageY),this.D(d)}else if(n===1){const d=O.$sb(y.rollingPageX),a=O.$sb(y.rollingPageY),k=O.$sb(y.rollingTimestamps)-y.rollingTimestamps[0],N=d-y.rollingPageX[0],R=a-y.rollingPageY[0],L=[...this.j].filter(P=>y.initialTarget instanceof Node&&P.contains(y.initialTarget));this.F(c,L,e,Math.abs(N)/k,N>0?1:-1,d,Math.abs(R)/k,R>0?1:-1,a)}this.D(this.C(b.End,y.initialTarget)),delete this.r[g.identifier]}this.h&&(f.preventDefault(),f.stopPropagation(),this.h=!1)}C(c,f){const e=document.createEvent("CustomEvent");return e.initEvent(c,!1,!0),e.initialTarget=f,e.tapCount=0,e}D(c){if(c.type===b.Tap){const f=new Date().getTime();let e=0;f-this.s>p.u?e=1:e=2,this.s=f,c.tapCount=e}else(c.type===b.Change||c.type===b.Contextmenu)&&(this.s=0);if(c.initialTarget instanceof Node){for(const e of this.m)if(e.contains(c.initialTarget))return;const f=[];for(const e of this.j)if(e.contains(c.initialTarget)){let n=0,r=c.initialTarget;for(;r&&r!==e;)n++,r=r.parentElement;f.push([n,e])}f.sort((e,n)=>e[0]-n[0]);for(const[e,n]of f)n.dispatchEvent(c),this.h=!0}}F(c,f,e,n,r,h,g,y,o){this.n=i.$QR(c,()=>{const d=Date.now(),a=d-e;let k=0,N=0,R=!0;n+=p.c*a,g+=p.c*a,n>0&&(R=!1,k=r*n*a),g>0&&(R=!1,N=y*g*a);const L=this.C(b.Change);L.translationX=k,L.translationY=N,f.forEach(P=>P.dispatchEvent(L)),R||this.F(c,f,d,n,r,h+k,g,y,o+N)})}G(c){const f=Date.now();for(let e=0,n=c.changedTouches.length;e<n;e++){const r=c.changedTouches.item(e);if(!this.r.hasOwnProperty(String(r.identifier))){console.warn("end of an UNKNOWN touch",r);continue}const h=this.r[r.identifier],g=this.C(b.Change,h.initialTarget);g.translationX=r.pageX-O.$sb(h.rollingPageX),g.translationY=r.pageY-O.$sb(h.rollingPageY),g.pageX=r.pageX,g.pageY=r.pageY,this.D(g),h.rollingPageX.length>3&&(h.rollingPageX.shift(),h.rollingPageY.shift(),h.rollingTimestamps.shift()),h.rollingPageX.push(r.pageX),h.rollingPageY.push(r.pageY),h.rollingTimestamps.push(f)}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}}t.$dT=p,Je([H.$Uh],p,"isTouchDevice",null)}),define(be[68],$e([1,0,4,104]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JT=b,t.$KT=p,t.$LT=j;const T=2e4;let O,H,S,A,m;function b(f){O=document.createElement("div"),O.className="monaco-aria-container";const e=()=>{const r=document.createElement("div");return r.className="monaco-alert",r.setAttribute("role","alert"),r.setAttribute("aria-atomic","true"),O.appendChild(r),r};H=e(),S=e();const n=()=>{const r=document.createElement("div");return r.className="monaco-status",r.setAttribute("aria-live","polite"),r.setAttribute("aria-atomic","true"),O.appendChild(r),r};A=n(),m=n(),f.appendChild(O)}function p(f){O&&(H.textContent!==f?(i.$FR(S),c(H,f)):(i.$FR(H),c(S,f)))}function j(f){O&&(A.textContent!==f?(i.$FR(m),c(A,f)):(i.$FR(A),c(m,f)))}function c(f,e){i.$FR(f),e.length>T&&(e=e.substr(0,T)),f.textContent=e,f.style.visibility="hidden",f.style.visibility="visible"}}),define(be[130],$e([1,0,4,19]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cU=H,t.$dU=S;const O=new RegExp(`(\\\\)?\\$\\((${T.ThemeIcon.iconNameExpression}(?:${T.ThemeIcon.iconModifierExpression})?)\\)`,"g");function H(A){const m=new Array;let b,p=0,j=0;for(;(b=O.exec(A))!==null;){j=b.index||0,p<j&&m.push(A.substring(p,j)),p=(b.index||0)+b[0].length;const[,c,f]=b;m.push(c?`$(${f})`:S({id:f}))}return p<A.length&&m.push(A.substring(p)),m}function S(A){const m=i.$("span");return m.classList.add(...T.ThemeIcon.asClassNameArray(A)),m}}),define(be[131],$e([1,0,4]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RT=void 0;function T(H){try{H.parentElement?.removeChild(H)}catch{}}class O{constructor(S){this.d=S,this.a=new Map,this.b=new Set,this.c=!1}alloc(S){let A=this.h(S).pop(),m=!1;if(A)m=this.b.has(A.domNode),m&&this.b.delete(A.domNode);else{const b=(0,i.$)(".monaco-list-row"),j=this.i(S).renderTemplate(b);A={domNode:b,templateId:S,templateData:j}}return{row:A,isReusingConnectedDomNode:m}}release(S){S&&this.f(S)}transact(S){if(this.c)throw new Error("Already in transaction");this.c=!0;try{S()}finally{for(const A of this.b)this.g(A);this.b.clear(),this.c=!1}}f(S){const{domNode:A,templateId:m}=S;A&&(this.c?this.b.add(A):this.g(A)),this.h(m).push(S)}g(S){S.classList.remove("scrolling"),T(S)}h(S){let A=this.a.get(S);return A||(A=[],this.a.set(S,A)),A}dispose(){this.a.forEach((S,A)=>{for(const m of S)this.i(A).disposeTemplate(m.templateData),m.templateData=null}),this.a.clear(),this.b.clear()}i(S){const A=this.d.get(S);if(!A)throw new Error(`No renderer found for ${S}`);return A}}t.$RT=O}),define(be[132],$e([1,0,11,2]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lT=void 0;class O extends T.$Uc{constructor(S,A,m){super(),this.a=S,this.b=A,this.c=m,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$Ah)}setVisibility(S){this.a!==S&&(this.a=S,this.s())}setShouldBeVisible(S){this.g=S,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const S=this.r();this.h!==S&&(this.h=S,this.ensureVisibility())}setIsNeeded(S){this.j!==S&&(this.j=S,this.ensureVisibility())}setDomNode(S){this.f=S,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(S){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(S?" fade":"")))}}t.$lT=O}),define(be[133],$e([1,0,4,28,8,3,2,5]),function(se,t,i,T,O,H,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mU=void 0;class m extends S.$Uc{constructor(p,j,c,f){super(),this.f=0,this.b=f||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.$be),this.h=c,this.j(),this.setOptions(p,j)}j(){this.B(T.$dT.addTarget(this.a)),[T.EventType.Tap].forEach(p=>{this.B(i.$GR(this.a,p,j=>{this.a.focus()}))}),this.B(i.$HR(this.a,"click",p=>{i.$BS.stop(p,!0)})),this.B(i.$HR(this.a,"change",p=>{this.a.title=p.target.value,this.g.fire({index:p.target.selectedIndex,selected:p.target.value})})),this.B(i.$HR(this.a,"keydown",p=>{let j=!1;A.$j?(p.keyCode===18||p.keyCode===16||p.keyCode===10)&&(j=!0):(p.keyCode===18&&p.altKey||p.keyCode===10||p.keyCode===3)&&(j=!0),j&&p.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(p,j){(!this.c||!O.$ub(this.c,p))&&(this.c=p,this.a.options.length=0,this.c.forEach((c,f)=>{this.a.add(this.m(c.text,f,c.isDisabled))})),j!==void 0&&this.select(j)}select(p){this.c.length===0?this.f=0:p>=0&&p<this.c.length?this.f=p:p>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(p){this.b.ariaLabel=p,this.a.setAttribute("aria-label",p)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(p){this.a.tabIndex=p?0:-1}render(p){p.classList.add("select-container"),p.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(p){this.h=p,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(p,j,c){const f=document.createElement("option");return f.value=p,f.text=p,f.disabled=!!c,f}}t.$mU=m}),define(be[69],$e([1,0,30,8,11,60,98,3,32]),function(se,t,i,T,O,H,S,A,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WV=void 0,t.$UV=b,t.$VV=p;function b(f){return typeof f=="object"&&"visibility"in f&&"data"in f}function p(f){switch(f){case!0:return 1;case!1:return 0;default:return f}}function j(f){return typeof f.collapsible=="boolean"}class c{constructor(e,n,r,h={}){this.p=e,this.q=n,this.rootRef=[],this.d=new A.$je,this.f=new A.$be,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new A.$be,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new A.$be,this.onDidSplice=this.m.event,this.o=new O.$nh(H.$$d),this.h=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.j=h.allowNonCollapsibleParents??!1,this.k=h.filter,this.l=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.c={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,n,r=m.Iterable.empty(),h={}){if(e.length===0)throw new i.$SV(this.p,"Invalid tree location");h.diffIdentityProvider?this.s(h.diffIdentityProvider,e,n,r,h):this.t(e,n,r,h)}s(e,n,r,h=m.Iterable.empty(),g,y=g.diffDepth??0){const{parentNode:o}=this.H(n);if(!o.lastDiffIds)return this.t(n,r,h,g);const d=[...h],a=n[n.length-1],k=new S.$qt({getElements:()=>o.lastDiffIds},{getElements:()=>[...o.children.slice(0,a),...d,...o.children.slice(a+r)].map(E=>e.getId(E.element).toString())}).ComputeDiff(!1);if(k.quitEarly)return o.lastDiffIds=void 0,this.t(n,r,d,g);const N=n.slice(0,-1),R=(E,z,W)=>{if(y>0)for(let F=0;F<W;F++)E--,z--,this.s(e,[...N,E,0],Number.MAX_SAFE_INTEGER,d[z].children,g,y-1)};let L=Math.min(o.children.length,a+r),P=d.length;for(const E of k.changes.sort((z,W)=>W.originalStart-z.originalStart))R(L,P,L-(E.originalStart+E.originalLength)),L=E.originalStart,P=E.modifiedStart-a,this.t([...N,L],E.originalLength,m.Iterable.slice(d,P,P+E.modifiedLength),g);R(L,P,L)}t(e,n,r=m.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:g,diffIdentityProvider:y}){const{parentNode:o,listIndex:d,revealed:a,visible:k}=this.H(e),N=[],R=m.Iterable.map(r,G=>this.x(G,o,o.visible?1:0,a,N,h)),L=e[e.length-1];let P=0;for(let G=L;G>=0&&G<o.children.length;G--){const V=o.children[G];if(V.visible){P=V.visibleChildIndex;break}}const E=[];let z=0,W=0;for(const G of R)E.push(G),W+=G.renderNodeCount,G.visible&&(G.visibleChildIndex=P+z++);const F=(0,T.$6b)(o.children,L,n,E);y?o.lastDiffIds?(0,T.$6b)(o.lastDiffIds,L,n,E.map(G=>y.getId(G.element).toString())):o.lastDiffIds=o.children.map(G=>y.getId(G.element).toString()):o.lastDiffIds=void 0;let K=0;for(const G of F)G.visible&&K++;if(K!==0)for(let G=L+E.length;G<o.children.length;G++){const V=o.children[G];V.visible&&(V.visibleChildIndex-=K)}if(o.visibleChildrenCount+=z-K,a&&k){const G=F.reduce((V,ae)=>V+(ae.visible?ae.renderNodeCount:0),0);this.C(o,W-G),this.q.splice(d,G,N)}if(F.length>0&&g){const G=V=>{g(V),V.children.forEach(G)};F.forEach(G)}this.m.fire({insertedNodes:E,deletedNodes:F});let B=o;for(;B;){if(B.visibility===2){this.o.trigger(()=>this.refilter());break}B=B.parent}}rerender(e){if(e.length===0)throw new i.$SV(this.p,"Invalid tree location");const{node:n,listIndex:r,revealed:h}=this.G(e);n.visible&&h&&this.q.splice(r,1,[n])}updateElementHeight(e,n){if(e.length===0)throw new i.$SV(this.p,"Invalid tree location");const{listIndex:r}=this.G(e);this.q.updateElementHeight(r,n)}has(e){return this.E(e)}getListIndex(e){const{listIndex:n,visible:r,revealed:h}=this.G(e);return r&&h?n:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,n){const r=this.F(e);typeof n>"u"&&(n=!r.collapsible);const h={collapsible:n};return this.d.bufferEvents(()=>this.u(e,h))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,n,r){const h=this.F(e);typeof n>"u"&&(n=!h.collapsed);const g={collapsed:n,recursive:r||!1};return this.d.bufferEvents(()=>this.u(e,g))}u(e,n){const{node:r,listIndex:h,revealed:g}=this.G(e),y=this.v(r,h,g,n);if(r!==this.c&&this.l&&y&&!j(n)&&r.collapsible&&!r.collapsed&&!n.recursive){let o=-1;for(let d=0;d<r.children.length;d++)if(r.children[d].visible)if(o>-1){o=-1;break}else o=d;o>-1&&this.u([...e,o],n)}return y}v(e,n,r,h){const g=this.w(e,h,!1);if(!r||!e.visible||!g)return g;const y=e.renderNodeCount,o=this.y(e),d=y-(n===-1?0:1);return this.q.splice(n+1,d,o.slice(1)),g}w(e,n,r){let h;if(e===this.c?h=!1:(j(n)?(h=e.collapsible!==n.collapsible,e.collapsible=n.collapsible):e.collapsible?(h=e.collapsed!==n.collapsed,e.collapsed=n.collapsed):h=!1,h&&this.f.fire({node:e,deep:r})),!j(n)&&n.recursive)for(const g of e.children)h=this.w(g,n,!0)||h;return h}expandTo(e){this.d.bufferEvents(()=>{let n=this.F(e);for(;n.parent;)n=n.parent,e=e.slice(0,e.length-1),n.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,n=this.A(this.c);this.q.splice(0,e,n),this.o.cancel()}x(e,n,r,h,g,y){const o={parent:n,element:e.element,children:[],depth:n.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},d=this.D(o,r);o.visibility=d,h&&g.push(o);const a=e.children||m.Iterable.empty(),k=h&&d!==0&&!o.collapsed;let N=0,R=1;for(const L of a){const P=this.x(L,o,d,k,g,y);o.children.push(P),R+=P.renderNodeCount,P.visible&&(P.visibleChildIndex=N++)}return this.j||(o.collapsible=o.collapsible||o.children.length>0),o.visibleChildrenCount=N,o.visible=d===2?N>0:d===1,o.visible?o.collapsed||(o.renderNodeCount=R):(o.renderNodeCount=0,h&&g.pop()),y?.(o),o}y(e){const n=e.renderNodeCount,r=[];return this.z(e,r),this.C(e.parent,r.length-n),r}z(e,n){if(e.visible===!1)return 0;if(n.push(e),e.renderNodeCount=1,!e.collapsed)for(const r of e.children)e.renderNodeCount+=this.z(r,n);return this.g.fire(e),e.renderNodeCount}A(e){const n=e.renderNodeCount,r=[];return this.B(e,e.visible?1:0,r),this.C(e.parent,r.length-n),r}B(e,n,r,h=!0){let g;if(e!==this.c){if(g=this.D(e,n),g===0)return e.visible=!1,e.renderNodeCount=0,!1;h&&r.push(e)}const y=r.length;e.renderNodeCount=e===this.c?0:1;let o=!1;if(!e.collapsed||g!==0){let d=0;for(const a of e.children)o=this.B(a,g,r,h&&!e.collapsed)||o,a.visible&&(a.visibleChildIndex=d++);e.visibleChildrenCount=d}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=g===2?o:g===1,e.visibility=g),e.visible?e.collapsed||(e.renderNodeCount+=r.length-y):(e.renderNodeCount=0,h&&r.pop()),this.g.fire(e),e.visible}C(e,n){if(n!==0)for(;e;)e.renderNodeCount+=n,this.g.fire(e),e=e.parent}D(e,n){const r=this.k?this.k.filter(e.element,n):1;return typeof r=="boolean"?(e.filterData=void 0,r?1:0):b(r)?(e.filterData=r.data,p(r.visibility)):(e.filterData=void 0,p(r))}E(e,n=this.c){if(!e||e.length===0)return!0;const[r,...h]=e;return r<0||r>n.children.length?!1:this.E(h,n.children[r])}F(e,n=this.c){if(!e||e.length===0)return n;const[r,...h]=e;if(r<0||r>n.children.length)throw new i.$SV(this.p,"Invalid tree location");return this.F(h,n.children[r])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:n,listIndex:r,revealed:h,visible:g}=this.H(e),y=e[e.length-1];if(y<0||y>n.children.length)throw new i.$SV(this.p,"Invalid tree location");const o=n.children[y];return{node:o,listIndex:r,revealed:h,visible:g&&o.visible}}H(e,n=this.c,r=0,h=!0,g=!0){const[y,...o]=e;if(y<0||y>n.children.length)throw new i.$SV(this.p,"Invalid tree location");for(let d=0;d<y;d++)r+=n.children[d].renderNodeCount;return h=h&&!n.collapsed,g=g&&n.visible,o.length===0?{parentNode:n,listIndex:r,revealed:h,visible:g}:this.H(o,n.children[y],r+1,h,g)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const n=[];let r=e;for(;r.parent;)n.push(r.parent.children.indexOf(r)),r=r.parent;return n.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,T.$tb)(e)[0]}getFirstElementChild(e){const n=this.F(e);if(n.children.length!==0)return n.children[0].element}getLastElementAncestor(e=[]){const n=this.F(e);if(n.children.length!==0)return this.I(n)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$WV=c}),define(be[134],$e([1,0,69,30,32]),function(se,t,i,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4V=void 0;class H{get size(){return this.d.size}constructor(A,m,b={}){this.k=A,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$WV(A,m,null,b),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,b.sorter&&(this.j={compare(p,j){return b.sorter.compare(p.element,j.element)}}),this.h=b.identityProvider}setChildren(A,m=O.Iterable.empty(),b={}){const p=this.o(A);this.l(p,this.m(m),b)}l(A,m=O.Iterable.empty(),b){const p=new Set,j=new Set,c=e=>{if(e.element===null)return;const n=e;if(p.add(n.element),this.d.set(n.element,n),this.h){const r=this.h.getId(n.element).toString();j.add(r),this.f.set(r,n)}b.onDidCreateNode?.(n)},f=e=>{if(e.element===null)return;const n=e;if(p.has(n.element)||this.d.delete(n.element),this.h){const r=this.h.getId(n.element).toString();j.has(r)||this.f.delete(r)}b.onDidDeleteNode?.(n)};this.c.splice([...A,0],Number.MAX_VALUE,m,{...b,onDidCreateNode:c,onDidDeleteNode:f})}m(A=O.Iterable.empty()){return this.j&&(A=[...A].sort(this.j.compare.bind(this.j))),O.Iterable.map(A,m=>{let b=this.d.get(m.element);if(!b&&this.h){const c=this.h.getId(m.element).toString();b=this.f.get(c)}if(!b){let c;return typeof m.collapsed>"u"?c=void 0:m.collapsed===T.ObjectTreeElementCollapseState.Collapsed||m.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed?c=!0:m.collapsed===T.ObjectTreeElementCollapseState.Expanded||m.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?c=!1:c=!!m.collapsed,{...m,children:this.m(m.children),collapsed:c}}const p=typeof m.collapsible=="boolean"?m.collapsible:b.collapsible;let j;return typeof m.collapsed>"u"||m.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed||m.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?j=b.collapsed:m.collapsed===T.ObjectTreeElementCollapseState.Collapsed?j=!0:m.collapsed===T.ObjectTreeElementCollapseState.Expanded?j=!1:j=!!m.collapsed,{...m,collapsible:p,collapsed:j,children:this.m(m.children)}})}rerender(A){const m=this.o(A);this.c.rerender(m)}updateElementHeight(A,m){const b=this.o(A);this.c.updateElementHeight(b,m)}resort(A=null,m=!0){if(!this.j)return;const b=this.o(A),p=this.c.getNode(b);this.l(b,this.n(p,m),{})}n(A,m,b=!0){let p=[...A.children];return(m||b)&&(p=p.sort(this.j.compare.bind(this.j))),O.Iterable.map(p,j=>({element:j.element,collapsible:j.collapsible,collapsed:j.collapsed,children:this.n(j,m,!1)}))}getFirstElementChild(A=null){const m=this.o(A);return this.c.getFirstElementChild(m)}getLastElementAncestor(A=null){const m=this.o(A);return this.c.getLastElementAncestor(m)}has(A){return this.d.has(A)}getListIndex(A){const m=this.o(A);return this.c.getListIndex(m)}getListRenderCount(A){const m=this.o(A);return this.c.getListRenderCount(m)}isCollapsible(A){const m=this.o(A);return this.c.isCollapsible(m)}setCollapsible(A,m){const b=this.o(A);return this.c.setCollapsible(b,m)}isCollapsed(A){const m=this.o(A);return this.c.isCollapsed(m)}setCollapsed(A,m,b){const p=this.o(A);return this.c.setCollapsed(p,m,b)}expandTo(A){const m=this.o(A);this.c.expandTo(m)}refilter(){this.c.refilter()}getNode(A=null){if(A===null)return this.c.getNode(this.c.rootRef);const m=this.d.get(A);if(!m)throw new T.$SV(this.k,`Tree element not found: ${A}`);return m}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new T.$SV(this.k,"Invalid getParentNodeLocation call");const m=this.d.get(A);if(!m)throw new T.$SV(this.k,`Tree element not found: ${A}`);const b=this.c.getNodeLocation(m),p=this.c.getParentNodeLocation(b);return this.c.getNode(p).element}o(A){if(A===null)return[];const m=this.d.get(A);if(!m)throw new T.$SV(this.k,`Tree element not found: ${A}`);return this.c.getNodeLocation(m)}}t.$4V=H}),define(be[21],$e([1,0,4,15,20,28,2]),function(se,t,i,T,O,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hT=void 0;class A extends S.$Uc{f(b,p){this.B(i.$GR(b,i.$zS.CLICK,j=>p(new O.$yR(i.getWindow(b),j))))}j(b,p){this.B(i.$GR(b,i.$zS.MOUSE_DOWN,j=>p(new O.$yR(i.getWindow(b),j))))}m(b,p){this.B(i.$GR(b,i.$zS.MOUSE_OVER,j=>p(new O.$yR(i.getWindow(b),j))))}u(b,p){this.B(i.$GR(b,i.$zS.MOUSE_LEAVE,j=>p(new O.$yR(i.getWindow(b),j))))}z(b,p){this.B(i.$GR(b,i.$zS.KEY_DOWN,j=>p(new T.$DR(j))))}C(b,p){this.B(i.$GR(b,i.$zS.KEY_UP,j=>p(new T.$DR(j))))}D(b,p){this.B(i.$GR(b,i.$zS.INPUT,p))}F(b,p){this.B(i.$GR(b,i.$zS.BLUR,p))}G(b,p){this.B(i.$GR(b,i.$zS.FOCUS,p))}H(b,p){this.B(i.$GR(b,i.$zS.CHANGE,p))}I(b){return H.$dT.ignoreTarget(b)}}t.$hT=A}),define(be[48],$e([1,0,67,21,11,19,4]),function(se,t,i,T,O,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jT=t.$iT=void 0,t.$iT=11;class A extends T.$hT{constructor(b){super(),this.a=b.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=b.bgWidth+"px",this.bgDomNode.style.height=b.bgHeight+"px",typeof b.top<"u"&&(this.bgDomNode.style.top="0px"),typeof b.left<"u"&&(this.bgDomNode.style.left="0px"),typeof b.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof b.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=b.className,this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(b.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$iT+"px",this.domNode.style.height=t.$iT+"px",typeof b.top<"u"&&(this.domNode.style.top=b.top+"px"),typeof b.left<"u"&&(this.domNode.style.left=b.left+"px"),typeof b.bottom<"u"&&(this.domNode.style.bottom=b.bottom+"px"),typeof b.right<"u"&&(this.domNode.style.right=b.right+"px"),this.g=this.B(new i.$gT),this.B(S.$HR(this.bgDomNode,S.$zS.POINTER_DOWN,p=>this.h(p))),this.B(S.$HR(this.domNode,S.$zS.POINTER_DOWN,p=>this.h(p))),this.b=this.B(new S.$SR),this.c=this.B(new O.$Ah)}h(b){if(!b.target||!(b.target instanceof Element))return;const p=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,S.getWindow(b))};this.a(),this.b.cancel(),this.c.cancelAndSet(p,200),this.g.startMonitoring(b.target,b.pointerId,b.buttons,j=>{},()=>{this.b.cancel(),this.c.cancel()}),b.preventDefault()}}t.$jT=A}),define(be[70],$e([1,0,4,51,67,48,132,21,5]),function(se,t,i,T,O,H,S,A,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mT=void 0;const b=140;class p extends A.$hT{constructor(c){super(),this.g=c.lazyRender,this.a=c.host,this.b=c.scrollable,this.c=c.scrollByPage,this.h=c.scrollbarState,this.n=this.B(new S.$lT(c.visibility,"visible scrollbar "+c.extraScrollbarClassName,"invisible scrollbar "+c.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new O.$gT),this.s=!0,this.domNode=(0,T.$fT)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$GR(this.domNode.domNode,i.$zS.POINTER_DOWN,f=>this.M(f)))}t(c){const f=this.B(new H.$jT(c));this.domNode.domNode.appendChild(f.bgDomNode),this.domNode.domNode.appendChild(f.domNode)}w(c,f,e,n){this.slider=(0,T.$fT)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(c),this.slider.setLeft(f),typeof e=="number"&&this.slider.setWidth(e),typeof n=="number"&&this.slider.setHeight(n),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$GR(this.slider.domNode,i.$zS.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this.O(r))})),this.f(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}y(c){return this.h.setVisibleSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(c){return this.h.setScrollSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(c){return this.h.setScrollPosition(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(c){c.target===this.domNode.domNode&&this.N(c)}delegatePointerDown(c){const f=this.domNode.domNode.getClientRects()[0].top,e=f+this.h.getSliderPosition(),n=f+this.h.getSliderPosition()+this.h.getSliderSize(),r=this.U(c);e<=r&&r<=n?c.button===0&&(c.preventDefault(),this.O(c)):this.N(c)}N(c){let f,e;if(c.target===this.domNode.domNode&&typeof c.offsetX=="number"&&typeof c.offsetY=="number")f=c.offsetX,e=c.offsetY;else{const r=i.$3R(this.domNode.domNode);f=c.pageX-r.left,e=c.pageY-r.top}const n=this.S(f,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(n):this.h.getDesiredScrollPositionFromOffset(n)),c.button===0&&(c.preventDefault(),this.O(c))}O(c){if(!c.target||!(c.target instanceof Element))return;const f=this.U(c),e=this.W(c),n=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(c.target,c.pointerId,c.buttons,r=>{const h=this.W(r),g=Math.abs(h-e);if(m.$i&&g>b){this.P(n.getScrollPosition());return}const o=this.U(r)-f;this.P(n.getDesiredScrollPositionFromDelta(o))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(c){const f={};this.writeScrollPosition(f,c),this.b.setScrollPositionNow(f)}updateScrollbarSize(c){this.X(c),this.h.setScrollbarSize(c),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$mT=p}),define(be[135],$e([1,0,20,70,48,52,18]),function(se,t,i,T,O,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nT=void 0;class A extends T.$mT{constructor(b,p,j){const c=b.getScrollDimensions(),f=b.getCurrentScrollPosition();if(super({lazyRender:p.lazyRender,host:j,scrollbarState:new H.$kT(p.horizontalHasArrows?p.arrowSize:0,p.horizontal===2?0:p.horizontalScrollbarSize,p.vertical===2?0:p.verticalScrollbarSize,c.width,c.scrollWidth,f.scrollLeft),visibility:p.horizontal,extraScrollbarClassName:"horizontal",scrollable:b,scrollByPage:p.scrollByPage}),p.horizontalHasArrows){const e=(p.arrowSize-O.$iT)/2,n=(p.horizontalScrollbarSize-O.$iT)/2;this.t({className:"scra",icon:S.$Pj.scrollbarButtonLeft,top:n,left:e,bottom:void 0,right:void 0,bgWidth:p.arrowSize,bgHeight:p.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$AR(null,1,0))}),this.t({className:"scra",icon:S.$Pj.scrollbarButtonRight,top:n,left:void 0,bottom:void 0,right:e,bgWidth:p.arrowSize,bgHeight:p.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$AR(null,-1,0))})}this.w(Math.floor((p.horizontalScrollbarSize-p.horizontalSliderSize)/2),0,void 0,p.horizontalSliderSize)}R(b,p){this.slider.setWidth(b),this.slider.setLeft(p)}Q(b,p){this.domNode.setWidth(b),this.domNode.setHeight(p),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(b){return this.s=this.J(b.scrollWidth)||this.s,this.s=this.L(b.scrollLeft)||this.s,this.s=this.y(b.width)||this.s,this.s}S(b,p){return b}U(b){return b.pageX}W(b){return b.pageY}X(b){this.slider.setHeight(b)}writeScrollPosition(b,p){b.scrollLeft=p}updateOptions(b){this.updateScrollbarSize(b.horizontal===2?0:b.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(b.vertical===2?0:b.verticalScrollbarSize),this.n.setVisibility(b.horizontal),this.c=b.scrollByPage}}t.$nT=A}),define(be[136],$e([1,0,20,70,48,52,18]),function(se,t,i,T,O,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oT=void 0;class A extends T.$mT{constructor(b,p,j){const c=b.getScrollDimensions(),f=b.getCurrentScrollPosition();if(super({lazyRender:p.lazyRender,host:j,scrollbarState:new H.$kT(p.verticalHasArrows?p.arrowSize:0,p.vertical===2?0:p.verticalScrollbarSize,0,c.height,c.scrollHeight,f.scrollTop),visibility:p.vertical,extraScrollbarClassName:"vertical",scrollable:b,scrollByPage:p.scrollByPage}),p.verticalHasArrows){const e=(p.arrowSize-O.$iT)/2,n=(p.verticalScrollbarSize-O.$iT)/2;this.t({className:"scra",icon:S.$Pj.scrollbarButtonUp,top:e,left:n,bottom:void 0,right:void 0,bgWidth:p.verticalScrollbarSize,bgHeight:p.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$AR(null,0,1))}),this.t({className:"scra",icon:S.$Pj.scrollbarButtonDown,top:void 0,left:n,bottom:e,right:void 0,bgWidth:p.verticalScrollbarSize,bgHeight:p.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$AR(null,0,-1))})}this.w(0,Math.floor((p.verticalScrollbarSize-p.verticalSliderSize)/2),p.verticalSliderSize,void 0)}R(b,p){this.slider.setHeight(b),this.slider.setTop(p)}Q(b,p){this.domNode.setWidth(p),this.domNode.setHeight(b),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(b){return this.s=this.J(b.scrollHeight)||this.s,this.s=this.L(b.scrollTop)||this.s,this.s=this.y(b.height)||this.s,this.s}S(b,p){return p}U(b){return b.pageY}W(b){return b.pageX}X(b){this.slider.setWidth(b)}writeScrollPosition(b,p){b.scrollTop=p}updateOptions(b){this.updateScrollbarSize(b.vertical===2?0:b.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(b.vertical),this.c=b.scrollByPage}}t.$oT=A}),define(be[71],$e([1,0,17,4,51,20,135,136,21,11,3,2,5,58,111]),function(se,t,i,T,O,H,S,A,m,b,p,j,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tT=t.$sT=t.$rT=t.$qT=t.$pT=void 0;const e=500,n=50,r=!0;class h{constructor(R,L,P){this.timestamp=R,this.deltaX=L,this.deltaY=P,this.score=0}}class g{static{this.INSTANCE=new g}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,L=0,P=1,E=this.d;do{const z=E===this.c?R:Math.pow(2,-P);if(R-=z,L+=this.b[E].score*z,E===this.c)break;E=(this.a+E-1)%this.a,P++}while(!0);return L<=.5}acceptStandardWheelEvent(R){if(i.$oR){const L=T.getWindow(R.browserEvent),P=(0,i.$hR)(L);this.accept(Date.now(),R.deltaX*P,R.deltaY*P)}else this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,L,P){let E=null;const z=new h(R,L,P);this.c===-1&&this.d===-1?(this.b[0]=z,this.c=0,this.d=0):(E=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=z),z.score=this.f(z,E)}f(R,L){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let P=.5;if((!this.g(R.deltaX)||!this.g(R.deltaY))&&(P+=.25),L){const E=Math.abs(R.deltaX),z=Math.abs(R.deltaY),W=Math.abs(L.deltaX),F=Math.abs(L.deltaY),K=Math.max(Math.min(E,W),1),B=Math.max(Math.min(z,F),1),G=Math.max(E,W),V=Math.max(z,F);G%K===0&&V%B===0&&(P-=.5)}return Math.min(Math.max(P,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$pT=g;class y extends m.$hT{get options(){return this.a}constructor(R,L,P){super(),this.O=this.B(new p.$be),this.onScroll=this.O.event,this.P=this.B(new p.$be),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=k(L),this.b=P,this.B(this.b.onScroll(z=>{this.P.fire(z),this.S(z),this.O.fire(z)}));const E={onMouseWheel:z=>this.R(z),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new A.$oT(this.b,this.a,E)),this.g=this.B(new S.$nT(this.b,this.a,E)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,O.$fT)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,O.$fT)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,O.$fT)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,z=>this.Z(z)),this.u(this.t,z=>this.Y(z)),this.L=this.B(new b.$Ah),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,j.$Pc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,c.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new H.$AR(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,j.$Pc)(this.w),R)){const P=E=>{this.R(new H.$AR(E))};this.w.push(T.$GR(this.t,T.$zS.MOUSE_WHEEL,P,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const L=g.INSTANCE;r&&L.acceptStandardWheelEvent(R);let P=!1;if(R.deltaY||R.deltaX){let z=R.deltaY*this.a.mouseWheelScrollSensitivity,W=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&W+z===0?W=z=0:Math.abs(z)>=Math.abs(W)?W=0:z=0),this.a.flipAxes&&([z,W]=[W,z]);const F=!c.$j&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||F)&&!W&&(W=z,z=0),R.browserEvent&&R.browserEvent.altKey&&(W=W*this.a.fastScrollSensitivity,z=z*this.a.fastScrollSensitivity);const K=this.b.getFutureScrollPosition();let B={};if(z){const G=n*z,V=K.scrollTop-(G<0?Math.floor(G):Math.ceil(G));this.c.writeScrollPosition(B,V)}if(W){const G=n*W,V=K.scrollLeft-(G<0?Math.floor(G):Math.ceil(G));this.g.writeScrollPosition(B,V)}B=this.b.validateScrollPosition(B),(K.scrollLeft!==B.scrollLeft||K.scrollTop!==B.scrollTop)&&(r&&this.a.mouseWheelSmoothScroll&&L.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(B):this.b.setScrollPositionNow(B),P=!0)}let E=P;!E&&this.a.alwaysConsumeMouseWheel&&(E=!0),!E&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(E=!0),E&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),L=R.scrollTop>0,P=R.scrollLeft>0,E=P?" left":"",z=L?" top":"",W=P||L?" top-left-corner":"";this.n.setClassName(`shadow${E}`),this.r.setClassName(`shadow${z}`),this.s.setClassName(`shadow${W}${z}${E}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$qT=y;class o extends y{constructor(R,L){L=L||{},L.mouseWheelSmoothScroll=!1;const P=new f.$Ns({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:E=>T.$QR(T.getWindow(R),E)});super(R,L,P),this.B(P)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$rT=o;class d extends y{constructor(R,L,P){super(R,L,P)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$sT=d;class a extends y{constructor(R,L){L=L||{},L.mouseWheelSmoothScroll=!1;const P=new f.$Ns({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:E=>T.$QR(T.getWindow(R),E)});super(R,L,P),this.B(P),this.cb=R,this.B(this.onScroll(E=>{E.scrollTopChanged&&(this.cb.scrollTop=E.scrollTop),E.scrollLeftChanged&&(this.cb.scrollLeft=E.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$tT=a;function k(N){const R={lazyRender:typeof N.lazyRender<"u"?N.lazyRender:!1,className:typeof N.className<"u"?N.className:"",useShadows:typeof N.useShadows<"u"?N.useShadows:!0,handleMouseWheel:typeof N.handleMouseWheel<"u"?N.handleMouseWheel:!0,flipAxes:typeof N.flipAxes<"u"?N.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof N.consumeMouseWheelIfScrollbarIsNeeded<"u"?N.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof N.alwaysConsumeMouseWheel<"u"?N.alwaysConsumeMouseWheel:!1,scrollYToX:typeof N.scrollYToX<"u"?N.scrollYToX:!1,mouseWheelScrollSensitivity:typeof N.mouseWheelScrollSensitivity<"u"?N.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof N.fastScrollSensitivity<"u"?N.fastScrollSensitivity:5,scrollPredominantAxis:typeof N.scrollPredominantAxis<"u"?N.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof N.mouseWheelSmoothScroll<"u"?N.mouseWheelSmoothScroll:!0,arrowSize:typeof N.arrowSize<"u"?N.arrowSize:11,listenOnDomNode:typeof N.listenOnDomNode<"u"?N.listenOnDomNode:null,horizontal:typeof N.horizontal<"u"?N.horizontal:1,horizontalScrollbarSize:typeof N.horizontalScrollbarSize<"u"?N.horizontalScrollbarSize:10,horizontalSliderSize:typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:0,horizontalHasArrows:typeof N.horizontalHasArrows<"u"?N.horizontalHasArrows:!1,vertical:typeof N.vertical<"u"?N.vertical:1,verticalScrollbarSize:typeof N.verticalScrollbarSize<"u"?N.verticalScrollbarSize:10,verticalHasArrows:typeof N.verticalHasArrows<"u"?N.verticalHasArrows:!1,verticalSliderSize:typeof N.verticalSliderSize<"u"?N.verticalSliderSize:0,scrollByPage:typeof N.scrollByPage<"u"?N.scrollByPage:!1};return R.horizontalSliderSize=typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof N.verticalSliderSize<"u"?N.verticalSliderSize:R.verticalScrollbarSize,c.$j&&(R.className+=" mac"),R}}),define(be[72],$e([1,0,65,4,24,28,71,8,11,31,3,2,56,58,92,131,6,40]),function(se,t,i,T,O,H,S,A,m,b,p,j,c,f,e,n,r,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VT=t.$UT=t.$TT=t.$ST=t.ListViewTargetSector=void 0;const g={CurrentDragAndDropData:void 0};var y;(function(P){P[P.TOP=0]="TOP",P[P.CENTER_TOP=1]="CENTER_TOP",P[P.CENTER_BOTTOM=2]="CENTER_BOTTOM",P[P.BOTTOM=3]="BOTTOM"})(y||(t.ListViewTargetSector=y={}));const o={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(P){return[P]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class d{get context(){return this.d}set context(E){this.d=E}constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.$ST=d;class a{constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.$TT=a;class k{constructor(){this.types=[],this.files=[]}update(E){if(E.types&&this.types.splice(0,this.types.length,...E.types),E.files){this.files.splice(0,this.files.length);for(let z=0;z<E.files.length;z++){const W=E.files.item(z);W&&(W.size||W.type)&&this.files.push(W)}}}getData(){return{types:this.types,files:this.files}}}t.$UT=k;function N(P,E){return Array.isArray(P)&&Array.isArray(E)?(0,A.$ub)(P,E):P===E}class R{constructor(E){E?.getSetSize?this.getSetSize=E.getSetSize.bind(E):this.getSetSize=(z,W,F)=>F,E?.getPosInSet?this.getPosInSet=E.getPosInSet.bind(E):this.getPosInSet=(z,W)=>W+1,E?.getRole?this.getRole=E.getRole.bind(E):this.getRole=z=>"listitem",E?.isChecked?this.isChecked=E.isChecked.bind(E):this.isChecked=z=>{}}}class L{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(E){if(E!==this.P){if(E&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=E,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const z of this.d)this.ab(z);this.X(),this.q.setScrollDimensions({width:(0,T.$6R)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(E,z,W,F=o){if(this.R=z,this.domId=`list_id_${++L.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new m.$nh(50),this.v=!1,this.x=j.$Uc.None,this.y=0,this.G=!1,this.K=j.$Uc.None,this.L=j.$Uc.None,this.M=new j.$Tc,this.N=new p.$be,this.O=new p.$be,this.onDidChangeContentHeight=p.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=p.Event.latch(this.O.event,void 0,this.M),this.P=!1,F.horizontalScrolling&&F.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(F.paddingTop??0);for(const B of W)this.j.set(B.templateId,B);this.h=this.M.add(new n.$RT(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof F.mouseSupport=="boolean"?F.mouseSupport:!0),this.P=F.horizontalScrolling??o.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof F.paddingBottom>"u"?0:F.paddingBottom,this.D=new R(F.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(F.transformOptimization??o.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(H.$dT.addTarget(this.o)),this.p=this.M.add(new f.$Ns({forceIntegerValues:!0,smoothScrollDuration:F.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:B=>(0,T.$QR)((0,T.getWindow)(this.domNode),B)})),this.q=this.M.add(new S.$sT(this.o,{alwaysConsumeMouseWheel:F.alwaysConsumeMouseWheel??o.alwaysConsumeMouseWheel,horizontal:1,vertical:F.verticalScrollMode??o.verticalScrollMode,useShadows:F.useShadows??o.useShadows,mouseWheelScrollSensitivity:F.mouseWheelScrollSensitivity,fastScrollSensitivity:F.fastScrollSensitivity,scrollByPage:F.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),E.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,T.$GR)(this.o,H.EventType.Change,B=>this.jb(B))),this.M.add((0,T.$GR)(this.q.getDomNode(),"scroll",B=>B.target.scrollTop=0)),this.M.add((0,T.$GR)(this.domNode,"dragover",B=>this.lb(this.hb(B)))),this.M.add((0,T.$GR)(this.domNode,"drop",B=>this.nb(this.hb(B)))),this.M.add((0,T.$GR)(this.domNode,"dragleave",B=>this.mb(this.hb(B)))),this.M.add((0,T.$GR)(this.domNode,"dragend",B=>this.ob(B))),this.z=F.setRowLineHeight??o.setRowLineHeight,this.A=F.setRowHeight??o.setRowHeight,this.B=F.supportDynamicHeights??o.supportDynamicHeights,this.F=F.dnd??this.M.add(o.dnd),this.layout(F.initialSize?.height,F.initialSize?.width)}updateOptions(E){E.paddingBottom!==void 0&&(this.C=E.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),E.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(E.smoothScrolling?125:0),E.horizontalScrolling!==void 0&&(this.Q=E.horizontalScrolling);let z;if(E.scrollByPage!==void 0&&(z={...z??{},scrollByPage:E.scrollByPage}),E.mouseWheelScrollSensitivity!==void 0&&(z={...z??{},mouseWheelScrollSensitivity:E.mouseWheelScrollSensitivity}),E.fastScrollSensitivity!==void 0&&(z={...z??{},fastScrollSensitivity:E.fastScrollSensitivity}),z&&this.q.updateOptions(z),E.paddingTop!==void 0&&E.paddingTop!==this.g.paddingTop){const W=this.vb(this.k,this.m),F=E.paddingTop-this.g.paddingTop;this.g.paddingTop=E.paddingTop,this.Y(W,Math.max(0,this.k+F),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(E){this.q.delegateScrollFromMouseWheelEvent(E)}delegateVerticalScrollbarPointerDown(E){this.q.delegateVerticalScrollbarPointerDown(E)}updateElementHeight(E,z,W){if(E<0||E>=this.d.length)return;const F=this.d[E].size;if(typeof z>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[E].lastDynamicHeightWidth=void 0,z=F+this.xb(E)}if(F===z)return;const K=this.vb(this.k,this.m);let B=0;E<K.start||W!==null&&W>E&&W<K.end?B=z-F:B=0,this.g.splice(E,1,[{size:z}]),this.d[E].size=z,this.Y(K,Math.max(0,this.k+B),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(E){return new e.$QT(E)}splice(E,z,W=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(E,z,W)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(E,z,W=[]){const F=this.vb(this.k,this.m),K={start:E,end:E+z},B=c.Range.intersect(F,K),G=new Map;for(let U=B.end-1;U>=B.start;U--){const re=this.d[U];if(re.dragStartDisposable.dispose(),re.checkedDisposable.dispose(),re.row){let me=G.get(re.templateId);me||(me=[],G.set(re.templateId,me));const ve=this.j.get(re.templateId);ve&&ve.disposeElement&&ve.disposeElement(re.element,U,re.row.templateData,re.size),me.unshift(re.row)}re.row=null,re.stale=!0}const V={start:E+z,end:this.d.length},ae=c.Range.intersect(V,F),ie=c.Range.relativeComplement(V,F),ee=W.map(U=>({id:String(this.f++),element:U,templateId:this.R.getTemplateId(U),size:this.R.getHeight(U),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(U),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:j.$Uc.None,checkedDisposable:j.$Uc.None,stale:!1}));let ge;E===0&&z>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ee),ge=this.d,this.d=ee):(this.g.splice(E,z,ee),ge=this.d.splice(E,z,...ee));const Ee=W.length-z,De=this.vb(this.k,this.m),Le=(0,e.$OT)(ae,Ee),he=c.Range.intersect(De,Le);for(let U=he.start;U<he.end;U++)this.bb(this.d[U],U);const _=c.Range.relativeComplement(Le,De);for(const U of _)for(let re=U.start;re<U.end;re++)this.db(re);const ue=ie.map(U=>(0,e.$OT)(U,Ee)),Q=[{start:E,end:E+W.length},...ue].map(U=>c.Range.intersect(De,U)).reverse();for(const U of Q)for(let re=U.end-1;re>=U.start;re--){const me=this.d[re],Ne=G.get(me.templateId)?.pop();this.Z(re,Ne)}for(const U of G.values())for(const re of U)this.h.release(re);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),ge.map(U=>U.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,T.$QR)((0,T.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let E=0;for(const z of this.d)typeof z.width<"u"&&(E=Math.max(E,z.width));this.E=E,this.q.setScrollDimensions({scrollWidth:E===0?0:E+10}),this.O.fire(this.E)}updateWidth(E){if(!this.Q||typeof this.E>"u")return;const z=this.d[E];this.ab(z),typeof z.width<"u"&&z.width>this.E&&(this.E=z.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const E of this.d)E.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const E=this.firstVisibleIndex,z=this.g.positionAt(E),W=this.g.positionAt(E+1);return W!==-1&&(W-z)/2+z<this.scrollTop?E+1:E}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(E){return this.d[E].element}indexOf(E){return this.d.findIndex(z=>z.element===E)}domElement(E){const z=this.d[E].row;return z&&z.domNode}elementHeight(E){return this.d[E].size}elementTop(E){return this.g.positionAt(E)}indexAt(E){return this.g.indexAt(E)}indexAfter(E){return this.g.indexAfter(E)}layout(E,z){const W={height:typeof E=="number"?E:(0,T.$8R)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,W.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(W),typeof z<"u"&&(this.n=z,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof z=="number"?z:(0,T.$6R)(this.domNode)})}Y(E,z,W,F,K,B=!1){const G=this.vb(z,W),V=c.Range.relativeComplement(G,E).reverse(),ae=c.Range.relativeComplement(E,G);if(B){const ie=c.Range.intersect(E,G);for(let ee=ie.start;ee<ie.end;ee++)this.bb(this.d[ee],ee)}this.h.transact(()=>{for(const ie of ae)for(let ee=ie.start;ee<ie.end;ee++)this.db(ee);for(const ie of V)for(let ee=ie.end-1;ee>=ie.start;ee--)this.Z(ee)}),F!==void 0&&(this.o.style.left=`-${F}px`),this.o.style.top=`-${z}px`,this.Q&&K!==void 0&&(this.o.style.width=`${Math.max(K,this.n)}px`),this.k=z,this.m=W}Z(E,z){const W=this.d[E];if(!W.row)if(z)W.row=z,W.stale=!0;else{const V=this.h.alloc(W.templateId);W.row=V.row,W.stale||=V.isReusingConnectedDomNode}const F=this.D.getRole(W.element)||"listitem";W.row.domNode.setAttribute("role",F);const K=this.D.isChecked(W.element);if(typeof K=="boolean")W.row.domNode.setAttribute("aria-checked",String(!!K));else if(K){const V=ae=>W.row.domNode.setAttribute("aria-checked",String(!!ae));V(K.value),W.checkedDisposable=K.onDidChange(()=>V(K.value))}if(W.stale||!W.row.domNode.parentElement){const V=this.d.at(E+1)?.row?.domNode??null;(W.row.domNode.parentElement!==this.o||W.row.domNode.nextElementSibling!==V)&&this.o.insertBefore(W.row.domNode,V),W.stale=!1}this.bb(W,E);const B=this.j.get(W.templateId);if(!B)throw new Error(`No renderer found for template id ${W.templateId}`);B?.renderElement(W.element,E,W.row.templateData,W.size);const G=this.F.getDragURI(W.element);W.dragStartDisposable.dispose(),W.row.domNode.draggable=!!G,G&&(W.dragStartDisposable=(0,T.$GR)(W.row.domNode,"dragstart",V=>this.kb(W.element,G,V))),this.Q&&(this.ab(W),this.W())}ab(E){if(!E.row||!E.row.domNode)return;E.row.domNode.style.width="fit-content",E.width=(0,T.$6R)(E.row.domNode);const z=(0,T.getWindow)(E.row.domNode).getComputedStyle(E.row.domNode);z.paddingLeft&&(E.width+=parseFloat(z.paddingLeft)),z.paddingRight&&(E.width+=parseFloat(z.paddingRight)),E.row.domNode.style.width=""}bb(E,z){E.row.domNode.style.top=`${this.elementTop(z)}px`,this.A&&(E.row.domNode.style.height=`${E.size}px`),this.z&&(E.row.domNode.style.lineHeight=`${E.size}px`),E.row.domNode.setAttribute("data-index",`${z}`),E.row.domNode.setAttribute("data-last-element",z===this.length-1?"true":"false"),E.row.domNode.setAttribute("data-parity",z%2===0?"even":"odd"),E.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(E.element,z,this.length))),E.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(E.element,z))),E.row.domNode.setAttribute("id",this.getElementDomId(z)),E.row.domNode.classList.toggle("drop-target",E.dropTarget)}db(E){const z=this.d[E];if(z.dragStartDisposable.dispose(),z.checkedDisposable.dispose(),z.row){const W=this.j.get(z.templateId);W&&W.disposeElement&&W.disposeElement(z.element,E,z.row.templateData,z.size),this.h.release(z.row),z.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(E,z){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:E,reuseAnimation:z})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(E){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:E})}get scrollTop(){return this.getScrollTop()}set scrollTop(E){this.setScrollTop(E)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return p.Event.map(this.M.add(new O.$IT(this.domNode,"click")).event,E=>this.eb(E),this.M)}get onMouseDblClick(){return p.Event.map(this.M.add(new O.$IT(this.domNode,"dblclick")).event,E=>this.eb(E),this.M)}get onMouseMiddleClick(){return p.Event.filter(p.Event.map(this.M.add(new O.$IT(this.domNode,"auxclick")).event,E=>this.eb(E),this.M),E=>E.browserEvent.button===1,this.M)}get onMouseUp(){return p.Event.map(this.M.add(new O.$IT(this.domNode,"mouseup")).event,E=>this.eb(E),this.M)}get onMouseDown(){return p.Event.map(this.M.add(new O.$IT(this.domNode,"mousedown")).event,E=>this.eb(E),this.M)}get onMouseOver(){return p.Event.map(this.M.add(new O.$IT(this.domNode,"mouseover")).event,E=>this.eb(E),this.M)}get onMouseMove(){return p.Event.map(this.M.add(new O.$IT(this.domNode,"mousemove")).event,E=>this.eb(E),this.M)}get onMouseOut(){return p.Event.map(this.M.add(new O.$IT(this.domNode,"mouseout")).event,E=>this.eb(E),this.M)}get onContextMenu(){return p.Event.any(p.Event.map(this.M.add(new O.$IT(this.domNode,"contextmenu")).event,E=>this.eb(E),this.M),p.Event.map(this.M.add(new O.$IT(this.domNode,H.EventType.Contextmenu)).event,E=>this.gb(E),this.M))}get onTouchStart(){return p.Event.map(this.M.add(new O.$IT(this.domNode,"touchstart")).event,E=>this.fb(E),this.M)}get onTap(){return p.Event.map(this.M.add(new O.$IT(this.o,H.EventType.Tap)).event,E=>this.gb(E),this.M)}eb(E){const z=this.ub(E.target||null),W=typeof z>"u"?void 0:this.d[z],F=W&&W.element;return{browserEvent:E,index:z,element:F}}fb(E){const z=this.ub(E.target||null),W=typeof z>"u"?void 0:this.d[z],F=W&&W.element;return{browserEvent:E,index:z,element:F}}gb(E){const z=this.ub(E.initialTarget||null),W=typeof z>"u"?void 0:this.d[z],F=W&&W.element;return{browserEvent:E,index:z,element:F}}hb(E){const z=this.ub(E.target||null),W=typeof z>"u"?void 0:this.d[z],F=W&&W.element,K=this.tb(E,z);return{browserEvent:E,index:z,element:F,sector:K}}ib(E){try{const z=this.vb(this.k,this.m);this.Y(z,E.scrollTop,E.height,E.scrollLeft,E.scrollWidth),this.B&&this.wb(E.scrollTop,E.height,E.inSmoothScrolling)}catch(z){throw console.error("Got bad scroll event:",E),z}}jb(E){E.preventDefault(),E.stopPropagation(),this.scrollTop-=E.translationY}kb(E,z,W){if(!W.dataTransfer)return;const F=this.F.getDragElements(E);if(W.dataTransfer.effectAllowed="copyMove",W.dataTransfer.setData(i.$bT.TEXT,z),W.dataTransfer.setDragImage){let K;this.F.getDragLabel&&(K=this.F.getDragLabel(F,W)),typeof K>"u"&&(K=String(F.length));const B=(0,T.$)(".monaco-drag-image");B.textContent=K;const V=(ae=>{for(;ae&&!ae.classList.contains("monaco-workbench");)ae=ae.parentElement;return ae||this.domNode.ownerDocument})(this.domNode);V.appendChild(B),W.dataTransfer.setDragImage(B,-10,-10),setTimeout(()=>V.removeChild(B),0)}this.domNode.classList.add("dragging"),this.H=new d(F),g.CurrentDragAndDropData=new a(F),this.F.onDragStart?.(this.H,W)}lb(E){if(E.browserEvent.preventDefault(),this.L.dispose(),g.CurrentDragAndDropData&&g.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(E.browserEvent),!E.browserEvent.dataTransfer))return!1;if(!this.H)if(g.CurrentDragAndDropData)this.H=g.CurrentDragAndDropData;else{if(!E.browserEvent.dataTransfer.types)return!1;this.H=new k}const z=this.F.onDragOver(this.H,E.element,E.index,E.sector,E.browserEvent);if(this.G=typeof z=="boolean"?z:z.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;E.browserEvent.dataTransfer.dropEffect=typeof z!="boolean"&&z.effect?.type===0?"copy":"move";let W;typeof z!="boolean"&&z.feedback?W=z.feedback:typeof E.index>"u"?W=[-1]:W=[E.index],W=(0,A.$Mb)(W).filter(K=>K>=-1&&K<this.length).sort((K,B)=>K-B),W=W[0]===-1?[-1]:W;let F=typeof z!="boolean"&&z.effect&&z.effect.position?z.effect.position:"drop-target";if(N(this.I,W)&&this.J===F)return!0;if(this.I=W,this.J=F,this.K.dispose(),W[0]===-1)this.domNode.classList.add(F),this.o.classList.add(F),this.K=(0,j.$Sc)(()=>{this.domNode.classList.remove(F),this.o.classList.remove(F)});else{if(W.length>1&&F!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");F==="drop-target-after"&&W[0]<this.length-1&&(W[0]+=1,F="drop-target-before");for(const K of W){const B=this.d[K];B.dropTarget=!0,B.row?.domNode.classList.add(F)}this.K=(0,j.$Sc)(()=>{for(const K of W){const B=this.d[K];B.dropTarget=!1,B.row?.domNode.classList.remove(F)}})}return!0}mb(E){this.L.dispose(),this.L=(0,m.$sh)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,E.element,E.index,E.browserEvent)}nb(E){if(!this.G)return;const z=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,g.CurrentDragAndDropData=void 0,!(!z||!E.browserEvent.dataTransfer)&&(E.browserEvent.preventDefault(),z.update(E.browserEvent.dataTransfer),this.F.drop(z,E.element,E.index,E.sector,E.browserEvent))}ob(E){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,g.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(E)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=j.$Uc.None}qb(E){if(!this.w){const z=(0,T.$ZR)(this.domNode).top;this.w=(0,T.$VS)((0,T.getWindow)(this.domNode),this.rb.bind(this,z))}this.x.dispose(),this.x=(0,m.$sh)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=E.pageY}rb(E){if(this.y===void 0)return;const z=this.y-E,W=this.renderHeight-35;z<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(z-35))):z>W&&(this.scrollTop+=Math.min(14,Math.floor(.3*(z-W))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(E,z){if(z===void 0)return;const W=E.offsetY/this.d[z].size,F=Math.floor(W/.25);return(0,h.$vm)(F,0,3)}ub(E){const z=this.q.getDomNode();let W=E;for(;W instanceof HTMLElement&&W!==this.o&&z.contains(W);){const F=W.getAttribute("data-index");if(F){const K=Number(F);if(!isNaN(K))return K}W=W.parentElement}}vb(E,z){return{start:this.g.indexAt(E),end:this.g.indexAfter(E+z-1)}}wb(E,z,W){const F=this.vb(E,z);let K,B;E===this.elementTop(F.start)?(K=F.start,B=0):F.end-F.start>1&&(K=F.start+1,B=this.elementTop(K)-E);let G=0;for(;;){const V=this.vb(E,z);let ae=!1;for(let ie=V.start;ie<V.end;ie++){const ee=this.xb(ie);ee!==0&&this.g.splice(ie,1,[this.d[ie]]),G+=ee,ae=ae||ee!==0}if(!ae){G!==0&&this.V();const ie=c.Range.relativeComplement(F,V);for(const ge of ie)for(let Ee=ge.start;Ee<ge.end;Ee++)this.d[Ee].row&&this.db(Ee);const ee=c.Range.relativeComplement(V,F).reverse();for(const ge of ee)for(let Ee=ge.end-1;Ee>=ge.start;Ee--)this.Z(Ee);for(let ge=V.start;ge<V.end;ge++)this.d[ge].row&&this.bb(this.d[ge],ge);if(typeof K=="number"){const ge=this.p.getFutureScrollPosition().scrollTop-E,Ee=this.elementTop(K)-B+ge;this.setScrollTop(Ee,W)}this.N.fire(this.contentHeight);return}}}xb(E){const z=this.d[E];if(this.R.getDynamicHeight){const B=this.R.getDynamicHeight(z.element);if(B!==null){const G=z.size;return z.size=B,z.lastDynamicHeightWidth=this.n,B-G}}if(!z.hasDynamicHeight||z.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(z.element))return 0;const W=z.size;if(z.row)return z.row.domNode.style.height="",z.size=z.row.domNode.offsetHeight,z.size===0&&!(0,T.$$R)(z.row.domNode,(0,T.getWindow)(z.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),z.lastDynamicHeightWidth=this.n,z.size-W;const{row:F}=this.h.alloc(z.templateId);F.domNode.style.height="",this.o.appendChild(F.domNode);const K=this.j.get(z.templateId);if(!K)throw new r.$cb("Missing renderer for templateId: "+z.templateId);return K.renderElement(z.element,E,F.templateData,void 0),z.size=F.domNode.offsetHeight,K.disposeElement?.(z.element,E,F.templateData,void 0),this.R.setDynamicHeight?.(z.element,z.size),z.lastDynamicHeightWidth=this.n,this.o.removeChild(F.domNode),this.h.release(F),z.size-W}getElementDomId(E){return`${this.domId}_${E}`}dispose(){for(const E of this.d)if(E.dragStartDisposable.dispose(),E.checkedDisposable.dispose(),E.row){const z=this.j.get(E.row.templateId);z&&(z.disposeElement?.(E.element,-1,E.row.templateData,void 0),z.disposeTemplate(E.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$VT=L,Je([b.$Uh],L.prototype,"onMouseClick",null),Je([b.$Uh],L.prototype,"onMouseDblClick",null),Je([b.$Uh],L.prototype,"onMouseMiddleClick",null),Je([b.$Uh],L.prototype,"onMouseUp",null),Je([b.$Uh],L.prototype,"onMouseDown",null),Je([b.$Uh],L.prototype,"onMouseOver",null),Je([b.$Uh],L.prototype,"onMouseMove",null),Je([b.$Uh],L.prototype,"onMouseOut",null),Je([b.$Uh],L.prototype,"onContextMenu",null),Je([b.$Uh],L.prototype,"onTouchStart",null),Je([b.$Uh],L.prototype,"onTap",null)}),define(be[49],$e([1,0,4,24,15,28,68,81,8,11,84,31,3,44,2,40,5,10,80,72,20,57,110]),function(se,t,i,T,O,H,S,A,m,b,p,j,c,f,e,n,r,h,g,y,o,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bU=t.$aU=t.$_T=t.$$T=t.$8T=t.TypeNavigationMode=void 0,t.$ZT=L,t.$1T=E,t.$2T=z,t.$3T=W,t.$4T=F,t.$5T=K,t.$6T=B,t.$7T=G,t.$9T=Ee,t.$0T=De;class a{constructor(u){this.d=u,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(u){return u}renderElement(u,v,l){const w=this.c.findIndex(C=>C.templateData===l);if(w>=0){const C=this.c[w];this.d.unrender(l),C.index=v}else{const C={index:v,templateData:l};this.c.push(C)}this.d.renderIndex(v,l)}splice(u,v,l){const w=[];for(const C of this.c)C.index<u?w.push(C):C.index>=u+v&&w.push({index:C.index+l-v,templateData:C.templateData});this.c=w}renderIndexes(u){for(const{index:v,templateData:l}of this.c)u.indexOf(v)>-1&&this.d.renderIndex(v,l)}disposeTemplate(u){const v=this.c.findIndex(l=>l.templateData===u);v<0||this.c.splice(v,1)}}class k{get name(){return this.g}get renderer(){return new a(this)}constructor(u){this.g=u,this.c=[],this.d=[],this.f=new c.$be,this.onChange=this.f.event}splice(u,v,l){const w=l.length-v,C=u+v,s=[];let D=0;for(;D<this.d.length&&this.d[D]<u;)s.push(this.d[D++]);for(let $=0;$<l.length;$++)l[$]&&s.push($+u);for(;D<this.d.length&&this.d[D]>=C;)s.push(this.d[D++]+w);this.renderer.splice(u,v,l.length),this.h(s,s)}renderIndex(u,v){v.classList.toggle(this.g,this.contains(u))}unrender(u){u.classList.remove(this.g)}set(u,v){return this.h(u,[...u].sort(me),v)}h(u,v,l){const w=this.c,C=this.d;this.c=u,this.d=v;const s=U(C,u);return this.renderer.renderIndexes(s),this.f.fire({indexes:u,browserEvent:l}),w}get(){return this.c}contains(u){return(0,m.$wb)(this.d,u,me)>=0}dispose(){(0,e.$Pc)(this.f)}}Je([j.$Uh],k.prototype,"renderer",null);class N extends k{constructor(u){super("selected"),this.k=u}renderIndex(u,v){super.renderIndex(u,v),this.k&&(this.contains(u)?v.setAttribute("aria-selected","true"):v.setAttribute("aria-selected","false"))}}class R{constructor(u,v,l){this.c=u,this.d=v,this.f=l}splice(u,v,l){if(!this.f)return this.c.splice(u,v,new Array(l.length).fill(!1));const w=this.c.get().map(D=>this.f.getId(this.d.element(D)).toString());if(w.length===0)return this.c.splice(u,v,new Array(l.length).fill(!1));const C=new Set(w),s=l.map(D=>C.has(this.f.getId(D).toString()));this.c.splice(u,v,s)}}function L(x){return x.tagName==="INPUT"||x.tagName==="TEXTAREA"}function P(x,u){return x.classList.contains(u)?!0:x.classList.contains("monaco-list")||!x.parentElement?!1:P(x.parentElement,u)}function E(x){return P(x,"monaco-editor")}function z(x){return P(x,"monaco-custom-toggle")}function W(x){return P(x,"action-item")}function F(x){return P(x,"monaco-tl-twistie")}function K(x){return P(x,"monaco-tree-sticky-row")}function B(x){return x.classList.contains("monaco-tree-sticky-container")}function G(x){return x.tagName==="A"&&x.classList.contains("monaco-button")||x.tagName==="DIV"&&x.classList.contains("monaco-button-dropdown")?!0:x.classList.contains("monaco-list")||!x.parentElement?!1:G(x.parentElement)}class V{get g(){return c.Event.chain(this.c.add(new T.$IT(this.k.domNode,"keydown")).event,u=>u.filter(v=>!L(v.target)).map(v=>new O.$DR(v)))}constructor(u,v,l){this.h=u,this.k=v,this.c=new e.$Tc,this.d=new e.$Tc,this.f=l.multipleSelectionSupport,this.c.add(this.g(w=>{switch(w.keyCode){case 3:return this.l(w);case 16:return this.o(w);case 18:return this.p(w);case 11:return this.q(w);case 12:return this.s(w);case 9:return this.u(w);case 31:this.f&&(r.$j?w.metaKey:w.ctrlKey)&&this.t(w)}}))}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.f=u.multipleSelectionSupport)}l(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection(this.h.getFocus(),u.browserEvent)}o(u){u.preventDefault(),u.stopPropagation(),this.h.focusPrevious(1,!1,u.browserEvent);const v=this.h.getFocus()[0];this.h.setAnchor(v),this.h.reveal(v),this.k.domNode.focus()}p(u){u.preventDefault(),u.stopPropagation(),this.h.focusNext(1,!1,u.browserEvent);const v=this.h.getFocus()[0];this.h.setAnchor(v),this.h.reveal(v),this.k.domNode.focus()}q(u){u.preventDefault(),u.stopPropagation(),this.h.focusPreviousPage(u.browserEvent);const v=this.h.getFocus()[0];this.h.setAnchor(v),this.h.reveal(v),this.k.domNode.focus()}s(u){u.preventDefault(),u.stopPropagation(),this.h.focusNextPage(u.browserEvent);const v=this.h.getFocus()[0];this.h.setAnchor(v),this.h.reveal(v),this.k.domNode.focus()}t(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection((0,m.$Sb)(this.h.length),u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(u){this.h.getSelection().length&&(u.preventDefault(),u.stopPropagation(),this.h.setSelection([],u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Je([j.$Uh],V.prototype,"g",null);var ae;(function(x){x[x.Automatic=0]="Automatic",x[x.Trigger=1]="Trigger"})(ae||(t.TypeNavigationMode=ae={}));var ie;(function(x){x[x.Idle=0]="Idle",x[x.Typing=1]="Typing"})(ie||(ie={})),t.$8T=new class{mightProducePrintableCharacter(x){return x.ctrlKey||x.metaKey||x.altKey?!1:x.keyCode>=31&&x.keyCode<=56||x.keyCode>=21&&x.keyCode<=30||x.keyCode>=98&&x.keyCode<=107||x.keyCode>=85&&x.keyCode<=95}};class ee{constructor(u,v,l,w,C){this.o=u,this.p=v,this.q=l,this.s=w,this.t=C,this.c=!1,this.d=ie.Idle,this.f=ae.Automatic,this.g=!1,this.h=-1,this.k=new e.$Tc,this.l=new e.$Tc,this.updateOptions(u.options)}updateOptions(u){u.typeNavigationEnabled??!0?this.u():this.v(),this.f=u.typeNavigationMode??ae.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let u=!1;const v=c.Event.chain(this.k.add(new T.$IT(this.p.domNode,"keydown")).event,C=>C.filter(s=>!L(s.target)).filter(()=>this.f===ae.Automatic||this.g).map(s=>new O.$DR(s)).filter(s=>u||this.s(s)).filter(s=>this.t.mightProducePrintableCharacter(s)).forEach(s=>i.$BS.stop(s,!0)).map(s=>s.browserEvent.key)),l=c.Event.debounce(v,()=>null,800,void 0,void 0,void 0,this.k);c.Event.reduce(c.Event.any(v,l),(C,s)=>s===null?null:(C||"")+s,void 0,this.k)(this.x,this,this.k),l(this.w,this,this.k),v(()=>u=!0,void 0,this.k),l(()=>u=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const u=this.o.getFocus();if(u.length>0&&u[0]===this.h){const v=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(u[0]));typeof v=="string"?(0,S.$KT)(v):v&&(0,S.$KT)(v.get())}this.h=-1}x(u){if(!u){this.d=ie.Idle,this.g=!1;return}const v=this.o.getFocus(),l=v.length>0?v[0]:0,w=this.d===ie.Idle?1:0;this.d=ie.Typing;for(let C=0;C<this.o.length;C++){const s=(l+C+w)%this.o.length,D=this.q.getKeyboardNavigationLabel(this.p.element(s)),$=D&&D.toString();if(this.o.options.typeNavigationEnabled){if(typeof $<"u"){if((0,f.$sk)(u,$)){this.h=l,this.o.setFocus([s]),this.o.reveal(s);return}const I=(0,f.$zk)(u,$);if(I&&I[0].end-I[0].start>1&&I.length===1){this.h=l,this.o.setFocus([s]),this.o.reveal(s);return}}}else if(typeof $>"u"||(0,f.$sk)(u,$)){this.h=l,this.o.setFocus([s]),this.o.reveal(s);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ge{constructor(u,v){this.d=u,this.f=v,this.c=new e.$Tc;const l=c.Event.chain(this.c.add(new T.$IT(v.domNode,"keydown")).event,C=>C.filter(s=>!L(s.target)).map(s=>new O.$DR(s)));c.Event.chain(l,C=>C.filter(s=>s.keyCode===2&&!s.ctrlKey&&!s.metaKey&&!s.shiftKey&&!s.altKey))(this.g,this,this.c)}g(u){if(u.target!==this.f.domNode)return;const v=this.d.getFocus();if(v.length===0)return;const l=this.f.domElement(v[0]);if(!l)return;const w=l.querySelector("[tabIndex]");if(!w||!(w instanceof HTMLElement)||w.tabIndex===-1)return;const C=(0,i.getWindow)(w).getComputedStyle(w);C.visibility==="hidden"||C.display==="none"||(u.preventDefault(),u.stopPropagation(),w.focus())}dispose(){this.c.dispose()}}function Ee(x){return r.$j?x.browserEvent.metaKey:x.browserEvent.ctrlKey}function De(x){return x.browserEvent.shiftKey}function Le(x){return(0,i.$vS)(x)&&x.button===2}const he={isSelectionSingleChangeEvent:Ee,isSelectionRangeChangeEvent:De};class _{constructor(u){this.k=u,this.f=new e.$Tc,this.g=new c.$be,this.onPointer=this.g.event,u.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||he),this.d=typeof u.options.mouseSupport>"u"||!!u.options.mouseSupport,this.d&&(u.onMouseDown(this.s,this,this.f),u.onContextMenu(this.t,this,this.f),u.onMouseDblClick(this.v,this,this.f),u.onTouchStart(this.s,this,this.f),this.f.add(H.$dT.addTarget(u.getHTMLElement()))),c.Event.any(u.onMouseClick,u.onMouseMiddleClick,u.onTap)(this.u,this,this.f)}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.c=void 0,u.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||he))}o(u){return this.c?this.c.isSelectionSingleChangeEvent(u):!1}p(u){return this.c?this.c.isSelectionRangeChangeEvent(u):!1}q(u){return this.o(u)||this.p(u)}s(u){E(u.browserEvent.target)||(0,i.$gS)()!==u.browserEvent.target&&this.k.domFocus()}t(u){if(L(u.browserEvent.target)||E(u.browserEvent.target))return;const v=typeof u.index>"u"?[]:[u.index];this.k.setFocus(v,u.browserEvent)}u(u){if(!this.d||L(u.browserEvent.target)||E(u.browserEvent.target)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const v=u.index;if(typeof v>"u"){this.k.setFocus([],u.browserEvent),this.k.setSelection([],u.browserEvent),this.k.setAnchor(void 0);return}if(this.q(u))return this.w(u);this.k.setFocus([v],u.browserEvent),this.k.setAnchor(v),Le(u.browserEvent)||this.k.setSelection([v],u.browserEvent),this.g.fire(u)}v(u){if(L(u.browserEvent.target)||E(u.browserEvent.target)||this.q(u)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const v=this.k.getFocus();this.k.setSelection(v,u.browserEvent)}w(u){const v=u.index;let l=this.k.getAnchor();if(this.p(u)){typeof l>"u"&&(l=this.k.getFocus()[0]??v,this.k.setAnchor(l));const w=Math.min(l,v),C=Math.max(l,v),s=(0,m.$Sb)(w,C+1),D=this.k.getSelection(),$=Q(U(D,[l]),l);if($.length===0)return;const I=U(s,re(D,$));this.k.setSelection(I,u.browserEvent),this.k.setFocus([v],u.browserEvent)}else if(this.o(u)){const w=this.k.getSelection(),C=w.filter(s=>s!==v);this.k.setFocus([v]),this.k.setAnchor(v),w.length===C.length?this.k.setSelection([...C,v],u.browserEvent):this.k.setSelection(C,u.browserEvent)}}dispose(){this.f.dispose()}}t.$$T=_;class ue{constructor(u,v){this.c=u,this.d=v}style(u){const v=this.d&&`.${this.d}`,l=[];u.listBackground&&l.push(`.monaco-list${v} .monaco-list-rows { background: ${u.listBackground}; }`),u.listFocusBackground&&(l.push(`.monaco-list${v}:focus .monaco-list-row.focused { background-color: ${u.listFocusBackground}; }`),l.push(`.monaco-list${v}:focus .monaco-list-row.focused:hover { background-color: ${u.listFocusBackground}; }`)),u.listFocusForeground&&l.push(`.monaco-list${v}:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),u.listActiveSelectionBackground&&(l.push(`.monaco-list${v}:focus .monaco-list-row.selected { background-color: ${u.listActiveSelectionBackground}; }`),l.push(`.monaco-list${v}:focus .monaco-list-row.selected:hover { background-color: ${u.listActiveSelectionBackground}; }`)),u.listActiveSelectionForeground&&l.push(`.monaco-list${v}:focus .monaco-list-row.selected { color: ${u.listActiveSelectionForeground}; }`),u.listActiveSelectionIconForeground&&l.push(`.monaco-list${v}:focus .monaco-list-row.selected .codicon { color: ${u.listActiveSelectionIconForeground}; }`),u.listFocusAndSelectionBackground&&l.push(`
				.monaco-drag-image,
				.monaco-list${v}:focus .monaco-list-row.selected.focused { background-color: ${u.listFocusAndSelectionBackground}; }
			`),u.listFocusAndSelectionForeground&&l.push(`
				.monaco-drag-image,
				.monaco-list${v}:focus .monaco-list-row.selected.focused { color: ${u.listFocusAndSelectionForeground}; }
			`),u.listInactiveFocusForeground&&(l.push(`.monaco-list${v} .monaco-list-row.focused { color:  ${u.listInactiveFocusForeground}; }`),l.push(`.monaco-list${v} .monaco-list-row.focused:hover { color:  ${u.listInactiveFocusForeground}; }`)),u.listInactiveSelectionIconForeground&&l.push(`.monaco-list${v} .monaco-list-row.focused .codicon { color:  ${u.listInactiveSelectionIconForeground}; }`),u.listInactiveFocusBackground&&(l.push(`.monaco-list${v} .monaco-list-row.focused { background-color:  ${u.listInactiveFocusBackground}; }`),l.push(`.monaco-list${v} .monaco-list-row.focused:hover { background-color:  ${u.listInactiveFocusBackground}; }`)),u.listInactiveSelectionBackground&&(l.push(`.monaco-list${v} .monaco-list-row.selected { background-color:  ${u.listInactiveSelectionBackground}; }`),l.push(`.monaco-list${v} .monaco-list-row.selected:hover { background-color:  ${u.listInactiveSelectionBackground}; }`)),u.listInactiveSelectionForeground&&l.push(`.monaco-list${v} .monaco-list-row.selected { color: ${u.listInactiveSelectionForeground}; }`),u.listHoverBackground&&l.push(`.monaco-list${v}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${u.listHoverBackground}; }`),u.listHoverForeground&&l.push(`.monaco-list${v}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${u.listHoverForeground}; }`);const w=(0,i.$YS)(u.listFocusAndSelectionOutline,(0,i.$YS)(u.listSelectionOutline,u.listFocusOutline??""));w&&l.push(`.monaco-list${v}:focus .monaco-list-row.focused.selected { outline: 1px solid ${w}; outline-offset: -1px;}`),u.listFocusOutline&&l.push(`
				.monaco-drag-image,
				.monaco-list${v}:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${v}.last-focused .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
			`);const C=(0,i.$YS)(u.listSelectionOutline,u.listInactiveFocusOutline??"");C&&l.push(`.monaco-list${v} .monaco-list-row.focused.selected { outline: 1px dotted ${C}; outline-offset: -1px; }`),u.listSelectionOutline&&l.push(`.monaco-list${v} .monaco-list-row.selected { outline: 1px dotted ${u.listSelectionOutline}; outline-offset: -1px; }`),u.listInactiveFocusOutline&&l.push(`.monaco-list${v} .monaco-list-row.focused { outline: 1px dotted ${u.listInactiveFocusOutline}; outline-offset: -1px; }`),u.listHoverOutline&&l.push(`.monaco-list${v} .monaco-list-row:hover { outline: 1px dashed ${u.listHoverOutline}; outline-offset: -1px; }`),u.listDropOverBackground&&l.push(`
				.monaco-list${v}.drop-target,
				.monaco-list${v} .monaco-list-rows.drop-target,
				.monaco-list${v} .monaco-list-row.drop-target { background-color: ${u.listDropOverBackground} !important; color: inherit !important; }
			`),u.listDropBetweenBackground&&(l.push(`
			.monaco-list${v} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${v} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`),l.push(`
			.monaco-list${v} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${v} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`)),u.tableColumnsBorder&&l.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${u.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),u.tableOddRowsBackgroundColor&&l.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${u.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=l.join(`
`)}}t.$_T=ue,t.$aU={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:p.$Ft.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:p.$Ft.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:p.$Ft.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const le={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Q(x,u){const v=x.indexOf(u);if(v===-1)return[];const l=[];let w=v-1;for(;w>=0&&x[w]===u-(v-w);)l.push(x[w--]);for(l.reverse(),w=v;w<x.length&&x[w]===u+(w-v);)l.push(x[w++]);return l}function U(x,u){const v=[];let l=0,w=0;for(;l<x.length||w<u.length;)if(l>=x.length)v.push(u[w++]);else if(w>=u.length)v.push(x[l++]);else if(x[l]===u[w]){v.push(x[l]),l++,w++;continue}else x[l]<u[w]?v.push(x[l++]):v.push(u[w++]);return v}function re(x,u){const v=[];let l=0,w=0;for(;l<x.length||w<u.length;)if(l>=x.length)v.push(u[w++]);else if(w>=u.length)v.push(x[l++]);else if(x[l]===u[w]){l++,w++;continue}else x[l]<u[w]?v.push(x[l++]):w++;return v}const me=(x,u)=>x-u;class ve{constructor(u,v){this.c=u,this.d=v}get templateId(){return this.c}renderTemplate(u){return this.d.map(v=>v.renderTemplate(u))}renderElement(u,v,l,w){let C=0;for(const s of this.d)s.renderElement(u,v,l[C++],w)}disposeElement(u,v,l,w){let C=0;for(const s of this.d)s.disposeElement?.(u,v,l[C],w),C+=1}disposeTemplate(u){let v=0;for(const l of this.d)l.disposeTemplate(u[v++])}}class Ne{constructor(u){this.c=u,this.templateId="a18n"}renderTemplate(u){return{container:u,disposables:new e.$Tc}}renderElement(u,v,l){const w=this.c.getAriaLabel(u),C=w&&typeof w!="string"?w:(0,d.constObservable)(w);l.disposables.add((0,d.autorun)(D=>{this.d(D.readObservable(C),l.container)}));const s=this.c.getAriaLevel&&this.c.getAriaLevel(u);typeof s=="number"?l.container.setAttribute("aria-level",`${s}`):l.container.removeAttribute("aria-level")}d(u,v){u?v.setAttribute("aria-label",u):v.removeAttribute("aria-label")}disposeElement(u,v,l,w){l.disposables.clear()}disposeTemplate(u){u.disposables.dispose()}}class Te{constructor(u,v){this.c=u,this.d=v}getDragElements(u){const v=this.c.getSelectedElements();return v.indexOf(u)>-1?v:[u]}getDragURI(u){return this.d.getDragURI(u)}getDragLabel(u,v){if(this.d.getDragLabel)return this.d.getDragLabel(u,v)}onDragStart(u,v){this.d.onDragStart?.(u,v)}onDragOver(u,v,l,w,C){return this.d.onDragOver(u,v,l,w,C)}onDragLeave(u,v,l,w){this.d.onDragLeave?.(u,v,l,w)}onDragEnd(u){this.d.onDragEnd?.(u)}drop(u,v,l,w,C){this.d.drop(u,v,l,w,C)}dispose(){this.d.dispose()}}class Me{get onDidChangeFocus(){return c.Event.map(this.g.wrapEvent(this.c.onChange),u=>this.G(u),this.y)}get onDidChangeSelection(){return c.Event.map(this.g.wrapEvent(this.d.onChange),u=>this.G(u),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let u=!1;const v=c.Event.chain(this.y.add(new T.$IT(this.k.domNode,"keydown")).event,C=>C.map(s=>new O.$DR(s)).filter(s=>u=s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$BS.stop(s,!0)).filter(()=>!1)),l=c.Event.chain(this.y.add(new T.$IT(this.k.domNode,"keyup")).event,C=>C.forEach(()=>u=!1).map(s=>new O.$DR(s)).filter(s=>s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$BS.stop(s,!0)).map(({browserEvent:s})=>{const D=this.getFocus(),$=D.length?D[0]:void 0,I=typeof $<"u"?this.k.element($):void 0,M=typeof $<"u"?this.k.domElement($):this.k.domNode;return{index:$,element:I,anchor:M,browserEvent:s}})),w=c.Event.chain(this.k.onContextMenu,C=>C.filter(s=>!u).map(({element:s,index:D,browserEvent:$})=>({element:s,index:D,anchor:new o.$yR((0,i.getWindow)(this.k.domNode),$),browserEvent:$})));return c.Event.any(v,l,w)}get onKeyDown(){return this.y.add(new T.$IT(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new T.$IT(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new T.$IT(this.k.domNode,"keypress")).event}get onDidFocus(){return c.Event.signal(this.y.add(new T.$IT(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return c.Event.signal(this.y.add(new T.$IT(this.k.domNode,"blur",!0)).event)}constructor(u,v,l,w,C=le){this.A=u,this.B=C,this.c=new k("focused"),this.f=new k("anchor"),this.g=new c.$je,this.x="",this.y=new e.$Tc,this.z=new c.$be,this.onDidDispose=this.z.event;const s=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new N(s!=="listbox");const D=[this.c.renderer,this.d.renderer];this.u=C.accessibilityProvider,this.u&&(D.push(new Ne(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),w=w.map(I=>new ve(I.templateId,[...D,I]));const $={...C,dnd:C.dnd&&new Te(this,C.dnd)};if(this.k=this.C(v,l,w,$),this.k.domNode.setAttribute("role",s),C.styleController)this.q=C.styleController(this.k.domId);else{const I=(0,i.$oS)(this.k.domNode);this.q=new ue(I,this.k.domId)}if(this.o=new A.$MT([new R(this.c,this.k,C.identityProvider),new R(this.d,this.k,C.identityProvider),new R(this.f,this.k,C.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ge(this,this.k)),(typeof C.keyboardSupport!="boolean"||C.keyboardSupport)&&(this.v=new V(this,this.k,C),this.y.add(this.v)),C.keyboardNavigationLabelProvider){const I=C.keyboardNavigationDelegate||t.$8T;this.t=new ee(this,this.k,C.keyboardNavigationLabelProvider,C.keyboardNavigationEventFilter??(()=>!0),I),this.y.add(this.t)}this.w=this.D(C),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(u,v,l,w){return new y.$VT(u,v,l,w)}D(u){return new _(this)}updateOptions(u={}){this.B={...this.B,...u},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(u),this.v?.updateOptions(u),this.k.updateOptions(u)}get options(){return this.B}splice(u,v,l=[]){if(u<0||u>this.k.length)throw new g.$XT(this.A,`Invalid start index: ${u}`);if(v<0)throw new g.$XT(this.A,`Invalid delete count: ${v}`);v===0&&l.length===0||this.g.bufferEvents(()=>this.o.splice(u,v,l))}updateWidth(u){this.k.updateWidth(u)}updateElementHeight(u,v){this.k.updateElementHeight(u,v,null)}rerender(){this.k.rerender()}element(u){return this.k.element(u)}indexOf(u){return this.k.indexOf(u)}indexAt(u){return this.k.indexAt(u)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(u){this.k.setScrollTop(u)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(u){this.k.setScrollLeft(u)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(u){this.x=u,this.k.domNode.setAttribute("aria-label",u)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(u,v){this.k.layout(u,v)}triggerTypeNavigation(){this.t?.trigger()}setSelection(u,v){for(const l of u)if(l<0||l>=this.length)throw new g.$XT(this.A,`Invalid index ${l}`);this.d.set(u,v)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(u=>this.k.element(u))}setAnchor(u){if(typeof u>"u"){this.f.set([]);return}if(u<0||u>=this.length)throw new g.$XT(this.A,`Invalid index ${u}`);this.f.set([u])}getAnchor(){return(0,m.$Ob)(this.f.get(),void 0)}getAnchorElement(){const u=this.getAnchor();return typeof u>"u"?void 0:this.element(u)}setFocus(u,v){for(const l of u)if(l<0||l>=this.length)throw new g.$XT(this.A,`Invalid index ${l}`);this.c.set(u,v)}focusNext(u=1,v=!1,l,w){if(this.length===0)return;const C=this.c.get(),s=this.E(C.length>0?C[0]+u:0,v,w);s>-1&&this.setFocus([s],l)}focusPrevious(u=1,v=!1,l,w){if(this.length===0)return;const C=this.c.get(),s=this.F(C.length>0?C[0]-u:0,v,w);s>-1&&this.setFocus([s],l)}async focusNextPage(u,v){let l=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);l=l===0?0:l-1;const w=this.getFocus()[0];if(w!==l&&(w===void 0||l>w)){const C=this.F(l,!1,v);C>-1&&w!==C?this.setFocus([C],u):this.setFocus([l],u)}else{const C=this.k.getScrollTop();let s=C+this.k.renderHeight;l>w&&(s-=this.k.elementHeight(l)),this.k.setScrollTop(s),this.k.getScrollTop()!==C&&(this.setFocus([]),await(0,b.$rh)(0),await this.focusNextPage(u,v))}}async focusPreviousPage(u,v,l=()=>0){let w;const C=l(),s=this.k.getScrollTop()+C;s===0?w=this.k.indexAt(s):w=this.k.indexAfter(s-1);const D=this.getFocus()[0];if(D!==w&&(D===void 0||D>=w)){const $=this.E(w,!1,v);$>-1&&D!==$?this.setFocus([$],u):this.setFocus([w],u)}else{const $=s;this.k.setScrollTop(s-this.k.renderHeight-C),this.k.getScrollTop()+l()!==$&&(this.setFocus([]),await(0,b.$rh)(0),await this.focusPreviousPage(u,v,l))}}focusLast(u,v){if(this.length===0)return;const l=this.F(this.length-1,!1,v);l>-1&&this.setFocus([l],u)}focusFirst(u,v){this.focusNth(0,u,v)}focusNth(u,v,l){if(this.length===0)return;const w=this.E(u,!1,l);w>-1&&this.setFocus([w],v)}E(u,v=!1,l){for(let w=0;w<this.length;w++){if(u>=this.length&&!v)return-1;if(u=u%this.length,!l||l(this.element(u)))return u;u++}return-1}F(u,v=!1,l){for(let w=0;w<this.length;w++){if(u<0&&!v)return-1;if(u=(this.length+u%this.length)%this.length,!l||l(this.element(u)))return u;u--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(u=>this.k.element(u))}reveal(u,v,l=0){if(u<0||u>=this.length)throw new g.$XT(this.A,`Invalid index ${u}`);const w=this.k.getScrollTop(),C=this.k.elementTop(u),s=this.k.elementHeight(u);if((0,h.$8f)(v)){const D=s-this.k.renderHeight+l;this.k.setScrollTop(D*(0,n.$vm)(v,0,1)+C-l)}else{const D=C+s,$=w+this.k.renderHeight;C<w+l&&D>=$||(C<w+l||D>=$&&s>=this.k.renderHeight?this.k.setScrollTop(C-l):D>=$&&this.k.setScrollTop(D-this.k.renderHeight))}}getRelativeTop(u,v=0){if(u<0||u>=this.length)throw new g.$XT(this.A,`Invalid index ${u}`);const l=this.k.getScrollTop(),w=this.k.elementTop(u),C=this.k.elementHeight(u);if(w<l+v||w+C>l+this.k.renderHeight)return null;const s=C-this.k.renderHeight+v;return Math.abs((l+v-w)/s)}isDOMFocused(){return(0,i.$hS)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(u){return this.k.getElementDomId(u)}getElementTop(u){return this.k.elementTop(u)}style(u){this.q.style(u)}G({indexes:u,browserEvent:v}){return{indexes:u,elements:u.map(l=>this.k.element(l)),browserEvent:v}}H(){const u=this.c.get();this.k.domNode.classList.toggle("element-focused",u.length>0),this.I()}I(){const u=this.c.get();if(u.length>0){let v;this.u?.getActiveDescendantId&&(v=this.u.getActiveDescendantId(this.k.element(u[0]))),this.k.domNode.setAttribute("aria-activedescendant",v||this.k.getElementDomId(u[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const u=this.d.get();this.k.domNode.classList.toggle("selection-none",u.length===0),this.k.domNode.classList.toggle("selection-single",u.length===1),this.k.domNode.classList.toggle("selection-multiple",u.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$bU=Me,Je([j.$Uh],Me.prototype,"onDidChangeFocus",null),Je([j.$Uh],Me.prototype,"onDidChangeSelection",null),Je([j.$Uh],Me.prototype,"onContextMenu",null),Je([j.$Uh],Me.prototype,"onKeyDown",null),Je([j.$Uh],Me.prototype,"onKeyUp",null),Je([j.$Uh],Me.prototype,"onKeyPress",null),Je([j.$Uh],Me.prototype,"onDidFocus",null),Je([j.$Uh],Me.prototype,"onDidBlur",null)}),define(be[137],$e([1,0,6,62,47,9,16]),function(se,t,i,T,O,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nk=t.MarkdownStringTextNewlineStyle=void 0,t.$Ok=b,t.$Pk=p,t.$Qk=j,t.$Rk=c,t.$Sk=f,t.$Tk=e,t.$Uk=n,t.$Vk=r;var A;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(A||(t.MarkdownStringTextNewlineStyle=A={}));class m{constructor(g="",y=!1){if(this.value=g,typeof this.value!="string")throw(0,i.$7)("value");typeof y=="boolean"?(this.isTrusted=y,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=y.isTrusted??void 0,this.supportThemeIcons=y.supportThemeIcons??!1,this.supportHtml=y.supportHtml??!1)}appendText(g,y=0){return this.value+=c(this.supportThemeIcons?(0,T.$Hk)(g):g).replace(/([ \t]+)/g,(o,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,y===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,y){return this.value+=`
${f(y,g)}
`,this}appendLink(g,y,o){return this.value+="[",this.value+=this.c(y,"]"),this.value+="](",this.value+=this.c(String(g),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(g,y){const o=new RegExp((0,H.$8e)(y),"g");return g.replace(o,(d,a)=>g.charAt(a-1)!=="\\"?`\\${d}`:d)}}t.$Nk=m;function b(h){return p(h)?!h.value:Array.isArray(h)?h.every(b):!0}function p(h){return h instanceof m?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function j(h,g){return h===g?!0:!h||!g?!1:h.value===g.value&&h.isTrusted===g.isTrusted&&h.supportThemeIcons===g.supportThemeIcons&&h.supportHtml===g.supportHtml&&(h.baseUri===g.baseUri||!!h.baseUri&&!!g.baseUri&&(0,O.$Wg)(S.URI.from(h.baseUri),S.URI.from(g.baseUri)))}function c(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function f(h,g){const y=h.match(/^`+/gm)?.reduce((d,a)=>d.length>a.length?d:a).length??0,o=y>=3?y+1:3;return[`${"`".repeat(o)}${g}`,h,`${"`".repeat(o)}`].join(`
`)}function e(h){return h.replace(/"/g,"&quot;")}function n(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(h){const g=[],y=h.split("|").map(d=>d.trim());h=y[0];const o=y[1];if(o){const d=/height=(\d+)/.exec(o),a=/width=(\d+)/.exec(o),k=d?d[1]:"",N=a?a[1]:"",R=isFinite(parseInt(N)),L=isFinite(parseInt(k));R&&g.push(`width="${N}"`),L&&g.push(`height="${k}"`)}return{href:h,dimensions:g}}}),define(be[138],$e([1,0,4,129,24,66,15,20,130,6,3,137,62,86,23,2,88,64,36,61,47,9,16]),function(se,t,i,T,O,H,S,A,m,b,p,j,c,f,e,n,r,h,g,y,o,d,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fU=void 0,t.$eU=N,t.$gU=z,t.$hU=W,t.$iU=ae;const k=Object.freeze({image:(U,re,me)=>{let ve=[],Ne=[];return U&&({href:U,dimensions:ve}=(0,j.$Vk)(U),Ne.push(`src="${(0,j.$Tk)(U)}"`)),me&&Ne.push(`alt="${(0,j.$Tk)(me)}"`),re&&Ne.push(`title="${(0,j.$Tk)(re)}"`),ve.length&&(Ne=Ne.concat(ve)),"<img "+Ne.join(" ")+">"},paragraph:U=>`<p>${U}</p>`,link:(U,re,me)=>typeof U!="string"?"":(U===me&&(me=(0,j.$Uk)(me)),re=typeof re=="string"?(0,j.$Tk)((0,j.$Uk)(re)):"",U=(0,j.$Uk)(U),U=U.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${U}" title="${re||U}" draggable="false">${me}</a>`)});function N(U,re={},me={}){const ve=new n.$Tc;let Ne=!1;const Te=(0,H.$HT)(re),Me=function($){let I;try{I=(0,h.$Yh)(decodeURIComponent($))}catch{}return I?(I=(0,y.$Yn)(I,M=>{if(U.uris&&U.uris[M])return a.URI.revive(U.uris[M])}),encodeURIComponent(JSON.stringify(I))):$},x=function($,I){const M=U.uris&&U.uris[$];let Y=a.URI.revive(M);return I?$.startsWith(g.Schemas.data+":")?$:(Y||(Y=a.URI.parse($)),g.$Kg.uriToBrowserUri(Y).toString(!0)):!Y||a.URI.parse($).toString()===Y.toString()?$:(Y.query&&(Y=Y.with({query:Me(Y.query)})),Y.toString())},u=new r.marked.Renderer;u.image=k.image,u.link=k.link,u.paragraph=k.paragraph;const v=[],l=[];if(re.codeBlockRendererSync?u.code=($,I)=>{const M=f.$jP.nextId(),Y=re.codeBlockRendererSync(R(I),$);return l.push([M,Y]),`<div class="code" data-code="${M}">${(0,d.$7e)($)}</div>`}:re.codeBlockRenderer&&(u.code=($,I)=>{const M=f.$jP.nextId(),Y=re.codeBlockRenderer(R(I),$);return v.push(Y.then(J=>[M,J])),`<div class="code" data-code="${M}">${(0,d.$7e)($)}</div>`}),re.actionHandler){const $=function(Y){let J=Y.target;if(!(J.tagName!=="A"&&(J=J.parentElement,!J||J.tagName!=="A")))try{let oe=J.dataset.href;oe&&(U.baseUri&&(oe=L(a.URI.from(U.baseUri),oe)),re.actionHandler.callback(oe,Y))}catch(oe){(0,b.$1)(oe)}finally{Y.preventDefault()}},I=re.actionHandler.disposables.add(new O.$IT(Te,"click")),M=re.actionHandler.disposables.add(new O.$IT(Te,"auxclick"));re.actionHandler.disposables.add(p.Event.any(I.event,M.event)(Y=>{const J=new A.$yR(i.getWindow(Te),Y);!J.leftButton&&!J.middleButton||$(J)})),re.actionHandler.disposables.add(i.$GR(Te,"keydown",Y=>{const J=new S.$DR(Y);!J.equals(10)&&!J.equals(3)||$(J)}))}U.supportHtml||(me.sanitizer=$=>(U.isTrusted?$.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?$:"",me.sanitize=!0,me.silent=!0),me.renderer=u;let w=U.value??"";w.length>1e5&&(w=`${w.substr(0,1e5)}\u2026`),U.supportThemeIcons&&(w=(0,c.$Ik)(w));let C;if(re.fillInIncompleteTokens){const $={...r.marked.defaults,...me},I=r.marked.lexer(w,$),M=ae(I);C=r.marked.parser(M,$)}else C=r.marked.parse(w,me);U.supportThemeIcons&&(C=(0,m.$cU)(C).map(I=>typeof I=="string"?I:I.outerHTML).join(""));const D=new DOMParser().parseFromString(P(U,C),"text/html");if(D.body.querySelectorAll("img, audio, video, source").forEach($=>{const I=$.getAttribute("src");if(I){let M=I;try{U.baseUri&&(M=L(a.URI.from(U.baseUri),M))}catch{}if($.setAttribute("src",x(M,!0)),re.disallowRemoteImages){const Y=a.URI.parse(M).scheme;Y!==g.Schemas.file&&Y!==g.Schemas.data&&$.replaceWith(i.$("",void 0,$.outerHTML))}}}),D.body.querySelectorAll("a").forEach($=>{const I=$.getAttribute("href");if($.setAttribute("href",""),!I||/^data:|javascript:/i.test(I)||/^command:/i.test(I)&&!U.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(I))$.replaceWith(...$.childNodes);else{let M=x(I,!1);U.baseUri&&(M=L(a.URI.from(U.baseUri),I)),$.dataset.href=M}}),Te.innerHTML=P(U,D.body.innerHTML),v.length>0)Promise.all(v).then($=>{if(Ne)return;const I=new Map($),M=Te.querySelectorAll("div[data-code]");for(const Y of M){const J=I.get(Y.dataset.code??"");J&&i.$IS(Y,J)}re.asyncRenderCallback?.()});else if(l.length>0){const $=new Map(l),I=Te.querySelectorAll("div[data-code]");for(const M of I){const Y=$.get(M.dataset.code??"");Y&&i.$IS(M,Y)}}if(re.asyncRenderCallback)for(const $ of Te.getElementsByTagName("img")){const I=ve.add(i.$GR($,"load",()=>{I.dispose(),re.asyncRenderCallback()}))}return{element:Te,dispose:()=>{Ne=!0,ve.dispose()}}}function R(U){if(!U)return"";const re=U.split(/[\s+|:|,|\{|\?]/,1);return re.length?re[0]:U}function L(U,re){return/^\w[\w\d+.-]*:/.test(re)?re:U.path.endsWith("/")?(0,o.$7g)(U,re).toString():(0,o.$7g)((0,o.$3g)(U),re).toString()}function P(U,re){const{config:me,allowedSchemes:ve}=E(U);T.addHook("uponSanitizeAttribute",(Te,Me)=>{if(Me.attrName==="style"||Me.attrName==="class"){if(Te.tagName==="SPAN"){if(Me.attrName==="style"){Me.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Me.attrValue);return}else if(Me.attrName==="class"){Me.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Me.attrValue);return}}Me.keepAttr=!1;return}else if(Te.tagName==="INPUT"&&Te.attributes.getNamedItem("type")?.value==="checkbox"){if(Me.attrName==="type"&&Me.attrValue==="checkbox"||Me.attrName==="disabled"||Me.attrName==="checked"){Me.keepAttr=!0;return}Me.keepAttr=!1}}),T.addHook("uponSanitizeElement",(Te,Me)=>{Me.tagName==="input"&&(Te.attributes.getNamedItem("type")?.value==="checkbox"?Te.setAttribute("disabled",""):Te.parentElement?.removeChild(Te))});const Ne=i.$3S(ve);try{return T.sanitize(re,{...me,RETURN_TRUSTED_TYPE:!0})}finally{T.removeHook("uponSanitizeAttribute"),Ne.dispose()}}t.$fU=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function E(U){const re=[g.Schemas.http,g.Schemas.https,g.Schemas.mailto,g.Schemas.data,g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemote,g.Schemas.vscodeRemoteResource];return U.isTrusted&&re.push(g.Schemas.command),{config:{ALLOWED_TAGS:[...i.$4S],ALLOWED_ATTR:t.$fU,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:re}}function z(U){return typeof U=="string"?U:W(U)}function W(U){let re=U.value??"";re.length>1e5&&(re=`${re.substr(0,1e5)}\u2026`);const me=r.marked.parse(re,{renderer:K.value}).replace(/&(#\d+|[a-zA-Z]+);/g,ve=>F.get(ve)??ve);return P({isTrusted:!1},me).toString()}const F=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),K=new e.$V(()=>{const U=new r.marked.Renderer;return U.code=re=>re,U.blockquote=re=>re,U.html=re=>"",U.heading=(re,me,ve)=>re+`
`,U.hr=()=>"",U.list=(re,me)=>re,U.listitem=re=>re+`
`,U.paragraph=re=>re+`
`,U.table=(re,me)=>re+me+`
`,U.tablerow=re=>re,U.tablecell=(re,me)=>re+" ",U.strong=re=>re,U.em=re=>re,U.codespan=re=>re,U.br=()=>`
`,U.del=re=>re,U.image=(re,me,ve)=>"",U.text=re=>re,U.link=(re,me,ve)=>ve,U});function B(U){let re="";return U.forEach(me=>{re+=me.raw}),re}function G(U){for(let re=0;re<U.tokens.length;re++){const me=U.tokens[re];if(me.type==="text"){const ve=me.raw.split(`
`),Ne=ve[ve.length-1];if(Ne.includes("`"))return ee(U);if(Ne.includes("**"))return _(U);if(Ne.match(/\*\w/))return ge(U);if(Ne.match(/(^|\s)__\w/))return ue(U);if(Ne.match(/(^|\s)_\w/))return Ee(U);if(Ne.match(/(^|\s)\[.*\]\(\w*/)){const Te=U.tokens.slice(re+1);return Te[0]?.type==="link"&&Te[1]?.type==="text"&&Te[1].raw.match(/^ *"[^"]*$/)?Le(U):De(U)}else{if(V(Ne))return De(U);if(Ne.match(/(^|\s)\[\w/)&&!U.tokens.slice(re+1).some(Te=>V(Te.raw)))return he(U)}}}}function V(U){return!!U.match(/^[^\[]*\]\([^\)]*$/)}function ae(U){let re,me;for(re=0;re<U.length;re++){const ve=U[re];let Ne;if(ve.type==="paragraph"&&(Ne=ve.raw.match(/(\n|^)(````*)/))){const Te=Ne[2];me=ie(U.slice(re),Te);break}if(ve.type==="paragraph"&&ve.raw.match(/(\n|^)\|/)){me=Q(U.slice(re));break}if(re===U.length-1&&ve.type==="paragraph"){const Te=G(ve);if(Te){me=[Te];break}}}if(me){const ve=[...U.slice(0,re),...me];return ve.links=U.links,ve}return U}function ie(U,re){const me=B(U);return r.marked.lexer(me+`
${re}`)}function ee(U){return le(U,"`")}function ge(U){return le(U,"*")}function Ee(U){return le(U,"_")}function De(U){return le(U,")")}function Le(U){return le(U,'")')}function he(U){return le(U,"](about:blank)")}function _(U){return le(U,"**")}function ue(U){return le(U,"__")}function le(U,re){const me=B(Array.isArray(U)?U:[U]);return r.marked.lexer(me+re)[0]}function Q(U){const re=B(U),me=re.split(`
`);let ve,Ne=!1;for(let Te=0;Te<me.length;Te++){const Me=me[Te].trim();if(typeof ve>"u"&&Me.match(/^\s*\|/)){const x=Me.match(/(\|[^\|]+)(?=\||$)/g);x&&(ve=x.length)}else if(typeof ve=="number")if(Me.match(/^\s*\|/)){if(Te!==me.length-1)return;Ne=!0}else return}if(typeof ve=="number"&&ve>0){const Te=Ne?me.slice(0,-1).join(`
`):re,Me=!!Te.match(/\|\s*$/),x=Te+(Me?"":"|")+`
|${" --- |".repeat(ve)}`;return r.marked.lexer(x)}}}),define(be[139],$e([1,0,4,24,15,138,29,14,49,8,3,54,2,5,121,113]),function(se,t,i,T,O,H,S,A,m,b,p,j,c,f,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lU=void 0;const n=i.$,r="selectOption.entry.template";class h{get templateId(){return r}renderTemplate(o){const d=Object.create(null);return d.root=o,d.text=i.$GS(o,n(".option-text")),d.detail=i.$GS(o,n(".option-detail")),d.decoratorRight=i.$GS(o,n(".option-decorator-right")),d}renderElement(o,d,a){const k=a,N=o.text,R=o.detail,L=o.decoratorRight,P=o.isDisabled;k.text.textContent=N,k.detail.textContent=R||"",k.decoratorRight.innerText=L||"",P?k.root.classList.add("option-disabled"):k.root.classList.remove("option-disabled")}disposeTemplate(o){}}class g extends c.$Uc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(o,d,a,k,N){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=k,this.g=N||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=g.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new p.$be,this.B(this.r),this.Q(),this.P(a),this.n=d||0,o&&this.setOptions(o,d),this.S()}O(o){!this.M&&o?this.M=this.B((0,S.$kU)().setupUpdatableHover((0,A.$yT)("mouse"),this.h,o)):this.M&&this.M.update(o)}getHeight(){return 22}getTemplateId(){return r}P(o){this.u=o,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$GS(this.w,n(".select-box-details-pane"));const d=i.$GS(this.w,n(".select-box-dropdown-container-width-control")),a=i.$GS(d,n(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$GS(a,this.D),this.G=0,this.y=i.$oS(this.w),this.w.setAttribute("draggable","true"),this.B(i.$GR(this.w,i.$zS.DRAG_START,k=>{i.$BS.stop(k,!0)}))}Q(){this.B(i.$HR(this.h,"change",d=>{this.n=d.target.selectedIndex,this.r.fire({index:d.target.selectedIndex,selected:d.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$GR(this.h,i.$zS.CLICK,d=>{i.$BS.stop(d),this.f?this.Z(!0):this.Y()})),this.B(i.$GR(this.h,i.$zS.MOUSE_DOWN,d=>{i.$BS.stop(d)}));let o;this.B(i.$GR(this.h,"touchstart",d=>{o=this.f})),this.B(i.$GR(this.h,"touchend",d=>{i.$BS.stop(d),o?this.Z(!0):this.Y()})),this.B(i.$GR(this.h,i.$zS.KEY_DOWN,d=>{const a=new O.$DR(d);let k=!1;f.$j?(a.keyCode===18||a.keyCode===16||a.keyCode===10||a.keyCode===3)&&(k=!0):(a.keyCode===18&&a.altKey||a.keyCode===16&&a.altKey||a.keyCode===10||a.keyCode===3)&&(k=!0),k&&(this.Y(),i.$BS.stop(d,!0))}))}get onDidSelect(){return this.r.event}setOptions(o,d){b.$ub(this.m,o)||(this.m=o,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((a,k)=>{this.h.add(this.X(a.text,k,a.isDisabled)),typeof a.description=="string"&&(this.H=!0)})),d!==void 0&&(this.select(d),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(o){o>=0&&o<this.m.length?this.n=o:o>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(o){this.g.ariaLabel=o,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(o){this.h.tabIndex=o?0:-1}render(o){this.j=o,o.classList.add("select-container"),o.appendChild(this.h),this.U()}S(){const o=[];this.s.listFocusBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(o.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=o.join(`
`)}U(){const o=this.s.selectBackground??"",d=this.s.selectForeground??"",a=this.s.selectBorder??"";this.h.style.backgroundColor=o,this.h.style.color=d,this.h.style.borderColor=a}W(){const o=this.s.selectBackground??"",d=i.$YS(this.s.selectListBackground,o);this.C.style.backgroundColor=d,this.I.style.backgroundColor=d;const a=this.s.focusBorder??"";this.w.style.outlineColor=a,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(o,d,a){const k=document.createElement("option");return k.value=o,k.text=o,k.disabled=!!a,k}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.ab(o,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.ab(o),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(o){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),o&&this.h.focus(),this.u.hideContextView())}ab(o,d){return o.appendChild(this.w),this.cb(d),{dispose:()=>{try{o.removeChild(this.w)}catch{}}}}bb(){let o=0;return this.m.forEach((d,a)=>{this.jb(a),this.I.offsetHeight>o&&(o=this.I.offsetHeight)}),o}cb(o){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const d=i.getWindow(this.h),a=i.$3R(this.h),k=i.getWindow(this.h).getComputedStyle(this.h),N=parseFloat(k.getPropertyValue("--dropdown-padding-top"))+parseFloat(k.getPropertyValue("--dropdown-padding-bottom")),R=d.innerHeight-a.top-a.height-(this.g.minBottomMargin||0),L=a.top-g.b,P=this.h.offsetWidth,E=this.db(this.D),z=Math.max(E,Math.round(P)).toString()+"px";this.w.style.width=z,this.z.getHTMLElement().style.height="",this.z.layout();let W=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const F=this.H?this.L:0,K=W+N+F,B=Math.floor((R-N-F)/this.getHeight()),G=Math.floor((L-N-F)/this.getHeight());if(o)return a.top+a.height>d.innerHeight-22||a.top<g.b||B<1&&G<1?!1:(B<g.c&&G>B&&this.m.length>B?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(a.top+a.height>d.innerHeight-22||a.top<g.b||this.G===0&&B<1||this.G===1&&G<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&B+G<1)return this.Z(!0),!1;K>R&&(W=B*this.getHeight())}else K>L&&(W=G*this.getHeight());return this.z.layout(W),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=W+N+"px",this.w.style.height=""):this.w.style.height=W+N+"px",this.jb(this.n),this.w.style.width=z,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(o){let d=0;if(o){let a=0,k=0;this.m.forEach((N,R)=>{const L=N.detail?N.detail.length:0,P=N.decoratorRight?N.decoratorRight.length:0,E=N.text.length+L+P;E>k&&(a=R,k=E)}),o.textContent=this.m[a].text+(this.m[a].decoratorRight?this.m[a].decoratorRight+" ":""),d=i.$5R(o)}return d}eb(o){if(this.z)return;this.C=i.$GS(o,n(".select-box-dropdown-list-container")),this.t=new h,this.z=new m.$bU("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:k=>{let N=k.text;return k.detail&&(N+=`. ${k.detail}`),k.decoratorRight&&(N+=`. ${k.decoratorRight}`),k.description&&(N+=`. ${k.description}`),N},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>f.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const d=this.B(new T.$IT(this.C,"keydown")),a=p.Event.chain(d.event,k=>k.filter(()=>this.z.length>0).map(N=>new O.$DR(N)));this.B(p.Event.chain(a,k=>k.filter(N=>N.keyCode===3))(this.lb,this)),this.B(p.Event.chain(a,k=>k.filter(N=>N.keyCode===2))(this.lb,this)),this.B(p.Event.chain(a,k=>k.filter(N=>N.keyCode===9))(this.kb,this)),this.B(p.Event.chain(a,k=>k.filter(N=>N.keyCode===16))(this.nb,this)),this.B(p.Event.chain(a,k=>k.filter(N=>N.keyCode===18))(this.mb,this)),this.B(p.Event.chain(a,k=>k.filter(N=>N.keyCode===12))(this.pb,this)),this.B(p.Event.chain(a,k=>k.filter(N=>N.keyCode===11))(this.ob,this)),this.B(p.Event.chain(a,k=>k.filter(N=>N.keyCode===14))(this.qb,this)),this.B(p.Event.chain(a,k=>k.filter(N=>N.keyCode===13))(this.rb,this)),this.B(p.Event.chain(a,k=>k.filter(N=>N.keyCode>=21&&N.keyCode<=56||N.keyCode>=85&&N.keyCode<=113))(this.sb,this)),this.B(i.$GR(this.z.getHTMLElement(),i.$zS.POINTER_UP,k=>this.fb(k))),this.B(this.z.onMouseOver(k=>typeof k.index<"u"&&this.z.setFocus([k.index]))),this.B(this.z.onDidChangeFocus(k=>this.ib(k))),this.B(i.$GR(this.w,i.$zS.FOCUS_OUT,k=>{!this.f||i.$$R(k.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(o){if(!this.z.length)return;i.$BS.stop(o);const d=o.target;if(!d||d.classList.contains("slider"))return;const a=d.closest(".monaco-list-row");if(!a)return;const k=Number(a.getAttribute("data-index")),N=a.classList.contains("option-disabled");k>=0&&k<this.m.length&&!N&&(this.n=k,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(o,d){const a=N=>{for(let R=0;R<N.childNodes.length;R++){const L=N.childNodes.item(R);(L.tagName&&L.tagName.toLowerCase())==="img"?N.removeChild(L):a(L)}},k=(0,H.$eU)({value:o,supportThemeIcons:!0},{actionHandler:d});return k.element.classList.add("select-box-description-markdown"),a(k.element),k.element}ib(o){!this.f||!this.H||this.jb(o.indexes[0])}jb(o){this.I.innerText="";const d=this.m[o],a=d?.description??"",k=d?.descriptionIsMarkdown??!1;if(a){if(k){const N=d.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(a,N))}else this.I.innerText=a;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(o){i.$BS.stop(o),this.select(this.F),this.Z(!0)}lb(o){i.$BS.stop(o),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(o){if(this.n<this.m.length-1){i.$BS.stop(o,!0);const d=this.m[this.n+1].isDisabled;if(d&&this.m.length>this.n+2)this.n+=2;else{if(d)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(o){this.n>0&&(i.$BS.stop(o,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(o){i.$BS.stop(o),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(o){i.$BS.stop(o),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(o){i.$BS.stop(o),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(o){i.$BS.stop(o),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(o){const d=j.KeyCodeUtils.toString(o.keyCode);let a=-1;for(let k=0;k<this.m.length-1;k++)if(a=(k+this.n+1)%this.m.length,this.m[a].text.charAt(0).toUpperCase()===d&&!this.m[a].isDisabled){this.select(a),this.z.setFocus([a]),this.z.reveal(this.z.getFocus()[0]),i.$BS.stop(o);break}}dispose(){this.Z(!1),super.dispose()}}t.$lU=g}),define(be[140],$e([1,0,49,139,133,21,5,112]),function(se,t,i,T,O,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oU=t.$nU=void 0,t.$nU={...i.$aU,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends H.$hT{constructor(b,p,j,c,f){super(),S.$j&&!f?.useCustomDrawn?this.a=new O.$mU(b,p,c,f):this.a=new T.$lU(b,p,j,c,f),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(b,p){this.a.setOptions(b,p)}select(b){this.a.select(b)}setAriaLabel(b){this.a.setAriaLabel(b)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(b){this.a.setFocusable(b)}render(b){this.a.render(b)}}t.$oU=A}),define(be[73],$e([1,0,17,65,4,28,14,140,46,2,5,10,117,29,63]),function(se,t,i,T,O,H,S,A,m,b,p,j,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wU=t.$vU=t.$uU=void 0;class e extends b.$Uc{get action(){return this._action}constructor(g,y,o={}){super(),this.m=o,this._context=g||this,this._action=y,y instanceof m.$8i&&this.B(y.onDidChange(d=>{this.element&&this.t(d)}))}t(g){g.enabled!==void 0&&this.u(),g.checked!==void 0&&this.H(),g.class!==void 0&&this.G(),g.label!==void 0&&(this.w(),this.D()),g.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new m.$9i)),this.j}set actionRunner(g){this.j=g}isEnabled(){return this._action.enabled}setActionContext(g){this._context=g}render(g){const y=this.element=g;this.B(H.$dT.addTarget(g));const o=this.m&&this.m.draggable;o&&(g.draggable=!0,i.$mR&&this.B((0,O.$GR)(g,O.$zS.DRAG_START,d=>d.dataTransfer?.setData(T.$bT.TEXT,this._action.label)))),this.B((0,O.$GR)(y,H.EventType.Tap,d=>this.onClick(d,!0))),this.B((0,O.$GR)(y,O.$zS.MOUSE_DOWN,d=>{o||O.$BS.stop(d,!0),this._action.enabled&&d.button===0&&y.classList.add("active")})),p.$j&&this.B((0,O.$GR)(y,O.$zS.CONTEXT_MENU,d=>{d.button===0&&d.ctrlKey===!0&&this.onClick(d)})),this.B((0,O.$GR)(y,O.$zS.CLICK,d=>{O.$BS.stop(d,!0),this.m&&this.m.isMenu||this.onClick(d)})),this.B((0,O.$GR)(y,O.$zS.DBLCLICK,d=>{O.$BS.stop(d,!0)})),[O.$zS.MOUSE_UP,O.$zS.MOUSE_OUT].forEach(d=>{this.B((0,O.$GR)(y,d,a=>{O.$BS.stop(a),y.classList.remove("active")}))})}onClick(g,y=!1){O.$BS.stop(g,!0);const o=j.$ag(this._context)?this.m?.useEventAsContext?g:{preserveFocus:y}:this._context;this.actionRunner.run(this._action,o)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(g){this.element&&(this.element.tabIndex=g?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const g=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=g;else if(!this.f&&g!==""){const y=this.m.hoverDelegate??(0,S.$yT)("element");this.f=this.q.add((0,f.$kU)().setupUpdatableHover(y,this.element,g))}else this.f&&this.f.update(g)}F(){if(this.element){const g=this.C()??"";this.element.setAttribute("aria-label",g)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$uU=e;class n extends e{constructor(g,y,o){super(g,y,o),this.m=o,this.m.icon=o.icon!==void 0?o.icon:!1,this.m.label=o.label!==void 0?o.label:!0,this.L=""}render(g){super.render(g),j.$bg(this.element);const y=document.createElement("a");if(y.classList.add("action-label"),y.setAttribute("role",this.M()),this.I=y,this.element.appendChild(y),this.m.label&&this.m.keybinding){const o=document.createElement("span");o.classList.add("keybinding"),o.textContent=this.m.keybinding,this.element.appendChild(o)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===m.$0i.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(g){this.I&&(this.I.tabIndex=g?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let g=null;return this.action.tooltip?g=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(g=this.action.label,this.m.keybinding&&(g=c.localize(0,null,g,this.m.keybinding))),g??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const g=this.C()??"";this.I.setAttribute("aria-label",g)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$vU=n;class r extends e{constructor(g,y,o,d,a,k,N){super(g,y),this.b=new A.$oU(o,d,a,k,N),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(g,y){this.b.setOptions(g,y)}select(g){this.b.select(g)}g(){this.B(this.b.onDidSelect(g=>this.n(g.selected,g.index)))}n(g,y){this.actionRunner.run(this._action,this.r(g,y))}r(g,y){return g}setFocusable(g){this.b.setFocusable(g)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(g){this.b.render(g)}}t.$wU=r}),define(be[74],$e([1,0,4,15,73,14,46,3,2,10,63]),function(se,t,i,T,O,H,S,A,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AT=t.ActionsOrientation=void 0,t.$BT=c;var p;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(p||(t.ActionsOrientation=p={}));class j extends m.$Uc{constructor(e,n={}){super(),this.j=this.B(new m.$Tc),this.s=this.B(new m.$4c),this.y=!1,this.z=!0,this.D=this.B(new A.$be),this.onDidBlur=this.D.event,this.F=this.B(new A.$be({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new A.$be),this.onDidRun=this.H.event,this.I=this.B(new A.$be),this.onWillRun=this.I.event,this.b=n,this.m=n.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=n.hoverDelegate??this.B((0,H.$zT)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new S.$9i,this.j.add(this.g)),this.j.add(this.g.onDidRun(g=>this.H.fire(g))),this.j.add(this.g.onWillRun(g=>this.I.fire(g))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let r,h;switch(this.n){case 0:r=[15],h=[17];break;case 1:r=[16],h=[18],this.domNode.className+=" vertical";break}this.B(i.$GR(this.domNode,i.$zS.KEY_DOWN,g=>{const y=new T.$DR(g);let o=!0;const d=typeof this.u=="number"?this.viewItems[this.u]:void 0;r&&(y.equals(r[0])||y.equals(r[1]))?o=this.Q():h&&(y.equals(h[0])||y.equals(h[1]))?o=this.P():y.equals(9)&&this.G?this.F.fire():y.equals(14)?o=this.N():y.equals(13)?o=this.O():y.equals(2)&&d instanceof O.$uU&&d.trapsArrowNavigation?o=this.P():this.L(y)?this.r.keyDown?this.S(y):this.y=!0:o=!1,o&&(y.preventDefault(),y.stopPropagation())})),this.B(i.$GR(this.domNode,i.$zS.KEY_UP,g=>{const y=new T.$DR(g);this.L(y)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(y)),y.preventDefault(),y.stopPropagation()):(y.equals(2)||y.equals(1026)||y.equals(16)||y.equals(18)||y.equals(15)||y.equals(17))&&this.M()})),this.w=this.B(i.$ES(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$gS()===this.domNode||!i.$$R(i.$gS(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),e.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(e){e?this.C.setAttribute("aria-label",e):this.C.removeAttribute("aria-label")}setFocusable(e){if(this.z=e,this.z){const n=this.viewItems.find(r=>r instanceof O.$uU&&r.isEnabled());n instanceof O.$uU&&n.setFocusable(!0)}else this.viewItems.forEach(n=>{n instanceof O.$uU&&n.setFocusable(!1)})}L(e){let n=!1;return this.r.keys.forEach(r=>{n=n||e.equals(r)}),n}M(){for(let e=0;e<this.C.children.length;e++){const n=this.C.children[e];if(i.$$R(i.$gS(),n)){this.u=e,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(e){this.m=e,this.viewItems.forEach(n=>n.setActionContext(e))}get actionRunner(){return this.g}set actionRunner(e){this.g=e,this.j.clear(),this.j.add(this.g.onDidRun(n=>this.H.fire(n))),this.j.add(this.g.onWillRun(n=>this.I.fire(n))),this.viewItems.forEach(n=>n.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(n=>n.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.C;){if(!e.parentElement)return;e=e.parentElement}for(let n=0;n<this.C.childNodes.length;n++)if(this.C.childNodes[n]===e)return this.viewItems[n].action}}push(e,n={}){const r=Array.isArray(e)?e:[e];let h=b.$8f(n.index)?n.index:null;r.forEach(g=>{const y=document.createElement("li");y.className="action-item",y.setAttribute("role","presentation");let o;const d={hoverDelegate:this.f,...n};this.b.actionViewItemProvider&&(o=this.b.actionViewItemProvider(g,d)),o||(o=new O.$vU(this.context,g,d)),this.b.allowContextMenu||this.s.set(o,i.$GR(y,i.$zS.CONTEXT_MENU,a=>{i.$BS.stop(a,!0)})),o.actionRunner=this.g,o.setActionContext(this.context),o.render(y),this.z&&o instanceof O.$uU&&this.viewItems.length===0&&o.setFocusable(!0),h===null||h<0||h>=this.C.children.length?(this.C.appendChild(y),this.viewItems.push(o)):(this.C.insertBefore(y,this.C.children[h]),this.viewItems.splice(h,0,o),h++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[e]),this.s.deleteAndDispose(this.viewItems[e]),(0,m.$Pc)(this.viewItems.splice(e,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,m.$Pc)(this.viewItems),this.s.clearAndDisposeAll(),i.$FR(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let n=!1,r;if(e===void 0?n=!0:typeof e=="number"?r=e:typeof e=="boolean"&&(n=e),n&&typeof this.u>"u"){const h=this.viewItems.findIndex(g=>g.isEnabled());this.u=h===-1?void 0:h,this.R(void 0,void 0,!0)}else r!==void 0&&(this.u=r),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(e){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const n=this.u;let r;do{if(!e&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=n,!1;this.u=(this.u+1)%this.viewItems.length,r=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===S.$0i.ID));return this.R(),!0}Q(e){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const n=this.u;let r;do{if(this.u=this.u-1,this.u<0){if(!e&&this.b.preventLoopNavigation)return this.u=n,!1;this.u=this.viewItems.length-1}r=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===S.$0i.ID));return this.R(!0),!0}R(e,n,r=!1){typeof this.u>"u"&&this.C.focus({preventScroll:n}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const h=this.u!==void 0?this.viewItems[this.u]:void 0;if(h){let g=!0;b.$fg(h.focus)||(g=!1),this.b.focusOnlyEnabledItems&&b.$fg(h.isEnabled)&&!h.isEnabled()&&(g=!1),h.action.id===S.$0i.ID&&(g=!1),g?(r||this.t!==this.u)&&(h.focus(e),this.t=this.u):(this.C.focus({preventScroll:n}),this.t=void 0),g&&h.showHover?.()}}S(e){if(typeof this.u>"u")return;const n=this.viewItems[this.u];if(n instanceof O.$uU){const r=n._context===null||n._context===void 0?e:n._context;this.run(n._action,r)}}async run(e,n){await this.g.run(e,n)}dispose(){this.m=void 0,this.viewItems=(0,m.$Pc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$AT=j;function c(f){if(!f.length)return f;let e=-1;for(let r=0;r<f.length;r++)if(f[r].id!==S.$0i.ID){e=r;break}if(e===-1)return[];f=f.slice(e);for(let r=f.length-1;r>=0&&f[r].id===S.$0i.ID;r--)f.splice(r,1);let n=!1;for(let r=f.length-1;r>=0;r--){const h=f[r].id===S.$0i.ID;h&&!n?f.splice(r,1):h?h&&(n=!1):n=!0}return f}}),define(be[75],$e([1,0,4,24,66,74,68,29,14,71,21,3,91,61,120,109]),function(se,t,i,T,O,H,S,A,m,b,p,j,c,f,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dV=t.$cV=t.$bV=t.MessageType=void 0;const n=i.$;var r;(function(y){y[y.INFO=1]="INFO",y[y.WARNING=2]="WARNING",y[y.ERROR=3]="ERROR"})(r||(t.MessageType=r={})),t.$bV={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class h extends p.$hT{constructor(o,d,a){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new j.$be),this.onDidChange=this.P.event,this.Q=this.B(new j.$be),this.onDidHeightChange=this.Q.event,this.a=d,this.g=a,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$GS(o,n(".monaco-inputbox.idle"));const k=this.g.flexibleHeight?"textarea":"input",N=i.$GS(this.element,n(".ibwrapper"));if(this.b=i.$GS(N,n(k+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$GS(N,n("div.mirror")),this.y.innerText="\xA0",this.N=new b.$rT(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$GS(o,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(P=>this.b.scrollTop=P.scrollTop));const R=this.B(new T.$IT(o.ownerDocument,"selectionchange")),L=j.Event.filter(R.event,()=>o.ownerDocument.getSelection()?.anchorNode===N);this.B(L(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new H.$AT(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(o){this.n=o,this.b.setAttribute("placeholder",o)}setTooltip(o){this.r=o,this.O?this.O.update(o):this.O=this.B((0,A.$kU)().setupUpdatableHover((0,m.$yT)("mouse"),this.b,o))}setAriaLabel(o){this.s=o,o?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(o){this.b.value!==o&&(this.b.value=o,this.Z())}get step(){return this.b.step}set step(o){this.b.step=o}get height(){return typeof this.J=="number"?this.J:i.$9R(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$hS(this.b)}select(o=null){this.b.select(),o&&(this.b.setSelectionRange(o.start,o.end),o.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const o=this.b.selectionStart;if(o===null)return null;const d=this.b.selectionEnd??o;return{start:o,end:d}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(o){o?this.enable():this.disable()}get width(){return i.$5R(this.b)}set width(o){if(this.g.flexibleHeight&&this.g.flexibleWidth){let d=0;if(this.y){const a=parseFloat(this.y.style.paddingLeft||"")||0,k=parseFloat(this.y.style.paddingRight||"")||0;d=a+k}this.b.style.width=o-d+"px"}else this.b.style.width=o+"px";this.y&&(this.y.style.width=o+"px")}set paddingRight(o){this.b.style.width=`calc(100% - ${o}px)`,this.y&&(this.y.style.paddingRight=o+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const o=this.L,d=this.J,a=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:o,height:d}),this.N.setScrollPosition({scrollTop:a})}showMessage(o,d){if(this.w==="open"&&(0,f.$1n)(this.h,o))return;this.h=o,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(o.type));const a=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$YS(a.border,"transparent")}`,this.h.content&&(this.hasFocus()||d)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let o=null;return this.t&&(o=this.t(this.value),o?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(o)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),o?.type}stylesForType(o){const d=this.g.inputBoxStyles;switch(o){case 1:return{border:d.inputValidationInfoBorder,background:d.inputValidationInfoBackground,foreground:d.inputValidationInfoForeground};case 2:return{border:d.inputValidationWarningBorder,background:d.inputValidationWarningBackground,foreground:d.inputValidationWarningForeground};default:return{border:d.inputValidationErrorBorder,background:d.inputValidationErrorBackground,foreground:d.inputValidationErrorForeground}}}W(o){switch(o){case 1:return"info";case 2:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let o;const d=()=>o.style.width=i.$5R(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:k=>{if(!this.h)return null;o=i.$GS(k,n(".monaco-inputbox-container")),d();const N={inline:!0,className:"monaco-inputbox-message"},R=this.h.formatContent?(0,O.$GT)(this.h.content,N):(0,O.$FT)(this.h.content,N);R.classList.add(this.W(this.h.type));const L=this.stylesForType(this.h.type);return R.style.backgroundColor=L.background??"",R.style.color=L.foreground??"",R.style.border=L.border?`1px solid ${L.border}`:"",i.$GS(o,R),null},onHide:()=>{this.w="closed"},layout:d});let a;this.h.type===3?a=e.localize(0,null,this.h.content):this.h.type===2?a=e.localize(1,null,this.h.content):a=e.localize(2,null,this.h.content),S.$KT(a),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const o=this.value,a=o.charCodeAt(o.length-1)===10?" ":"";(o+a).replace(/\u000c/g,"")?this.y.textContent=o+a:this.y.innerText="\xA0",this.layout()}bb(){const o=this.g.inputBoxStyles,d=o.inputBackground??"",a=o.inputForeground??"",k=o.inputBorder??"";this.element.style.backgroundColor=d,this.element.style.color=a,this.b.style.backgroundColor="inherit",this.b.style.color=a,this.element.style.border=`1px solid ${i.$YS(k,"transparent")}`}layout(){if(!this.y)return;const o=this.L;this.L=i.$9R(this.y),o!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(o){const d=this.inputElement,a=d.selectionStart,k=d.selectionEnd,N=d.value;a!==null&&k!==null&&(this.value=N.substr(0,a)+o+N.substr(k),d.setSelectionRange(a+1,a+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$cV=h;class g extends h{constructor(o,d,a){const k=e.localize(3,null,"\u21C5"),N=e.localize(4,null,"\u21C5");super(o,d,a),this.eb=this.B(new j.$be),this.onDidFocus=this.eb.event,this.fb=this.B(new j.$be),this.onDidBlur=this.fb.event,this.cb=new c.$_U(a.history,100);const R=()=>{if(a.showHistoryHint&&a.showHistoryHint()&&!this.n.endsWith(k)&&!this.n.endsWith(N)&&this.cb.getHistory().length){const L=this.n.endsWith(")")?k:N,P=this.n+L;a.showPlaceholderOnFocus&&!i.$hS(this.b)?this.n=P:this.setPlaceHolder(P)}};this.db=new MutationObserver((L,P)=>{L.forEach(E=>{E.target.textContent||R()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>R()),this.F(this.b,()=>{const L=P=>{if(this.n.endsWith(P)){const E=this.n.slice(0,this.n.length-P.length);return a.showPlaceholderOnFocus?this.n=E:this.setPlaceHolder(E),!0}else return!1};L(N)||L(k)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(o){this.value&&(o||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(o){const d=this.getHistory();this.clearHistory(),o.forEach(a=>{this.cb.add(a)}),d.forEach(a=>{this.cb.add(a)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let o=this.kb();o&&(o=o===this.value?this.kb():o),this.value=o??"",S.$LT(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let o=this.jb();o&&(o=o===this.value?this.jb():o),o&&(this.value=o,S.$LT(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(o){super.setPlaceHolder(o),this.setTooltip(o)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let o=this.cb.current();return o||(o=this.cb.last(),this.cb.next()),o}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$dV=g}),define(be[76],$e([1,0,73,21,18,19,3,4,14,29,114]),function(se,t,i,T,O,H,S,A,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tU=t.$sU=t.$rU=t.$qU=t.$pU=void 0,t.$pU={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class p extends i.$uU{constructor(n,r,h){super(n,r,h),this.a=this.B(new j({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:h.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:h.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:h.toggleStyles?.inputActiveOptionForeground,hoverDelegate:h.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(n){this.element=n,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$qU=p;class j extends T.$hT{constructor(n){super(),this.a=this.B(new S.$be),this.onChange=this.a.event,this.b=this.B(new S.$be),this.onKeyDown=this.b.event,this.c=n,this.s=this.c.isChecked;const r=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,r.push(...H.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&r.push(...this.c.actionClassName.split(" ")),this.s&&r.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,b.$kU)().setupUpdatableHover(n.hoverDelegate??(0,m.$yT)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...r),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,h=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),h.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,h=>{if(h.keyCode===10||h.keyCode===3){this.checked=!this.s,this.a.fire(!0),h.preventDefault(),h.stopPropagation();return}this.b.fire(h)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(n){this.s=n,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(n){this.g&&this.domNode.classList.remove(...H.ThemeIcon.asClassNameArray(this.g)),this.g=n,this.g&&this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(n){this.t.update(n),this.domNode.setAttribute("aria-label",n)}set visible(n){this.domNode.style.display=n?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.$rU=j;class c extends T.$hT{constructor(n,r,h){super(),this.g=n,this.h=r,this.a=this.B(new S.$be),this.onChange=this.a.event,this.b=this.B(new j({title:this.g,isChecked:this.h,icon:O.$Pj.check,actionClassName:"monaco-checkbox",...t.$pU})),this.domNode=this.b.domNode,this.c=h,this.n(),this.B(this.b.onChange(g=>{this.n(),this.a.fire(g)}))}get checked(){return this.b.checked}set checked(n){this.b.checked=n,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,A.$hS)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$sU=c;class f extends i.$uU{constructor(n,r,h){super(n,r,h),this.a=this.B(new c(this._action.label,!!this._action.checked,h.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(n){if(this.element=n,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const r=this.element.appendChild((0,A.$)("span.checkbox-label",void 0,this._action.label));this.B((0,A.$GR)(r,A.$zS.CLICK,h=>{this.a.checked=!this.a.checked,h.stopPropagation(),h.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$tU=f}),define(be[141],$e([1,0,14,76,18,119]),function(se,t,i,T,O,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qV=t.$pV=t.$oV=void 0;const S=H.localize(0,null),A=H.localize(1,null),m=H.localize(2,null);class b extends T.$rU{constructor(f){super({icon:O.$Pj.caseSensitive,title:S+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,i.$yT)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$oV=b;class p extends T.$rU{constructor(f){super({icon:O.$Pj.wholeWord,title:A+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,i.$yT)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$pV=p;class j extends T.$rU{constructor(f){super({icon:O.$Pj.regex,title:m+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,i.$yT)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$qV=j}),define(be[142],$e([1,0,4,141,75,21,3,118,2,14,108]),function(se,t,i,T,O,H,S,A,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rV=void 0;const p=A.localize(0,null);class j extends H.$hT{static{this.OPTION_CHANGE="optionChange"}constructor(f,e,n){super(),this.n=!0,this.s=!1,this.w=this.B(new m.$Vc),this.N=[],this.O=this.B(new S.$be),this.onDidOptionChange=this.O.event,this.P=this.B(new S.$be),this.onKeyDown=this.P.event,this.Q=this.B(new S.$be),this.onMouseDown=this.Q.event,this.R=this.B(new S.$be),this.onInput=this.R.event,this.S=this.B(new S.$be),this.onKeyUp=this.S.event,this.U=this.B(new S.$be),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new S.$be),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=n.placeholder||"",this.b=n.validation,this.c=n.label||p,this.h=!!n.showCommonFindToggles;const r=n.appendCaseSensitiveLabel||"",h=n.appendWholeWordsLabel||"",g=n.appendRegexLabel||"",y=n.history||[],o=!!n.flexibleHeight,d=!!n.flexibleWidth,a=n.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new O.$dV(this.domNode,e,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:y,showHistoryHint:n.showHistoryHint,flexibleHeight:o,flexibleWidth:d,flexibleMaxHeight:a,inputBoxStyles:n.inputBoxStyles}));const k=this.B((0,b.$zT)());if(this.h){this.J=this.B(new T.$qV({appendTitle:g,isChecked:!1,hoverDelegate:k,...n.toggleStyles})),this.B(this.J.onChange(R=>{this.O.fire(R),!R&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(R=>{this.W.fire(R)})),this.L=this.B(new T.$pV({appendTitle:h,isChecked:!1,hoverDelegate:k,...n.toggleStyles})),this.B(this.L.onChange(R=>{this.O.fire(R),!R&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new T.$oV({appendTitle:r,isChecked:!1,hoverDelegate:k,...n.toggleStyles})),this.B(this.M.onChange(R=>{this.O.fire(R),!R&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(R=>{this.U.fire(R)}));const N=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,R=>{if(R.equals(15)||R.equals(17)||R.equals(9)){const L=N.indexOf(this.domNode.ownerDocument.activeElement);if(L>=0){let P=-1;R.equals(17)?P=(L+1)%N.length:R.equals(15)&&(L===0?P=N.length-1:P=L-1),R.equals(9)?(N[L].blur(),this.inputBox.focus()):P>=0&&N[P].focus(),i.$BS.stop(R,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(n?.additionalToggles),this.y&&this.domNode.appendChild(this.y),f?.appendChild(this.domNode),this.B(i.$GR(this.inputBox.inputElement,"compositionstart",N=>{this.s=!0})),this.B(i.$GR(this.inputBox.inputElement,"compositionend",N=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,N=>this.P.fire(N)),this.C(this.inputBox.inputElement,N=>this.S.fire(N)),this.D(this.inputBox.inputElement,N=>this.R.fire()),this.j(this.inputBox.inputElement,N=>this.Q.fire(N))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(f){this.inputBox.layout(),this.X(f.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const f of this.N)f.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const f of this.N)f.disable()}setFocusInputOnOptionClick(f){this.n=f}setEnabled(f){f?this.enable():this.disable()}setAdditionalToggles(f){for(const e of this.N)e.domNode.remove();this.N=[],this.w.value=new m.$Tc;for(const e of f??[])this.w.value.add(e),this.y.appendChild(e.domNode),this.w.value.add(e.onChange(n=>{this.O.fire(n),!n&&this.n&&this.inputBox.focus()})),this.N.push(e);this.N.length>0&&(this.y.style.display=""),this.X()}X(f=!1){f?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((e,n)=>e+n.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(f){this.inputBox.value!==f&&(this.inputBox.value=f)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(f){this.M&&(this.M.checked=f)}getWholeWords(){return this.L?.checked??!1}setWholeWords(f){this.L&&(this.L.checked=f)}getRegex(){return this.J?.checked??!1}setRegex(f){this.J&&(this.J.checked=f,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(f){this.inputBox.showMessage(f)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$rV=j}),define(be[143],$e([1,0,4,24,15,74,142,75,72,49,76,69,30,46,8,11,18,19,39,3,44,2,40,10,122,14,57,115]),function(se,t,i,T,O,H,S,A,m,b,p,j,c,f,e,n,r,h,g,y,o,d,a,k,N,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3V=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$2V=t.$1V=t.$ZV=t.RenderIndentGuides=t.$YV=t.$XV=void 0;class P extends m.$ST{set context(s){this.c.context=s}get context(){return this.c.context}constructor(s){super(s.elements.map(D=>D.element)),this.c=s}}function E(C){return C instanceof m.$ST?new P(C):C}class z{constructor(s,D){this.d=s,this.f=D,this.b=d.$Uc.None,this.c=new d.$Tc}getDragURI(s){return this.f.getDragURI(s.element)}getDragLabel(s,D){if(this.f.getDragLabel)return this.f.getDragLabel(s.map($=>$.element),D)}onDragStart(s,D){this.f.onDragStart?.(E(s),D)}onDragOver(s,D,$,I,M,Y=!0){const J=this.f.onDragOver(E(s),D&&D.element,$,I,M),oe=this.a!==D;if(oe&&(this.b.dispose(),this.a=D),typeof D>"u")return J;if(oe&&typeof J!="boolean"&&J.autoExpand&&(this.b=(0,n.$sh)(()=>{const Oe=this.d(),Se=Oe.getNodeLocation(D);Oe.isCollapsed(Se)&&Oe.setCollapsed(Se,!1),this.a=void 0},500,this.c)),typeof J=="boolean"||!J.accept||typeof J.bubble>"u"||J.feedback){if(!Y){const Oe=typeof J=="boolean"?J:J.accept,Se=typeof J=="boolean"?void 0:J.effect;return{accept:Oe,effect:Se,feedback:[$]}}return J}if(J.bubble===1){const Oe=this.d(),Se=Oe.getNodeLocation(D),Ce=Oe.getParentNodeLocation(Se),He=Oe.getNode(Ce),Ue=Ce&&Oe.getListIndex(Ce);return this.onDragOver(s,He,Ue,I,M,!1)}const we=this.d(),fe=we.getNodeLocation(D),Ie=we.getListIndex(fe),ke=we.getListRenderCount(fe);return{...J,feedback:(0,e.$Sb)(Ie,Ie+ke)}}drop(s,D,$,I,M){this.b.dispose(),this.a=void 0,this.f.drop(E(s),D&&D.element,$,I,M)}onDragEnd(s){this.f.onDragEnd?.(s)}dispose(){this.c.dispose(),this.f.dispose()}}function W(C,s){return s&&{...s,identityProvider:s.identityProvider&&{getId(D){return s.identityProvider.getId(D.element)}},dnd:s.dnd&&new z(C,s.dnd),multipleSelectionController:s.multipleSelectionController&&{isSelectionSingleChangeEvent(D){return s.multipleSelectionController.isSelectionSingleChangeEvent({...D,element:D.element})},isSelectionRangeChangeEvent(D){return s.multipleSelectionController.isSelectionRangeChangeEvent({...D,element:D.element})}},accessibilityProvider:s.accessibilityProvider&&{...s.accessibilityProvider,getSetSize(D){const $=C(),I=$.getNodeLocation(D),M=$.getParentNodeLocation(I);return $.getNode(M).visibleChildrenCount},getPosInSet(D){return D.visibleChildIndex+1},isChecked:s.accessibilityProvider&&s.accessibilityProvider.isChecked?D=>s.accessibilityProvider.isChecked(D.element):void 0,getRole:s.accessibilityProvider&&s.accessibilityProvider.getRole?D=>s.accessibilityProvider.getRole(D.element):()=>"treeitem",getAriaLabel(D){return s.accessibilityProvider.getAriaLabel(D.element)},getWidgetAriaLabel(){return s.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:s.accessibilityProvider&&s.accessibilityProvider.getWidgetRole?()=>s.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:s.accessibilityProvider&&s.accessibilityProvider.getAriaLevel?D=>s.accessibilityProvider.getAriaLevel(D.element):D=>D.depth,getActiveDescendantId:s.accessibilityProvider.getActiveDescendantId&&(D=>s.accessibilityProvider.getActiveDescendantId(D.element))},keyboardNavigationLabelProvider:s.keyboardNavigationLabelProvider&&{...s.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(D){return s.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(D.element)}}}}class F{constructor(s){this.a=s}getHeight(s){return this.a.getHeight(s.element)}getTemplateId(s){return this.a.getTemplateId(s.element)}hasDynamicHeight(s){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(s.element)}setDynamicHeight(s,D){this.a.setDynamicHeight?.(s.element,D)}}t.$XV=F;class K{static lift(s){return s instanceof K?s:new K(s)}static empty(s=0){return new K({focus:[],selection:[],expanded:Object.create(null),scrollTop:s})}constructor(s){if(this.focus=new Set(s.focus),this.selection=new Set(s.selection),s.expanded instanceof Array){this.expanded=Object.create(null);for(const D of s.expanded)this.expanded[D]=1}else this.expanded=s.expanded;this.expanded=s.expanded,this.scrollTop=s.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$YV=K;var B;(function(C){C.None="none",C.OnHover="onHover",C.Always="always"})(B||(t.RenderIndentGuides=B={}));class G{get elements(){return this.b}constructor(s,D=[]){this.b=D,this.a=new d.$Tc,this.onDidChange=y.Event.forEach(s,$=>this.b=$,this.a)}dispose(){this.a.dispose()}}class V{static{this.a=8}constructor(s,D,$,I,M,Y={}){this.o=s,this.p=D,this.q=I,this.s=M,this.b=new Map,this.c=new Map,this.d=V.a,this.f=!1,this.g=!1,this.j=new Set,this.k=d.$Uc.None,this.m=new d.$Tc,this.templateId=s.templateId,this.updateOptions(Y),y.Event.map($,J=>J.node)(this.u,this,this.m),s.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(s={}){if(typeof s.indent<"u"){const D=(0,a.$vm)(s.indent,0,40);if(D!==this.d){this.d=D;for(const[$,I]of this.c)this.v($,I)}}if(typeof s.renderIndentGuides<"u"){const D=s.renderIndentGuides!==B.None;if(D!==this.g){this.g=D;for(const[$,I]of this.c)this.w($,I);if(this.k.dispose(),D){const $=new d.$Tc;this.q.onDidChange(this.x,this,$),this.k=$,this.x(this.q.elements)}}}typeof s.hideTwistiesOfChildlessElements<"u"&&(this.f=s.hideTwistiesOfChildlessElements)}renderTemplate(s){const D=(0,i.$GS)(s,(0,i.$)(".monaco-tl-row")),$=(0,i.$GS)(D,(0,i.$)(".monaco-tl-indent")),I=(0,i.$GS)(D,(0,i.$)(".monaco-tl-twistie")),M=(0,i.$GS)(D,(0,i.$)(".monaco-tl-contents")),Y=this.o.renderTemplate(M);return{container:s,indent:$,twistie:I,indentGuidesDisposable:d.$Uc.None,templateData:Y}}renderElement(s,D,$,I){this.c.set(s,$),this.b.set(s.element,s),this.v(s,$),this.o.renderElement(s,D,$.templateData,I)}disposeElement(s,D,$,I){$.indentGuidesDisposable.dispose(),this.o.disposeElement?.(s,D,$.templateData,I),typeof I=="number"&&(this.c.delete(s),this.b.delete(s.element))}disposeTemplate(s){this.o.disposeTemplate(s.templateData)}t(s){const D=this.b.get(s);D&&this.u(D)}u(s){const D=this.c.get(s);D&&(this.x(this.q.elements),this.v(s,D))}v(s,D){const $=V.a+(s.depth-1)*this.d;D.twistie.style.paddingLeft=`${$}px`,D.indent.style.width=`${$+this.d-16}px`,s.collapsible?D.container.setAttribute("aria-expanded",String(!s.collapsed)):D.container.removeAttribute("aria-expanded"),D.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(r.$Pj.treeItemExpanded));let I=!1;this.o.renderTwistie&&(I=this.o.renderTwistie(s.element,D.twistie)),s.collapsible&&(!this.f||s.visibleChildrenCount>0)?(I||D.twistie.classList.add(...h.ThemeIcon.asClassNameArray(r.$Pj.treeItemExpanded)),D.twistie.classList.add("collapsible"),D.twistie.classList.toggle("collapsed",s.collapsed)):D.twistie.classList.remove("collapsible","collapsed"),this.w(s,D)}w(s,D){if((0,i.$FR)(D.indent),D.indentGuidesDisposable.dispose(),!this.g)return;const $=new d.$Tc,I=this.p();for(;;){const M=I.getNodeLocation(s),Y=I.getParentNodeLocation(M);if(!Y)break;const J=I.getNode(Y),oe=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(J)&&oe.classList.add("active"),D.indent.childElementCount===0?D.indent.appendChild(oe):D.indent.insertBefore(oe,D.indent.firstElementChild),this.s.add(J,oe),$.add((0,d.$Sc)(()=>this.s.delete(J,oe))),s=J}D.indentGuidesDisposable=$}x(s){if(!this.g)return;const D=new Set,$=this.p();s.forEach(I=>{const M=$.getNodeLocation(I);try{const Y=$.getParentNodeLocation(M);I.collapsible&&I.children.length>0&&!I.collapsed?D.add(I):Y&&D.add($.getNode(Y))}catch{}}),this.j.forEach(I=>{D.has(I)||this.s.forEach(I,M=>M.classList.remove("active"))}),D.forEach(I=>{this.j.has(I)||this.s.forEach(I,M=>M.classList.add("active"))}),this.j=D}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,d.$Pc)(this.m)}}t.$ZV=V;class ae{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(s){this.c=s,this.d=s.toLowerCase()}constructor(s,D,$){this.g=s,this.j=D,this.k=$,this.a=0,this.b=0,this.c="",this.d="",this.f=new d.$Tc,s.onWillRefilter(this.m,this,this.f)}filter(s,D){let $=1;if(this.k){const Y=this.k.filter(s,D);if(typeof Y=="boolean"?$=Y?1:0:(0,j.$UV)(Y)?$=(0,j.$VV)(Y.visibility):$=Y,$===0)return!1}if(this.a++,!this.c)return this.b++,{data:o.FuzzyScore.Default,visibility:$};const I=this.j.getKeyboardNavigationLabel(s),M=Array.isArray(I)?I:[I];for(const Y of M){const J=Y&&Y.toString();if(typeof J>"u")return{data:o.FuzzyScore.Default,visibility:$};let oe;if(this.g.findMatchType===De.Contiguous){const we=J.toLowerCase().indexOf(this.d);if(we>-1){oe=[Number.MAX_SAFE_INTEGER,0];for(let fe=this.d.length;fe>0;fe--)oe.push(we+fe-1)}}else oe=(0,o.$Ek)(this.c,this.d,0,J,J.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return this.b++,M.length===1?{data:oe,visibility:$}:{data:{label:J,score:oe},visibility:$}}return this.g.findMode===Ee.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(s):2:{data:o.FuzzyScore.Default,visibility:$}}m(){this.a=0,this.b=0}dispose(){(0,d.$Pc)(this.f)}}class ie extends p.$rU{constructor(s){super({icon:r.$Pj.listFilter,title:(0,N.localize)(0,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,R.$yT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$1V=ie;class ee extends p.$rU{constructor(s){super({icon:r.$Pj.searchFuzzy,title:(0,N.localize)(1,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,R.$yT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$2V=ee;const ge={inputBoxStyles:A.$bV,toggleStyles:p.$pU,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var Ee;(function(C){C[C.Highlight=0]="Highlight",C[C.Filter=1]="Filter"})(Ee||(t.TreeFindMode=Ee={}));var De;(function(C){C[C.Fuzzy=0]="Fuzzy",C[C.Contiguous=1]="Contiguous"})(De||(t.TreeFindMatchType=De={}));class Le extends d.$Uc{set mode(s){this.b.checked=s===Ee.Filter,this.f.inputBox.setPlaceHolder(s===Ee.Filter?(0,N.localize)(2,null):(0,N.localize)(3,null))}set matchType(s){this.c.checked=s===De.Fuzzy}get value(){return this.f.inputBox.value}set value(s){this.f.inputBox.value=s}constructor(s,D,$,I,M,Y){super(),this.t=D,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new y.$be,this.onDidDisable=this._onDidDisable.event,s.appendChild(this.a.root),this.B((0,d.$Sc)(()=>s.removeChild(this.a.root)));const J=Y?.styles??ge;J.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=J.listFilterWidgetBackground),J.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${J.listFilterWidgetShadow}`);const oe=this.B((0,R.$zT)());this.b=this.B(new ie({...J.toggleStyles,isChecked:I===Ee.Filter,hoverDelegate:oe})),this.c=this.B(new ee({...J.toggleStyles,isChecked:M===De.Fuzzy,hoverDelegate:oe})),this.onDidChangeMode=y.Event.map(this.b.onChange,()=>this.b.checked?Ee.Filter:Ee.Highlight,this.q),this.onDidChangeMatchType=y.Event.map(this.c.onChange,()=>this.c.checked?De.Fuzzy:De.Contiguous,this.q),this.f=this.B(new S.$rV(this.a.findInput,$,{label:(0,N.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:J.inputBoxStyles,toggleStyles:J.toggleStyles,history:Y?.history})),this.g=this.B(new H.$AT(this.a.actionbar)),this.mode=I;const we=this.B(new T.$IT(this.f.inputBox.inputElement,"keydown")),fe=y.Event.chain(we.event,Se=>Se.map(Ce=>new O.$DR(Ce)));this.B(fe(Se=>{if(Se.equals(3)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Se.equals(18)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Se.equals(16)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const Ie=this.B(new f.$8i("close",(0,N.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(Ie,{icon:!0,label:!1});const ke=this.B(new T.$IT(this.a.grab,"mousedown"));this.B(ke.event(Se=>{const Ce=new d.$Tc,He=Ce.add(new T.$IT((0,i.getWindow)(Se),"mousemove")),Ue=Ce.add(new T.$IT((0,i.getWindow)(Se),"mouseup")),Xe=this.m,_e=Se.pageX,Z=this.s,ne=Se.pageY;this.a.grab.classList.add("grabbing");const pe=this.a.root.style.transition;this.a.root.style.transition="unset";const ye=Re=>{const ze=Re.pageX-_e;this.m=Xe-ze;const We=Re.pageY-ne;this.s=Z+We,this.layout()};Ce.add(He.event(ye)),Ce.add(Ue.event(Re=>{ye(Re),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=pe,Ce.dispose()}))}));const Oe=y.Event.chain(this.B(new T.$IT(this.a.grab,"keydown")).event,Se=>Se.map(Ce=>new O.$DR(Ce)));this.B(Oe(Se=>{let Ce,He;if(Se.keyCode===15?Ce=Number.POSITIVE_INFINITY:Se.keyCode===17?Ce=0:Se.keyCode===10&&(Ce=this.m===0?Number.POSITIVE_INFINITY:0),Se.keyCode===16?He=0:Se.keyCode===18&&(He=Number.POSITIVE_INFINITY),Ce!==void 0&&(Se.preventDefault(),Se.stopPropagation(),this.m=Ce,this.layout()),He!==void 0){Se.preventDefault(),Se.stopPropagation(),this.s=He;const Ue=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ue},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(s=this.j){this.j=s,this.m=(0,a.$vm)(this.m,0,Math.max(0,s-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,a.$vm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(s){this.f.showMessage(s)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,n.$rh)(300),super.dispose()}}class he{get pattern(){return this.b}get mode(){return this.d}set mode(s){s!==this.d&&(this.d=s,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(s))}get matchType(){return this.f}set matchType(s){s!==this.f&&(this.f=s,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(s))}constructor(s,D,$,I,M,Y={}){this.t=s,this.u=$,this.v=I,this.w=M,this.x=Y,this.b="",this.c="",this.j=0,this.k=new y.$be,this.onDidChangeMode=this.k.event,this.m=new y.$be,this.onDidChangeMatchType=this.m.event,this.o=new y.$be,this.onDidChangePattern=this.o.event,this.p=new y.$be,this.onDidChangeOpenState=this.p.event,this.q=new d.$Tc,this.s=new d.$Tc,this.d=s.options.defaultFindMode??Ee.Highlight,this.f=s.options.defaultFindMatchType??De.Fuzzy,D.onDidSplice(this.z,this,this.s)}updateOptions(s={}){s.defaultFindMode!==void 0&&(this.mode=s.defaultFindMode),s.defaultFindMatchType!==void 0&&(this.matchType=s.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Le(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(s=>this.mode=s,void 0,this.q),this.g.onDidChangeMatchType(s=>this.matchType=s,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(s){this.b=s,this.o.fire(s),this.v.pattern=s,this.t.refilter(),s&&this.t.focusNext(0,!0,void 0,$=>!o.FuzzyScore.isDefault($.filterData));const D=this.t.getFocus();if(D.length>0){const $=D[0];this.t.getRelativeTop($)===null&&this.t.reveal($,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const s=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&s?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,N.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(s){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!o.FuzzyScore.isDefault(s.filterData)}layout(s){this.j=s,this.g?.layout(s)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function _(C,s){return C.position===s.position&&ue(C,s)}function ue(C,s){return C.node.element===s.node.element&&C.startIndex===s.startIndex&&C.height===s.height&&C.endIndex===s.endIndex}class le{constructor(s=[]){this.stickyNodes=s}get count(){return this.stickyNodes.length}equal(s){return(0,e.$ub)(this.stickyNodes,s.stickyNodes,_)}lastNodePartiallyVisible(){if(this.count===0)return!1;const s=this.stickyNodes[this.count-1];if(this.count===1)return s.position!==0;const D=this.stickyNodes[this.count-2];return D.position+D.height!==s.position}animationStateChanged(s){if(!(0,e.$ub)(this.stickyNodes,s.stickyNodes,ue)||this.count===0)return!1;const D=this.stickyNodes[this.count-1],$=s.stickyNodes[s.count-1];return D.position!==$.position}}class Q{constrainStickyScrollNodes(s,D,$){for(let I=0;I<s.length;I++){const M=s[I];if(M.position+M.height>$||I>=D)return s.slice(0,I)}return s}}class U extends d.$Uc{constructor(s,D,$,I,M,Y={}){super(),this.g=s,this.j=D,this.m=$,this.s=M,this.c=.4;const J=this.validateStickySettings(Y);this.b=J.stickyScrollMaxItemCount,this.a=Y.stickyScrollDelegate??new Q,this.f=this.B(new re($.getScrollableElement(),$,s,I,M,Y.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B($.onDidScroll(()=>this.u())),this.B($.onDidChangeContentHeight(()=>this.u())),this.B(s.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(s){return this.f.getNode(s)}t(s){let D;if(s===0?D=this.m.firstVisibleIndex:D=this.m.indexAt(s+this.m.scrollTop),!(D<0||D>=this.m.length))return this.m.element(D)}u(){const s=this.t(0);if(!s||this.g.scrollTop===0){this.f.setState(void 0);return}const D=this.w(s);this.f.setState(D)}w(s){const D=[];let $=s,I=0,M=this.z($,void 0,I);for(;M&&(D.push(M),I+=M.height,!(D.length<=this.b&&($=this.y(M),!$)));)M=this.z($,M.node,I);const Y=this.H(D);return Y.length?new le(Y):void 0}y(s){return this.t(s.position+s.height)}z(s,D,$){const I=this.F(s,D);if(I&&!(I===s&&(!this.J(s)||this.C(s,$))))return this.D(I,$)}C(s,D){const $=this.L(s),I=this.m.getElementTop($),M=D;return this.m.scrollTop===I-M}D(s,D){const $=this.s.getHeight(s),{startIndex:I,endIndex:M}=this.M(s),Y=this.G(M,D,$);return{node:s,position:Y,height:$,startIndex:I,endIndex:M}}F(s,D=void 0){let $=s,I=this.I($);for(;I;){if(I===D)return $;$=I,I=this.I($)}if(D===void 0)return $}G(s,D,$){let I=this.m.getRelativeTop(s);if(I===null&&this.m.firstVisibleIndex===s&&s+1<this.m.length){const we=this.s.getHeight(this.m.element(s)),fe=this.m.getRelativeTop(s+1);I=fe?fe-we/this.m.renderHeight:null}if(I===null)return D;const M=this.m.element(s),Y=this.s.getHeight(M),oe=I*this.m.renderHeight+Y;return D+$>oe&&D<=oe?oe-$:D}H(s){if(s.length===0)return[];const D=this.m.renderHeight*this.c,$=s[s.length-1];if(s.length<=this.b&&$.position+$.height<=D)return s;const I=this.a.constrainStickyScrollNodes(s,this.b,D);if(!I.length)return[];const M=I[I.length-1];if(I.length>this.b||M.position+M.height>D)throw new Error("stickyScrollDelegate violates constraints");return I}I(s){const D=this.j.getNodeLocation(s),$=this.j.getParentNodeLocation(D);return $?this.j.getNode($):void 0}J(s){const D=this.j.getNodeLocation(s);return this.j.getListRenderCount(D)>1}L(s){const D=this.j.getNodeLocation(s);return this.j.getListIndex(D)}M(s){const D=this.j.getNodeLocation(s),$=this.j.getListIndex(D);if($<0)throw new Error("Node not found in tree");const I=this.j.getListRenderCount(D),M=$+I-1;return{startIndex:$,endIndex:M}}nodePositionTopBelowWidget(s){const D=[];let $=this.I(s);for(;$;)D.push($),$=this.I($);let I=0;for(let M=0;M<D.length&&M<this.b;M++)I+=this.s.getHeight(D[M]);return I}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(s={}){if(!s.stickyScrollMaxItemCount)return;const D=this.validateStickySettings(s);this.b!==D.stickyScrollMaxItemCount&&(this.b=D.stickyScrollMaxItemCount,this.u())}validateStickySettings(s){let D=7;return typeof s.stickyScrollMaxItemCount=="number"&&(D=Math.max(s.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:D}}}class re{constructor(s,D,$,I,M,Y){this.g=D,this.j=$,this.k=I,this.m=M,this.o=Y,this.c=[],this.d=new d.$Tc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),s.appendChild(this.a);const J=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(J),this.f=new me(this.a,D),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const s=this.b.stickyNodes[this.b.count-1];return s.position+s.height}get count(){return this.b?.count??0}getNode(s){return this.b?.stickyNodes.find(D=>D.node===s)}setState(s){const D=!!this.b&&this.b.count>0,$=!!s&&s.count>0;if(!D&&!$||D&&$&&this.b.equal(s))return;if(D!==$&&this.s($),!$){this.b=void 0,this.c=[],this.d.clear();return}const I=s.stickyNodes[s.count-1];if(this.b&&s.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${I.position}px`;else{this.d.clear();const M=Array(s.count);for(let Y=s.count-1;Y>=0;Y--){const J=s.stickyNodes[Y],{element:oe,disposable:we}=this.p(J,Y,s.count);M[Y]=oe,this.a.appendChild(oe),this.d.add(we)}this.f.updateElements(M,s),this.c=M}this.b=s,this.a.style.height=`${I.position+I.height}px`}p(s,D,$){const I=s.startIndex,M=document.createElement("div");M.style.top=`${s.position}px`,this.j.options.setRowHeight!==!1&&(M.style.height=`${s.height}px`),this.j.options.setRowLineHeight!==!1&&(M.style.lineHeight=`${s.height}px`),M.classList.add("monaco-tree-sticky-row"),M.classList.add("monaco-list-row"),M.setAttribute("data-index",`${I}`),M.setAttribute("data-parity",I%2===0?"even":"odd"),M.setAttribute("id",this.g.getElementID(I));const Y=this.q(M,s.node.element,D,$),J=this.m.getTemplateId(s.node),oe=this.k.find(ke=>ke.templateId===J);if(!oe)throw new Error(`No renderer found for template id ${J}`);let we=s.node;we===this.j.getNode(this.j.getNodeLocation(s.node))&&(we=new Proxy(s.node,{}));const fe=oe.renderTemplate(M);oe.renderElement(we,s.startIndex,fe,s.height);const Ie=(0,d.$Sc)(()=>{Y.dispose(),oe.disposeElement(we,s.startIndex,fe,s.height),oe.disposeTemplate(fe),M.remove()});return{element:M,disposable:Ie}}q(s,D,$,I){if(!this.o)return d.$Uc.None;this.o.getSetSize&&s.setAttribute("aria-setsize",String(this.o.getSetSize(D,$,I))),this.o.getPosInSet&&s.setAttribute("aria-posinset",String(this.o.getPosInSet(D,$))),this.o.getRole&&s.setAttribute("role",this.o.getRole(D)??"treeitem");const M=this.o.getAriaLabel(D),Y=M&&typeof M!="string"?M:(0,L.constObservable)(M),J=(0,L.autorun)(we=>{const fe=we.readObservable(Y);fe?s.setAttribute("aria-label",fe):s.removeAttribute("aria-label")});typeof M=="string"||M&&s.setAttribute("aria-label",M.get());const oe=this.o.getAriaLevel&&this.o.getAriaLevel(D);return typeof oe=="number"&&s.setAttribute("aria-level",`${oe}`),s.setAttribute("aria-selected",String(!1)),J}s(s){this.a.classList.toggle("empty",!s),s||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class me extends d.$Uc{get m(){return this.j}set m(s){s!==this.j&&(this.f.fire(s),this.j=s)}constructor(s,D){super(),this.s=s,this.t=D,this.a=-1,this.b=[],this.f=new y.$be,this.onDidChangeHasFocus=this.f.event,this.g=new y.$be,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown($=>this.w($))),this.B(this.t.onMouseDown($=>this.y($))),this.B(this.t.onContextMenu($=>this.u($)))}u(s){const D=s.browserEvent.target;if(!(0,b.$6T)(D)&&!(0,b.$5T)(D)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$wS)(s.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const Y=this.c.stickyNodes.findIndex(J=>J.node.element===s.element?.element);if(Y===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(Y);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const I=this.c.stickyNodes[this.a].node.element,M=this.b[this.a];this.g.fire({element:I,anchor:M,browserEvent:s.browserEvent,isStickyScroll:!0})}w(s){if(this.m&&this.c){if(s.key==="ArrowUp")this.z(Math.max(0,this.a-1)),s.preventDefault(),s.stopPropagation();else if(s.key==="ArrowDown"||s.key==="ArrowRight"){if(this.a>=this.c.count-1){const D=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([D]),this.C(D,this.c)}else this.z(this.a+1);s.preventDefault(),s.stopPropagation()}}}y(s){const D=s.browserEvent.target;!(0,b.$6T)(D)&&!(0,b.$5T)(D)||(s.browserEvent.preventDefault(),s.browserEvent.stopPropagation())}updateElements(s,D){if(D&&D.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(D&&D.count!==s.length)throw new Error("Sticky scroll focus received illigel state");const $=this.a;if(this.D(),this.b=s,this.c=D,D){const I=(0,a.$vm)($,0,D.count-1);this.F(I)}else this.m&&this.t.domFocus();this.s.tabIndex=D?0:-1}z(s){const D=this.c;if(!D)throw new Error("Cannot set focus when state is undefined");if(this.F(s),!(s<D.count-1)&&D.lastNodePartiallyVisible()){const $=D.stickyNodes[s];this.C($.endIndex+1,D)}}C(s,D){const $=D.stickyNodes[D.count-1],I=D.count>1?D.stickyNodes[D.count-2]:void 0,M=this.t.getElementTop(s),Y=I?I.position+I.height+$.height:$.height;this.t.scrollTop=M-Y}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(s){if(0>s)throw new Error("addFocus() can not remove focus");if(!this.c&&s>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&s>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const D=this.a;D>=0&&this.G(this.b[D],!1),s>=0&&this.G(this.b[s],!0),this.a=s}G(s,D){this.I(s,D&&this.m),this.J(s,D)}H(s){this.a!==-1&&this.I(this.b[this.a],s)}I(s,D){s.classList.toggle("focused",D)}J(s,D){s.classList.toggle("passive-focused",D)}L(s){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",s)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function ve(C){let s=c.TreeMouseEventTarget.Unknown;return(0,i.$cS)(C.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?s=c.TreeMouseEventTarget.Twistie:(0,i.$cS)(C.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?s=c.TreeMouseEventTarget.Element:(0,i.$cS)(C.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(s=c.TreeMouseEventTarget.Filter),{browserEvent:C.browserEvent,element:C.element?C.element.element:null,target:s}}function Ne(C){const s=(0,b.$6T)(C.browserEvent.target);return{element:C.element?C.element.element:null,browserEvent:C.browserEvent,anchor:C.anchor,isStickyScroll:s}}function Te(C,s){s(C),C.children.forEach(D=>Te(D,s))}class Me{get f(){return this.d||(this.d=this.m()),this.d}constructor(s,D){this.g=s,this.j=D,this.a=[],this.c=new y.$be,this.onDidChange=this.c.event}set(s,D){!D?.__forceEvent&&(0,e.$ub)(this.a,s)||this.k(s,!1,D)}k(s,D,$){if(this.a=[...s],this.b=void 0,this.d=void 0,!D){const I=this;this.c.fire({get elements(){return I.get()},browserEvent:$})}}get(){return this.b||(this.b=this.a.map(s=>s.element)),[...this.b]}getNodes(){return this.a}has(s){return this.f.has(s)}onDidModelSplice({insertedNodes:s,deletedNodes:D}){if(!this.j){const oe=this.m(),we=fe=>oe.delete(fe);D.forEach(fe=>Te(fe,we)),this.set([...oe.values()]);return}const $=new Set,I=oe=>$.add(this.j.getId(oe.element).toString());D.forEach(oe=>Te(oe,I));const M=new Map,Y=oe=>M.set(this.j.getId(oe.element).toString(),oe);s.forEach(oe=>Te(oe,Y));const J=[];for(const oe of this.a){const we=this.j.getId(oe.element).toString();if(!$.has(we))J.push(oe);else{const Ie=M.get(we);Ie&&Ie.visible&&J.push(Ie)}}if(this.a.length>0&&J.length===0){const oe=this.g();oe&&J.push(oe)}this.k(J,!0)}m(){const s=new Set;for(const D of this.a)s.add(D);return s}}class x extends b.$$T{constructor(s,D,$){super(s),this.x=D,this.y=$}u(s){if((0,b.$7T)(s.browserEvent.target)||(0,b.$ZT)(s.browserEvent.target)||(0,b.$1T)(s.browserEvent.target)||s.browserEvent.isHandledByList)return;const D=s.element;if(!D)return super.u(s);if(this.p(s)||this.o(s))return super.u(s);const $=s.browserEvent.target,I=$.classList.contains("monaco-tl-twistie")||$.classList.contains("monaco-icon-label")&&$.classList.contains("folder-icon")&&s.browserEvent.offsetX<16,M=(0,b.$5T)(s.browserEvent.target);let Y=!1;if(M?Y=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?Y=this.x.expandOnlyOnTwistieClick(D.element):Y=!!this.x.expandOnlyOnTwistieClick,M)this.A(s,D);else{if(Y&&!I&&s.browserEvent.detail!==2)return super.u(s);if(!this.x.expandOnDoubleClick&&s.browserEvent.detail===2)return super.u(s)}if(D.collapsible&&(!M||I)){const J=this.x.getNodeLocation(D),oe=s.browserEvent.altKey;if(this.x.setFocus([J]),this.x.toggleCollapsed(J,oe),I){s.browserEvent.isHandledByList=!0;return}}M||super.u(s)}A(s,D){if((0,b.$2T)(s.browserEvent.target)||(0,b.$3T)(s.browserEvent.target))return;const $=this.y();if(!$)throw new Error("Sticky scroll controller not found");const I=this.k.indexOf(D),M=this.k.getElementTop(I),Y=$.nodePositionTopBelowWidget(D);this.x.scrollTop=M-Y,this.k.domFocus(),this.k.setFocus([I]),this.k.setSelection([I])}v(s){s.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||s.browserEvent.isHandledByList||super.v(s)}s(s){const D=s.browserEvent.target;if(!(0,b.$6T)(D)&&!(0,b.$5T)(D)){super.s(s);return}}t(s){const D=s.browserEvent.target;if(!(0,b.$6T)(D)&&!(0,b.$5T)(D)){super.t(s);return}}}class u extends b.$bU{constructor(s,D,$,I,M,Y,J,oe){super(s,D,$,I,oe),this.p=M,this.s=Y,this.K=J}D(s){return new x(this,s.tree,s.stickyScrollProvider)}splice(s,D,$=[]){if(super.splice(s,D,$),$.length===0)return;const I=[],M=[];let Y;$.forEach((J,oe)=>{this.p.has(J)&&I.push(s+oe),this.s.has(J)&&M.push(s+oe),this.K.has(J)&&(Y=s+oe)}),I.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...I])),M.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...M])),typeof Y=="number"&&super.setAnchor(Y)}setFocus(s,D,$=!1){super.setFocus(s,D),$||this.p.set(s.map(I=>this.element(I)),D)}setSelection(s,D,$=!1){super.setSelection(s,D),$||this.s.set(s.map(I=>this.element(I)),D)}setAnchor(s,D=!1){super.setAnchor(s),D||(typeof s>"u"?this.K.set([]):this.K.set([this.element(s)]))}}var v;(function(C){C[C.Tree=0]="Tree",C[C.StickyScroll=1]="StickyScroll"})(v||(t.AbstractTreePart=v={}));class l{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return y.Event.map(this.j.onMouseClick,ve)}get onMouseDblClick(){return y.Event.filter(y.Event.map(this.j.onMouseDblClick,ve),s=>s.target!==c.TreeMouseEventTarget.Filter)}get onMouseOver(){return y.Event.map(this.j.onMouseOver,ve)}get onMouseOut(){return y.Event.map(this.j.onMouseOut,ve)}get onContextMenu(){return y.Event.any(y.Event.filter(y.Event.map(this.j.onContextMenu,Ne),s=>!s.isStickyScroll),this.B?.onContextMenu??y.Event.None)}get onTap(){return y.Event.map(this.j.onTap,ve)}get onPointer(){return y.Event.map(this.j.onPointer,ve)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return y.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??Ee.Highlight}set findMode(s){this.z&&(this.z.mode=s)}get findMatchType(){return this.z?.matchType??De.Fuzzy}set findMatchType(s){this.z&&(this.z.matchType=s)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:y.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(s,D,$,I,M={}){this.G=s,this.H=M,this.y=new y.$je,this.onDidChangeFindOpenState=y.Event.None,this.onDidChangeStickyScrollFocused=y.Event.None,this.D=new d.$Tc,this.E=new y.$be,this.onWillRefilter=this.E.event,this.F=new y.$be,this.onDidUpdateOptions=this.F.event,this.p=new F($);const Y=new y.$ke,J=new y.$ke,oe=this.D.add(new G(J.event)),we=new g.$Hc;this.k=I.map(Se=>new V(Se,()=>this.o,Y.event,oe,we,M));for(const Se of this.k)this.D.add(Se);let fe;M.keyboardNavigationLabelProvider&&(fe=new ae(this,M.keyboardNavigationLabelProvider,M.filter),M={...M,filter:fe},this.D.add(fe)),this.q=new Me(()=>this.j.getFocusedElements()[0],M.identityProvider),this.w=new Me(()=>this.j.getSelectedElements()[0],M.identityProvider),this.x=new Me(()=>this.j.getAnchorElement(),M.identityProvider),this.j=new u(s,D,this.p,this.k,this.q,this.w,this.x,{...W(()=>this.o,M),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(s,this.j,M),Y.input=this.o.onDidChangeCollapseState;const Ie=y.Event.forEach(this.o.onDidSplice,Se=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Se),this.w.onDidModelSplice(Se)})},this.D);Ie(()=>null,null,this.D);const ke=this.D.add(new y.$be),Oe=this.D.add(new n.$nh(0));if(this.D.add(y.Event.any(Ie,this.q.onDidChange,this.w.onDidChange)(()=>{Oe.trigger(()=>{const Se=new Set;for(const Ce of this.q.getNodes())Se.add(Ce);for(const Ce of this.w.getNodes())Se.add(Ce);ke.fire([...Se.values()])})})),J.input=ke.event,M.keyboardSupport!==!1){const Se=y.Event.chain(this.j.onKeyDown,Ce=>Ce.filter(He=>!(0,b.$ZT)(He.target)).map(He=>new O.$DR(He)));y.Event.chain(Se,Ce=>Ce.filter(He=>He.keyCode===15))(this.J,this,this.D),y.Event.chain(Se,Ce=>Ce.filter(He=>He.keyCode===17))(this.K,this,this.D),y.Event.chain(Se,Ce=>Ce.filter(He=>He.keyCode===10))(this.L,this,this.D)}if((M.findWidgetEnabled??!0)&&M.keyboardNavigationLabelProvider&&M.contextViewProvider){const Se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new he(this,this.o,this.j,fe,M.contextViewProvider,Se),this.A=Ce=>this.z.shouldAllowFocus(Ce),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=y.Event.None,this.onDidChangeFindMatchType=y.Event.None;M.enableStickyScroll&&(this.B=new U(this,this.o,this.j,this.k,this.p,M),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$oS)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===B.Always)}updateOptions(s={}){this.H={...this.H,...s};for(const D of this.k)D.updateOptions(s);this.j.updateOptions(this.H),this.z?.updateOptions(s),this.I(s),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===B.Always)}get options(){return this.H}I(s){!this.B&&this.H.enableStickyScroll?(this.B=new U(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=y.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(s)}updateWidth(s){const D=this.o.getListIndex(s);D!==-1&&this.j.updateWidth(D)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(s){this.j.scrollTop=s}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(s){this.j.scrollLeft=s}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let s=this.j.firstVisibleIndex;return this.B&&(s+=this.B.count),s<0||s>=this.j.length?void 0:this.j.element(s).element}get lastVisibleElement(){const s=this.j.lastVisibleIndex;return this.j.element(s).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(s){this.j.ariaLabel=s}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$hS)(this.getHTMLElement())}layout(s,D){this.j.layout(s,D),(0,k.$8f)(D)&&this.z?.layout(D)}style(s){const D=`.${this.j.domId}`,$=[];s.treeIndentGuidesStroke&&($.push(`.monaco-list${D}:hover .monaco-tl-indent > .indent-guide, .monaco-list${D}.always .monaco-tl-indent > .indent-guide  { border-color: ${s.treeInactiveIndentGuidesStroke}; }`),$.push(`.monaco-list${D} .monaco-tl-indent > .indent-guide.active { border-color: ${s.treeIndentGuidesStroke}; }`));const I=s.treeStickyScrollBackground??s.listBackground;I&&($.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${I}; }`),$.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${I}; }`)),s.treeStickyScrollBorder&&$.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${s.treeStickyScrollBorder}; }`),s.treeStickyScrollShadow&&$.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${s.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),s.listFocusForeground&&($.push(`.monaco-list${D}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${s.listFocusForeground}; }`),$.push(`.monaco-list${D}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const M=(0,i.$YS)(s.listFocusAndSelectionOutline,(0,i.$YS)(s.listSelectionOutline,s.listFocusOutline??""));M&&($.push(`.monaco-list${D}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${M}; outline-offset: -1px;}`),$.push(`.monaco-list${D}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),s.listFocusOutline&&($.push(`.monaco-list${D}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),$.push(`.monaco-list${D}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),$.push(`.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),$.push(`.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),$.push(`.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=$.join(`
`),this.j.style(s)}getParentElement(s){const D=this.o.getParentNodeLocation(s);return this.o.getNode(D).element}getFirstElementChild(s){return this.o.getFirstElementChild(s)}getNode(s){return this.o.getNode(s)}getNodeLocation(s){return this.o.getNodeLocation(s)}collapse(s,D=!1){return this.o.setCollapsed(s,!0,D)}expand(s,D=!1){return this.o.setCollapsed(s,!1,D)}toggleCollapsed(s,D=!1){return this.o.setCollapsed(s,void 0,D)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(s){return this.o.isCollapsible(s)}setCollapsible(s,D){return this.o.setCollapsible(s,D)}isCollapsed(s){return this.o.isCollapsed(s)}expandTo(s){this.o.expandTo(s)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(s){if(typeof s>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const D=this.o.getNode(s);this.x.set([D]);const $=this.o.getListIndex(s);$>-1&&this.j.setAnchor($,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(s,D){this.y.bufferEvents(()=>{const $=s.map(M=>this.o.getNode(M));this.w.set($,D);const I=s.map(M=>this.o.getListIndex(M)).filter(M=>M>-1);this.j.setSelection(I,D,!0)})}getSelection(){return this.w.get()}setFocus(s,D){this.y.bufferEvents(()=>{const $=s.map(M=>this.o.getNode(M));this.q.set($,D);const I=s.map(M=>this.o.getListIndex(M)).filter(M=>M>-1);this.j.setFocus(I,D,!0)})}focusNext(s=1,D=!1,$,I=(0,i.$wS)($)&&$.altKey?void 0:this.A){this.j.focusNext(s,D,$,I)}focusPrevious(s=1,D=!1,$,I=(0,i.$wS)($)&&$.altKey?void 0:this.A){this.j.focusPrevious(s,D,$,I)}focusNextPage(s,D=(0,i.$wS)(s)&&s.altKey?void 0:this.A){return this.j.focusNextPage(s,D)}focusPreviousPage(s,D=(0,i.$wS)(s)&&s.altKey?void 0:this.A){return this.j.focusPreviousPage(s,D,()=>this.B?.height??0)}focusLast(s,D=(0,i.$wS)(s)&&s.altKey?void 0:this.A){this.j.focusLast(s,D)}focusFirst(s,D=(0,i.$wS)(s)&&s.altKey?void 0:this.A){this.j.focusFirst(s,D)}getFocus(){return this.q.get()}getStickyScrollFocus(){const s=this.B?.getFocus();return s!==void 0?[s]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(s,D){this.o.expandTo(s);const $=this.o.getListIndex(s);if($!==-1)if(!this.B)this.j.reveal($,D);else{const I=this.B.nodePositionTopBelowWidget(this.getNode(s));this.j.reveal($,D,I)}}getRelativeTop(s){const D=this.o.getListIndex(s);if(D===-1)return null;const $=this.B?.getNode(this.getNode(s));return this.j.getRelativeTop(D,$?.position??this.B?.height)}getViewState(s=this.options.identityProvider){if(!s)throw new c.$SV(this.G,"Can't get tree view state without an identity provider");const D=Y=>s.getId(Y).toString(),$=K.empty(this.scrollTop);for(const Y of this.getFocus())$.focus.add(D(Y));for(const Y of this.getSelection())$.selection.add(D(Y));const I=this.o.getNode(),M=[I];for(;M.length>0;){const Y=M.shift();Y!==I&&Y.collapsible&&($.expanded[D(Y.element)]=Y.collapsed?0:1),M.push(...Y.children)}return $}J(s){s.preventDefault(),s.stopPropagation();const D=this.j.getFocusedElements();if(D.length===0)return;const $=D[0],I=this.o.getNodeLocation($);if(!this.o.setCollapsed(I,!0)){const Y=this.o.getParentNodeLocation(I);if(!Y)return;const J=this.o.getListIndex(Y);this.j.reveal(J),this.j.setFocus([J])}}K(s){s.preventDefault(),s.stopPropagation();const D=this.j.getFocusedElements();if(D.length===0)return;const $=D[0],I=this.o.getNodeLocation($);if(!this.o.setCollapsed(I,!1)){if(!$.children.some(oe=>oe.visible))return;const[Y]=this.j.getFocus(),J=Y+1;this.j.reveal(J),this.j.setFocus([J])}}L(s){s.preventDefault(),s.stopPropagation();const D=this.j.getFocusedElements();if(D.length===0)return;const $=D[0],I=this.o.getNodeLocation($),M=s.browserEvent.altKey;this.o.setCollapsed(I,void 0,M)}navigate(s){return new w(this.j,this.o,s)}dispose(){(0,d.$Pc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$3V=l;class w{constructor(s,D,$){this.b=s,this.c=D,$?this.a=this.c.getListIndex($):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[144],$e([1,0,143,134,30,32]),function(se,t,i,T,O,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bW=void 0;class S extends i.$3V{constructor(m,b,p,j,c,f={}){super(m,b,p,j,f),this.f=m,this.g=c,this.d=new Map,this.c=f.identityProvider}getInput(){return this.b}setInput(m,b){if(b&&!this.c)throw new O.$SV(this.f,"Can't restore tree view state without an identity provider");if(this.b=m,!m){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!b){this.m(m);return}const p=[],j=[],c=e=>{const n=this.c.getId(e).toString();return!b.expanded[n]},f=e=>{const n=this.c.getId(e.element).toString();b.focus.has(n)&&p.push(e.element),b.selection.has(n)&&j.push(e.element)};this.m(m,c,f),this.setFocus(p),this.setSelection(j),b&&typeof b.scrollTop=="number"&&(this.scrollTop=b.scrollTop)}updateChildren(m=this.b){if(typeof this.b>"u")throw new O.$SV(this.f,"Tree input not set");let b;this.c&&(b=p=>{const j=this.c.getId(p).toString(),c=this.d.get(j);if(c)return c.collapsed}),this.m(m,b)}resort(m=this.b,b=!0){this.o.resort(m===this.b?null:m,b)}refresh(m){if(m===void 0){this.j.rerender();return}this.o.rerender(m)}m(m,b,p){let j;if(this.c){const c=new Set,f=p;p=e=>{const n=this.c.getId(e.element).toString();c.add(n),this.d.set(n,e),f?.(e)},j=e=>{const n=this.c.getId(e.element).toString();c.has(n)||this.d.delete(n)}}this.o.setChildren(m===this.b?null:m,this.s(m,b).elements,{onDidCreateNode:p,onDidDeleteNode:j})}s(m,b){const p=[...this.g.getChildren(m)];return{elements:H.Iterable.map(p,c=>{const{elements:f,size:e}=this.s(c,b),n=this.g.hasChildren?this.g.hasChildren(c):void 0,r=e===0?void 0:b&&b(c);return{element:c,children:f,collapsible:n,collapsed:r}}),size:p.length}}M(m,b,p){return new T.$4V(m,b,p)}}t.$bW=S}),define(be[77],$e([1,0,8,11,43,34,31,6,3,2,64,9,10]),function(se,t,i,T,O,H,S,A,m,b,p,j,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_h=t.ProxyChannel=t.$$h=t.$8h=t.$7h=t.$6h=t.RequestInitiator=t.$5h=t.$2h=t.$1h=void 0,t.$3h=P,t.$4h=E,t.$9h=G,t.$0h=V;var f;(function(he){he[he.Promise=100]="Promise",he[he.PromiseCancel=101]="PromiseCancel",he[he.EventListen=102]="EventListen",he[he.EventDispose=103]="EventDispose"})(f||(f={}));function e(he){switch(he){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var n;(function(he){he[he.Initialize=200]="Initialize",he[he.PromiseSuccess=201]="PromiseSuccess",he[he.PromiseError=202]="PromiseError",he[he.PromiseErrorObj=203]="PromiseErrorObj",he[he.EventFire=204]="EventFire"})(n||(n={}));function r(he){switch(he){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(he){he[he.Uninitialized=0]="Uninitialized",he[he.Idle=1]="Idle"})(h||(h={}));function g(he){let _=0;for(let ue=0;;ue+=7){const le=he.read(1);if(_|=(le.buffer[0]&127)<<ue,!(le.buffer[0]&128))return _}}const y=N(0);function o(he,_){if(_===0){he.write(y);return}let ue=0;for(let Q=_;Q!==0;Q=Q>>>7)ue++;const le=O.$Ce.alloc(ue);for(let Q=0;_!==0;Q++)le.buffer[Q]=_&127,_=_>>>7,_>0&&(le.buffer[Q]|=128);he.write(le)}class d{constructor(_){this.b=_,this.a=0}read(_){const ue=this.b.slice(this.a,this.a+_);return this.a+=ue.byteLength,ue}}t.$1h=d;class a{constructor(){this.a=[]}get buffer(){return O.$Ce.concat(this.a)}write(_){this.a.push(_)}}t.$2h=a;var k;(function(he){he[he.Undefined=0]="Undefined",he[he.String=1]="String",he[he.Buffer=2]="Buffer",he[he.VSBuffer=3]="VSBuffer",he[he.Array=4]="Array",he[he.Object=5]="Object",he[he.Int=6]="Int"})(k||(k={}));function N(he){const _=O.$Ce.alloc(1);return _.writeUInt8(he,0),_}const R={Undefined:N(k.Undefined),String:N(k.String),Buffer:N(k.Buffer),VSBuffer:N(k.VSBuffer),Array:N(k.Array),Object:N(k.Object),Uint:N(k.Int)},L=typeof Buffer<"u";function P(he,_){if(typeof _>"u")he.write(R.Undefined);else if(typeof _=="string"){const ue=O.$Ce.fromString(_);he.write(R.String),o(he,ue.byteLength),he.write(ue)}else if(L&&Buffer.isBuffer(_)){const ue=O.$Ce.wrap(_);he.write(R.Buffer),o(he,ue.byteLength),he.write(ue)}else if(_ instanceof O.$Ce)he.write(R.VSBuffer),o(he,_.byteLength),he.write(_);else if(Array.isArray(_)){he.write(R.Array),o(he,_.length);for(const ue of _)P(he,ue)}else if(typeof _=="number"&&(_|0)===_)he.write(R.Uint),o(he,_);else{const ue=O.$Ce.fromString(JSON.stringify(_));he.write(R.Object),o(he,ue.byteLength),he.write(ue)}}function E(he){switch(he.read(1).readUInt8(0)){case k.Undefined:return;case k.String:return he.read(g(he)).toString();case k.Buffer:return he.read(g(he)).buffer;case k.VSBuffer:return he.read(g(he));case k.Array:{const ue=g(he),le=[];for(let Q=0;Q<ue;Q++)le.push(E(he));return le}case k.Object:return JSON.parse(he.read(g(he)).toString());case k.Int:return g(he)}}class z{constructor(_,ue,le=null,Q=1e3){this.h=_,this.j=ue,this.k=le,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(U=>this.q(U)),this.m({type:200})}registerChannel(_,ue){this.b.set(_,ue),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const ue=this.o([_.type]);this.k?.logOutgoing(ue,0,1,r(_.type));return}case 201:case 202:case 204:case 203:{const ue=this.o([_.type,_.id],_.data);this.k?.logOutgoing(ue,_.id,1,r(_.type),_.data);return}}}o(_,ue=void 0){const le=new a;return P(le,_),P(le,ue),this.p(le.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const ue=new d(_),le=E(ue),Q=E(ue),U=le[0];switch(U){case 100:return this.k?.logIncoming(_.byteLength,le[1],1,`${e(U)}: ${le[2]}.${le[3]}`,Q),this.s({type:U,id:le[1],channelName:le[2],name:le[3],arg:Q});case 102:return this.k?.logIncoming(_.byteLength,le[1],1,`${e(U)}: ${le[2]}.${le[3]}`,Q),this.t({type:U,id:le[1],channelName:le[2],name:le[3],arg:Q});case 101:return this.k?.logIncoming(_.byteLength,le[1],1,`${e(U)}`),this.u({type:U,id:le[1]});case 103:return this.k?.logIncoming(_.byteLength,le[1],1,`${e(U)}`),this.u({type:U,id:le[1]})}}s(_){const ue=this.b.get(_.channelName);if(!ue){this.v(_);return}const le=new H.$me;let Q;try{Q=ue.call(this.j,_.name,_.arg,le.token)}catch(me){Q=Promise.reject(me)}const U=_.id;Q.then(me=>{this.m({id:U,data:me,type:201})},me=>{me instanceof Error?this.m({id:U,data:{message:me.message,name:me.name,stack:me.stack?me.stack.split?me.stack.split(`
`):me.stack:void 0},type:202}):this.m({id:U,data:me,type:203})}).finally(()=>{re.dispose(),this.d.delete(_.id)});const re=(0,b.$Sc)(()=>le.cancel());this.d.set(_.id,re)}t(_){const ue=this.b.get(_.channelName);if(!ue){this.v(_);return}const le=_.id,U=ue.listen(this.j,_.name,_.arg)(re=>this.m({id:le,data:re,type:204}));this.d.set(_.id,U)}u(_){const ue=this.d.get(_.id);ue&&(ue.dispose(),this.d.delete(_.id))}v(_){let ue=this.g.get(_.channelName);ue||(ue=[],this.g.set(_.channelName,ue));const le=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ue.push({request:_,timeoutTimer:le})}w(_){const ue=this.g.get(_);if(ue){for(const le of ue)switch(clearTimeout(le.timeoutTimer),le.request.type){case 100:this.s(le.request);break;case 102:this.t(le.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Pc)(this.d.values()),this.d.clear()}}t.$5h=z;var W;(function(he){he[he.LocalSide=0]="LocalSide",he[he.OtherSide=1]="OtherSide"})(W||(t.RequestInitiator=W={}));class F{constructor(_,ue=null){this.l=_,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=ue}getChannel(_){const ue=this;return{call(le,Q,U){return ue.a?Promise.reject(new A.$5):ue.m(_,le,Q,U)},listen(le,Q){return ue.a?m.Event.None:ue.o(_,le,Q)}}}m(_,ue,le,Q=H.CancellationToken.None){const U=this.g++,me={id:U,type:100,channelName:_,name:ue,arg:le};if(Q.isCancellationRequested)return Promise.reject(new A.$5);let ve;return new Promise((Te,Me)=>{if(Q.isCancellationRequested)return Me(new A.$5);const x=()=>{const w=C=>{switch(C.type){case 201:this.f.delete(U),Te(C.data);break;case 202:{this.f.delete(U);const s=new Error(C.data.message);s.stack=Array.isArray(C.data.stack)?C.data.stack.join(`
`):C.data.stack,s.name=C.data.name,Me(s);break}case 203:this.f.delete(U),Me(C.data);break}};this.f.set(U,w),this.p(me)};let u=null;this.b===h.Idle?x():(u=(0,T.$dh)(w=>this.u()),u.then(()=>{u=null,x()}));const v=()=>{u?(u.cancel(),u=null):this.p({id:U,type:101}),Me(new A.$5)},l=Q.onCancellationRequested(v);ve=(0,b.$Rc)((0,b.$Sc)(v),l),this.d.add(ve)}).finally(()=>{ve.dispose(),this.d.delete(ve)})}o(_,ue,le){const Q=this.g++,re={id:Q,type:102,channelName:_,name:ue,arg:le};let me=null;const ve=new m.$be({onWillAddFirstListener:()=>{me=(0,T.$dh)(Te=>this.u()),me.then(()=>{me=null,this.d.add(ve),this.p(re)})},onDidRemoveLastListener:()=>{me?(me.cancel(),me=null):(this.d.delete(ve),this.p({id:Q,type:103}))}}),Ne=Te=>ve.fire(Te.data);return this.f.set(Q,Ne),ve.event}p(_){switch(_.type){case 100:case 102:{const ue=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(ue,_.id,0,`${e(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const ue=this.q([_.type,_.id]);this.j?.logOutgoing(ue,_.id,0,e(_.type));return}}}q(_,ue=void 0){const le=new a;return P(le,_),P(le,ue),this.r(le.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const ue=new d(_),le=E(ue),Q=E(ue),U=le[0];switch(U){case 200:return this.j?.logIncoming(_.byteLength,0,0,r(U)),this.t({type:le[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,le[1],0,r(U),Q),this.t({type:le[0],id:le[1],data:Q})}}t(_){if(_.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Pc)(this.d.values()),this.d.clear()}}t.$6h=F,Je([S.$Uh],F.prototype,"onDidInitializePromise",null);class K{get connections(){const _=[];return this.f.forEach(ue=>_.push(ue)),_}constructor(_,ue,le){this.a=new Map,this.f=new Set,this.g=new m.$be,this.onDidAddConnection=this.g.event,this.h=new m.$be,this.onDidRemoveConnection=this.h.event,this.j=new b.$Tc,this.j.add(_(({protocol:Q,onDidClientDisconnect:U})=>{const re=m.Event.once(Q.onMessage);this.j.add(re(me=>{const ve=new d(me),Ne=E(ve),Te=new z(Q,Ne,ue,le),Me=new F(Q,ue);this.a.forEach((u,v)=>Te.registerChannel(v,u));const x={channelServer:Te,channelClient:Me,ctx:Ne};this.f.add(x),this.g.fire(x),this.j.add(U(()=>{Te.dispose(),Me.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(_,ue){const le=this;return{call(Q,U,re){let me;if((0,c.$fg)(ue)){const Ne=(0,i.$4b)(le.connections.filter(ue));me=Ne?Promise.resolve(Ne):m.Event.toPromise(m.Event.filter(le.onDidAddConnection,ue))}else me=ue.routeCall(le,Q,U);const ve=me.then(Ne=>Ne.channelClient.getChannel(_));return G(ve).call(Q,U,re)},listen(Q,U){if((0,c.$fg)(ue))return le.k(_,ue,Q,U);const re=ue.routeEvent(le,Q,U).then(me=>me.channelClient.getChannel(_));return G(re).listen(Q,U)}}}k(_,ue,le,Q){const U=this;let re;const me=new m.$be({onWillAddFirstListener:()=>{re=new b.$Tc;const ve=new m.$he,Ne=new Map,Te=x=>{const v=x.channelClient.getChannel(_).listen(le,Q),l=ve.add(v);Ne.set(x,l)},Me=x=>{const u=Ne.get(x);u&&(u.dispose(),Ne.delete(x))};U.connections.filter(ue).forEach(Te),m.Event.filter(U.onDidAddConnection,ue)(Te,void 0,re),U.onDidRemoveConnection(Me,void 0,re),ve.event(me.fire,me,re),re.add(ve)},onDidRemoveLastListener:()=>{re?.dispose(),re=void 0}});return me.event}registerChannel(_,ue){this.a.set(_,ue);for(const le of this.f)le.channelServer.registerChannel(_,ue)}dispose(){this.j.dispose();for(const _ of this.f)_.channelClient.dispose(),_.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$7h=K;class B{constructor(_,ue,le=null){const Q=new a;P(Q,ue),_.send(Q.buffer),this.a=new F(_,le),this.d=new z(_,ue,le)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,ue){this.d.registerChannel(_,ue)}dispose(){this.a.dispose(),this.d.dispose()}}t.$8h=B;function G(he){return{call(_,ue,le){return he.then(Q=>Q.call(_,ue,le))},listen(_,ue){const le=new m.$ke;return he.then(Q=>le.input=Q.listen(_,ue)),le.event}}}function V(he){let _=!1;return{call(ue,le,Q){return _?he.call(ue,le,Q):(0,T.$rh)(0).then(()=>_=!0).then(()=>he.call(ue,le,Q))},listen(ue,le){if(_)return he.listen(ue,le);const Q=new m.$ke;return(0,T.$rh)(0).then(()=>_=!0).then(()=>Q.input=he.listen(ue,le)),Q.event}}}class ae{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const ue of _.connections)if(await Promise.resolve(this.a(ue.ctx)))return Promise.resolve(ue);return await m.Event.toPromise(_.onDidAddConnection),await this.b(_)}}t.$$h=ae;var ie;(function(he){function _(U,re,me){const ve=U,Ne=me&&me.disableMarshalling,Te=new Map;for(const Me in ve)le(Me)&&Te.set(Me,m.Event.buffer(ve[Me],!0,void 0,re));return new class{listen(Me,x,u){const v=Te.get(x);if(v)return v;const l=ve[x];if(typeof l=="function"){if(Q(x))return l.call(ve,u);if(le(x))return Te.set(x,m.Event.buffer(ve[x],!0,void 0,re)),Te.get(x)}throw new A.$bb(`Event not found: ${x}`)}call(Me,x,u){const v=ve[x];if(typeof v=="function"){if(!Ne&&Array.isArray(u))for(let w=0;w<u.length;w++)u[w]=(0,p.$Zh)(u[w]);let l=v.apply(ve,u);return l instanceof Promise||(l=Promise.resolve(l)),l}throw new A.$bb(`Method not found: ${x}`)}}}he.fromService=_;function ue(U,re){const me=re&&re.disableMarshalling;return new Proxy({},{get(ve,Ne){if(typeof Ne=="string")return re?.properties?.has(Ne)?re.properties.get(Ne):Q(Ne)?function(Te){return U.listen(Ne,Te)}:le(Ne)?U.listen(Ne):async function(...Te){let Me;re&&!(0,c.$ag)(re.context)?Me=[re.context,...Te]:Me=Te;const x=await U.call(Ne,Me);return me?x:(0,p.$Zh)(x)};throw new A.$bb(`Property not found: ${String(Ne)}`)}})}he.toService=ue;function le(U){return U[0]==="o"&&U[1]==="n"&&j.$sf(U.charCodeAt(2))}function Q(U){return/^onDynamic/.test(U)&&j.$sf(U.charCodeAt(9))}})(ie||(t.ProxyChannel=ie={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(he){if(Array.isArray(he))return he;if(he&&typeof he=="object"&&typeof he.toString=="function"){const _=he.toString();if(_!=="[object Object]")return _}return he}function Ee(he){return Array.isArray(he)?he.map(ge):ge(he)}function De(he,_,ue,le,Q,U,re){re=Ee(re);const me=ee[Q],ve=me[le%me.length];let Ne=[`%c[${he}]%c[${String(_).padStart(7," ")}]%c[len: ${String(ue).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${U}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(U)?(Ne=Ne.concat(re),Ne.push(")")):Ne.push(re),console.log.apply(console,Ne)}class Le{constructor(_,ue){this.d=_,this.f=ue,this.a=0,this.b=0}logOutgoing(_,ue,le,Q,U){this.b+=_,De(this.d,this.b,_,ue,le,Q,U)}logIncoming(_,ue,le,Q,U){this.a+=_,De(this.f,this.a,_,ue,le,Q,U)}}t.$_h=Le}),define(be[145],$e([1,0,43,3,77,102,35]),function(se,t,i,T,O,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OW=void 0;class A extends O.$8h{static f(){const b=T.Event.fromNodeEventEmitter(S.$O,"vscode:message",(p,j)=>i.$Ce.wrap(j));return S.$O.send("vscode:hello"),new H.$KW(S.$O,b)}constructor(b){const p=A.f();super(p,b),this.b=p}dispose(){this.b.disconnect(),super.dispose()}}t.$OW=A}),define(be[146],$e([13,12]),function(se,t){return se.create("vs/platform/files/common/files",t)}),define(be[147],$e([13,12]),function(se,t){return se.create("vs/platform/theme/common/iconRegistry",t)}),define(be[50],$e([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pi=t._util=void 0,t.$qi=O,t.$ri=H;var i;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function A(m){return m[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=A})(i||(t._util=i={})),t.$pi=O("instantiationService");function T(S,A,m){A[i.DI_TARGET]===A?A[i.DI_DEPENDENCIES].push({id:S,index:m}):(A[i.DI_DEPENDENCIES]=[{id:S,index:m}],A[i.DI_TARGET]=A)}function O(S){if(i.serviceIds.has(S))return i.serviceIds.get(S);const A=function(m,b,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(A,m,p)};return A.toString=()=>S,i.serviceIds.set(S,A),A}function H(S){return S}}),define(be[148],$e([1,0,50]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_m=t.$0m=t.ID=void 0,t.$$m=T,t.ID="diagnosticsService",t.$0m=(0,i.$qi)(t.ID);function T(H){return!!H.hostName&&!!H.errorMessage}class O{async getPerformanceInfo(S,A){return{}}async getSystemInfo(S,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(S,A){return""}async getWorkspaceFileExtensions(S){return{extensions:[]}}async reportWorkspaceStats(S){}}t.$_m=O}),define(be[149],$e([1,0,99,25,9,10,16,146,50,5,36,23]),function(se,t,i,T,O,H,S,A,m,b,p,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sl=t.$pl=t.FileKind=t.$ol=t.$nl=t.$ml=t.$ll=t.$kl=t.$jl=t.$il=t.FileOperationResult=t.$hl=t.$gl=t.$fl=t.$dl=t.FileChangeType=t.$cl=t.FileOperation=t.$9k=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.$Wk=void 0,t.$Xk=c,t.$Yk=n,t.$Zk=h,t.$1k=g,t.$2k=y,t.$3k=o,t.$4k=d,t.$5k=a,t.$6k=k,t.$7k=N,t.$8k=R,t.$0k=E,t.$$k=z,t.$_k=W,t.$al=F,t.$bl=K,t.$el=ie,t.$ql=he,t.$rl=_,t.$tl=le,t.$Wk=(0,m.$qi)("fileService");function c(Q){return Q.create===!0}var f;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.File=1]="File",Q[Q.Directory=2]="Directory",Q[Q.SymbolicLink=64]="SymbolicLink"})(f||(t.FileType=f={}));var e;(function(Q){Q[Q.Readonly=1]="Readonly",Q[Q.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function n(Q){const U=Q;return!!U&&typeof U.onDidChange=="function"}var r;(function(Q){Q[Q.None=0]="None",Q[Q.FileReadWrite=2]="FileReadWrite",Q[Q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Q[Q.FileReadStream=16]="FileReadStream",Q[Q.FileFolderCopy=8]="FileFolderCopy",Q[Q.PathCaseSensitive=1024]="PathCaseSensitive",Q[Q.Readonly=2048]="Readonly",Q[Q.Trash=4096]="Trash",Q[Q.FileWriteUnlock=8192]="FileWriteUnlock",Q[Q.FileAtomicRead=16384]="FileAtomicRead",Q[Q.FileAtomicWrite=32768]="FileAtomicWrite",Q[Q.FileAtomicDelete=65536]="FileAtomicDelete",Q[Q.FileClone=131072]="FileClone"})(r||(t.FileSystemProviderCapabilities=r={}));function h(Q){return!!(Q.capabilities&2)}function g(Q){return!!(Q.capabilities&8)}function y(Q){return!!(Q.capabilities&131072)}function o(Q){return!!(Q.capabilities&4)}function d(Q){return!!(Q.capabilities&16)}function a(Q){return h(Q)?!!(Q.capabilities&16384):!1}function k(Q){return h(Q)?!!(Q.capabilities&32768):!1}function N(Q){return!!(Q.capabilities&65536)}function R(Q){return!!(Q.capabilities&2048)}var L;(function(Q){Q.FileExists="EntryExists",Q.FileNotFound="EntryNotFound",Q.FileNotADirectory="EntryNotADirectory",Q.FileIsADirectory="EntryIsADirectory",Q.FileExceedsStorageQuota="EntryExceedsStorageQuota",Q.FileTooLarge="EntryTooLarge",Q.FileWriteLocked="EntryWriteLocked",Q.NoPermissions="NoPermissions",Q.Unavailable="Unavailable",Q.Unknown="Unknown"})(L||(t.FileSystemProviderErrorCode=L={}));class P extends Error{static create(U,re){const me=new P(U.toString(),re);return W(me,re),me}constructor(U,re){super(U),this.code=re}}t.$9k=P;function E(Q,U){return P.create(Q,U)}function z(Q){return Q||E((0,A.localize)(0,null),L.Unknown)}function W(Q,U){return Q.name=U?`${U} (FileSystemError)`:"FileSystemError",Q}function F(Q){if(!Q)return L.Unknown;if(Q instanceof P)return Q.code;const U=/^(.+) \(FileSystemError\)$/.exec(Q.name);if(!U)return L.Unknown;switch(U[1]){case L.FileExists:return L.FileExists;case L.FileIsADirectory:return L.FileIsADirectory;case L.FileNotADirectory:return L.FileNotADirectory;case L.FileNotFound:return L.FileNotFound;case L.FileTooLarge:return L.FileTooLarge;case L.FileWriteLocked:return L.FileWriteLocked;case L.NoPermissions:return L.NoPermissions;case L.Unavailable:return L.Unavailable}return L.Unknown}function K(Q){if(Q instanceof ee)return Q.fileOperationResult;switch(F(Q)){case L.FileNotFound:return 1;case L.FileIsADirectory:return 0;case L.FileNotADirectory:return 9;case L.FileWriteLocked:return 5;case L.NoPermissions:return 6;case L.FileExists:return 4;case L.FileTooLarge:return 7;default:return 10}}var B;(function(Q){Q[Q.CREATE=0]="CREATE",Q[Q.DELETE=1]="DELETE",Q[Q.MOVE=2]="MOVE",Q[Q.COPY=3]="COPY",Q[Q.WRITE=4]="WRITE"})(B||(t.FileOperation=B={}));class G{constructor(U,re,me){this.resource=U,this.operation=re,this.target=me}isOperation(U){return this.operation===U}}t.$cl=G;var V;(function(Q){Q[Q.UPDATED=0]="UPDATED",Q[Q.ADDED=1]="ADDED",Q[Q.DELETED=2]="DELETED"})(V||(t.FileChangeType=V={}));class ae{static{this.a=null}constructor(U,re){this.c=re,this.b=void 0,this.d=new j.$V(()=>{const me=i.$wi.forUris(()=>this.c);return me.fill(this.rawAdded.map(ve=>[ve,!0])),me}),this.f=new j.$V(()=>{const me=i.$wi.forUris(()=>this.c);return me.fill(this.rawUpdated.map(ve=>[ve,!0])),me}),this.g=new j.$V(()=>{const me=i.$wi.forUris(()=>this.c);return me.fill(this.rawDeleted.map(ve=>[ve,!0])),me}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const me of U){switch(me.type){case 1:this.rawAdded.push(me.resource);break;case 0:this.rawUpdated.push(me.resource);break;case 2:this.rawDeleted.push(me.resource);break}this.b!==ae.a&&(typeof me.cId=="number"?this.b===void 0?this.b=me.cId:this.b!==me.cId&&(this.b=ae.a):this.b!==void 0&&(this.b=ae.a))}}contains(U,...re){return this.h(U,{includeChildren:!1},...re)}affects(U,...re){return this.h(U,{includeChildren:!0},...re)}h(U,re,...me){if(!U)return!1;const ve=me.length>0;return!!((!ve||me.includes(1))&&(this.d.value.get(U)||re.includeChildren&&this.d.value.findSuperstr(U))||(!ve||me.includes(0))&&(this.f.value.get(U)||re.includeChildren&&this.f.value.findSuperstr(U))||(!ve||me.includes(2))&&(this.g.value.findSubstr(U)||re.includeChildren&&this.g.value.findSuperstr(U)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(U){return this.b===U}hasCorrelation(){return typeof this.b=="number"}}t.$dl=ae;function ie(Q,U,re){return!Q||!U||Q===U||U.length>Q.length?!1:(U.charAt(U.length-1)!==T.sep&&(U+=T.sep),re?(0,O.$uf)(Q,U):Q.indexOf(U)===0)}class ee extends Error{constructor(U,re,me){super(U),this.fileOperationResult=re,this.options=me}}t.$fl=ee;class ge extends ee{constructor(U,re,me,ve){super(U,re,ve),this.fileOperationResult=re,this.size=me}}t.$gl=ge;class Ee extends ee{constructor(U,re,me){super(U,2,me),this.stat=re}}t.$hl=Ee;var De;(function(Q){Q[Q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Q[Q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Q[Q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Q[Q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Q[Q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Q[Q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Q[Q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Q[Q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Q[Q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Q[Q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Q[Q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(De||(t.FileOperationResult=De={})),t.$il={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$jl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$kl="files.associations",t.$ll="files.exclude",t.$ml="files.readonlyInclude",t.$nl="files.readonlyExclude",t.$ol="files.readonlyFromPermissions";var Le;(function(Q){Q[Q.FILE=0]="FILE",Q[Q.FOLDER=1]="FOLDER",Q[Q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Le||(t.FileKind=Le={})),t.$pl="";function he(Q){if(!(typeof Q.size!="number"||typeof Q.mtime!="number"))return Q.mtime.toString(29)+Q.size.toString(31)}async function _(Q,U){if(!U.hasProvider(S.URI.from({scheme:Q.scheme})))return new Promise(re=>{const me=U.onDidChangeFileSystemProviderRegistrations(ve=>{ve.scheme===Q.scheme&&ve.added&&(me.dispose(),re())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(U){return(0,H.$8f)(U)||(U=0),U<ue.KB?(0,A.localize)(1,null,U.toFixed(0)):U<ue.MB?(0,A.localize)(2,null,(U/ue.KB).toFixed(2)):U<ue.GB?(0,A.localize)(3,null,(U/ue.MB).toFixed(2)):U<ue.TB?(0,A.localize)(4,null,(U/ue.GB).toFixed(2)):(0,A.localize)(5,null,(U/ue.TB).toFixed(2))}}t.$sl=ue;function le(Q){const U=typeof Q=="string"||Q?.scheme===p.Schemas.vscodeRemote;return typeof Q!="string"&&Q?.scheme===p.Schemas.file?1024*ue.MB:U?10*ue.MB:b.$o?50*ue.MB:1024*ue.MB}}),define(be[150],$e([1,0,50]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ucc=t.$Tcc=void 0,t.$Tcc=(0,i.$qi)("mainProcessService");class T{constructor(H,S){this.a=H,this.b=S}getChannel(H){return this.a.getChannel(H,this.b)}registerChannel(H,S){this.a.registerChannel(H,S)}}t.$Ucc=T}),define(be[151],$e([1,0,2,145]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vcc=void 0;class O extends i.$Uc{constructor(S){super(),this.a=this.B(new T.$OW(`window:${S}`))}getChannel(S){return this.a.getChannel(S)}registerChannel(S,A){this.a.registerChannel(S,A)}}t.$Vcc=O});var Ei=this&&this.__param||function(se,t){return function(i,T){t(i,T,se)}};define(be[152],$e([1,0,77,150]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zcc=void 0;let O=class{constructor(S,A){return this.windowId=S,i.ProxyChannel.toService(A.getChannel("nativeHost"),{context:S,properties:(()=>{const m=new Map;return m.set("windowId",S),m})()})}};t.$Zcc=O,t.$Zcc=O=Je([Ei(1,T.$Tcc)],O)}),define(be[78],$e([1,0,37,10]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9n=void 0;class O{constructor(){this.a=new Map}add(S,A){i.ok(T.$4f(S)),i.ok(T.$6f(A)),i.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,A)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}t.$9n=new O}),define(be[153],$e([1,0,3,78]),function(se,t,i,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0n=void 0,t.$0n={JSONContribution:"base.contributions.json"};function O(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class H{constructor(){this.b=new i.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,b){this.a[O(m)]=b,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const S=new H;T.$9n.add(t.$0n.JSONContribution,S)}),define(be[154],$e([1,0,11,18,45,19,3,10,16,147,153,78]),function(se,t,i,T,O,H,S,A,m,b,p,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0w=t.$9w=t.$8w=t.$7w=t.$6w=t.$5w=t.IconFontDefinition=t.IconContribution=t.$2w=void 0,t.$3w=r,t.$4w=h,t.$2w={IconContribution:"base.contributions.icons"};var c;(function(d){function a(k,N){let R=k.defaults;for(;H.ThemeIcon.isThemeIcon(R);){const L=n.getIcon(R.id);if(!L)return;R=L.defaults}return R}d.getDefinition=a})(c||(t.IconContribution=c={}));var f;(function(d){function a(N){return{weight:N.weight,style:N.style,src:N.src.map(R=>({format:R.format,location:R.location.toString()}))}}d.toJSONObject=a;function k(N){const R=L=>(0,A.$4f)(L)?L:void 0;if(N&&Array.isArray(N.src)&&N.src.every(L=>(0,A.$4f)(L.format)&&(0,A.$4f)(L.location)))return{weight:R(N.weight),style:R(N.style),src:N.src.map(L=>({format:L.format,location:m.URI.parse(L.location)}))}}d.fromJSONObject=k})(f||(t.IconFontDefinition=f={}));class e{constructor(){this.a=new S.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${H.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,k,N,R){const L=this.b[a];if(L){if(N&&!L.description){L.description=N,this.d.properties[a].markdownDescription=`${N} $(${a})`;const z=this.e.enum.indexOf(a);z!==-1&&(this.e.enumDescriptions[z]=N),this.a.fire()}return L}const P={id:a,description:N,defaults:k,deprecationMessage:R};this.b[a]=P;const E={$ref:"#/definitions/icons"};return R&&(E.deprecationMessage=R),N&&(E.markdownDescription=`${N}: $(${a})`),this.d.properties[a]=E,this.e.enum.push(a),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const k=this.e.enum.indexOf(a);k!==-1&&(this.e.enum.splice(k,1),this.e.enumDescriptions.splice(k,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,k){const N=this.f[a];return N||(this.f[a]=k,this.a.fire(),k)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(L,P)=>L.id.localeCompare(P.id),k=L=>{for(;H.ThemeIcon.isThemeIcon(L.defaults);)L=this.b[L.defaults.id];return`codicon codicon-${L?L.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const R=Object.keys(this.b).map(L=>this.b[L]);for(const L of R.filter(P=>!!P.description).sort(a))N.push(`|<i class="${k(L)}"></i>|${L.id}|${H.ThemeIcon.isThemeIcon(L.defaults)?L.defaults.id:L.id}|${L.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const L of R.filter(P=>!H.ThemeIcon.isThemeIcon(P.defaults)).sort(a))N.push(`|<i class="${k(L)}"></i>|${L.id}|`);return N.join(`
`)}}const n=new e;j.$9n.add(t.$2w.IconContribution,n);function r(d,a,k,N){return n.registerIcon(d,a,k,N)}function h(){return n}function g(){const d=(0,O.$Lj)();for(const a in d){const k="\\"+d[a].toString(16);n.registerIcon(a,{fontCharacter:k})}}g(),t.$5w="vscode://schemas/icons";const y=j.$9n.as(p.$0n.JSONContribution);y.registerSchema(t.$5w,n.getIconSchema());const o=new i.$Ch(()=>y.notifySchemaChanged(t.$5w),200);n.onDidChange(()=>{o.isScheduled()||o.schedule()}),t.$6w=r("widget-close",T.$Pj.close,(0,b.localize)(2,null)),t.$7w=r("goto-previous-location",T.$Pj.arrowUp,(0,b.localize)(3,null)),t.$8w=r("goto-next-location",T.$Pj.arrowDown,(0,b.localize)(4,null)),t.$9w=H.ThemeIcon.modify(T.$Pj.sync,"spin"),t.$0w=H.ThemeIcon.modify(T.$Pj.loading,"spin")}),define(be[155],$e([1,0,4,3,2,19,154]),function(se,t,i,T,O,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aJb=void 0,t.$_Ib=A;function A(b){const p=new O.$Tc,j=p.add(new T.$be),c=(0,S.$4w)();return p.add(c.onDidChange(()=>j.fire())),b&&p.add(b.onDidProductIconThemeChange(()=>j.fire())),{dispose:()=>p.dispose(),onDidChange:j.event,getCSS(){const f=b?b.getProductIconTheme():new m,e={},n=[],r=[];for(const h of c.getIcons()){const g=f.getIcon(h);if(!g)continue;const y=g.font,o=`--vscode-icon-${h.id}-font-family`,d=`--vscode-icon-${h.id}-content`;y?(e[y.id]=y.definition,r.push(`${o}: ${(0,i.$XS)(y.id)};`,`${d}: '${g.fontCharacter}';`),n.push(`.codicon-${h.id}:before { content: '${g.fontCharacter}'; font-family: ${(0,i.$XS)(y.id)}; }`)):(r.push(`${d}: '${g.fontCharacter}'; ${o}: 'codicon';`),n.push(`.codicon-${h.id}:before { content: '${g.fontCharacter}'; }`))}for(const h in e){const g=e[h],y=g.weight?`font-weight: ${g.weight};`:"",o=g.style?`font-style: ${g.style};`:"",d=g.src.map(a=>`${(0,i.$WS)(a.location)} format('${a.format}')`).join(", ");n.push(`@font-face { src: ${d}; font-family: ${(0,i.$XS)(h)};${y}${o} font-display: block; }`)}return n.push(`:root { ${r.join(" ")} }`),n.join(`
`)}}}class m{getIcon(p){const j=(0,S.$4w)();let c=p.defaults;for(;H.ThemeIcon.isThemeIcon(c);){const f=j.getIcon(c.id);if(!f)return;c=f.defaults}return c}}t.$aJb=m}),define(be[156],$e([1,0,5]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$lD=void 0,t.$mD=T,t.$nD=O,t.$oD=H,t.$pD=S,t.$qD=A,t.$rD=j,t.$sD=c,t.$tD=f,t.$uD=e,t.$vD=n,t.$wD=r,t.$lD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function T(h){return typeof h.parentId=="number"}function O(h){return!!h.workspaceUri}function H(h){return!!h.folderUri}function S(h){return!!h.fileUri}function A(h){const g=c(h),y=h.getValue("window.menuBarVisibility");return y==="default"||g&&y==="compact"||i.$j&&i.$m?"classic":y}var m;(function(h){h.TITLE_BAR_STYLE="window.titleBarStyle",h.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(m||(t.TitleBarSetting=m={}));var b;(function(h){h.NATIVE="native",h.CUSTOM="custom"})(b||(t.TitlebarStyle=b={}));var p;(function(h){h.AUTO="auto",h.WINDOWED="windowed",h.NEVER="never"})(p||(t.CustomTitleBarVisibility=p={}));function j(h,g){return!0}function c(h,g){return g||(g=f(h)),g==="native"}function f(h){if(i.$o)return"custom";const g=h.getValue("window");if(g){if(i.$j&&g.nativeTabs===!0||i.$j&&g.nativeFullScreen===!1)return"native";const d=g.titleBarStyle;if(d==="native"||d==="custom")return d}return i.$k?"native":"custom"}function e(h){return!(!i.$i||i.$o||c(h))}function n(h){const g=h.getValue("window");return!g||typeof g.nativeFullScreen!="boolean"||g.nativeTabs?!0:g.nativeFullScreen!==!1}function r(h=0){return Math.pow(1.2,h)}}),define(be[157],$e([1,0,17,4,22,35,156]),function(se,t,i,T,O,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3cc=t.$2cc=t.ApplyZoomTarget=void 0,t.$4cc=m,t.$5cc=p,t.$6cc=j;var A;(function(c){c[c.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",c[c.ALL_WINDOWS=2]="ALL_WINDOWS"})(A||(t.ApplyZoomTarget=A={})),t.$2cc=8,t.$3cc=-8;function m(c,f){c=Math.min(Math.max(c,t.$3cc),t.$2cc);const e=[];f===A.ACTIVE_WINDOW?e.push((0,T.$lS)()):f===A.ALL_WINDOWS?e.push(...Array.from((0,T.getWindows)()).map(({window:n})=>n)):e.push(f);for(const n of e)b(n)?.webFrame?.setZoomLevel(c),(0,i.$iR)((0,S.$wD)(c),n),(0,i.$eR)(c,n)}function b(c){if(c===O.$aR)return{ipcRenderer:H.$O,webFrame:H.$Q};{const f=c;if(f?.vscode?.ipcRenderer&&f?.vscode?.webFrame)return f.vscode}}function p(c){m((0,i.$fR)(typeof c=="number"?(0,T.$lS)():c)+1,c)}function j(c){m((0,i.$fR)(typeof c=="number"?(0,T.$lS)():c)-1,c)}}),define(be[158],$e([1,0,12,4,144,11,103,35,148,149,151,152,155,157,15,22,116,107]),function(se,t,i,T,O,H,S,A,m,b,p,j,c,f,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=z;const r=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,h=/\s--inspect-port=(?<port>\d+)/;class g{getHeight(F){return 22}getTemplateId(F){return L(F)?"process":N(F)?"machine":(0,m.$$m)(F)?"error":R(F)?"header":""}}class y{hasChildren(F){return(0,m.$$m)(F)?!1:L(F)?!!F.children?.length:!0}getChildren(F){return L(F)?F.children?F.children:[]:(0,m.$$m)(F)?[]:R(F)?F.processRoots.length>1?F.processRoots:[F.processRoots[0].rootProcess]:N(F)?[F.rootProcess]:[F.processes]}}class o{constructor(){this.templateId="header"}renderTemplate(F){const K=(0,T.$GS)(F,(0,T.$)(".row")),B=(0,T.$GS)(K,(0,T.$)(".nameLabel")),G=(0,T.$GS)(K,(0,T.$)(".cpu")),V=(0,T.$GS)(K,(0,T.$)(".memory")),ae=(0,T.$GS)(K,(0,T.$)(".pid"));return{name:B,CPU:G,memory:V,PID:ae}}renderElement(F,K,B,G){B.name.textContent=(0,i.localize)(0,null),B.CPU.textContent=(0,i.localize)(1,null),B.PID.textContent=(0,i.localize)(2,null),B.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(F){}}class d{constructor(){this.templateId="machine"}renderTemplate(F){const K=Object.create(null),B=(0,T.$GS)(F,(0,T.$)(".row"));return K.name=(0,T.$GS)(B,(0,T.$)(".nameLabel")),K}renderElement(F,K,B,G){B.name.textContent=F.element.name}disposeTemplate(F){}}class a{constructor(){this.templateId="error"}renderTemplate(F){const K=Object.create(null),B=(0,T.$GS)(F,(0,T.$)(".row"));return K.name=(0,T.$GS)(B,(0,T.$)(".nameLabel")),K}renderElement(F,K,B,G){B.name.textContent=F.element.errorMessage}disposeTemplate(F){}}class k{constructor(F,K,B){this.a=F,this.b=K,this.c=B,this.templateId="process"}renderTemplate(F){const K=(0,T.$GS)(F,(0,T.$)(".row")),B=(0,T.$GS)(K,(0,T.$)(".nameLabel")),G=(0,T.$GS)(K,(0,T.$)(".cpu")),V=(0,T.$GS)(K,(0,T.$)(".memory")),ae=(0,T.$GS)(K,(0,T.$)(".pid"));return{name:B,CPU:G,PID:ae,memory:V}}renderElement(F,K,B,G){const{element:V}=F,ae=V.pid.toFixed(0);let ie=V.name;this.c.has(V.pid)&&(ie=this.c.get(V.pid)),B.name.textContent=ie,B.name.title=V.cmd,B.CPU.textContent=V.load.toFixed(0),B.PID.textContent=ae,B.PID.parentElement.id=`pid-${ae}`;const ee=this.a==="win32"?V.mem:this.b*(V.mem/100);B.memory.textContent=(ee/b.$sl.MB).toFixed(0)}disposeTemplate(F){}}function N(W){return!!W.name&&!!W.rootProcess}function R(W){return!!W.processRoots}function L(W){return!!W.pid}class P{constructor(F,K){this.f=K,this.b=new Map;const B=new p.$Vcc(F);this.c=new j.$Zcc(F,B),this.k(K.styles),this.g(K),A.$O.on("vscode:pidToNameResponse",(G,V)=>{this.b.clear();for(const[ae,ie]of V)this.b.set(ae,ie)}),A.$O.on("vscode:listProcessesResponse",async(G,V)=>{V.forEach((ae,ie)=>{L(ae.rootProcess)&&(ae.rootProcess.name=ie===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:V}}),this.d.layout(n.$aR.innerHeight,n.$aR.innerWidth)):await this.h(V),this.m(0)}),this.a=Date.now(),A.$O.send("vscode:pidToNameRequest"),A.$O.send("vscode:listProcesses")}g(F){n.$aR.document.onkeydown=K=>{const B=F.platform==="darwin"?K.metaKey:K.ctrlKey;B&&K.keyCode===87&&(K.stopPropagation(),K.preventDefault(),A.$O.send("vscode:closeProcessExplorer")),B&&K.keyCode===187&&(0,f.$5cc)(n.$aR),B&&K.keyCode===189&&(0,f.$6cc)(n.$aR)}}async h(F){const K=n.$aR.document.getElementById("process-list");if(!K)return;const{totalmem:B}=await this.c.getOSStatistics(),G=[new k(this.f.platform,B,this.b),new o,new d,new a];this.d=new O.$bW("processExplorer",K,new g,G,new y,{identityProvider:{getId:V=>L(V)?V.pid.toString():(0,m.$$m)(V)?V.hostName:R(V)?"processes":N(V)?V.name:"header"}}),this.d.setInput({processes:{processRoots:F}}),this.d.layout(n.$aR.innerHeight,n.$aR.innerWidth),this.d.onKeyDown(V=>{const ae=new e.$DR(V);if(ae.keyCode===35&&ae.altKey){const ie=this.n();Promise.all(ie.map(ee=>this.c.killProcess(ee,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(V=>{L(V.element)&&this.l(V.element,!0)}),K.style.height=`${n.$aR.innerHeight}px`,n.$aR.addEventListener("resize",()=>{K.style.height=`${n.$aR.innerHeight}px`,this.d?.layout(n.$aR.innerHeight,n.$aR.innerWidth)})}i(F){const K=r.exec(F);return K&&K.groups.port!=="0"||F.indexOf("node ")>=0||F.indexOf("node.exe")>=0}j(F){const K={type:"node",request:"attach",name:`process ${F.pid}`};let B=r.exec(F.cmd);B?K.port=Number(B.groups.port):K.processId=String(F.pid),B=h.exec(F.cmd),B&&(K.port=Number(B.groups.port)),A.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[K]})}k(F){const K=(0,T.$oS)(),B=[];F.listFocusBackground&&(B.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${F.listFocusBackground}; }`),B.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${F.listFocusBackground}; }`)),F.listFocusForeground&&B.push(`.monaco-list:focus .monaco-list-row.focused { color: ${F.listFocusForeground}; }`),F.listActiveSelectionBackground&&(B.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${F.listActiveSelectionBackground}; }`),B.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${F.listActiveSelectionBackground}; }`)),F.listActiveSelectionForeground&&B.push(`.monaco-list:focus .monaco-list-row.selected { color: ${F.listActiveSelectionForeground}; }`),F.listHoverBackground&&B.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${F.listHoverBackground}; }`),F.listHoverForeground&&B.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${F.listHoverForeground}; }`),F.listFocusOutline&&B.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${F.listFocusOutline}; outline-offset: -1px; }`),F.listHoverOutline&&B.push(`.monaco-list-row:hover { outline: 1px dashed ${F.listHoverOutline}; outline-offset: -1px; }`),F.scrollbarShadowColor&&B.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${F.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${F.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${F.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),F.scrollbarSliderBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${F.scrollbarSliderBackgroundColor};
				}
			`),F.scrollbarSliderHoverBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${F.scrollbarSliderHoverBackgroundColor};
				}
			`),F.scrollbarSliderActiveBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${F.scrollbarSliderActiveBackgroundColor};
				}
			`),K.textContent=B.join(`
`),F.color&&(n.$aR.document.body.style.color=F.color)}l(F,K){const B=[],G=Number(F.pid);K&&(B.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(G,"SIGTERM")}}),B.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(G,"SIGKILL")}}),B.push({type:"separator"})),B.push({label:(0,i.localize)(6,null),click:()=>{const V=this.n();V?.includes(G)||(V.length=0,V.push(G));const ae=V?.map(ie=>n.$aR.document.getElementById(`pid-${ie}`)).filter(ie=>!!ie);if(ae){const ie=ae.map(ee=>ee.innerText).filter(ee=>!!ee);this.c.writeClipboardText(ie.join(`
`))}}}),B.push({label:(0,i.localize)(7,null),click:()=>{const V=n.$aR.document.getElementById("process-list");V&&this.c.writeClipboardText(V.innerText)}}),F&&K&&this.i(F.cmd)&&(B.push({type:"separator"}),B.push({label:(0,i.localize)(8,null),click:()=>{this.j(F)}})),(0,S.$GW)(B)}m(F){setTimeout(()=>{const K=Date.now(),B=F+K-this.a;this.a=K,B>1e3?(A.$O.send("vscode:pidToNameRequest"),A.$O.send("vscode:listProcesses")):this.m(B)},200)}n(){return this.d?.getSelection()?.map(F=>{if(!(!F||!("pid"in F)))return F.pid}).filter(F=>!!F)}}function E(){const W=(0,T.$oS)();W.id="codiconStyles";const F=(0,c.$_Ib)(void 0);function K(){W.textContent=F.getCSS()}const B=new H.$Ch(K,0);F.onDidChange(()=>B.schedule()),B.schedule()}function z(W){const F=W.data.platform==="win32"?"windows":W.data.platform==="linux"?"linux":"mac";n.$aR.document.body.classList.add(F),E(),(0,f.$4cc)(W.data.zoomLevel,n.$aR),new P(W.windowId,W.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d49050825fb0bbc6778a6e1a5db51fab5578abd6/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
