/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(ge){for(var e=[],I=0,T=ge.length;I<T;I++)e[I]=Re[ge[I]];return e};define(Re[68],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=T,e.$Vh=R,e.$Wh=O;function I(M){return(p,g,k)=>{let N=null,y=null;if(typeof k.value=="function"?(N="value",y=k.value):typeof k.get=="function"&&(N="get",y=k.get),!y)throw new Error("not supported");k[N]=M(y,g)}}function T(M,p,g){let k=null,N=null;if(typeof g.value=="function"?(k="value",N=g.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(k="get",N=g.get),!N)throw new Error("not supported");const y=`$memoize$${p}`;g[k]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,u)}),this[y]}}function R(M,p,g){return I((k,N)=>{const y=`$debounce$${N}`,u=`$debounce$result$${N}`;return function(...v){this[u]||(this[u]=g?g():void 0),clearTimeout(this[y]),p&&(this[u]=p(this[u],...v),v=[this[u]]),this[y]=setTimeout(()=>{k.apply(this,v),this[u]=g?g():void 0},M)}})}function O(M,p,g){return I((k,N)=>{const y=`$throttle$timer$${N}`,u=`$throttle$result$${N}`,v=`$throttle$lastRun$${N}`,m=`$throttle$pending$${N}`;return function(...s){if(this[u]||(this[u]=g?g():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),p&&(this[u]=p(this[u],...s)),this[m])return;const o=this[v]+M;o<=Date.now()?(this[v]=Date.now(),k.apply(this,[this[u]]),this[u]=g?g():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[v]=Date.now(),k.apply(this,[this[u]]),this[u]=g?g():void 0},o-Date.now()))}})}}),define(Re[90],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jP=e.$iP=void 0;class I{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$iP=I,e.$jP=new I("id#")}),define(Re[123],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Bn=M,e.$Cn=y,e.$Dn=u,e.$En=v,e.$Fn=m,e.$Gn=s,e.$Hn=o,e.$In=r,e.$Jn=n,e.$Kn=t,e.$Ln=c,e.$Mn=h;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function M(i,b=!1){let a=0;const $=i.length;let l="",S=0,d=16,D=0;function f(q){let A=0,U=0;for(;A<q;){const K=i.charCodeAt(a);if(K>=48&&K<=57)U=U*16+K-48;else if(K>=65&&K<=70)U=U*16+K-65+10;else if(K>=97&&K<=102)U=U*16+K-97+10;else break;a++,A++}return A<q&&(U=-1),U}function E(q){a=q,l="",S=0,d=16,D=0}function w(){const q=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&k(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&k(i.charCodeAt(a)))for(a++;a<i.length&&k(i.charCodeAt(a));)a++;else return D=3,i.substring(q,a);let A=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&k(i.charCodeAt(a))){for(a++;a<i.length&&k(i.charCodeAt(a));)a++;A=a}else D=3;return i.substring(q,A)}function P(){let q="",A=a;for(;;){if(a>=$){q+=i.substring(A,a),D=2;break}const U=i.charCodeAt(a);if(U===34){q+=i.substring(A,a),a++;break}if(U===92){if(q+=i.substring(A,a),a++,a>=$){D=2;break}switch(i.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const se=f(4);se>=0?q+=String.fromCharCode(se):D=4;break}default:D=5}A=a;continue}if(U>=0&&U<=31)if(g(U)){q+=i.substring(A,a),D=2;break}else D=6;a++}return q}function C(){if(l="",D=0,S=a,a>=$)return S=$,d=17;let q=i.charCodeAt(a);if(p(q)){do a++,l+=String.fromCharCode(q),q=i.charCodeAt(a);while(p(q));return d=15}if(g(q))return a++,l+=String.fromCharCode(q),q===13&&i.charCodeAt(a)===10&&(a++,l+=`
`),d=14;switch(q){case 123:return a++,d=1;case 125:return a++,d=2;case 91:return a++,d=3;case 93:return a++,d=4;case 58:return a++,d=6;case 44:return a++,d=5;case 34:return a++,l=P(),d=10;case 47:{const A=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<$&&!g(i.charCodeAt(a));)a++;return l=i.substring(A,a),d=12}if(i.charCodeAt(a+1)===42){a+=2;const U=$-1;let K=!1;for(;a<U;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,D=1),l=i.substring(A,a),d=13}return l+=String.fromCharCode(q),a++,d=16}case 45:if(l+=String.fromCharCode(q),a++,a===$||!k(i.charCodeAt(a)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=w(),d=11;default:for(;a<$&&V(q);)a++,q=i.charCodeAt(a);if(S!==a){switch(l=i.substring(S,a),l){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return l+=String.fromCharCode(q),a++,d=16}}function V(q){if(p(q)||g(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=C();while(q>=12&&q<=15);return q}return{setPosition:E,getPosition:()=>a,scan:b?W:C,getToken:()=>d,getTokenValue:()=>l,getTokenOffset:()=>S,getTokenLength:()=>a-S,getTokenError:()=>D}}function p(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function k(i){return i>=48&&i<=57}var N;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(N||(N={}));function y(i,b){const a=[],$=new Object;let l;const S={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function D(f,E,w,P){S.value=f,S.offset=E,S.length=w,S.type=P,S.colonOffset=void 0,l=S}try{t(i,{onObjectBegin:(f,E)=>{if(b<=f)throw $;l=void 0,d=b>f,a.push("")},onObjectProperty:(f,E,w)=>{if(b<E||(D(f,E,w,"property"),a[a.length-1]=f,b<=E+w))throw $},onObjectEnd:(f,E)=>{if(b<=f)throw $;l=void 0,a.pop()},onArrayBegin:(f,E)=>{if(b<=f)throw $;l=void 0,a.push(0)},onArrayEnd:(f,E)=>{if(b<=f)throw $;l=void 0,a.pop()},onLiteralValue:(f,E,w)=>{if(b<E||(D(f,E,w,h(f)),b<=E+w))throw $},onSeparator:(f,E,w)=>{if(b<=E)throw $;if(f===":"&&l&&l.type==="property")l.colonOffset=E,d=!1,l=void 0;else if(f===","){const P=a[a.length-1];typeof P=="number"?a[a.length-1]=P+1:(d=!0,a[a.length-1]=""),l=void 0}}})}catch(f){if(f!==$)throw f}return{path:a,previousNode:l,isAtPropertyKey:d,matches:f=>{let E=0;for(let w=0;E<f.length&&w<a.length;w++)if(f[E]===a[w]||f[E]==="*")E++;else if(f[E]!=="**")return!1;return E===f.length}}}function u(i,b=[],a=O.DEFAULT){let $=null,l=[];const S=[];function d(f){Array.isArray(l)?l.push(f):$!==null&&(l[$]=f)}return t(i,{onObjectBegin:()=>{const f={};d(f),S.push(l),l=f,$=null},onObjectProperty:f=>{$=f},onObjectEnd:()=>{l=S.pop()},onArrayBegin:()=>{const f=[];d(f),S.push(l),l=f,$=null},onArrayEnd:()=>{l=S.pop()},onLiteralValue:d,onError:(f,E,w)=>{b.push({error:f,offset:E,length:w})}},a),l[0]}function v(i,b=[],a=O.DEFAULT){let $={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(f){$.type==="property"&&($.length=f-$.offset,$=$.parent)}function S(f){return $.children.push(f),f}t(i,{onObjectBegin:f=>{$=S({type:"object",offset:f,length:-1,parent:$,children:[]})},onObjectProperty:(f,E,w)=>{$=S({type:"property",offset:E,length:-1,parent:$,children:[]}),$.children.push({type:"string",value:f,offset:E,length:w,parent:$})},onObjectEnd:(f,E)=>{$.length=f+E-$.offset,$=$.parent,l(f+E)},onArrayBegin:(f,E)=>{$=S({type:"array",offset:f,length:-1,parent:$,children:[]})},onArrayEnd:(f,E)=>{$.length=f+E-$.offset,$=$.parent,l(f+E)},onLiteralValue:(f,E,w)=>{S({type:h(f),offset:E,length:w,parent:$,value:f}),l(E+w)},onSeparator:(f,E,w)=>{$.type==="property"&&(f===":"?$.colonOffset=E:f===","&&l(E))},onError:(f,E,w)=>{b.push({error:f,offset:E,length:w})}},a);const D=$.children[0];return D&&delete D.parent,D}function m(i,b){if(!i)return;let a=i;for(const $ of b)if(typeof $=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let l=!1;for(const S of a.children)if(Array.isArray(S.children)&&S.children[0].value===$){a=S.children[1],l=!0;break}if(!l)return}else{const l=$;if(a.type!=="array"||l<0||!Array.isArray(a.children)||l>=a.children.length)return;a=a.children[l]}return a}function s(i){if(!i.parent||!i.parent.children)return[];const b=s(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;b.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&b.push(a)}return b}function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const b=Object.create(null);for(const a of i.children){const $=a.children[1];$&&(b[a.children[0].value]=o($))}return b}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function r(i,b,a=!1){return b>=i.offset&&b<i.offset+i.length||a&&b===i.offset+i.length}function n(i,b,a=!1){if(r(i,b,a)){const $=i.children;if(Array.isArray($))for(let l=0;l<$.length&&$[l].offset<=b;l++){const S=n($[l],b,a);if(S)return S}return i}}function t(i,b,a=O.DEFAULT){const $=M(i,!1);function l(ie){return ie?()=>ie($.getTokenOffset(),$.getTokenLength()):()=>!0}function S(ie){return ie?Ce=>ie(Ce,$.getTokenOffset(),$.getTokenLength()):()=>!0}const d=l(b.onObjectBegin),D=S(b.onObjectProperty),f=l(b.onObjectEnd),E=l(b.onArrayBegin),w=l(b.onArrayEnd),P=S(b.onLiteralValue),C=S(b.onSeparator),V=l(b.onComment),W=S(b.onError),q=a&&a.disallowComments,A=a&&a.allowTrailingComma;function U(){for(;;){const ie=$.scan();switch($.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(ie){case 12:case 13:q?K(10):V();break;case 16:K(1);break;case 15:case 14:break;default:return ie}}}function K(ie,Ce=[],Fe=[]){if(W(ie),Ce.length+Fe.length>0){let ne=$.getToken();for(;ne!==17;){if(Ce.indexOf(ne)!==-1){U();break}else if(Fe.indexOf(ne)!==-1)break;ne=U()}}}function se(ie){const Ce=$.getTokenValue();return ie?P(Ce):D(Ce),U(),!0}function ce(){switch($.getToken()){case 11:{let ie=0;try{ie=JSON.parse($.getTokenValue()),typeof ie!="number"&&(K(2),ie=0)}catch{K(2)}P(ie);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return U(),!0}function ve(){return $.getToken()!==10?(K(3,[],[2,5]),!1):(se(!1),$.getToken()===6?(C(":"),U(),be()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Ie(){d(),U();let ie=!1;for(;$.getToken()!==2&&$.getToken()!==17;){if($.getToken()===5){if(ie||K(4,[],[]),C(","),U(),$.getToken()===2&&A)break}else ie&&K(6,[],[]);ve()||K(4,[],[2,5]),ie=!0}return f(),$.getToken()!==2?K(7,[2],[]):U(),!0}function ue(){E(),U();let ie=!1;for(;$.getToken()!==4&&$.getToken()!==17;){if($.getToken()===5){if(ie||K(4,[],[]),C(","),U(),$.getToken()===4&&A)break}else ie&&K(6,[],[]);be()||K(4,[],[4,5]),ie=!0}return w(),$.getToken()!==4?K(8,[4],[]):U(),!0}function be(){switch($.getToken()){case 3:return ue();case 1:return Ie();case 10:return se(!0);default:return ce()}}return U(),$.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):be()?($.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(i,b){const a=M(i),$=[];let l,S=0,d;do switch(d=a.getPosition(),l=a.scan(),l){case 12:case 13:case 17:S!==d&&$.push(i.substring(S,d)),b!==void 0&&$.push(a.getTokenValue().replace(/[^\r\n]/g,b)),S=a.getPosition();break}while(l!==17);return $.join("")}function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),function(ge,e){typeof define=="function"&&define.amd?define(Re[124],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(ke,$e){for(var fe=0;fe<$e.length;fe++){var J=$e[fe];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ke,J.key,J)}}function I(ke,$e,fe){return $e&&e(ke.prototype,$e),fe&&e(ke,fe),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function T(ke,$e){if(ke){if(typeof ke=="string")return R(ke,$e);var fe=Object.prototype.toString.call(ke).slice(8,-1);if(fe==="Object"&&ke.constructor&&(fe=ke.constructor.name),fe==="Map"||fe==="Set")return Array.from(ke);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return R(ke,$e)}}function R(ke,$e){($e==null||$e>ke.length)&&($e=ke.length);for(var fe=0,J=new Array($e);fe<$e;fe++)J[fe]=ke[fe];return J}function O(ke,$e){var fe=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(fe)return(fe=fe.call(ke)).next.bind(fe);if(Array.isArray(ke)||(fe=T(ke))||$e&&ke&&typeof ke.length=="number"){fe&&(ke=fe);var J=0;return function(){return J>=ke.length?{done:!0}:{done:!1,value:ke[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=M();function p(ke){ge.defaults=ke}var g=/[&<>"']/,k=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function($e){return u[$e]};function m(ke,$e){if($e){if(g.test(ke))return ke.replace(k,v)}else if(N.test(ke))return ke.replace(y,v);return ke}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ke){return ke.replace(s,function($e,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var r=/(^|[^\[])\^/g;function n(ke,$e){ke=typeof ke=="string"?ke:ke.source,$e=$e||"";var fe={replace:function(Y,he){return he=he.source||he,he=he.replace(r,"$1"),ke=ke.replace(Y,he),fe},getRegex:function(){return new RegExp(ke,$e)}};return fe}var t=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(ke,$e,fe){if(ke){var J;try{J=decodeURIComponent(o(fe)).replace(t,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}$e&&!c.test(fe)&&(fe=l($e,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},b=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,$=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(ke,$e){i[" "+ke]||(b.test(ke)?i[" "+ke]=ke+"/":i[" "+ke]=f(ke,"/",!0)),ke=i[" "+ke];var fe=ke.indexOf(":")===-1;return $e.substring(0,2)==="//"?fe?$e:ke.replace(a,"$1")+$e:$e.charAt(0)==="/"?fe?$e:ke.replace($,"$1")+$e:ke+$e}var S={exec:function(){}};function d(ke){for(var $e=1,fe,J;$e<arguments.length;$e++){fe=arguments[$e];for(J in fe)Object.prototype.hasOwnProperty.call(fe,J)&&(ke[J]=fe[J])}return ke}function D(ke,$e){var fe=ke.replace(/\|/g,function(he,le,Te){for(var de=!1,Pe=le;--Pe>=0&&Te[Pe]==="\\";)de=!de;return de?"|":" |"}),J=fe.split(/ \|/),Y=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>$e)J.splice($e);else for(;J.length<$e;)J.push("");for(;Y<J.length;Y++)J[Y]=J[Y].trim().replace(/\\\|/g,"|");return J}function f(ke,$e,fe){var J=ke.length;if(J===0)return"";for(var Y=0;Y<J;){var he=ke.charAt(J-Y-1);if(he===$e&&!fe)Y++;else if(he!==$e&&fe)Y++;else break}return ke.slice(0,J-Y)}function E(ke,$e){if(ke.indexOf($e[1])===-1)return-1;for(var fe=ke.length,J=0,Y=0;Y<fe;Y++)if(ke[Y]==="\\")Y++;else if(ke[Y]===$e[0])J++;else if(ke[Y]===$e[1]&&(J--,J<0))return Y;return-1}function w(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ke,$e){if($e<1)return"";for(var fe="";$e>1;)$e&1&&(fe+=ke),$e>>=1,ke+=ke;return fe+ke}function C(ke,$e,fe,J){var Y=$e.href,he=$e.title?m($e.title):null,le=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){J.state.inLink=!0;var Te={type:"link",raw:fe,href:Y,title:he,text:le,tokens:J.inlineTokens(le)};return J.state.inLink=!1,Te}return{type:"image",raw:fe,href:Y,title:he,text:m(le)}}function V(ke,$e){var fe=ke.match(/^(\s+)(?:```)/);if(fe===null)return $e;var J=fe[1];return $e.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var le=he[0];return le.length>=J.length?Y.slice(J.length):Y}).join(`
`)}var W=function(){function ke(fe){this.options=fe||ge.defaults}var $e=ke.prototype;return $e.space=function(J){var Y=this.rules.block.newline.exec(J);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},$e.code=function(J){var Y=this.rules.block.code.exec(J);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:f(he,`
`)}}},$e.fences=function(J){var Y=this.rules.block.fences.exec(J);if(Y){var he=Y[0],le=V(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:le}}},$e.heading=function(J){var Y=this.rules.block.heading.exec(J);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var le=f(he,"#");(this.options.pedantic||!le||/ $/.test(le))&&(he=le.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},$e.hr=function(J){var Y=this.rules.block.hr.exec(J);if(Y)return{type:"hr",raw:Y[0]}},$e.blockquote=function(J){var Y=this.rules.block.blockquote.exec(J);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},$e.list=function(J){var Y=this.rules.block.list.exec(J);if(Y){var he,le,Te,de,Pe,Me,ze,z,L,G,H,ee,re=Y[1].trim(),Ne=re.length>1,Be={type:"list",raw:"",ordered:Ne,start:Ne?+re.slice(0,-1):"",loose:!1,items:[]};re=Ne?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Ne?re:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(ee=!1,!(!(Y=Qe.exec(J))||this.rules.block.hr.test(J)));){if(he=Y[0],J=J.substring(he.length),z=Y[2].split(`
`,1)[0],L=J.split(`
`,1)[0],this.options.pedantic?(de=2,H=z.trimLeft()):(de=Y[2].search(/[^ ]/),de=de>4?1:de,H=z.slice(de),de+=Y[1].length),Me=!1,!z&&/^ *$/.test(L)&&(he+=L+`
`,J=J.substring(L.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");J&&(G=J.split(`
`,1)[0],z=G,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(z)||it.test(z)||_e.test(z)||et.test(J)));){if(z.search(/[^ ]/)>=de||!z.trim())H+=`
`+z.slice(de);else if(!Me)H+=`
`+z;else break;!Me&&!z.trim()&&(Me=!0),he+=G+`
`,J=J.substring(G.length+1)}Be.loose||(ze?Be.loose=!0:/\n *\n *$/.test(he)&&(ze=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(H),le&&(Te=le[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:he,task:!!le,checked:Te,loose:!1,text:H}),Be.raw+=he}Be.items[Be.items.length-1].raw=he.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var nt=Be.items.length;for(Pe=0;Pe<nt;Pe++){this.lexer.state.top=!1,Be.items[Pe].tokens=this.lexer.blockTokens(Be.items[Pe].text,[]);var at=Be.items[Pe].tokens.filter(function(je){return je.type==="space"}),mt=at.every(function(je){for(var st=je.raw.split(""),X=0,Z=O(st),me;!(me=Z()).done;){var He=me.value;if(He===`
`&&(X+=1),X>1)return!0}return!1});!Be.loose&&at.length&&mt&&(Be.loose=!0,Be.items[Pe].loose=!0)}return Be}},$e.html=function(J){var Y=this.rules.block.html.exec(J);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]);he.type="paragraph",he.text=le,he.tokens=this.lexer.inline(le)}return he}},$e.def=function(J){var Y=this.rules.block.def.exec(J);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},$e.table=function(J){var Y=this.rules.block.table.exec(J);if(Y){var he={type:"table",header:D(Y[1]).map(function(ze){return{text:ze}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var le=he.align.length,Te,de,Pe,Me;for(Te=0;Te<le;Te++)/^ *-+: *$/.test(he.align[Te])?he.align[Te]="right":/^ *:-+: *$/.test(he.align[Te])?he.align[Te]="center":/^ *:-+ *$/.test(he.align[Te])?he.align[Te]="left":he.align[Te]=null;for(le=he.rows.length,Te=0;Te<le;Te++)he.rows[Te]=D(he.rows[Te],he.header.length).map(function(ze){return{text:ze}});for(le=he.header.length,de=0;de<le;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(le=he.rows.length,de=0;de<le;de++)for(Me=he.rows[de],Pe=0;Pe<Me.length;Pe++)Me[Pe].tokens=this.lexer.inline(Me[Pe].text);return he}}},$e.lheading=function(J){var Y=this.rules.block.lheading.exec(J);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},$e.paragraph=function(J){var Y=this.rules.block.paragraph.exec(J);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},$e.text=function(J){var Y=this.rules.block.text.exec(J);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},$e.escape=function(J){var Y=this.rules.inline.escape.exec(J);if(Y)return{type:"escape",raw:Y[0],text:m(Y[1])}},$e.tag=function(J){var Y=this.rules.inline.tag.exec(J);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]):Y[0]}},$e.link=function(J){var Y=this.rules.inline.link.exec(J);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var le=f(he.slice(0,-1),"\\");if((he.length-le.length)%2===0)return}else{var Te=E(Y[2],"()");if(Te>-1){var de=Y[0].indexOf("!")===0?5:4,Pe=de+Y[1].length+Te;Y[2]=Y[2].substring(0,Te),Y[0]=Y[0].substring(0,Pe).trim(),Y[3]=""}}var Me=Y[2],ze="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);z&&(Me=z[1],ze=z[3])}else ze=Y[3]?Y[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(he)?Me=Me.slice(1):Me=Me.slice(1,-1)),C(Y,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},$e.reflink=function(J,Y){var he;if((he=this.rules.inline.reflink.exec(J))||(he=this.rules.inline.nolink.exec(J))){var le=(he[2]||he[1]).replace(/\s+/g," ");if(le=Y[le.toLowerCase()],!le||!le.href){var Te=he[0].charAt(0);return{type:"text",raw:Te,text:Te}}return C(he,le,he[0],this.lexer)}},$e.emStrong=function(J,Y,he){he===void 0&&(he="");var le=this.rules.inline.emStrong.lDelim.exec(J);if(le&&!(le[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=le[1]||le[2]||"";if(!Te||Te&&(he===""||this.rules.inline.punctuation.exec(he))){var de=le[0].length-1,Pe,Me,ze=de,z=0,L=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(L.lastIndex=0,Y=Y.slice(-1*J.length+de);(le=L.exec(Y))!=null;)if(Pe=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!Pe){if(Me=Pe.length,le[3]||le[4]){ze+=Me;continue}else if((le[5]||le[6])&&de%3&&!((de+Me)%3)){z+=Me;continue}if(ze-=Me,!(ze>0)){if(Me=Math.min(Me,Me+ze+z),Math.min(de,Me)%2){var G=J.slice(1,de+le.index+Me);return{type:"em",raw:J.slice(0,de+le.index+Me+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=J.slice(2,de+le.index+Me-1);return{type:"strong",raw:J.slice(0,de+le.index+Me+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},$e.codespan=function(J){var Y=this.rules.inline.code.exec(J);if(Y){var he=Y[2].replace(/\n/g," "),le=/[^ ]/.test(he),Te=/^ /.test(he)&&/ $/.test(he);return le&&Te&&(he=he.substring(1,he.length-1)),he=m(he,!0),{type:"codespan",raw:Y[0],text:he}}},$e.br=function(J){var Y=this.rules.inline.br.exec(J);if(Y)return{type:"br",raw:Y[0]}},$e.del=function(J){var Y=this.rules.inline.del.exec(J);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},$e.autolink=function(J,Y){var he=this.rules.inline.autolink.exec(J);if(he){var le,Te;return he[2]==="@"?(le=m(this.options.mangle?Y(he[1]):he[1]),Te="mailto:"+le):(le=m(he[1]),Te=le),{type:"link",raw:he[0],text:le,href:Te,tokens:[{type:"text",raw:le,text:le}]}}},$e.url=function(J,Y){var he;if(he=this.rules.inline.url.exec(J)){var le,Te;if(he[2]==="@")le=m(this.options.mangle?Y(he[0]):he[0]),Te="mailto:"+le;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);le=m(he[0]),he[1]==="www."?Te="http://"+le:Te=le}return{type:"link",raw:he[0],text:le,href:Te,tokens:[{type:"text",raw:le,text:le}]}}},$e.inlineText=function(J,Y){var he=this.rules.inline.text.exec(J);if(he){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):m(he[0]):he[0]:le=m(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:le}}},ke}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=n(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=n(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=n(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=n(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=n(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=d({},q),q.gfm=d({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=n(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=d({},q.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:n(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=n(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=n(q._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=n(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=n(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=n(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=n(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=n(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=n(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=n(A.reflink).replace("label",A._label).replace("ref",q._label).getRegex(),A.nolink=n(A.nolink).replace("ref",q._label).getRegex(),A.reflinkSearch=n(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=d({},A),A.pedantic=d({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=d({},A.normal,{escape:n(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=n(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=d({},A.gfm,{br:n(A.br).replace("{2,}","*").getRegex(),text:n(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(ke){var $e="",fe,J,Y=ke.length;for(fe=0;fe<Y;fe++)J=ke.charCodeAt(fe),Math.random()>.5&&(J="x"+J.toString(16)),$e+="&#"+J+";";return $e}var se=function(){function ke(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ge.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:q.normal,inline:A.normal};this.options.pedantic?(J.block=q.pedantic,J.inline=A.pedantic):this.options.gfm&&(J.block=q.gfm,this.options.breaks?J.inline=A.breaks:J.inline=A.gfm),this.tokenizer.rules=J}ke.lex=function(J,Y){var he=new ke(Y);return he.lex(J)},ke.lexInline=function(J,Y){var he=new ke(Y);return he.inlineTokens(J)};var $e=ke.prototype;return $e.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},$e.blockTokens=function(J,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(ze,z,L){return z+"    ".repeat(L.length)});for(var le,Te,de,Pe;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(le=ze.call({lexer:he},J,Y))?(J=J.substring(le.raw.length),Y.push(le),!0):!1}))){if(le=this.tokenizer.space(J)){J=J.substring(le.raw.length),le.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(le);continue}if(le=this.tokenizer.code(J)){J=J.substring(le.raw.length),Te=Y[Y.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+le.raw,Te.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(le);continue}if(le=this.tokenizer.fences(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.heading(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.hr(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.blockquote(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.list(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.html(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.def(J)){J=J.substring(le.raw.length),Te=Y[Y.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+le.raw,Te.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.lheading(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(de=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,z=J.slice(1),L=void 0;he.options.extensions.startBlock.forEach(function(G){L=G.call({lexer:this},z),typeof L=="number"&&L>=0&&(ze=Math.min(ze,L))}),ze<1/0&&ze>=0&&(de=J.substring(0,ze+1))}(),this.state.top&&(le=this.tokenizer.paragraph(de))){Te=Y[Y.length-1],Pe&&Te.type==="paragraph"?(Te.raw+=`
`+le.raw,Te.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(le),Pe=de.length!==J.length,J=J.substring(le.raw.length);continue}if(le=this.tokenizer.text(J)){J=J.substring(le.raw.length),Te=Y[Y.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+le.raw,Te.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(le);continue}if(J){var Me="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,Y},$e.inline=function(J,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:J,tokens:Y}),Y},$e.inlineTokens=function(J,Y){var he=this;Y===void 0&&(Y=[]);var le,Te,de,Pe=J,Me,ze,z;if(this.tokens.links){var L=Object.keys(this.tokens.links);if(L.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)L.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Me.index)+"["+P("a",Me[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Me.index)+"["+P("a",Me[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Me.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(ze||(z=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(le=H.call({lexer:he},J,Y))?(J=J.substring(le.raw.length),Y.push(le),!0):!1}))){if(le=this.tokenizer.escape(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.tag(J)){J=J.substring(le.raw.length),Te=Y[Y.length-1],Te&&le.type==="text"&&Te.type==="text"?(Te.raw+=le.raw,Te.text+=le.text):Y.push(le);continue}if(le=this.tokenizer.link(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(le.raw.length),Te=Y[Y.length-1],Te&&le.type==="text"&&Te.type==="text"?(Te.raw+=le.raw,Te.text+=le.text):Y.push(le);continue}if(le=this.tokenizer.emStrong(J,Pe,z)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.codespan(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.br(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.del(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.autolink(J,K)){J=J.substring(le.raw.length),Y.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(J,K))){J=J.substring(le.raw.length),Y.push(le);continue}if(de=J,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=J.slice(1),re=void 0;he.options.extensions.startInline.forEach(function(Ne){re=Ne.call({lexer:this},ee),typeof re=="number"&&re>=0&&(H=Math.min(H,re))}),H<1/0&&H>=0&&(de=J.substring(0,H+1))}(),le=this.tokenizer.inlineText(de,U)){J=J.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(z=le.raw.slice(-1)),ze=!0,Te=Y[Y.length-1],Te&&Te.type==="text"?(Te.raw+=le.raw,Te.text+=le.text):Y.push(le);continue}if(J){var G="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Y},I(ke,null,[{key:"rules",get:function(){return{block:q,inline:A}}}]),ke}(),ce=function(){function ke(fe){this.options=fe||ge.defaults}var $e=ke.prototype;return $e.code=function(J,Y,he){var le=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(J,le);Te!=null&&Te!==J&&(he=!0,J=Te)}return J=J.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+m(le,!0)+'">'+(he?J:m(J,!0))+`</code></pre>
`:"<pre><code>"+(he?J:m(J,!0))+`</code></pre>
`},$e.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},$e.html=function(J){return J},$e.heading=function(J,Y,he,le){if(this.options.headerIds){var Te=this.options.headerPrefix+le.slug(he);return"<h"+Y+' id="'+Te+'">'+J+"</h"+Y+`>
`}return"<h"+Y+">"+J+"</h"+Y+`>
`},$e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},$e.list=function(J,Y,he){var le=Y?"ol":"ul",Te=Y&&he!==1?' start="'+he+'"':"";return"<"+le+Te+`>
`+J+"</"+le+`>
`},$e.listitem=function(J){return"<li>"+J+`</li>
`},$e.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},$e.paragraph=function(J){return"<p>"+J+`</p>
`},$e.table=function(J,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+Y+`</table>
`},$e.tablerow=function(J){return`<tr>
`+J+`</tr>
`},$e.tablecell=function(J,Y){var he=Y.header?"th":"td",le=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return le+J+("</"+he+`>
`)},$e.strong=function(J){return"<strong>"+J+"</strong>"},$e.em=function(J){return"<em>"+J+"</em>"},$e.codespan=function(J){return"<code>"+J+"</code>"},$e.br=function(){return this.options.xhtml?"<br/>":"<br>"},$e.del=function(J){return"<del>"+J+"</del>"},$e.link=function(J,Y,he){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return he;var le='<a href="'+m(J)+'"';return Y&&(le+=' title="'+Y+'"'),le+=">"+he+"</a>",le},$e.image=function(J,Y,he){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return he;var le='<img src="'+J+'" alt="'+he+'"';return Y&&(le+=' title="'+Y+'"'),le+=this.options.xhtml?"/>":">",le},$e.text=function(J){return J},ke}(),ve=function(){function ke(){}var $e=ke.prototype;return $e.strong=function(J){return J},$e.em=function(J){return J},$e.codespan=function(J){return J},$e.del=function(J){return J},$e.html=function(J){return J},$e.text=function(J){return J},$e.link=function(J,Y,he){return""+he},$e.image=function(J,Y,he){return""+he},$e.br=function(){return""},ke}(),Ie=function(){function ke(){this.seen={}}var $e=ke.prototype;return $e.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},$e.getNextSafeSlug=function(J,Y){var he=J,le=0;if(this.seen.hasOwnProperty(he)){le=this.seen[J];do le++,he=J+"-"+le;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[J]=le,this.seen[he]=0),he},$e.slug=function(J,Y){Y===void 0&&(Y={});var he=this.serialize(J);return this.getNextSafeSlug(he,Y.dryrun)},ke}(),ue=function(){function ke(fe){this.options=fe||ge.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new Ie}ke.parse=function(J,Y){var he=new ke(Y);return he.parse(J)},ke.parseInline=function(J,Y){var he=new ke(Y);return he.parseInline(J)};var $e=ke.prototype;return $e.parse=function(J,Y){Y===void 0&&(Y=!0);var he="",le,Te,de,Pe,Me,ze,z,L,G,H,ee,re,Ne,Be,Qe,_e,et,tt,it,nt=J.length;for(le=0;le<nt;le++){if(H=J[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(it=this.options.extensions.renderers[H.type].call({parser:this},H),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){he+=it||"";continue}switch(H.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(L="",z="",Pe=H.header.length,Te=0;Te<Pe;Te++)z+=this.renderer.tablecell(this.parseInline(H.header[Te].tokens),{header:!0,align:H.align[Te]});for(L+=this.renderer.tablerow(z),G="",Pe=H.rows.length,Te=0;Te<Pe;Te++){for(ze=H.rows[Te],z="",Me=ze.length,de=0;de<Me;de++)z+=this.renderer.tablecell(this.parseInline(ze[de].tokens),{header:!1,align:H.align[de]});G+=this.renderer.tablerow(z)}he+=this.renderer.table(L,G);continue}case"blockquote":{G=this.parse(H.tokens),he+=this.renderer.blockquote(G);continue}case"list":{for(ee=H.ordered,re=H.start,Ne=H.loose,Pe=H.items.length,G="",Te=0;Te<Pe;Te++)Qe=H.items[Te],_e=Qe.checked,et=Qe.task,Be="",Qe.task&&(tt=this.renderer.checkbox(_e),Ne?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=tt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=tt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:tt}):Be+=tt),Be+=this.parse(Qe.tokens,Ne),G+=this.renderer.listitem(Be,et,_e);he+=this.renderer.list(G,ee,re);continue}case"html":{he+=this.renderer.html(H.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;le+1<nt&&J[le+1].type==="text";)H=J[++le],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);he+=Y?this.renderer.paragraph(G):G;continue}default:{var at='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return he},$e.parseInline=function(J,Y){Y=Y||this.renderer;var he="",le,Te,de,Pe=J.length;for(le=0;le<Pe;le++){if(Te=J[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(de=this.options.extensions.renderers[Te.type].call({parser:this},Te),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){he+=de||"";continue}switch(Te.type){case"escape":{he+=Y.text(Te.text);break}case"html":{he+=Y.html(Te.text);break}case"link":{he+=Y.link(Te.href,Te.title,this.parseInline(Te.tokens,Y));break}case"image":{he+=Y.image(Te.href,Te.title,Te.text);break}case"strong":{he+=Y.strong(this.parseInline(Te.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Te.tokens,Y));break}case"codespan":{he+=Y.codespan(Te.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Te.tokens,Y));break}case"text":{he+=Y.text(Te.text);break}default:{var Me='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return he},ke}();function be(ke,$e,fe){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof $e=="function"&&(fe=$e,$e=null),$e=d({},be.defaults,$e||{}),w($e),fe){var J=$e.highlight,Y;try{Y=se.lex(ke,$e)}catch(Pe){return fe(Pe)}var he=function(Me){var ze;if(!Me)try{$e.walkTokens&&be.walkTokens(Y,$e.walkTokens),ze=ue.parse(Y,$e)}catch(z){Me=z}return $e.highlight=J,Me?fe(Me):fe(null,ze)};if(!J||J.length<3||(delete $e.highlight,!Y.length))return he();var le=0;be.walkTokens(Y,function(Pe){Pe.type==="code"&&(le++,setTimeout(function(){J(Pe.text,Pe.lang,function(Me,ze){if(Me)return he(Me);ze!=null&&ze!==Pe.text&&(Pe.text=ze,Pe.escaped=!0),le--,le===0&&he()})},0))}),le===0&&he();return}function Te(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+m(Pe.message+"",!0)+"</pre>";throw Pe}try{var de=se.lex(ke,$e);if($e.walkTokens){if($e.async)return Promise.all(be.walkTokens(de,$e.walkTokens)).then(function(){return ue.parse(de,$e)}).catch(Te);be.walkTokens(de,$e.walkTokens)}return ue.parse(de,$e)}catch(Pe){Te(Pe)}}be.options=be.setOptions=function(ke){return d(be.defaults,ke),p(be.defaults),be},be.getDefaults=M,be.defaults=ge.defaults,be.use=function(){for(var ke=arguments.length,$e=new Array(ke),fe=0;fe<ke;fe++)$e[fe]=arguments[fe];var J=d.apply(void 0,[{}].concat($e)),Y=be.defaults.extensions||{renderers:{},childTokens:{}},he;$e.forEach(function(le){if(le.extensions&&(he=!0,le.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Pe=Y.renderers?Y.renderers[de.name]:null;Pe?Y.renderers[de.name]=function(){for(var Me=arguments.length,ze=new Array(Me),z=0;z<Me;z++)ze[z]=arguments[z];var L=de.renderer.apply(this,ze);return L===!1&&(L=Pe.apply(this,ze)),L}:Y.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[de.level]?Y[de.level].unshift(de.tokenizer):Y[de.level]=[de.tokenizer],de.start&&(de.level==="block"?Y.startBlock?Y.startBlock.push(de.start):Y.startBlock=[de.start]:de.level==="inline"&&(Y.startInline?Y.startInline.push(de.start):Y.startInline=[de.start]))}de.childTokens&&(Y.childTokens[de.name]=de.childTokens)})),le.renderer&&function(){var de=be.defaults.renderer||new ce,Pe=function(z){var L=de[z];de[z]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var re=le.renderer[z].apply(de,H);return re===!1&&(re=L.apply(de,H)),re}};for(var Me in le.renderer)Pe(Me);J.renderer=de}(),le.tokenizer&&function(){var de=be.defaults.tokenizer||new W,Pe=function(z){var L=de[z];de[z]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var re=le.tokenizer[z].apply(de,H);return re===!1&&(re=L.apply(de,H)),re}};for(var Me in le.tokenizer)Pe(Me);J.tokenizer=de}(),le.walkTokens){var Te=be.defaults.walkTokens;J.walkTokens=function(de){var Pe=[];return Pe.push(le.walkTokens.call(this,de)),Te&&(Pe=Pe.concat(Te.call(this,de))),Pe}}he&&(J.extensions=Y),be.setOptions(J)})},be.walkTokens=function(ke,$e){for(var fe=[],J=function(){var Te=he.value;switch(fe=fe.concat($e.call(be,Te)),Te.type){case"table":{for(var de=O(Te.header),Pe;!(Pe=de()).done;){var Me=Pe.value;fe=fe.concat(be.walkTokens(Me.tokens,$e))}for(var ze=O(Te.rows),z;!(z=ze()).done;)for(var L=z.value,G=O(L),H;!(H=G()).done;){var ee=H.value;fe=fe.concat(be.walkTokens(ee.tokens,$e))}break}case"list":{fe=fe.concat(be.walkTokens(Te.items,$e));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[Te.type]?be.defaults.extensions.childTokens[Te.type].forEach(function(re){fe=fe.concat(be.walkTokens(Te[re],$e))}):Te.tokens&&(fe=fe.concat(be.walkTokens(Te.tokens,$e)))}},Y=O(ke),he;!(he=Y()).done;)J();return fe},be.parseInline=function(ke,$e){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");$e=d({},be.defaults,$e||{}),w($e);try{var fe=se.lexInline(ke,$e);return $e.walkTokens&&be.walkTokens(fe,$e.walkTokens),ue.parseInline(fe,$e)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+m(J.message+"",!0)+"</pre>";throw J}},be.Parser=ue,be.parser=ue.parse,be.Renderer=ce,be.TextRenderer=ve,be.Lexer=se,be.lexer=se.lex,be.Tokenizer=W,be.Slugger=Ie,be.parse=be;var ie=be.options,Ce=be.setOptions,Fe=be.use,ne=be.walkTokens,j=be.parseInline,x=be,pe=ue.parse,Oe=se.lex;ge.Lexer=se,ge.Parser=ue,ge.Renderer=ce,ge.Slugger=Ie,ge.TextRenderer=ve,ge.Tokenizer=W,ge.getDefaults=M,ge.lexer=Oe,ge.marked=be,ge.options=ie,ge.parse=x,ge.parseInline=j,ge.parser=pe,ge.setOptions=Ce,ge.use=Fe,ge.walkTokens=ne,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Re[125],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=I;function I(s){const o=O(s);if(o&&o.length>0)return new Uint32Array(o)}let T=0;const R=new Uint32Array(10);function O(s){if(T=0,M(s,y,4352),T>0||(M(s,u,4449),T>0)||(M(s,v,4520),T>0)||(M(s,m,12593),T))return R.subarray(0,T);if(s>=44032&&s<=55203){const o=s-44032,r=o%588,n=Math.floor(o/588),t=Math.floor(r/28),c=r%28-1;if(n<y.length?M(n,y,0):4352+n-12593<m.length&&M(4352+n,m,12593),t<u.length?M(t,u,0):4449+t-12593<m.length&&M(4449+t-12593,m,12593),c>=0&&(c<v.length?M(c,v,0):4520+c-12593<m.length&&M(4520+c-12593,m,12593)),T>0)return R.subarray(0,T)}}function M(s,o,r){s>=r&&s<r+o.length&&p(o[s-r])}function p(s){s!==0&&(R[T++]=s&255,s>>8&&(R[T++]=s>>8&255),s>>16&&(R[T++]=s>>16&255))}var g;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var k;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(k||(k={}));var N;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(N||(N={}));const y=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),m=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Re[126],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0,e.$vm=I,e.rot=T;function I(p,g,k){return Math.min(Math.max(p,g),k)}function T(p,g){return(g+p%g)%g}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$xm=R;class O{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ym=O;class M{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const k=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zm=M}),function(){function ge(R){const O=[];typeof R=="number"&&O.push("code/timeOrigin",R);function M(g){O.push(g,Date.now())}function p(){const g=[];for(let k=0;k<O.length;k+=2)g.push({name:O[k],startTime:O[k+1]});return g}return{mark:M,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))O.push({name:M.name,startTime:Math.round(R+M.startTime)});return O}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function I(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=I(T))}(),define(Re[127],Ae([1,0,40]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=void 0;const T=Symbol("unset");class R{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(g,k,N){this.d(g,y=>y._value=k,N)}mutate(g,k){this.d(g,N=>N._value=k(N._value===T?void 0:N._value))}delete(g){const k=this.c(g);if(!k)return;let N=k.length-1;const y=k[N].node._value;if(y!==T){for(this.b--,k[N].node._value=T;N>0;N--){const{node:u,part:v}=k[N];if(u.children?.size||u._value!==T)break;k[N-1].node.children.delete(v)}return y}}*deleteRecursive(g){const k=this.c(g);if(!k)return;const N=k[k.length-1].node;for(let y=k.length-1;y>0;y--){const u=k[y-1];if(u.node.children.delete(k[y].part),u.node.children.size>0||u.node._value!==T)break}for(const y of O(N))y._value!==T&&(this.b--,yield y._value)}find(g){let k=this.a;for(const N of g){const y=k.children?.get(N);if(!y)return;k=y}return k._value===T?void 0:k._value}hasKeyOrParent(g){let k=this.a;for(const N of g){const y=k.children?.get(N);if(!y)return!1;if(y._value!==T)return!0;k=y}return!1}hasKeyOrChildren(g){let k=this.a;for(const N of g){const y=k.children?.get(N);if(!y)return!1;k=y}return!0}hasKey(g){let k=this.a;for(const N of g){const y=k.children?.get(N);if(!y)return!1;k=y}return k._value!==T}c(g){const k=[{part:"",node:this.a}];let N=0;for(const y of g){const u=k[N].node.children?.get(y);if(!u)return;k.push({part:y,node:u}),N++}return k}d(g,k,N){let y=this.a;for(const m of g){if(y.children)if(y.children.has(m))y=y.children.get(m);else{const s=new M;y.children.set(m,s),y=s}else{const s=new M;y.children=new Map([[m,s]]),y=s}N?.(y)}const u=y._value===T?0:1;k(y);const v=y._value===T?0:1;this.b+=v-u}*values(){for(const{_value:g}of O(this.a))g!==T&&(yield g)}}e.$5O=R;function*O(p){const g=[p];for(;g.length>0;){const k=g.pop();if(yield k,k.children)for(const N of k.children.values())g.push(N)}}class M{constructor(){this._value=T}get value(){return this._value===T?void 0:this._value}set value(g){this._value=g===void 0?T:g}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var T in I)(typeof exports=="object"?exports:ge)[T]=I[T]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function I(T){if(e[T])return e[T].exports;var R=e[T]={i:T,l:!1,exports:{}};return ge[T].call(R.exports,R,R.exports,I),R.l=!0,R.exports}return I.m=ge,I.c=e,I.d=function(T,R,O){I.o(T,R)||Object.defineProperty(T,R,{enumerable:!0,get:O})},I.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},I.t=function(T,R){if(1&R&&(T=I(T)),8&R||4&R&&typeof T=="object"&&T&&T.__esModule)return T;var O=Object.create(null);if(I.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:T}),2&R&&typeof T!="string")for(var M in T)I.d(O,M,function(p){return T[p]}.bind(null,M));return O},I.n=function(T){var R=T&&T.__esModule?function(){return T.default}:function(){return T};return I.d(R,"a",R),R},I.o=function(T,R){return Object.prototype.hasOwnProperty.call(T,R)},I.p="",I(I.s=0)}([function(ge,e,I){(function(T){var R;e=ge.exports=Fe,R=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var L=Array.prototype.slice.call(arguments,0);L.unshift("SEMVER"),console.log.apply(console,L)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],g=e.src=[],k=0,N=k++;g[N]="0|[1-9]\\d*";var y=k++;g[y]="[0-9]+";var u=k++;g[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=k++;g[v]="("+g[N]+")\\.("+g[N]+")\\.("+g[N]+")";var m=k++;g[m]="("+g[y]+")\\.("+g[y]+")\\.("+g[y]+")";var s=k++;g[s]="(?:"+g[N]+"|"+g[u]+")";var o=k++;g[o]="(?:"+g[y]+"|"+g[u]+")";var r=k++;g[r]="(?:-("+g[s]+"(?:\\."+g[s]+")*))";var n=k++;g[n]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var t=k++;g[t]="[0-9A-Za-z-]+";var c=k++;g[c]="(?:\\+("+g[t]+"(?:\\."+g[t]+")*))";var h=k++,i="v?"+g[v]+g[r]+"?"+g[c]+"?";g[h]="^"+i+"$";var b="[v=\\s]*"+g[m]+g[n]+"?"+g[c]+"?",a=k++;g[a]="^"+b+"$";var $=k++;g[$]="((?:<|>)?=?)";var l=k++;g[l]=g[y]+"|x|X|\\*";var S=k++;g[S]=g[N]+"|x|X|\\*";var d=k++;g[d]="[v=\\s]*("+g[S]+")(?:\\.("+g[S]+")(?:\\.("+g[S]+")(?:"+g[r]+")?"+g[c]+"?)?)?";var D=k++;g[D]="[v=\\s]*("+g[l]+")(?:\\.("+g[l]+")(?:\\.("+g[l]+")(?:"+g[n]+")?"+g[c]+"?)?)?";var f=k++;g[f]="^"+g[$]+"\\s*"+g[d]+"$";var E=k++;g[E]="^"+g[$]+"\\s*"+g[D]+"$";var w=k++;g[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=k++;g[P]="(?:~>?)";var C=k++;g[C]="(\\s*)"+g[P]+"\\s+",p[C]=new RegExp(g[C],"g");var V=k++;g[V]="^"+g[P]+g[d]+"$";var W=k++;g[W]="^"+g[P]+g[D]+"$";var q=k++;g[q]="(?:\\^)";var A=k++;g[A]="(\\s*)"+g[q]+"\\s+",p[A]=new RegExp(g[A],"g");var U=k++;g[U]="^"+g[q]+g[d]+"$";var K=k++;g[K]="^"+g[q]+g[D]+"$";var se=k++;g[se]="^"+g[$]+"\\s*("+b+")$|^$";var ce=k++;g[ce]="^"+g[$]+"\\s*("+i+")$|^$";var ve=k++;g[ve]="(\\s*)"+g[$]+"\\s*("+b+"|"+g[d]+")",p[ve]=new RegExp(g[ve],"g");var Ie=k++;g[Ie]="^\\s*("+g[d]+")\\s+-\\s+("+g[d]+")\\s*$";var ue=k++;g[ue]="^\\s*("+g[D]+")\\s+-\\s+("+g[D]+")\\s*$";var be=k++;g[be]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)R(ie,g[ie]),p[ie]||(p[ie]=new RegExp(g[ie]));function Ce(L,G){if(L instanceof Fe)return L;if(typeof L!="string"||L.length>O||!(G?p[a]:p[h]).test(L))return null;try{return new Fe(L,G)}catch{return null}}function Fe(L,G){if(L instanceof Fe){if(L.loose===G)return L;L=L.version}else if(typeof L!="string")throw new TypeError("Invalid Version: "+L);if(L.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Fe))return new Fe(L,G);R("SemVer",L,G),this.loose=G;var H=L.trim().match(G?p[a]:p[h]);if(!H)throw new TypeError("Invalid Version: "+L);if(this.raw=L,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var re=+ee;if(re>=0&&re<M)return re}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=Ce,e.valid=function(L,G){var H=Ce(L,G);return H?H.version:null},e.clean=function(L,G){var H=Ce(L.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Fe,Fe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Fe.prototype.toString=function(){return this.version},Fe.prototype.compare=function(L){return R("SemVer.compare",this.version,this.loose,L),L instanceof Fe||(L=new Fe(L,this.loose)),this.compareMain(L)||this.comparePre(L)},Fe.prototype.compareMain=function(L){return L instanceof Fe||(L=new Fe(L,this.loose)),j(this.major,L.major)||j(this.minor,L.minor)||j(this.patch,L.patch)},Fe.prototype.comparePre=function(L){if(L instanceof Fe||(L=new Fe(L,this.loose)),this.prerelease.length&&!L.prerelease.length)return-1;if(!this.prerelease.length&&L.prerelease.length)return 1;if(!this.prerelease.length&&!L.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ee=L.prerelease[G];if(R("prerelease compare",G,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return j(H,ee)}while(++G)},Fe.prototype.inc=function(L,G){switch(L){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+L)}return this.format(),this.raw=this.version,this},e.inc=function(L,G,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Fe(L,H).inc(G,ee).version}catch{return null}},e.diff=function(L,G){if(ke(L,G))return null;var H=Ce(L),ee=Ce(G);if(H.prerelease.length||ee.prerelease.length){for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return"pre"+re;return"prerelease"}for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return re},e.compareIdentifiers=j;var ne=/^[0-9]+$/;function j(L,G){var H=ne.test(L),ee=ne.test(G);return H&&ee&&(L=+L,G=+G),H&&!ee?-1:ee&&!H?1:L<G?-1:L>G?1:0}function x(L,G,H){return new Fe(L,H).compare(new Fe(G,H))}function pe(L,G,H){return x(L,G,H)>0}function Oe(L,G,H){return x(L,G,H)<0}function ke(L,G,H){return x(L,G,H)===0}function $e(L,G,H){return x(L,G,H)!==0}function fe(L,G,H){return x(L,G,H)>=0}function J(L,G,H){return x(L,G,H)<=0}function Y(L,G,H,ee){var re;switch(G){case"===":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),re=L===H;break;case"!==":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),re=L!==H;break;case"":case"=":case"==":re=ke(L,H,ee);break;case"!=":re=$e(L,H,ee);break;case">":re=pe(L,H,ee);break;case">=":re=fe(L,H,ee);break;case"<":re=Oe(L,H,ee);break;case"<=":re=J(L,H,ee);break;default:throw new TypeError("Invalid operator: "+G)}return re}function he(L,G){if(L instanceof he){if(L.loose===G)return L;L=L.value}if(!(this instanceof he))return new he(L,G);R("comparator",L,G),this.loose=G,this.parse(L),this.semver===le?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(L,G){return j(G,L)},e.major=function(L,G){return new Fe(L,G).major},e.minor=function(L,G){return new Fe(L,G).minor},e.patch=function(L,G){return new Fe(L,G).patch},e.compare=x,e.compareLoose=function(L,G){return x(L,G,!0)},e.rcompare=function(L,G,H){return x(G,L,H)},e.sort=function(L,G){return L.sort(function(H,ee){return e.compare(H,ee,G)})},e.rsort=function(L,G){return L.sort(function(H,ee){return e.rcompare(H,ee,G)})},e.gt=pe,e.lt=Oe,e.eq=ke,e.neq=$e,e.gte=fe,e.lte=J,e.cmp=Y,e.Comparator=he;var le={};function Te(L,G){if(L instanceof Te)return L.loose===G?L:new Te(L.raw,G);if(L instanceof he)return new Te(L.value,G);if(!(this instanceof Te))return new Te(L,G);if(this.loose=G,this.raw=L,this.set=L.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+L);this.format()}function de(L){return!L||L.toLowerCase()==="x"||L==="*"}function Pe(L,G,H,ee,re,Ne,Be,Qe,_e,et,tt,it,nt){return((G=de(H)?"":de(ee)?">="+H+".0.0":de(re)?">="+H+"."+ee+".0":">="+G)+" "+(Qe=de(_e)?"":de(et)?"<"+(+_e+1)+".0.0":de(tt)?"<"+_e+"."+(+et+1)+".0":it?"<="+_e+"."+et+"."+tt+"-"+it:"<="+Qe)).trim()}function Me(L,G){for(var H=0;H<L.length;H++)if(!L[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<L.length;H++)if(R(L[H].semver),L[H].semver!==le&&L[H].semver.prerelease.length>0){var ee=L[H].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function ze(L,G,H){try{G=new Te(G,H)}catch{return!1}return G.test(L)}function z(L,G,H,ee){var re,Ne,Be,Qe,_e;switch(L=new Fe(L,ee),G=new Te(G,ee),H){case">":re=pe,Ne=J,Be=Oe,Qe=">",_e=">=";break;case"<":re=Oe,Ne=fe,Be=pe,Qe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(L,G,ee))return!1;for(var et=0;et<G.set.length;++et){var tt=G.set[et],it=null,nt=null;if(tt.forEach(function(at){at.semver===le&&(at=new he(">=0.0.0")),it=it||at,nt=nt||at,re(at.semver,it.semver,ee)?it=at:Be(at.semver,nt.semver,ee)&&(nt=at)}),it.operator===Qe||it.operator===_e||(!nt.operator||nt.operator===Qe)&&Ne(L,nt.semver)||nt.operator===_e&&Be(L,nt.semver))return!1}return!0}he.prototype.parse=function(L){var G=this.loose?p[se]:p[ce],H=L.match(G);if(!H)throw new TypeError("Invalid comparator: "+L);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Fe(H[2],this.loose):this.semver=le},he.prototype.toString=function(){return this.value},he.prototype.test=function(L){return R("Comparator.test",L,this.loose),this.semver===le||(typeof L=="string"&&(L=new Fe(L,this.loose)),Y(L,this.operator,this.semver,this.loose))},he.prototype.intersects=function(L,G){if(!(L instanceof he))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Te(L.value,G),ze(this.value,H,G);if(L.operator==="")return H=new Te(this.value,G),ze(L.semver,H,G);var ee=!(this.operator!==">="&&this.operator!==">"||L.operator!==">="&&L.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||L.operator!=="<="&&L.operator!=="<"),Ne=this.semver.version===L.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||L.operator!==">="&&L.operator!=="<="),Qe=Y(this.semver,"<",L.semver,G)&&(this.operator===">="||this.operator===">")&&(L.operator==="<="||L.operator==="<"),_e=Y(this.semver,">",L.semver,G)&&(this.operator==="<="||this.operator==="<")&&(L.operator===">="||L.operator===">");return ee||re||Ne&&Be||Qe||_e},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(L){return L.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(L){var G=this.loose;L=L.trim(),R("range",L,G);var H=G?p[ue]:p[Ie];L=L.replace(H,Pe),R("hyphen replace",L),L=L.replace(p[ve],"$1$2$3"),R("comparator trim",L,p[ve]),L=(L=(L=L.replace(p[C],"$1~")).replace(p[A],"$1^")).split(/\s+/).join(" ");var ee=G?p[se]:p[ce],re=L.split(" ").map(function(Ne){return function(Be,Qe){return R("comp",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){R("caret",it,nt);var at=nt?p[K]:p[U];return it.replace(at,function(mt,je,st,X,Z){var me;return R("caret",it,mt,je,st,X,Z),de(je)?me="":de(st)?me=">="+je+".0.0 <"+(+je+1)+".0.0":de(X)?me=je==="0"?">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":">="+je+"."+st+".0 <"+(+je+1)+".0.0":Z?(R("replaceCaret pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=je==="0"?st==="0"?">="+je+"."+st+"."+X+Z+" <"+je+"."+st+"."+(+X+1):">="+je+"."+st+"."+X+Z+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+X+Z+" <"+(+je+1)+".0.0"):(R("no pr"),me=je==="0"?st==="0"?">="+je+"."+st+"."+X+" <"+je+"."+st+"."+(+X+1):">="+je+"."+st+"."+X+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+X+" <"+(+je+1)+".0.0"),R("caret return",me),me})}(tt,et)}).join(" ")}(Be,Qe),R("caret",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){var at=nt?p[W]:p[V];return it.replace(at,function(mt,je,st,X,Z){var me;return R("tilde",it,mt,je,st,X,Z),de(je)?me="":de(st)?me=">="+je+".0.0 <"+(+je+1)+".0.0":de(X)?me=">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":Z?(R("replaceTilde pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=">="+je+"."+st+"."+X+Z+" <"+je+"."+(+st+1)+".0"):me=">="+je+"."+st+"."+X+" <"+je+"."+(+st+1)+".0",R("tilde return",me),me})}(tt,et)}).join(" ")}(Be,Qe),R("tildes",Be),Be=function(_e,et){return R("replaceXRanges",_e,et),_e.split(/\s+/).map(function(tt){return function(it,nt){it=it.trim();var at=nt?p[E]:p[f];return it.replace(at,function(mt,je,st,X,Z,me){R("xRange",it,mt,je,st,X,Z,me);var He=de(st),ye=He||de(X),ot=ye||de(Z);return je==="="&&ot&&(je=""),He?mt=je===">"||je==="<"?"<0.0.0":"*":je&&ot?(ye&&(X=0),ot&&(Z=0),je===">"?(je=">=",ye?(st=+st+1,X=0,Z=0):ot&&(X=+X+1,Z=0)):je==="<="&&(je="<",ye?st=+st+1:X=+X+1),mt=je+st+"."+X+"."+Z):ye?mt=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(mt=">="+st+"."+X+".0 <"+st+"."+(+X+1)+".0"),R("xRange return",mt),mt})}(tt,et)}).join(" ")}(Be,Qe),R("xrange",Be),Be=function(_e,et){return R("replaceStars",_e,et),_e.trim().replace(p[be],"")}(Be,Qe),R("stars",Be),Be}(Ne,G)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Ne){return!!Ne.match(ee)})),re=re.map(function(Ne){return new he(Ne,G)})},Te.prototype.intersects=function(L,G){if(!(L instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return L.set.some(function(re){return re.every(function(Ne){return ee.intersects(Ne,G)})})})})},e.toComparators=function(L,G){return new Te(L,G).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(L){if(!L)return!1;typeof L=="string"&&(L=new Fe(L,this.loose));for(var G=0;G<this.set.length;G++)if(Me(this.set[G],L))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(L,G,H){var ee=null,re=null;try{var Ne=new Te(G,H)}catch{return null}return L.forEach(function(Be){Ne.test(Be)&&(ee&&re.compare(Be)!==-1||(re=new Fe(ee=Be,H)))}),ee},e.minSatisfying=function(L,G,H){var ee=null,re=null;try{var Ne=new Te(G,H)}catch{return null}return L.forEach(function(Be){Ne.test(Be)&&(ee&&re.compare(Be)!==1||(re=new Fe(ee=Be,H)))}),ee},e.validRange=function(L,G){try{return new Te(L,G).range||"*"}catch{return null}},e.ltr=function(L,G,H){return z(L,G,"<",H)},e.gtr=function(L,G,H){return z(L,G,">",H)},e.outside=z,e.prerelease=function(L,G){var H=Ce(L,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(L,G,H){return L=new Te(L,H),G=new Te(G,H),L.intersects(G)},e.coerce=function(L){if(L instanceof Fe)return L;if(typeof L!="string")return null;var G=L.match(p[w]);return G==null?null:Ce((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,I(1))},function(ge,e){var I,T,R=ge.exports={};function O(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function p(o){if(I===setTimeout)return setTimeout(o,0);if((I===O||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:O}catch{I=O}try{T=typeof clearTimeout=="function"?clearTimeout:M}catch{T=M}})();var g,k=[],N=!1,y=-1;function u(){N&&g&&(N=!1,g.length?k=g.concat(k):y=-1,k.length&&v())}function v(){if(!N){var o=p(u);N=!0;for(var r=k.length;r;){for(g=k,k=[];++y<r;)g&&g[y].run();y=-1,r=k.length}g=null,N=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===M||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(o)}}function m(o,r){this.fun=o,this.array=r}function s(){}R.nextTick=function(o){var r=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)r[n-1]=arguments[n];k.push(new m(o,r)),k.length!==1||N||p(v)},m.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=s,R.addListener=s,R.once=s,R.off=s,R.removeListener=s,R.removeAllListeners=s,R.emit=s,R.prependListener=s,R.prependOnceListener=s,R.listeners=function(o){return[]},R.binding=function(o){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(o){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Re[128],Ae([1,0,14,6]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=R,e.$oe=O,e.$pe=M,e.$qe=p,e.$re=k,e.$se=N,e.$te=y,e.$ue=u,e.$ve=v,e.$we=m,e.$xe=s,e.$ye=o,e.$ze=r,e.$Ae=n,e.$Be=t;function R(c){const h=c;return h?typeof h.read=="function":!1}function O(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}function M(c){const h=c;return h?O(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function p(c,h){return new g(c,h)}class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,I.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let b;switch(h){case"data":b=this.c.data;break;case"end":b=this.c.end;break;case"error":b=this.c.error;break}if(b){const a=b.indexOf(i);a>=0&&b.splice(a,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(b=>b())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(c,h){const i=[];let b;for(;(b=c.read())!==null;)i.push(b);return h(i)}function N(c,h,i){const b=[];let a;for(;(a=c.read())!==null&&b.length<i;)b.push(a);return a===null&&b.length>0?h(b):{read:()=>{if(b.length>0)return b.shift();if(typeof a<"u"){const $=a;return a=void 0,$}return c.read()}}}function y(c,h){return new Promise((i,b)=>{const a=[];u(c,{onData:$=>{h&&a.push($)},onError:$=>{h?b($):i(void 0)},onEnd:()=>{i(h?h(a):void 0)}})})}function u(c,h,i){c.on("error",b=>{i?.isCancellationRequested||h.onError(b)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",b=>{i?.isCancellationRequested||h.onData(b)})}function v(c,h){return new Promise((i,b)=>{const a=new T.$Tc,$=[],l=D=>{if($.push(D),$.length>h)return a.dispose(),c.pause(),i({stream:c,buffer:$,ended:!1})},S=D=>(a.dispose(),b(D)),d=()=>(a.dispose(),i({stream:c,buffer:$,ended:!0}));a.add((0,T.$Sc)(()=>c.removeListener("error",S))),c.on("error",S),a.add((0,T.$Sc)(()=>c.removeListener("end",d))),c.on("end",d),a.add((0,T.$Sc)(()=>c.removeListener("data",l))),c.on("data",l)})}function m(c,h){const i=p(h);return i.end(c),i}function s(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}function r(c,h,i){const b=p(i);return u(c,{onData:a=>b.write(h.data(a)),onError:a=>b.error(h.error?h.error(a):a),onEnd:()=>b.end()}),b}function n(c,h,i){let b=!1;return{read:()=>{const a=h.read();return b?a:(b=!0,a!==null?i([c,a]):c)}}}function t(c,h,i){let b=!1;const a=p(i);return u(h,{onData:$=>b?a.write($):(b=!0,a.write(i([c,$]))),onError:$=>a.error($),onEnd:()=>{b||(b=!0,a.write(c)),a.end()}}),a}}),define(Re[23],Ae([1,0,41,128]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=k,e.$Ee=N,e.$Fe=y,e.$Ge=u,e.$He=v,e.$Ie=m,e.$Je=s,e.$Ke=o,e.$Le=r,e.$Me=n,e.$Ne=t,e.$Oe=c,e.$Pe=h,e.$Qe=i,e.$Re=b,e.$Se=a,e.$Te=$,e.$Ue=l,e.$Ve=S,e.$We=f;const R=typeof Buffer<"u",O=new I.$V(()=>new Uint8Array(256));let M,p;class g{static alloc(w){return R?new g(Buffer.allocUnsafe(w)):new g(new Uint8Array(w))}static wrap(w){return R&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new g(w)}static fromString(w,P){return!(P?.dontUseNodeBuffer||!1)&&R?new g(Buffer.from(w)):(M||(M=new TextEncoder),new g(M.encode(w)))}static fromByteArray(w){const P=g.alloc(w.length);for(let C=0,V=w.length;C<V;C++)P.buffer[C]=w[C];return P}static concat(w,P){if(typeof P>"u"){P=0;for(let W=0,q=w.length;W<q;W++)P+=w[W].byteLength}const C=g.alloc(P);let V=0;for(let W=0,q=w.length;W<q;W++){const A=w[W];C.set(A,V),V+=A.byteLength}return C}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=g.alloc(this.byteLength);return w.set(this),w}toString(){return R?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(w,P){return new g(this.buffer.subarray(w,P))}set(w,P){if(w instanceof g)this.buffer.set(w.buffer,P);else if(w instanceof Uint8Array)this.buffer.set(w,P);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),P);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return u(this.buffer,w)}writeUInt32BE(w,P){v(this.buffer,w,P)}readUInt32LE(w){return m(this.buffer,w)}writeUInt32LE(w,P){s(this.buffer,w,P)}readUInt8(w){return o(this.buffer,w)}writeUInt8(w,P){r(this.buffer,w,P)}indexOf(w,P=0){return k(this.buffer,w instanceof g?w.buffer:w,P)}}e.$Ce=g;function k(E,w,P=0){const C=w.byteLength,V=E.byteLength;if(C===0)return 0;if(C===1)return E.indexOf(w[0]);if(C>V-P)return-1;const W=O.value;W.fill(w.length);for(let K=0;K<w.length;K++)W[w[K]]=w.length-K-1;let q=P+w.length-1,A=q,U=-1;for(;q<V;)if(E[q]===w[A]){if(A===0){U=q;break}q--,A--}else q+=Math.max(w.length-A,W[E[q]]),A=w.length-1;return U}function N(E,w){return E[w+0]<<0>>>0|E[w+1]<<8>>>0}function y(E,w,P){E[P+0]=w&255,w=w>>>8,E[P+1]=w&255}function u(E,w){return E[w]*2**24+E[w+1]*2**16+E[w+2]*2**8+E[w+3]}function v(E,w,P){E[P+3]=w,w=w>>>8,E[P+2]=w,w=w>>>8,E[P+1]=w,w=w>>>8,E[P]=w}function m(E,w){return E[w+0]<<0>>>0|E[w+1]<<8>>>0|E[w+2]<<16>>>0|E[w+3]<<24>>>0}function s(E,w,P){E[P+0]=w&255,w=w>>>8,E[P+1]=w&255,w=w>>>8,E[P+2]=w&255,w=w>>>8,E[P+3]=w&255}function o(E,w){return E[w]}function r(E,w,P){E[P]=w}function n(E){return T.$re(E,w=>g.concat(w))}function t(E){return T.$ye(E)}function c(E){return T.$te(E,w=>g.concat(w))}async function h(E){return E.ended?g.concat(E.buffer):g.concat([...E.buffer,await c(E.stream)])}function i(E){return T.$we(E,w=>g.concat(w))}function b(E){return T.$ze(E,{data:w=>typeof w=="string"?g.fromString(w):g.wrap(w)},w=>g.concat(w))}function a(E){return T.$qe(w=>g.concat(w),E)}function $(E,w){return T.$Ae(E,w,P=>g.concat(P))}function l(E,w){return T.$Be(E,w,P=>g.concat(P))}function S(E){let w=0,P=0,C=0;const V=new Uint8Array(Math.floor(E.length/4*3)),W=A=>{switch(P){case 3:V[C++]=w|A,P=0;break;case 2:V[C++]=w|A>>>2,w=A<<6,P=3;break;case 1:V[C++]=w|A>>>4,w=A<<4,P=2;break;default:w=A<<2,P=1}};for(let A=0;A<E.length;A++){const U=E.charCodeAt(A);if(U>=65&&U<=90)W(U-65);else if(U>=97&&U<=122)W(U-97+26);else if(U>=48&&U<=57)W(U-48+52);else if(U===43||U===45)W(62);else if(U===47||U===95)W(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${E[A]}`)}}const q=C;for(;P>0;)W(0);return g.wrap(V).slice(0,q)}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:E},w=!0,P=!1){const C=P?D:d;let V="";const W=E.byteLength%3;let q=0;for(;q<E.byteLength-W;q+=3){const A=E[q+0],U=E[q+1],K=E[q+2];V+=C[A>>>2],V+=C[(A<<4|U>>>4)&63],V+=C[(U<<2|K>>>6)&63],V+=C[K&63]}if(W===1){const A=E[q+0];V+=C[A>>>2],V+=C[A<<4&63],w&&(V+="==")}else if(W===2){const A=E[q+0],U=E[q+1];V+=C[A>>>2],V+=C[(A<<4|U>>>4)&63],V+=C[U<<2&63],w&&(V+="=")}return V}}),define(Re[129],Ae([1,0,28,125,15]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.FuzzyScore=e.$sk=e.$rk=void 0,e.or=O,e.$tk=p,e.$uk=g,e.$vk=y,e.$wk=S,e.$xk=d,e.$yk=C,e.$zk=V,e.$Ak=W,e.$Bk=q,e.$Ck=x,e.$Ek=$e,e.$Fk=Y,e.$Gk=he;function O(...de){return function(Pe,Me){for(let ze=0,z=de.length;ze<z;ze++){const L=de[ze](Pe,Me);if(L)return L}return null}}e.$rk=M.bind(void 0,!1),e.$sk=M.bind(void 0,!0);function M(de,Pe,Me){if(!Me||Me.length<Pe.length)return null;let ze;return de?ze=R.$uf(Me,Pe):ze=Me.indexOf(Pe)===0,ze?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function p(de,Pe){const Me=Pe.toLowerCase().indexOf(de.toLowerCase());return Me===-1?null:[{start:Me,end:Me+de.length}]}function g(de,Pe){return k(de.toLowerCase(),Pe.toLowerCase(),0,0)}function k(de,Pe,Me,ze){if(Me===de.length)return[];if(ze===Pe.length)return null;if(de[Me]===Pe[ze]){let z=null;return(z=k(de,Pe,Me+1,ze+1))?c({start:ze,end:ze+1},z):null}return k(de,Pe,Me,ze+1)}function N(de){return 97<=de&&de<=122}function y(de){return 65<=de&&de<=90}function u(de){return 48<=de&&de<=57}function v(de){return de===32||de===9||de===10||de===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>m.add(de.charCodeAt(0)));function s(de){return v(de)||m.has(de)}function o(de,Pe){return de===Pe||s(de)&&s(Pe)}const r=new Map;function n(de){if(r.has(de))return r.get(de);let Pe;const Me=(0,T.$pk)(de);return Me&&(Pe=Me),r.set(de,Pe),Pe}function t(de){return N(de)||y(de)||u(de)}function c(de,Pe){return Pe.length===0?Pe=[de]:de.end===Pe[0].start?Pe[0].start=de.start:Pe.unshift(de),Pe}function h(de,Pe){for(let Me=Pe;Me<de.length;Me++){const ze=de.charCodeAt(Me);if(y(ze)||u(ze)||Me>0&&!t(de.charCodeAt(Me-1)))return Me}return de.length}function i(de,Pe,Me,ze){if(Me===de.length)return[];if(ze===Pe.length)return null;if(de[Me]!==Pe[ze].toLowerCase())return null;{let z=null,L=ze+1;for(z=i(de,Pe,Me+1,ze+1);!z&&(L=h(Pe,L))<Pe.length;)z=i(de,Pe,Me+1,L),L++;return z===null?null:c({start:ze,end:ze+1},z)}}function b(de){let Pe=0,Me=0,ze=0,z=0,L=0;for(let Ne=0;Ne<de.length;Ne++)L=de.charCodeAt(Ne),y(L)&&Pe++,N(L)&&Me++,t(L)&&ze++,u(L)&&z++;const G=Pe/de.length,H=Me/de.length,ee=ze/de.length,re=z/de.length;return{upperPercent:G,lowerPercent:H,alphaPercent:ee,numericPercent:re}}function a(de){const{upperPercent:Pe,lowerPercent:Me}=de;return Me===0&&Pe>.6}function $(de){const{upperPercent:Pe,lowerPercent:Me,alphaPercent:ze,numericPercent:z}=de;return Me>.2&&Pe<.8&&ze>.6&&z<.2}function l(de){let Pe=0,Me=0,ze=0,z=0;for(let L=0;L<de.length;L++)ze=de.charCodeAt(L),y(ze)&&Pe++,N(ze)&&Me++,v(ze)&&z++;return(Pe===0||Me===0)&&z===0?de.length<=30:Pe<=5}function S(de,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!l(de))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Me=b(Pe);if(!$(Me)){if(!a(Me))return null;Pe=Pe.toLowerCase()}let ze=null,z=0;for(de=de.toLowerCase();z<Pe.length&&(ze=i(de,Pe,0,z))===null;)z=h(Pe,z+1);return ze}function d(de,Pe,Me=!1){if(!Pe||Pe.length===0)return null;let ze=null,z=0;for(de=de.toLowerCase(),Pe=Pe.toLowerCase();z<Pe.length&&(ze=D(de,Pe,0,z,Me),ze===null);)z=f(Pe,z+1);return ze}function D(de,Pe,Me,ze,z){let L=0;if(Me===de.length)return[];if(ze===Pe.length)return null;if(!o(de.charCodeAt(Me),Pe.charCodeAt(ze))){const ee=n(de.charCodeAt(Me));if(!ee)return null;for(let re=0;re<ee.length;re++)if(!o(ee[re],Pe.charCodeAt(ze+re)))return null;L+=ee.length-1}let G=null,H=ze+L+1;if(G=D(de,Pe,Me+1,H,z),!z)for(;!G&&(H=f(Pe,H))<Pe.length;)G=D(de,Pe,Me+1,H,z),H++;if(!G)return null;if(de.charCodeAt(Me)!==Pe.charCodeAt(ze)){const ee=n(de.charCodeAt(Me));if(!ee)return G;for(let re=0;re<ee.length;re++)if(ee[re]!==Pe.charCodeAt(ze+re))return G}return c({start:ze,end:ze+L+1},G)}function f(de,Pe){for(let Me=Pe;Me<de.length;Me++)if(s(de.charCodeAt(Me))||Me>0&&s(de.charCodeAt(Me-1)))return Me;return de.length}const E=O(e.$sk,S,p),w=O(e.$sk,S,g),P=new I.$Ec(1e4);function C(de,Pe,Me=!1){if(typeof de!="string"||typeof Pe!="string")return null;let ze=P.get(de);ze||(ze=new RegExp(R.$cf(de),"i"),P.set(de,ze));const z=ze.exec(Pe);return z?[{start:z.index,end:z.index+z[0].length}]:Me?w(de,Pe):E(de,Pe)}function V(de,Pe){const Me=$e(de,de.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?q(Me):null}function W(de,Pe,Me,ze,z,L){const G=Math.min(13,de.length);for(;Me<G;Me++){const H=$e(de,Pe,Me,ze,z,L,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,L]}function q(de){if(typeof de>"u")return[];const Pe=[],Me=de[1];for(let ze=de.length-1;ze>1;ze--){const z=de[ze]+Me,L=Pe[Pe.length-1];L&&L.end===z?L.end=z+1:Pe.push({start:z,end:z+1})}return Pe}const A=128;function U(){const de=[],Pe=[];for(let Me=0;Me<=A;Me++)Pe[Me]=0;for(let Me=0;Me<=A;Me++)de.push(Pe.slice(0));return de}function K(de){const Pe=[];for(let Me=0;Me<=de;Me++)Pe[Me]=0;return Pe}const se=K(2*A),ce=K(2*A),ve=U(),Ie=U(),ue=U(),be=!1;function ie(de,Pe,Me,ze,z){function L(H,ee,re=" "){for(;H.length<ee;)H=re+H;return H}let G=` |   |${ze.split("").map(H=>L(H,3)).join("|")}
`;for(let H=0;H<=Me;H++)H===0?G+=" |":G+=`${Pe[H-1]}|`,G+=de[H].slice(0,z+1).map(ee=>L(ee.toString(),3)).join("|")+`
`;return G}function Ce(de,Pe,Me,ze){de=de.substr(Pe),Me=Me.substr(ze),console.log(ie(Ie,de,de.length,Me,Me.length)),console.log(ie(ue,de,de.length,Me,Me.length)),console.log(ie(ve,de,de.length,Me,Me.length))}function Fe(de,Pe){if(Pe<0||Pe>=de.length)return!1;const Me=de.codePointAt(Pe);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Mf(Me)}}function ne(de,Pe){if(Pe<0||Pe>=de.length)return!1;switch(de.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function j(de,Pe,Me){return Pe[de]!==Me[de]}function x(de,Pe,Me,ze,z,L,G=!1){for(;Pe<Me&&z<L;)de[Pe]===ze[z]&&(G&&(se[Pe]=z),Pe+=1),z+=1;return Pe===Me}var pe;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Oe;(function(de){de.Default=[-100,0];function Pe(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}de.isDefault=Pe})(Oe||(e.FuzzyScore=Oe={}));class ke{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Me){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Me}}e.$Dk=ke;function $e(de,Pe,Me,ze,z,L,G=ke.default){const H=de.length>A?A:de.length,ee=ze.length>A?A:ze.length;if(Me>=H||L>=ee||H-Me>ee-L||!x(Pe,Me,H,z,L,ee,!0))return;fe(H,ee,Me,L,Pe,z);let re=1,Ne=1,Be=Me,Qe=L;const _e=[!1];for(re=1,Be=Me;Be<H;re++,Be++){const at=se[Be],mt=ce[Be],je=Be+1<H?ce[Be+1]:ee;for(Ne=at-L+1,Qe=at;Qe<je;Ne++,Qe++){let st=Number.MIN_SAFE_INTEGER,X=!1;Qe<=mt&&(st=J(de,Pe,Be,Me,ze,z,Qe,ee,L,ve[re-1][Ne-1]===0,_e));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(X=!0,Z=st+Ie[re-1][Ne-1]);const me=Qe>at,He=me?Ie[re][Ne-1]+(ve[re][Ne-1]>0?-5:0):0,ye=Qe>at+1&&ve[re][Ne-1]>0,ot=ye?Ie[re][Ne-2]+(ve[re][Ne-2]>0?-5:0):0;if(ye&&(!me||ot>=He)&&(!X||ot>=Z))Ie[re][Ne]=ot,ue[re][Ne]=3,ve[re][Ne]=0;else if(me&&(!X||He>=Z))Ie[re][Ne]=He,ue[re][Ne]=2,ve[re][Ne]=0;else if(X)Ie[re][Ne]=Z,ue[re][Ne]=1,ve[re][Ne]=ve[re-1][Ne-1]+1;else throw new Error("not possible")}}if(be&&Ce(de,Me,ze,L),!_e[0]&&!G.firstMatchCanBeWeak)return;re--,Ne--;const et=[Ie[re][Ne],L];let tt=0,it=0;for(;re>=1;){let at=Ne;do{const mt=ue[re][at];if(mt===3)at=at-2;else if(mt===2)at=at-1;else break}while(at>=1);tt>1&&Pe[Me+re-1]===z[L+Ne-1]&&!j(at+L-1,ze,z)&&tt+1>ve[re][at]&&(at=Ne),at===Ne?tt++:tt=1,it||(it=at),re--,Ne=at-1,et.push(Ne)}ee===H&&G.boostFullMatch&&(et[0]+=2);const nt=it-H;return et[0]-=nt,et}function fe(de,Pe,Me,ze,z,L){let G=de-1,H=Pe-1;for(;G>=Me&&H>=ze;)z[G]===L[H]&&(ce[G]=H,G--),H--}function J(de,Pe,Me,ze,z,L,G,H,ee,re,Ne){if(Pe[Me]!==L[G])return Number.MIN_SAFE_INTEGER;let Be=1,Qe=!1;return G===Me-ze?Be=de[Me]===z[G]?7:5:j(G,z,L)&&(G===0||!j(G-1,z,L))?(Be=de[Me]===z[G]?7:5,Qe=!0):Fe(L,G)&&(G===0||!Fe(L,G-1))?Be=5:(Fe(L,G-1)||ne(L,G-1))&&(Be=5,Qe=!0),Be>1&&Me===ze&&(Ne[0]=!0),Qe||(Qe=j(G,z,L)||Fe(L,G-1)||ne(L,G-1)),Me===ze?G>ee&&(Be-=Qe?3:5):re?Be+=Qe?2:0:Be+=Qe?0:1,G+1===H&&(Be-=Qe?3:5),Be}function Y(de,Pe,Me,ze,z,L,G){return le(de,Pe,Me,ze,z,L,!0,G)}function he(de,Pe,Me,ze,z,L,G){return le(de,Pe,Me,ze,z,L,!1,G)}function le(de,Pe,Me,ze,z,L,G,H){let ee=$e(de,Pe,Me,ze,z,L,H);if(ee&&!G)return ee;if(de.length>=3){const re=Math.min(7,de.length-1);for(let Ne=Me+1;Ne<re;Ne++){const Be=Te(de,Ne);if(Be){const Qe=$e(Be,Be.toLowerCase(),Me,ze,z,L,H);Qe&&(Qe[0]-=3,(!ee||Qe[0]>ee[0])&&(ee=Qe))}}}return ee}function Te(de,Pe){if(Pe+1>=de.length)return;const Me=de[Pe],ze=de[Pe+1];if(Me!==ze)return de.slice(0,Pe)+ze+Me+de.slice(Pe+2)}}),define(Re[33],Ae([1,0,15]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(T||(T={})),function(R){const O="error",M="warning",p="warn",g="info",k="ignore";function N(u){return u?I.$tf(O,u)?R.Error:I.$tf(M,u)||I.$tf(p,u)?R.Warning:I.$tf(g,u)?R.Info:R.Ignore:R.Ignore}R.fromValue=N;function y(u){switch(u){case R.Error:return O;case R.Warning:return M;case R.Info:return g;default:return k}}R.toString=y}(T||(T={})),e.default=T}),define(Re[130],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(Re[52],Ae([1,0,18,15]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class R{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const m=v.charCodeAt(0),s=this.b.charCodeAt(this.c);return m-s}value(){return this.b[this.c]}}e.$si=R;class O{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,T.$nf)(v,this.b,0,v.length,this.c,this.d):(0,T.$pf)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ti=O;class M{constructor(v=!0,m=!0){this.f=v,this.g=m}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let m=v.length-1;m>=0;m--,this.c--){const s=this.b.charCodeAt(m);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,T.$nf)(v,this.b,0,v.length,this.d,this.e):(0,T.$pf)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ui=M;var p;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(p||(p={}));class g{constructor(v,m){this.f=v,this.g=m,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,T.$of)(v,this.c.scheme);if(this.d[this.e]===2)return(0,T.$of)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,T.$mf)(v,this.c.query);if(this.d[this.e]===5)return(0,T.$mf)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$vi=g;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(N||(N={}));class y{static forUris(v=()=>!1,m=()=>!1){return new y(new g(v,m))}static forPaths(v=!1){return new y(new M(void 0,!v))}static forStrings(){return new y(new R)}static forConfigKeys(){return new y(new O)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,m){if(m){const s=m.slice(0);(0,I.$Xb)(s);for(const o of s)this.set(o,v)}else{const s=v.slice(0);(0,I.$Xb)(s);for(const o of s)this.set(o[0],o[1])}}set(v,m){const s=this.b.reset(v);let o;this.c||(this.c=new k,this.c.segment=s.value());const r=[];for(o=this.c;;){const t=s.cmp(o.segment);if(t>0)o.left||(o.left=new k,o.left.segment=s.value()),r.push([-1,o]),o=o.left;else if(t<0)o.right||(o.right=new k,o.right.segment=s.value()),r.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new k,o.mid.segment=s.value()),r.push([0,o]),o=o.mid;else break}const n=o.value;o.value=m,o.key=v;for(let t=r.length-1;t>=0;t--){const c=r[t][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=r[t][0],b=r[t+1][0];if(i===1&&b===1)r[t][1]=c.rotateLeft();else if(i===-1&&b===-1)r[t][1]=c.rotateRight();else if(i===1&&b===-1)c.right=r[t+1][1]=r[t+1][1].rotateRight(),r[t][1]=c.rotateLeft();else if(i===-1&&b===1)c.left=r[t+1][1]=r[t+1][1].rotateLeft(),r[t][1]=c.rotateRight();else throw new Error;if(t>0)switch(r[t-1][0]){case-1:r[t-1][1].left=r[t][1];break;case 1:r[t-1][1].right=r[t][1];break;case 0:r[t-1][1].mid=r[t][1];break}else this.c=r[0][1]}}return n}get(v){return this.d(v)?.value}d(v){const m=this.b.reset(v);let s=this.c;for(;s;){const o=m.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(m.hasNext())m.next(),s=s.mid;else break}return s}has(v){const m=this.d(v);return!(m?.value===void 0&&m?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,m){const s=this.b.reset(v),o=[];let r=this.c;for(;r;){const n=s.cmp(r.segment);if(n>0)o.push([-1,r]),r=r.left;else if(n<0)o.push([1,r]),r=r.right;else if(s.hasNext())s.next(),o.push([0,r]),r=r.mid;else break}if(r){if(m?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const n=this.f(r.right);if(n.key){const{key:t,value:c,segment:h}=n;this.e(n.key,!1),r.key=t,r.value=c,r.segment=h}}else{const n=r.left??r.right;if(o.length>0){const[t,c]=o[o.length-1];switch(t){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const t=o[n][1];t.updateHeight();const c=t.balanceFactor();if(c>1?(t.right.balanceFactor()>=0||(t.right=t.right.rotateRight()),o[n][1]=t.rotateLeft()):c<-1&&(t.left.balanceFactor()<=0||(t.left=t.left.rotateLeft()),o[n][1]=t.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const m=this.b.reset(v);let s=this.c,o;for(;s;){const r=m.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(m.hasNext())m.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(v){return this.g(v,!1)}g(v,m){const s=this.b.reset(v);let o=this.c;for(;o;){const r=s.cmp(o.segment);if(r>0)o=o.left;else if(r<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[m,s]of this)v(s,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const m=[];return this.j(v,m),m[Symbol.iterator]()}j(v,m){v&&(v.left&&this.j(v.left,m),v.value&&m.push([v.key,v.value]),v.mid&&this.j(v.mid,m),v.right&&this.j(v.right,m))}_isBalanced(){const v=m=>{if(!m)return!0;const s=m.balanceFactor();return s<-1||s>1?!1:v(m.left)&&v(m.right)};return v(this.c)}}e.$wi=y}),define(Re[42],Ae([1,0,91]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Qj=R;var T;(function(M){function p(g){return g&&typeof g=="object"&&typeof g.id=="string"}M.isThemeColor=p})(T||(e.ThemeColor=T={}));function R(M){return{id:M}}var O;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function g(n){const t=p.exec(n.id);if(!t)return g(I.$Pj.error);const[,c,h]=t,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}M.asClassNameArray=g;function k(n){return g(n).join(" ")}M.asClassName=k;function N(n){return"."+g(n).join(".")}M.asCSSSelector=N;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}M.isThemeIcon=y;const u=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function v(n){const t=u.exec(n);if(!t)return;const[,c]=t;return{id:c}}M.fromString=v;function m(n){return{id:n}}M.fromId=m;function s(n,t){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),t&&(c=`${c}~${t}`),{id:c}}M.modify=s;function o(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}M.getModifier=o;function r(n,t){return n.id===t.id&&n.color?.id===t.color?.id}M.isEqual=r})(O||(e.ThemeIcon=O={}))}),define(Re[131],Ae([1,0,129,15,42]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=g,e.$Ik=N,e.$Jk=u,e.$Kk=v,e.$Lk=s,e.$Mk=o;const O="$(",M=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${M.source}`,"g");function g(r){return r.replace(p,(n,t)=>t?n:`\\${n}`)}const k=new RegExp(`\\\\${M.source}`,"g");function N(r){return r.replace(k,n=>`\\${n}`)}const y=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function u(r){return r.indexOf(O)===-1?r:r.replace(y,(n,t,c,h)=>c?n:t||h||"")}function v(r){return r?r.replace(/\$\((.*?)\)/g,(n,t)=>` ${t} `).trim():""}const m=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(r){m.lastIndex=0;let n="";const t=[];let c=0;for(;;){const h=m.lastIndex,i=m.exec(r),b=r.substring(h,i?.index);if(b.length>0){n+=b;for(let a=0;a<b.length;a++)t.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:t}}function o(r,n,t=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,I.$yk)(r,c,t);const i=(0,T.$af)(c," "),b=c.length-i.length,a=(0,I.$yk)(r,i,t);if(a)for(const $ of a){const l=h[$.start+b]+b;$.start+=l,$.end+=l}return a}}),define(Re[35],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=T;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(R){return I.test(R)}e.$Mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(p){for(let g=0;g<p.length;g++)p[g]=Math.floor(Math.random()*256);return p};const O=new Uint8Array(16),M=[];for(let p=0;p<256;p++)M.push(p.toString(16).padStart(2,"0"));return function(){R(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let g=0,k="";return k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+="-",k+=M[O[g++]],k+=M[O[g++]],k+="-",k+=M[O[g++]],k+=M[O[g++]],k+="-",k+=M[O[g++]],k+=M[O[g++]],k+="-",k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k}}()}),define(Re[132],Ae([1,0,18,40,35]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$It=void 0,e.$Gt=O,e.$Ht=M,e.$Jt=k;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function M(y,u,v){const m={id:(0,R.$Mg)(),name:y,uri:u,data:v};return{asString:async()=>"",asFile:()=>m,value:void 0}}class p{constructor(){this.a=new Map}get size(){let u=0;for(const v of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const v=[...this.a.keys()];return T.Iterable.some(this,([m,s])=>s.asFile())&&v.push("files"),N(g(u),v)}get(u){return this.a.get(this.b(u))?.[0]}append(u,v){const m=this.a.get(u);m?m.push(v):this.a.set(this.b(u),[v])}replace(u,v){this.a.set(this.b(u),[v])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,v]of this.a)for(const m of v)yield[u,m]}b(u){return g(u)}}e.$It=p;function g(y){return y.toLowerCase()}function k(y,u){return N(g(y),u.map(g))}function N(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const v=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[m,s,o]=v;return o==="*"?u.some(r=>r.startsWith(s+"/")):!1}e.$Kt=Object.freeze({create:y=>(0,I.$Mb)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$Kt.split(y).filter(u=>!u.startsWith("#"))})}),define(Re[133],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=T;var I;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function T(R){let O=0,M=0,p=0,g=0;for(let k=0,N=R.length;k<N;k++){const y=R.charCodeAt(k);y===13?(O===0&&(M=k),O++,k+1<N&&R.charCodeAt(k+1)===10?(g|=2,k++):g|=3,p=k+1):y===10&&(g|=1,O===0&&(M=k),O++,p=k+1)}return O===0&&(M=R.length),[O,M,R.length-p,g]}}),define(Re[134],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[135],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.$au=e.IndentAction=void 0;var I;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class T{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let g=0,k=p.notIn.length;g<k;g++)switch(p.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,g){if(p.getTokenCount()===0)return!0;const k=p.findTokenIndexAtOffset(g-2),N=p.getStandardTokenType(k);return this.isOK(N)}g(p,g){for(let k=p;k<=g;k++){const N=String.fromCharCode(k);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$au=T;class R{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of p)O(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),O(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),O(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),O(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&O(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$bu=R;function O(M,p,g){M.has(p)?M.get(p).push(g):M.set(p,[g])}}),define(Re[136],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rC=e.NodeColor=e.$qC=void 0,e.$sC=R,e.$tC=O,e.$uC=k,e.$vC=N,e.$wC=y,e.$xC=u,e.$yC=v,e.$zC=m;class I{constructor(o,r){this.piece=o,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$rC)return R(this.right);let o=this;for(;o.parent!==e.$rC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$rC?e.$rC:o.parent}prev(){if(this.left!==e.$rC)return O(this.left);let o=this;for(;o.parent!==e.$rC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$rC?e.$rC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$qC=I;var T;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$rC=new I(null,0),e.$rC.parent=e.$rC,e.$rC.left=e.$rC,e.$rC.right=e.$rC,e.$rC.color=0;function R(s){for(;s.left!==e.$rC;)s=s.left;return s}function O(s){for(;s.right!==e.$rC;)s=s.right;return s}function M(s){return s===e.$rC?0:s.size_left+s.piece.length+M(s.right)}function p(s){return s===e.$rC?0:s.lf_left+s.piece.lineFeedCnt+p(s.right)}function g(){e.$rC.parent=e.$rC}function k(s,o){const r=o.right;r.size_left+=o.size_left+(o.piece?o.piece.length:0),r.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=r.left,r.left!==e.$rC&&(r.left.parent=o),r.parent=o.parent,o.parent===e.$rC?s.root=r:o.parent.left===o?o.parent.left=r:o.parent.right=r,r.left=o,o.parent=r}function N(s,o){const r=o.left;o.left=r.right,r.right!==e.$rC&&(r.right.parent=o),r.parent=o.parent,o.size_left-=r.size_left+(r.piece?r.piece.length:0),o.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),o.parent===e.$rC?s.root=r:o===o.parent.right?o.parent.right=r:o.parent.left=r,r.right=o,o.parent=r}function y(s,o){let r,n;if(o.left===e.$rC?(n=o,r=n.right):o.right===e.$rC?(n=o,r=n.left):(n=R(o.right),r=n.right),n===s.root){s.root=r,r.color=0,o.detach(),g(),s.root.parent=e.$rC;return}const t=n.color===1;if(n===n.parent.left?n.parent.left=r:n.parent.right=r,n===o?(r.parent=n.parent,m(s,r)):(n.parent===o?r.parent=n:r.parent=n.parent,m(s,r),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===s.root?s.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$rC&&(n.left.parent=n),n.right!==e.$rC&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,m(s,n)),o.detach(),r.parent.left===r){const h=M(r),i=p(r);if(h!==r.parent.size_left||i!==r.parent.lf_left){const b=h-r.parent.size_left,a=i-r.parent.lf_left;r.parent.size_left=h,r.parent.lf_left=i,v(s,r.parent,b,a)}}if(m(s,r.parent),t){g();return}let c;for(;r!==s.root&&r.color===0;)r===r.parent.left?(c=r.parent.right,c.color===1&&(c.color=0,r.parent.color=1,k(s,r.parent),c=r.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.right.color===0&&(c.left.color=0,c.color=1,N(s,c),c=r.parent.right),c.color=r.parent.color,r.parent.color=0,c.right.color=0,k(s,r.parent),r=s.root)):(c=r.parent.left,c.color===1&&(c.color=0,r.parent.color=1,N(s,r.parent),c=r.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.left.color===0&&(c.right.color=0,c.color=1,k(s,c),c=r.parent.left),c.color=r.parent.color,r.parent.color=0,c.left.color=0,N(s,r.parent),r=s.root));r.color=0,g()}function u(s,o){for(m(s,o);o!==s.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const r=o.parent.parent.right;r.color===1?(o.parent.color=0,r.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,k(s,o)),o.parent.color=0,o.parent.parent.color=1,N(s,o.parent.parent))}else{const r=o.parent.parent.left;r.color===1?(o.parent.color=0,r.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,N(s,o)),o.parent.color=0,o.parent.parent.color=1,k(s,o.parent.parent))}s.root.color=0}function v(s,o,r,n){for(;o!==s.root&&o!==e.$rC;)o.parent.left===o&&(o.parent.size_left+=r,o.parent.lf_left+=n),o=o.parent}function m(s,o){let r=0,n=0;if(o!==s.root){for(;o!==s.root&&o===o.parent.right;)o=o.parent;if(o!==s.root)for(o=o.parent,r=M(o.left)-o.size_left,n=p(o.left)-o.lf_left,o.size_left+=r,o.lf_left+=n;o!==s.root&&(r!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=r,o.parent.lf_left+=n),o=o.parent}}}),define(Re[92],Ae([1,0,93,29,94,136,95]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=e.$JC=e.$IC=void 0,e.$GC=N,e.$HC=y;const p=65535;function g(r){let n;return r[r.length-1]<65536?n=new Uint16Array(r.length):n=new Uint32Array(r.length),n.set(r,0),n}class k{constructor(n,t,c,h,i){this.lineStarts=n,this.cr=t,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function N(r,n=!0){const t=[0];let c=1;for(let h=0,i=r.length;h<i;h++){const b=r.charCodeAt(h);b===13?h+1<i&&r.charCodeAt(h+1)===10?(t[c++]=h+2,h++):t[c++]=h+1:b===10&&(t[c++]=h+1)}return n?g(t):t}function y(r,n){r.length=0,r[0]=0;let t=1,c=0,h=0,i=0,b=!0;for(let $=0,l=n.length;$<l;$++){const S=n.charCodeAt($);S===13?$+1<l&&n.charCodeAt($+1)===10?(i++,r[t++]=$+2,$++):(c++,r[t++]=$+1):S===10?(h++,r[t++]=$+1):b&&S!==9&&(S<32||S>126)&&(b=!1)}const a=new k(g(r),c,h,i,b);return r.length=0,a}class u{constructor(n,t,c,h,i){this.bufferIndex=n,this.start=t,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$IC=u;class v{constructor(n,t){this.buffer=n,this.lineStarts=t}}e.$JC=v;class m{constructor(n,t){this.a=[],this.c=n,this.d=t,this.b=0,n.root!==O.$rC&&n.iterate(n.root,c=>(c!==O.$rC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(n){this.a=n,this.b=[]}get(n){for(let t=this.b.length-1;t>=0;t--){const c=this.b[t];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let t=this.b.length-1;t>=0;t--){const c=this.b[t];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let t=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=n){c[h]=null,t=!0;continue}}if(t){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class o{constructor(n,t,c){this.create(n,t,c)}create(n,t,c){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=O.$rC,this.b=1,this.c=0,this.d=t,this.e=t.length,this.f=c;let h=null;for(let i=0,b=n.length;i<b;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=N(n[i].buffer));const a=new u(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),h=this.S(h,a)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const t=p,c=t-Math.floor(t/3),h=c*2;let i="",b=0;const a=[];if(this.iterate(this.root,$=>{const l=this.R($),S=l.length;if(b<=c||b+S<h)return i+=l,b+=S,!0;const d=i.replace(/\r\n|\r|\n/g,n);return a.push(new v(d,N(d))),i=l,b=S,!0}),b>0){const $=i.replace(/\r\n|\r|\n/g,n);a.push(new v($,N($)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new m(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let t=0;return this.iterate(this.root,h=>{if(h===O.$rC)return!0;const i=this.R(h),b=i.length,a=n.G(t),$=n.G(t+b),l=n.getValueInRange2(a,$);return t+=b,i===l})}getOffsetAt(n,t){let c=0,h=this.root;for(;h!==O.$rC;)if(h.left!==O.$rC&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const i=this.B(h,n-h.lf_left-2);return c+=i+t-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let t=this.root,c=0;const h=n;for(;t!==O.$rC;)if(t.size_left!==0&&t.size_left>=n)t=t.left;else if(t.size_left+t.piece.length>=n){const i=this.A(t,n-t.size_left);if(c+=t.lf_left+i.index,i.index===0){const b=this.getOffsetAt(c+1,1),a=h-b;return new I.$jt(c+1,a+1)}return new I.$jt(c+1,i.remainder+1)}else if(n-=t.size_left+t.piece.length,c+=t.lf_left+t.piece.lineFeedCnt,t.right===O.$rC){const i=this.getOffsetAt(c+1,1),b=h-n-i;return new I.$jt(c+1,b+1)}else t=t.right;return new I.$jt(1,1)}getValueInRange(n,t){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,h);return t?t!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,t):t===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,t):i}getValueInRange2(n,t){if(n.node===t.node){const a=n.node,$=this.a[a.piece.bufferIndex].buffer,l=this.u(a.piece.bufferIndex,a.piece.start);return $.substring(l+n.remainder,l+t.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let b=h.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==O.$rC;){const a=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);if(c===t.node){b+=a.substring($,$+t.remainder);break}else b+=a.substr($,c.piece.length);c=c.next()}return b}getLinesContent(){const n=[];let t=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===O.$rC)return!0;const b=i.piece;let a=b.length;if(a===0)return!0;const $=this.a[b.bufferIndex].buffer,l=this.a[b.bufferIndex].lineStarts,S=b.start.line,d=b.end.line;let D=l[S]+b.start.column;if(h&&($.charCodeAt(D)===10&&(D++,a--),n[t++]=c,c="",h=!1,a===0))return!0;if(S===d)return!this.f&&$.charCodeAt(D+a-1)===13?(h=!0,c+=$.substr(D,a-1)):c+=$.substr(D,a),!0;c+=this.f?$.substring(D,Math.max(D,l[S+1]-this.e)):$.substring(D,l[S+1]).replace(/(\r\n|\r|\n)$/,""),n[t++]=c;for(let f=S+1;f<d;f++)c=this.f?$.substring(l[f],l[f+1]-this.e):$.substring(l[f],l[f+1]).replace(/(\r\n|\r|\n)$/,""),n[t++]=c;return!this.f&&$.charCodeAt(l[d]+b.end.column-1)===13?(h=!0,b.end.column===0?t--:c=$.substr(l[d],b.end.column-1)):c=$.substr(l[d],b.end.column),!0}),h&&(n[t++]=c,c=""),n[t++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t)return 0;const c=this.a[t.piece.bufferIndex],h=this.u(t.piece.bufferIndex,t.piece.start);return c.buffer.charCodeAt(h)}else{const t=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return t.buffer.charCodeAt(h)}}getLineCharCode(n,t){const c=this.H(n,t+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const t=this.getOffsetAt(n,1);return this.getLength()-t}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const t=this.G(n);return this.l(t)}findMatchesInNode(n,t,c,h,i,b,a,$,l,S,d){const D=this.a[n.piece.bufferIndex],f=this.u(n.piece.bufferIndex,n.piece.start),E=this.u(n.piece.bufferIndex,i),w=this.u(n.piece.bufferIndex,b);let P;const C={line:0,column:0};let V,W;t._wordSeparators?(V=D.buffer.substring(E,w),W=q=>q+E,t.reset(0)):(V=D.buffer,W=q=>q,t.reset(E));do if(P=t.next(V),P){if(W(P.index)>=w)return S;this.s(n,W(P.index)-f,C);const q=this.t(n.piece.bufferIndex,i,C),A=C.line===i.line?C.column-i.column+h:C.column+1,U=A+P[0].length;if(d[S++]=(0,M.$CC)(new T.$kt(c+q,A,c+q,U),P,$),W(P.index)+P[0].length>=w||S>=l)return S}while(P);return S}findMatchesLineByLine(n,t,c,h){const i=[];let b=0;const a=new M.$FC(t.wordSeparators,t.regex);let $=this.H(n.startLineNumber,n.startColumn);if($===null)return[];const l=this.H(n.endLineNumber,n.endColumn);if(l===null)return[];let S=this.s($.node,$.remainder);const d=this.s(l.node,l.remainder);if($.node===l.node)return this.findMatchesInNode($.node,a,n.startLineNumber,n.startColumn,S,d,t,c,h,b,i),i;let D=n.startLineNumber,f=$.node;for(;f!==l.node;){const w=this.t(f.piece.bufferIndex,S,f.piece.end);if(w>=1){const C=this.a[f.piece.bufferIndex].lineStarts,V=this.u(f.piece.bufferIndex,f.piece.start),W=C[S.line+w],q=D===n.startLineNumber?n.startColumn:1;if(b=this.findMatchesInNode(f,a,D,q,S,this.s(f,W-V),t,c,h,b,i),b>=h)return i;D+=w}const P=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const C=this.getLineContent(D).substring(P,n.endColumn-1);return b=this.n(t,a,C,n.endLineNumber,P,b,i,c,h),i}if(b=this.n(t,a,this.getLineContent(D).substr(P),D,P,b,i,c,h),b>=h)return i;D++,$=this.H(D,1),f=$.node,S=this.s($.node,$.remainder)}if(D===n.endLineNumber){const w=D===n.startLineNumber?n.startColumn-1:0,P=this.getLineContent(D).substring(w,n.endColumn-1);return b=this.n(t,a,P,n.endLineNumber,w,b,i,c,h),i}const E=D===n.startLineNumber?n.startColumn:1;return b=this.findMatchesInNode(l.node,a,D,E,S,d,t,c,h,b,i),i}n(n,t,c,h,i,b,a,$,l){const S=n.wordSeparators;if(!$&&n.simpleSearch){const D=n.simpleSearch,f=D.length,E=c.length;let w=-f;for(;(w=c.indexOf(D,w+f))!==-1;)if((!S||(0,M.$EC)(S,c,E,w,f))&&(a[b++]=new R.$vv(new T.$kt(h,w+1+i,h,w+1+f+i),null),b>=l))return b;return b}let d;t.reset(0);do if(d=t.next(c),d&&(a[b++]=(0,M.$CC)(new T.$kt(h,d.index+1+i,h,d.index+1+d[0].length+i),d,$),b>=l))return b;while(d);return b}insert(n,t,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==O.$rC){const{node:h,remainder:i,nodeStartOffset:b}=this.G(n),a=h.piece,$=a.bufferIndex,l=this.s(h,i);if(h.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&b+a.length===n&&t.length<p){this.F(h,t),this.y();return}if(b===n)this.o(t,h),this.h.validate(n);else if(b+h.piece.length>n){const S=[];let d=new u(a.bufferIndex,l,a.end,this.t(a.bufferIndex,l,a.end),this.u($,a.end)-this.u($,l));if(this.K()&&this.M(t)&&this.I(h,i)===10){const w={line:d.start.line+1,column:0};d=new u(d.bufferIndex,w,d.end,this.t(d.bufferIndex,w,d.end),d.length-1),t+=`
`}if(this.K()&&this.L(t))if(this.I(h,i-1)===13){const w=this.s(h,i-1);this.C(h,w),t="\r"+t,h.piece.length===0&&S.push(h)}else this.C(h,l);else this.C(h,l);const D=this.w(t);d.length>0&&this.S(h,d);let f=h;for(let E=0;E<D.length;E++)f=this.S(f,D[E]);this.v(S)}else this.q(t,h)}else{const h=this.w(t);let i=this.T(null,h[0]);for(let b=1;b<h.length;b++)i=this.S(i,h[b])}this.y()}delete(n,t){if(this.j.lineNumber=0,this.j.value="",t<=0||this.root===O.$rC)return;const c=this.G(n),h=this.G(n+t),i=c.node,b=h.node;if(i===b){const D=this.s(i,c.remainder),f=this.s(i,h.remainder);if(c.nodeStartOffset===n){if(t===i.piece.length){const E=i.next();(0,O.$wC)(this,i),this.N(E),this.y();return}this.D(i,f),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+t){this.C(i,D),this.O(i),this.y();return}this.E(i,D,f),this.y();return}const a=[],$=this.s(i,c.remainder);this.C(i,$),this.h.validate(n),i.piece.length===0&&a.push(i);const l=this.s(b,h.remainder);this.D(b,l),b.piece.length===0&&a.push(b);const S=i.next();for(let D=S;D!==O.$rC&&D!==b;D=D.next())a.push(D);const d=i.piece.length===0?i.prev():i;this.v(a),this.O(d),this.y()}o(n,t){const c=[];if(this.K()&&this.M(n)&&this.L(t)){const b=t.piece,a={line:b.start.line+1,column:0},$=new u(b.bufferIndex,a,b.end,this.t(b.bufferIndex,a,b.end),b.length-1);t.piece=$,n+=`
`,(0,O.$yC)(this,t,-1,-1),t.piece.length===0&&c.push(t)}const h=this.w(n);let i=this.T(t,h[h.length-1]);for(let b=h.length-2;b>=0;b--)i=this.T(i,h[b]);this.N(i),this.v(c)}q(n,t){this.Q(n,t)&&(n+=`
`);const c=this.w(n),h=this.S(t,c[0]);let i=h;for(let b=1;b<c.length;b++)i=this.S(i,c[b]);this.N(h)}s(n,t,c){const h=n.piece,i=n.piece.bufferIndex,b=this.a[i].lineStarts,$=b[h.start.line]+h.start.column+t;let l=h.start.line,S=h.end.line,d=0,D=0,f=0;for(;l<=S&&(d=l+(S-l)/2|0,f=b[d],d!==S);)if(D=b[d+1],$<f)S=d-1;else if($>=D)l=d+1;else break;return c?(c.line=d,c.column=$-f,null):{line:d,column:$-f}}t(n,t,c){if(c.column===0)return c.line-t.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-t.line;const i=h[c.line+1],b=h[c.line]+c.column;if(i>b+1)return c.line-t.line;const a=b-1;return this.a[n].buffer.charCodeAt(a)===13?c.line-t.line+1:c.line-t.line}u(n,t){return this.a[n].lineStarts[t.line]+t.column}v(n){for(let t=0;t<n.length;t++)(0,O.$wC)(this,n[t])}w(n){if(n.length>p){const S=[];for(;n.length>p;){const D=n.charCodeAt(p-1);let f;D===13||D>=55296&&D<=56319?(f=n.substring(0,p-1),n=n.substring(p-1)):(f=n.substring(0,p),n=n.substring(p));const E=N(f);S.push(new u(this.a.length,{line:0,column:0},{line:E.length-1,column:f.length-E[E.length-1]},E.length-1,f.length)),this.a.push(new v(f,E))}const d=N(n);return S.push(new u(this.a.length,{line:0,column:0},{line:d.length-1,column:n.length-d[d.length-1]},d.length-1,n.length)),this.a.push(new v(n,d)),S}let t=this.a[0].buffer.length;const c=N(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===t&&t!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let S=0;S<c.length;S++)c[S]+=t+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,t+=1}else{if(t!==0)for(let S=0;S<c.length;S++)c[S]+=t;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,b=this.a[0].lineStarts.length-1,a=i-this.a[0].lineStarts[b],$={line:b,column:a},l=new u(0,h,$,this.t(0,h,$),i-t);return this.g=$,[l]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,t=0){let c=this.root,h="";const i=this.h.get2(n);if(i){c=i.node;const b=this.B(c,n-i.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=a.substring($+b,$+c.piece.length);else{const l=this.B(c,n-i.nodeStartLineNumber);return a.substring($+b,$+l-t)}}else{let b=0;const a=n;for(;c!==O.$rC;)if(c.left!==O.$rC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const $=this.B(c,n-c.lf_left-2),l=this.B(c,n-c.lf_left-1),S=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);return b+=c.size_left,this.h.set({node:c,nodeStartOffset:b,nodeStartLineNumber:a-(n-1-c.lf_left)}),S.substring(d+$,d+l-t)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const $=this.B(c,n-c.lf_left-2),l=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);h=l.substring(S+$,S+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,b+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==O.$rC;){const b=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),$=this.u(c.piece.bufferIndex,c.piece.start);return h+=b.substring($,$+a-t),h}else{const a=this.u(c.piece.bufferIndex,c.piece.start);h+=b.substr(a,c.piece.length)}c=c.next()}return h}y(){let n=this.root,t=1,c=0;for(;n!==O.$rC;)t+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=t,this.c=c,this.h.validate(this.c)}A(n,t){const c=n.piece,h=this.s(n,t),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===t){const b=this.t(n.piece.bufferIndex,c.start,h);if(b!==i)return{index:b,remainder:0}}return{index:i,remainder:h.column}}B(n,t){if(t<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+t+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(n,t){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),b=t,a=this.u(c.bufferIndex,b),$=this.t(c.bufferIndex,c.start,b),l=$-h,S=a-i,d=c.length+S;n.piece=new u(c.bufferIndex,c.start,b,$,d),(0,O.$yC)(this,n,S,l)}D(n,t){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),b=t,a=this.t(c.bufferIndex,b,c.end),$=this.u(c.bufferIndex,b),l=a-h,S=i-$,d=c.length+S;n.piece=new u(c.bufferIndex,b,c.end,a,d),(0,O.$yC)(this,n,S,l)}E(n,t,c){const h=n.piece,i=h.start,b=h.end,a=h.length,$=h.lineFeedCnt,l=t,S=this.t(h.bufferIndex,h.start,l),d=this.u(h.bufferIndex,t)-this.u(h.bufferIndex,i);n.piece=new u(h.bufferIndex,h.start,l,S,d),(0,O.$yC)(this,n,d-a,S-$);const D=new u(h.bufferIndex,c,b,this.t(h.bufferIndex,c,b),this.u(h.bufferIndex,b)-this.u(h.bufferIndex,c)),f=this.S(n,D);this.N(f)}F(n,t){this.Q(t,n)&&(t+=`
`);const c=this.K()&&this.L(t)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=t;const i=N(t,!1);for(let f=0;f<i.length;f++)i[f]+=h;if(c){const f=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-f}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const b=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[b],$={line:b,column:a},l=n.piece.length+t.length,S=n.piece.lineFeedCnt,d=this.t(0,n.piece.start,$),D=d-S;n.piece=new u(n.piece.bufferIndex,n.piece.start,$,d,l),this.g=$,(0,O.$yC)(this,n,t.length,D)}G(n){let t=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;t!==O.$rC;)if(t.size_left>n)t=t.left;else if(t.size_left+t.piece.length>=n){h+=t.size_left;const i={node:t,remainder:n-t.size_left,nodeStartOffset:h};return this.h.set(i),i}else n-=t.size_left+t.piece.length,h+=t.size_left+t.piece.length,t=t.right;return null}H(n,t){let c=this.root,h=0;for(;c!==O.$rC;)if(c.left!==O.$rC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),b=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+t-1,b),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+t-1<=c.piece.length)return{node:c,remainder:i+t-1,nodeStartOffset:h};t-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==O.$rC;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),b=this.J(c);return{node:c,remainder:Math.min(t-1,i),nodeStartOffset:b}}else if(c.piece.length>=t-1){const i=this.J(c);return{node:c,remainder:t-1,nodeStartOffset:i}}else t-=c.piece.length;c=c.next()}return null}I(n,t){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+t;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let t=n.size_left;for(;n!==this.root;)n.parent.right===n&&(t+=n.parent.size_left+n.parent.piece.length),n=n.parent;return t}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===O.$rC||n.piece.lineFeedCnt===0)return!1;const t=n.piece,c=this.a[t.bufferIndex].lineStarts,h=t.start.line,i=c[h]+t.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[t.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===O.$rC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const t=n.prev();this.M(t)&&this.P(t,n)}}O(n){if(this.K()&&this.M(n)){const t=n.next();this.L(t)&&this.P(n,t)}}P(n,t){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const b=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new u(n.piece.bufferIndex,n.piece.start,i,a,b),(0,O.$yC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const $={line:t.piece.start.line+1,column:0},l=t.piece.length-1,S=this.t(t.piece.bufferIndex,$,t.piece.end);t.piece=new u(t.piece.bufferIndex,$,t.piece.end,S,l),(0,O.$yC)(this,t,-1,-1),t.piece.length===0&&c.push(t);const d=this.w(`\r
`);this.S(n,d[0]);for(let D=0;D<c.length;D++)(0,O.$wC)(this,c[D])}Q(n,t){if(this.K()&&this.M(n)){const c=t.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,O.$wC)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},b=h.length-1,a=this.t(h.bufferIndex,i,h.end);c.piece=new u(h.bufferIndex,i,h.end,a,b),(0,O.$yC)(this,c,-1,-1)}return!0}}return!1}iterate(n,t){if(n===O.$rC)return t(O.$rC);const c=this.iterate(n.left,t);return c&&t(n)&&this.iterate(n.right,t)}R(n){if(n===O.$rC)return"";const t=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return t.buffer.substring(h,i)}getPieceContent(n){const t=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return t.buffer.substring(c,h)}S(n,t){const c=new O.$qC(t,1);if(c.left=O.$rC,c.right=O.$rC,c.parent=O.$rC,c.size_left=0,c.lf_left=0,this.root===O.$rC)this.root=c,c.color=0;else if(n.right===O.$rC)n.right=c,c.parent=n;else{const i=(0,O.$sC)(n.right);i.left=c,c.parent=i}return(0,O.$xC)(this,c),c}T(n,t){const c=new O.$qC(t,1);if(c.left=O.$rC,c.right=O.$rC,c.parent=O.$rC,c.size_left=0,c.lf_left=0,this.root===O.$rC)this.root=c,c.color=0;else if(n.left===O.$rC)n.left=c,c.parent=n;else{const h=(0,O.$tC)(n.left);h.right=c,c.parent=h}return(0,O.$xC)(this,c),c}U(n){let t="";return this.iterate(n,c=>(t+=this.R(c),!0)),t}}e.$KC=o}),define(Re[137],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f9=e.$e9=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const M=this.a.get(O);return this.a.delete(O),M}}addDragOperationTransfer(O,M){this.a.set(O,M)}}e.$e9=I;class T{constructor(O){this.identifier=O}}e.$f9=T}),define(Re[138],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Re[139],Ae([1,0,5,6,138]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0,e.$aj=N;class O extends T.$Uc{constructor(u,v="",m="",s=!0,o){super(),this.h=this.B(new I.$be),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=v,this.u=m,this.w=s,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,v){this.C&&await this.C(u)}}e.$8i=O;class M extends T.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$be),this.onWillRun=this.f.event,this.m=this.B(new I.$be),this.onDidRun=this.m.event}async run(u,v){if(!u.enabled)return;this.f.fire({action:u});let m;try{await this.u(u,v)}catch(s){m=s}this.m.fire({action:u,error:m})}async u(u,v){await u.run(v)}}e.$9i=M;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let v=[];for(const m of u)m.length&&(v.length?v=[...v,new p,...m]:v=m);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$0i=p;class g{get actions(){return this.a}constructor(u,v,m,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=v,this.class=s,this.a=m}async run(){}}e.$$i=g;class k extends O{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,R.localize(0,null),void 0,!1)}}e.$_i=k;function N(y){return{id:y.id,label:y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u),tooltip:y.label}}}),define(Re[140],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Re[141],Ae([1,0,140]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=k,e.$Wm=N,e.$Xm=y;const T=60,R=T*60,O=R*24,M=O*7,p=O*30,g=O*365;function k(u,v,m,s){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,I.localize)(0,null,k(new Date().getTime()+o*1e3,!1));if(!s&&o<30)return(0,I.localize)(1,null);let r;return o<T?(r=o,v?r===1?m?(0,I.localize)(2,null,r):(0,I.localize)(3,null,r):m?(0,I.localize)(4,null,r):(0,I.localize)(5,null,r):r===1?m?(0,I.localize)(6,null,r):(0,I.localize)(7,null,r):m?(0,I.localize)(8,null,r):(0,I.localize)(9,null,r)):o<R?(r=Math.floor(o/T),v?r===1?m?(0,I.localize)(10,null,r):(0,I.localize)(11,null,r):m?(0,I.localize)(12,null,r):(0,I.localize)(13,null,r):r===1?m?(0,I.localize)(14,null,r):(0,I.localize)(15,null,r):m?(0,I.localize)(16,null,r):(0,I.localize)(17,null,r)):o<O?(r=Math.floor(o/R),v?r===1?m?(0,I.localize)(18,null,r):(0,I.localize)(19,null,r):m?(0,I.localize)(20,null,r):(0,I.localize)(21,null,r):r===1?m?(0,I.localize)(22,null,r):(0,I.localize)(23,null,r):m?(0,I.localize)(24,null,r):(0,I.localize)(25,null,r)):o<M?(r=Math.floor(o/O),v?r===1?(0,I.localize)(26,null,r):(0,I.localize)(27,null,r):r===1?(0,I.localize)(28,null,r):(0,I.localize)(29,null,r)):o<p?(r=Math.floor(o/M),v?r===1?m?(0,I.localize)(30,null,r):(0,I.localize)(31,null,r):m?(0,I.localize)(32,null,r):(0,I.localize)(33,null,r):r===1?m?(0,I.localize)(34,null,r):(0,I.localize)(35,null,r):m?(0,I.localize)(36,null,r):(0,I.localize)(37,null,r)):o<g?(r=Math.floor(o/p),v?r===1?m?(0,I.localize)(38,null,r):(0,I.localize)(39,null,r):m?(0,I.localize)(40,null,r):(0,I.localize)(41,null,r):r===1?m?(0,I.localize)(42,null,r):(0,I.localize)(43,null,r):m?(0,I.localize)(44,null,r):(0,I.localize)(45,null,r)):(r=Math.floor(o/g),v?r===1?m?(0,I.localize)(46,null,r):(0,I.localize)(47,null,r):m?(0,I.localize)(48,null,r):(0,I.localize)(49,null,r):r===1?m?(0,I.localize)(50,null,r):(0,I.localize)(51,null,r):m?(0,I.localize)(52,null,r):(0,I.localize)(53,null,r))}function N(u,v){const m=Math.abs(u/1e3);return m<1?v?(0,I.localize)(54,null,u):(0,I.localize)(55,null,u):m<T?v?(0,I.localize)(56,null,Math.round(u)/1e3):(0,I.localize)(57,null,Math.round(u)/1e3):m<R?v?(0,I.localize)(58,null,Math.round(u/(1e3*T))):(0,I.localize)(59,null,Math.round(u/(1e3*T))):m<O?v?(0,I.localize)(60,null,Math.round(u/(1e3*R))):(0,I.localize)(61,null,Math.round(u/(1e3*R))):(0,I.localize)(62,null,Math.round(u/(1e3*O)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Re[142],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Re[43],Ae([1,0,18,17,142]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=g,e.$cj=k,e.$dj=N;function O(y,u){return u&&(y.stack||y.stacktrace)?R.localize(0,null,p(y),M(y.stack)||M(y.stacktrace)):p(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function p(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?R.localize(1,null,y.message):y.message||R.localize(2,null)}function g(y=null,u=!1){if(!y)return R.localize(3,null);if(Array.isArray(y)){const v=I.$Hb(y),m=g(v[0],u);return v.length>1?R.localize(4,null,m,v.length):m}if(T.$4f(y))return y;if(y.detail){const v=y.detail;if(v.error)return O(v.error,u);if(v.exception)return O(v.exception,u)}return y.stack?O(y,u):y.message?y.message:R.localize(5,null)}function k(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function N(y,u){let v;return typeof y=="string"?v=new Error(y):v=y,v.actions=u,v}}),define(Re[143],Ae([1,0,41,19]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=p,e.$_q=g,e.$ar=k,e.$br=N,e.$cr=y,e.$dr=u,e.$er=v,e.$fr=m,e.$gr=s,e.$hr=o,e.$ir=l,e.$jr=S,e.$kr=d;const R=new I.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),O=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(D,f,E=!1){const w=D||"",P=f||"",C=R.value.collator.compare(w,P);return R.value.collatorIsNumeric&&C===0&&w!==P?w<P?-1:1:C}function g(D,f){const E=O.value.collator;return D=D||"",f=f||"",c(E,D,f)}function k(D,f){const E=O.value.collator;return D=D||"",f=f||"",a(D,f)||c(E,D,f)}function N(D,f){const E=O.value.collator;return D=D||"",f=f||"",b(D,f)||c(E,D,f)}function y(D,f){return D=D||"",f=f||"",D===f?0:D<f?-1:1}function u(D,f){const[E,w]=n(D),[P,C]=n(f);let V=R.value.collator.compare(w,C);if(V===0){if(R.value.collatorIsNumeric&&w!==C)return w<C?-1:1;if(V=R.value.collator.compare(E,P),R.value.collatorIsNumeric&&V===0&&E!==P)return E<P?-1:1}return V}function v(D,f){D=D||"",f=f||"";const E=t(D),w=t(f),P=O.value.collator,C=M.value.collator;return c(C,E,w)||c(P,D,f)}function m(D,f){D=D||"",f=f||"";const E=t(D),w=t(f),P=O.value.collator,C=M.value.collator;return c(C,E,w)||a(D,f)||c(P,D,f)}function s(D,f){D=D||"",f=f||"";const E=t(D),w=t(f),P=O.value.collator,C=M.value.collator;return c(C,E,w)||b(D,f)||c(P,D,f)}function o(D,f){D=D||"",f=f||"";const E=t(D).toLowerCase(),w=t(f).toLowerCase();return E!==w?E<w?-1:1:D!==f?D<f?-1:1:0}const r=/^(.*?)(\.([^.]*))?$/;function n(D,f=!1){const E=D?r.exec(D):[];let w=[E&&E[1]||"",E&&E[3]||""];return f&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function t(D){const f=D?r.exec(D):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function c(D,f,E){const w=D.compare(f,E);return w!==0?w:f.length!==E.length?f.length<E.length?-1:1:0}function h(D){const f=D.charAt(0);return f.toLocaleUpperCase()!==f}function i(D){const f=D.charAt(0);return f.toLocaleLowerCase()!==f}function b(D,f){return h(D)&&i(f)?-1:i(D)&&h(f)?1:0}function a(D,f){return i(D)&&h(f)?-1:h(D)&&i(f)?1:0}function $(D,f,E=!1){return E||(D=D&&D.toLowerCase(),f=f&&f.toLowerCase()),D===f?0:D<f?-1:1}function l(D,f,E=!1){const w=D.split(T.sep),P=f.split(T.sep),C=w.length-1,V=P.length-1;let W,q;for(let A=0;;A++){if(W=C===A,q=V===A,W&&q)return p(w[A],P[A],E);if(W)return-1;if(q)return 1;const U=$(w[A],P[A],E);if(U!==0)return U}}function S(D,f,E){const w=D.toLowerCase(),P=f.toLowerCase(),C=d(D,f,E);if(C)return C;const V=w.endsWith(E),W=P.endsWith(E);if(V!==W)return V?-1:1;const q=p(w,P);return q!==0?q:w.localeCompare(P)}function d(D,f,E){const w=D.toLowerCase(),P=f.toLowerCase(),C=w.startsWith(E),V=P.startsWith(E);if(C!==V)return C?-1:1;if(C&&V){if(w.length<P.length)return-1;if(w.length>P.length)return 1}return 0}}),define(Re[47],Ae([1,0,19,21,15,17]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=M,e.$kg=p,e.$lg=g,e.$mg=k,e.$ng=N,e.$og=m,e.$pg=s,e.$qg=o,e.$rg=r,e.$sg=n,e.$tg=t,e.$ug=c,e.$vg=h,e.$wg=i,e.$xg=b,e.$yg=l;function M(S){return S===47||S===92}function p(S){return S.replace(/[\\/]/g,I.$hc.sep)}function g(S){return S.indexOf("/")===-1&&(S=p(S)),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S),S}function k(S,d=I.$hc.sep){if(!S)return"";const D=S.length,f=S.charCodeAt(0);if(M(f)){if(M(S.charCodeAt(1))&&!M(S.charCodeAt(2))){let w=3;const P=w;for(;w<D&&!M(S.charCodeAt(w));w++);if(P!==w&&!M(S.charCodeAt(w+1))){for(w+=1;w<D;w++)if(M(S.charCodeAt(w)))return S.slice(0,w+1).replace(/[\\/]/g,d)}}return d}else if(r(f)&&S.charCodeAt(1)===58)return M(S.charCodeAt(2))?S.slice(0,2)+d:S.slice(0,2);let E=S.indexOf("://");if(E!==-1){for(E+=3;E<D;E++)if(M(S.charCodeAt(E)))return S.slice(0,E+1)}return""}function N(S){if(!T.$i||!S||S.length<5)return!1;let d=S.charCodeAt(0);if(d!==92||(d=S.charCodeAt(1),d!==92))return!1;let D=2;const f=D;for(;D<S.length&&(d=S.charCodeAt(D),d!==92);D++);return!(f===D||(d=S.charCodeAt(D+1),isNaN(d)||d===92))}const y=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(S,d=T.$i){const D=d?y:u;return!(!S||S.length===0||/^\s+$/.test(S)||(D.lastIndex=0,D.test(S))||d&&v.test(S)||S==="."||S===".."||d&&S[S.length-1]==="."||d&&S.length!==S.trim().length||S.length>255)}function s(S,d,D){const f=S===d;return!D||f?f:!S||!d?!1:(0,R.$tf)(S,d)}function o(S,d,D,f=I.sep){if(S===d)return!0;if(!S||!d||d.length>S.length)return!1;if(D){if(!(0,R.$uf)(S,d))return!1;if(d.length===S.length)return!0;let w=d.length;return d.charAt(d.length-1)===f&&w--,S.charAt(w)===f}return d.charAt(d.length-1)!==f&&(d+=f),S.indexOf(d)===0}function r(S){return S>=65&&S<=90||S>=97&&S<=122}function n(S,d){return T.$i&&S.endsWith(":")&&(S+=I.sep),(0,I.$jc)(S)||(S=(0,I.$kc)(d,S)),S=(0,I.$ic)(S),T.$i?(S=(0,R.$bf)(S,I.sep),S.endsWith(":")&&(S+=I.sep)):(S=(0,R.$bf)(S,I.sep),S||(S=I.sep)),S}function t(S){const d=(0,I.$ic)(S);return T.$i?S.length>3?!1:c(d)&&(S.length===2||d.charCodeAt(2)===92):d===I.$hc.sep}function c(S,d=T.$i){return d?r(S.charCodeAt(0))&&S.charCodeAt(1)===58:!1}function h(S,d=T.$i){return c(S,d)?S[0]:void 0}function i(S,d,D){return d.length>S.length?-1:S===d?0:(D&&(S=S.toLowerCase(),d=d.toLowerCase()),S.indexOf(d))}function b(S){const d=S.split(":");let D,f,E;for(const w of d){const P=Number(w);(0,O.$8f)(P)?f===void 0?f=P:E===void 0&&(E=P):D=D?[D,w].join(":"):w}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:f!==void 0?f:void 0,column:E!==void 0?E:f!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",$="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(S,d,D=8){let f="";for(let w=0;w<D;w++){let P;w===0&&T.$i&&!d&&(D===3||D===4)?P=$:P=a,f+=P.charAt(Math.floor(Math.random()*P.length))}let E;return d?E=`${d}-${f}`:E=f,S?(0,I.$kc)(S,E):E}}),define(Re[69],Ae([1,0,19]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Is=O,e.$Js=M,e.$Ks=p,e.$Ls=k,e.$Hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(N){const y=(0,I.$pc)(N),u=T[y.toLowerCase()];return u!==void 0?u:M(N)}function M(N){const y=(0,I.$pc)(N);return R[y.toLowerCase()]}function p(N){for(const y in R)if(R[y]===N)return y}const g=/^(.+)\/(.+?)(;.+)?$/;function k(N,y){const u=g.exec(N);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:N}}),define(Re[53],Ae([1,0,23,2]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=R,e.$Yh=O,e.$Zh=p;function R(g){return JSON.stringify(g,M)}function O(g){let k=JSON.parse(g);return k=p(k),k}function M(g,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function p(g,k=0){if(!g||k>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return T.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof I.$Ce||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let N=0;N<g.length;++N)g[N]=p(g[N],k+1);else for(const N in g)Object.hasOwnProperty.call(g,N)&&(g[N]=p(g[N],k+1))}return g}}),define(Re[12],Ae([1,0,14,21,15,2,19]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Dg=e.$Cg=e.$Bg=e.Schemas=void 0,e.$zg=g,e.$Ag=k,e.$Eg=y;var p;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.commentsInput="comment",m.codeSetting="code-setting"})(p||(e.Schemas=p={}));function g(m,s){return O.URI.isUri(m)?(0,R.$tf)(m.scheme,s):(0,R.$uf)(m,s+":")}function k(m,...s){return s.some(o=>g(m,o))}e.$Bg="vscode-tkn",e.$Cg="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,o){this.f=y(s,o)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,p.vscodeRemoteResource)}set(s,o,r){this.a[s]=o,this.b[s]=r}setConnectionToken(s,o){this.c[s]=o}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(h){return I.$1(h),s}const o=s.authority;let r=this.a[o];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const n=this.b[o],t=this.c[o];let c=`path=${encodeURIComponent(s.path)}`;return typeof t=="string"&&(c+=`&${e.$Cg}=${encodeURIComponent(t)}`),O.URI.from({scheme:T.$o?this.d:p.vscodeRemoteResource,authority:`${r}:${n}`,path:this.g,query:c})}}e.$Dg=new N;function y(m,s){return M.$hc.join(s??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$Fg="vs/../../extensions",e.$Gg="vs/../../node_modules",e.$Hg="vs/../../node_modules.asar",e.$Ig="vs/../../node_modules.asar.unpacked",e.$Jg="vscode-app";class u{static{this.a=e.$Jg}asBrowserUri(s){const o=this.b(s,ge);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===p.vscodeRemote?e.$Dg.rewrite(s):s.scheme===p.file&&(T.$m||T.$q===`${p.vscodeFileResource}://${u.a}`)?s.with({scheme:p.vscodeFileResource,authority:s.authority||u.a,query:null,fragment:null}):s}asFileUri(s){const o=this.b(s,ge);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===p.vscodeFileResource?s.with({scheme:p.file,authority:s.authority!==u.a?s.authority:null,query:null,fragment:null}):s}b(s,o){return O.URI.isUri(s)?s:O.URI.parse(o.toUrl(s))}}e.$Kg=new u;var v;(function(m){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function r(t){let c;typeof t=="string"?c=new URL(t).searchParams:t instanceof URL?c=t.searchParams:O.URI.isUri(t)&&(c=new URL(t.toString(!0)).searchParams);const h=c?.get(o);if(h)return s.get(h)}m.getHeadersFromQuery=r;function n(t,c,h){if(!globalThis.crossOriginIsolated)return;const i=c&&h?"3":h?"2":"1";t instanceof URLSearchParams?t.set(o,i):t[o]=i}m.addSearchParam=n})(v||(e.COI=v={}))}),define(Re[24],Ae([1,0,47,12,19,21,15,2]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0,e.$Rg=g,e.$ah=N,e.$bh=u;function g(v){return(0,p.$xc)(v,!0)}class k{constructor(m){this.a=m}compare(m,s,o=!1){return m===s?0:(0,M.$mf)(this.getComparisonKey(m,o),this.getComparisonKey(s,o))}isEqual(m,s,o=!1){return m===s?!0:!m||!s?!1:this.getComparisonKey(m,o)===this.getComparisonKey(s,o)}getComparisonKey(m,s=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,s,o=!1){if(m.scheme===s.scheme){if(m.scheme===T.Schemas.file)return I.$qg(g(m),g(s),this.a(m))&&m.query===s.query&&(o||m.fragment===s.fragment);if((0,e.$9g)(m.authority,s.authority))return I.$qg(m.path,s.path,this.a(m),"/")&&m.query===s.query&&(o||m.fragment===s.fragment)}return!1}joinPath(m,...s){return p.URI.joinPath(m,...s)}basenameOrAuthority(m){return(0,e.$1g)(m)||m.authority}basename(m){return R.$hc.basename(m.path)}extname(m){return R.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let s;return m.scheme===T.Schemas.file?s=p.URI.file(R.$nc(g(m))).path:(s=R.$hc.dirname(m.path),m.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),s="/")),m.with({path:s})}normalizePath(m){if(!m.path.length)return m;let s;return m.scheme===T.Schemas.file?s=p.URI.file(R.$ic(g(m))).path:s=R.$hc.normalize(m.path),m.with({path:s})}relativePath(m,s){if(m.scheme!==s.scheme||!(0,e.$9g)(m.authority,s.authority))return;if(m.scheme===T.Schemas.file){const n=R.$mc(g(m),g(s));return O.$i?I.$kg(n):n}let o=m.path||"/";const r=s.path||"/";if(this.a(m)){let n=0;for(const t=Math.min(o.length,r.length);n<t&&!(o.charCodeAt(n)!==r.charCodeAt(n)&&o.charAt(n).toLowerCase()!==r.charAt(n).toLowerCase());n++);o=r.substr(0,n)+o.substr(n)}return R.$hc.relative(o,r)}resolvePath(m,s){if(m.scheme===T.Schemas.file){const o=p.URI.file(R.$lc(g(m),s));return m.with({authority:o.authority,path:o.path})}return s=I.$lg(s),m.with({path:R.$hc.resolve(m.path,s)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,s){return m===s||m!==void 0&&s!==void 0&&(0,M.$tf)(m,s)}hasTrailingPathSeparator(m,s=R.sep){if(m.scheme===T.Schemas.file){const o=g(m);return o.length>I.$mg(o).length&&o[o.length-1]===s}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,s=R.sep){return(0,e.$0g)(m,s)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,s=R.sep){let o=!1;if(m.scheme===T.Schemas.file){const r=g(m);o=r!==void 0&&r.length===I.$mg(r).length&&r[r.length-1]===s}else{s="/";const r=m.path;o=r.length===1&&r.charCodeAt(r.length-1)===47}return!o&&!(0,e.$0g)(m,s)?m.with({path:m.path+"/"}):m}}e.$Sg=k,e.$Tg=new k(()=>!1),e.$Ug=new k(v=>v.scheme===T.Schemas.file?!O.$k:!0),e.$Vg=new k(v=>!0),e.$Wg=e.$Tg.isEqual.bind(e.$Tg),e.$Xg=e.$Tg.isEqualOrParent.bind(e.$Tg),e.$Yg=e.$Tg.getComparisonKey.bind(e.$Tg),e.$Zg=e.$Tg.basenameOrAuthority.bind(e.$Tg),e.$1g=e.$Tg.basename.bind(e.$Tg),e.$2g=e.$Tg.extname.bind(e.$Tg),e.$3g=e.$Tg.dirname.bind(e.$Tg),e.$4g=e.$Tg.joinPath.bind(e.$Tg),e.$5g=e.$Tg.normalizePath.bind(e.$Tg),e.$6g=e.$Tg.relativePath.bind(e.$Tg),e.$7g=e.$Tg.resolvePath.bind(e.$Tg),e.$8g=e.$Tg.isAbsolutePath.bind(e.$Tg),e.$9g=e.$Tg.isEqualAuthority.bind(e.$Tg),e.$0g=e.$Tg.hasTrailingPathSeparator.bind(e.$Tg),e.$$g=e.$Tg.removeTrailingPathSeparator.bind(e.$Tg),e.$_g=e.$Tg.addTrailingPathSeparator.bind(e.$Tg);function N(v,m){const s=[];for(let o=0;o<v.length;o++){const r=m(v[o]);v.some((n,t)=>t===o?!1:(0,e.$Xg)(r,m(n)))||s.push(v[o])}return s}var y;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function m(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(t=>{const[c,h]=t.split(":");c&&h&&o.set(c,h)});const n=s.path.substring(0,s.path.indexOf(";"));return n&&o.set(v.META_DATA_MIME,n),o}v.parseMetaData=m})(y||(e.DataUri=y={}));function u(v,m,s){if(m){let o=v.path;return o&&o[0]!==R.$hc.sep&&(o=R.$hc.sep+o),v.with({scheme:s,authority:m,path:o})}return v.with({scheme:s})}}),define(Re[11],Ae([1,0,22,14,5,6,24,21,130,41]),function(ge,e,I,T,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.Promises=e.$Nh=e.$Mh=e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0,e.$ch=N,e.$dh=y,e.$eh=u,e.$fh=v,e.$gh=m,e.$hh=s,e.$ih=o,e.$jh=r,e.$rh=S,e.$sh=d,e.$th=D,e.$uh=f,e.$vh=E,e.$Kh=Ie,e.$Sh=ke;function N(fe){return!!fe&&typeof fe.then=="function"}function y(fe){const J=new I.$me,Y=fe(J.token),he=new Promise((le,Te)=>{const de=J.token.onCancellationRequested(()=>{de.dispose(),Te(new T.$5)});Promise.resolve(Y).then(Pe=>{de.dispose(),J.dispose(),le(Pe)},Pe=>{de.dispose(),J.dispose(),Te(Pe)})});return new class{cancel(){J.cancel(),J.dispose()}then(le,Te){return he.then(le,Te)}catch(le){return this.then(void 0,le)}finally(le){return he.finally(le)}}}function u(fe,J,Y){return new Promise((he,le)=>{const Te=J.onCancellationRequested(()=>{Te.dispose(),he(Y)});fe.then(he,le).finally(()=>Te.dispose())})}function v(fe,J){return new Promise((Y,he)=>{const le=J.onCancellationRequested(()=>{le.dispose(),he(new T.$5)});fe.then(Y,he).finally(()=>le.dispose())})}async function m(fe){let J=-1;const Y=fe.map((he,le)=>he.then(Te=>(J=le,Te)));try{return await Promise.race(Y)}finally{fe.forEach((he,le)=>{le!==J&&he.cancel()})}}function s(fe,J,Y){let he;const le=setTimeout(()=>{he?.(void 0),Y?.()},J);return Promise.race([fe.finally(()=>clearTimeout(le)),new Promise(Te=>he=Te)])}function o(fe){return new Promise((J,Y)=>{const he=fe();N(he)?he.then(J,Y):J(he)})}function r(){let fe,J;return{promise:new Promise((he,le)=>{fe=he,J=le}),resolve:fe,reject:J}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=J(),new Promise((Y,he)=>{this.a.then(le=>{this.a=null,Y(le)},le=>{this.a=null,he(le)})})}dispose(){this.f=!0}}e.$kh=n;class t{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$lh=t;class c{constructor(){this.a=new Map}queue(J,Y){const le=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(J)===le&&this.a.delete(J)});return this.a.set(J,le),le}}e.$mh=c;const h=(fe,J)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,J()},fe);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},i=fe=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,fe())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class b{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,Y=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((le,Te)=>{this.d=le,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const le=this.g;return this.g=null,le()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===g.$$d?i(he):h(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$nh=b;class a{constructor(J){this.a=new b(J),this.b=new n}trigger(J,Y){return this.a.trigger(()=>this.b.queue(J),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$oh=a;class ${constructor(){this.a=!1,this.b=new Promise((J,Y)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ph=$;class l extends ${constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$qh=l;function S(fe,J){return J?new Promise((Y,he)=>{const le=setTimeout(()=>{Te.dispose(),Y()},fe),Te=J.onCancellationRequested(()=>{clearTimeout(le),Te.dispose(),he(new T.$5)})}):y(Y=>S(fe,Y))}function d(fe,J=0,Y){const he=setTimeout(()=>{fe(),Y&&le.dispose()},J),le=(0,O.$Sc)(()=>{clearTimeout(he),Y?.deleteAndLeak(le)});return Y?.add(le),le}function D(fe){const J=[];let Y=0;const he=fe.length;function le(){return Y<he?fe[Y++]():null}function Te(de){de!=null&&J.push(de);const Pe=le();return Pe?Pe.then(Te):Promise.resolve(J)}return Promise.resolve(null).then(Te)}function f(fe,J=he=>!!he,Y=null){let he=0;const le=fe.length,Te=()=>{if(he>=le)return Promise.resolve(Y);const de=fe[he++];return Promise.resolve(de()).then(Me=>J(Me)?Promise.resolve(Me):Te())};return Te()}function E(fe,J=he=>!!he,Y=null){if(fe.length===0)return Promise.resolve(Y);let he=fe.length;const le=()=>{he=-1;for(const Te of fe)Te.cancel?.()};return new Promise((Te,de)=>{for(const Pe of fe)Pe.then(Me=>{--he>=0&&J(Me)?(le(),Te(Me)):he===0&&Te(Y)}).catch(Me=>{--he>=0&&(le(),de(Me))})})}class w{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new R.$be}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:J,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const Y=J.factory();Y.then(J.c,J.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$wh=w;class P extends w{constructor(){super(1)}}e.$xh=P;class C{constructor(){this.a=new ue,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$yh=C;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new Ce;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,Y=M.$Tg){const he=Y.getComparisonKey(J);return this.a.get(he)?.size??0}queueFor(J,Y,he=M.$Tg){const le=he.getComparisonKey(J);let Te=this.a.get(le);if(!Te){Te=new P;const de=this.f++,Pe=R.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(le),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(de,Pe),this.a.set(le,Te)}return Te.queue(Y)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$zh=V;class W{constructor(J,Y){this.a=-1,typeof J=="function"&&typeof Y=="number"&&this.setIfNotSet(J,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},Y)}setIfNotSet(J,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},Y))}}e.$Ah=W;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,Y,he=globalThis){this.cancel();const le=he.setInterval(()=>{J()},Y);this.d=(0,O.$Sc)(()=>{he.clearInterval(le),this.d=void 0})}dispose(){this.cancel()}}e.$Bh=q;class A{constructor(J,Y){this.b=-1,this.a=J,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ch=A;class U{constructor(J,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=J,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dh=U;class K extends A{constructor(J,Y){super(J,Y),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Eh=K;class se extends O.$Uc{constructor(J,Y){super(),this.g=J,this.h=Y,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of J)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fh=se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Hh=(fe,J)=>{(0,p.$B)(()=>{if(Y)return;const he=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Hh=(fe,J,Y)=>{const he=fe.requestIdleCallback(J,typeof Y=="number"?{timeout:Y}:void 0);let le=!1;return{dispose(){le||(le=!0,fe.cancelIdleCallback(he))}}},e.$Gh=fe=>(0,e.$Hh)(globalThis,fe)}();class ce{constructor(J,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Hh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ih=ce;class ve extends ce{constructor(J){super(globalThis,J)}}e.$Jh=ve;async function Ie(fe,J,Y){let he;for(let le=0;le<Y;le++)try{return await fe()}catch(Te){he=Te,await S(J)}throw he}class ue{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,Y,he){return this.a={taskId:J,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(J),()=>this.d(J)),Y}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:Y,resolve:he,reject:le}=r();this.b={run:J,promise:Y,promiseResolve:he,promiseReject:le}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lh=ue;class be{constructor(J,Y=()=>Date.now()){this.d=J,this.f=Y,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Mh=be;var ie;(function(fe){fe[fe.Resolved=0]="Resolved",fe[fe.Rejected=1]="Rejected"})(ie||(ie={}));class Ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,Y)=>{this.a=J,this.b=Y})}complete(J){return new Promise(Y=>{this.a(J),this.d={outcome:0,value:J},Y()})}error(J){return new Promise(Y=>{this.b(J),this.d={outcome:1,value:J},Y()})}cancel(){return this.error(new T.$5)}}e.$Nh=Ce;var Fe;(function(fe){async function J(he){let le;const Te=await Promise.all(he.map(de=>de.then(Pe=>Pe,Pe=>{le||(le=Pe)})));if(typeof le<"u")throw le;return Te}fe.settled=J;function Y(he){return new Promise(async(le,Te)=>{try{await he(le,Te)}catch(de){Te(de)}})}fe.withAsyncBody=Y})(Fe||(e.Promises=Fe={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Oh=ne;class j{constructor(J){this.b=J,this.a=new k.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Ph=j;var x;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(x||(x={}));class pe{static fromArray(J){return new pe(Y=>{Y.emitMany(J)})}static fromPromise(J){return new pe(async Y=>{Y.emitMany(await J)})}static fromPromises(J){return new pe(async Y=>{await Promise.all(J.map(async he=>Y.emitOne(await he)))})}static merge(J){return new pe(async Y=>{await Promise.all(J.map(async he=>{for await(const le of he)Y.emitOne(le)}))})}static{this.EMPTY=pe.fromArray([])}constructor(J,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new R.$be,queueMicrotask(async()=>{const he={emitOne:le=>this.h(le),emitMany:le=>this.j(le),reject:le=>this.l(le)};try{await Promise.resolve(J(he)),this.k()}catch(le){this.l(le)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,Y){return new pe(async he=>{for await(const le of J)he.emitOne(Y(le))})}map(J){return pe.map(this,J)}static filter(J,Y){return new pe(async he=>{for await(const le of J)Y(le)&&he.emitOne(le)})}filter(J){return pe.filter(this,J)}static coalesce(J){return pe.filter(J,Y=>!!Y)}coalesce(){return pe.coalesce(this)}static async toPromise(J){const Y=[];for await(const he of J)Y.push(he);return Y}toPromise(){return pe.toPromise(this)}h(J){this.a===0&&(this.b.push(J),this.g.fire())}j(J){this.a===0&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(J){this.a===0&&(this.a=2,this.d=J,this.g.fire())}}e.$Qh=pe;class Oe extends pe{constructor(J,Y){super(Y),this.m=J}cancel(){this.m.cancel()}}e.$Rh=Oe;function ke(fe){const J=new I.$me,Y=fe(J.token);return new Oe(J,async he=>{const le=J.token.onCancellationRequested(()=>{le.dispose(),J.dispose(),he.reject(new T.$5)});try{for await(const Te of Y){if(J.token.isCancellationRequested)return;he.emitOne(Te)}le.dispose(),J.dispose()}catch(Te){le.dispose(),J.dispose(),he.reject(Te)}})}class $e{constructor(J){this.a=new Ce,this.b=new pe(le=>{if(Y){le.reject(Y);return}return he&&le.emitMany(he),this.d=Te=>le.reject(Te),this.f=Te=>le.emitOne(Te),this.a.p},J);let Y,he;this.f=le=>{he||(he=[]),he.push(le)},this.d=le=>{Y||(Y=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Th=$e}),define(Re[36],Ae([1,0,18,11,47,28,19,21,15]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$fk=k,e.$ik=m,e.$jk=P,e.$kk=C,e.$lk=V,e.$mk=W,e.$nk=q,e.$ok=se;function k(){return Object.create(null)}e.$gk="**",e.$hk="/";const N="[/\\\\]",y="[^/\\\\]",u=/\//g;function v(ce,ve){switch(ce){case 0:return"";case 1:return`${y}*?`;default:return`(?:${N}|${y}+${N}${ve?`|${N}${y}+`:""})*?`}}function m(ce,ve){if(!ce)return[];const Ie=[];let ue=!1,be=!1,ie="";for(const Ce of ce){switch(Ce){case ve:if(!ue&&!be){Ie.push(ie),ie="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":be=!0;break;case"]":be=!1;break}ie+=Ce}return ie&&Ie.push(ie),Ie}function s(ce){if(!ce)return"";let ve="";const Ie=m(ce,e.$hk);if(Ie.every(ue=>ue===e.$gk))ve=".*";else{let ue=!1;Ie.forEach((be,ie)=>{if(be===e.$gk){if(ue)return;ve+=v(2,ie===Ie.length-1)}else{let Ce=!1,Fe="",ne=!1,j="";for(const x of be){if(x!=="}"&&Ce){Fe+=x;continue}if(ne&&(x!=="]"||!j)){let pe;x==="-"?pe=x:(x==="^"||x==="!")&&!j?pe="^":x===e.$hk?pe="":pe=(0,g.$8e)(x),j+=pe;continue}switch(x){case"{":Ce=!0;continue;case"[":ne=!0;continue;case"}":{const Oe=`(?:${m(Fe,",").map(ke=>s(ke)).join("|")})`;ve+=Oe,Ce=!1,Fe="";break}case"]":{ve+="["+j+"]",ne=!1,j="";break}case"?":ve+=y;continue;case"*":ve+=v(1);continue;default:ve+=(0,g.$8e)(x)}}ie<Ie.length-1&&(Ie[ie+1]!==e.$gk||ie+2<Ie.length)&&(ve+=N)}ue=be===e.$gk})}return ve}const o=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,t=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new O.$Ec(1e4),b=function(){return!1},a=function(){return null};function $(ce,ve){if(!ce)return a;let Ie;typeof ce!="string"?Ie=ce.pattern:Ie=ce,Ie=Ie.trim();const ue=`${Ie}_${!!ve.trimForExclusions}`;let be=i.get(ue);if(be)return l(be,ce);let ie;return o.test(Ie)?be=d(Ie.substr(4),Ie):(ie=r.exec(S(Ie,ve)))?be=D(ie[1],Ie):(ve.trimForExclusions?t:n).test(Ie)?be=f(Ie,ve):(ie=c.exec(S(Ie,ve)))?be=E(ie[1].substr(1),Ie,!0):(ie=h.exec(S(Ie,ve)))?be=E(ie[1],Ie,!1):be=w(Ie),i.set(ue,be),l(be,ce)}function l(ce,ve){if(typeof ve=="string")return ce;const Ie=function(ue,be){return(0,R.$qg)(ue,ve.base,!p.$k)?ce((0,g.$af)(ue.substr(ve.base.length),M.sep),be):null};return Ie.allBasenames=ce.allBasenames,Ie.allPaths=ce.allPaths,Ie.basenames=ce.basenames,Ie.patterns=ce.patterns,Ie}function S(ce,ve){return ve.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function d(ce,ve){return function(Ie,ue){return typeof Ie=="string"&&Ie.endsWith(ce)?ve:null}}function D(ce,ve){const Ie=`/${ce}`,ue=`\\${ce}`,be=function(Ce,Fe){return typeof Ce!="string"?null:Fe?Fe===ce?ve:null:Ce===ce||Ce.endsWith(Ie)||Ce.endsWith(ue)?ve:null},ie=[ce];return be.basenames=ie,be.patterns=[ve],be.allBasenames=ie,be}function f(ce,ve){const Ie=K(ce.slice(1,-1).split(",").map(Fe=>$(Fe,ve)).filter(Fe=>Fe!==a),ce),ue=Ie.length;if(!ue)return a;if(ue===1)return Ie[0];const be=function(Fe,ne){for(let j=0,x=Ie.length;j<x;j++)if(Ie[j](Fe,ne))return ce;return null},ie=Ie.find(Fe=>!!Fe.allBasenames);ie&&(be.allBasenames=ie.allBasenames);const Ce=Ie.reduce((Fe,ne)=>ne.allPaths?Fe.concat(ne.allPaths):Fe,[]);return Ce.length&&(be.allPaths=Ce),be}function E(ce,ve,Ie){const ue=M.sep===M.$hc.sep,be=ue?ce:ce.replace(u,M.sep),ie=M.sep+be,Ce=M.$hc.sep+ce;let Fe;return Ie?Fe=function(ne,j){return typeof ne=="string"&&(ne===be||ne.endsWith(ie)||!ue&&(ne===ce||ne.endsWith(Ce)))?ve:null}:Fe=function(ne,j){return typeof ne=="string"&&(ne===be||!ue&&ne===ce)?ve:null},Fe.allPaths=[(Ie?"*/":"./")+ce],Fe}function w(ce){try{const ve=new RegExp(`^${s(ce)}$`);return function(Ie){return ve.lastIndex=0,typeof Ie=="string"&&ve.test(Ie)?ce:null}}catch{return a}}function P(ce,ve,Ie){return!ce||typeof ve!="string"?!1:C(ce)(ve,void 0,Ie)}function C(ce,ve={}){if(!ce)return b;if(typeof ce=="string"||V(ce)){const Ie=$(ce,ve);if(Ie===a)return b;const ue=function(be,ie){return!!Ie(be,ie)};return Ie.allBasenames&&(ue.allBasenames=Ie.allBasenames),Ie.allPaths&&(ue.allPaths=Ie.allPaths),ue}return A(ce,ve)}function V(ce){const ve=ce;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}function W(ce){return ce.allBasenames||[]}function q(ce){return ce.allPaths||[]}function A(ce,ve){const Ie=K(Object.getOwnPropertyNames(ce).map(Fe=>U(Fe,ce[Fe],ve)).filter(Fe=>Fe!==a)),ue=Ie.length;if(!ue)return a;if(!Ie.some(Fe=>!!Fe.requiresSiblings)){if(ue===1)return Ie[0];const Fe=function(x,pe){let Oe;for(let ke=0,$e=Ie.length;ke<$e;ke++){const fe=Ie[ke](x,pe);if(typeof fe=="string")return fe;(0,T.$ch)(fe)&&(Oe||(Oe=[]),Oe.push(fe))}return Oe?(async()=>{for(const ke of Oe){const $e=await ke;if(typeof $e=="string")return $e}return null})():null},ne=Ie.find(x=>!!x.allBasenames);ne&&(Fe.allBasenames=ne.allBasenames);const j=Ie.reduce((x,pe)=>pe.allPaths?x.concat(pe.allPaths):x,[]);return j.length&&(Fe.allPaths=j),Fe}const be=function(Fe,ne,j){let x,pe;for(let Oe=0,ke=Ie.length;Oe<ke;Oe++){const $e=Ie[Oe];$e.requiresSiblings&&j&&(ne||(ne=(0,M.$oc)(Fe)),x||(x=ne.substr(0,ne.length-(0,M.$pc)(Fe).length)));const fe=$e(Fe,ne,x,j);if(typeof fe=="string")return fe;(0,T.$ch)(fe)&&(pe||(pe=[]),pe.push(fe))}return pe?(async()=>{for(const Oe of pe){const ke=await Oe;if(typeof ke=="string")return ke}return null})():null},ie=Ie.find(Fe=>!!Fe.allBasenames);ie&&(be.allBasenames=ie.allBasenames);const Ce=Ie.reduce((Fe,ne)=>ne.allPaths?Fe.concat(ne.allPaths):Fe,[]);return Ce.length&&(be.allPaths=Ce),be}function U(ce,ve,Ie){if(ve===!1)return a;const ue=$(ce,Ie);if(ue===a)return a;if(typeof ve=="boolean")return ue;if(ve){const be=ve.when;if(typeof be=="string"){const ie=(Ce,Fe,ne,j)=>{if(!j||!ue(Ce,Fe))return null;const x=be.replace("$(basename)",()=>ne),pe=j(x);return(0,T.$ch)(pe)?pe.then(Oe=>Oe?ce:null):pe?ce:null};return ie.requiresSiblings=!0,ie}}return ue}function K(ce,ve){const Ie=ce.filter(Fe=>!!Fe.basenames);if(Ie.length<2)return ce;const ue=Ie.reduce((Fe,ne)=>{const j=ne.basenames;return j?Fe.concat(j):Fe},[]);let be;if(ve){be=[];for(let Fe=0,ne=ue.length;Fe<ne;Fe++)be.push(ve)}else be=Ie.reduce((Fe,ne)=>{const j=ne.patterns;return j?Fe.concat(j):Fe},[]);const ie=function(Fe,ne){if(typeof Fe!="string")return null;if(!ne){let x;for(x=Fe.length;x>0;x--){const pe=Fe.charCodeAt(x-1);if(pe===47||pe===92)break}ne=Fe.substr(x)}const j=ue.indexOf(ne);return j!==-1?be[j]:null};ie.basenames=ue,ie.patterns=be,ie.allBasenames=ue;const Ce=ce.filter(Fe=>!Fe.basenames);return Ce.push(ie),Ce}function se(ce,ve){return(0,I.$ub)(ce,ve,(Ie,ue)=>typeof Ie=="string"&&typeof ue=="string"?Ie===ue:typeof Ie!="string"&&typeof ue!="string"?Ie.base===ue.base&&Ie.pattern===ue.pattern:!1)}}),define(Re[54],Ae([1,0,14,131,24,15,2]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.MarkdownStringTextNewlineStyle=void 0,e.$Ok=k,e.$Pk=N,e.$Qk=y,e.$Rk=u,e.$Sk=v,e.$Tk=m,e.$Uk=s,e.$Vk=o;var p;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class g{constructor(n="",t=!1){if(this.value=n,typeof this.value!="string")throw(0,I.$7)("value");typeof t=="boolean"?(this.isTrusted=t,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=t.isTrusted??void 0,this.supportThemeIcons=t.supportThemeIcons??!1,this.supportHtml=t.supportHtml??!1)}appendText(n,t=0){return this.value+=u(this.supportThemeIcons?(0,T.$Hk)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,t===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,t){return this.value+=`
${v(t,n)}
`,this}appendLink(n,t,c){return this.value+="[",this.value+=this.c(t,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,t){const c=new RegExp((0,O.$8e)(t),"g");return n.replace(c,(h,i)=>n.charAt(i-1)!=="\\"?`\\${h}`:h)}}e.$Nk=g;function k(r){return N(r)?!r.value:Array.isArray(r)?r.every(k):!0}function N(r){return r instanceof g?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}function y(r,n){return r===n?!0:!r||!n?!1:r.value===n.value&&r.isTrusted===n.isTrusted&&r.supportThemeIcons===n.supportThemeIcons&&r.supportHtml===n.supportHtml&&(r.baseUri===n.baseUri||!!r.baseUri&&!!n.baseUri&&(0,R.$Wg)(M.URI.from(r.baseUri),M.URI.from(n.baseUri)))}function u(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function v(r,n){const t=r.match(/^`+/gm)?.reduce((h,i)=>h.length>i.length?h:i).length??0,c=t>=3?t+1:3;return[`${"`".repeat(c)}${n}`,r,`${"`".repeat(c)}`].join(`
`)}function m(r){return r.replace(/"/g,"&quot;")}function s(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(r){const n=[],t=r.split("|").map(h=>h.trim());r=t[0];const c=t[1];if(c){const h=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),b=h?h[1]:"",a=i?i[1]:"",$=isFinite(parseInt(a)),l=isFinite(parseInt(b));$&&n.push(`width="${a}"`),l&&n.push(`height="${b}"`)}return{href:r,dimensions:n}}}),define(Re[96],Ae([1,0,18,47,19,21,24,15]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=g,e.$pw=N,e.$qw=u,e.$rw=v,e.$sw=r,e.$tw=t,e.$uw=c,e.$vw=h,e.$ww=i,e.$xw=b;function g($,l){const{os:S,tildify:d,relative:D}=l;if(D){const w=k($,D,S);if(typeof w=="string")return w}let f=$.fsPath;if(S===1&&!O.$i?f=f.replace(/\//g,"\\"):S!==1&&O.$i&&(f=f.replace(/\\/g,"/")),S!==1&&d?.userHome){const w=d.userHome.fsPath;let P;$.scheme!==d.userHome.scheme&&$.path[0]===R.$hc.sep&&$.path[1]!==R.$hc.sep?P=d.userHome.with({path:$.path}).fsPath:P=f,f=u(P,w,S)}return(S===1?R.$gc:R.$hc).normalize(N(f,S===1))}function k($,l,S){const d=S===1?R.$gc:R.$hc,D=S===3?M.$Tg:M.$Vg,f=l.getWorkspace(),E=(0,I.$Ob)(f.folders);if(!E)return;$.scheme!==E.uri.scheme&&$.path[0]===R.$hc.sep&&$.path[1]!==R.$hc.sep&&($=E.uri.with({path:$.path}));const w=l.getWorkspaceFolder($);if(!w)return;let P;if(D.isEqual(w.uri,$)?P="":P=D.relativePath(w.uri,$)??"",P&&(P=d.normalize(P)),f.folders.length>1&&!l.noPrefix){const C=w.name?w.name:D.basenameOrAuthority(w.uri);P=P?`${C} \u2022 ${P}`:C}return P}function N($,l=O.$i){return(0,T.$ug)($,l)?$.charAt(0).toUpperCase()+$.slice(1):$}let y=Object.create(null);function u($,l,S=O.OS){if(S===1||!$||!l)return $;let d=y.original===l?y.normalized:void 0;d||(d=l,O.$i&&(d=(0,T.$kg)(d)),d=`${(0,p.$bf)(d,R.$hc.sep)}${R.$hc.sep}`,y={original:l,normalized:d});let D=$;return O.$i&&(D=(0,T.$kg)(D)),(S===3?D.startsWith(d):(0,p.$uf)(D,d))?`~/${D.substr(d.length)}`:$}function v($,l){return $.replace(/^~($|\/|\\)/,`${l}$1`)}const m="\u2026",s="\\\\",o="~";function r($,l=R.sep){const S=new Array($.length);let d=!1;for(let D=0;D<$.length;D++){const f=$[D];if(f===""){S[D]=`.${l}`;continue}if(!f){S[D]=f;continue}d=!0;let E="",w=f;w.indexOf(s)===0?(E=w.substr(0,w.indexOf(s)+s.length),w=w.substr(w.indexOf(s)+s.length)):w.indexOf(l)===0?(E=w.substr(0,w.indexOf(l)+l.length),w=w.substr(w.indexOf(l)+l.length)):w.indexOf(o)===0&&(E=w.substr(0,w.indexOf(o)+o.length),w=w.substr(w.indexOf(o)+o.length));const P=w.split(l);for(let C=1;d&&C<=P.length;C++)for(let V=P.length-C;d&&V>=0;V--){d=!1;let W=P.slice(V,V+C).join(l);for(let q=0;!d&&q<$.length;q++)if(q!==D&&$[q]&&$[q].indexOf(W)>-1){const A=V+C===P.length,U=V>0&&$[q].indexOf(l)>-1?l+W:W,K=$[q].endsWith(U);d=!A||K}if(!d){let q="";(P[0].endsWith(":")||E!=="")&&(V===1&&(V=0,C++,W=P[0]+l+W),V>0&&(q=P[0]+l),q=E+q),V>0&&(q=q+m+l),q=q+W,V+C<P.length&&(q=q+l+m),S[D]=q}}d&&(S[D]=f)}return S}var n;(function($){$[$.TEXT=0]="TEXT",$[$.VARIABLE=1]="VARIABLE",$[$.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function t($,l=Object.create(null)){const S=[];let d=!1,D="";for(const f of $)if(f==="$"||d&&f==="{")D&&S.push({value:D,type:n.TEXT}),D="",d=!0;else if(f==="}"&&d){const E=l[D];if(typeof E=="string")E.length&&S.push({value:E,type:n.VARIABLE});else if(E){const w=S[S.length-1];(!w||w.type!==n.SEPARATOR)&&S.push({value:E.label,type:n.SEPARATOR})}D="",d=!1}else D+=f;return D&&!d&&S.push({value:D,type:n.TEXT}),S.filter((f,E)=>{if(f.type===n.SEPARATOR){const w=S[E-1],P=S[E+1];return[w,P].every(C=>C&&(C.type===n.VARIABLE||C.type===n.TEXT)&&C.value.length>0)}return!0}).map(f=>f.value).join("")}function c($,l){return O.$j||l?$.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):$.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function h($,l){return O.$j||l?$.replace(/\(&&\w\)|&&/g,""):O.$i?$.replace(/&&|&/g,S=>S==="&"?"&&":"&"):$.replace(/&&/g,"_")}function i($){return $.replace(/&/g,"&&")}function b($){if($.endsWith("]")){const l=$.lastIndexOf(" [",$.length-2);if(l!==-1){const S=a($.substring(0,l)),d=$.substring(l);return{name:S.name+d,parentPath:S.parentPath}}}return a($)}function a($){const l=$.indexOf("/")!==-1?R.$hc:R.$gc,S=l.basename($),d=l.dirname($);return S.length?{name:S,parentPath:d}:{name:d,parentPath:""}}}),define(Re[144],Ae([1,0,23,2]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0,e.$un=p,e.$vn=k,e.$wn=N;function R(y){return y.toJSON()}class O{constructor(u){this.a=u}transformIncoming(u){const v=this.a.transformIncoming(u);return v===u?u:R(T.URI.from(v))}transformOutgoing(u){const v=this.a.transformOutgoing(u);return v===u?u:R(T.URI.from(v))}transformOutgoingURI(u){const v=this.a.transformOutgoing(u);return v===u?u:T.URI.from(v)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$sn=O,e.$tn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function M(y,u,v){if(!y||v>200)return null;if(typeof y=="object"){if(y instanceof T.URI)return u.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const s=M(y[m],u,v+1);s!==null&&(y[m]=s)}}return null}function p(y,u){const v=M(y,u,0);return v===null?y:v}function g(y,u,v,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return v?T.URI.revive(u.transformIncoming(y)):u.transformIncoming(y);if(y instanceof I.$Ce)return null;for(const s in y)if(Object.hasOwnProperty.call(y,s)){const o=g(y[s],u,v,m+1);o!==null&&(y[s]=o)}}return null}function k(y,u){const v=g(y,u,!1,0);return v===null?y:v}function N(y,u){const v=g(y,u,!0,0);return v===null?y:v}}),define(Re[145],Ae([1,0,15,21,23]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$tt=N,e.$ut=y;let O;function M(){return O||(O=new TextDecoder("UTF-16LE")),O}let p;function g(){return p||(p=new TextDecoder("UTF-16BE")),p}let k;function N(){return k||(k=T.$D()?M():g()),k}function y(m,s,o){const r=new Uint16Array(m.buffer,s,o);return o>0&&(r[0]===65279||r[0]===65534)?u(m,s,o):M().decode(r)}function u(m,s,o){const r=[];let n=0;for(let t=0;t<o;t++){const c=R.$Ee(m,s);s+=2,r[n++]=String.fromCharCode(c)}return r.join("")}class v{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return N().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const o=this.a-this.d;o<=1&&(o===0||I.$xf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const o=s.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=s;return}for(let r=0;r<o;r++)this.b[this.d++]=s.charCodeAt(r)}}e.$vt=v}),define(Re[146],Ae([1,0,23,145]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$xt=M;function R(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,N,y,u){this.oldPosition=k,this.oldText=N,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,N,y){const u=N.length;I.$He(k,u,y),y+=4;for(let v=0;v<u;v++)I.$Fe(k,N.charCodeAt(v),y),y+=2;return y}static d(k,N){const y=I.$Ge(k,N);return N+=4,(0,T.$ut)(k,N,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(k,N){return I.$He(k,this.oldPosition,N),N+=4,I.$He(k,this.newPosition,N),N+=4,N=O.c(k,this.oldText,N),N=O.c(k,this.newText,N),N}static read(k,N,y){const u=I.$Ge(k,N);N+=4;const v=I.$Ge(k,N);N+=4;const m=O.d(k,N);N+=O.a(m);const s=O.d(k,N);return N+=O.a(s),y.push(new O(u,m,v,s)),N}}e.$wt=O;function M(g,k){return g===null||g.length===0?k:new p(g,k).compress()}class p{constructor(k,N){this.a=k,this.c=N,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,N=0,y=this.n(k),u=this.l(N);for(;k<this.f||N<this.h;){if(y===null){this.k(u),u=this.l(++N);continue}if(u===null){this.m(y),y=this.n(++k);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++N);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++k);continue}if(u.oldPosition<y.newPosition){const[r,n]=p.r(u,y.newPosition-u.oldPosition);this.k(r),u=n;continue}if(y.newPosition<u.oldPosition){const[r,n]=p.q(y,u.oldPosition-y.newPosition);this.m(r),y=n;continue}let s,o;if(u.oldEnd===y.newEnd)s=y,o=u,y=this.n(++k),u=this.l(++N);else if(u.oldEnd<y.newEnd){const[r,n]=p.q(y,u.oldLength);s=r,o=u,y=n,u=this.l(++N)}else{const[r,n]=p.r(u,y.newLength);s=y,o=r,y=this.n(++k),u=n}this.d[this.e++]=new O(s.oldPosition,s.oldText,o.newPosition,o.newText),this.g+=s.newLength-s.oldLength,this.j+=o.newLength-o.oldLength}const v=p.s(this.d);return p.t(v)}k(k){this.d[this.e++]=p.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=p.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,N){return new O(N.oldPosition-k,N.oldText,N.newPosition,N.newText)}static p(k,N){return new O(N.oldPosition,N.oldText,N.newPosition+k,N.newText)}static q(k,N){const y=k.newText.substr(0,N),u=k.newText.substr(N);return[new O(k.oldPosition,k.oldText,k.newPosition,y),new O(k.oldEnd,"",k.newPosition+N,u)]}static r(k,N){const y=k.oldText.substr(0,N),u=k.oldText.substr(N);return[new O(k.oldPosition,y,k.newPosition,k.newText),new O(k.oldPosition+N,u,k.newEnd,"")]}static s(k){if(k.length===0)return k;const N=[];let y=0,u=k[0];for(let v=1;v<k.length;v++){const m=k[v];u.oldEnd===m.oldPosition?u=new O(u.oldPosition,u.oldText+m.oldText,u.newPosition,u.newText+m.newText):(N[y++]=u,u=m)}return N[y++]=u,N}static t(k){if(k.length===0)return k;const N=[];let y=0;for(let u=0;u<k.length;u++){const v=k[u];v.oldText!==v.newText&&(N[y++]=v)}return N}}}),define(Re[147],Ae([1,0,36,19]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=R,e.$Vt=O;function R(M,p,g,k,N,y){if(Array.isArray(M)){let u=0;for(const v of M){const m=R(v,p,g,k,N,y);if(m===10)return m;m>u&&(u=m)}return u}else{if(typeof M=="string")return k?M==="*"?5:M===g?10:0:0;if(M){const{language:u,pattern:v,scheme:m,hasAccessToAllModels:s,notebookType:o}=M;if(!k&&!s)return 0;o&&N&&(p=N);let r=0;if(m)if(m===p.scheme)r=10;else if(m==="*")r=5;else return 0;if(u)if(u===g)r=10;else if(u==="*")r=Math.max(r,5);else return 0;if(o)if(o===y)r=10;else if(o==="*"&&y!==void 0)r=Math.max(r,5);else return 0;if(v){let n;if(typeof v=="string"?n=v:n={...v,base:(0,T.$ic)(v.base)},n===p.fsPath||(0,I.$jk)(n,p.fsPath))r=10;else return 0}return r}else return 0}}function O(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(O):!!M.notebookType}}),define(Re[148],Ae([1,0,5,15,29,94,92,133,146,6]),function(ge,e,I,T,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class N extends k.$Uc{constructor(u,v,m,s,o,r,n){super(),this.m=this.B(new I.$be),this.onDidChangeContent=this.m.event,this.f=v,this.j=!r,this.g=s,this.h=o,this.c=new M.$KC(u,m,n)}equals(u){return!(u instanceof N)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,v){return this.c.getOffsetAt(u,v)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,v){const m=u+v,s=this.getPositionAt(u),o=this.getPositionAt(m);return new R.$kt(s.lineNumber,s.column,o.lineNumber,o.column)}getValueInRange(u,v=0){if(u.isEmpty())return"";const m=this.n(v);return this.c.getValueInRange(u,m)}getValueLengthInRange(u,v=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const m=this.getOffsetAt(u.startLineNumber,u.startColumn),s=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const r=this.n(v),n=this.getEOL();if(r.length!==n.length){const t=r.length-n.length,c=u.endLineNumber-u.startLineNumber;o=t*c}return s-m+o}getCharacterCountInRange(u,v=0){if(this.j){let m=0;const s=u.startLineNumber,o=u.endLineNumber;for(let r=s;r<=o;r++){const n=this.getLineContent(r),t=r===s?u.startColumn-1:0,c=r===o?u.endColumn-1:n.length;for(let h=t;h<c;h++)T.$xf(n.charCodeAt(h))?(m=m+1,h=h+1):m=m+1}return m+=this.n(v).length*(o-s),m}return this.getValueLengthInRange(u,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,v){return this.c.getLineCharCode(u,v)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const v=T.$if(this.getLineContent(u));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(u){const v=T.$kf(this.getLineContent(u));return v===-1?0:v+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,v,m){let s=this.g,o=this.h,r=this.j,n=!0,t=[];for(let l=0;l<u.length;l++){const S=u[l];n&&S._isTracked&&(n=!1);const d=S.range;if(S.text){let P=!0;r||(P=!T.$If(S.text),r=P),!s&&P&&(s=T.$Hf(S.text)),!o&&P&&(o=T.$Kf(S.text))}let D="",f=0,E=0,w=0;if(S.text){let P;[f,E,w,P]=(0,p.$Nt)(S.text);const C=this.getEOL();P===0||P===(C===`\r
`?2:1)?D=S.text:D=S.text.replace(/\r\n|\r|\n/g,C)}t[l]={sortIndex:l,identifier:S.identifier||null,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d),text:D,eolCount:f,firstLineLength:E,lastLineLength:w,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}t.sort(N.u);let c=!1;for(let l=0,S=t.length-1;l<S;l++){const d=t[l].range.getEndPosition(),D=t[l+1].range.getStartPosition();if(D.isBeforeOrEqual(d)){if(D.isBefore(d))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(t=this.s(t));const h=m||v?N._getInverseEditRanges(t):[],i=[];if(v)for(let l=0;l<t.length;l++){const S=t[l],d=h[l];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let D=d.startLineNumber;D<=d.endLineNumber;D++){let f="";D===d.startLineNumber&&(f=this.getLineContent(S.range.startLineNumber),T.$if(f)!==-1)||i.push({lineNumber:D,oldContent:f})}}let b=null;if(m){let l=0;b=[];for(let S=0;S<t.length;S++){const d=t[S],D=h[S],f=this.getValueInRange(d.range),E=d.rangeOffset+l;l+=d.text.length-f.length,b[S]={sortIndex:d.sortIndex,identifier:d.identifier,range:D,text:f,textChange:new g.$wt(d.rangeOffset,f,E,d.text)}}c||b.sort((S,d)=>S.sortIndex-d.sortIndex)}this.g=s,this.h=o,this.j=r;const a=this.t(t);let $=null;if(v&&i.length>0){i.sort((l,S)=>S.lineNumber-l.lineNumber),$=[];for(let l=0,S=i.length;l<S;l++){const d=i[l].lineNumber;if(l>0&&i[l-1].lineNumber===d)continue;const D=i[l].oldContent,f=this.getLineContent(d);f.length===0||f===D||T.$if(f)!==-1||$.push(d)}}return this.m.fire(),new O.$zv(b,a,$)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let v=!1;const m=u[0].range,s=u[u.length-1].range,o=new R.$kt(m.startLineNumber,m.startColumn,s.endLineNumber,s.endColumn);let r=m.startLineNumber,n=m.startColumn;const t=[];for(let a=0,$=u.length;a<$;a++){const l=u[a],S=l.range;v=v||l.forceMoveMarkers,t.push(this.getValueInRange(new R.$kt(r,n,S.startLineNumber,S.startColumn))),l.text.length>0&&t.push(l.text),r=S.endLineNumber,n=S.endColumn}const c=t.join(""),[h,i,b]=(0,p.$Nt)(c);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:b,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(u){u.sort(N.w);const v=[];for(let m=0;m<u.length;m++){const s=u[m],o=s.range.startLineNumber,r=s.range.startColumn,n=s.range.endLineNumber,t=s.range.endColumn;if(o===n&&r===t&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new R.$kt(o,r,n,t);v.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return v}findMatchesLineByLine(u,v,m,s){return this.c.findMatchesLineByLine(u,v,m,s)}getPieceTree(){return this.c}static _getInverseEditRange(u,v){const m=u.startLineNumber,s=u.startColumn,[o,r,n]=(0,p.$Nt)(v);let t;if(v.length>0){const c=o+1;c===1?t=new R.$kt(m,s,m,s+r):t=new R.$kt(m,s,m+c-1,n+1)}else t=new R.$kt(m,s,m,s);return t}static _getInverseEditRanges(u){const v=[];let m=0,s=0,o=null;for(let r=0,n=u.length;r<n;r++){const t=u[r];let c,h;o?o.range.endLineNumber===t.range.startLineNumber?(c=m,h=s+(t.range.startColumn-o.range.endColumn)):(c=m+(t.range.startLineNumber-o.range.endLineNumber),h=t.range.startColumn):(c=t.range.startLineNumber,h=t.range.startColumn);let i;if(t.text.length>0){const b=t.eolCount+1;b===1?i=new R.$kt(c,h,c,h+t.firstLineLength):i=new R.$kt(c,h,c+b-1,t.lastLineLength+1)}else i=new R.$kt(c,h,c,h);m=i.endLineNumber,s=i.endColumn,v.push(i),o=t}return v}static u(u,v){const m=R.$kt.compareRangesUsingEnds(u.range,v.range);return m===0?u.sortIndex-v.sortIndex:m}static w(u,v){const m=R.$kt.compareRangesUsingEnds(u.range,v.range);return m===0?v.sortIndex-u.sortIndex:-m}}e.$LC=N}),define(Re[149],Ae([1,0,15,92,148]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=void 0;class O{constructor(g,k,N,y,u,v,m,s,o){this.a=g,this.b=k,this.c=N,this.d=y,this.e=u,this.f=v,this.g=m,this.h=s,this.j=o}k(g){const k=this.c+this.d+this.e,N=this.c+this.e;return k===0?g===1?`
`:`\r
`:N>k/2?`\r
`:`
`}create(g){const k=this.k(g),N=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let u=0,v=N.length;u<v;u++){const m=N[u].buffer.replace(/\r\n|\r|\n/g,k),s=(0,T.$GC)(m);N[u]=new T.$JC(m,s)}const y=new R.$LC(N,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:y,disposable:y}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&I.$Rf(g)&&(this.b=I.$Qf,g=g.substr(1));const k=g.charCodeAt(g.length-1);k===13||k>=55296&&k<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=k):(this.m(g,!1),this.c=!1,this.d=k)}m(g,k){!k&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const k=(0,T.$HC)(this.e,g);this.a.push(new T.$JC(g,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Hf(g)),this.k||(this.k=I.$Kf(g)))}finish(g=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const k=(0,T.$GC)(g.buffer);g.lineStarts=k,this.d===13&&this.f++}}}e.$MC=M}),define(Re[97],Ae([1,0,23,21]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbb=g,e.$xbb=N;var R;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(R||(R={}));function O(y){for(let u=0,v=y.length;u<v;u+=4){const m=y[u+0],s=y[u+1],o=y[u+2],r=y[u+3];y[u+0]=r,y[u+1]=o,y[u+2]=s,y[u+3]=m}}function M(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return T.$D()||O(u),I.$Ce.wrap(u)}function p(y){const u=y.buffer;if(T.$D()||O(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const v=new Uint8Array(u.byteLength);return v.set(u),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function g(y){const u=new Uint32Array(k(y));let v=0;if(u[v++]=y.id,y.type==="full")u[v++]=1,u[v++]=y.data.length,u.set(y.data,v),v+=y.data.length;else{u[v++]=2,u[v++]=y.deltas.length;for(const m of y.deltas)u[v++]=m.start,u[v++]=m.deleteCount,m.data?(u[v++]=m.data.length,u.set(m.data,v),v+=m.data.length):u[v++]=0}return M(u)}function k(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const v of y.deltas)v.data&&(u+=v.data.length)}return u}function N(y){const u=p(y);let v=0;const m=u[v++];if(u[v++]===1){const n=u[v++],t=u.subarray(v,v+n);return v+=n,{id:m,type:"full",data:t}}const o=u[v++],r=[];for(let n=0;n<o;n++){const t=u[v++],c=u[v++],h=u[v++];let i;h>0&&(i=u.subarray(v,v+h),v+=h),r[n]={start:t,deleteCount:c,data:i}}return{id:m,type:"delta",deltas:r}}}),define(Re[150],Ae([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Re[151],Ae([1,0,18,26,21,134,152,150]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=n,e.clampedFloat=c,e.stringSet=b,e.cursorStyleToString=w,e.filterValidationDecorations=le;var g;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=k;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class y{constructor(Z,me,He,ye){this.id=Z,this.name=me,this.defaultValue=He,this.schema=ye}applyUpdate(Z,me){return v(Z,me)}compute(Z,me,He){return He}}class u{constructor(Z,me){this.newValue=Z,this.didChange=me}}e.ApplyUpdateResult=u;function v(X,Z){if(typeof X!="object"||typeof Z!="object"||!X||!Z)return new u(Z,X!==Z);if(Array.isArray(X)||Array.isArray(Z)){const He=Array.isArray(X)&&Array.isArray(Z)&&I.$ub(X,Z);return new u(Z,!He)}let me=!1;for(const He in Z)if(Z.hasOwnProperty(He)){const ye=v(X[He],Z[He]);ye.didChange&&(X[He]=ye.newValue,me=!0)}return new u(X,me)}class m{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,me){return v(Z,me)}validate(Z){return this.defaultValue}}class s{constructor(Z,me,He,ye){this.id=Z,this.name=me,this.defaultValue=He,this.schema=ye}applyUpdate(Z,me){return v(Z,me)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,me,He){return He}}function o(X,Z){return typeof X>"u"?Z:X==="false"?!1:!!X}class r extends s{constructor(Z,me,He,ye=void 0){typeof ye<"u"&&(ye.type="boolean",ye.default=He),super(Z,me,He,ye)}validate(Z){return o(Z,this.defaultValue)}}function n(X,Z,me,He){if(typeof X>"u")return Z;let ye=parseInt(X,10);return isNaN(ye)?Z:(ye=Math.max(me,ye),ye=Math.min(He,ye),ye|0)}class t extends s{static clampedInt(Z,me,He,ye){return n(Z,me,He,ye)}constructor(Z,me,He,ye,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=He,dt.minimum=ye,dt.maximum=ot),super(Z,me,He,dt),this.minimum=ye,this.maximum=ot}validate(Z){return t.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function c(X,Z,me,He){if(typeof X>"u")return Z;const ye=h.float(X,Z);return h.clamp(ye,me,He)}class h extends s{static clamp(Z,me,He){return Z<me?me:Z>He?He:Z}static float(Z,me){if(typeof Z=="number")return Z;if(typeof Z>"u")return me;const He=parseFloat(Z);return isNaN(He)?me:He}constructor(Z,me,He,ye,ot){typeof ot<"u"&&(ot.type="number",ot.default=He),super(Z,me,He,ot),this.validationFn=ye}validate(Z){return this.validationFn(h.float(Z,this.defaultValue))}}class i extends s{static string(Z,me){return typeof Z!="string"?me:Z}constructor(Z,me,He,ye=void 0){typeof ye<"u"&&(ye.type="string",ye.default=He),super(Z,me,He,ye)}validate(Z){return i.string(Z,this.defaultValue)}}function b(X,Z,me,He){return typeof X!="string"?Z:He&&X in He?He[X]:me.indexOf(X)===-1?Z:X}class a extends s{constructor(Z,me,He,ye,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=ye,ot.default=He),super(Z,me,He,ot),this.c=ye}validate(Z){return b(Z,this.defaultValue,this.c)}}class $ extends y{constructor(Z,me,He,ye,ot,dt,It=void 0){typeof It<"u"&&(It.type="string",It.enum=ot,It.default=ye),super(Z,me,He,It),this.c=ot,this.d=dt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function l(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class S extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,me,He){return He===0?Z.accessibilitySupport:He}}class d extends y{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:p.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function f(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function w(X){switch(X){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}function P(X){switch(X){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class C extends m{constructor(){super(142)}compute(Z,me,He){const ye=["monaco-editor"];return me.get(39)&&ye.push(me.get(39)),Z.extraEditorClassName&&ye.push(Z.extraEditorClassName),me.get(74)==="default"?ye.push("mouse-default"):me.get(74)==="copy"&&ye.push("mouse-copy"),me.get(111)&&ye.push("showUnused"),me.get(140)&&ye.push("showDeprecated"),ye.join(" ")}}class V extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(Z,me,He){return He&&Z.emptySelectionClipboard}}class W extends y{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:p.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:p.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":b(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":b(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class q extends y{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?q.OFF:Z==="true"?q.ON:Z:Z?q.ON:q.OFF}}e.EditorFontLigatures=q;class A extends y{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?A.OFF:Z==="true"?A.TRANSLATE:Z:Z?A.TRANSLATE:A.OFF}compute(Z,me,He){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=A;class U extends m{constructor(){super(50)}compute(Z,me,He){return Z.fontInfo}}class K extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(Z){const me=h.float(Z,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(me,6,100)}compute(Z,me,He){return Z.fontInfo.fontSize}}class se extends y{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:se.d,maximum:se.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:se.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(t.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,se.d,se.e))}}class ce extends y{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:He,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:He,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:He,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:He,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:He,description:p.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{multiple:b(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??b(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??b(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??b(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??b(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??b(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ve extends y{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:p.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:t.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(me.above,this.defaultValue.above)}}}var Ie;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class ue extends m{constructor(){super(145)}compute(Z,me,He){return ue.computeLayout(me,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const me=Z.height/Z.lineHeight,He=Math.floor(Z.paddingTop/Z.lineHeight);let ye=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(ye=Math.max(ye,me-1));const ot=(He+Z.viewLineCount+ye)/(Z.pixelRatio*Z.height),dt=Math.floor(Z.viewLineCount/ot);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:ye,desiredRatio:ot,minimapLineCount:dt}}static c(Z,me){const He=Z.outerWidth,ye=Z.outerHeight,ot=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ye};const dt=me.stableMinimapLayoutInput,It=dt&&Z.outerHeight===dt.outerHeight&&Z.lineHeight===dt.lineHeight&&Z.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===dt.pixelRatio&&Z.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Z.paddingTop===dt.paddingTop&&Z.paddingBottom===dt.paddingBottom&&Z.minimap.enabled===dt.minimap.enabled&&Z.minimap.side===dt.minimap.side&&Z.minimap.size===dt.minimap.size&&Z.minimap.showSlider===dt.minimap.showSlider&&Z.minimap.renderCharacters===dt.minimap.renderCharacters&&Z.minimap.maxColumn===dt.minimap.maxColumn&&Z.minimap.scale===dt.minimap.scale&&Z.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Z.isViewportWrapping===dt.isViewportWrapping,Qt=Z.lineHeight,Ut=Z.typicalHalfwidthCharacterWidth,xt=Z.scrollBeyondLastLine,_t=Z.minimap.renderCharacters;let Ct=ot>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Vt=Z.minimap.maxColumn,Zt=Z.minimap.size,Xe=Z.minimap.side,si=Z.verticalScrollbarWidth,Xt=Z.viewLineCount,lt=Z.remainingWidth,vt=Z.isViewportWrapping,ti=_t?2:3;let Yt=Math.floor(ot*ye);const Lt=Yt/ot;let ft=!1,jt=!1,Bt=ti*Ct,qt=Ct/ot,Ge=1;if(Zt==="fill"||Zt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:Gt,desiredRatio:ni,minimapLineCount:Mt}=ue.computeContainedMinimapLineCount({viewLineCount:Xt,scrollBeyondLastLine:xt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:ye,lineHeight:Qt,pixelRatio:ot});if(Xt/Mt>1)ft=!0,jt=!0,Ct=1,Bt=1,qt=Ct/ot;else{let Pt=!1,Dt=Ct+1;if(Zt==="fit"){const pt=Math.ceil((ii+Xt+Gt)*Bt);vt&&It&&lt<=me.stableFitRemainingWidth?(Pt=!0,Dt=me.stableFitMaxMinimapScale):Pt=pt>Yt}if(Zt==="fill"||Pt){ft=!0;const pt=Ct;Bt=Math.min(Qt*ot,Math.max(1,Math.floor(1/ni))),vt&&It&&lt<=me.stableFitRemainingWidth&&(Dt=me.stableFitMaxMinimapScale),Ct=Math.min(Dt,Math.max(1,Math.floor(Bt/ti))),Ct>pt&&(Ge=Math.min(2,Ct/pt)),qt=Ct/ot/Ge,Yt=Math.ceil(Math.max(Ot,ii+Xt+Gt)*Bt),vt?(me.stableMinimapLayoutInput=Z,me.stableFitRemainingWidth=lt,me.stableFitMaxMinimapScale=Ct):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ui=Math.floor(Vt*qt),Ht=Math.min(ui,Math.max(0,Math.floor((lt-si-2)*qt/(Ut+qt)))+e.MINIMAP_GUTTER_WIDTH);let zt=Math.floor(ot*Ht);const gt=zt/ot;zt=Math.floor(zt*Ge);const Nt=_t?1:2,Rt=Xe==="left"?0:He-Ht-si;return{renderMinimap:Nt,minimapLeft:Rt,minimapWidth:Ht,minimapHeightIsEditorHeight:ft,minimapIsSampling:jt,minimapScale:Ct,minimapLineHeight:Bt,minimapCanvasInnerWidth:zt,minimapCanvasInnerHeight:Yt,minimapCanvasOuterWidth:gt,minimapCanvasOuterHeight:Lt}}static computeLayout(Z,me){const He=me.outerWidth|0,ye=me.outerHeight|0,ot=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,It=me.typicalHalfwidthCharacterWidth,Qt=me.maxDigitWidth,Ut=me.pixelRatio,xt=me.viewLineCount,_t=Z.get(137),Ct=_t==="inherit"?Z.get(136):_t,Vt=Ct==="inherit"?Z.get(132):Ct,Zt=Z.get(135),Xe=me.isDominatedByLongLines,si=Z.get(57),Xt=Z.get(68).renderType!==0,lt=Z.get(69),vt=Z.get(105),ti=Z.get(84),Yt=Z.get(73),Lt=Z.get(103),ft=Lt.verticalScrollbarSize,jt=Lt.verticalHasArrows,Bt=Lt.arrowSize,qt=Lt.horizontalScrollbarSize,Ge=Z.get(43),ui=Z.get(110)!=="never";let Ht=Z.get(66);Ge&&ui&&(Ht+=16);let zt=0;if(Xt){const li=Math.max(dt,lt);zt=Math.round(li*Qt)}let gt=0;si&&(gt=ot*me.glyphMarginDecorationLaneCount);let Nt=0,Rt=Nt+gt,Ot=Rt+zt,ii=Ot+Ht;const Gt=He-gt-zt-Ht;let ni=!1,Mt=!1,Tt=-1;Ct==="inherit"&&Xe?(ni=!0,Mt=!0):Vt==="on"||Vt==="bounded"?Mt=!0:Vt==="wordWrapColumn"&&(Tt=Zt);const Pt=ue.c({outerWidth:He,outerHeight:ye,lineHeight:ot,typicalHalfwidthCharacterWidth:It,pixelRatio:Ut,scrollBeyondLastLine:vt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:Yt,verticalScrollbarWidth:ft,viewLineCount:xt,remainingWidth:Gt,isViewportWrapping:Mt},me.memory||new N);Pt.renderMinimap!==0&&Pt.minimapLeft===0&&(Nt+=Pt.minimapWidth,Rt+=Pt.minimapWidth,Ot+=Pt.minimapWidth,ii+=Pt.minimapWidth);const Dt=Gt-Pt.minimapWidth,pt=Math.max(1,Math.floor((Dt-ft-2)/It)),St=jt?Bt:0;return Mt&&(Tt=Math.max(1,pt),Vt==="bounded"&&(Tt=Math.min(Tt,Zt))),{width:He,height:ye,glyphMarginLeft:Nt,glyphMarginWidth:gt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Rt,lineNumbersWidth:zt,decorationsLeft:Ot,decorationsWidth:Ht,contentLeft:ii,contentWidth:Dt,minimap:Pt,viewportColumn:pt,isWordWrapMinified:ni,isViewportWrapping:Mt,wrappingColumn:Tt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:qt,overviewRuler:{top:St,width:ft,height:ye-2*St,right:0}}}}e.EditorLayoutInfoComputer=ue;class be extends y{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(Z){return b(Z,"simple",["simple","advanced"])}compute(Z,me,He){return me.get(2)===2?"advanced":He}}var ie;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(ie||(e.ShowLightbulbIconMode=ie={}));class Ce extends y{constructor(){const Z={enabled:ie.On};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ie.Off,ie.OnCode,ie.On],default:Z.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:b(Z.enabled,this.defaultValue.enabled,[ie.Off,ie.OnCode,ie.On])}}}class Fe extends y{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:p.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:b(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends y{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:p.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:b(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class j extends y{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):t.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,me,He){return He<0?t.clampedInt(-He*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class x extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>h.clamp(Z,0,150),{markdownDescription:p.localize(66,null)})}compute(Z,me,He){return Z.fontInfo.lineHeight}}class pe extends y{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:Z.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Z.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Z.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Z.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:b(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(me.side,this.defaultValue.side,["right","left"]),showSlider:b(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(me.scale,1,1,3),maxColumn:t.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Oe(X){return X==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class ke extends y{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{top:t.clampedInt(me.top,0,0,1e3),bottom:t.clampedInt(me.bottom,0,0,1e3)}}}class $e extends y{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:p.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class fe extends m{constructor(){super(143)}compute(Z,me,He){return Z.pixelRatio}}class J extends y{constructor(){const Z={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Z.strings,description:p.localize(88,null)},comments:{anyOf:me,default:Z.comments,description:p.localize(89,null)},other:{anyOf:me,default:Z.other,description:p.localize(90,null)}},default:Z,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Ut=Z?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:me,comments:He,strings:ye}=Z,ot=["on","inline","off"];let dt,It,Qt;return typeof me=="boolean"?dt=me?"on":"off":dt=b(me,this.defaultValue.other,ot),typeof He=="boolean"?It=He?"on":"off":It=b(He,this.defaultValue.comments,ot),typeof ye=="boolean"?Qt=ye?"on":"off":Qt=b(ye,this.defaultValue.strings,ot),{other:dt,comments:It,strings:Qt}}}var Y;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends y{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(Z){let me=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(me=4,He=Z):Z==="interval"?me=3:Z==="relative"?me=2:Z==="on"?me=1:me=0),{renderType:me,renderFn:He}}}function le(X){const Z=X.get(98);return Z==="editable"?X.get(91):Z!=="on"}class Te extends y{constructor(){const Z=[],me={type:"number",description:p.localize(97,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:Z,description:p.localize(99,null)})}validate(Z){if(Array.isArray(Z)){const me=[];for(const He of Z)if(typeof He=="number")me.push({column:t.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const ye=He;me.push({column:t.clampedInt(ye.column,0,0,1e4),color:ye.color})}return me.sort((He,ye)=>He.column-ye.column),me}return this.defaultValue}}class de extends y{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Pe(X,Z){if(typeof X!="string")return Z;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends y{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z,He=t.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ye=t.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(me.vertical,this.defaultValue.vertical),horizontal:Pe(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:t.clampedInt(me.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:ye,verticalSliderSize:t.clampedInt(me.verticalSliderSize,ye,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends y{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:p.localize(118,null)}})}applyUpdate(Z,me){let He=!1;me.allowedCharacters&&Z&&(T.$1n(Z.allowedCharacters,me.allowedCharacters)||(Z={...Z,allowedCharacters:me.allowedCharacters},He=!0)),me.allowedLocales&&Z&&(T.$1n(Z.allowedLocales,me.allowedLocales)||(Z={...Z,allowedLocales:me.allowedLocales},He=!0));const ye=super.applyUpdate(Z,me);return He?new u(ye.newValue,!0):ye}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,me){if(typeof Z!="object"||!Z)return me;const He={};for(const[ye,ot]of Object.entries(Z))ot===!0&&(He[ye]=!0);return He}}class z extends y{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:p.localize(125,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:b(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:b(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily)}}}class L extends y{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:p.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showToolbar:b(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends y{constructor(){const Z={enabled:O.$Us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$Us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends y{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:Z.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:Z.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:Z.highlightActiveIndentation,description:p.localize(148,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(X,Z,me){const He=me.indexOf(X);return He===-1?Z:me[He]}class re extends y{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:Z.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:Z.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertMode:b(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:b(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:b(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Ne extends y{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Z.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends y{constructor(){const Z=[];super(130,"wordSegmenterLocales",Z,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Z){if(typeof Z=="string"&&(Z=[Z]),Array.isArray(Z)){const me=[];for(const He of Z)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&me.push(He)}catch{}return me}return this.defaultValue}}var Qe;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class _e extends y{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,me,He){return me.get(2)===2?0:He}}class et extends m{constructor(){super(146)}compute(Z,me,He){const ye=me.get(145);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:ye.isWordWrapMinified,isViewportWrapping:ye.isViewportWrapping,wrappingColumn:ye.wrappingColumn}}}class tt extends y{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showDropSelector:b(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends y{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showPasteSelector:b(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",mt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?at:R.$k?mt:nt,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(X){return e.editorOptionsRegistry[X.id]=X,X}var st;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSegmenterLocales=130]="wordSegmenterLocales",X[X.wordSeparators=131]="wordSeparators",X[X.wordWrap=132]="wordWrap",X[X.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=135]="wordWrapColumn",X[X.wordWrapOverride1=136]="wordWrapOverride1",X[X.wordWrapOverride2=137]="wordWrapOverride2",X[X.wrappingIndent=138]="wrappingIndent",X[X.wrappingStrategy=139]="wrappingStrategy",X[X.showDeprecated=140]="showDeprecated",X[X.inlayHints=141]="inlayHints",X[X.editorClassName=142]="editorClassName",X[X.pixelRatio=143]="pixelRatio",X[X.tabFocusMode=144]="tabFocusMode",X[X.layoutInfo=145]="layoutInfo",X[X.wrappingInfo=146]="wrappingInfo",X[X.defaultColorDecorators=147]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:je(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:je(new S),accessibilityPageSize:je(new t(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new i(4,"ariaLabel",p.localize(218,null))),ariaRequired:je(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:je(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:je(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:je(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:je(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:je(new $(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:je(new r(13,"automaticLayout",!1)),autoSurround:je(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:je(new G),bracketPairGuides:je(new H),stickyTabStops:je(new r(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:je(new r(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:je(new i(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:je(new t(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:je(new r(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:je(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:je(new t(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:je(new r(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:je(new d),contextmenu:je(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new r(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:je(new $(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:je(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:je(new $(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:p.localize(260,null)})),cursorSurroundingLines:je(new t(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:je(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:je(new t(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:je(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new r(34,"domReadOnly",!1)),dragAndDrop:je(new r(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:je(new V),dropIntoEditor:je(new tt),stickyScroll:je(new Fe),experimentalWhitespaceRendering:je(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:je(new i(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:p.localize(271,null)})),find:je(new W),fixedOverflowWidgets:je(new r(42,"fixedOverflowWidgets",!1)),folding:je(new r(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:je(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:je(new r(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:je(new r(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:je(new t(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:je(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:je(new U),fontLigatures2:je(new q),fontSize:je(new K),fontWeight:je(new se),fontVariations:je(new A),formatOnPaste:je(new r(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:je(new r(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:je(new r(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:je(new ce),hideCursorInOverviewRuler:je(new r(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:je(new ve),inDiffEditor:je(new r(61,"inDiffEditor",!1)),letterSpacing:je(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>h.clamp(X,-5,20),{description:p.localize(285,null)})),lightbulb:je(new Ce),lineDecorationsWidth:je(new j),lineHeight:je(new x),lineNumbers:je(new he),lineNumbersMinChars:je(new t(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new r(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:je(new r(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:je(new a(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:je(new pe),mouseStyle:je(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(75,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:je(new r(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:je(new r(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:je(new $(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Oe,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:je(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:je(new t(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:je(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:je(new r(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:je(new t(83,"overviewRulerLanes",3,0,3)),padding:je(new ke),pasteAs:je(new it),parameterHints:je(new $e),peekWidgetDefaultFocus:je(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:je(new r(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:je(new J),quickSuggestionsDelay:je(new t(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:je(new r(91,"readOnly",!1)),readOnlyMessage:je(new de),renameOnType:je(new r(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:je(new r(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:je(new a(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:je(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new r(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:je(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:je(new t(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new r(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:je(new Te),scrollbar:je(new Me),scrollBeyondLastColumn:je(new t(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:je(new r(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:je(new r(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:je(new r(107,"selectionClipboard",!0,{description:p.localize(325,null),included:R.$k})),selectionHighlight:je(new r(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:je(new r(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:je(new r(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:je(new r(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:je(new ne),snippetSuggestions:je(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:je(new Ne),smoothScrolling:je(new r(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:je(new t(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new re),inlineSuggest:je(new z),inlineEdit:je(new L),inlineCompletionsAccessibilityVerbose:je(new r(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:je(new t(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new t(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new r(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:je(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:je(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:je(new t(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new ze),unusualLineTerminators:je(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:je(new r(127,"useShadowDOM",!0)),useTabStops:je(new r(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:je(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:je(new Be),wordSeparators:je(new i(131,"wordSeparators",M.$Vs,{description:p.localize(359,null)})),wordWrap:je(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:je(new i(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new i(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new t(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:je(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new C),defaultColorDecorators:je(new r(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:je(new fe),tabFocusMode:je(new r(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:je(new ue),wrappingInfo:je(new et),wrappingIndent:je(new _e),wrappingStrategy:je(new be)}}),define(Re[153],Ae([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[154],Ae([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[155],Ae([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Re[156],Ae([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[157],Ae([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[158],Ae([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Re[159],Ae([9,10]),function(ge,e){return ge.create("vs/platform/log/common/log",e)}),define(Re[160],Ae([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Re[161],Ae([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[162],Ae([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Re[163],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[164],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[165],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[166],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Re[167],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[168],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[169],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[170],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[171],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[172],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[173],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[174],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[175],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Re[176],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Re[177],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Re[178],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Re[179],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[180],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[181],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[182],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[183],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[184],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Re[185],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[186],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[187],Ae([1,0,14,155]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.TokenType=void 0;var R;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(R||(e.TokenType=R={}));function O(...k){switch(k.length){case 1:return(0,T.localize)(0,null,k[0]);case 2:return(0,T.localize)(1,null,k[0],k[1]);case 3:return(0,T.localize)(2,null,k[0],k[1],k[2]);default:return}}const M=(0,T.localize)(3,null),p=(0,T.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(N){switch(N.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return N.isTripleEq?"===":"==";case 4:return N.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return N.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return N.lexeme;case 18:return N.lexeme;case 19:return N.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(N)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(N=>N.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(N){return this.c=N,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(N){return this.r()||this.c.charCodeAt(this.e)!==N?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(N){this.f.push({type:N,offset:this.d})}l(N){const y=this.d,u=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:u};this.g.push({offset:y,lexeme:u,additionalInfo:N}),this.f.push(v)}n(){this.m.lastIndex=this.d;const N=this.m.exec(this.c);if(N){this.e=this.d+N[0].length;const y=this.c.substring(this.d,this.e),u=g.b.get(y);u?this.k(u):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let N=this.e,y=!1,u=!1;for(;;){if(N>=this.c.length){this.e=N,this.l(p);return}const m=this.c.charCodeAt(N);if(y)y=!1;else if(m===47&&!u){N++;break}else m===91?u=!0:m===92?y=!0:m===93&&(u=!1);N++}for(;N<this.c.length&&g.a.has(this.c.charCodeAt(N));)N++;this.e=N;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$lj=g}),define(Re[188],Ae([1,0,24,33,157,300]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=g,e.$Bp=k,e.$Cp=N,e.$Dp=y,e.$Ep=u,e.$Fp=v,e.$Gp=m;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function g(r){return r=r.trim(),r==="*"||M.test(r)}function k(r){if(!g(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=r.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function N(r){if(!r)return null;const n=r.majorBase,t=r.majorMustEqual,c=r.minorBase;let h=r.minorMustEqual;const i=r.patchBase;let b=r.patchMustEqual;r.hasCaret&&(n===0||(h=!1),b=!1);let a=0;if(r.preRelease){const $=p.exec(r.preRelease);if($){const[,l,S,d]=$;a=Date.UTC(Number(l),Number(S)-1,Number(d))}}return{majorBase:n,majorMustEqual:t,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:b,isMinimum:r.hasGreaterEquals,notBefore:a}}function y(r,n,t){let c;typeof r=="string"?c=N(k(r)):c=r;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let i;if(typeof t=="string"?i=N(k(t)):i=t,!c||!i)return!1;const b=c.majorBase,a=c.minorBase,$=c.patchBase;let l=i.majorBase,S=i.minorBase,d=i.patchBase;const D=i.notBefore;let f=i.majorMustEqual,E=i.minorMustEqual,w=i.patchMustEqual;return i.isMinimum?b>l?!0:b<l?!1:a>S?!0:a<S||h&&h<D?!1:$>=d:(b===1&&l===0&&(!f||!E||!w)&&(l=1,S=0,d=0,f=!0,E=!1,w=!1),b<l?!1:b>l?!f:a<S?!1:a>S?!E:$<d?!1:$>d?!w:!(h&&h<D))}function u(r,n,t,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,R.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,R.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,R.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,R.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([T.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([T.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,R.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,R.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,R.localize(9,null,"main")]),i;{const $=(0,I.$4g)(t,c.main);(0,I.$Xg)($,t)||i.push([T.default.Warning,R.localize(10,null,$.path,t.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,R.localize(11,null,"browser")]),i;{const $=(0,I.$4g)(t,c.browser);(0,I.$Xg)($,t)||i.push([T.default.Warning,R.localize(12,null,$.path,t.path)])}}if(!O.valid(c.version))return i.push([T.default.Error,R.localize(13,null)]),i;const b=[];if(!v(r,n,c,h,b))for(const $ of b)i.push([T.default.Error,$]);return i}function v(r,n,t,c,h){return c||typeof t.main>"u"&&typeof t.browser>"u"?!0:s(r,n,t.engines.vscode,h)}function m(r,n,t){return r==="*"||s(n,t,r)}function s(r,n,t,c=[]){const h=N(k(t));if(!h)return c.push(R.localize(14,null,t)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(R.localize(15,null,t)),!1}else if(!h.majorMustEqual)return c.push(R.localize(16,null,t)),!1;return y(r,n,h)?!0:(c.push(R.localize(17,null,r,t)),!1)}function o(r){if(!Array.isArray(r))return!1;for(let n=0,t=r.length;n<t;n++)if(typeof r[n]!="string")return!1;return!0}}),define(Re[70],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=void 0;class I{constructor(R,O=[],M=!1){this.ctor=R,this.staticArguments=O,this.supportsDelayedInstantiation=M}}e.$ni=I}),define(Re[55],Ae([1,0,70]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$os=O,e.$ps=M;const T=[];var R;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function O(p,g,k){g instanceof I.$ni||(g=new I.$ni(g,[],!!k)),T.push([p,g])}function M(){return T}}),define(Re[189],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class I{constructor(O,M){this.key=O,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$5q=I;class T{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const M of this.a.values())M.outgoing.size===0&&O.push(M);return O}insertEdge(O,M){const p=this.lookupOrInsertNode(O),g=this.lookupOrInsertNode(M);p.outgoing.set(g.key,g),g.incoming.set(p.key,p)}removeNode(O){const M=this.b(O);this.a.delete(M);for(const p of this.a.values())p.outgoing.delete(M),p.incoming.delete(M)}lookupOrInsertNode(O){const M=this.b(O);let p=this.a.get(M);return p||(p=new I(M,O),this.a.set(M,p)),p}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[M,p]of this.a)O.push(`${M}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,M]of this.a){const p=new Set([O]),g=this.c(M,p);if(g)return g}}c(O,M){for(const[p,g]of O.outgoing){if(M.has(p))return[...M,p].join(" -> ");M.add(p);const k=this.c(g,M);if(k)return k;M.delete(p)}}}e.$6q=T}),define(Re[3],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e._util=void 0,e.$qi=R,e.$ri=O;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function p(g){return g[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=p})(I||(e._util=I={})),e.$pi=R("instantiationService");function T(M,p,g){p[I.DI_TARGET]===p?p[I.DI_DEPENDENCIES].push({id:M,index:g}):(p[I.DI_DEPENDENCIES]=[{id:M,index:g}],p[I.DI_TARGET]=p)}function R(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const p=function(g,k,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(p,g,N)};return p.toString=()=>M,I.serviceIds.set(M,p),p}function O(M){return M}}),define(Re[48],Ae([1,0,17,2,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Wi=void 0,e.$Xi=O,e.$Yi=M,e.$Zi=g,e.$1i=k,e.$2i=N,e.$3i=y,e.$4i=u,e.$5i=m,e.$6i=s,e.$7i=o,e.$Wi=(0,R.$qi)("configurationService");function O(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof T.URI)}function M(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof T.URI)}var p;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function g(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}function N(r,n){const t=Object.create(null);for(const c in r)y(t,c,r[c],n);return t}function y(r,n,t,c){const h=n.split("."),i=h.pop();let b=r;for(let a=0;a<h.length;a++){const $=h[a];let l=b[$];switch(typeof l){case"undefined":l=b[$]=Object.create(null);break;case"object":if(l===null){c(`Ignoring ${n} as ${h.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${n} as ${h.slice(0,a+1).join(".")} is ${JSON.stringify(l)}`);return}b=l}if(typeof b=="object"&&b!==null)try{b[i]=t}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(b)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(b)}`)}function u(r,n){const t=n.split(".");v(r,t)}function v(r,n){const t=n.shift();if(n.length===0){delete r[t];return}if(Object.keys(r).indexOf(t)!==-1){const c=r[t];typeof c=="object"&&!Array.isArray(c)&&(v(c,n),Object.keys(c).length===0&&delete r[t])}}function m(r,n,t){function c(b,a){let $=b;for(const l of a){if(typeof $!="object"||$===null)return;$=$[l]}return $}const h=n.split("."),i=c(r,h);return typeof i>"u"?t:i}function s(r,n,t){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in r?I.$6f(r[c])&&I.$6f(n[c])?s(r[c],n[c],t):t&&(r[c]=n[c]):r[c]=n[c])})}function o(r){return r.replace(/[\[\]]/g,"")}}),define(Re[31],Ae([1,0,21,15,187,3,154,14]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$oj=e.$nj=e.ContextKeyExprType=void 0,e.$mj=k,e.$pj=b,e.$qj=a,e.$Jj=ie;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",I.$j),g.set("isLinux",I.$k),g.set("isWindows",I.$i),g.set("isWeb",I.$o),g.set("isMacNative",I.$j&&!I.$o),g.set("isEdge",I.$H),g.set("isFirefox",I.$F),g.set("isChrome",I.$E),g.set("isSafari",I.$G);function k(ne,j){if(g.get(ne)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(ne,j)}const N=Object.prototype.hasOwnProperty;var y;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const u={regexParsingWithErrorRecovery:!0},v=(0,M.localize)(0,null),m=(0,M.localize)(1,null),s=(0,M.localize)(2,null),o=(0,M.localize)(3,null),r=(0,M.localize)(4,null),n=(0,M.localize)(5,null),t=(0,M.localize)(6,null),c=(0,M.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=u){this.k=j,this.d=new R.$lj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const pe=this.D(),Oe=pe.type===17?n:void 0;throw this.h.push({message:r,offset:pe.offset,lexeme:R.$lj.getLexeme(pe),additionalInfo:Oe}),h.c}return x}catch(x){if(x!==h.c)throw x;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const x=this.o();j.push(x)}return j.length===1?j[0]:i.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const x=this.s();j.push(x)}return j.length===1?j[0]:i.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),S.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),P.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=j.lexeme;if(this.z(),this.y(9)){const Oe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Oe.type!==10)throw this.B("REGEX",Oe);const ke=Oe.lexeme,$e=ke.lastIndexOf("/"),fe=$e===ke.length-1?void 0:this.w(ke.substring($e+1));let J;try{J=new RegExp(ke.substring(1,$e),fe)}catch{throw this.B("REGEX",Oe)}return U.create(x,J)}switch(Oe.type){case 10:case 19:{const ke=[Oe.lexeme];this.z();let $e=this.D(),fe=0;for(let Te=0;Te<Oe.lexeme.length;Te++)Oe.lexeme.charCodeAt(Te)===40?fe++:Oe.lexeme.charCodeAt(Te)===41&&fe--;for(;!this.E()&&$e.type!==15&&$e.type!==16;){switch($e.type){case 0:fe++;break;case 1:fe--;break;case 10:case 18:for(let Te=0;Te<$e.lexeme.length;Te++)$e.lexeme.charCodeAt(Te)===40?fe++:Oe.lexeme.charCodeAt(Te)===41&&fe--}if(fe<0)break;ke.push(R.$lj.getLexeme($e)),this.z(),$e=this.D()}const J=ke.join(""),Y=J.lastIndexOf("/"),he=Y===J.length-1?void 0:this.w(J.substring(Y+1));let le;try{le=new RegExp(J.substring(1,Y),he)}catch{throw this.B("REGEX",Oe)}return i.regex(x,le)}case 18:{const ke=Oe.lexeme;this.z();let $e=null;if(!(0,T.$3e)(ke)){const fe=ke.indexOf("/"),J=ke.lastIndexOf("/");if(fe!==J&&fe>=0){const Y=ke.slice(fe+1,J),he=ke[J+1]==="i"?"i":"";try{$e=new RegExp(Y,he)}catch{throw this.B("REGEX",Oe)}}}if($e===null)throw this.B("REGEX",Oe);return U.create(x,$e)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Oe=this.u();return i.notIn(x,Oe)}switch(this.D().type){case 3:{this.z();const Oe=this.u();if(this.x().type===18)return i.equals(x,Oe);switch(Oe){case"true":return i.has(x);case"false":return i.not(x);default:return i.equals(x,Oe)}}case 4:{this.z();const Oe=this.u();if(this.x().type===18)return i.notEquals(x,Oe);switch(Oe){case"true":return i.not(x);case"false":return i.has(x);default:return i.notEquals(x,Oe)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),A.create(x,this.u());case 7:return this.z(),V.create(x,this.u());case 8:return this.z(),W.create(x,this.u());case 13:return this.z(),i.in(x,this.u());default:return i.has(x)}}case 20:throw this.h.push({message:t,offset:j.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,x){if(this.C(j))return this.z();throw this.B(x,this.D())}B(j,x,pe){const Oe=(0,M.localize)(8,null,j,R.$lj.getLexeme(x)),ke=x.offset,$e=R.$lj.getLexeme(x);return this.h.push({message:Oe,offset:ke,lexeme:$e,additionalInfo:pe}),h.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$nj=h;class i{static false(){return l.INSTANCE}static true(){return S.INSTANCE}static has(j){return d.create(j)}static equals(j,x){return D.create(j,x)}static notEquals(j,x){return w.create(j,x)}static regex(j,x){return U.create(j,x)}static in(j,x){return f.create(j,x)}static notIn(j,x){return E.create(j,x)}static not(j){return P.create(j)}static and(...j){return ce.create(j,null,!0)}static or(...j){return ve.create(j,null,!0)}static greater(j,x){return V.create(j,x)}static greaterEquals(j,x){return W.create(j,x)}static smaller(j,x){return q.create(j,x)}static smallerEquals(j,x){return A.create(j,x)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$oj=i;function b(ne){const j=new h({regexParsingWithErrorRecovery:!1});return ne.map(x=>(j.parse(x),j.lexingErrors.length>0?j.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,M.localize)(9,null,pe.additionalInfo):(0,M.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function a(ne,j){const x=ne?ne.substituteConstants():void 0,pe=j?j.substituteConstants():void 0;return!x&&!pe?!0:!x||!pe?!1:x.equals(pe)}function $(ne,j){return ne.cmp(j)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return S.INSTANCE}}e.$rj=l;class S{static{this.INSTANCE=new S}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return l.INSTANCE}}e.$sj=S;class d{static create(j,x=null){const pe=g.get(j);return typeof pe=="boolean"?pe?S.INSTANCE:l.INSTANCE:new d(j,x)}constructor(j,x){this.key=j,this.c=x,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=g.get(this.key);return typeof j=="boolean"?j?S.INSTANCE:l.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$tj=d;class D{static create(j,x,pe=null){if(typeof x=="boolean")return x?d.create(j,pe):P.create(j,pe);const Oe=g.get(j);return typeof Oe=="boolean"?x===(Oe?"true":"false")?S.INSTANCE:l.INSTANCE:new D(j,x,pe)}constructor(j,x,pe){this.c=j,this.d=x,this.f=pe,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=g.get(this.c);if(typeof j=="boolean"){const x=j?"true":"false";return this.d===x?S.INSTANCE:l.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$uj=D;class f{static create(j,x){return new f(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:be(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const x=j.getValue(this.f),pe=j.getValue(this.d);return Array.isArray(x)?x.includes(pe):typeof pe=="string"&&typeof x=="object"&&x!==null?N.call(x,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$vj=f;class E{static create(j,x){return new E(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=11,this.c=f.create(j,x)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$wj=E;class w{static create(j,x,pe=null){if(typeof x=="boolean")return x?P.create(j,pe):d.create(j,pe);const Oe=g.get(j);return typeof Oe=="boolean"?x===(Oe?"true":"false")?l.INSTANCE:S.INSTANCE:new w(j,x,pe)}constructor(j,x,pe){this.c=j,this.d=x,this.f=pe,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=g.get(this.c);if(typeof j=="boolean"){const x=j?"true":"false";return this.d===x?l.INSTANCE:S.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$xj=w;class P{static create(j,x=null){const pe=g.get(j);return typeof pe=="boolean"?pe?l.INSTANCE:S.INSTANCE:new P(j,x)}constructor(j,x){this.c=j,this.d=x,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=g.get(this.c);return typeof j=="boolean"?j?l.INSTANCE:S.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=d.create(this.c,this)),this.d}}e.$yj=P;function C(ne,j){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?j(ne):l.INSTANCE}class V{static create(j,x,pe=null){return C(x,Oe=>new V(j,Oe,pe))}constructor(j,x,pe){this.c=j,this.d=x,this.f=pe,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$zj=V;class W{static create(j,x,pe=null){return C(x,Oe=>new W(j,Oe,pe))}constructor(j,x,pe){this.c=j,this.d=x,this.f=pe,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Aj=W;class q{static create(j,x,pe=null){return C(x,Oe=>new q(j,Oe,pe))}constructor(j,x,pe){this.c=j,this.d=x,this.f=pe,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Bj=q;class A{static create(j,x,pe=null){return C(x,Oe=>new A(j,Oe,pe))}constructor(j,x,pe){this.c=j,this.d=x,this.f=pe,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Cj=A;class U{static create(j,x){return new U(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const x=this.f?this.f.source:"",pe=j.f?j.f.source:"";return x<pe?-1:x>pe?1:0}equals(j){if(j.type===this.type){const x=this.f?this.f.source:"",pe=j.f?j.f.source:"";return this.d===j.d&&x===pe}return!1}substituteConstants(){return this}evaluate(j){const x=j.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Dj=U;class K{static create(j){return new K(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new K(this.c.map(j))}negate(){return this.c}}e.$Ej=K;function se(ne){let j=null;for(let x=0,pe=ne.length;x<pe;x++){const Oe=ne[x].substituteConstants();if(ne[x]!==Oe&&j===null){j=[];for(let ke=0;ke<x;ke++)j[ke]=ne[ke]}j!==null&&(j[x]=Oe)}return j===null?ne:j}class ce{static create(j,x,pe){return ce.d(j,x,pe)}constructor(j,x){this.expr=j,this.c=x,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let x=0,pe=this.expr.length;x<pe;x++){const Oe=$(this.expr[x],j.expr[x]);if(Oe!==0)return Oe}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let x=0,pe=this.expr.length;x<pe;x++)if(!this.expr[x].equals(j.expr[x]))return!1;return!0}return!1}substituteConstants(){const j=se(this.expr);return j===this.expr?this:ce.create(j,this.c,!1)}evaluate(j){for(let x=0,pe=this.expr.length;x<pe;x++)if(!this.expr[x].evaluate(j))return!1;return!0}static d(j,x,pe){const Oe=[];let ke=!1;for(const $e of j)if($e){if($e.type===1){ke=!0;continue}if($e.type===0)return l.INSTANCE;if($e.type===6){Oe.push(...$e.expr);continue}Oe.push($e)}if(Oe.length===0&&ke)return S.INSTANCE;if(Oe.length!==0){if(Oe.length===1)return Oe[0];Oe.sort($);for(let $e=1;$e<Oe.length;$e++)Oe[$e-1].equals(Oe[$e])&&(Oe.splice($e,1),$e--);if(Oe.length===1)return Oe[0];for(;Oe.length>1;){const $e=Oe[Oe.length-1];if($e.type!==9)break;Oe.pop();const fe=Oe.pop(),J=Oe.length===0,Y=ve.create($e.expr.map(he=>ce.create([he,fe],null,pe)),null,J);Y&&(Oe.push(Y),Oe.sort($))}if(Oe.length===1)return Oe[0];if(pe){for(let $e=0;$e<Oe.length;$e++)for(let fe=$e+1;fe<Oe.length;fe++)if(Oe[$e].negate().equals(Oe[fe]))return l.INSTANCE;if(Oe.length===1)return Oe[0]}return new ce(Oe,x)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const x of this.expr)j.push(...x.keys());return j}map(j){return new ce(this.expr.map(x=>x.map(j)),null)}negate(){if(!this.c){const j=[];for(const x of this.expr)j.push(x.negate());this.c=ve.create(j,this,!0)}return this.c}}e.$Fj=ce;class ve{static create(j,x,pe){return ve.d(j,x,pe)}constructor(j,x){this.expr=j,this.c=x,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let x=0,pe=this.expr.length;x<pe;x++){const Oe=$(this.expr[x],j.expr[x]);if(Oe!==0)return Oe}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let x=0,pe=this.expr.length;x<pe;x++)if(!this.expr[x].equals(j.expr[x]))return!1;return!0}return!1}substituteConstants(){const j=se(this.expr);return j===this.expr?this:ve.create(j,this.c,!1)}evaluate(j){for(let x=0,pe=this.expr.length;x<pe;x++)if(this.expr[x].evaluate(j))return!0;return!1}static d(j,x,pe){let Oe=[],ke=!1;if(j){for(let $e=0,fe=j.length;$e<fe;$e++){const J=j[$e];if(J){if(J.type===0){ke=!0;continue}if(J.type===1)return S.INSTANCE;if(J.type===9){Oe=Oe.concat(J.expr);continue}Oe.push(J)}}if(Oe.length===0&&ke)return l.INSTANCE;Oe.sort($)}if(Oe.length!==0){if(Oe.length===1)return Oe[0];for(let $e=1;$e<Oe.length;$e++)Oe[$e-1].equals(Oe[$e])&&(Oe.splice($e,1),$e--);if(Oe.length===1)return Oe[0];if(pe){for(let $e=0;$e<Oe.length;$e++)for(let fe=$e+1;fe<Oe.length;fe++)if(Oe[$e].negate().equals(Oe[fe]))return S.INSTANCE;if(Oe.length===1)return Oe[0]}return new ve(Oe,x)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const x of this.expr)j.push(...x.keys());return j}map(j){return new ve(this.expr.map(x=>x.map(j)),null)}negate(){if(!this.c){const j=[];for(const x of this.expr)j.push(x.negate());for(;j.length>1;){const x=j.shift(),pe=j.shift(),Oe=[];for(const ke of Fe(x))for(const $e of Fe(pe))Oe.push(ce.create([ke,$e],null,!1));j.unshift(ve.create(Oe,null,!1))}this.c=ve.create(j,this,!0)}return this.c}}e.$Gj=ve;class Ie extends d{static{this.d=[]}static all(){return Ie.d.values()}constructor(j,x,pe){super(j,null),this.f=x,typeof pe=="object"?Ie.d.push({...pe,key:j}):pe!==!0&&Ie.d.push({key:j,description:pe,type:x!=null?typeof x:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return D.create(this.key,j)}notEqualsTo(j){return w.create(this.key,j)}}e.$Hj=Ie,e.$Ij=(0,O.$qi)("contextKeyService");function ue(ne,j){return ne<j?-1:ne>j?1:0}function be(ne,j,x,pe){return ne<x?-1:ne>x?1:j<pe?-1:j>pe?1:0}function ie(ne,j){if(ne.type===0||j.type===1)return!0;if(ne.type===9)return j.type===9?Ce(ne.expr,j.expr):!1;if(j.type===9){for(const x of j.expr)if(ie(ne,x))return!0;return!1}if(ne.type===6){if(j.type===6)return Ce(j.expr,ne.expr);for(const x of ne.expr)if(ie(x,j))return!0;return!1}return ne.equals(j)}function Ce(ne,j){let x=0,pe=0;for(;x<ne.length&&pe<j.length;){const Oe=ne[x].cmp(j[pe]);if(Oe<0)return!1;Oe===0&&x++,pe++}return x===ne.length}function Fe(ne){return ne.type===9?ne.expr:[ne]}}),define(Re[190],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=void 0,e.$xi=(0,I.$qi)("environmentService"),e.$yi=(0,I.$ri)(e.$xi)}),define(Re[98],Ae([1,0,156,3]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.ExtensionGalleryErrorCode=e.$1o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$To=R,e.$Uo=O,e.$Vo=M,e.$Wo=p,e.$Xo=g,e.$Yo=k,e.$No="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Oo=new RegExp(e.$No),e.$Po="__web_extension",e.$Qo="skipWalkthrough",e.$Ro="extensionsSync",e.$So="dependecyOrPackExtensionInstall";function R(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(t,c){switch(t){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(t,c){return c==="web"&&!t.includes("web")}function g(t,c,h){return p(c,h)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===h}function k(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var N;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(N||(e.SortBy=N={}));var y;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var u;(function(t){t.Install="install",t.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var v;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$Zo=(0,T.$qi)("extensionGalleryService");var m;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Unknown="Unknown",t.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var s;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class o extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$1o=o;var r;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed"})(r||(e.ExtensionGalleryErrorCode=r={}));class n extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$2o=n,e.$3o=(0,T.$qi)("extensionManagementService"),e.$4o="extensionsIdentifiers/disabled",e.$5o="extensionsIdentifiers/enabled",e.$6o=(0,T.$qi)("IGlobalExtensionEnablementService"),e.$7o=(0,T.$qi)("IExtensionTipsService"),e.$8o=(0,I.localize2)(0,"Extensions"),e.$9o=(0,I.localize2)(1,"Preferences")}),define(Re[44],Ae([1,0,52,19,15,17,2,158,3,21,12,41]),function(ge,e,I,T,R,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$pl=e.FileKind=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.FileOperationResult=e.$hl=e.$gl=e.$fl=e.$dl=e.FileChangeType=e.$cl=e.FileOperation=e.$9k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Wk=void 0,e.$Xk=u,e.$Yk=s,e.$Zk=r,e.$1k=n,e.$2k=t,e.$3k=c,e.$4k=h,e.$5k=i,e.$6k=b,e.$7k=a,e.$8k=$,e.$0k=d,e.$$k=D,e.$_k=f,e.$al=E,e.$bl=w,e.$el=q,e.$ql=ve,e.$rl=Ie,e.$tl=be,e.$Wk=(0,g.$qi)("fileService");function u(ie){return ie.create===!0}var v;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var m;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function s(ie){const Ce=ie;return!!Ce&&typeof Ce.onDidChange=="function"}var o;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function r(ie){return!!(ie.capabilities&2)}function n(ie){return!!(ie.capabilities&8)}function t(ie){return!!(ie.capabilities&131072)}function c(ie){return!!(ie.capabilities&4)}function h(ie){return!!(ie.capabilities&16)}function i(ie){return r(ie)?!!(ie.capabilities&16384):!1}function b(ie){return r(ie)?!!(ie.capabilities&32768):!1}function a(ie){return!!(ie.capabilities&65536)}function $(ie){return!!(ie.capabilities&2048)}var l;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class S extends Error{static create(Ce,Fe){const ne=new S(Ce.toString(),Fe);return f(ne,Fe),ne}constructor(Ce,Fe){super(Ce),this.code=Fe}}e.$9k=S;function d(ie,Ce){return S.create(ie,Ce)}function D(ie){return ie||d((0,p.localize)(0,null),l.Unknown)}function f(ie,Ce){return ie.name=Ce?`${Ce} (FileSystemError)`:"FileSystemError",ie}function E(ie){if(!ie)return l.Unknown;if(ie instanceof S)return ie.code;const Ce=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!Ce)return l.Unknown;switch(Ce[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function w(ie){if(ie instanceof A)return ie.fileOperationResult;switch(E(ie)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}var P;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class C{constructor(Ce,Fe,ne){this.resource=Ce,this.operation=Fe,this.target=ne}isOperation(Ce){return this.operation===Ce}}e.$cl=C;var V;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class W{static{this.a=null}constructor(Ce,Fe){this.c=Fe,this.b=void 0,this.d=new y.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawAdded.map(j=>[j,!0])),ne}),this.f=new y.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawUpdated.map(j=>[j,!0])),ne}),this.g=new y.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawDeleted.map(j=>[j,!0])),ne}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ne of Ce){switch(ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}this.b!==W.a&&(typeof ne.cId=="number"?this.b===void 0?this.b=ne.cId:this.b!==ne.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(Ce,...Fe){return this.h(Ce,{includeChildren:!1},...Fe)}affects(Ce,...Fe){return this.h(Ce,{includeChildren:!0},...Fe)}h(Ce,Fe,...ne){if(!Ce)return!1;const j=ne.length>0;return!!((!j||ne.includes(1))&&(this.d.value.get(Ce)||Fe.includeChildren&&this.d.value.findSuperstr(Ce))||(!j||ne.includes(0))&&(this.f.value.get(Ce)||Fe.includeChildren&&this.f.value.findSuperstr(Ce))||(!j||ne.includes(2))&&(this.g.value.findSubstr(Ce)||Fe.includeChildren&&this.g.value.findSuperstr(Ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ce){return this.b===Ce}hasCorrelation(){return typeof this.b=="number"}}e.$dl=W;function q(ie,Ce,Fe){return!ie||!Ce||ie===Ce||Ce.length>ie.length?!1:(Ce.charAt(Ce.length-1)!==T.sep&&(Ce+=T.sep),Fe?(0,R.$uf)(ie,Ce):ie.indexOf(Ce)===0)}class A extends Error{constructor(Ce,Fe,ne){super(Ce),this.fileOperationResult=Fe,this.options=ne}}e.$fl=A;class U extends A{constructor(Ce,Fe,ne,j){super(Ce,Fe,j),this.fileOperationResult=Fe,this.size=ne}}e.$gl=U;class K extends A{constructor(Ce,Fe,ne){super(Ce,2,ne),this.stat=Fe}}e.$hl=K;var se;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(se||(e.FileOperationResult=se={})),e.$il={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$jl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$kl="files.associations",e.$ll="files.exclude",e.$ml="files.readonlyInclude",e.$nl="files.readonlyExclude",e.$ol="files.readonlyFromPermissions";var ce;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$pl="";function ve(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}async function Ie(ie,Ce){if(!Ce.hasProvider(M.URI.from({scheme:ie.scheme})))return new Promise(Fe=>{const ne=Ce.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===ie.scheme&&j.added&&(ne.dispose(),Fe())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(Ce){return(0,O.$8f)(Ce)||(Ce=0),Ce<ue.KB?(0,p.localize)(1,null,Ce.toFixed(0)):Ce<ue.MB?(0,p.localize)(2,null,(Ce/ue.KB).toFixed(2)):Ce<ue.GB?(0,p.localize)(3,null,(Ce/ue.MB).toFixed(2)):Ce<ue.TB?(0,p.localize)(4,null,(Ce/ue.GB).toFixed(2)):(0,p.localize)(5,null,(Ce/ue.TB).toFixed(2))}}e.$sl=ue;function be(ie){const Ce=typeof ie=="string"||ie?.scheme===N.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===N.Schemas.file?1024*ue.MB:Ce?10*ue.MB:k.$o?50*ue.MB:1024*ue.MB}}),define(Re[71],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class I{constructor(...R){this.a=new Map;for(const[O,M]of R)this.set(O,M)}set(R,O){const M=this.a.get(R);return this.a.set(R,O),M}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$oi=I}),define(Re[191],Ae([1,0,11,14,6,70,189,3,71,192]),function(ge,e,I,T,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;const N=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new g.$oi,r=!1,n,t=N){this.i=o,this.j=r,this.k=n,this.l=t,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$pi,this),this._globalGraph=t?n?._globalGraph??new M.$6q(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,R.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,R.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const r=new class extends u{dispose(){this.h.delete(r),super.dispose()}}(o,this.j,this,this.l);return this.h.add(r),r}invokeFunction(o,...r){this.m();const n=m.traceInvocation(this.l,o);let t=!1;try{return o({get:h=>{if(t)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(h,n);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...r)}finally{t=!0,n.stop()}}createInstance(o,...r){this.m();let n,t;return o instanceof O.$ni?(n=m.traceCreation(this.l,o.ctor),t=this.o(o.ctor,o.staticArguments.concat(r),n)):(n=m.traceCreation(this.l,o),t=this.o(o,r,n)),n.stop(),t}o(o,r=[],n){const t=p._util.getServiceDependencies(o).sort((i,b)=>i.index-b.index),c=[];for(const i of t){const b=this.s(i.id,n);b||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(b)}const h=t.length>0?t[0].index:r.length;if(r.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${r.length} static arguments`);const i=h-r.length;i>0?r=r.concat(new Array(i)):r=r.slice(0,h)}return Reflect.construct(o,r.concat(c))}q(o,r){if(this.i.get(o)instanceof O.$ni)this.i.set(o,r);else if(this.k)this.k.q(o,r);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const r=this.i.get(o);return!r&&this.k?this.k.r(o):r}s(o,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.r(o);return n instanceof O.$ni?this.u(o,n,r.branch(o,!0)):(r.branch(o,!1),n)}u(o,r,n){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,r,n)}finally{this.t.delete(o)}}v(o,r,n){const t=new M.$6q(i=>i.id.toString());let c=0;const h=[{id:o,desc:r,_trace:n}];for(;h.length;){const i=h.pop();if(t.lookupOrInsertNode(i),c++>1e3)throw new y(t);for(const b of p._util.getServiceDependencies(i.desc.ctor)){const a=this.r(b.id);if(a||this.y(`[createInstance] ${o} depends on ${b.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(b.id)),a instanceof O.$ni){const $={id:b.id,desc:a,_trace:i._trace.branch(b.id,!0)};t.insertEdge(i,$),h.push($)}}}for(;;){const i=t.roots();if(i.length===0){if(!t.isEmpty())throw new y(t);break}for(const{data:b}of i){if(this.r(b.id)instanceof O.$ni){const $=this.w(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this.q(b.id,$)}t.removeNode(b)}}return this.r(o)}w(o,r,n=[],t,c){if(this.i.get(o)instanceof O.$ni)return this.x(o,r,n,t,c,this.g);if(this.k)return this.k.w(o,r,n,t,c);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}x(o,r,n=[],t,c,h){if(t){const i=new u(void 0,this.j,this,this.l);i.c=String(o);const b=new Map,a=new I.$Jh(()=>{const $=i.o(r,n,c);for(const[l,S]of b){const d=$[l];if(typeof d=="function")for(const D of S)D.disposable=d.apply($,D.listener)}return b.clear(),h.add($),$});return new Proxy(Object.create(null),{get($,l){if(!a.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let D=b.get(l);return D||(D=new k.$5c,b.set(l,D)),(E,w,P)=>{if(a.isInitialized)return a.value[l](E,w,P);{const C={listener:[E,w,P],disposable:void 0},V=D.push(C);return(0,R.$Sc)(()=>{V(),C.disposable?.dispose()})}}}if(l in $)return $[l];const S=a.value;let d=S[l];return typeof d!="function"||(d=d.bind(S),$[l]=d),d},set($,l,S){return a.value[l]=S,!0},getPrototypeOf($){return r.prototype}})}else{const i=this.o(r,n,c);return h.add(i),i}}y(o,r){if(r&&console.warn(o),this.j)throw new Error(o)}}e.$7q=u;var v;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(v||(v={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,r){return o?new m(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,r){return o?new m(1,r.name):m.c}static{this.f=0}constructor(o,r){this.type=o,this.name=r,this.g=Date.now(),this.h=[]}branch(o,r){const n=new m(3,o.toString());return this.h.push([o,r,n]),n}stop(){const o=Date.now()-this.g;m.f+=o;let r=!1;function n(c,h){const i=[],b=new Array(c+1).join("	");for(const[a,$,l]of h.h)if($&&l){r=!0,i.push(`${b}CREATES -> ${a}`);const S=n(c+1,l);S&&i.push(S)}else i.push(`${b}uses -> ${a}`);return i.join(`
`)}const t=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||r)&&m.all.add(t.join(`
`))}}e.$8q=m}),define(Re[13],Ae([1,0,159,43,5,99,6,28,21,24,17,2,31,3]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$Zj=e.LogLevel=e.$Xj=e.$Wj=void 0,e.$Yj=s,e.log=r,e.$$j=d,e.$_j=D,e.$ak=f,e.$bk=E,e.$Wj=(0,v.$qi)("logService"),e.$Xj=(0,v.$qi)("loggerService");function m(){return new Date().toISOString()}function s(w){return(0,N.$8f)(w)}var o;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Zj=o.Info;function r(w,P,C){switch(P){case o.Trace:w.trace(C);break;case o.Debug:w.debug(C);break;case o.Info:w.info(C);break;case o.Warning:w.warn(C);break;case o.Error:w.error(C);break;case o.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function n(w,P=!1){let C="";for(let V=0;V<w.length;V++){let W=w[V];if(W instanceof Error&&(W=(0,T.$bj)(W,P)),typeof W=="object")try{W=JSON.stringify(W)}catch{}C+=(V>0?" ":"")+W}return C}class t extends M.$Uc{constructor(){super(...arguments),this.b=e.$Zj,this.c=this.B(new R.$be),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==o.Off&&this.b<=P}}e.$2j=t;class c extends t{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...C){this.f(o.Trace)&&this.g(o.Trace,n([P,...C],!0))}debug(P,...C){this.f(o.Debug)&&this.g(o.Debug,n([P,...C]))}info(P,...C){this.f(o.Info)&&this.g(o.Info,n([P,...C]))}warn(P,...C){this.f(o.Warning)&&this.g(o.Warning,n([P,...C]))}error(P,...C){if(this.f(o.Error))if(P instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=P.stack,this.g(o.Error,n(V))}else this.g(o.Error,n([P,...C]))}flush(){}}e.$3j=c;class h extends t{constructor(P=e.$Zj){super(),this.setLevel(P),this.g=!g.$i}trace(P,...C){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,P,...C):console.log(`[main ${m()}]`,P,...C))}debug(P,...C){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,P,...C):console.log(`[main ${m()}]`,P,...C))}info(P,...C){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,P,...C):console.log(`[main ${m()}]`,P,...C))}warn(P,...C){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,P,...C):console.warn(`[main ${m()}]`,P,...C))}error(P,...C){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,P,...C):console.error(`[main ${m()}]`,P,...C))}flush(){}}e.$4j=h;class i extends t{constructor(P=e.$Zj,C=!0){super(),this.g=C,this.setLevel(P)}trace(P,...C){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...C):console.log(P,...C))}debug(P,...C){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...C):console.log(P,...C))}info(P,...C){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...C):console.log(P,...C))}warn(P,...C){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...C):console.log(P,...C))}error(P,...C){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...C):console.error(P,...C))}flush(){}}e.$5j=i;class b extends t{constructor(P,C=e.$Zj){super(),this.g=P,this.setLevel(C)}trace(P,...C){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(P),...C])}debug(P,...C){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(P),...C])}info(P,...C){this.f(o.Info)&&this.g.log(o.Info,[this.h(P),...C])}warn(P,...C){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(P),...C])}error(P,...C){this.f(o.Error)&&this.g.log(o.Error,[this.h(P),...C])}h(P){return typeof P=="string"?P:(0,T.$bj)(P,this.f(o.Trace))}flush(){}}e.$6j=b;class a extends t{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const C of this.g)C.setLevel(P);super.setLevel(P)}trace(P,...C){for(const V of this.g)V.trace(P,...C)}debug(P,...C){for(const V of this.g)V.debug(P,...C)}info(P,...C){for(const V of this.g)V.info(P,...C)}warn(P,...C){for(const V of this.g)V.warn(P,...C)}error(P,...C){for(const V of this.g)V.error(P,...C)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$7j=a;class $ extends M.$Uc{constructor(P,C,V){if(super(),this.h=P,this.j=C,this.b=new p.$Bc,this.c=this.B(new R.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$be),this.onDidChangeVisibility=this.g.event,V)for(const W of V)this.b.set(W.resource,{logger:void 0,info:W})}m(P){return(0,N.$4f)(P)?[...this.b.values()].find(C=>C.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,C){const V=this.n(P),W=(0,N.$4f)(P)?P:C?.id??(0,O.$ej)(V.toString()).toString(16);let q=this.b.get(V)?.logger;const A=C?.logLevel==="always"?o.Trace:C?.logLevel;q||(q=this.s(V,A??this.getLogLevel(V)??this.h,{...C,id:W}));const U={logger:q,info:{resource:V,id:W,logLevel:A,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(U.info),this.b.set(V,U),q}n(P){return(0,N.$4f)(P)?(0,k.$4g)(this.j,`${P}.log`):P}setLogLevel(P,C){if(y.URI.isUri(P)){const V=P,W=C,q=this.b.get(V);q&&W!==q.info.logLevel&&(q.info.logLevel=W===this.h?void 0:W,q.logger?.setLevel(W),this.b.set(q.info.resource,q),this.f.fire([V,W]))}else{this.h=P;for(const[V,W]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,C){const V=this.m(P);V&&C!==!V.info.hidden&&(V.info.hidden=!C,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,C]))}getLogLevel(P){let C;return P&&(C=this.b.get(P)?.info.logLevel),C??this.h}registerLogger(P){const C=this.b.get(P.resource);C?C.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const C=this.b.get(P);C&&(C.logger&&C.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$8j=$;class l{constructor(){this.onDidChangeLogLevel=new R.$be().event}setLevel(P){}getLevel(){return o.Info}trace(P,...C){}debug(P,...C){}info(P,...C){}warn(P,...C){}error(P,...C){}critical(P,...C){}dispose(){}flush(){}}e.$9j=l;class S extends l{}e.$0j=S;function d(w){if(w.verbose)return o.Trace;if(typeof w.logLevel=="string"){const P=E(w.logLevel.toLowerCase());if(P!==void 0)return P}return e.$Zj}function D(w){switch(w){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function f(w){switch(w){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function E(w){switch(w){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$ck=new u.$Hj("logLevel",D(o.Info))}),define(Re[193],Ae([1,0,6,13]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BQ=void 0;class R extends I.$Uc{constructor(M,p=[]){super(),this.a=new T.$7j([M,...p]),this.B(M.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...p){this.a.trace(M,...p)}debug(M,...p){this.a.debug(M,...p)}info(M,...p){this.a.info(M,...p)}warn(M,...p){this.a.warn(M,...p)}error(M,...p){this.a.error(M,...p)}flush(){this.a.flush()}}e.$BQ=R}),define(Re[100],Ae([1,0,33,160,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var M;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(g){function k(m,s){return s-m}g.compare=k;const N=Object.create(null);N[g.Error]=(0,T.localize)(0,null),N[g.Warning]=(0,T.localize)(1,null),N[g.Info]=(0,T.localize)(2,null);function y(m){return N[m]||""}g.toString=y;function u(m){switch(m){case I.default.Error:return g.Error;case I.default.Warning:return g.Warning;case I.default.Info:return g.Info;case I.default.Ignore:return g.Hint}}g.fromSeverity=u;function v(m){switch(m){case g.Error:return I.default.Error;case g.Warning:return I.default.Warning;case g.Info:return I.default.Info;case g.Hint:return I.default.Ignore}}g.toSeverity=v}(M||(e.MarkerSeverity=M={}));var p;(function(g){const k="";function N(u){return y(u,!0)}g.makeKey=N;function y(u,v){const m=[k];return u.source?m.push(u.source.replace("\xA6","\\\xA6")):m.push(k),u.code?typeof u.code=="string"?m.push(u.code.replace("\xA6","\\\xA6")):m.push(u.code.value.replace("\xA6","\\\xA6")):m.push(k),u.severity!==void 0&&u.severity!==null?m.push(M.toString(u.severity)):m.push(k),u.message&&v?m.push(u.message.replace("\xA6","\\\xA6")):m.push(k),u.startLineNumber!==void 0&&u.startLineNumber!==null?m.push(u.startLineNumber.toString()):m.push(k),u.startColumn!==void 0&&u.startColumn!==null?m.push(u.startColumn.toString()):m.push(k),u.endLineNumber!==void 0&&u.endLineNumber!==null?m.push(u.endLineNumber.toString()):m.push(k),u.endColumn!==void 0&&u.endColumn!==null?m.push(u.endColumn.toString()):m.push(k),m.push(k),m.join("\xA6")}g.makeKeyOptionalMessage=y})(p||(e.IMarkerData=p={})),e.$Tt=(0,R.$qi)("markerService")}),define(Re[194],Ae([1,0,5,33,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Tv=e.Severity=void 0,e.$Uv=p,e.Severity=T.default,e.$Tv=(0,R.$qi)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var M;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function p(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var g;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(g||(e.NotificationsFilter=g={}));class k{constructor(){this.progress=new N,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Vv=k;class N{infinite(){}done(){}total(u){}worked(u){}}e.$Wv=N}),define(Re[195],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$dk=(0,I.$qi)("productService"),e.$ek="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,I,T){var R=arguments.length,O=R<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,I):T,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ge,e,I,T);else for(var p=ge.length-1;p>=0;p--)(M=ge[p])&&(O=(R<3?M(O):R>3?M(e,I,O):M(e,I))||O);return R>3&&O&&Object.defineProperty(e,I,O),O},Ve=this&&this.__param||function(ge,e){return function(I,T){e(I,T,ge)}};define(Re[101],Ae([1,0,11,22,6,3]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.ProgressLocation=e.$Xv=void 0,e.$Xv=(0,O.$qi)("progressService");var M;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Yv=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Zv=p;class g{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const v=this.d;this.d=()=>{v?.(),u()}}):Promise.resolve()}}e.$1v=g;let k=class extends R.$Uc{constructor(u,v){super(),this.a=new I.$Nh,v.withProgress(u,m=>(this.b=m,this.c&&m.report(this.c),this.a.p)),this.B((0,R.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$2v=k,e.$2v=k=Je([Ve(1,e.$Xv)],k);class N extends R.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new R.$Tc)}start(u){this.stop();const v=++this.a,m=new T.$me;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,R.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Sc)(()=>m.cancel())),this.b.add((0,R.$Sc)(()=>this.c?this.c.done():void 0)),{id:v,token:m.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$3v=N,e.$4v=(0,O.$qi)("editorProgressService")}),define(Re[30],Ae([1,0,56,17]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=void 0;class R{constructor(){this.a=new Map}add(M,p){I.ok(T.$4f(M)),I.ok(T.$6f(p)),I.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,p)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$9n=new R}),define(Re[72],Ae([1,0,5,30]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0,e.$0n={JSONContribution:"base.contributions.json"};function R(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class O{constructor(){this.b=new I.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,k){this.a[R(g)]=k,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const M=new O;T.$9n.add(e.$0n.JSONContribution,M)}),define(Re[57],Ae([1,0,18,5,17,153,48,72,30]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ConfigurationScope=e.$bo=e.EditPresentationTypes=void 0,e.$mo=s,e.$no=o,e.$oo=r,e.$po=t,e.$qo=c;var k;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$bo={Configuration:"base.contributions.configuration"};var N;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N||(e.ConfigurationScope=N={})),e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io="vscode://schemas/settings/resourceLanguage",e.$jo="vscode://schemas/settings/configurationDefaults";const y=g.$9n.as(p.$0n.JSONContribution);class u{constructor(){this.h=new Set,this.i=new T.$be,this.onDidSchemaChange=this.i.event,this.j=new T.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$io,this.g),this.v()}registerConfiguration(i,b=!0){this.registerConfigurations([i],b)}registerConfigurations(i,b=!0){const a=new Set;this.n(i,b,a),y.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(i){const b=new Set;this.o(i,b),y.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:b})}updateConfigurations({add:i,remove:b}){const a=new Set;this.o(b,a),this.n(i,!1,a),y.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(i){const b=new Set;this.k(i,b),this.i.fire(),this.j.fire({properties:b,defaultsOverrides:!0})}k(i,b){const a=[];for(const{overrides:$,source:l}of i)for(const S in $)if(b.add(S),e.$lo.test(S)){const d=this.a.get(S),D=d?.valuesSources??new Map;if(l)for(const P of Object.keys($[S]))D.set(P,l);const f={...d?.value||{},...$[S]};this.a.set(S,{source:l,value:f,valuesSources:D});const E=(0,M.$7i)(S),w={type:"object",default:f,description:O.localize(1,null,E),$ref:e.$io,defaultDefaultValue:f,source:R.$4f(l)?void 0:l,defaultValueSource:l};a.push(...s(S)),this.d[S]=w,this.b.properties[S]=w}else{this.a.set(S,{value:$[S],source:l});const d=this.d[S];d&&(this.w(S,d),this.r(S,d))}this.m(a)}deregisterDefaultConfigurations(i){const b=new Set;this.l(i,b),this.i.fire(),this.j.fire({properties:b,defaultsOverrides:!0})}l(i,b){for(const{overrides:a,source:$}of i)for(const l in a){const S=this.a.get(l),d=R.$4f($)?$:$?.id,D=R.$4f(S?.source)?S?.source:S?.source?.id;if(d===D)if(b.add(l),this.a.delete(l),e.$lo.test(l))delete this.d[l],delete this.b.properties[l];else{const f=this.d[l];f&&(this.w(l,f),this.r(l,f))}}this.u()}deltaConfiguration(i){let b=!1;const a=new Set;i.removedDefaults&&(this.l(i.removedDefaults,a),b=!0),i.addedDefaults&&(this.k(i.addedDefaults,a),b=!0),i.removedConfigurations&&this.o(i.removedConfigurations,a),i.addedConfigurations&&this.n(i.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:b})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const b of i)this.h.add(b);this.u()}n(i,b,a){i.forEach($=>{this.p($,b,$.extensionInfo,$.restrictedProperties,void 0,a),this.c.push($),this.q($)})}o(i,b){const a=$=>{if($.properties)for(const l in $.properties){b.add(l);const S=this.d[l];S?.policy?.name&&this.e.delete(S.policy.name),delete this.d[l],this.s(l,$.properties[l])}$.allOf?.forEach(l=>a(l))};for(const $ of i){a($);const l=this.c.indexOf($);l!==-1&&this.c.splice(l,1)}}p(i,b=!0,a,$,l=3,S){l=R.$ag(i.scope)?l:i.scope;const d=i.properties;if(d)for(const f in d){const E=d[f];if(b&&t(f,E)){delete d[f];continue}if(E.source=a,E.defaultDefaultValue=d[f].default,this.w(f,E),e.$lo.test(f)?E.scope=void 0:(E.scope=R.$ag(E.scope)?l:E.scope,E.restricted=R.$ag(E.restricted)?!!$?.includes(f):E.restricted),d[f].hasOwnProperty("included")&&!d[f].included){this.f[f]=d[f],delete d[f];continue}else this.d[f]=d[f],d[f].policy?.name&&this.e.set(d[f].policy.name,f);!d[f].deprecationMessage&&d[f].markdownDeprecationMessage&&(d[f].deprecationMessage=d[f].markdownDeprecationMessage),S.add(f)}const D=i.allOf;if(D)for(const f of D)this.p(f,b,a,$,l,S)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const b=a=>{const $=a.properties;if($)for(const S in $)this.r(S,$[S]);a.allOf?.forEach(b)};b(i)}r(i,b){switch(e.$co.properties[i]=b,b.scope){case 1:e.$do.properties[i]=b;break;case 2:e.$eo.properties[i]=b;break;case 6:e.$fo.properties[i]=b;break;case 3:e.$go.properties[i]=b;break;case 4:e.$ho.properties[i]=b;break;case 5:e.$ho.properties[i]=b,this.g.properties[i]=b;break}}s(i,b){switch(delete e.$co.properties[i],b.scope){case 1:delete e.$do.properties[i];break;case 2:delete e.$eo.properties[i];break;case 6:delete e.$fo.properties[i];break;case 3:delete e.$go.properties[i];break;case 4:case 5:delete e.$ho.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const b=`[${i}]`,a={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$io};this.w(b,a),e.$co.properties[b]=a,e.$do.properties[b]=a,e.$eo.properties[b]=a,e.$fo.properties[b]=a,e.$go.properties[b]=a,e.$ho.properties[b]=a}}v(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$io};e.$co.patternProperties[e.$ko]=i,e.$do.patternProperties[e.$ko]=i,e.$eo.patternProperties[e.$ko]=i,e.$fo.patternProperties[e.$ko]=i,e.$go.patternProperties[e.$ko]=i,e.$ho.patternProperties[e.$ko]=i,this.i.fire()}w(i,b){const a=this.a.get(i);let $=a?.value,l=a?.source;R.$$f($)&&($=b.defaultDefaultValue,l=void 0),R.$$f($)&&($=r(b.type)),b.default=$,b.defaultValueSource=l}}const v="\\[([^\\]]+)\\]",m=new RegExp(v,"g");e.$ko=`^(${v})+$`,e.$lo=new RegExp(e.$ko);function s(h){const i=[];if(e.$lo.test(h)){let b=m.exec(h);for(;b?.length;){const a=b[1].trim();a&&i.push(a),b=m.exec(h)}}return(0,I.$Mb)(i)}function o(h){return h.reduce((i,b)=>`${i}[${b}]`,"")}function r(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new u;g.$9n.add(e.$bo.Configuration,n);function t(h,i){return h.trim()?e.$lo.test(h)?O.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?O.localize(8,null,h):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,h,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}function c(){const h=[],i=n.getConfigurationProperties();for(const b of Object.keys(i))h.push([b,i[b].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Re[196],Ae([1,0,18,5,123,6,28,26,17,2,48,57,30]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$uo=e.$to=e.$so=e.$ro=void 0,e.$vo=t;function v(b){return Object.isFrozen(b)?b:p.$Xn(b)}class m{static createEmptyModel(a){return new m({},[],[],void 0,a)}constructor(a,$,l,S,d){this.b=a,this.c=$,this.d=l,this.raw=S,this.f=d,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map($=>{if($ instanceof m)return $;const l=new s("",this.f);return l.parseRaw($),l.configurationModel});this.g=a.reduce(($,l)=>l===$?l:$.merge(l),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,N.$5i)(this.contents,a):this.contents}inspect(a,$){const l=this;return{get value(){return v(l.rawConfiguration.getValue(a))},get override(){return $?v(l.rawConfiguration.getOverrideValue(a,$)):void 0},get merged(){return v($?l.rawConfiguration.override($).getValue(a):l.rawConfiguration.getValue(a))},get overrides(){const S=[];for(const{contents:d,identifiers:D,keys:f}of l.rawConfiguration.overrides){const E=new m(d,f,[],void 0,l.f).getValue(a);E!==void 0&&S.push({identifiers:D,value:E})}return S.length?v(S):void 0}}}getOverrideValue(a,$){const l=this.j($);return l?a?(0,N.$5i)(l,a):l:void 0}getKeysForOverrideIdentifier(a){const $=[];for(const l of this.overrides)l.identifiers.includes(a)&&$.push(...l.keys);return I.$Mb($)}getAllOverrideIdentifiers(){const a=[];for(const $ of this.overrides)a.push(...$.identifiers);return I.$Mb(a)}override(a){let $=this.a.get(a);return $||($=this.h(a),this.a.set(a,$)),$}merge(...a){const $=p.$Wn(this.contents),l=p.$Wn(this.overrides),S=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const D of a)if(d.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i($,D.contents);for(const f of D.overrides){const[E]=l.filter(w=>I.$ub(w.identifiers,f.identifiers));E?(this.i(E.contents,f.contents),E.keys.push(...f.keys),E.keys=I.$Mb(E.keys)):l.push(p.$Wn(f))}for(const f of D.keys)S.indexOf(f)===-1&&S.push(f)}return new m($,S,l,d.every(D=>D instanceof m)?void 0:d,this.f)}h(a){const $=this.j(a);if(!$||typeof $!="object"||!Object.keys($).length)return this;const l={};for(const S of I.$Mb([...Object.keys(this.contents),...Object.keys($)])){let d=this.contents[S];const D=$[S];D&&(typeof d=="object"&&typeof D=="object"?(d=p.$Wn(d),this.i(d,D)):d=D),l[S]=d}return new m(l,this.keys,this.overrides,void 0,this.f)}i(a,$){for(const l of Object.keys($)){if(l in a&&g.$6f(a[l])&&g.$6f($[l])){this.i(a[l],$[l]);continue}a[l]=p.$Wn($[l])}}j(a){let $=null,l=null;const S=d=>{d&&(l?this.i(l,d):l=p.$Wn(d))};for(const d of this.overrides)d.identifiers.length===1&&d.identifiers[0]===a?$=d.contents:d.identifiers.includes(a)&&S(d.contents);return S($),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,$){this.k(a,$,!0)}setValue(a,$){this.k(a,$,!1)}removeValue(a){const $=this.keys.indexOf(a);$!==-1&&(this.keys.splice($,1),(0,N.$4i)(this.contents,a),y.$lo.test(a)&&this.overrides.splice(this.overrides.findIndex(l=>I.$ub(l.identifiers,(0,y.$mo)(a))),1))}k(a,$,l){(0,N.$3i)(this.contents,a,$,S=>this.f.error(S)),l=l||this.keys.indexOf(a)===-1,l&&this.keys.push(a),y.$lo.test(a)&&this.overrides.push({identifiers:(0,y.$mo)(a),keys:Object.keys(this.contents[a]),contents:(0,N.$2i)(this.contents[a],S=>this.f.error(S))})}}e.$ro=m;class s{constructor(a,$){this.f=a,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,$){if(!g.$ag(a)){const l=this.h(a);this.parseRaw(l,$)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,$){this.a=a;const{contents:l,keys:S,overrides:d,restricted:D,hasExcludedProperties:f}=this.i(a,$);this.b=new m(l,S,d,f?[a]:void 0,this.g),this.c=D||[]}h(a){let $={},l=null,S=[];const d=[],D=[];function f(w){Array.isArray(S)?S.push(w):l!==null&&(S[l]=w)}const E={onObjectBegin:()=>{const w={};f(w),d.push(S),S=w,l=null},onObjectProperty:w=>{l=w},onObjectEnd:()=>{S=d.pop()},onArrayBegin:()=>{const w=[];f(w),d.push(S),S=w,l=null},onArrayEnd:()=>{S=d.pop()},onLiteralValue:f,onError:(w,P,C)=>{D.push({error:w,offset:P,length:C})}};if(a)try{R.$Kn(a,E),$=S[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return $}i(a,$){const l=u.$9n.as(y.$bo.Configuration).getConfigurationProperties(),S=this.j(a,l,!0,$);a=S.raw;const d=(0,N.$2i)(a,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),D=Object.keys(a),f=this.l(a,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:d,keys:D,overrides:f,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(a,$,l,S){let d=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:d};const D={},f=[];for(const E in a)if(y.$lo.test(E)&&l){const w=this.j(a[E],$,!1,S);D[E]=w.raw,d=d||w.hasExcludedProperties,f.push(...w.restricted)}else{const w=$[E],P=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&f.push(E),!S.exclude?.includes(E)&&(S.include?.includes(E)||(P===void 0||S.scopes===void 0||S.scopes.includes(P))&&!(S.skipRestricted&&w?.restricted))?D[E]=a[E]:d=!0}return{raw:D,restricted:f,hasExcludedProperties:d}}l(a,$){const l=[];for(const S of Object.keys(a))if(y.$lo.test(S)){const d={};for(const D in a[S])d[D]=a[S][D];l.push({identifiers:(0,y.$mo)(S),keys:Object.keys(d),contents:(0,N.$2i)(d,$)})}return l}}e.$so=s;class o extends O.$Uc{constructor(a,$,l,S,d){super(),this.c=a,this.f=$,this.g=S,this.h=d,this.b=this.B(new T.$be),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),d),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&l.isEqual(D.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$to=o;class r{constructor(a,$,l,S,d,D,f,E,w,P,C,V,W){this.a=a,this.b=$,this.c=l,this.overrideIdentifiers=S,this.d=d,this.f=D,this.g=f,this.h=E,this.i=w,this.j=P,this.k=C,this.l=V,this.m=W}get value(){return v(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,$,l,S,d,D,f,E,w,P){this.j=a,this.l=$,this.m=l,this.n=S,this.p=d,this.q=D,this.r=f,this.s=E,this.t=w,this.u=P,this.h=null,this.i=new M.$Bc,this.v=null}getValue(a,$,l){return this.w(a,$,l).getValue(a)}updateValue(a,$,l={}){let S;l.resource?(S=this.t.get(l.resource),S||(S=m.createEmptyModel(this.u),this.t.set(l.resource,S))):S=this.s,$===void 0?S.removeValue(a):S.setValue(a,$),l.resource||(this.h=null)}inspect(a,$,l){const S=this.w(a,$,l),d=this.A($.resource,l),D=$.resource?this.t.get($.resource)||this.s:this.s,f=new Set;for(const E of S.overrides)for(const w of E.identifiers)S.getOverrideValue(a,w)!==void 0&&f.add(w);return new r(a,$,S.getValue(a),f.size?[...f]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.q:void 0,d||void 0,D)}keys(a){const $=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,$){this.r.set(a,$),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,$){const l=[];if(!$){const{added:S,updated:d,removed:D}=h(this.j,a);$=[...S,...d,...D]}for(const S of $)for(const d of(0,y.$mo)(S)){const D=this.j.getKeysForOverrideIdentifier(d),f=a.getKeysForOverrideIdentifier(d),E=[...f.filter(w=>D.indexOf(w)===-1),...D.filter(w=>f.indexOf(w)===-1),...D.filter(w=>!p.$1n(this.j.override(d).getValue(w),a.override(d).getValue(w)))];l.push([d,E])}return this.updateDefaultConfiguration(a),{keys:$,overrides:l}}compareAndUpdatePolicyConfiguration(a){const{added:$,updated:l,removed:S}=h(this.l,a),d=[...$,...l,...S];return d.length&&this.updatePolicyConfiguration(a),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:$,updated:l,removed:S,overrides:d}=h(this.applicationConfiguration,a),D=[...$,...l,...S];return D.length&&this.updateApplicationConfiguration(a),{keys:D,overrides:d}}compareAndUpdateLocalUserConfiguration(a){const{added:$,updated:l,removed:S,overrides:d}=h(this.localUserConfiguration,a),D=[...$,...l,...S];return D.length&&this.updateLocalUserConfiguration(a),{keys:D,overrides:d}}compareAndUpdateRemoteUserConfiguration(a){const{added:$,updated:l,removed:S,overrides:d}=h(this.remoteUserConfiguration,a),D=[...$,...l,...S];return D.length&&this.updateRemoteUserConfiguration(a),{keys:D,overrides:d}}compareAndUpdateWorkspaceConfiguration(a){const{added:$,updated:l,removed:S,overrides:d}=h(this.workspaceConfiguration,a),D=[...$,...l,...S];return D.length&&this.updateWorkspaceConfiguration(a),{keys:D,overrides:d}}compareAndUpdateFolderConfiguration(a,$){const l=this.folderConfigurations.get(a),{added:S,updated:d,removed:D,overrides:f}=h(l,$),E=[...S,...d,...D];return(E.length||!l)&&this.updateFolderConfiguration(a,$),{keys:E,overrides:f}}compareAndDeleteFolderConfiguration(a){const $=this.folderConfigurations.get(a);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:l,updated:S,removed:d,overrides:D}=h($,void 0);return{keys:[...l,...S,...d],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,$,l){let S=this.x($,l);return $.overrideIdentifier&&(S=S.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(S=S.merge(this.l)),S}x({resource:a},$){let l=this.y();if($&&a){const S=$.getFolder(a);S&&(l=this.z(S.uri)||l);const d=this.t.get(a);d&&(l=l.merge(d))}return l}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let $=this.i.get(a);if(!$){const l=this.y(),S=this.r.get(a);S?($=l.merge(S),this.i.set(a,$)):$=l}return $}A(a,$){if($&&a){const l=$.getFolder(a);if(l)return this.r.get(l.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,$)=>{const{contents:l,overrides:S,keys:d}=this.r.get($);return a.push([$,{contents:l,overrides:S,keys:d}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach($=>a.add($)),this.userConfiguration.keys.forEach($=>a.add($)),this.q.keys.forEach($=>a.add($)),this.r.forEach($=>$.keys.forEach(l=>a.add(l))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>a.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>a.add($)),this.q.getAllOverrideIdentifiers().forEach($=>a.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(l=>a.add(l))),[...a.values()]}D(a){const $=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(l=>$.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(l=>$.add(l)),this.q.getKeysForOverrideIdentifier(a).forEach(l=>$.add(l)),this.r.forEach(l=>l.getKeysForOverrideIdentifier(a).forEach(S=>$.add(S))),[...$.values()]}static parse(a,$){const l=this.E(a.defaults,$),S=this.E(a.policy,$),d=this.E(a.application,$),D=this.E(a.user,$),f=this.E(a.workspace,$),E=a.folders.reduce((w,P)=>(w.set(k.URI.revive(P[0]),this.E(P[1],$)),w),new M.$Bc);return new n(l,S,d,D,m.createEmptyModel($),f,E,m.createEmptyModel($),new M.$Bc,$)}static E(a,$){return new m(a.contents,a.keys,a.overrides,void 0,$)}}e.$uo=n;function t(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const a=new Set,$=new Map;for(const S of b)S.keys.forEach(d=>a.add(d)),S.overrides.forEach(([d,D])=>{const f=(0,M.$yc)($,d,new Set);D.forEach(E=>f.add(E))});const l=[];return $.forEach((S,d)=>l.push([d,[...S.values()]])),{keys:[...a.values()],overrides:l}}class c{constructor(a,$,l,S,d){this.change=a,this.f=$,this.g=l,this.h=S,this.i=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of a.keys)this.affectedKeys.add(D);for(const[,D]of a.overrides)for(const f of D)this.affectedKeys.add(f);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,$){const l=this.a+a,S=this.d.indexOf(l);if(S<0)return!1;const d=S+l.length;if(d>=this.d.length)return!1;const D=this.d.charCodeAt(d);if(D!==this.b&&D!==this.c)return!1;if($){const f=this.previousConfiguration?this.previousConfiguration.getValue(a,$,this.f?.workspace):void 0,E=this.g.getValue(a,$,this.h);return!p.$1n(f,E)}return!0}}e.$wo=c;function h(b,a){const{added:$,removed:l,updated:S}=i(a?.rawConfiguration,b?.rawConfiguration),d=[],D=b?.getAllOverrideIdentifiers()||[],f=a?.getAllOverrideIdentifiers()||[];if(a){const E=f.filter(w=>!D.includes(w));for(const w of E)d.push([w,a.getKeysForOverrideIdentifier(w)])}if(b){const E=D.filter(w=>!f.includes(w));for(const w of E)d.push([w,b.getKeysForOverrideIdentifier(w)])}if(a&&b){for(const E of D)if(f.includes(E)){const w=i({contents:b.getOverrideValue(void 0,E)||{},keys:b.getKeysForOverrideIdentifier(E)},{contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)});d.push([E,[...w.added,...w.removed,...w.updated]])}}return{added:$,removed:l,updated:S,overrides:d}}function i(b,a){const $=b?a?b.keys.filter(d=>a.keys.indexOf(d)===-1):[...b.keys]:[],l=a?b?a.keys.filter(d=>b.keys.indexOf(d)===-1):[...a.keys]:[],S=[];if(b&&a){for(const d of a.keys)if(b.keys.indexOf(d)!==-1){const D=(0,N.$5i)(a.contents,d),f=(0,N.$5i)(b.contents,d);p.$1n(D,f)||S.push(d)}}return{added:$,removed:l,updated:S}}}),define(Re[102],Ae([1,0,14,3]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.RemoteAuthorityResolverErrorCode=e.$Dl=e.$Cl=e.RemoteConnectionType=e.$Bl=void 0,e.$Fl=k,e.$Bl=(0,T.$qi)("remoteAuthorityResolverService");var R;(function(N){N[N.WebSocket=0]="WebSocket",N[N.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class O{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Cl=O;class M{constructor(y,u){this.host=y,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Dl=M;var p;(function(N){N.Unknown="Unknown",N.NotAvailable="NotAvailable",N.TemporarilyNotAvailable="TemporarilyNotAvailable",N.NoResolverFound="NoResolverFound",N.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class g extends I.$bb{static isNotAvailable(y){return y instanceof g&&y._code===p.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof g&&y._code===p.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof g&&y._code===p.NoResolverFound}static isInvalidAuthority(y){return y instanceof g&&y._code===p.InvalidAuthority}static isHandled(y){return y instanceof g&&y.isHandled}constructor(y,u=p.Unknown,v){super(y),this._message=y,this._code=u,this._detail=v,this.isHandled=u===p.NotAvailable&&v===!0,Object.setPrototypeOf(this,g.prototype)}}e.$El=g;function k(N){const y=N.indexOf("+");return y===-1?N:N.substring(0,y)}}),define(Re[58],Ae([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=T,e.$Cm=R,e.$Dm=O,e.$Em=M;function T(g){return g.scheme===I.Schemas.vscodeRemote?g.authority:void 0}function R(g){if(!g)return;const k=g.indexOf("+");return k<0?g:g.substr(0,k)}function O(g){const{host:k,port:N}=p(g);if(typeof N>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:N}}function M(g,k){let{host:N,port:y}=p(g);return typeof y>"u"&&(y=k),{host:N,port:y}}function p(g){const k=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const N=g.match(/^(\[[0-9a-z:]+\])$/);if(N)return{host:N[1],port:void 0};const y=g.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:g,port:void 0}}}),define(Re[20],Ae([1,0,15,3,58]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Nm=e.$Mm=e.$Lm=e.TargetPlatform=e.ExtensionType=e.$Km=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0,e.$Jm=O,e.$Om=y,e.$Pm=u,e.$Qm=v,e.$Rm=m,e.$Fm="extensions.user.cache",e.$Gm="extensions.builtin.cache",e.$Hm="undefined_publisher",e.$Im=["ui","workspace","web"];function O(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$Km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(M||(e.ExtensionType=M={}));var p;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,r){if(typeof o>"u"||o===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof o=="string"||typeof r=="string"){const n=typeof o=="string"?o:o.value,t=typeof r=="string"?r:r.value;return I.$tf(n,t)}return o._lower===r._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Lm=g;class k{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const r of o)this.add(r)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$Mm=k;class N{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,r){this.c.set(g.toKey(o),r)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Nm=N;function y(s){return u(s)}function u(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function v(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function m(s,o){if(o){const r=`onResolveRemoteAuthority:${(0,R.$Cm)(o)}`;return!!s.activationEvents?.includes(r)}return!1}e.$Sm=(0,T.$qi)("IBuiltinExtensionsScannerService")}),define(Re[103],Ae([1,0,14,20]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(M,p){this.a.set(M,p)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const p=Object.create(null);for(const g of M){const k=this.readActivationEvents(g);k.length>0&&(p[T.$Lm.toKey(g.identifier)]=k)}return p}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const p=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let g=0;g<p.length;g++)p[g]==="onUri"&&(p[g]=`onUri:${T.$Lm.toKey(M.identifier)}`);if(!M.contributes)return p;for(const g in M.contributes){const k=this.a.get(g);if(!k)continue;const N=M.contributes[g],y=Array.isArray(N)?N:[N];try{k(y,p)}catch(u){(0,I.$1)(u)}}return p}}e.$cG=R,e.$dG=new R}),define(Re[197],Ae([1,0,21,73,35]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=M,e.$$o=p;function O(g){if(I.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function M(g,k,N,y,u,v,m,s,o){const r=Object.create(null);r["common.machineId"]=v,r["common.sqmId"]=m,r.sessionID=(0,R.$Mg)()+Date.now(),r.commitHash=y,r.version=u,r["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,I.$h)(I.$u),r["common.nodePlatform"]=T.$ec,r["common.nodeArch"]=N,r["common.product"]=o||"desktop",s&&(r["common.msftInternal"]=s);let n=0;const t=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),I.$l&&(r["common.snap"]="true");const c=O(k);return c&&(r["common.platformDetail"]=c),r}function p(g){const k=T.env.USERDNSDOMAIN;if(!k)return!1;const N=k.toLowerCase();return g.some(y=>N===y)}}),define(Re[198],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=(0,I.$qi)("telemetryService"),e.$Wl=(0,I.$qi)("customEndpointTelemetryService"),e.$Xl="telemetry.currentSessionDate",e.$Yl="telemetry.firstSessionDate",e.$Zl="telemetry.lastSessionDate",e.$1l="telemetry.machineId",e.$2l="telemetry.sqmId",e.$3l="telemetry",e.$4l="telemetry.telemetryLevel",e.$5l="telemetry.enableCrashReporter",e.$6l="telemetry.enableTelemetry";var T;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var R;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Re[59],Ae([1,0,26,17,58,197,198]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=N,e.$hp=y,e.$ip=u,e.$jp=v,e.$kp=s,e.$lp=r,e.$mp=n,e.$np=h;class p{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.$_o=p;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ap=g,e.$bp=new g;class k{async publicLog(b,a,$){}async publicLogError(b,a,$){}}e.$cp=k,e.$dp="telemetry",e.$ep="extensionTelemetryLog",e.$fp={log:()=>null,flush:()=>Promise.resolve(null)};function N(i,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!i.enableTelemetry)}function y(i,b){return b.extensionTestsLocationURI?!0:!(b.isBuilt||b.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function u(i){const b=i.getValue(M.$4l),a=i.getValue(M.$5l);if(i.getValue(M.$6l)===!1||a===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function v(i){const b={},a={},$={};o(i,$);for(let l in $){l=l.length>150?l.substr(l.length-149):l;const S=$[l];typeof S=="number"?a[l]=S:typeof S=="boolean"?a[l]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${S.length}`),b[l]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(b[l]=S)}return{properties:b,measurements:a}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const b=(0,R.$Cm)(i);return m.has(b)?b:"other"}function o(i,b,a=0,$){if(i)for(const l of Object.getOwnPropertyNames(i)){const S=i[l],d=$?$+l:l;Array.isArray(S)?b[d]=(0,I.$2n)(S):S instanceof Date?b[d]=S.toISOString():(0,T.$6f)(S)?a<2?o(S,b,a+1,d+"."):b[d]=(0,I.$2n)(S):b[d]=S}}function r(i,b){const a=i.msftInternalDomains||[],$=b.getValue("telemetry.internalTesting");return(0,O.$$o)(a)||$}function n(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function t(i,b){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const $=[];for(const D of b)for(;;){const f=D.exec(i);if(!f)break;$.push([f.index,D.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(a="";;){const D=S.exec(i);if(!D)break;const f=$.some(([E,w])=>D.index<w&&E<S.lastIndex);!l.test(D[0])&&!f&&(a+=i.substring(d,D.index)+"<REDACTED: user-file-path>",d=S.lastIndex)}return d<i.length&&(a+=i.substr(d)),a}function c(i){if(!i)return i;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of b)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function h(i,b){return(0,I.$Yn)(i,a=>{if(a instanceof p||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let $=a.replaceAll("%20"," ");$=t($,b);for(const l of b)$=$.replace(l,"");return $=c($),$}})}}),define(Re[199],Ae([1,0,15,98,20,21,2,14,73,59]),function(ge,e,I,T,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$pp=void 0,e.$op=N,e.$qp=m,e.$rp=s,e.$sp=o,e.$tp=r,e.$up=n,e.$vp=t,e.$wp=c,e.$yp=h,e.$zp=b;function N(a,$){return a.uuid&&$.uuid?a.uuid===$.uuid:a.id===$.id?!0:(0,I.$of)(a.id,$.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create($){const l=$.manifest?$.manifest.version:$.version,S=$.manifest?$.targetPlatform:$.properties.targetPlatform;return new u($.identifier,l,S)}static parse($){const l=y.exec($);return l&&l[1]&&l[2]?new u({id:l[1]},l[2],l[4]||void 0):null}constructor($,l,S="undefined"){this.version=l,this.targetPlatform=S,this.id=$.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals($){return $ instanceof u?N(this,$)&&this.version===$.version&&this.targetPlatform===$.targetPlatform:!1}}e.$pp=u;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(a){const $=v.exec(a);return $&&$[1]?[o($[1]),$[2]]:[o(a),void 0]}function s(a,$){return`${a}.${$}`}function o(a){return a.toLowerCase()}function r(a,$){return o(s(a??R.$Hm,$))}function n(a,$){const l=[],S=d=>{for(const D of l)if(D.some(f=>N($(f),$(d))))return D;return null};for(const d of a){const D=S(d);D?D.push(d):l.push([d])}return l}function t(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new k.$_o(a.identifier.id),name:new k.$_o(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$xp=new R.$Lm("pprice.better-merge");function h(a,$){const l=[],S=$.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const d=S.shift();if(d&&l.every(D=>!N(D.identifier,{id:d}))){const D=a.filter(f=>N(f.identifier,{id:d}));D.length===1&&(l.push(D[0]),S.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}async function i(a,$){if(!O.$k)return!1;let l;try{l=(await a.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await a.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){$.debug("Error while getting the os-release file.",(0,p.$0)(d))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function b(a,$){const l=await i(a,$),S=(0,T.$Vo)(l?"alpine":O.$u,g.$fc);return $.debug("ComputeTargetPlatform:",S),S}}),define(Re[200],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=I,e.$ds=T,e.$es=R,e.$fs=O,e.$gs=M,e.$hs=p;function I(g){return[...g.entries()]}function T(g){return g?[...g.entries()]:[]}function R(g){return new Map(g)}function O(g){return new Map(g??[])}function M(g){return Array.from(g.entries()).map(k=>[k[0],I(k[1].map),T(k[1].descriptionMap)])}function p(g){return new Map(g.map(k=>[k[0],{map:R(k[1]),descriptionMap:O(k[2])}]))}}),define(Re[201],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Usb=void 0;class I{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,O,M=5){const p=O(g=>{const k=typeof g=="string"?g:g.data;let N=this.a.get(R);if(N){N.data.push(k);return}const y=setTimeout(()=>this.flushBuffer(R),M);N={data:[k],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(R),p.dispose()}},this.a.set(R,N)});return p}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const O=this.a.get(R);O&&(this.a.delete(R),this.b(R,O.data.join("")))}}e.$Usb=I}),define(Re[202],Ae([1,0,11,91,301,42,5,17,2,161,72,30]),function(ge,e,I,T,R,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0w=e.$9w=e.$8w=e.$7w=e.$6w=e.$5w=e.IconFontDefinition=e.IconContribution=e.$2w=void 0,e.$3w=o,e.$4w=r,e.$2w={IconContribution:"base.contributions.icons"};var u;(function(h){function i(b,a){let $=b.defaults;for(;O.ThemeIcon.isThemeIcon($);){const l=s.getIcon($.id);if(!l)return;$=l.defaults}return $}h.getDefinition=i})(u||(e.IconContribution=u={}));var v;(function(h){function i(a){return{weight:a.weight,style:a.style,src:a.src.map($=>({format:$.format,location:$.location.toString()}))}}h.toJSONObject=i;function b(a){const $=l=>(0,p.$4f)(l)?l:void 0;if(a&&Array.isArray(a.src)&&a.src.every(l=>(0,p.$4f)(l.format)&&(0,p.$4f)(l.location)))return{weight:$(a.weight),style:$(a.style),src:a.src.map(l=>({format:l.format,location:g.URI.parse(l.location)}))}}h.fromJSONObject=b})(v||(e.IconFontDefinition=v={}));class m{constructor(){this.a=new M.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,b,a,$){const l=this.b[i];if(l){if(a&&!l.description){l.description=a,this.d.properties[i].markdownDescription=`${a} $(${i})`;const D=this.e.enum.indexOf(i);D!==-1&&(this.e.enumDescriptions[D]=a),this.a.fire()}return l}const S={id:i,description:a,defaults:b,deprecationMessage:$};this.b[i]=S;const d={$ref:"#/definitions/icons"};return $&&(d.deprecationMessage=$),a&&(d.markdownDescription=`${a}: $(${i})`),this.d.properties[i]=d,this.e.enum.push(i),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const b=this.e.enum.indexOf(i);b!==-1&&(this.e.enum.splice(b,1),this.e.enumDescriptions.splice(b,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,b){const a=this.f[i];return a||(this.f[i]=b,this.a.fire(),b)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(l,S)=>l.id.localeCompare(S.id),b=l=>{for(;O.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const $=Object.keys(this.b).map(l=>this.b[l]);for(const l of $.filter(S=>!!S.description).sort(i))a.push(`|<i class="${b(l)}"></i>|${l.id}|${O.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const l of $.filter(S=>!O.ThemeIcon.isThemeIcon(S.defaults)).sort(i))a.push(`|<i class="${b(l)}"></i>|${l.id}|`);return a.join(`
`)}}const s=new m;y.$9n.add(e.$2w.IconContribution,s);function o(h,i,b,a){return s.registerIcon(h,i,b,a)}function r(){return s}function n(){const h=(0,R.$Lj)();for(const i in h){const b="\\"+h[i].toString(16);s.registerIcon(i,{fontCharacter:b})}}n(),e.$5w="vscode://schemas/icons";const t=y.$9n.as(N.$0n.JSONContribution);t.registerSchema(e.$5w,s.getIconSchema());const c=new I.$Ch(()=>t.notifySchemaChanged(e.$5w),200);s.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$6w=o("widget-close",T.$Pj.close,(0,k.localize)(2,null)),e.$7w=o("goto-previous-location",T.$Pj.arrowUp,(0,k.localize)(3,null)),e.$8w=o("goto-next-location",T.$Pj.arrowDown,(0,k.localize)(4,null)),e.$9w=O.ThemeIcon.modify(T.$Pj.sync,"spin"),e.$0w=O.ThemeIcon.modify(T.$Pj.loading,"spin")}),define(Re[203],Ae([1,0,5,2,48,3,13]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$_v=e.$0v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$6v=e.$5v=void 0,e.$7v=k,e.$8v=y,e.$9v=u,e.$$v=v,e.$aw=m,e.$bw=s,e.$5v=(0,O.$qi)("tunnelService"),e.$6v=(0,O.$qi)("sharedTunnelsService");var p;(function(n){n.Http="http",n.Https="https"})(p||(e.TunnelProtocol=p={}));var g;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(g||(e.TunnelPrivacyId=g={}));function k(n){return!!n.forwardPort}var N;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(N||(e.ProvidedOnAutoForward=N={}));function y(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function u(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const c of t){const h=c.split("=")[1];if(/^https?:/.exec(h)){const i=y(T.URI.parse(h));if(i)return i}}}e.$0v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(n){return e.$0v.indexOf(n)>=0}e.$_v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(n){return e.$_v.indexOf(n)>=0}function s(n,t,c,h){if(c===1)return!1;if(c===2&&m(t)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(i?.length===4&&parseInt(i[1])>=18)return!1}return n<1024}class o{constructor(t,c,h){this.remoteAddress=t,this.localAddress=c,this.b=h,this.a=new I.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cw=o;let r=class{constructor(t,c){this.k=t,this.l=c,this.a=new I.$be,this.onTunnelOpened=this.a.event,this.b=new I.$be,this.onTunnelClosed=this.b.event,this.c=new I.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const t=this.l.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.i=t.privacyOptions,this.h=t.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const t=[],c=Array.from(this.e.values());for(const h of c){const i=Array.from(h.values());for(const b of i){const a=await b.value;a&&typeof a!="string"&&t.push(a)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:c}of t.values())await c.then(h=>typeof h!="string"?h?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,c,h,i,b){this.q(t,c,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:c,localAddress:h,privacy:i,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,c){(m(t)||v(t))&&(t=e.$0v[0]);const h=this.s(t,c);if(h)return++h.refcount,h.value}openTunnel(t,c,h,i,b,a=!1,$,l){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${h} on local port ${b}.`);const S=this.f??t;if(!S)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.t(S,c,h,i,b,a,$,l);return d?d.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,h),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.o(D);return(D.tunnelRemoteHost!==c||D.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&D.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}o(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const c=this.e.get(t.tunnelRemoteHost);if(c){const h=c.get(t.tunnelRemotePort);h&&(h.refcount--,await this.p(t.tunnelRemoteHost,t.tunnelRemotePort,h))}}}}async p(t,c,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${c}.`);const i=h.value.then(async b=>{b&&typeof b!="string"&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(c),i}}async closeTunnel(t,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${c} `);const h=this.e.get(t);if(h&&h.has(c)){const i=h.get(c);i.refcount=0,await this.p(t,c,i)}}q(t,c,h){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(c,{refcount:1,value:h})}async r(t,c){const h=this.e.get(t);if(h){const i=h.get(c),b=i?await i.value:void 0;(!b||typeof b=="string")&&h.delete(c),h.size===0&&this.e.delete(t)}}s(t,c){const h=[t];v(t)?(h.push(...e.$0v),h.push(...e.$_v)):m(t)&&h.push(...e.$_v);const i=h.map(b=>this.e.get(b));for(const b of i){const a=b?.get(c);if(a)return a}}canTunnel(t){return!!y(t)}u(t,c,h,i,b,a,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${h} on local port ${i}.`);const l=h;this.j.add(l);const S=i===void 0?h:i,d={elevationRequired:b?this.isPortPrivileged(S):!1},D={remoteAddress:{host:c,port:h},localAddressPort:i,privacy:a,public:a?a!==g.Private:void 0,protocol:$},f=t.forwardPort(D,d);return f?(this.q(c,h,f),f.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(l)})):this.j.delete(l),f}};e.$dw=r,e.$dw=r=Je([Ve(0,M.$Wj),Ve(1,R.$Wi)],r)}),define(Re[204],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ew=void 0,e.$ew=(0,I.$qi)("editSessionIdentityService");var T;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Re[205],Ae([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=T,e.$oM=R,e.$pM=O,e.$qM=M,e.$rM=p;function T(g){return g.scheme!==I.Schemas.file&&g.scheme!==I.Schemas.vscodeRemote}function R(g){if(g.folders.length)return g.folders.every(k=>T(k.uri))?g.folders[0].uri:void 0;if(g.configuration&&T(g.configuration))return g.configuration}function O(g){return R(g)?.scheme}function M(g){return R(g)?.authority}function p(g){return R(g)!==void 0}}),define(Re[49],Ae([1,0,162,19,52,24,2,3,12]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Ki=e.$Ji=e.WorkbenchState=e.$Di=e.$Ci=e.$zi=void 0,e.$Ai=k,e.$Bi=N,e.$Ei=y,e.$Fi=u,e.$Gi=v,e.$Hi=s,e.$Ii=o,e.$Li=t,e.$Qi=c,e.$Ri=h,e.$Ti=i,e.$Ui=b,e.$Vi=a,e.$zi=(0,p.$qi)("contextService");function k($){const l=$;return typeof l?.id=="string"&&M.URI.isUri(l.uri)}function N($){return typeof $?.id=="string"&&!k($)&&!u($)}e.$Ci={id:"ext-dev"},e.$Di={id:"empty-window"};function y($,l){if(typeof $=="string"||typeof $>"u")return typeof $=="string"?{id:(0,T.$oc)($)}:l?e.$Ci:e.$Di;const S=$;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function u($){const l=$;return typeof l?.id=="string"&&M.URI.isUri(l.configPath)}function v($){const l=$;if(l?.uri)return{id:l.id,uri:M.URI.revive(l.uri)};const S=$;if(S?.configPath)return{id:S.id,configPath:M.URI.revive(S.configPath)};if($?.id)return{id:$.id}}var m;(function($){$[$.EMPTY=1]="EMPTY",$[$.FOLDER=2]="FOLDER",$[$.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function s($){const l=$;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}function o($){const l=$;return!!(l&&typeof l=="object"&&M.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}class r{constructor(l,S,d,D,f){this.h=l,this.j=d,this.k=D,this.l=f,this.c=R.$wi.forUris(this.l,()=>!0),this.folders=S}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=R.$wi.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ji=r;class n{constructor(l,S){this.raw=S,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,O.$4g)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ki=n;function t($){return new n({uri:$,index:0,name:(0,O.$Zg)($)},{uri:$.toString()})}e.$Mi="code-workspace",e.$Ni=`.${e.$Mi}`,e.$Oi=[{name:(0,I.localize)(0,null),extensions:[e.$Mi]}],e.$Pi="workspace.json";function c($,l){return O.$Ug.isEqualOrParent($,l.untitledWorkspacesHome)}function h($){let l;return M.URI.isUri($)?l=$:l=$.configuration,l?.scheme===g.Schemas.tmp}e.$Si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i($){return $.id===e.$Si}function b($,l){return!c($,l)&&!h($)}function a($){return(typeof $=="string"?(0,T.$pc)($):(0,O.$2g)($))===e.$Ni}}),define(Re[74],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class I{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const O=this.c++;return this.b.set(O,R),this.e(),O}get(R,O){return this.b.has(R)?this.b.get(R)[O]:void 0}delete(R){this.b.delete(R),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$fkc=I}),define(Re[45],Ae([1,0,12,24,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=e.$kkc=void 0;class O{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new T.$Sg(p=>{const g=this.b.get(p.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(p,g){g===null?this.b.delete(p.scheme):this.b.set(p.scheme,g)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$kkc=O,e.$lkc=(0,R.$qi)("IExtHostFileSystemInfo")}),define(Re[27],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=void 0,e.$tP=(0,I.$qi)("IExtHostInitDataService")}),define(Re[206],Ae([1,0,167,13,193,27]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rmc=void 0;let M=class extends R.$BQ{constructor(g,k,N){const y=N.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",u=N.remote.isRemote?(0,I.localize)(0,null):g?(0,I.localize)(1,null):(0,I.localize)(2,null);super(k.createLogger(y,{name:u}))}};e.$rmc=M,e.$rmc=M=Je([Ve(1,T.$Xj),Ve(2,O.$tP)],M)}),define(Re[207],Ae([1,0,11]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=e.$3kc=void 0;class T{constructor(M,p,g){this.h=new Map,this.a=M,this.b=p,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new I.$Ch(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of k.values())N.complete()}catch(N){for(const y of k.values())y.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,p){let g=this.f[M];return typeof g>"u"&&(g=p),g}update(M,p){this.f[M]=p;const g=this.h.get(M);if(g!==void 0)return g.p;const k=new I.$Nh;return this.h.set(M,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$3kc=T;class R extends T{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,p){super(M.identifier.value,!0,p),this.j=M}}e.$4kc=R}),define(Re[208],Ae([1,0,5,2]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=void 0;class R{constructor(M){this.c=M,this.a=new I.$be,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$be,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,p,g,k){const y=this.c.getNotebookDocument(T.URI.revive(M)).acceptModelChanged(p.value,g,k);this.b.fire(y)}$acceptDirtyStateChanged(M,p){this.c.getNotebookDocument(T.URI.revive(M)).acceptDirty(p)}$acceptModelSaved(M){const p=this.c.getNotebookDocument(T.URI.revive(M));this.a.fire(p.apiNotebook)}}e.$Rlc=R}),define(Re[16],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eP=e.$dP=void 0,e.$dP=(0,I.$qi)("IExtHostRpcService");class T{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$eP=T}),define(Re[209],Ae([1,0,20,5]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;class R{#e;constructor(M,p){this.b=new T.$be,this.onDidChange=this.b.event,this.a=I.$Lm.toKey(M.identifier),this.#e=p,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(M){return this.#e.get(this.a,M)}store(M,p){return this.#e.store(this.a,M,p)}delete(M){return this.#e.delete(this.a,M)}}e.$alc=R}),define(Re[60],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=e.$Akc=void 0,e.$Akc=(0,I.$qi)("IURITransformerService");class T{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$Bkc=T}),define(Re[210],Ae([1,0,23]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aob=R,e.$bob=M;class T{constructor(){this.buffers=[]}add(g){let k=this.buffers.indexOf(g);return k<0&&(k=this.buffers.length,this.buffers.push(g)),k}}function R(p,g){if(g.serializeBuffersForPostMessage){const k=new T,y=JSON.stringify(p,(v,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(m)};if(ArrayBuffer.isView(m)){const s=O(m);if(s)return{$$vscode_array_buffer_reference$$:!0,index:k.add(m.buffer),view:{type:s,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),u=k.buffers.map(v=>{const m=new Uint8Array(v);return I.$Ce.wrap(m)});return{message:y,buffers:u}}else return{message:JSON.stringify(p),buffers:[]}}function O(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(p,g){const k=g.map(u=>{const v=new ArrayBuffer(u.byteLength);return new Uint8Array(v).set(u.buffer),v}),N=g.length?(u,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const m=v,{index:s}=m,o=k[s];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return v}:void 0;return{message:JSON.parse(p,N),arrayBuffers:k}}}),define(Re[104],Ae([1,0,176,17,2,6,3,30,44,12,43,139,33]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$BF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$sF=e.EditorInputCapabilities=e.$rF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=void 0,e.$iF=s,e.$jF=o,e.$kF=r,e.$lF=n,e.$mF=t,e.$nF=c,e.$oF=h,e.$pF=i,e.$qF=b,e.$tF=D,e.$uF=E,e.$vF=w,e.$wF=P,e.$xF=C,e.$yF=V,e.$zF=W,e.$AF=ce,e.$CF=ue,e.$DF=ie,e.$EF=Ce,e.$FF=Fe,e.$dF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$eF={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$fF="workbench.editor.sidebysideEditor",e.$gF="workbench.editors.textDiffEditor",e.$hF="workbench.editors.binaryResourceDiffEditor";var v;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var m;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function s(ne){const j=ne;return!!j&&typeof j.getSelection=="function"&&!!j.onDidChangeSelection}function o(ne){const j=ne;return!!j&&typeof j.getScrollPosition=="function"&&typeof j.setScrollPosition=="function"&&!!j.onDidChangeScroll}function r(ne,j,x){for(const pe of x.visibleEditorPanes)if(pe.group.id===j&&ne.matches(pe.input))return pe.getViewState()}function n(ne){if(D(ne))return!1;const j=ne;return R.URI.isUri(j?.resource)}function t(ne){if(D(ne))return!1;const j=ne;return j?.original!==void 0&&j.modified!==void 0}function c(ne){if(D(ne))return!1;const j=ne;return!j||j.resources&&!Array.isArray(j.resources)?!1:!!j.resources||!!j.multiDiffSource}function h(ne){if(D(ne)||t(ne))return!1;const j=ne;return j?.primary!==void 0&&j.secondary!==void 0}function i(ne){if(D(ne))return!1;const j=ne;return j?j.resource===void 0||j.resource.scheme===k.Schemas.untitled||j.forceUntitled===!0:!1}function b(ne){if(D(ne))return!1;const j=ne;return R.URI.isUri(j?.base?.resource)&&R.URI.isUri(j?.input1?.resource)&&R.URI.isUri(j?.input2?.resource)&&R.URI.isUri(j?.result?.resource)}var a;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var $;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})($||(e.SaveReason=$={}));class l{constructor(){this.a=new Map}registerSource(j,x){let pe=this.a.get(j);return pe||(pe={source:j,label:x},this.a.set(j,pe)),pe.source}getSourceLabel(j){return this.a.get(j)?.label??j}}e.$rF=new l;var S;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class d extends O.$Uc{}e.$sF=d;function D(ne){return ne instanceof d}function f(ne){const j=ne;return R.URI.isUri(j?.preferredResource)}function E(ne){const j=ne;return D(j?.primary)&&D(j?.secondary)}function w(ne){const j=ne;return D(j?.modified)&&D(j?.original)}function P(ne,j,x,pe,Oe){return Fe(pe,[(0,y.$aj)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const ke={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(j,ke)}}),(0,y.$aj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Oe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function C(ne){return D(ne?.editor)}function V(ne){const j=ne;return C(ne)&&j?.group!==void 0}function W(ne){const j=ne;return typeof j?.groupId=="number"&&D(j.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var A;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var U;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class K{getOriginalUri(j,x){if(!j)return;if(b(j))return e.$BF.getOriginalUri(j.result,x);if(x?.supportSideBySide){const{primary:Oe,secondary:ke}=this.a(j);if(Oe&&ke){if(x?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Oe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===U.ANY)return this.getOriginalUri(Oe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:x.filterByScheme});j=x.supportSideBySide===U.PRIMARY?Oe:ke}}if(t(j)||c(j)||h(j)||b(j))return;const pe=f(j)?j.preferredResource:j.resource;return!pe||!x||!x.filterByScheme?pe:this.b(pe,x.filterByScheme)}a(j){return E(j)||h(j)?{primary:j.primary,secondary:j.secondary}:w(j)||t(j)?{primary:j.modified,secondary:j.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(j,x){if(!j)return;if(b(j))return e.$BF.getCanonicalUri(j.result,x);if(x?.supportSideBySide){const{primary:Oe,secondary:ke}=this.a(j);if(Oe&&ke){if(x?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Oe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===U.ANY)return this.getCanonicalUri(Oe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme});j=x.supportSideBySide===U.PRIMARY?Oe:ke}}if(t(j)||c(j)||h(j)||b(j))return;const pe=j.resource;return!pe||!x||!x.filterByScheme?pe:this.b(pe,x.filterByScheme)}b(j,x){if(Array.isArray(x)){if(x.some(pe=>j.scheme===pe))return j}else if(x===j.scheme)return j}}var se;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(se||(e.EditorCloseMethod=se={}));function ce(ne,j,x,pe){if(!ne.isSticky(j))return!1;switch(pe.preventPinnedEditorClose){case"keyboardAndMouse":return x===se.MOUSE||x===se.KEYBOARD;case"mouse":return x===se.MOUSE;case"keyboard":return x===se.KEYBOARD}return!1}e.$BF=new K;var ve;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ve||(e.CloseDirection=ve={}));class Ie{constructor(){this.c=new Map,this.d=new Map}start(j){const x=this.a=j.get(M.$pi);for(const[pe,Oe]of this.c)this.e(pe,Oe,x);this.c.clear()}e(j,x,pe){const Oe=pe.createInstance(x);this.d.set(j,Oe)}registerFileEditorFactory(j){if(this.b)throw new Error("Can only register one file editor factory.");this.b=j}getFileEditorFactory(){return(0,T.$cg)(this.b)}registerEditorSerializer(j,x){if(this.c.has(j)||this.d.has(j))throw new Error(`A editor serializer with type ID '${j}' was already registered.`);return this.a?this.e(j,x,this.a):this.c.set(j,x),(0,O.$Sc)(()=>{this.c.delete(j),this.d.delete(j)})}getEditorSerializer(j){return this.d.get(typeof j=="string"?j:j.typeId)}}p.$9n.add(e.$dF.EditorFactory,new Ie);async function ue(ne,j,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async pe=>{const Oe=R.URI.revive(pe.fileUri);if(!Oe){x.info("Cannot resolve the path because it is not valid.",pe);return}if(!await j.canHandleResource(Oe)){x.info("Cannot resolve the path because it cannot be handled",pe);return}let $e=pe.exists,fe=pe.type;if(typeof $e!="boolean"||typeof fe!="number")try{fe=(await j.stat(Oe)).isDirectory?g.FileType.Directory:g.FileType.Unknown,$e=!0}catch(Y){x.error(Y),$e=!1}if(!$e&&pe.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",pe);return}if(fe===g.FileType.Directory){x.info("Cannot resolve the path because it is a directory",pe);return}const J={...pe.options,pinned:!0};return $e?{resource:Oe,options:J}:{resource:Oe,options:J,forceUntitled:!0}}))}var be;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(be||(e.EditorsOrder=be={}));function ie(ne){const j=ne;if(!j)return!1;const x=j;if(x.modified)return ie(x.modified);const pe=j;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}function Ce(ne){return(0,N.$cj)(ne)}function Fe(ne,j,x){const pe=(0,N.$dj)(ne,j);return pe.forceMessage=x?.forceMessage,pe.forceSeverity=x?.forceSeverity,pe.allowDialog=x?.allowDialog,pe}}),define(Re[211],Ae([1,0,5,177,3,6,28,30,18,26,91,202]),function(ge,e,I,T,R,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=e.$MF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$LF=e.ViewContentGroups=e.$JF=e.ViewContainerLocation=e.Extensions=e.$IF=e.$HF=e.$GF=void 0,e.$KF=m,e.$GF="views",e.$HF=(0,T.localize)(0,null),e.$IF=(0,y.$3w)("default-view-icon",N.$Pj.window,(0,T.localize)(1,null));var u;(function(b){b.ViewContainersRegistry="workbench.registry.view.containers",b.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var v;(function(b){b[b.Sidebar=0]="Sidebar",b[b.Panel=1]="Panel",b[b.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$JF=[0,1,2];function m(b){switch(b){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class s extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$be),this.onDidRegister=this.c.event,this.f=this.B(new I.$be),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(a,$,l){const S=this.get(a.id);if(S)return S;const d=a;return d.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:d.openCommandActionDescriptor??{id:d.id},(0,M.$yc)(this.g,$,[]).push(d),l?.isDefault&&this.h.push(d),this.c.fire({viewContainer:d,viewContainerLocation:$}),d}deregisterViewContainer(a){for(const $ of this.g.keys()){const l=this.g.get($),S=l?.indexOf(a);if(S!==-1){l?.splice(S,1),l.length===0&&this.g.delete($),this.f.fire({viewContainer:a,viewContainerLocation:$});return}}}get(a){return this.all.filter($=>$.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(l=>l?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find($=>this.getViewContainerLocation($)===a)}}p.$9n.add(u.ViewContainersRegistry,new s);var o;(function(b){b.Open="2_open",b.Debug="4_debug",b.SCM="5_scm",b.More="9_more"})(o||(e.ViewContentGroups=o={}));function r(b,a){const $=b.group??o.More,l=a.group??o.More;return $!==l?$.localeCompare(l):(b.order??5)-(a.order??5)}class n extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$be),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$be),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$be),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$be),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(a,$){this.registerViews2([{views:a,viewContainer:$}])}registerViews2(a){a.forEach(({views:$,viewContainer:l})=>this.r($,l)),this.c.fire(a)}deregisterViews(a,$){const l=this.s(a,$);l.length&&this.f.fire({views:l,viewContainer:$})}moveViews(a,$){for(const l of this.m.keys())if(l!==$){const S=this.s(a,l);S.length&&(this.r(S,$),this.g.fire({views:S,from:l,to:$}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const $ of this.j){const l=(this.m.get($)||[]).filter(S=>S.id===a)[0];if(l)return l}return null}getViewContainer(a){for(const $ of this.j)if((this.m.get($)||[]).filter(S=>S.id===a)[0])return $;return null}registerViewWelcomeContent(a,$){return this.n.add(a,$),this.h.fire(a),(0,O.$Sc)(()=>{this.n.delete(a,$),this.h.fire(a)})}registerViewWelcomeContent2(a,$){const l=new Map;for(const[S,d]of $)this.n.add(a,d),l.set(S,(0,O.$Sc)(()=>{this.n.delete(a,d),this.h.fire(a)}));return this.h.fire(a),l}getViewWelcomeContent(a){const $=[];return this.n.forEach(a,l=>$.push(l)),$.sort(r)}r(a,$){let l=this.m.get($);l||(l=[],this.m.set($,l),this.j.push($));for(const S of a){if(this.getView(S.id)!==null)throw new Error((0,T.localize)(2,null,S.id));l.push(S)}}s(a,$){const l=this.m.get($);if(!l)return[];const S=[],d=[];for(const D of l)a.includes(D)?S.push(D):d.push(D);return S.length&&(d.length?this.m.set($,d):(this.m.delete($),this.j.splice(this.j.indexOf($),1))),S}}p.$9n.add(u.ViewsRegistry,new n),e.$LF=(0,R.$qi)("viewDescriptorService");var t;(function(b){b[b.Default=0]="Default",b[b.Expand=1]="Expand"})(t||(e.ViewVisibilityState=t={}));var c;(function(b){b[b.None=0]="None",b[b.Collapsed=1]="Collapsed",b[b.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(a,$){this.c=!1,this.d=!1,(0,k.$Zn)(this,a),this.d=!!$,this.resolve=async l=>{if($&&!this.c){const S=await $(l);S&&(this.tooltip=this.tooltip??S.tooltip,this.command=this.command??S.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$MF=h;class i extends Error{constructor(a){super((0,T.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$NF=i}),define(Re[212],Ae([1,0,178,31]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$RF=new T.$Hj("chatSessionResponseVote","",{type:"string",description:(0,I.localize)(0,null)}),e.$SF=new T.$Hj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,I.localize)(1,null)}),e.$TF=new T.$Hj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,I.localize)(2,null)}),e.$UF=new T.$Hj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,I.localize)(3,null)}),e.$VF=new T.$Hj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,I.localize)(4,null)}),e.$WF=new T.$Hj("chatResponse",!1,{type:"boolean",description:(0,I.localize)(5,null)}),e.$XF=new T.$Hj("chatRequest",!1,{type:"boolean",description:(0,I.localize)(6,null)}),e.$YF=new T.$Hj("chatInputHasText",!1,{type:"boolean",description:(0,I.localize)(7,null)}),e.$ZF=new T.$Hj("chatInputHasFocus",!1,{type:"boolean",description:(0,I.localize)(8,null)}),e.$1F=new T.$Hj("inChatInput",!1,{type:"boolean",description:(0,I.localize)(9,null)}),e.$2F=new T.$Hj("inChat",!1,{type:"boolean",description:(0,I.localize)(10,null)}),e.$3F=new T.$Hj("chatIsEnabled",!1,{type:"boolean",description:(0,I.localize)(11,null)}),e.$4F=new T.$Hj("chatCursorAtTop",!1),e.$5F=new T.$Hj("chatInputHasAgent",!1),e.$6F=new T.$Hj("chatLocation",void 0)}),define(Re[213],Ae([1,0,5,40,6,31,3,212]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6G=e.$5G=e.$4G=e.ChatAgentLocation=void 0;var g;(function(y){y.Panel="panel",y.Terminal="terminal",y.Notebook="notebook",y.Editor="editor"})(g||(e.ChatAgentLocation=g={})),function(y){function u(v){switch(v){case"panel":return y.Panel;case"terminal":return y.Terminal;case"notebook":return y.Notebook;case"editor":return y.Editor}return y.Panel}y.fromRaw=u}(g||(e.ChatAgentLocation=g={})),e.$4G=(0,M.$qi)("chatAgentService");let k=class{static{this.AGENT_LEADER="@"}constructor(u){this.f=u,this.b=[],this.d=new I.$be,this.onDidChangeAgents=this.d.event,this.e=p.$3F.bindTo(this.f)}registerAgent(u,v){if(this.getAgent(u))throw new Error(`Agent already registered: ${JSON.stringify(u)}`);const s=this,o=v.slashCommands;v={...v,get slashCommands(){return o.filter(n=>!n.when||s.f.contextMatchesRules(O.$oj.deserialize(n.when)))}};const r={data:v};return this.b.push(r),(0,R.$Sc)(()=>{this.b=this.b.filter(n=>n!==r),this.d.fire(void 0)})}registerAgentImplementation(u,v){const m=this.g(u);if(!m)throw new Error(`Unknown agent: ${JSON.stringify(u)}`);if(m.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(u)}`);return m.data.isDefault&&this.e.set(!0),m.impl=v,this.d.fire(new N(m.data,v)),(0,R.$Sc)(()=>{m.impl=void 0,this.d.fire(void 0),m.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(u,v){const m={data:u,impl:v};return this.b.push(m),this.d.fire(new N(u,v)),(0,R.$Sc)(()=>{this.b=this.b.filter(s=>s!==m),this.d.fire(void 0)})}updateAgent(u,v){const m=this.g(u);if(!m?.impl)throw new Error(`No activated agent with id ${JSON.stringify(u)} registered`);m.data.metadata={...m.data.metadata,...v},this.d.fire(new N(m.data,m.impl))}getDefaultAgent(u){return this.getActivatedAgents().find(v=>!!v.isDefault&&v.locations.includes(u))}getContributedDefaultAgent(u){return this.getAgents().find(v=>!!v.isDefault&&v.locations.includes(u))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),u=>!!u.data.metadata.isSecondary)?.data}g(u){return this.b.find(v=>v.data.id===u)}getAgent(u){return this.g(u)?.data}getAgents(){return this.b.map(u=>u.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(u=>!!u.impl).map(u=>new N(u.data,u.impl))}getAgentsByName(u){return this.getAgents().filter(v=>v.name===u)}async invokeAgent(u,v,m,s,o){const r=this.g(u);if(!r?.impl)throw new Error(`No activated agent with id ${u}`);return await r.impl.invoke(v,m,s,o)}async getFollowups(u,v,m,s,o){const r=this.g(u);if(!r?.impl)throw new Error(`No activated agent with id ${u}`);return r.impl?.provideFollowups?r.impl.provideFollowups(v,m,s,o):[]}};e.$5G=k,e.$5G=k=Je([Ve(0,O.$Ij)],k);class N{constructor(u,v){this.b=u,this.d=v}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(u,v,m,s){return this.d.invoke(u,v,m,s)}async provideFollowups(u,v,m,s){return this.d.provideFollowups?this.d.provideFollowups(u,v,m,s):[]}provideWelcomeMessage(u,v){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(u,v)}provideSampleQuestions(u,v){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(u,v)}}e.$6G=N}),define(Re[214],Ae([1,0,2,29,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bG=e.$aG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$$F=O,e.$_F=M;function O(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof I.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(T.$kt.isIRange)}function M(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(O)}var p;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var g;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(g||(e.ChatCopyKind=g={})),e.$aG=(0,R.$qi)("IChatService"),e.$bG="accessibility.voice.keywordActivation"}),define(Re[215],Ae([1,0,5,11,179]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hob=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new I.$be,this.o=new I.$be,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,g,k,N){const y={command:p};if(g&&Object.keys(g).length>0&&(y.arguments=g),this.u("request",y),typeof N=="number"){const u=setTimeout(()=>{clearTimeout(u);const v=this.f.get(y.seq);if(v){this.f.delete(y.seq);const m={type:"response",seq:0,request_seq:y.seq,success:!1,command:p,message:(0,R.localize)(0,null,N,p)};v(m)}},N)}return k&&this.f.set(y.seq,k),y.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,g){return p.type!=="event"||g.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,T.$rh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const g=p,k=this.f.get(g.request_seq);k&&(this.f.delete(g.request_seq),k(g));break}}}}u(p,g){g.type=p,g.seq=this.d++,this.sendMessage(g)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((g,k)=>p.set(k,g)),await(0,T.$rh)(500),p.forEach((g,k)=>{g({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Hob=O}),define(Re[216],Ae([1,0,2,180,31,3]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$jJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$hJ=e.MemoryRangeType=e.State=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=void 0,e.$gJ=g,e.$iJ=N,e.$7H="workbench.view.debug",e.$8H="workbench.debug.variablesView",e.$9H="workbench.debug.watchExpressionsView",e.$0H="workbench.debug.callStackView",e.$$H="workbench.debug.loadedScriptsView",e.$_H="workbench.debug.breakPointsView",e.$aI="workbench.debug.disassemblyView",e.$bI="workbench.panel.repl",e.$cI="workbench.panel.repl.view",e.$dI=new R.$Hj("debugType",void 0,{type:"string",description:T.localize(0,null)}),e.$eI=new R.$Hj("debugConfigurationType",void 0,{type:"string",description:T.localize(1,null)}),e.$fI=new R.$Hj("debugState","inactive",{type:"string",description:T.localize(2,null)}),e.$gI="debugUx",e.$hI=new R.$Hj(e.$gI,"default",{type:"string",description:T.localize(3,null)}),e.$iI=new R.$Hj("hasDebugged",!1,{type:"boolean",description:T.localize(4,null)}),e.$jI=new R.$Hj("inDebugMode",!1,{type:"boolean",description:T.localize(5,null)}),e.$kI=new R.$Hj("inDebugRepl",!1,{type:"boolean",description:T.localize(6,null)}),e.$lI=new R.$Hj("breakpointWidgetVisible",!1,{type:"boolean",description:T.localize(7,null)}),e.$mI=new R.$Hj("inBreakpointWidget",!1,{type:"boolean",description:T.localize(8,null)}),e.$nI=new R.$Hj("breakpointsFocused",!0,{type:"boolean",description:T.localize(9,null)}),e.$oI=new R.$Hj("watchExpressionsFocused",!0,{type:"boolean",description:T.localize(10,null)}),e.$pI=new R.$Hj("watchExpressionsExist",!1,{type:"boolean",description:T.localize(11,null)}),e.$qI=new R.$Hj("variablesFocused",!0,{type:"boolean",description:T.localize(12,null)}),e.$rI=new R.$Hj("expressionSelected",!1,{type:"boolean",description:T.localize(13,null)}),e.$sI=new R.$Hj("breakpointInputFocused",!1,{type:"boolean",description:T.localize(14,null)}),e.$tI=new R.$Hj("callStackItemType",void 0,{type:"string",description:T.localize(15,null)}),e.$uI=new R.$Hj("callStackSessionIsAttach",!1,{type:"boolean",description:T.localize(16,null)}),e.$vI=new R.$Hj("callStackItemStopped",!1,{type:"boolean",description:T.localize(17,null)}),e.$wI=new R.$Hj("callStackSessionHasOneThread",!1,{type:"boolean",description:T.localize(18,null)}),e.$xI=new R.$Hj("watchItemType",void 0,{type:"string",description:T.localize(19,null)}),e.$yI=new R.$Hj("canViewMemory",void 0,{type:"boolean",description:T.localize(20,null)}),e.$zI=new R.$Hj("breakpointItemType",void 0,{type:"string",description:T.localize(21,null)}),e.$AI=new R.$Hj("breakpointItemBytes",void 0,{type:"boolean",description:T.localize(22,null)}),e.$BI=new R.$Hj("breakpointHasModes",!1,{type:"boolean",description:T.localize(23,null)}),e.$CI=new R.$Hj("breakpointSupportsCondition",!1,{type:"boolean",description:T.localize(24,null)}),e.$DI=new R.$Hj("loadedScriptsSupported",!1,{type:"boolean",description:T.localize(25,null)}),e.$EI=new R.$Hj("loadedScriptsItemType",void 0,{type:"string",description:T.localize(26,null)}),e.$FI=new R.$Hj("focusedSessionIsAttach",!1,{type:"boolean",description:T.localize(27,null)}),e.$GI=new R.$Hj("focusedSessionIsNoDebug",!1,{type:"boolean",description:T.localize(28,null)}),e.$HI=new R.$Hj("stepBackSupported",!1,{type:"boolean",description:T.localize(29,null)}),e.$II=new R.$Hj("restartFrameSupported",!1,{type:"boolean",description:T.localize(30,null)}),e.$JI=new R.$Hj("stackFrameSupportsRestart",!1,{type:"boolean",description:T.localize(31,null)}),e.$KI=new R.$Hj("jumpToCursorSupported",!1,{type:"boolean",description:T.localize(32,null)}),e.$LI=new R.$Hj("stepIntoTargetsSupported",!1,{type:"boolean",description:T.localize(33,null)}),e.$MI=new R.$Hj("breakpointsExist",!1,{type:"boolean",description:T.localize(34,null)}),e.$NI=new R.$Hj("debuggersAvailable",!1,{type:"boolean",description:T.localize(35,null)}),e.$OI=new R.$Hj("debugExtensionAvailable",!0,{type:"boolean",description:T.localize(36,null)}),e.$PI=new R.$Hj("debugProtocolVariableMenuContext",void 0,{type:"string",description:T.localize(37,null)}),e.$QI=new R.$Hj("debugSetVariableSupported",!1,{type:"boolean",description:T.localize(38,null)}),e.$RI=new R.$Hj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:T.localize(39,null)}),e.$SI=new R.$Hj("debugSetExpressionSupported",!1,{type:"boolean",description:T.localize(40,null)}),e.$TI=new R.$Hj("breakWhenValueChangesSupported",!1,{type:"boolean",description:T.localize(41,null)}),e.$UI=new R.$Hj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:T.localize(42,null)}),e.$VI=new R.$Hj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:T.localize(43,null)}),e.$WI=new R.$Hj("terminateDebuggeeSupported",!1,{type:"boolean",description:T.localize(44,null)}),e.$XI=new R.$Hj("suspendDebuggeeSupported",!1,{type:"boolean",description:T.localize(45,null)}),e.$YI=new R.$Hj("variableEvaluateNamePresent",!1,{type:"boolean",description:T.localize(46,null)}),e.$ZI=new R.$Hj("variableIsReadonly",!1,{type:"boolean",description:T.localize(47,null)}),e.$1I=new R.$Hj("variableValue",!1,{type:"string",description:T.localize(48,null)}),e.$2I=new R.$Hj("variableType",!1,{type:"string",description:T.localize(49,null)}),e.$3I=new R.$Hj("variableInterfaces",!1,{type:"array",description:T.localize(50,null)}),e.$4I=new R.$Hj("variableName",!1,{type:"string",description:T.localize(51,null)}),e.$5I=new R.$Hj("variableLanguage",!1,{type:"string",description:T.localize(52,null)}),e.$6I=new R.$Hj("variableExtensionId",!1,{type:"string",description:T.localize(53,null)}),e.$7I=new R.$Hj("exceptionWidgetVisible",!1,{type:"boolean",description:T.localize(54,null)}),e.$8I=new R.$Hj("multiSessionRepl",!1,{type:"boolean",description:T.localize(55,null)}),e.$9I=new R.$Hj("multiSessionDebug",!1,{type:"boolean",description:T.localize(56,null)}),e.$0I=new R.$Hj("disassembleRequestSupported",!1,{type:"boolean",description:T.localize(57,null)}),e.$$I=new R.$Hj("disassemblyViewFocus",!1,{type:"boolean",description:T.localize(58,null)}),e.$_I=new R.$Hj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:T.localize(59,null)}),e.$aJ=new R.$Hj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:T.localize(60,null)});const M=t=>T.localize(61,null,t);e.$bJ=M,e.$cJ="editor.contrib.debug",e.$dJ="editor.contrib.breakpoint",e.$eJ="debug",e.$fJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:T.localize(62,null)};var p;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(p||(e.State=p={}));function g(t){switch(t){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$hJ="vscode-debug-memory";function N(t){return t.source.presentationHint==="deemphasize"||t.presentationHint==="deemphasize"||t.presentationHint==="subtle"}var y;(function(t){t[t.Variable=0]="Variable",t[t.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var v;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(v||(e.DebuggerString=v={})),e.$jJ=(0,O.$qi)("debugService");var m;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(m||(e.BreakpointWidgetContext=m={}));var s;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(s||(e.DebugVisualizationType=s={}));var o;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var r;(function(t){t.deserialize=c=>c,t.serialize=c=>c})(r||(e.IDebugVisualizationTreeItem=r={}));var n;(function(t){t.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:I.URI.revive(c.iconPath.light),dark:I.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),t.serialize=c=>c})(n||(e.IDebugVisualization=n={}))}),define(Re[217],Ae([1,0,15,2,19,26,12,29,22,18]),function(ge,e,I,T,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iH=void 0,e.$9G=y,e.$0G=u,e.$$G=v,e.$_G=m,e.$aH=s,e.$bH=o,e.$cH=r,e.$dH=t,e.$eH=i,e.$fH=b,e.$gH=$,e.$hH=S;const N=/{([^}]+)}/g;function y(D,f,E){return D.replace(N,function(w,P){return f&&P.length>0&&P[0]!=="_"?w:E&&E.hasOwnProperty(P)?E[P]:w})}function u(D){const f={};for(const E of Object.keys(D))E.startsWith("!")||(f[E]=D[E]);return f}function v(D){return D.configuration.request==="attach"&&!m(D)&&(!D.parentSession||v(D.parentSession))}function m(D){let f=D.configuration.type;if(f)return f==="vslsShare"&&(f=D.configuration.adapterProxy.configuration.type),(0,I.$tf)(f,"extensionhost")||(0,I.$tf)(f,"pwa-extensionhost")?D:D.parentSession?m(D.parentSession):void 0}function s(D){return D.type&&(D.label||D.program||D.runtime)}function o(D,f,E){let w,P=0;const C=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=C.exec(D);){const W=V.index+1,q=W+V[0].length;if(W<=f&&q>=E){w=V[0],P=W;break}}if(w){const W=/\w+/g;let q=null;for(;(q=W.exec(w))&&!(q.index+1+P+q[0].length>=E););q&&(w=w.substring(0,W.lastIndex))}return w?{start:P,end:P+w.length-1}:{start:0,end:0}}async function r(D,f,E,w){if(D.evaluatableExpressionProvider.has(f)){const P=D.evaluatableExpressionProvider.ordered(f),C=(0,k.$Hb)(await Promise.all(P.map(async V=>{try{return await V.provideEvaluatableExpression(f,E,w??g.CancellationToken.None)}catch{return}})));if(C.length>0){let V=C[0].expression;const W=C[0].range;return V||(V=f.getLineContent(E.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:V}}}else{const P=f.getLineContent(E.lineNumber),{start:C,end:V}=o(P,E.column,E.column),W=P.substring(C-1,V);return{matchingExpression:W,range:new p.$kt(E.lineNumber,C,E.lineNumber,C+W.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(D){return!!(D&&D.match(n))}function c(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(t(D.path))return T.URI.parse(D.path);if((0,R.$jc)(D.path))return T.URI.file(D.path)}return D.path}function h(D){if(typeof D.path=="object"){const f=T.URI.revive(D.path);if(f)return f.scheme===M.Schemas.file?f.fsPath:f.toString()}return D.path}function i(D,f){const E=f?c:h,w=(0,O.$Wn)(D);return a(w,(P,C)=>{P&&C&&(C.path=E(C))}),w}function b(D,f){const E=f?c:h,w=(0,O.$Wn)(D);return a(w,(P,C)=>{!P&&C&&(C.path=E(C))}),w}function a(D,f){switch(D.type){case"event":{const E=D;switch(E.event){case"output":f(!1,E.body.source);break;case"loadedSource":f(!1,E.body.source);break;case"breakpoint":f(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=D;switch(E.command){case"setBreakpoints":f(!0,E.arguments.source);break;case"breakpointLocations":f(!0,E.arguments.source);break;case"source":f(!0,E.arguments.source);break;case"gotoTargets":f(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(w=>f(!1,w));break;default:break}break}case"response":{const E=D;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(w=>f(!1,w.source));break;case"loadedSources":E.body.sources.forEach(w=>f(!1,w));break;case"scopes":E.body.scopes.forEach(w=>f(!1,w.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(w=>f(!1,w.source));break;case"setBreakpoints":E.body.breakpoints.forEach(w=>f(!1,w.source));break;case"disassemble":E.body?.instructions.forEach(P=>f(!1,P.location));break;default:break}break}}}function $(D){return D.filter(f=>!f.presentation?.hidden).sort((f,E)=>f.presentation?E.presentation?f.presentation.group?E.presentation.group?f.presentation.group!==E.presentation.group?f.presentation.group.localeCompare(E.presentation.group):l(f.presentation.order,E.presentation.order):-1:E.presentation.group?1:l(f.presentation.order,E.presentation.order):-1:E.presentation?1:0)}function l(D,f){return typeof D!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:D-f}async function S(D,f){const E=D.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(E!=="none"&&(await f.saveAll(),E==="allEditorsInActiveGroup")){const w=f.activeEditorPane;w&&w.input.resource?.scheme===M.Schemas.untitled&&await f.save({editor:w.input,groupId:w.group.id})}await D.reloadConfiguration()}const d=(D,f)=>!D||!f?D===f:D.name===f.name&&D.path===f.path&&D.sourceReference===f.sourceReference;e.$iH=d}),define(Re[218],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wK=e.CellExecutionUpdateType=void 0;var T;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$wK=(0,I.$qi)("INotebookExecutionService")}),define(Re[219],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bib=e.$Aib=e.ProxyKernelState=e.$zib=void 0,e.$zib=100;var T;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(T||(e.ProxyKernelState=T={})),e.$Aib=(0,I.$qi)("INotebookKernelService"),e.$Bib=(0,I.$qi)("INotebookKernelHistoryService")}),define(Re[220],Ae([1,0,6,29,149,95]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oWb=void 0;class M extends I.$Uc{constructor(g,k,N){super(),this._source=g,this.b=k,this.c=N,this.a=void 0}f(g){const k=g.getLineCount();return new T.$kt(1,1,k,this.g(g,k))}g(g,k){if(k<1||k>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const g=new R.$MC;g.acceptChunk(this._source);const k=g.finish(!0),{textBuffer:N,disposable:y}=k.create(1);this.b=N,this.B(y)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const k=new R.$MC;k.acceptChunk(g);const N=k.finish(!0),{textBuffer:y,disposable:u}=N.create(1);return this.B(u),y})),this.a}findInInputs(g){const N=new O.$AC(g,!1,!1,null).parseSearchRequest();if(!N)return[];const y=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(y,N,!0,5e3)}findInOutputs(g){const N=new O.$AC(g,!1,!1,null).parseSearchRequest();return N?this.outputTextBuffers.map(y=>{const u=y.findMatchesLineByLine(this.f(y),N,!0,5e3);if(u.length!==0)return{textBuffer:y,matches:u}}).filter(y=>!!y):[]}}e.$oWb=M}),define(Re[50],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(O){O.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var T;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class R{static fromExtHostTestItem(M,p,g=M.parent){if(M._isRoot)return new R([p]);const k=[M.id];for(let N=g;N&&N.id!==p;N=N.parent)k.push(N.id);return k.push(p),new R(k.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const p=M.indexOf("\0");return p===-1?M:M.slice(0,p)}static fromString(M){return new R(M.split("\0"))}static join(M,p){return new R([...M.path,p])}static joinToString(M,p){return M.toString()+"\0"+p}static parentId(M){const p=M.lastIndexOf("\0");return p===-1?void 0:M.slice(0,p)}static localId(M){const p=M.lastIndexOf("\0");return p===-1?M:M.slice(p+1)}static isChild(M,p){return p.startsWith(M)&&p[M.length]==="\0"}static compare(M,p){return M===p?0:R.isChild(M,p)?2:R.isChild(p,M)?3:1}constructor(M,p=M.length){if(this.path=M,this.d=p,M.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new R(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new R(this.path,M)}compare(M){if(typeof M=="string")return R.compare(this.toString(),M);for(let p=0;p<M.d&&p<this.d;p++)if(M.path[p]!==this.path[p])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$CL=R}),define(Re[61],Ae([1,0,2,93,29,50]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$KL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$JL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$IL=e.$HL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$GL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$FL=e.$EL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$DL=e.TestResultState=void 0;var M;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$DL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var g;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$EL=[2,4,8,16,32,64];const k=A=>"runId"in A;e.$FL=k;var N;(function(A){A.serialize=U=>({range:U.range.toJSON(),uri:U.uri.toJSON()}),A.deserialize=(U,K)=>({range:R.$kt.lift(K.range),uri:U.asCanonicalUri(I.URI.revive(K.uri))})})(N||(e.IRichLocation=N={}));var y;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(y||(e.TestMessageType=y={}));var u;(function(A){A.serialize=U=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&N.serialize(U.location)}),A.deserialize=(U,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&N.deserialize(U,K.location)})})(u||(e.ITestErrorMessage=u={}));const v=(A,U)=>`${U?"s":"e"}${A}`;e.$GL=v;var m;(function(A){A.serialize=U=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&N.serialize(U.location)}),A.deserialize=(U,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&N.deserialize(U,K.location)})})(m||(e.ITestOutputMessage=m={}));var s;(function(A){A.serialize=U=>U.type===0?u.serialize(U):m.serialize(U),A.deserialize=(U,K)=>K.type===0?u.deserialize(U,K):m.deserialize(U,K)})(s||(e.ITestMessage=s={}));var o;(function(A){A.serializeWithoutMessages=U=>({state:U.state,duration:U.duration,messages:[]}),A.serialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(s.serialize)}),A.deserialize=(U,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(se=>s.deserialize(U,se))})})(o||(e.ITestTaskState=o={}));const r="\0",n=(A,U)=>A+r+U;e.$HL=n;const t=A=>{const U=A.indexOf(r);return{ctrlId:A.slice(0,U),tagId:A.slice(U+1)}};e.$IL=t;var c;(function(A){A.serialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?.toJSON(),range:U.range?.toJSON()||null,description:U.description,error:U.error,sortText:U.sortText}),A.deserialize=(U,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?U.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?R.$kt.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var h;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(A){A.serialize=U=>({expand:U.expand,item:c.serialize(U.item)}),A.deserialize=(U,K)=>({controllerId:O.$CL.root(K.item.extId),expand:K.expand,item:c.deserialize(U,K.item)})})(i||(e.InternalTestItem=i={}));var b;(function(A){A.serialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.uri!==void 0&&(K.uri=U.item.uri?.toJSON()),U.item.range!==void 0&&(K.range=U.item.range?.toJSON()),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}},A.deserialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.range!==void 0&&(K.range=U.item.range?R.$kt.lift(U.item.range):null),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}}})(b||(e.ITestItemUpdate=b={}));const a=(A,U)=>{U.expand!==void 0&&(A.expand=U.expand),U.item!==void 0&&(A.item=A.item?Object.assign(A.item,U.item):U.item)};e.$JL=a;var $;(function(A){A.serializeWithoutMessages=U=>({...i.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serializeWithoutMessages)}),A.serialize=U=>({...i.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serialize)}),A.deserialize=(U,K)=>({...i.deserialize(U,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(se=>o.deserialize(U,se)),retired:!0})})($||(e.TestResultItem=$={}));var l;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(U,K)=>{U.covered+=K.covered,U.total+=K.total}})(l||(e.ICoverageCount=l={}));var S;(function(A){A.serialize=U=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,uri:U.uri.toJSON()}),A.deserialize=(U,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:U.asCanonicalUri(I.URI.revive(K.uri))})})(S||(e.IFileCoverage=S={}));function d(A){return{...A,location:A.location?.toJSON()}}function D(A){return A.location=A.location?T.$jt.isIPosition(A.location)?T.$jt.lift(A.location):R.$kt.lift(A.location):void 0,A}e.$KL=3;var f;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})(f||(e.DetailType=f={}));var E;(function(A){A.serialize=U=>U.type===0?P.serialize(U):C.serialize(U),A.deserialize=U=>U.type===0?P.deserialize(U):C.deserialize(U)})(E||(e.CoverageDetails=E={}));var w;(function(A){A.serialize=d,A.deserialize=D})(w||(e.IBranchCoverage=w={}));var P;(function(A){A.serialize=d,A.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var C;(function(A){A.serialize=U=>({...d(U),branches:U.branches?.map(w.serialize)}),A.deserialize=U=>({...D(U),branches:U.branches?.map(w.deserialize)})})(C||(e.IStatementCoverage=C={}));var V;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(V||(e.TestDiffOpType=V={}));var W;(function(A){A.deserialize=(U,K)=>K.op===0?{op:K.op,item:i.deserialize(U,K.item)}:K.op===1?{op:K.op,item:b.deserialize(K.item)}:K.op===2?{op:K.op,uri:U.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,A.serialize=U=>U.op===0?{op:U.op,item:i.serialize(U.item)}:U.op===1?{op:U.op,item:b.serialize(U.item)}:U})(W||(e.TestsDiffOp=W={}));class q{constructor(U){this.k=U,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(U){const K=this.v();for(const se of U)switch(se.op){case 0:this.l(i.deserialize(this.k,se.item),K);break;case 1:this.o(b.deserialize(se.item),K);break;case 3:this.p(se.itemId,K);break;case 5:this.q(se.itemId);break;case 4:this.updatePendingRoots(se.amount);break;case 6:this.c.set(se.tag.id,se.tag);break;case 7:this.c.delete(se.id);break}K.complete?.()}l(U,K){const se=O.$CL.parentId(U.item.extId)?.toString();let ce;if(!se)ce=this.w(U),this.g.add(ce),this.f.set(U.item.extId,ce);else if(this.f.has(se)){const ve=this.f.get(se);ve.children.add(U.item.extId),ce=this.w(U,ve),this.f.set(U.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(U)}`);return}return K.add?.(ce),U.expand===2&&this.h++,ce}o(U,K){const se=this.f.get(U.extId);if(se)return U.expand!==void 0&&(se.expand===2&&this.h--,U.expand===2&&this.h++),(0,e.$JL)(se,U),K.update?.(se),se}p(U,K){const se=this.f.get(U);if(!se)return;const ce=O.$CL.parentId(se.item.extId)?.toString();ce?this.f.get(ce).children.delete(se.item.extId):this.g.delete(se);const ve=[[U]];for(;ve.length;)for(const Ie of ve.pop()){const ue=this.f.get(Ie);ue&&(ve.push(ue.children),this.f.delete(Ie),K.remove?.(ue,ue!==se),ue.expand===2&&this.h--)}}q(U){}updatePendingRoots(U){this.j+=U}v(){return{}}}e.$LL=q}),define(Re[75],Ae([1,0,11,5,6,56,61,50]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.TestItemEventOp=void 0;var g;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const k=(n,t)=>n===t,y=Object.entries({range:(n,t)=>n===t?!0:!n||!t?!1:n.equalsRange(t),busy:k,label:k,description:k,error:k,sortText:k,tags:(n,t)=>!(n.length!==t.length||n.some(c=>!t.includes(c)))}),u=(n,t)=>{let c;for(const[h,i]of y)i(n[h],t[h])||(c?c[h]=t[h]:c={[h]:t[h]});return c};class v extends R.$Uc{get root(){return this.s.root}constructor(t){super(),this.s=t,this.f=this.B(new I.$Ch(()=>this.flushDiff(),200)),this.g=this.B(new T.$be),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(t){this.h=t;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const t=this.m;return this.m=[],t}pushDiff(t){switch(t.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===t.uri){c.docv=t.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===t.item.extId){(0,M.$JL)(c.item,t.item);return}if(c.op===0&&c.item.item.extId===t.item.extId){(0,M.$JL)(c.item,t.item);return}}break}}this.m.push(t),this.f.isScheduled()||this.f.schedule()}expand(t,c){const h=this.tree.get(t);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.M(h);return i.isOpen()?this.L(h,c-1):i.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const t of this.tree.values())this.s.getApiFor(t.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(t,c){switch(c.op){case 3:this.O(p.$CL.joinToString(t.fullId,c.id));break;case 0:this.z(c.item,t);break;case 5:for(const h of c.ops)this.w(t,h);break;case 1:this.C(c.new,c.old,t.fullId.toString());break;case 2:this.J(t);break;case 4:this.pushDiff({op:1,item:{extId:t.fullId.toString(),item:c.update}});break;case 6:this.y(t.actual.uri);break;default:(0,O.$cd)(c)}}y(t){t&&this.pushDiff({op:2,uri:t,docv:this.s.getDocumentVersion(t)})}z(t,c){const h=p.$CL.fromExtHostTestItem(t,this.root.id,c?.actual),i=this.s.getApiFor(t);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(t.id);let b=this.tree.get(h.toString());if(!b){b={fullId:h,actual:t,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},t.tags.forEach(this.D,this),this.tree.set(b.fullId.toString(),b),this.G(t,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:b.expand,item:this.s.toITestItem(t)}}),this.I(t,b,c);return}if(b.actual===t){this.H(t,b,c);return}if(b.actual.uri?.toString()!==t.uri?.toString())return this.O(h.toString()),this.z(t,c);const a=this.s.getChildren(b.actual),$=b.actual,l=u(this.s.toITestItem($),this.s.toITestItem(t));this.s.getApiFor($).listener=void 0,b.actual=t,b.resolveBarrier=void 0,b.expand=0,l&&(l.hasOwnProperty("tags")&&(this.C(t.tags,$.tags,h.toString()),delete l.tags),this.w(b,{op:4,update:l})),this.I(t,b,c);for(const[d,D]of a)this.s.getChildren(t).get(D.id)||this.O(p.$CL.joinToString(h,D.id));const S=b.expandLevels;S!==void 0&&queueMicrotask(()=>{b.expand===1&&(b.expandLevels=void 0,this.expand(h.toString(),S))}),this.y(b.actual.uri)}C(t,c,h){const i=new Set(c.map(b=>b.id));for(const b of t)i.delete(b.id)||this.D(b);this.pushDiff({op:1,item:{extId:h,item:{tags:t.map(b=>(0,M.$HL)(this.s.controllerId,b.id))}}}),i.forEach(this.F,this)}D(t){const c=this.j.get(t.id);c?c.refCount++:(this.j.set(t.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$HL)(this.s.controllerId,t.id)}}))}F(t){const c=this.j.get(t);c&&!--c.refCount&&(this.j.delete(t),this.pushDiff({op:7,id:(0,M.$HL)(this.s.controllerId,t)}))}G(t,c){this.s.getApiFor(t).parent=c&&c.actual!==this.root?c.actual:void 0}H(t,c,h){this.G(t,h);const i=this.s.getApiFor(t);i.parent=h?.actual,i.listener=b=>this.w(c,b),this.J(c)}I(t,c,h){this.H(t,c,h);for(const[i,b]of this.s.getChildren(t))this.z(b,c)}J(t){let c;this.h?t.resolveBarrier?c=t.resolveBarrier.isOpen()?3:2:c=t.actual.canResolveChildren?1:0:c=0,c!==t.expand&&(t.expand=c,this.pushDiff({op:1,item:{extId:t.fullId.toString(),expand:c}}),c===1&&t.expandLevels!==void 0&&this.M(t))}L(t,c){if(c<0)return;const h=[];for(const[i,b]of this.s.getChildren(t.actual)){const a=this.expand(p.$CL.joinToString(t.fullId,b.id),c);(0,I.$ch)(a)&&h.push(a)}if(h.length)return Promise.all(h).then(()=>{})}M(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this.h){const b=new I.$ph;return b.open(),b}t.expand=2,this.N(t);const c=t.resolveBarrier=new I.$ph,h=b=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,b)};let i;try{i=this.h(t.actual===this.root?void 0:t.actual)}catch(b){h(b)}return(0,I.$ch)(i)?i.catch(h).then(()=>{c.open(),this.J(t)}):(c.open(),this.J(t)),t.resolveBarrier}N(t){this.pushDiff({op:1,item:{extId:t.fullId.toString(),expand:t.expand}})}O(t){const c=this.tree.get(t);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:t});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const b of i.actual.tags)this.F(b.id);this.tree.delete(i.fullId.toString());for(const[b,a]of this.s.getChildren(i.actual))h.push(this.tree.get(p.$CL.joinToString(i.fullId,a.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.g.fire(t)}}e.$6O=v;class m extends Error{constructor(t){super(`Attempted to insert a duplicate test item ID ${t}`)}}e.$7O=m;class s extends Error{constructor(t){super(`TestItem with ID "${t}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$8O=s;class o extends Error{constructor(t,c,h){super(`TestItem with ID "${t}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$9O=o;const r=(n,t,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,b){for(const a of h.values())i.call(b,a,this)},[Symbol.iterator](){return h.entries()},replace(i){const b=new Map,a=new Set(h.keys()),$={op:5,ops:[]};for(const l of i){if(!(l instanceof c))throw new s(l.id);const S=t(l).controllerId;if(S!==n.controllerId)throw new o(l.id,S,n.controllerId);if(b.has(l.id))throw new m(l.id);b.set(l.id,l),a.delete(l.id),$.ops.push({op:0,item:l})}for(const l of a.keys())$.ops.push({op:3,id:l});n.listener?.($),h=b},add(i){if(!(i instanceof c))throw new s(i.id);h.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){h.delete(i)&&n.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$0O=r}),define(Re[105],Ae([1,0,75]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_O=e.$$O=void 0;const T=new WeakMap,R=(M,p)=>{const g={controllerId:p};return T.set(M,g),g};e.$$O=R;const O=M=>{const p=T.get(M);if(!p)throw new I.$8O(M?.id||"<unknown>");return p};e.$_O=O}),define(Re[76],Ae([1,0,12,2]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Txb=e.$Sxb=e.$Rxb=void 0,e.$Uxb=R,e.$Vxb=M,e.$Rxb="vscode-cdn.net",e.$Sxb=`vscode-resource.${e.$Rxb}`,e.$Txb=`'self' https://*.${e.$Rxb}`;function R(p,g){return p.scheme===I.Schemas.http||p.scheme===I.Schemas.https?p:(g&&g.authority&&g.isRemote&&p.scheme===I.Schemas.file&&(p=T.URI.from({scheme:I.Schemas.vscodeRemote,authority:g.authority,path:p.path})),T.URI.from({scheme:I.Schemas.https,authority:`${p.scheme}+${O(p.authority)}.${e.$Sxb}`,path:p.path,fragment:p.fragment,query:p.query}))}function O(p){return p.replace(/./g,g=>{const k=g.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?g:"-"+k.toString(16).padStart(4,"0")})}function M(p){return p.replace(/-([0-9a-f]{4})/g,(g,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Re[221],Ae([1,0,5,6,76]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;class O{constructor(p,g,k){this.d=p,this.e=g,this.f=k,this.a=0,this.b=new T.$Tc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const N=g.getVisibleTextEditors();for(const y of this.c.values())N.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,g,k,N,y){let u;for(const t of this.e.getVisibleTextEditors(!0))if(t.value===p){u=t;break}if(!u)throw new Error("not a visible editor");const v=this,m=this.a++,s=new I.$be,o=new I.$be,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(t){return(0,R.$Uxb)(t,v.f)}get cspSource(){return R.$Txb}set options(t){this.b=t,v.d.$setOptions(m,t)}get options(){return this.b}set html(t){this.a=t,v.d.$setHtml(m,t)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(t){return v.d.$postMessage(m,t)}},n=new class{constructor(){this.editor=p,this.line=g,this.height=k,this.webview=r,this.onDidDispose=o.event}dispose(){v.c.has(m)&&(v.c.delete(m),v.d.$disposeEditorInset(m),o.fire(),o.dispose(),s.dispose())}};return this.d.$createEditorInset(m,u.id,u.value.document.uri,g+1,k,N||{},y.identifier,y.extensionLocation),this.c.set(m,{editor:p,inset:n,onDidReceiveMessage:s}),n}$onDidDispose(p){const g=this.c.get(p);g&&g.inset.dispose()}$onDidReceiveMessage(p,g){this.c.get(p)?.onDidReceiveMessage.fire(g)}}e.$ykc=O}),define(Re[106],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UL=e.$TL=e.$SL=void 0,e.$SL="__",e.$TL=(0,I.$qi)("IAuthenticationService"),e.$UL=(0,I.$qi)("IAuthenticationExtensionsService")}),define(Re[222],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=e.VariableKind=e.$2P=void 0,e.$2P=(0,I.$qi)("configurationResolverService");var T;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class R extends Error{constructor(M,p){super(p),this.variable=M}}e.$3P=R}),define(Re[223],Ae([1,0,19,73,17,26,21,96,183,222,15]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0;class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,m,s,o){this.h=new Map,this.a=v,this.b=m,this.g=s,o&&(this.c=o.then(r=>this.i(r)))}i(v){if(M.$i){const m=Object.create(null);return Object.keys(v).forEach(s=>{m[s.toLowerCase()]=v[s]}),m}return v}resolveWithEnvironment(v,m,s){return this.l({env:this.i(v),userHome:void 0},m?m.uri:void 0,s)}async resolveAsync(v,m){const s={env:await this.c,userHome:await this.g};return this.l(s,v?v.uri:void 0,m)}async j(v,m,s,o){const r=O.$Wn(m);M.$i&&r.windows?Object.keys(r.windows).forEach(t=>r[t]=r.windows[t]):M.$j&&r.osx?Object.keys(r.osx).forEach(t=>r[t]=r.osx[t]):M.$k&&r.linux&&Object.keys(r.linux).forEach(t=>r[t]=r.linux[t]),delete r.windows,delete r.osx,delete r.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,v?v.uri:void 0,r,s,o)}async resolveAnyAsync(v,m,s){return this.j(v,m,s)}async resolveAnyMap(v,m,s){const o=new Map;return{newConfig:await this.j(v,m,s,o),resolvedVariables:o}}resolveWithInteractionReplace(v,m,s,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,m,s,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,m){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,m)}async l(v,m,s,o,r){if(R.$4f(s))return this.m(v,m,s,o,r);if(Array.isArray(s))return Promise.all(s.map(n=>this.l(v,m,n,o,r)));if(R.$6f(s)){const n=Object.create(null),t=await Promise.all(Object.keys(s).map(async c=>[await this.m(v,m,c,o,r),await this.l(v,m,s[c],o,r)]));for(const[c,h]of t)n[c]=h;return n}return s}m(v,m,s,o,r){return(0,N.$lf)(s,y.VARIABLE_REGEXP,async(n,t)=>{if(t.includes(y.VARIABLE_LHS))return n;let c=await this.o(v,n,t,m,o);return r?.set(t,c),c!==n&&R.$4f(c)&&c.match(y.VARIABLE_REGEXP)&&(c=await this.m(v,m,c,o,r)),c})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,m,s,o,r){let n;const t=s.split(":");t.length>1&&(s=t[0],n=t[1]);const c=b=>{const a=this.a.getFilePath();if(a)return(0,p.$pw)(a);throw new k.$3P(b,(0,g.localize)(0,null,m))},h=b=>{const a=c(b);if(this.a.getWorkspaceFolderPathForFile){const $=this.a.getWorkspaceFolderPathForFile();if($)return(0,p.$pw)($)}throw new k.$3P(b,(0,g.localize)(1,null,m,I.$oc(a)))},i=b=>{if(n){const a=this.a.getFolderUri(n);if(a)return a;throw new k.$3P(b,(0,g.localize)(2,null,m,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.$3P(b,(0,g.localize)(3,null,m)):new k.$3P(b,(0,g.localize)(4,null,m))};switch(s){case"env":if(n){if(v.env){const b=v.env[M.$i?n.toLowerCase():n];if(R.$4f(b))return b}return""}throw new k.$3P(k.VariableKind.Env,(0,g.localize)(5,null,m));case"config":if(n){const b=this.a.getConfigurationValue(o,n);if(R.$ag(b))throw new k.$3P(k.VariableKind.Config,(0,g.localize)(6,null,m,n));if(R.$6f(b))throw new k.$3P(k.VariableKind.Config,(0,g.localize)(7,null,m,n));return b}throw new k.$3P(k.VariableKind.Config,(0,g.localize)(8,null,m));case"command":return this.p(k.VariableKind.Command,m,n,r,"command");case"input":return this.p(k.VariableKind.Input,m,n,r,"input");case"extensionInstallFolder":if(n){const b=await this.a.getExtension(n);if(!b)throw new k.$3P(k.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,m,n));return this.n(b.extensionLocation)}throw new k.$3P(k.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,m));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,p.$pw)(this.n(i(k.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,p.$pw)(this.n(i(k.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$pw)(I.$oc(this.n(i(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new k.$3P(k.VariableKind.UserHome,(0,g.localize)(11,null,m))}case"lineNumber":{const b=this.a.getLineNumber();if(b)return b;throw new k.$3P(k.VariableKind.LineNumber,(0,g.localize)(12,null,m))}case"selectedText":{const b=this.a.getSelectedText();if(b)return b;throw new k.$3P(k.VariableKind.SelectedText,(0,g.localize)(13,null,m))}case"file":return c(k.VariableKind.File);case"fileWorkspaceFolder":return h(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(h(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?I.$mc(this.n(i(k.VariableKind.RelativeFile)),c(k.VariableKind.RelativeFile)):c(k.VariableKind.RelativeFile);case"relativeFileDirname":{const b=I.$nc(c(k.VariableKind.RelativeFileDirname));if(o||n){const a=I.$mc(this.n(i(k.VariableKind.RelativeFileDirname)),b);return a.length===0?".":a}return b}case"fileDirname":return I.$nc(c(k.VariableKind.FileDirname));case"fileExtname":return I.$pc(c(k.VariableKind.FileExtname));case"fileBasename":return I.$oc(c(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const b=I.$oc(c(k.VariableKind.FileBasenameNoExtension));return b.slice(0,b.length-I.$pc(b).length)}case"fileDirnameBasename":return I.$oc(I.$nc(c(k.VariableKind.FileDirnameBasename)));case"execPath":{const b=this.a.getExecPath();return b||m}case"execInstallFolder":{const b=this.a.getAppRoot();return b||m}case"pathSeparator":case"/":return I.sep;default:try{const b=n?`${s}:${n}`:s;return this.p(k.VariableKind.Unknown,m,b,r,void 0)}catch{return m}}}}p(v,m,s,o,r){if(s&&o){const n=r===void 0?o[s]:o[r+":"+s];if(typeof n=="string")return n;throw new k.$3P(v,(0,g.localize)(14,null,m))}return m}}e.$fQ=y}),define(Re[107],Ae([1,0,3,104]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$ID=void 0,e.$JD=k,e.$KD=u,e.$LD=v,e.$ID=(0,I.$qi)("editorGroupsService");var R;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var O;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var M;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var p;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EXPAND=1]="EXPAND",m[m.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var g;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function k(m){const s=m;return(0,T.$tF)(s?.editor)&&(0,T.$tF)(s?.replacement)}var N;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N||(e.GroupsOrder=N={}));var y;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(m){const s=m;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}function v(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Re[224],Ae([1,0,3,107]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PD=e.$OD=e.$ND=e.$MD=void 0,e.$QD=R,e.$MD=(0,I.$qi)("editorService"),e.$ND=-1,e.$OD=-2,e.$PD=-3;function R(O){const M=O;return typeof O=="number"||(0,T.$KD)(M)}}),define(Re[225],Ae([1,0,3,190]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=void 0,e.$bM=(0,I.$ri)(T.$xi)}),define(Re[108],Ae([1,0,20,5,19,6,11]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=e.$V$b=e.$U$b=e.$T$b=e.$S$b=void 0;class p{constructor(n,t){this.versionId=n,this.removedDueToLooping=t}}e.$S$b=p;class g{static isHostExtension(n,t,c){if(t.getExtensionDescription(n))return!1;const h=c.getExtensionDescription(n);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(n,t){this.j=n,this.c=new T.$be,this.onDidChange=this.c.event,this.d=0,this.e=t,this.k()}k(){this.e.sort(s),this.f=new I.$Nm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const t=this.j.readActivationEvents(n);for(const c of t)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,t){this.e=o(this.e,t),this.e=this.e.concat(n);const c=g.l(this.e);return this.e=o(this.e,c.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,c)}static l(n){const t=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,$){this.addNode(a),this.addNode($),this.c.has(a)?this.c.get(a).push($):this.c.set(a,[$])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,$){const l=t.getArcs(a);for(let S=0;S<l.length;S++)if(!$.has(l[S]))return!1;return!0}getNodes(){return this.e}},c=new I.$Nm;for(const a of n)if(c.set(a.identifier,a),a.extensionDependencies)for(const $ of a.extensionDependencies)t.addArc(I.$Lm.toKey(a.identifier),I.$Lm.toKey($));const h=new Set;t.getNodes().filter(a=>t.getArcs(a).length===0).forEach(a=>h.add(a));const i=t.getNodes().filter(a=>!h.has(a));let b;do{b=!1;for(let a=0;a<i.length;a++){const $=i[a];t.hasOnlyGoodArcs($,h)&&(i.splice(a,1),a--,h.add($),b=!0)}}while(b);return i.map(a=>c.get(a))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const t=this.h.get(n);return t?t.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const t=this.f.get(n);return t||void 0}getExtensionDescriptionByUUID(n){for(const t of this.g)if(t.uuid===n)return t}getExtensionDescriptionByIdOrUUID(n,t){return this.getExtensionDescription(n)??(t?this.getExtensionDescriptionByUUID(t):void 0)}}e.$T$b=g;class k{constructor(n,t){this.versionId=n,this.extensions=t}}e.$U$b=k;class N{constructor(n){this.d=new v,this.c=new g(n,[])}async acquireLock(n){const t=await this.d.acquire(n);return new y(this,t)}deltaExtensions(n,t,c){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(t,c)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,t){return this.c.getExtensionDescriptionByIdOrUUID(n,t)}}e.$V$b=N;class y extends O.$Uc{constructor(n,t){super(),this.f=n,this.c=!1,this.B(t)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$W$b=y;class u{constructor(n){this.name=n;const t=(0,M.$jh)();this.promise=t.promise,this.c=t.resolve}resolve(n){this.c(n)}}class v{constructor(){this.c=[],this.d=!1}async acquire(n){const t=new u(n);return this.c.push(t),this.e(),t.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let t=!0;const c=setTimeout(()=>{t&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{t&&(clearTimeout(c),t=!1,this.d=!1,this.e())};n.resolve((0,O.$Sc)(h))}}var m;(function(r){r[r.Builtin=0]="Builtin",r[r.User=1]="User",r[r.Dev=2]="Dev"})(m||(m={}));function s(r,n){const t=r.isBuiltin?0:r.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(t!==c)return t-c;const h=R.$hc.basename(r.extensionLocation.path),i=R.$hc.basename(n.extensionLocation.path);return h<i?-1:h>i?1:0}function o(r,n){const t=new I.$Mm(n);return r.filter(c=>!t.has(c.identifier))}}),define(Re[77],Ae([1,0,23]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Tm=M,e.$Um=p;var T;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(T||(e.UIKind=T={}));var R;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var O;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function M(k){const N=I.$Ce.alloc(1);switch(k){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}function p(k,N){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}var g;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Re[62],Ae([1,0,3,5,13,27,77,58,59,26,2,6,170]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=e.$vP=e.$uP=void 0,e.$wP=s;let v=class extends y.$Uc{constructor(r,n){super(),this.s=r,this.t=n,this.a=this.B(new T.$be),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$be),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=N.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:g.$ep,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(t=>{(0,R.$Yj)(t)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,n,t){const c=this.getTelemetryDetails(),h=new m(n,t,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(r,n,t){this.f=r,this.g=n,this.c=t??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const n=Object.create(null);switch(n["common.extname"]=`${r.publisher}.${r.name}`,n["common.extversion"]=r.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$Cm)((0,g.$kp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const n=this.getTelemetryDetails();this.r.forEach((t,c)=>{const h=t.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(t=>{for(const c of t)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,n){const c=this.r.get(r.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(r.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),h=!0);return h}};e.$uP=v,e.$uP=v=Je([Ve(0,O.$tP),Ve(1,R.$Xj)],v);class m{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,n,t,c,h,i,b){this.g=t,this.h=c,this.i=h,this.j=i,this.a=new T.$be,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled}}updateTelemetryEnablements(r,n){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let n="properties"in r?r.properties??{}:r;return n=(0,g.$np)(n,[]),this.c&&(n=(0,k.$Zn)(n,this.c)),this.b||(n=(0,k.$Zn)(n,this.j)),"properties"in r?r.properties=n:r=n,r}k(r,n){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(r,n),this.h.trace(r,n))}logUsage(r,n){this.d.isUsageEnabled&&this.k(r,n)}logError(r,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,n);else{const t={name:r.name,message:r.message,stack:r.stack,cause:r.cause},c=(0,g.$np)(t,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const r=this,n={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$vP=m;function s(o){const r=Date.now()-new Date(o).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$xP=(0,I.$qi)("IExtHostTelemetry")}),define(Re[25],Ae([1,0,5,2,199,103,20,3]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DG=e.ActivationKind=e.$AG=e.$zG=e.$wG=e.ExtensionHostStartup=e.$vG=e.$uG=e.$tG=e.$sG=void 0,e.$xG=u,e.$yG=v,e.$BG=r,e.$CG=n,e.$sG=Object.freeze({identifier:new M.$Lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$tG="extensions.webWorker",e.$uG=(0,p.$qi)("extensionService");class g{constructor(h){this.dependency=h}}e.$vG=g;var k;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class N{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,b){this.c=h,this.d=i.slice(0),this.e=b.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$dG.createActivationEventsMap(this.d)}}set(h,i,b){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const a=[],$=[],l=[],S=[],d=y(this.d),D=y(i),f=(V,W)=>V.extensionLocation.toString()===W.extensionLocation.toString()||V.isBuiltin===W.isBuiltin||V.isUserBuiltin===W.isUserBuiltin||V.isUnderDevelopment===W.isUnderDevelopment;for(const V of this.d){const W=D.get(V.identifier);if(!W){a.push(V.identifier),d.delete(V.identifier);continue}if(!f(V,W)){a.push(V.identifier),d.delete(V.identifier);continue}}for(const V of i){const W=d.get(V.identifier);if(!W){$.push(V);continue}if(!f(W,V)){a.push(W.identifier),d.delete(W.identifier);continue}}const E=new M.$Mm(this.e),w=new M.$Mm(b);for(const V of this.e)w.has(V)||l.push(V);for(const V of b)E.has(V)||S.push(V);const P=O.$dG.createActivationEventsMap($),C={versionId:h,toRemove:a,toAdd:$,addActivationEvents:P,myToRemove:l,myToAdd:S};return this.delta(C),C}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:b,myToRemove:a,myToAdd:$}=h,l=new M.$Mm(i),S=new M.$Mm(a);for(let d=0;d<this.d.length;d++)l.has(this.d[d].identifier)&&(this.d.splice(d,1),d--);for(let d=0;d<this.e.length;d++)S.has(this.e[d])&&(this.e.splice(d,1),d--);for(const d of b)this.d.push(d);for(const d of $)this.e.push(d);return this.f=null,h}containsExtension(h){for(const i of this.e)if(M.$Lm.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const b=O.$dG.readActivationEvents(i);for(const a of b)h.add(a)}return h}}e.$wG=N;function y(c){const h=new M.$Nm;for(const i of c)h.set(i.identifier,i);return h}function u(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}function v(c,h){if(!u(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class m{constructor(h,i,b,a){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=b,this.activationReason=a}}e.$zG=m;class s{constructor(h,i){this.description=h,this.value=i}}e.$AG=s;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,R.$tp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function n(c,h){return{identifier:new M.$Lm((0,R.$rp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class t{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$DG=t}),define(Re[226],Ae([1,0,14,108,20,25,13,11]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkc=e.$Ykc=e.$Xkc=e.$Wkc=e.$Vkc=e.$Ukc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(r,n,t,c){this.startup=r,this.codeLoadingTime=n,this.activateCallTime=t,this.activateResolvedTime=c}}e.$Ukc=g;class k{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,n){return r===-1||n===-1?-1:n-r}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Vkc=k;class N{constructor(r,n,t,c,h,i){this.activationFailed=r,this.activationFailedError=n,this.activationTimes=t,this.module=c,this.exports=h,this.subscriptions=i}}e.$Wkc=N;class y extends N{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Xkc=y;class u extends N{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ykc=u;class v extends N{constructor(r){super(!0,r,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(r,n,t,c){this.g=c,this.a=r,this.b=n,this.c=t,this.d=new R.$Nm,this.f=Object.create(null)}dispose(){for(const[r,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const r=[];for(const[n,t]of this.d)r.push(t.wait());await Promise.all(r)}isActivated(r){const n=this.d.get(r);return!!(n&&n.value)}getActivatedExtension(r){const n=this.d.get(r);if(!n||!n.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return n.value}async activateByEvent(r,n){if(this.f[r])return;const t=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(t.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,n){const t=this.a.getExtensionDescription(r);if(!t)throw new Error(`Extension '${r.value}' is not known`);return this.h([{id:t.identifier,reason:n}])}async h(r){const n=r.filter(t=>!this.isActivated(t.id)).map(t=>this.j(t));await Promise.all(n.map(t=>t.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const n=this.a.getExtensionDescription(r.id);if(!n){const h=new Error(`Cannot activate unknown extension '${r.id.value}'`),i=this.k(r,null,[],new v(h));return this.c.onExtensionActivationError(r.id,h,new O.$vG(r.id.value)),i}const t=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){t.push(i);continue}if(this.l(h)){t.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:r.reason}));continue}const b=this.a.getExtensionDescription(h);if(b){if(!b.main&&!b.browser)continue;t.push(this.j({id:b.identifier,reason:r.reason}));continue}const a=n.displayName||n.identifier.value,$=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${h}'`),l=this.k(r,n.displayName,[],new v($));return this.c.onExtensionActivationError(n.identifier,$,new O.$vG(h)),l}return this.k(r,n.displayName,t,null)}k(r,n,t,c){const h=new s(r.id,n,r.reason,t,c,this.c,this.g);return this.d.set(r.id,h),h}l(r){return T.$T$b.isHostExtension(r,this.a,this.b)}m(r){const n=this.b.getExtensionDescription(r);return n?!n.main&&!n.browser:!1}};e.$Zkc=m,e.$Zkc=m=Je([Ve(3,M.$Wj)],m);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,n,t,c,h,i,b){this.c=r,this.d=n,this.f=t,this.g=c,this.h=h,this.j=i,this.k=b,this.a=new p.$ph,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const n=this.g[r];if(n.value&&!n.value.activationFailed){this.g.splice(r,1),r--;continue}if(n.value&&n.value.activationFailed){const t=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);t.detail=n.value.activationFailedError,this.h=new v(t),this.j.onExtensionActivationError(this.c,t,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const n=new Error;if(r&&r.name&&(n.name=r.name),r&&r.message?n.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(n.stack=r.stack),this.h=new v(n),this.b&&I.$4(r))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};s=Je([Ve(6,M.$Wj)],s)}),define(Re[227],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[228],Ae([1,0,185,14,33,98,72,30,20,227,195,103]),function(ge,e,I,T,R,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=void 0;const u=p.$9n.as(M.$0n.JSONContribution);class v{constructor(h,i,b){this.a=h,this.b=i,this.c=b}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(R.default.Error,h)}warn(h){this.d(R.default.Warning,h)}info(h){this.d(R.default.Info,h)}}e.$mG=v;class m{static a(h){const i=new g.$Mm;for(let b=0,a=h.length;b<a;b++)i.add(h[b].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new m(i,[]);if(!i||!i.length)return new m([],h);const b=this.a(h),a=this.a(i),$=i.filter(S=>!b.has(S.description.identifier)),l=h.filter(S=>!a.has(S.description.identifier));return new m($,l)}constructor(h,i){this.added=h,this.removed=i}}e.$nG=m;class s{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=m.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$oG=s;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$pG={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$Km},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$No}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$No}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new s(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&y.$dG.register(h.extensionPoint,h.activationEventsGenerator),e.$pG.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,u.registerSchema(r,e.$pG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$qG=n;const t={ExtensionsRegistry:"ExtensionsRegistry"};p.$9n.add(t.ExtensionsRegistry,new n),e.$rG=p.$9n.as(t.ExtensionsRegistry),u.registerSchema(r,e.$pG),u.registerSchema(N.$ek,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Re[229],Ae([1,0,181,17,26,228,31,5]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VH=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var k;(function(u){function v(m,s,o){if(!m)return;const r=T.$4f(m.type)?m.type:void 0;if(!r||r.length===0){o.error(I.localize(3,null));return}const n=[];if(Array.isArray(m.required))for(const t of m.required)T.$4f(t)&&n.push(t);return{extensionId:s.value,taskType:r,required:n,properties:m.properties?R.$Wn(m.properties):{},when:m.when?M.$oj.deserialize(m.when):void 0}}u.from=v})(k||(k={}));const N=O.$rG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,v)=>{for(const m of u)m.type&&v.push(`onTaskType:${m.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:g}});class y{constructor(){this.d=new p.$be,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,m)=>{N.setHandler((s,o)=>{this.c=void 0;try{for(const r of o.removed){const n=r.value;for(const t of n)this.a&&t.type&&this.a[t.type]&&delete this.a[t.type]}for(const r of o.added){const n=r.value;for(const t of n){const c=k.from(t,r.description.identifier,r.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const m of this.all()){const s={type:"object",additionalProperties:!1};m.required.length>0&&(s.required=m.required.slice(0)),m.properties!==void 0?s.properties=R.$Wn(m.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[m.taskType]},v.push(s)}this.c={oneOf:v}}return this.c}}e.$VH=new y}),define(Re[230],Ae([1,0,182,17,24,26,31,229]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$6H=e.JsonSchemaVersion=e.ExecutionEngine=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$ZH=e.ShellQuoting=e.$YH=e.$XH=e.$WH=void 0,e.$WH="settings",e.$XH=new M.$Hj("taskRunning",!1,I.localize(0,null)),e.$YH=I.localize2(2,"Tasks");var g;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$ZH="$customized",function(A){function U(K){if(!K)return A.Strong;switch(K.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=U}(g||(e.ShellQuoting=g={}));var k;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var N;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(N||(e.RevealKind=N={})),function(A){function U(K){switch(K.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=U}(N||(e.RevealKind=N={}));var y;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(y||(e.RevealProblemKind=y={})),function(A){function U(K){switch(K.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=U}(y||(e.RevealProblemKind=y={}));var u;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(u||(e.PanelKind=u={})),function(A){function U(K){switch(K.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=U}(u||(e.PanelKind=u={}));var v;(function(A){A.defaults={echo:!0,reveal:N.Always,revealProblems:y.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var m;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(A){function U(se){switch(se.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=U;function K(se){switch(se){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=K}(m||(e.RuntimeType=m={}));var s;(function(A){function U(K){return T.$4f(K)?K:K.value}A.value=U})(s||(e.CommandString=s={}));var o;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function U(se){return se===A.Clean._id||se===A.Build._id||se===A.Rebuild._id||se===A.Test._id}A.is=U;function K(se){if(se!==void 0)return T.$4f(se)?U(se)?{_id:se,isDefault:!1}:void 0:se}A.from=K})(o||(e.TaskGroup=o={}));var r;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var n;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function U(K){switch(K){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=U})(n||(e.TaskSourceKind=n={}));var t;(function(A){A.parallel="parallel",A.sequence="sequence"})(t||(e.DependsOrder=t={}));var c;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(U,K,se,ce,ve,Ie){this._label="",this._id=U,K&&(this._label=K),se&&(this.type=se),this.runOptions=ce,this.configurationProperties=ve,this._source=Ie}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,K=!1){if(U===void 0)return!1;if(T.$4f(U))return U===this._label||U===this.configurationProperties.identifier||K&&U===this._id;const se=this.getDefinition(!0);return se!==void 0&&se._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$1H=i;class b extends i{constructor(U,K,se,ce,ve,Ie,ue,be){super(U,se,void 0,ue,be,K),this.command={},this._source=K,this.hasDefinedMatchers=Ie,ve&&(this.command=ve)}clone(){return new b(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case m.Shell:K="shell";break;case m.Process:K="process";break;case m.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(U){return U instanceof b}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$WH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const se={type:e.$ZH,folder:U,id:K};return JSON.stringify(se)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$1g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new b(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$2H=b;class a extends i{constructor(U,K,se,ce,ve,Ie,ue){super(U,se,ce,Ie,ue,K),this._source=K,this.configures=ve}static is(U){return U instanceof a}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$1g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$WH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const se={type:e.$ZH,folder:U,id:K};return JSON.stringify(se)}}e.$3H=a;class $ extends i{constructor(U,K,se,ce,ve,Ie,ue,be,ie){super(U,se,ce,be,ie,K),this.defines=ve,this.hasDefinedMatchers=ue,this.command=Ie,this.icon=ie.icon,this.hide=ie.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof $}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new $(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$4H=$;class l extends i{constructor(U,K,se,ce,ve,Ie){super(U,se,ce,ve,Ie,K),this._source=K}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new l(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$5H=l;var S;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(A){A._default=A.Terminal}(S||(e.ExecutionEngine=S={}));var d;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(d||(e.JsonSchemaVersion=d={}));class D{constructor(U){this.c=new Map;for(let K=0;K<U.length;K++)this.c.set(U[K].uri.toString(),K)}compare(U,K){const se=U.getWorkspaceFolder(),ce=K.getWorkspaceFolder();if(se&&ce){let ve=this.c.get(se.uri.toString());ve=ve===void 0?0:ve+1;let Ie=this.c.get(ce.uri.toString());return Ie=Ie===void 0?0:Ie+1,ve===Ie?U._label.localeCompare(K._label):ve-Ie}else return!se&&ce?-1:se&&!ce?1:0}}e.$6H=D;var f;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(f||(e.TaskEventKind=f={}));var E;(function(A){A.SingleRun="singleRun",A.Background="background"})(E||(e.TaskRunType=E={}));var w;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var P;(function(A){function U(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?"background":"singleRun",group:be.configurationProperties.group,__task:be}}function K(be,ie,Ce){return{...U(be),kind:"start",terminalId:ie,resolvedVariables:Ce}}A.start=K;function se(be,ie,Ce){return{...U(be),kind:"processStarted",terminalId:ie,processId:Ce}}A.processStarted=se;function ce(be,ie,Ce){return{...U(be),kind:"processEnded",terminalId:ie,exitCode:Ce}}A.processEnded=ce;function ve(be,ie,Ce){return{...U(be),kind:"terminated",exitReason:Ce,terminalId:ie}}A.terminated=ve;function Ie(be,ie,Ce){return{...U(ie),kind:be,terminalId:Ce}}A.general=Ie;function ue(){return{kind:"changed"}}A.changed=ue})(P||(e.TaskEvent=P={}));var C;(function(A){function U(se){const ce=Object.keys(se).sort();let ve="";for(const Ie of ce){let ue=se[Ie];ue instanceof Object?ue=U(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ve+=Ie+","+ue+","}return ve}function K(se){const ve={_key:U(se),type:se.taskType};return Object.assign(ve,se),ve}A.create=K})(C||(e.KeyedTaskIdentifier=C={}));var V;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(V||(e.TaskSettingId=V={}));var W;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var q;(function(A){function U(K,se){const ce=p.$VH.get(K.type);if(ce===void 0){const be=O.$Wn(K);return delete be._key,C.create(be)}const ve=Object.create(null);ve.type=ce.taskType;const Ie=new Set;ce.required.forEach(be=>Ie.add(be));const ue=ce.properties;for(const be of Object.keys(ue)){const ie=K[be];if(ie!=null)ve[be]=ie;else if(Ie.has(be)){const Ce=ue[be];if(Ce.default!==void 0)ve[be]=O.$Wn(Ce.default);else switch(Ce.type){case"boolean":ve[be]=!1;break;case"number":case"integer":ve[be]=0;break;case"string":ve[be]="";break;default:se.error(I.localize(1,null,JSON.stringify(K,void 0,0),be));return}}}return C.create(ve)}A.createTaskIdentifier=U})(q||(e.TaskDefinition=q={}))}),define(Re[231],Ae([1,0,14]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=e.$X$b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,p)=>{this.b=M,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,I.$1)(M))}then(M,p){return this.j().then(M,p)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$X$b=T;class R extends T{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$Y$b=R}),define(Re[34],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$jw=void 0,e.$kw=R,e.$lw=O;class I{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++I.count}}e.$jw=I;const T=[];function R(p){const g=new I(p);return T[g.nid]=g,g}function O(p){return T[p].sid}class M{constructor(g){this.value=g}}e.$mw=M}),define(Re[4],Ae([1,0,34]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$PM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var R;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput",s[s.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var O;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var M;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var p;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var g;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var k;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var N;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(N||(e.CandidatePortSource=N={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$PM=y;var u;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var m;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$QM={MainThreadAuthentication:(0,I.$kw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$kw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$kw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$kw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$kw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$kw)("MainThreadClipboard"),MainThreadCommands:(0,I.$kw)("MainThreadCommands"),MainThreadComments:(0,I.$kw)("MainThreadComments"),MainThreadConfiguration:(0,I.$kw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$kw)("MainThreadConsole"),MainThreadDebugService:(0,I.$kw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$kw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$kw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$kw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$kw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$kw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$kw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$kw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$kw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$kw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$kw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$kw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$kw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$kw)("MainThreadLanguages"),MainThreadLogger:(0,I.$kw)("MainThreadLogger"),MainThreadMessageService:(0,I.$kw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$kw)("MainThreadOutputService"),MainThreadProgress:(0,I.$kw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$kw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$kw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$kw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$kw)("MainThreadSecretState"),MainThreadStorage:(0,I.$kw)("MainThreadStorage"),MainThreadSpeech:(0,I.$kw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$kw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$kw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.$kw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.$kw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$kw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$kw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$kw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$kw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$kw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$kw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$kw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$kw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$kw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$kw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$kw)("MainThreadSCM"),MainThreadSearch:(0,I.$kw)("MainThreadSearch"),MainThreadShare:(0,I.$kw)("MainThreadShare"),MainThreadTask:(0,I.$kw)("MainThreadTask"),MainThreadWindow:(0,I.$kw)("MainThreadWindow"),MainThreadLabelService:(0,I.$kw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$kw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$kw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$kw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$kw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$kw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$kw)("MainThreadInteractive"),MainThreadInlineChat:(0,I.$kw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$kw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$kw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$kw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$kw)("MainThreadTimeline"),MainThreadTesting:(0,I.$kw)("MainThreadTesting"),MainThreadLocalization:(0,I.$kw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$kw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$kw)("MainThreadAiEmbeddingVector")},e.$RM={ExtHostCommands:(0,I.$kw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$kw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$kw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$kw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$kw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$kw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$kw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$kw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$kw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$kw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$kw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$kw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$kw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$kw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$kw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$kw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$kw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$kw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$kw)("ExtHostStatusBar"),ExtHostShare:(0,I.$kw)("ExtHostShare"),ExtHostExtensionService:(0,I.$kw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$kw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$kw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.$kw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.$kw)("ExtHostSCM"),ExtHostSearch:(0,I.$kw)("ExtHostSearch"),ExtHostTask:(0,I.$kw)("ExtHostTask"),ExtHostWorkspace:(0,I.$kw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$kw)("ExtHostWindow"),ExtHostWebviews:(0,I.$kw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$kw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$kw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$kw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$kw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$kw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$kw)("ExtHostProgress"),ExtHostComments:(0,I.$kw)("ExtHostComments"),ExtHostSecretState:(0,I.$kw)("ExtHostSecretState"),ExtHostStorage:(0,I.$kw)("ExtHostStorage"),ExtHostUrls:(0,I.$kw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$kw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$kw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$kw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$kw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$kw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$kw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$kw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$kw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$kw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$kw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$kw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$kw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,I.$kw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$kw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$kw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$kw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$kw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$kw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$kw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$kw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$kw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$kw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$kw)("ExtHostTimeline"),ExtHostTesting:(0,I.$kw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$kw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$kw)("ExtHostLocalization")}}),define(Re[78],Ae([1,0,3,13,4,16]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=e.$ikc=e.$hkc=void 0,e.$hkc=(0,I.$qi)("IExtHostApiDeprecationService");let M=class{constructor(g,k){this.c=k,this.a=new Set,this.b=g.getProxy(R.$QM.MainThreadTelemetry)}report(g,k,N){const y=this.d(g,k);this.a.has(y)||(this.a.add(y),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:g}))}d(g,k){return`${g}-${k.identifier.value}`}};e.$ikc=M,e.$ikc=M=Je([Ve(0,O.$dP),Ve(1,T.$Wj)],M),e.$jkc=Object.freeze(new class{report(p,g,k){}})}),define(Re[232],Ae([1,0,4]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=void 0;class T{constructor(O){const M=O.getProxy(I.$QM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(p){return M.$writeText(p)}})}}e.$wkc=T}),define(Re[233],Ae([1,0,26,4,27,16]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=void 0;let M=class{constructor(N,y){this.a=N.getProxy(T.$QM.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(N,y){const u=this,v=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){u.e(N,y,v,arguments)}})}e(N,y,u,v){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:g(v,this.b)}),this.c&&this.f(N,u,v)}};e.$qmc=M,e.$qmc=M=Je([Ve(0,O.$dP),Ve(1,R.$tP)],M);const p=1e5;function g(k,N){const y=[];if(k.length)for(let u=0;u<k.length;u++){let v=k[u];if(typeof v>"u")v="undefined";else if(v instanceof Error){const m=v;m.stack?v=m.stack:v=m.toString()}y.push(v)}if(N){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.$2n)(y);return u.length>p?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Re[234],Ae([1,0,2,4,25]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;class O{constructor(p){this.a=p.getProxy(T.$QM.MainThreadDialogs)}showOpenDialog(p,g){return g?.allowUIResources&&(0,R.$yG)(p,"showLocal"),this.a.$showOpenDialog(g).then(k=>k?k.map(N=>I.URI.revive(N)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(g=>g?I.URI.revive(g):void 0)}}e.$tlc=O}),define(Re[235],Ae([1,0,6,4]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;class R{constructor(M){this.b=0,this.a=M.getProxy(T.$QM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,M),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$Nlc=R}),define(Re[79],Ae([1,0,21,15,2,3,13,4,27,16]),function(ge,e,I,T,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=e.$blc=void 0;let N=class{constructor(u,v,m){this.f=m,this.d=new Map,this.a=v.getProxy(p.$QM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===I.$g}getMessage(u,v){const{message:m,args:s,comment:o}=v;if(this.c)return(0,T.$5e)(m,s??{});let r=m;o&&o.length>0&&(r+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(u)?.contents[r];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,T.$5e)(n??m,s??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let v;const m=await this.g(u);if(!m){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(m),o=JSON.parse(s);v=u.isBuiltin?o.contents?.bundle:o}catch(s){this.f.error(`Failed to load translations for ${u.identifier.value} from ${m}: ${s.message}`);return}v&&this.d.set(u.identifier.value,{contents:v,uri:m})}async g(u){if(u.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return R.URI.revive(v)}return u.l10n?R.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$blc=N,e.$blc=N=Je([Ve(0,g.$tP),Ve(1,k.$dP),Ve(2,M.$Wj)],N),e.$clc=(0,O.$qi)("IExtHostLocalizationService")}),define(Re[236],Ae([1,0,13,4,27,16,2,53]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=void 0;let g=class extends I.$8j{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(v=>(0,p.$Zh)(v))),this.r=y.getProxy(T.$QM.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(M.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,v){return new k(this.r,y,u,v)}};e.$pmc=g,e.$pmc=g=Je([Ve(0,O.$dP),Ve(1,R.$tP)],g);class k extends I.$3j{constructor(y,u,v,m){super(m?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(u,m).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const v=[[y,u]];this.m?this.u(v):this.n.push(...v)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Re[80],Ae([1,0,4,3,6,16,23]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=e.$dlc=void 0,e.$dlc=(0,T.$qi)("IExtHostManagedSockets");let p=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(I.$QM.MainThreadManagedSockets)}setFactory(y,u){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,v=await this.c.makeConnection(),m=new R.$Tc;return this.d.set(u,new k(u,v,m)),m.add((0,R.$Sc)(()=>this.d.delete(u))),m.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),m.dispose()})),m.add(v.onDidClose(s=>{this.a.$onDidManagedSocketClose(u,s?.stack??s?.message),m.dispose()})),m.add(v.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(u,M.$Ce.wrap(s)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$elc=p,e.$elc=p=Je([Ve(0,O.$dP)],p);class g{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class k extends R.$Uc{constructor(y,u,v){super(),this.socketId=y,this.actual=u,this.B(v)}}}),define(Re[237],Ae([1,0,4,13,25]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=void 0;function O(p){return p&&p.title}let M=class{constructor(g,k){this.b=k,this.a=g.getProxy(I.$QM.MainThreadMessageService)}showMessage(g,k,N,y,u){const v={source:{identifier:g.identifier,label:g.displayName||g.name}};let m;typeof y=="string"||O(y)?m=[y,...u]:(v.modal=y?.modal,v.useCustom=y?.useCustom,v.detail=y?.detail,m=u),v.useCustom&&(0,R.$yG)(g,"resolvers");const s=[];let o=!1;for(let r=0;r<m.length;r++){const n=m[r];if(typeof n=="string")s.push({title:n,handle:r,isCloseAffordance:!1});else if(typeof n=="object"){const{title:t,isCloseAffordance:c}=n;s.push({title:t,isCloseAffordance:!!c,handle:r}),c&&(o?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,n)}return this.a.$showMessage(k,N,v,s).then(r=>{if(typeof r=="number")return m[r]})}};e.$Plc=M,e.$Plc=M=Je([Ve(1,T.$Wj)],M)}),define(Re[238],Ae([1,0,6,17,2,25,4]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=void 0;class p{constructor(k){this.b=new Map,this.a=k.getProxy(M.$QM.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,N,y){if((0,O.$yG)(k,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,y),this.a.$registerProfileContentHandler(N,y.name,y.description,k.identifier.value),(0,I.$Sc)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(k,N,y,u){const v=this.b.get(k);if(!v)throw new Error(`Unknown handler with id: ${k}`);return v.saveProfile(N,y,u)}async $readProfile(k,N,y){const u=this.b.get(k);if(!u)throw new Error(`Unknown handler with id: ${k}`);return u.readProfile((0,T.$4f)(N)?N:R.URI.revive(N),y)}}e.$Ylc=p}),define(Re[81],Ae([1,0,4,5,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=e.$$kc=void 0;class O{constructor(p){this.b=new T.$be,this.onDidChangePassword=this.b.event,this.a=p.getProxy(I.$QM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,g){return this.a.$getPassword(p,g)}store(p,g,k){return this.a.$setPassword(p,g,k)}delete(p,g){return this.a.$deletePassword(p,g)}}e.$$kc=O,e.$_kc=(0,R.$qi)("IExtHostSecretState")}),define(Re[239],Ae([1,0,22,6,4]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class O{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(R.$QM.MainThreadSpeech)}async $createSpeechToTextSession(p,g,k){const N=this.c.get(p);if(!N)return;const y=new T.$Tc,u=new I.$me;this.d.set(g,u);const v=y.add(N.provideSpeechToTextSession(u.token,k?{language:k}:void 0));y.add(v.onDidChange(m=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,m)})),y.add(u.token.onCancellationRequested(()=>y.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,g){const k=this.c.get(p);if(!k)return;const N=new T.$Tc,y=new I.$me;this.d.set(g,y);const u=N.add(k.provideKeywordRecognitionSession(y.token));N.add(u.onDidChange(v=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(g,v)})),N.add(y.token.onCancellationRequested(()=>N.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,g,k){const N=O.a++;return this.c.set(N,k),this.b.$registerProvider(N,g,{extension:p,displayName:p.value}),(0,T.$Sc)(()=>{this.b.$unregisterProvider(N),this.c.delete(N)})}}e.$6lc=O}),define(Re[82],Ae([1,0,4,5,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=e.$1kc=void 0;class O{constructor(p,g){this.c=g,this.b=new T.$be,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(I.$QM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,g){this.a.$registerExtensionStorageKeysToSync(p,g)}async initializeExtensionStorage(p,g,k){const N=await this.a.$initializeExtensionStorage(p,g);let y;return N&&(y=this.d(p,g,N)),y||k}setValue(p,g,k){return this.a.$setValue(p,g,k)}$acceptValue(p,g,k){const N=this.d(p,g,k);N&&this.b.fire({shared:p,key:g,value:N})}d(p,g,k){try{return JSON.parse(k)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${p}): ${N}`)}}}e.$1kc=O,e.$2kc=(0,R.$qi)("IExtHostStorage")}),define(Re[240],Ae([1,0,6,12,2,4]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=void 0;class M{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(O.$QM.MainThreadUriOpeners)}registerExternalUriOpener(g,k,N,y){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const u=y.schemes.find(v=>!M.a.has(v));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(k,N),this.b.$registerUriOpener(k,y.schemes,g,y.label),(0,I.$Sc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(g,k,N){const y=this.c.get(g);if(!y)throw new Error(`Unknown opener with id: ${g}`);const u=R.URI.revive(k);return y.canOpenExternalUri(u,N)}async $openUri(g,k,N){const y=this.c.get(g);if(!y)throw new Error(`Unknown opener id: '${g}'`);return y.openExternalUri(R.URI.revive(k.resolvedUri),{sourceUri:R.URI.revive(k.sourceUri)},N)}}e.$jmc=M}),define(Re[241],Ae([1,0,4,2,6,14,20]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=void 0;class p{static{this.a=0}constructor(k){this.c=new M.$Mm,this.d=new Map,this.b=k.getProxy(I.$QM.MainThreadUrls)}registerUriHandler(k,N){const y=k.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=p.a++;return this.c.add(y),this.d.set(u,N),this.b.$registerUriHandler(u,y,k.displayName||k.name),(0,R.$Sc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(k,N){const y=this.d.get(k);if(!y)return Promise.resolve(void 0);try{y.handleUri(T.URI.revive(N))}catch(u){(0,O.$1)(u)}return Promise.resolve(void 0)}async createAppUri(k){return T.URI.revive(await this.b.$createAppUri(k))}}e.$kmc=p}),define(Re[63],Ae([1,0,5,6,12,26,2,188,210,76,4]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=e.$Lkc=void 0,e.$Mkc=u,e.$Okc=s,e.$Pkc=o;class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,h,i,b,a,$,l){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$be,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$be,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#o=i,this.#n=b,this.#s=a,this.#r=$,this.#l=u($),this.#d=v($),this.#i=l}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,k.$Uxb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===R.Schemas.https||c.scheme===R.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+k.$Txb}return k.$Txb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),O.$1n(this.#o,c)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$aob)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(b,a,$,l,S,d)=>{const D=M.URI.from({scheme:l||"file",path:decodeURIComponent(S)}),f=(0,k.$Uxb)(D,{isRemote:h,authority:i}).toString();return`${a}${f}${d}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(b,a,$,l,S,d)=>{const D=M.URI.from({scheme:l||"file",path:decodeURIComponent(S)}),f=(0,k.$Uxb)(D,{isRemote:h,authority:i}).toString();return`${a}${f}${d}`})}}e.$Lkc=y;function u(t){try{const c=(0,p.$Cp)((0,p.$Bp)(t.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function v(t){try{const c=(0,p.$Cp)((0,p.$Bp)(t.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class m extends T.$Uc{constructor(c,h,i,b,a){super(),this.c=h,this.f=i,this.g=b,this.h=a,this.b=new Map,this.a=c.getProxy(N.$QM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const b=this.j(c);if(b){const{message:a}=(0,g.$bob)(h,i.value);b._onMessageEmitter.fire(a)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const b=new y(c,this.a,r(h),this.c,this.f,i,this.h);this.b.set(c,b);const a=b._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return b}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Nkc=m;function s(t){return{id:t.identifier,location:t.extensionLocation}}function o(t,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(t,c)}}function r(t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots?.map(c=>M.URI.from(c))}}function n(t,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),t.extensionLocation]}}),define(Re[109],Ae([1,0,5,4,2,12,15,3,16,25]),function(ge,e,I,T,R,O,M,p,g,k){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=e.$mmc=void 0;let y=class{static{N=this}static{this.a={focused:!0,active:!0}}getState(v){const m=this.d;return{get focused(){return m.focused},get active(){return(0,k.$yG)(v,"windowActivity"),m.active}}}constructor(v){this.c=new I.$be,this.onDidChangeWindowState=this.c.event,this.d=N.a,this.b=v.getProxy(T.$QM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:m,isActive:s})=>{this.onDidChangeWindowProperty("focused",m),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,m){m!==this.d[v]&&(this.d={...this.d,[v]:m},this.c.fire(this.d))}openUri(v,m){let s;if(typeof v=="string"){s=v;try{v=R.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,M.$3e)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,s,m)}async asExternalUri(v,m){if((0,M.$3e)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(v,m);return R.URI.from(s)}};e.$mmc=y,e.$mmc=y=N=Je([Ve(0,g.$dP)],y),e.$nmc=(0,p.$qi)("IExtHostWindow")}),define(Re[242],Ae([1,0,233,27,16]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0;let O=class extends I.$qmc{constructor(p,g){super(p,g)}f(p,g,k){g.apply(console,k)}};e.$yoc=O,e.$yoc=O=Je([Ve(0,R.$dP),Ve(1,T.$tP)],O)}),define(Re[243],Ae([1,0,11,23,22,14,5,6,144,231,34]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$Z$b=o,e.$1$b=r;function u(w,P){try{return JSON.stringify(w,P)}catch{return"null"}}const v="$$ref$$",m={[v]:-1};class s{constructor(P,C){this.jsonString=P,this.referencedBuffers=C}}function o(w,P=null,C=!1){const V=[];return{jsonString:(C?u:JSON.stringify)(w,(q,A)=>{if(typeof A>"u")return m;if(typeof A=="object"){if(A instanceof T.$Ce){const U=V.push(A)-1;return{[v]:U}}if(P)return P(q,A)}return A}),referencedBuffers:V}}function r(w,P,C){return JSON.parse(w,(V,W)=>{if(W){const q=W[v];if(typeof q=="number")return P[q];if(C&&W.$mid===1)return C.transformIncoming(W)}return W})}function n(w,P){return JSON.stringify(w,P)}function t(w){return w?(P,C)=>C&&C.$mid===1?w.transformOutgoing(C):C:null}var c;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},b=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class $ extends p.$Uc{static{y=b}static{this.a=3*1e3}constructor(P,C=null,V=null){super(),this[y]=!0,this.b=this.B(new M.$be),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=C,this.g=V,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,q=N.$jw.count;W<q;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$Ch(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const C=this.w[P];delete this.w[P],C.resolveErr(O.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+$.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+$.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,g.$vn)(P,this.g):P}getProxy(P){const{nid:C,sid:V}=P;return this.s[C]||(this.s[C]=this.J(C,V)),this.s[C]}J(P,C){const V={get:(W,q)=>(typeof q=="string"&&!W[q]&&q.charCodeAt(0)===36&&(W[q]=(...A)=>this.U(P,q,A)),q===a?C:W[q])};return new Proxy(Object.create(null),V)}set(P,C){return this.m[P.nid]=C,C}assertRegistered(P){for(let C=0,V=P.length;C<V;C++){const W=P[C];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(P){if(this.j)return;const C=P.byteLength,V=S.read(P,0),W=V.readUInt8(),q=V.readUInt32();switch(W){case 1:case 2:{let{rpcId:A,method:U,args:K}=D.deserializeRequestJSONArgs(V);this.g&&(K=(0,g.$vn)(K,this.g)),this.M(C,q,A,U,K,W===2);break}case 3:case 4:{let{rpcId:A,method:U,args:K}=D.deserializeRequestMixedArgs(V);this.g&&(K=(0,g.$vn)(K,this.g)),this.M(C,q,A,U,K,W===4);break}case 5:{this.f?.logIncoming(C,q,0,"ack"),this.G(q);break}case 6:{this.N(C,q);break}case 7:{this.O(C,q,void 0);break}case 9:{let A=D.deserializeReplyOKJSON(V);this.g&&(A=(0,g.$vn)(A,this.g)),this.O(C,q,A);break}case 10:{const A=D.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(C,q,A);break}case 8:{const A=D.deserializeReplyOKVSBuffer(V);this.O(C,q,A);break}case 11:{let A=D.deserializeReplyErrError(V);this.g&&(A=(0,g.$vn)(A,this.g)),this.P(C,q,A);break}case 12:{this.P(C,q,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,C,V,W,q,A){this.f?.logIncoming(P,C,1,`receiveRequest ${(0,N.$lw)(V)}.${W}(`,q);const U=String(C);let K,se;if(A){const ve=new R.$me;q.push(ve.token),K=this.Q(V,W,q),se=()=>ve.cancel()}else K=this.Q(V,W,q),se=i;this.u[U]=se;const ce=D.serializeAcknowledged(C);this.f?.logOutgoing(ce.byteLength,C,1,"ack"),this.c.send(ce),K.then(ve=>{delete this.u[U];const Ie=D.serializeReplyOK(C,ve,this.h);this.f?.logOutgoing(Ie.byteLength,C,1,"reply:",ve),this.c.send(Ie)},ve=>{delete this.u[U];const Ie=D.serializeReplyErr(C,ve);this.f?.logOutgoing(Ie.byteLength,C,1,"replyErr:",ve),this.c.send(Ie)})}N(P,C){this.f?.logIncoming(P,C,1,"receiveCancel");const V=String(C);this.u[V]?.()}O(P,C,V){this.f?.logIncoming(P,C,0,"receiveReply:",V);const W=String(C);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W],q.resolveOk(V)}P(P,C,V){this.f?.logIncoming(P,C,0,"receiveReplyErr:",V);const W=String(C);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W];let A;V&&(V.$isError?(A=new Error,A.name=V.name,A.message=V.message,A.stack=V.stack):A=V),q.resolveErr(A)}Q(P,C,V){try{return Promise.resolve(this.S(P,C,V))}catch(W){return Promise.reject(W)}}S(P,C,V){const W=this.m[P];if(!W)throw new Error("Unknown actor "+(0,N.$lw)(P));const q=W[C];if(typeof q!="function")throw new Error("Unknown method "+C+" on actor "+(0,N.$lw)(P));return q.apply(W,V)}U(P,C,V){if(this.j)return new k.$Y$b;let W=null;if(V.length>0&&R.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(O.$6());const q=D.serializeRequestArguments(V,this.h),A=++this.t,U=String(A),K=new k.$X$b,se=new p.$Tc;W&&se.add(W.onCancellationRequested(()=>{const ve=D.serializeCancel(A);this.f?.logOutgoing(ve.byteLength,A,0,"cancel"),this.c.send(D.serializeCancel(A))})),this.w[U]=new l(K,se),this.F(A);const ce=D.serializeRequest(A,P,C,q,!!W);return this.f?.logOutgoing(ce.byteLength,A,0,`request: ${(0,N.$lw)(P)}.${C}(`,V),this.c.send(ce),K}}e.$2$b=$;class l{constructor(P,C){this.a=P,this.b=C}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class S{static alloc(P,C,V){const W=new S(T.$Ce.alloc(V+1+4),0);return W.writeUInt8(P),W.writeUInt32(C),W}static read(P,C){return new S(P,C)}get buffer(){return this.a}constructor(P,C){this.a=P,this.b=C}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+P).toString();return this.b+=P,V}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+P).toString();return this.b+=P,V}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const C=this.a.slice(this.b,this.b+P);return this.b+=P,C}static sizeMixedArray(P){let C=0;C+=1;for(let V=0,W=P.length;V<W;V++){const q=P[V];switch(C+=1,q.type){case 1:C+=this.sizeLongString(q.value);break;case 2:C+=this.sizeVSBuffer(q.value);break;case 3:C+=this.sizeUInt32,C+=this.sizeLongString(q.value);for(let A=0;A<q.buffers.length;++A)C+=this.sizeVSBuffer(q.buffers[A]);break;case 4:break}}return C}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let C=0,V=P.length;C<V;C++){const W=P[C];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let q=0;q<W.buffers.length;++q)this.writeBuffer(W.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const C=new Array(P);for(let V=0;V<P;V++)switch(this.readUInt8()){case 1:C[V]=this.readLongString();break;case 2:C[V]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),A=this.readLongString(),U=[];for(let K=0;K<q;++K)U.push(this.readVSBuffer());C[V]=new N.$mw(r(A,U,null));break}case 4:C[V]=void 0;break}return C}}var d;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(d||(d={}));class D{static a(P){for(let C=0,V=P.length;C<V;C++)if(P[C]instanceof T.$Ce||P[C]instanceof N.$mw||typeof P[C]>"u")return!0;return!1}static serializeRequestArguments(P,C){if(this.a(P)){const V=[];for(let W=0,q=P.length;W<q;W++){const A=P[W];if(A instanceof T.$Ce)V[W]={type:2,value:A};else if(typeof A>"u")V[W]={type:4};else if(A instanceof N.$mw){const{jsonString:U,referencedBuffers:K}=o(A.value,C);V[W]={type:3,value:T.$Ce.fromString(U),buffers:K}}else V[W]={type:1,value:T.$Ce.fromString(n(A,C))}}return{type:1,args:V}}return{type:0,args:n(P,C)}}static serializeRequest(P,C,V,W,q){switch(W.type){case 0:return this.b(P,C,V,W.args,q);case 1:return this.c(P,C,V,W.args,q)}}static b(P,C,V,W,q){const A=T.$Ce.fromString(V),U=T.$Ce.fromString(W);let K=0;K+=S.sizeUInt8(),K+=S.sizeShortString(A),K+=S.sizeLongString(U);const se=S.alloc(q?2:1,P,K);return se.writeUInt8(C),se.writeShortString(A),se.writeLongString(U),se.buffer}static deserializeRequestJSONArgs(P){const C=P.readUInt8(),V=P.readShortString(),W=P.readLongString();return{rpcId:C,method:V,args:JSON.parse(W)}}static c(P,C,V,W,q){const A=T.$Ce.fromString(V);let U=0;U+=S.sizeUInt8(),U+=S.sizeShortString(A),U+=S.sizeMixedArray(W);const K=S.alloc(q?4:3,P,U);return K.writeUInt8(C),K.writeShortString(A),K.writeMixedArray(W),K.buffer}static deserializeRequestMixedArgs(P){const C=P.readUInt8(),V=P.readShortString(),W=P.readMixedArray(),q=new Array(W.length);for(let A=0,U=W.length;A<U;A++){const K=W[A];typeof K=="string"?q[A]=JSON.parse(K):q[A]=K}return{rpcId:C,method:V,args:q}}static serializeAcknowledged(P){return S.alloc(5,P,0).buffer}static serializeCancel(P){return S.alloc(6,P,0).buffer}static serializeReplyOK(P,C,V){if(typeof C>"u")return this.d(P);if(C instanceof T.$Ce)return this.e(P,C);if(C instanceof N.$mw){const{jsonString:W,referencedBuffers:q}=o(C.value,V,!0);return this.g(P,W,q)}else return this.f(P,u(C,V))}static d(P){return S.alloc(7,P,0).buffer}static e(P,C){let V=0;V+=S.sizeVSBuffer(C);const W=S.alloc(8,P,V);return W.writeVSBuffer(C),W.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,C){const V=T.$Ce.fromString(C);let W=0;W+=S.sizeLongString(V);const q=S.alloc(9,P,W);return q.writeLongString(V),q.buffer}static g(P,C,V){const W=T.$Ce.fromString(C);let q=0;q+=S.sizeUInt32,q+=S.sizeLongString(W);for(const U of V)q+=S.sizeVSBuffer(U);const A=S.alloc(10,P,q);A.writeUInt32(V.length),A.writeLongString(W);for(const U of V)A.writeBuffer(U);return A.buffer}static deserializeReplyOKJSON(P){const C=P.readLongString();return JSON.parse(C)}static deserializeReplyOKJSONWithBuffers(P,C){const V=P.readUInt32(),W=P.readLongString(),q=[];for(let A=0;A<V;++A)q.push(P.readVSBuffer());return new N.$mw(r(W,q,C))}static serializeReplyErr(P,C){const V=C?u(O.$3(C),null):void 0;if(typeof V!="string")return this.h(P);const W=T.$Ce.fromString(V);let q=0;q+=S.sizeLongString(W);const A=S.alloc(11,P,q);return A.writeLongString(W),A.buffer}static deserializeReplyErrError(P){const C=P.readLongString();return JSON.parse(C)}static h(P){return S.alloc(12,P,0).buffer}}var f;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var E;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(E||(E={}))}),define(Re[244],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=void 0;const I=function(O){const M=p=>{globalThis.removeEventListener("message",M);const g=p.data;Object.defineProperties(globalThis,{postMessage:{value(k,N){g.postMessage(k,N)}},onmessage:{get(){return g.onmessage},set(k){g.onmessage=k}}}),g.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data,ports:k.ports?[...k.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",M)}.toString();class T extends EventTarget{constructor(O,M,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${I})('${M}'))`,k=new Blob([g],{type:"application/javascript"}),N=URL.createObjectURL(k),y=new MessageChannel,u=N,v={type:"_newWorker",id:u,port:y.port2,url:N,options:p};O(v,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:u}),URL.revokeObjectURL(N),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(m){y.port1.onmessage=m}},onmessageerror:{get(){return y.port1.onmessageerror},set(m){y.port1.onmessageerror=m}}}),y.port1.addEventListener("messageerror",m=>{const s=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(s)}),y.port1.addEventListener("message",m=>{const s=new MessageEvent("message",{data:m.data});this.dispatchEvent(s)}),y.port1.start()}}e.$Aoc=T}),define(Re[245],Ae([1,0,23,28,12,55,3]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.$sK=void 0,e.$tK=N,e.$uK=y,e.$sK=(0,M.$qi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],g=new RegExp(`^[${p.join("")}]+`),k=7;function N(v){if(v.scheme!==R.Schemas.vscodeNotebookCell)return;const m=v.fragment.indexOf("s");if(m<0)return;const s=parseInt(v.fragment.substring(0,m).replace(g,""),k),o=(0,I.$Ve)(v.fragment.substring(m+1)).toString();if(!isNaN(s))return{handle:s,notebook:v.with({scheme:o,fragment:null})}}function y(v,m){const s=m.toString(k),r=`${s.length<p.length?p[s.length-1]:"z"}${s}s${(0,I.$We)(I.$Ce.fromString(v.scheme),!0,!0)}`;return v.with({scheme:R.Schemas.vscodeNotebookCell,fragment:r})}class u{constructor(){this.a=new T.$Bc}getNotebook(m){if(m.scheme===R.Schemas.vscodeNotebookCell){const s=N(m);if(s){const o=this.a.get(s.notebook);if(o)return o}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$vK=u,(0,O.$os)(e.$sK,u,1)}),define(Re[83],Ae([1,0,23,36,40,69,12,19,21,31,245]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$MK=e.CellStatusbarAlignment=e.$LK=e.NotebookEditorPriority=e.$IK=e.$HK=e.$FK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$EK=e.$DK=e.$CK=e.$BK=e.CellKind=e.$AK=e.$zK=e.$yK=void 0,e.$GK=b,e.$JK=$,e.$KK=l,e.$NK=D,e.$OK=E,e.$yK="workbench.editor.notebook",e.$zK="workbench.editor.notebookTextDiffEditor",e.$AK="workbench.editor.interactive";var y;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(y||(e.CellKind=y={})),e.$BK=["application/json","application/javascript","text/html","image/svg+xml",O.$Hs.latex,O.$Hs.markdown,"image/png","image/jpeg",O.$Hs.text],e.$CK=[O.$Hs.latex,O.$Hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Hs.text],e.$DK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$EK="_notAvailable";var u;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var v;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var m;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(m||(e.NotebookExecutionState=m={}));var s;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var r;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var n;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var t;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(t||(e.CellEditType=t={}));var c;(function(K){K.scheme=M.Schemas.vscodeNotebookCell;function se(ie,Ce){return(0,N.$uK)(ie,Ce)}K.generate=se;function ce(ie){return(0,N.$tK)(ie)}K.parse=ce;function ve(ie,Ce){return ie.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${Ce??""},${ie.scheme!==M.Schemas.file?ie.scheme:""}`})}K.generateCellOutputUri=ve;function Ie(ie){if(ie.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const Ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ie.fragment);if(!Ce)return;const Fe=Ce[1]&&Ce[1]!==""?Ce[1]:void 0,ne=Ce[2];return{outputId:Fe,notebook:ie.with({scheme:ne||M.Schemas.file,fragment:null})}}K.parseCellOutputUri=Ie;function ue(ie,Ce,Fe){return K.generate(ie,Ce).with({scheme:Fe})}K.generateCellPropertyUri=ue;function be(ie,Ce){if(ie.scheme===Ce)return K.parse(ie.with({scheme:K.scheme}))}K.parseCellPropertyUri=be})(c||(e.CellUri=c={}));const h=K=>g.$i?K.replace(/\//g,"\\"):K;class i{constructor(se=[],ce=e.$BK){this.e=ce,this.d=[...new Set(se)].map(ve=>({pattern:ve,matches:T.$kk(h(ve))}))}sort(se){const ce=new Map(R.Iterable.map(se,Ie=>[Ie,h(Ie)]));let ve=[];for(const{matches:Ie}of this.d)for(const[ue,be]of ce)if(Ie(be)){ve.push(ue),ce.delete(ue);break}return ce.size&&(ve=ve.concat([...ce.keys()].sort((Ie,ue)=>this.e.indexOf(Ie)-this.e.indexOf(ue)))),ve}prioritize(se,ce){const ve=this.f(se);if(ve===-1){this.d.unshift({pattern:se,matches:T.$kk(h(se))});return}const Ie=new Set(ce.map(be=>this.f(be,ve)));Ie.delete(-1);const ue=Array.from(Ie).sort();this.d.splice(ve+1,0,...ue.map(be=>this.d[be]));for(let be=ue.length-1;be>=0;be--)this.d.splice(ue[be],1)}toArray(){return this.d.map(se=>se.pattern)}f(se,ce=this.d.length){const ve=h(se);for(let Ie=0;Ie<ce;Ie++)if(this.d[Ie].matches(ve))return Ie;return-1}}e.$FK=i;function b(K,se,ce,ve=(Ie,ue)=>Ie===ue){const Ie=[];function ue(Ce,Fe,ne){if(Fe===0&&ne.length===0)return;const j=Ie[Ie.length-1];j&&j.start+j.deleteCount===Ce?(j.deleteCount+=Fe,j.toInsert.push(...ne)):Ie.push({start:Ce,deleteCount:Fe,toInsert:ne})}let be=0,ie=0;for(;;){if(be===K.length){ue(be,0,se.slice(ie));break}if(ie===se.length){ue(be,K.length-be,[]);break}const Ce=K[be],Fe=se[ie];if(ve(Ce,Fe)){be+=1,ie+=1;continue}ce(Fe)?(ue(be,1,[]),be+=1):(ue(be,0,[Fe]),ie+=1)}return Ie}e.$HK=new k.$Hj("notebookEditorCursorAtBoundary","none"),e.$IK=new k.$Hj("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function $(K){const se=K;return!!((typeof se.include=="string"||T.$lk(se.include))&&(typeof se.exclude=="string"||T.$lk(se.exclude)))}function l(K,se,ce){if(Array.isArray(K.viewType)&&K.viewType.indexOf(se)>=0||K.viewType===se)return!0;if(K.filenamePattern){const ve=$(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Ie=$(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(T.$jk(ve,(0,p.$oc)(ce.fsPath).toLowerCase()))return!(Ie&&T.$jk(Ie,(0,p.$oc)(ce.fsPath).toLowerCase()))}return!1}e.$LK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var S;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class d{static{this.d="notebook/"}static create(se){return`${d.d}${se}`}static parse(se){if(se.startsWith(d.d))return se.substring(d.d.length)}}e.$MK=d;function D(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const f=new TextDecoder;function E(K){const se=[];let ce=!1;for(const be of K)(se.length===0||ce)&&(se.push(be),ce=!0);let ve=C(se);const Ie=I.$Ce.concat(se.map(be=>I.$Ce.wrap(be))),ue=U(Ie);return ve=ve||ue.byteLength!==Ie.byteLength,{data:ue,didCompression:ve}}e.$PK="\x1B[A";const w=e.$PK.split("").map(K=>K.charCodeAt(0)),P=10;function C(K){let se=!1;return K.forEach((ce,ve)=>{if(ve===0||ce.length<e.$PK.length)return;const Ie=K[ve-1],ue=ce.subarray(0,e.$PK.length);if(ue[0]===w[0]&&ue[1]===w[1]&&ue[2]===w[2]){const be=Ie.lastIndexOf(P);if(be===-1)return;se=!0,K[ve-1]=Ie.subarray(0,be),K[ve]=ce.subarray(e.$PK.length)}}),se}function V(K){let se=K;do K=se,se=K.replace(/[^\n]\x08/gm,"");while(se.length<K.length);return K}function W(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const se=K.match(/^(.*)\r+/m)[1];let ce=K.match(/\r+(.*)$/m)[1];ce=ce+se.slice(ce.length,se.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return K}const q=8,A=13;function U(K){return!K.buffer.includes(q)&&!K.buffer.includes(A)?K:I.$Ce.fromString(W(V(f.decode(K.buffer))))}}),define(Re[7],Ae([1,0,18,14,54,28,69,15,17,2,35,20,44,102,83]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m){"use strict";var s,o,r,n,t,c,h,i,b,a,$,l,S,d,D,f,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$4O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$3O=e.$2O=e.$1O=e.$ZO=e.ChatLocation=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$NO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$AO=e.$zO=e.$yO=e.$xO=e.$vO=e.$uO=e.$tO=e.$sO=e.TestRunProfileKind=e.TestResultState=e.$rO=e.$qO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$pO=e.NotebookVariablesRequestKind=e.$oO=e.$nO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$mO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.ColorThemeKind=e.$gO=e.$fO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$eO=e.$dO=e.DebugConsoleMode=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$0N=e.$9N=e.FileChangeType=e.$8N=e.NewSymbolNameTag=e.$7N=e.$6N=e.$5N=e.$4N=e.InlineCompletionTriggerKind=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$QN=e.ConfigurationTarget=e.$PN=e.$ON=e.$NN=e.$MN=e.DocumentPasteTriggerKind=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$FN=e.ViewBadge=e.ProgressLocation=e.$EN=e.$DN=e.TaskScope=e.ShellQuoting=e.$CN=e.$BN=e.$AN=e.TaskPanelKind=e.TaskRevealKind=e.$zN=e.TerminalLocation=e.$yN=e.$xN=e.$wN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$vN=e.$uN=e.$tN=e.$sN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$qN=e.$pN=e.$oN=e.$nN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$mN=e.$lN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.LanguageStatusSeverity=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.CodeActionTriggerKind=e.$_M=e.$$M=e.SymbolTag=e.SymbolKind=e.$0M=e.$9M=e.DocumentHighlightKind=e.$8M=e.$7M=e.$6M=e.$5M=e.DiagnosticSeverity=e.DiagnosticTag=e.$4M=e.$3M=e.FileEditType=e.$2M=e.$1M=e.$ZM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$rN=dt,e.$RN=Q,e.$wO=At;function w(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const De=te.length===1?[]:te[1];return Reflect.construct(B,De,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[De,...Ke]=te;return Reflect.construct(B,Ke,De.constructor)}}})}var P;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var C;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(C||(e.TerminalQuickFixType=C={}));let V=s=class{static from(...F){let te=F;return new s(function(){if(te){for(const De of te)De&&typeof De.dispose=="function"&&De.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$SM=V,e.$SM=V=s=Je([w],V);let W=o=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let De=1;De<F.length;De++){const Ke=F[De];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let De=1;De<F.length;De++){const Ke=F[De];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:te,character:De}=F;return typeof te=="number"&&typeof De=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,T.$7)("line must be non-negative");if(te<0)throw(0,T.$7)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,T.$7)();let De;return typeof F>"u"?De=0:typeof F=="number"?De=F:(De=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),De===0&&te===0?this:new o(this.line+De,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,T.$7)();let De;return typeof F>"u"?De=this.line:typeof F=="number"?De=F:(De=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),De===this.line&&te===this.character?this:new o(De,te)}toJSON(){return{line:this.line,character:this.character}}};e.$TM=W,e.$TM=W=o=Je([w],W);let q=r=class{static isRange(F){return F instanceof r?!0:F?W.isPosition(F.start)&&W.isPosition(F.end):!1}static of(F){if(F instanceof r)return F;if(this.isRange(F))return new r(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,De,Ke){let Ye,ht;if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ke=="number"?(Ye=new W(F,te),ht=new W(De,Ke)):W.isPosition(F)&&W.isPosition(te)&&(Ye=W.of(F),ht=W.of(te)),!Ye||!ht)throw new Error("Invalid arguments");Ye.isBefore(ht)?(this.c=Ye,this.e=ht):(this.c=ht,this.e=Ye)}contains(F){return r.isRange(F)?this.contains(F.start)&&this.contains(F.end):W.isPosition(F)?!(W.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=W.Max(F.start,this.c),De=W.Min(F.end,this.e);if(!te.isAfter(De))return new r(te,De)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=W.Min(F.start,this.c),De=W.Max(F.end,this.end);return new r(te,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,T.$7)();let De;return F?W.isPosition(F)?De=F:(De=F.start||this.start,te=F.end||this.end):De=this.start,De.isEqual(this.c)&&te.isEqual(this.end)?this:new r(De,te)}toJSON(){return[this.start,this.end]}};e.$UM=q,e.$UM=q=r=Je([w],q);let A=n=class extends q{static isSelection(F){return F instanceof n?!0:F?q.isRange(F)&&W.isPosition(F.anchor)&&W.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,De,Ke){let Ye,ht;if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ke=="number"?(Ye=new W(F,te),ht=new W(De,Ke)):W.isPosition(F)&&W.isPosition(te)&&(Ye=W.of(F),ht=W.of(te)),!Ye||!ht)throw new Error("Invalid arguments");super(Ye,ht),this.f=Ye,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$VM=A,e.$VM=A=n=Je([w],A);const U=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,T.$7)("connectionToken")};class K{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,De){if(typeof F!="string"||F.length===0)throw(0,T.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,T.$7)("port");typeof De<"u"&&U(De),this.host=F,this.port=Math.round(te),this.connectionToken=De}}e.$WM=K;class se{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&U(te)}}e.$XM=se;class ce extends Error{static NotAvailable(F,te){return new ce(F,v.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new ce(F,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=v.RemoteAuthorityResolverErrorCode.Unknown,De){super(F),this._message=F,this._code=te,this._detail=De,Object.setPrototypeOf(this,ce.prototype)}}e.$YM=ce;var ve;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ve||(e.EndOfLine=ve={}));var Ie;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ie||(e.EnvironmentVariableMutatorType=Ie={}));let ue=t=class{static isTextEdit(F){return F instanceof t?!0:F?q.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new t(F,te)}static insert(F,te){return t.replace(new q(F,F),te)}static delete(F){return t.replace(F,"")}static setEndOfLine(F){const te=new t(new q(new W(0,0),new W(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!q.isRange(F))throw(0,T.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,T.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,T.$7)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$ZM=ue,e.$ZM=ue=t=Je([w],ue);let be=c=class{static isNotebookCellEdit(F){return F instanceof c?!0:F?xe.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new c(F,te)}static insertCells(F,te){return new c(new xe(F,F),te)}static deleteCells(F){return new c(F,[])}static updateCellMetadata(F,te){const De=new c(new xe(F,F),[]);return De.newCellMetadata=te,De}static updateNotebookMetadata(F){const te=new c(new xe(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$1M=be,e.$1M=be=c=Je([w],be);class ie{static isSnippetTextEdit(F){return F instanceof ie?!0:F?q.isRange(F.range)&&ne.isSnippetString(F.snippet):!1}static replace(F,te){return new ie(F,te)}static insert(F,te){return ie.replace(new q(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$2M=ie;var Ce;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Ce||(e.FileEditType=Ce={}));let Fe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,De,Ke){this.c.push({_type:1,from:F,to:te,options:De,metadata:Ke})}createFile(F,te,De){this.c.push({_type:1,from:void 0,to:F,options:te,metadata:De})}deleteFile(F,te,De){this.c.push({_type:1,from:F,to:void 0,options:te,metadata:De})}e(F,te,De){this.c.push({_type:3,metadata:De,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}f(F,te,De,Ke){const Ye=te.start,ht=te.end;(Ye!==ht||De.length>0)&&this.c.push({_type:5,uri:F,index:Ye,count:ht-Ye,cells:De,metadata:Ke})}g(F,te,De,Ke){this.c.push({_type:3,metadata:Ke,uri:F,edit:{editType:3,index:te,metadata:De}})}replace(F,te,De,Ke){this.c.push({_type:2,uri:F,edit:new ue(te,De),metadata:Ke})}insert(F,te,De,Ke){this.replace(F,new q(te,te),De,Ke)}delete(F,te,De){this.replace(F,te,"",De)}has(F){return this.c.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const De of te){if(!De)continue;let Ke,Ye;Array.isArray(De)?(Ke=De[0],Ye=De[1]):Ke=De,be.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(F,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(F,Ke.newNotebookMetadata,Ye):this.f(F,Ke.range,Ke.newCells,Ye):ie.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:F,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:F,edit:Ke,metadata:Ye})}else{for(let De=0;De<this.c.length;De++){const Ke=this.c[De];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===F.toString()&&(this.c[De]=void 0);break}}(0,I.$Ib)(this.c)}}get(F){const te=[];for(const De of this.c)De._type===2&&De.uri.toString()===F.toString()&&te.push(De.edit);return te}entries(){const F=new O.$Bc;for(const te of this.c)if(te._type===2){let De=F.get(te.uri);De||(De=[te.uri,[]],F.set(te.uri,De)),De[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$3M=Fe,e.$3M=Fe=Je([w],Fe);let ne=h=class{static isSnippetString(F){return F instanceof h?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=h.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const De=new h;De.e=this.e,F(De),this.e=De.e,F=De.value}else F=h.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const De=F.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const De=new h;De.e=this.e,te(De),this.e=De.e,te=De.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$4M=ne,e.$4M=ne=h=Je([w],ne);var j;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(j||(e.DiagnosticTag=j={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let pe=i=class{static isLocation(F){return F instanceof i?!0:F?q.isRange(F.range)&&k.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(q.isRange(te))this.range=q.of(te);else if(W.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$5M=pe,e.$5M=pe=i=Je([w],pe);let Oe=class{static is(F){return F?typeof F.message=="string"&&F.location&&q.isRange(F.location.range)&&k.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$6M=Oe,e.$6M=Oe=Je([w],Oe);let ke=class{constructor(F,te,De=x.Error){if(!q.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=De}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,I.$ub)(F.tags,te.tags)&&(0,I.$ub)(F.relatedInformation,te.relatedInformation,Oe.isEqual)}};e.$7M=ke,e.$7M=ke=Je([w],ke);let $e=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$8M=$e,e.$8M=$e=Je([w],$e);var fe;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(fe||(e.DocumentHighlightKind=fe={}));let J=class{constructor(F,te=fe.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:fe[this.kind]}}};e.$9M=J,e.$9M=J=Je([w],J);let Y=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$0M=Y,e.$0M=Y=Je([w],Y);var he;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var le;(function(B){B[B.Deprecated=1]="Deprecated"})(le||(e.SymbolTag=le={}));let Te=b=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,De,Ke,Ye){this.name=F,this.kind=te,this.containerName=Ye,typeof De=="string"&&(this.containerName=De),Ke instanceof pe?this.location=Ke:De instanceof q&&(this.location=new pe(Ke,De)),b.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$$M=Te,e.$$M=Te=b=Je([w],Te);let de=a=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(a.validate)}constructor(F,te,De,Ke,Ye){this.name=F,this.detail=te,this.kind=De,this.range=Ke,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.$_M=de,e.$_M=de=a=Je([w],de);var Pe;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Pe||(e.CodeActionTriggerKind=Pe={}));let Me=class{constructor(F,te){this.title=F,this.kind=te}};e.$aN=Me,e.$aN=Me=Je([w],Me);let ze=class{static{$=this}static{this.c="."}constructor(F){this.value=F}append(F){return new $(this.value?this.value+$.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+$.c)}};e.$bN=ze,e.$bN=ze=$=Je([w],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let z=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$cN=z,e.$cN=z=Je([w],z);class L{constructor(F,te,De,Ke,Ye,ht){this.kind=F,this.name=te,this.detail=De,this.uri=Ke,this.range=Ye,this.selectionRange=ht}}e.$dN=L;class G{constructor(F,te){this.fromRanges=te,this.from=F}}e.$eN=G;class H{constructor(F,te){this.fromRanges=te,this.to=F}}e.$fN=H;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let re=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$gN=re,e.$gN=re=Je([w],re);let Ne=l=class{#e;static isMarkdownString(F){return F instanceof l?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new R.$Nk(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$hN=Ne,e.$hN=Ne=l=Je([w],Ne);let Be=class{constructor(F,te){this.label=F,this.documentation=te}};e.$iN=Be,e.$iN=Be=Je([w],Be);let Qe=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$jN=Qe,e.$jN=Qe=Je([w],Qe);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$kN=_e,e.$kN=_e=Je([w],_e);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let it=class{constructor(F){this.value=F}};e.$lN=it,e.$lN=it=Je([w],it);let nt=class{constructor(F,te,De){this.position=F,this.label=te,this.kind=De}};e.$mN=nt,e.$mN=nt=Je([w],nt);var at;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var mt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(mt||(e.CompletionItemKind=mt={}));var je;(function(B){B[B.Deprecated=1]="Deprecated"})(je||(e.CompletionItemTag=je={}));let st=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&mt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$nN=st,e.$nN=st=Je([w],st);let X=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$oN=X,e.$oN=X=Je([w],X);let Z=class{constructor(F,te,De){this.insertText=F,this.range=te,this.command=De}};e.$pN=Z,e.$pN=Z=Je([w],Z);let me=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$qN=me,e.$qN=me=Je([w],me);var He;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(He||(e.PartialAcceptTriggerKind=He={}));var ye;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ye||(e.ViewColumn=ye={}));var ot;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function dt(B,F){return`${y.$Lm.toKey(B)}.${F}`}var It;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(It||(e.TextEditorLineNumbersStyle=It={}));var Qt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Qt||(e.TextDocumentSaveReason=Qt={}));var Ut;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ut||(e.TextEditorRevealType=Ut={}));var xt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(xt||(e.TextEditorSelectionChangeKind=xt={}));var _t;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Ct;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Ct||(e.DecorationRangeBehavior=Ct={})),function(B){function F(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=F}(xt||(e.TextEditorSelectionChangeKind=xt={}));var Vt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Vt||(e.SyntaxTokenType=Vt={})),function(B){function F(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=F}(Vt||(e.SyntaxTokenType=Vt={}));let Zt=class{constructor(F,te){if(te&&!k.URI.isUri(te))throw(0,T.$7)("target");if(!q.isRange(F)||F.isEmpty)throw(0,T.$7)("range");this.range=F,this.target=te}};e.$sN=Zt,e.$sN=Zt=Je([w],Zt);let Xe=class{constructor(F,te,De,Ke){this.red=F,this.green=te,this.blue=De,this.alpha=Ke}};e.$tN=Xe,e.$tN=Xe=Je([w],Xe);let si=class{constructor(F,te){if(te&&!(te instanceof Xe))throw(0,T.$7)("color");if(!q.isRange(F)||F.isEmpty)throw(0,T.$7)("range");this.range=F,this.color=te}};e.$uN=si,e.$uN=si=Je([w],si);let Xt=class{constructor(F){if(!F||typeof F!="string")throw(0,T.$7)("label");this.label=F}};e.$vN=Xt,e.$vN=Xt=Je([w],Xt);var lt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(lt||(e.ColorFormat=lt={}));var vt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(vt||(e.SourceControlInputBoxValidationType=vt={}));var ti;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ti||(e.TerminalExitReason=ti={}));var Yt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(Yt||(e.TerminalShellExecutionCommandLineConfidence=Yt={}));class Lt{constructor(F,te,De){if(this.startIndex=F,this.length=te,this.tooltip=De,typeof F!="number"||F<0)throw(0,T.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,T.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,T.$7)("tooltip")}}e.$wN=Lt;class ft{constructor(F){this.uri=F}}e.$xN=ft;class jt{constructor(F){this.terminalCommand=F}}e.$yN=jt;var Bt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Bt||(e.TerminalLocation=Bt={}));class qt{constructor(F){if(this.options=F,typeof F!="object")throw(0,T.$7)("options")}}e.$zN=qt;var Ge;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ge||(e.TaskRevealKind=Ge={}));var ui;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let Ht=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(F){switch(F){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,T.$7)("name");this.c=F}get id(){return this.c}};e.$AN=Ht,e.$AN=Ht=S=Je([w],Ht);function zt(B){let F="";for(let te=0;te<B.length;te++)F+=B[te].replace(/,/g,",,")+",";return F}let gt=class{constructor(F,te,De){if(typeof F!="string")throw(0,T.$7)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=De):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,T.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return zt(F)}};e.$BN=gt,e.$BN=gt=Je([w],gt);let Nt=class{constructor(F,te,De){if(this.f=[],Array.isArray(te)){if(!F)throw(0,T.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,T.$7)("command");this.e=F,this.f=te,this.g=De}else{if(typeof F!="string")throw(0,T.$7)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,T.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,T.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return zt(F)}};e.$CN=Nt,e.$CN=Nt=Je([w],Nt);var Rt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Rt||(e.ShellQuoting=Rt={}));var Ot;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Ot||(e.TaskScope=Ot={}));class ii{constructor(F){this.c=F}computeId(){return"customExecution"+(0,N.$Mg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$DN=ii;let Gt=class{static{d=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,De,Ke,Ye,ht){this.k=!1,this.l=this.definition=F;let $t;typeof te=="string"?(this.o=this.name=te,this.w=this.source=De,this.execution=Ke,$t=Ye,this.k=!0):te===Ot.Global||te===Ot.Workspace?(this.target=te,this.o=this.name=De,this.w=this.source=Ke,this.execution=Ye,$t=ht):(this.target=te,this.o=this.name=De,this.w=this.source=Ke,this.execution=Ye,$t=ht),typeof $t=="string"?(this.r=[$t],this.t=!0):Array.isArray($t)?(this.r=$t,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof gt?this.l={type:d.e,id:this.q.computeId()}:this.q instanceof Nt?this.l={type:d.f,id:this.q.computeId()}:this.q instanceof ii?this.l={type:d.c,id:this.q.computeId()}:this.l={type:d.g,id:(0,N.$Mg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,T.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,T.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(d.g===te||d.e===te||d.f===te||d.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,T.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$EN=Gt,e.$EN=Gt=d=Je([w],Gt);var ni;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var Mt;(function(B){function F(te){const De=te;return(0,g.$8f)(De.value)?De.tooltip&&!(0,g.$4f)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=F})(Mt||(e.ViewBadge=Mt={}));let Tt=D=class{static isTreeItem(F,te){const De=F;if(De.checkboxState!==void 0){const Ke=(0,g.$8f)(De.checkboxState)?De.checkboxState:(0,g.$6f)(De.checkboxState)&&(0,g.$8f)(De.checkboxState.state)?De.checkboxState.state:void 0,Ye=!(0,g.$8f)(De.checkboxState)&&(0,g.$6f)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Dt.Checked&&Ke!==Dt.Unchecked||Ye!==void 0&&!(0,g.$4f)(Ye))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(F instanceof D)return!0;if(De.label!==void 0&&!(0,g.$4f)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,g.$4f)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,g.$4f)(De.iconPath)&&!k.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,g.$4f)(De.iconPath.id))){const Ke=De.iconPath;if(!Ke||!(0,g.$4f)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,g.$4f)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,g.$4f)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!k.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,g.$4f)(De.tooltip)&&!(De.tooltip instanceof Ne)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Pt.None&&De.collapsibleState>Pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,g.$4f)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(F,te=Pt.None){this.collapsibleState=te,k.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$FN=Tt,e.$FN=Tt=D=Je([w],Tt);var Pt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Pt||(e.TreeItemCollapsibleState=Pt={}));var Dt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$GN=pt,e.$GN=pt=Je([w],pt);class St extends pt{}e.$HN=St;class li extends St{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$IN=li;class Et{constructor(F,te,De,Ke){this.name=F,this.uri=te,this._itemId=De,this.c=Ke}data(){return this.c()}}e.$JN=Et;let hi=class{#e=new Map;constructor(F){for(const[te,De]of F??[]){const Ke=this.#e.get(this.#t(te));Ke?Ke.push(De):this.#e.set(this.#t(te),[De])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[De,Ke]of this.#e)for(const Ye of Ke)F.call(te,Ye,De,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const De of te)yield[F,De]}#t(F){return F.toLowerCase()}};e.$KN=hi,e.$KN=hi=Je([w],hi);let Kt=class{constructor(F,te,De){this.insertText=F,this.title=te,this.kind=De}};e.$LN=Kt,e.$LN=Kt=Je([w],Kt);var vi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class ei{static{this.c="."}constructor(F){this.value=F}append(...F){return new ei((this.value?[this.value,...F]:F).join(ei.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+ei.c)}}e.$MN=ei,ei.Empty=new ei("");class wi{constructor(F,te,De){this.title=te,this.insertText=F,this.kind=De}}e.$NN=wi;let yt=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$ON=yt,e.$ON=yt=Je([w],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let $i=class{constructor(F){this.id=F}};e.$PN=$i,e.$PN=$i=Je([w],$i);var we;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(we||(e.ConfigurationTarget=we={}));let Se=class{get base(){return this.c}set base(F){this.c=F,this.e=k.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!k.URI.isUri(F)&&!k.URI.isUri(F.uri)))throw(0,T.$7)("base");if(typeof te!="string")throw(0,T.$7)("pattern");typeof F=="string"?this.baseUri=k.URI.file(F):k.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$QN=Se,e.$QN=Se=Je([w],Se);const ae=new WeakMap;function Q(B,F){ae.set(B,F)}let Ee=class{constructor(F,te,De,Ke,Ye){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof De=="string"&&(this.hitCondition=De),typeof Ke=="string"&&(this.logMessage=Ke),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=ae.get(this)??(0,N.$Mg)()),this.c}};e.$SN=Ee,e.$SN=Ee=Je([w],Ee);let We=class extends Ee{constructor(F,te,De,Ke,Ye,ht){if(super(te,De,Ke,Ye,ht),F===null)throw(0,T.$7)("location");this.location=F}};e.$TN=We,e.$TN=We=Je([w],We);let Ze=class extends Ee{constructor(F,te,De,Ke,Ye,ht){super(te,De,Ke,Ye,ht),this.functionName=F}};e.$UN=Ze,e.$UN=Ze=Je([w],Ze);let qe=class extends Ee{constructor(F,te,De,Ke,Ye,ht,$t,Jt){if(super(Ke,Ye,ht,$t,Jt),!te)throw(0,T.$7)("dataId");this.label=F,this.dataId=te,this.canPersist=De}};e.$VN=qe,e.$VN=qe=Je([w],qe);let ut=class{constructor(F,te,De){this.command=F,this.args=te||[],this.options=De}};e.$WN=ut,e.$WN=ut=Je([w],ut);let kt=class{constructor(F,te){this.port=F,this.host=te}};e.$XN=kt,e.$XN=kt=Je([w],kt);let Ft=class{constructor(F){this.path=F}};e.$YN=Ft,e.$YN=Ft=Je([w],Ft);let Wt=class{constructor(F){this.implementation=F}};e.$ZN=Wt,e.$ZN=Wt=Je([w],Wt);class ct{constructor(F,te,De){this.session=F,this.threadId=te,this.frameId=De}}e.$1N=ct;class ri{constructor(F,te){this.session=F,this.threadId=te}}e.$2N=ri;let di=class{constructor(F,te){this.range=F,this.expression=te}};e.$3N=di,e.$3N=di=Je([w],di);var pi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(pi||(e.InlineCompletionTriggerKind=pi={}));let Si=class{constructor(F,te){this.range=F,this.text=te}};e.$4N=Si,e.$4N=Si=Je([w],Si);let Ai=class{constructor(F,te,De=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=De}};e.$5N=Ai,e.$5N=Ai=Je([w],Ai);let Mi=class{constructor(F,te){this.range=F,this.expression=te}};e.$6N=Mi,e.$6N=Mi=Je([w],Mi);let Ti=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$7N=Ti,e.$7N=Ti=Je([w],Ti);var Ni;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Ni||(e.NewSymbolNameTag=Ni={}));class cn{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$8N=cn;var Oi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Fi=f=class extends Error{static FileExists(F){return new f(F,u.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(F){return new f(F,u.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(F){return new f(F,u.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(F){return new f(F,u.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(F){return new f(F,u.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(F){return new f(F,u.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}constructor(F,te=u.FileSystemProviderErrorCode.Unknown,De){super(k.URI.isUri(F)?F.toString(!0):F),this.code=De?.name??"Unknown",(0,u.$_k)(this,te),Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$9N=Fi,e.$9N=Fi=f=Je([w],Fi);let yi=class{constructor(F,te,De){this.start=F,this.end=te,this.kind=De}};e.$0N=yi,e.$0N=yi=Je([w],yi);var Ii;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Ii||(e.FoldingRangeKind=Ii={}));var Gi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Gi||(e.CommentThreadCollapsibleState=Gi={}));var Ki;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var bi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(bi||(e.CommentState=bi={}));var Ji;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Ji||(e.CommentThreadState=Ji={}));var Qi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$$N=un;function Li(B){return typeof B>"u"||(0,g.$5f)(B)}class zi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,De=F.tokenTypes.length;te<De;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,De=F.tokenModifiers.length;te<De;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,De,Ke,Ye){if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(F,te,De,Ke,Ye);if(q.isRange(F)&&typeof te=="string"&&Li(De))return this.o(F,te,De);throw(0,T.$7)()}o(F,te,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=F.start.line,Ye=F.start.character,ht=F.end.character-F.start.character,$t=this.k.get(te);let Jt=0;if(De)for(const ci of De){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ci);Jt|=1<<fi>>>0}this.q(Ke,Ye,ht,$t,Jt)}q(F,te,De,Ke,Ye){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const Jt=this.g.length/5|0;let ci=0,fi=0;for(let gi=0;gi<Jt;gi++){let mi=this.g[5*gi],qi=this.g[5*gi+1];mi===0?(mi=ci,qi+=fi):mi+=ci,this.g[5*gi]=mi,this.g[5*gi+1]=qi,ci=mi,fi=qi}}let ht=F,$t=te;this.f&&this.j>0&&(ht-=this.c,ht===0&&($t-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=$t,this.g[this.j++]=De,this.g[this.j++]=Ke,this.g[this.j++]=Ye,this.c=F,this.e=te}static r(F){const te=[],De=F.length/5|0;for(let $t=0;$t<De;$t++)te[$t]=$t;te.sort(($t,Jt)=>{const ci=F[5*$t],fi=F[5*Jt];if(ci===fi){const gi=F[5*$t+1],mi=F[5*Jt+1];return gi-mi}return ci-fi});const Ke=new Uint32Array(F.length);let Ye=0,ht=0;for(let $t=0;$t<De;$t++){const Jt=5*te[$t],ci=F[Jt+0],fi=F[Jt+1],gi=F[Jt+2],mi=F[Jt+3],qi=F[Jt+4],Mn=ci-Ye,ur=Mn===0?fi-ht:fi,Hi=5*$t;Ke[Hi+0]=Mn,Ke[Hi+1]=ur,Ke[Hi+2]=gi,Ke[Hi+3]=mi,Ke[Hi+4]=qi,Ye=ci,ht=fi}return Ke}build(F){return this.f?new Ci(new Uint32Array(this.g),F):new Ci(zi.r(this.g),F)}}e.$_N=zi;class Ci{constructor(F,te){this.resultId=te,this.data=F}}e.$aO=Ci;class ln{constructor(F,te,De){this.start=F,this.deleteCount=te,this.data=De}}e.$bO=ln;class Zi{constructor(F,te){this.resultId=te,this.edits=F}}e.$cO=Zi;var Xi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Xi||(e.DebugConsoleMode=Xi={}));class hn{constructor(F){this.name=F}}e.$dO=hn;let Ui=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.$eO=Ui,e.$eO=Ui=Je([w],Ui);var Yi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Pi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Pi||(e.InputBoxValidationSeverity=Pi={}));var ji;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(ji||(e.ExtensionKind=ji={}));class Ue{static validate(F){if(typeof F.badge=="string"){let te=(0,p.$Df)(F.badge,0);if(te<F.badge.length&&(te+=(0,p.$Df)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!yt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,De){this.badge=F,this.tooltip=te,this.color=De}}e.$fO=Ue;let oi=class{constructor(F){this.kind=F}};e.$gO=oi,e.$gO=oi=Je([w],oi);var Bi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Bi||(e.ColorThemeKind=Bi={}));class xe{static isNotebookRange(F){return F instanceof xe?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,T.$7)("start must be positive");if(te<0)throw(0,T.$7)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,De=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(De=F.end),te===this.c&&De===this.e?this:new xe(te,De)}}e.$hO=xe;class bt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>bt.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,De,Ke,Ye,ht,$t){this.kind=F,this.value=te,this.languageId=De,this.mime=Ke,this.outputs=Ye??[],this.metadata=ht,this.executionSummary=$t,bt.validate(this)}}e.$iO=bt;class dn{constructor(F){this.cells=F}}e.$jO=dn;class ai{static isNotebookCellOutputItem(F){return F instanceof ai?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return ai.json(te,"application/vnd.code.notebook.error")}static stdout(F){return ai.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return ai.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new ai(F,te)}static#e=new TextEncoder;static text(F,te=M.$Hs.text){const De=ai.#e.encode(String(F));return new ai(De,te)}static json(F,te="text/x-json"){const De=JSON.stringify(F,void 0,"	");return ai.text(De,te)}constructor(F,te){this.data=F,this.mime=te;const De=(0,M.$Ls)(te,!0);if(!De)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$kO=ai;class ki{static isNotebookCellOutput(F){return F instanceof ki?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const De=new Set,Ke=new Set;for(let Ye=0;Ye<F.length;Ye++){const ht=F[Ye],$t=(0,M.$Ls)(ht.mime);if(!De.has($t)||(0,m.$NK)($t)){De.add($t);continue}Ke.add(Ye),te&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ke.size===0?F:F.filter((Ye,ht)=>!Ke.has(ht))}constructor(F,te,De){this.items=ki.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=De):(this.id=(0,N.$Mg)(),this.metadata=te??De)}}e.$lO=ki;var xi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var Di;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Di||(e.NotebookCellExecutionState=Di={}));var _i;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(_i||(e.NotebookCellStatusBarAlignment=_i={}));var en;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(F,te){this.text=F,this.alignment=te}}e.$mO=fn;var Wi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Wi||(e.NotebookControllerAffinity=Wi={}));var tn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(tn||(e.NotebookControllerAffinity2=tn={}));class gn{constructor(F,te=[]){this.uri=F,this.provides=(0,I.$3b)(te)}}e.$nO=gn;class mn{constructor(F){this.label=F}}e.$oO=mn;var nn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Vi=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$pO=Vi,e.$pO=Vi=Je([w],Vi);var rn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$qO=$n;class pn{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$rO=pn;var an;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var _;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(_||(e.TestRunProfileKind=_={}));let oe=class{constructor(F=void 0,te=void 0,De=void 0,Ke=!1){this.include=F,this.exclude=te,this.profile=De,this.continuous=Ke}};e.$sO=oe,e.$sO=oe=Je([w],oe);let Le=E=class{static diff(F,te,De){const Ke=new E(F);return Ke.expectedOutput=te,Ke.actualOutput=De,Ke}constructor(F){this.message=F}};e.$tO=Le,e.$tO=Le=E=Je([w],Le);let rt=class{constructor(F){this.id=F}};e.$uO=rt,e.$uO=rt=Je([w],rt);class wt{constructor(F,te){this.covered=F,this.total=te,At(this)}}e.$vO=wt;function At(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class Ei{static fromDetails(F,te){const De=new wt(0,0),Ke=new wt(0,0),Ye=new wt(0,0);for(const $t of te)if("branches"in $t){De.total+=1,De.covered+=$t.executed?1:0;for(const Jt of $t.branches)Ke.total+=1,Ke.covered+=Jt.executed?1:0}else Ye.total+=1,Ye.covered+=$t.executed?1:0;const ht=new Ei(F,De,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ht.detailedCoverage=te,ht}constructor(F,te,De,Ke){this.uri=F,this.statementCoverage=te,this.branchCoverage=De,this.declarationCoverage=Ke}}e.$xO=Ei;class Tn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De=[]){this.executed=F,this.location=te,this.branches=De}}e.$yO=Tn;class Nn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De){this.executed=F,this.location=te,this.label=De}}e.$zO=Nn;class On{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De){this.name=F,this.executed=te,this.location=De}}e.$AO=On;var bn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(bn||(e.ExternalUriOpenerPriority=bn={}));var vn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(vn||(e.WorkspaceTrustState=vn={}));var wn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn||(e.PortAutoForwardAction=wn={}));class Fn{constructor(F,te,De,Ke,Ye,ht){this.kind=F,this.name=te,this.detail=De,this.uri=Ke,this.range=Ye,this.selectionRange=ht}}e.$BO=Fn;class Ln{constructor(F){this.uri=F}}e.$CO=Ln;class zn{constructor(F,te){this.original=F,this.modified=te}}e.$DO=zn;class Un{constructor(F,te,De,Ke){this.base=F,this.input1=te,this.input2=De,this.result=Ke}}e.$EO=Un;class jn{constructor(F,te){this.uri=F,this.viewType=te}}e.$FO=jn;class Bn{constructor(F){this.viewType=F}}e.$GO=Bn;class Wn{constructor(F,te){this.uri=F,this.notebookType=te}}e.$HO=Wn;class Vn{constructor(F,te,De){this.original=F,this.modified=te,this.notebookType=De}}e.$IO=Vn;class qn{constructor(){}}e.$JO=qn;class Hn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$KO=Hn;class Gn{constructor(){}}e.$LO=Gn;class Kn{constructor(F){this.textDiffs=F}}e.$MO=Kn;var yn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var kn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var Dn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Jn{constructor(F,te){this.label=F,this.values=te}}e.$NO=Jn;var En;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(En||(e.InteractiveEditorResponseFeedbackKind=En={}));var Sn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Sn||(e.ChatResultFeedbackKind=Sn={}));class Qn{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new Ne(F):F}}e.$OO=Qn;class Zn{constructor(F,te){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new Ne(F):F,this.vulnerabilities=te}}e.$PO=Zn;class Xn{constructor(F,te){this.participant=F,this.command=te}}e.$QO=Xn;class Yn{constructor(F,te){this.value=F,this.baseUri=te}}e.$RO=Yn;class xn{constructor(F,te){this.value=F,this.title=te}}e.$SO=xn;class _n{constructor(F){this.value=F}}e.$TO=_n;class er{constructor(F){this.value=F}}e.$UO=er;class tr{constructor(F){this.value=F}}e.$VO=tr;class ir{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.$WO=ir;class nr{constructor(F,te,De,Ke){this.prompt=F,this.command=te,this.variables=De,this.participant=Ke}}e.$XO=nr;class rr{constructor(F,te,De,Ke){this.response=F,this.result=te,this.participant=De,this.command=Ke}}e.$YO=rr;var In;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(In||(e.ChatLocation=In={}));class sr{constructor(F){this.content=F}}e.$ZO=sr;class or{constructor(F,te){this.content=F,this.name=te}}e.$1O=or;class ar{constructor(F,te){this.content=F,this.name=te}}e.$2O=ar;class Ri extends Error{static NotFound(F){return new Ri(F,Ri.NotFound.name)}static NoPermissions(F){return new Ri(F,Ri.NoPermissions.name)}constructor(F,te,De){super(F,{cause:De}),this.name="LanguageModelError",this.code=te??""}}e.$3O=Ri;var Cn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Cn||(e.RelatedInformationType=Cn={}));var Pn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Pn||(e.SpeechToTextStatus=Pn={}));var Rn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Rn||(e.KeywordRecognitionStatus=Rn={}));class cr{constructor(F,te){this.text=F,this.range=te}}e.$4O=cr;var An;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(An||(e.InlineEditTriggerKind=An={}))}),define(Re[246],Ae([1,0,4,7]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$QM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,p,g){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(M);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(p,g)??[]}getRelatedInformation(M,p,g){return this.c.$getAiRelatedInformation(p,g)}registerRelatedInformationProvider(M,p,g){const k=this.b;return this.b++,this.a.set(k,g),this.c.$registerAiRelatedInformationProvider(k,p),new T.$SM(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$gkc=R}),define(Re[84],Ae([1,0,5,4,7,20,106,3,16]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=e.$rkc=void 0,e.$rkc=(0,p.$qi)("IExtHostAuthentication");let k=class{constructor(u){this.b=new Map,this.c=new I.$be,this.onDidChangeSessions=this.c.event,this.d=new N,this.f=new N,this.a=u.getProxy(T.$QM.MainThreadAuthentication)}async getSession(u,v,m,s={}){const o=O.$Lm.toKey(u.identifier),r=[...m].sort().join(" ");return await this.d.getOrCreate(`${o} ${v} ${r}`,async()=>{await this.a.$ensureProvider(v);const n=u.displayName||u.name;return this.a.$getSession(v,m,o,n,s)})}async getSessions(u,v,m){const s=O.$Lm.toKey(u.identifier),o=[...m].sort().join(" ");return await this.f.getOrCreate(`${s} ${o}`,async()=>{await this.a.$ensureProvider(v);const r=u.displayName||u.name;return this.a.$getSessions(v,m,s,r)})}async removeSession(u,v){const m=this.b.get(u);return m?m.provider.removeSession(v):this.a.$removeSession(u,v)}registerAuthenticationProvider(u,v,m,s){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:v,provider:m,options:s??{supportsMultipleAccounts:!1}});const o=m.onDidChangeSessions(r=>this.a.$sendDidChangeSessions(u,r));return this.a.$registerAuthenticationProvider(u,v,s?.supportsMultipleAccounts??!1),new R.$SM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}$createSession(u,v,m){const s=this.b.get(u);if(s)return Promise.resolve(s.provider.createSession(v,m));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$removeSession(u,v){const m=this.b.get(u);if(m)return Promise.resolve(m.provider.removeSession(v));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$getSessions(u,v){const m=this.b.get(u);if(m)return Promise.resolve(m.provider.getSessions(v));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,v){return u.startsWith(M.$SL)||this.c.fire({provider:{id:u,label:v}}),Promise.resolve()}};e.$skc=k,e.$skc=k=Je([Ve(0,g.$dP)],k);class N{constructor(){this.a=new Map}getOrCreate(u,v){const m=this.a.get(u);if(m)return m;const s=v().finally(()=>this.a.delete(u));return this.a.set(u,s),s}}}),define(Re[110],Ae([1,0,2,4,7,3,16,13,18,15,19,25]),function(ge,e,I,T,R,O,M,p,g,k,N,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=e.$rlc=void 0;let v=class{static{u=this}static{this.c=0}static{this.d=250}constructor(s,o){this.h=o,this.f=new Map,this.g=s.getProxy(T.$QM.MainThreadDecorations)}registerFileDecorationProvider(s,o){const r=u.c++;this.f.set(r,{provider:s,extensionDescription:o}),this.g.$registerDecorationProvider(r,o.identifier.value);const n=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(t=>{if(!t){this.g.$onDidChange(r,null);return}const c=(0,g.$3b)(t);if(c.length<=u.d){this.g.$onDidChange(r,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(a=>({uri:a,rank:(0,k.$9e)(a.path,"/")})),i=(0,g.$zb)(h,(a,$)=>a.rank-$.rank||(0,k.$mf)(a.uri.path,$.uri.path)),b=[];e:for(const a of i){let $;for(const l of a){const S=(0,N.$nc)(l.uri.path);if($!==S&&($=S,b.push(l.uri)>=u.d))break e}}this.g.$onDidChange(r,b)});return new R.$SM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(s,o,r){if(!this.f.has(s))return Object.create(null);const n=Object.create(null),{provider:t,extensionDescription:c}=this.f.get(s);return await Promise.all(o.map(async h=>{try{const{uri:i,id:b}=h,a=await Promise.resolve(t.provideFileDecoration(I.URI.revive(i),r));if(!a)return;try{R.$fO.validate(a),a.badge&&typeof a.badge!="string"&&(0,y.$yG)(c,"codiconDecoration"),n[b]=[a.propagate,a.tooltip,a.badge,a.color]}catch($){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${$}`)}}catch(i){this.h.error(i)}})),n}};e.$rlc=v,e.$rlc=v=u=Je([Ve(0,M.$dP),Ve(1,p.$Wj)],v),e.$slc=(0,O.$qi)("IExtHostDecorations")}),define(Re[247],Ae([1,0,14,2,7,4,12,22,15]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class k{static{this.a=0}constructor(y,u,v){this.d=u,this.e=v,this.b=new Map,this.c=y.getProxy(O.$QM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(M.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const v=k.a++;this.b.set(v,u),this.c.$registerTextContentProvider(v,y);let m;if(typeof u.onDidChange=="function"){let s;m=u.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;s&&await s;const r=this.$provideTextDocumentContent(v,o).then(async n=>{if(!n&&typeof n!="string")return;const t=this.d.getDocument(o);if(!t)return;const c=(0,g.$gf)(n);if(!t.equalLines(c))return this.c.$onVirtualDocumentChange(o,n)}).catch(I.$1).finally(()=>{s===r&&(s=void 0)});s=r})}return new R.$SM(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(y,u){const v=this.b.get(y);return v?Promise.resolve(v.provideTextDocumentContent(T.URI.revive(u),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$ulc=k}),define(Re[111],Ae([1,0,56,12,15,302,152,7,18]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hP=e.$gP=void 0,e.$fP=N;const k=new Map;function N(m,s){s?k.set(m,s):k.delete(m)}function y(m){return k.get(m)}class u extends O.$Pv{constructor(s,o,r,n,t,c,h){super(o,r,n,t),this.c=s,this.m=c,this.q=h,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,g.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===T.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(o){return o?s.s(o):s.getText()},get eol(){return s.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(o){return s.t(o)},offsetAt(o){return s.u(o)},positionAt(o){return s.v(o)},validateRange(o){return s.w(o)},validatePosition(o){return s.x(o)},getWordRangeAtPosition(o,r){return s.y(o,r)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,I.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,I.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const o=this.w(s);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const r=this.g,n=o.start.line,t=o.end.line,c=[];c.push(this.f[n].substring(o.start.character));for(let h=n+1;h<t;h++)c.push(this.f[h]);return c.push(this.f[t].substring(0,o.end.character)),c.join(r)}t(s){let o;if(s instanceof p.$TM?o=s.line:typeof s=="number"&&(o=s),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new v(o,this.f[o],o===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const o=this.j.getIndexOf(s),r=this.f[o.index].length;return new p.$TM(o.index,Math.min(o.remainder,r))}w(s){if(!(s instanceof p.$UM))throw new Error("Invalid argument");const o=this.x(s.start),r=this.x(s.end);return o===s.start&&r===s.end?s:new p.$UM(o.line,o.character,r.line,r.character)}x(s){if(!(s instanceof p.$TM))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:o,character:r}=s,n=!1;if(o<0)o=0,r=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,r=this.f[o].length,n=!0;else{const t=this.f[o].length;r<0?(r=0,n=!0):r>t&&(r=t,n=!0)}return n?new p.$TM(o,r):s}y(s,o){const r=this.x(s);if(!o)o=y(this.m);else if((0,R.$ff)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,M.$Zs)(r.character+1,(0,M.$Xs)(o),this.f[r.line],0);if(n)return new p.$UM(r.line,n.startColumn-1,r.line,n.endColumn-1)}}e.$gP=u;class v{constructor(s,o,r){this.a=s,this.b=o,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$UM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$UM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$hP=v}),define(Re[248],Ae([1,0,4,7]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$QM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,p,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(M);if(!k)throw new Error("Embedding vector provider not found");const N=await k.provideEmbeddingVector(p,g);if(!N)throw new Error("Embedding vector provider returned undefined");return N}registerEmbeddingVectorProvider(M,p,g){const k=this.b;return this.b++,this.a.set(k,g),this.c.$registerAiEmbeddingVectorProvider(p,k),new T.$SM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$wlc=R}),define(Re[64],Ae([1,0,4,44,7,23,3,16,45,6,11,24,12]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=void 0;let m=v=class{constructor(o,r){this.b=new Map,this.c=new N.$zh,this.a=o.getProxy(I.$QM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(t){try{let c;const h=n.b.get(t.scheme);return h?(await n.a.$ensureActivation(t.scheme),c=await h.impl.stat(t)):c=await n.a.$stat(t),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){v.e(c)}},async readDirectory(t){try{const c=n.b.get(t.scheme);return c?(await n.a.$ensureActivation(t.scheme),(await c.impl.readDirectory(t)).slice()):await n.a.$readdir(t)}catch(c){return v.e(c)}},async createDirectory(t){try{const c=n.b.get(t.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(t.scheme),await n.d(c.impl,c.extUri,t)):await n.a.$mkdir(t)}catch(c){return v.e(c)}},async readFile(t){try{const c=n.b.get(t.scheme);return c?(await n.a.$ensureActivation(t.scheme),(await c.impl.readFile(t)).slice()):(await n.a.$readFile(t)).buffer}catch(c){return v.e(c)}},async writeFile(t,c){try{const h=n.b.get(t.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(t.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(t)),await n.c.queueFor(t,()=>Promise.resolve(h.impl.writeFile(t,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(t,O.$Ce.wrap(c))}catch(h){return v.e(h)}},async delete(t,c){try{const h=n.b.get(t.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(t.scheme),await h.impl.delete(t,{recursive:!1,...c})):await n.a.$delete(t,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return v.e(h)}},async rename(t,c,h){try{return await n.a.$rename(t,c,{overwrite:!1,...h})}catch(i){return v.e(i)}},async copy(t,c,h){try{return await n.a.$copy(t,c,{overwrite:!1,...h})}catch(i){return v.e(i)}},isWritableFileSystem(t){const c=r.getCapabilities(t);if(typeof c=="number")return!(c&2048)}})}async d(o,r,n){const t=[];for(;!r.isEqual(n,r.dirname(n));)try{if(!((await o.stat(n)).type&T.FileType.Directory))throw R.$9N.FileExists(`Unable to create folder '${n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$al(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;t.push(r.basename(n)),n=r.dirname(n)}for(let c=t.length-1;c>=0;c--){n=r.joinPath(n,t[c]);try{await o.createDirectory(n)}catch(h){if(T.$al(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof R.$9N)throw o;if(o instanceof T.$9k)switch(o.code){case T.FileSystemProviderErrorCode.FileExists:throw R.$9N.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw R.$9N.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw R.$9N.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw R.$9N.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw R.$9N.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw R.$9N.Unavailable(o.message);default:throw new R.$9N(o.message,o.name)}if(!(o instanceof Error))throw new R.$9N(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw R.$9N.Unavailable(o.message);switch(o.name){case T.FileSystemProviderErrorCode.FileExists:throw R.$9N.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw R.$9N.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw R.$9N.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw R.$9N.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw R.$9N.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw R.$9N.Unavailable(o.message);default:throw new R.$9N(o.message,o.name)}}addFileSystemProvider(o,r,n){return this.b.set(o,{impl:r,extUri:n?.isCaseSensitive?y.$Tg:y.$Vg,isReadonly:!!n?.isReadonly}),(0,k.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$Tg}};e.$Hkc=m,e.$Hkc=m=v=Je([Ve(0,p.$dP),Ve(1,g.$lkc)],m),e.$Ikc=(0,M.$qi)("IExtHostConsumerFileSystem")}),define(Re[85],Ae([1,0,3,27,13,64,2]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=e.$Jkc=void 0,e.$Jkc=(0,I.$qi)("IExtensionStoragePaths");let p=class{constructor(k,N,y){this.d=N,this.f=y,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(k){return M.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,N=await this.g(k);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(M.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(k){if(this.c)return M.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return M.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Kkc=p,e.$Kkc=p=Je([Ve(0,T.$tP),Ve(1,R.$Wj),Ve(2,O.$Ikc)],p)}),define(Re[249],Ae([1,0,7,16,5]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=void 0;let O=class{constructor(p){this.a=new I.$gO(I.ColorThemeKind.Dark),this.b=new R.$be}get activeColorTheme(){return this.a}$onColorThemeChange(p){let g;switch(p){case"light":g=I.ColorThemeKind.Light;break;case"hcDark":g=I.ColorThemeKind.HighContrast;break;case"hcLight":g=I.ColorThemeKind.HighContrastLight;break;default:g=I.ColorThemeKind.Dark}this.a=new I.$gO(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$fmc=O,e.$fmc=O=Je([Ve(0,T.$dP)],O)}),define(Re[86],Ae([1,0,22,5,6,173,3,13,203,4,27,16,7]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ECb=e.$DCb=e.TunnelDtoConverter=void 0;class v extends g.$cw{}var m;(function(o){function r(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,privacy:t.privacy??(t.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:t.protocol}}o.fromApiTunnel=r;function n(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.privacy!==g.TunnelPrivacyId.ConstantPrivate&&t.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:t.privacy,protocol:t.protocol}}o.fromServiceTunnel=n})(m||(e.TunnelDtoConverter=m={})),e.$DCb=(0,M.$qi)("IExtHostTunnelService");let s=class extends R.$Uc{constructor(r,n,t){super(),this.s=t,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$be,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(k.$QM.MainThreadTunnelService)}async openTunnel(r,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const t=await this.a.$openTunnel(n,r.displayName);if(t){const c=new v(t.remoteAddress,t.localAddress,()=>this.a.$closeTunnel(t.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,n){r.portRange===void 0&&r.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const t=this.u();return this.r.set(t,{selector:r,provider:n}),this.a.$registerPortsAttributesProvider(r,t),new u.$SM(()=>{this.r.delete(t),this.a.$unregisterPortsAttributesProvider(t)})}async $providePortAttributes(r,n,t,c,h){const i=[];for(const a of r){const $=this.r.get(a);if(!$)return[];i.push(...await Promise.all(n.map(async l=>{let S;try{S=await $.provider.providePortAttributes({port:l,pid:t,commandLine:c},h)}catch{S=await $.provider.providePortAttributes(l,t,c,h)}return{providedAttributes:S,port:l}})))}const b=i.filter(a=>!!a.providedAttributes);return b.length>0?b.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await r.provideTunnel(c,h,I.CancellationToken.None)??void 0;const t=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(t),Promise.resolve((0,R.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,n){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const t=r.tunnelFactory??(n?this.w(n):void 0);if(t){this.b=t;let c=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const h=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,R.$Sc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,n){if(this.g.has(r.host)){const t=this.g.get(r.host);t.has(r.port)&&(n&&t.get(r.port).disposeListener.dispose(),await t.get(r.port).tunnel.dispose(),t.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const t=this.b(r,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),t!==void 0){const c=await t;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:c,disposeListener:h}),m.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(t){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),t instanceof Error)return t.message}}async $applyCandidateFilter(r){const n=await Promise.all(r.map(c=>this.f(c.host,c.port,c.detail??""))),t=r.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(c=>c.port).join(", ")} to ${t.map(c=>c.port).join(", ")}`),t}};e.$ECb=s,e.$ECb=s=Je([Ve(0,y.$dP),Ve(1,N.$tP),Ve(2,p.$Wj)],s)}),define(Re[8],Ae([1,0,18,23,132,250,54,28,124,53,69,26,127,24,17,2,29,87,100,105,104,213,83,50,61,224,7]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b,a,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$aP=U,e.$bP=se,e.$cP=ce;var S;(function(we){function Se(Q){const{selectionStartLineNumber:Ee,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:qe}=Q,ut=new l.$TM(Ee-1,We-1),kt=new l.$TM(Ze-1,qe-1);return new l.$VM(ut,kt)}we.to=Se;function ae(Q){const{anchor:Ee,active:We}=Q;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}we.from=ae})(S||(e.Selection=S={}));var d;(function(we){function Se(Q){if(!Q)return;const{start:Ee,end:We}=Q;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}we.from=Se;function ae(Q){if(!Q)return;const{startLineNumber:Ee,startColumn:We,endLineNumber:Ze,endColumn:qe}=Q;return new l.$UM(Ee-1,We-1,Ze-1,qe-1)}we.to=ae})(d||(e.Range=d={}));var D;(function(we){function Se(Q){return{uri:Q.uri,range:d.from(Q.range)}}we.from=Se;function ae(Q){return new l.$5M(s.URI.revive(Q.uri),d.to(Q.range))}we.to=ae})(D||(e.Location=D={}));var f;(function(we){function Se(ae){switch(ae){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}we.to=Se})(f||(e.TokenType=f={}));var E;(function(we){function Se(Q){return new l.$TM(Q.lineNumber-1,Q.column-1)}we.to=Se;function ae(Q){return{lineNumber:Q.line+1,column:Q.character+1}}we.from=ae})(E||(e.Position=E={}));var w;(function(we){function Se(Ee,We,Ze){return(0,I.$Hb)((0,I.$3b)(Ee).map(qe=>ae(qe,We,Ze)))}we.from=Se;function ae(Ee,We,Ze){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Ze?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:Q(Ee.scheme,We),pattern:Z.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Ze?.isBuiltin}}function Q(Ee,We){return We&&typeof Ee=="string"?We.transformOutgoingScheme(Ee):Ee}})(w||(e.DocumentSelector=w={}));var P;(function(we){function Se(Q){switch(Q){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}we.from=Se;function ae(Q){switch(Q){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}we.to=ae})(P||(e.DiagnosticTag=P={}));var C;(function(we){function Se(Q){let Ee;return Q.code&&((0,m.$4f)(Q.code)||(0,m.$8f)(Q.code)?Ee=String(Q.code):Ee={value:String(Q.code.value),target:Q.code.target}),{...d.from(Q.range),message:Q.message,source:Q.source,code:Ee,severity:W.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(V.from),tags:Array.isArray(Q.tags)?(0,I.$Hb)(Q.tags.map(P.from)):void 0}}we.from=Se;function ae(Q){const Ee=new l.$7M(d.to(Q),Q.message,W.to(Q.severity));return Ee.source=Q.source,Ee.code=(0,m.$4f)(Q.code)?Q.code:Q.code?.value,Ee.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(V.to),Ee.tags=Q.tags&&(0,I.$Hb)(Q.tags.map(P.to)),Ee}we.to=ae})(C||(e.Diagnostic=C={}));var V;(function(we){function Se(Q){return{...d.from(Q.location.range),message:Q.message,resource:Q.location.uri}}we.from=Se;function ae(Q){return new l.$6M(new l.$5M(Q.resource,d.to(Q)),Q.message)}we.to=ae})(V||(e.DiagnosticRelatedInformation=V={}));var W;(function(we){function Se(Q){switch(Q){case l.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}we.from=Se;function ae(Q){switch(Q){case n.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}we.to=ae})(W||(e.DiagnosticSeverity=W={}));var q;(function(we){function Se(Q){return typeof Q=="number"&&Q>=l.ViewColumn.One?Q-1:Q===l.ViewColumn.Beside?$.$OD:$.$ND}we.from=Se;function ae(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=ae})(q||(e.ViewColumn=q={}));function A(we){return typeof we.range<"u"}function U(we){return we.length===0?!0:!!A(we[0])}var K;(function(we){function Se(qe){return qe.map(we.from)}we.fromMany=Se;function ae(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function Q(qe){let ut;if(ae(qe)){const{language:ct,value:ri}=qe;ut={value:"```"+ct+`
`+ri+"\n```\n"}}else l.$hN.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const kt=Object.create(null);ut.uris=kt;const Ft=ct=>{try{let ri=s.URI.parse(ct,!0);ri=ri.with({query:Ee(ri.query,kt)}),kt[ct]=ri}catch{}return""},Wt=new g.marked.Renderer;return Wt.link=Ft,Wt.image=ct=>typeof ct=="string"?Ft(M.$Vk(ct).href):"",(0,g.marked)(ut.value,{renderer:Wt}),ut}we.from=Q;function Ee(qe,ut){if(!qe)return qe;let kt;try{kt=(0,k.$Yh)(qe)}catch{}if(!kt)return qe;let Ft=!1;return kt=(0,y.$Yn)(kt,Wt=>{if(s.URI.isUri(Wt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ct]=Wt,Ft=!0,ct}else return}),Ft?JSON.stringify(kt):qe}function We(qe){const ut=new l.$hN(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?s.URI.from(qe.baseUri):void 0,ut}we.to=We;function Ze(qe){if(qe)return typeof qe=="string"?qe:we.from(qe)}we.fromStrict=Ze})(K||(e.MarkdownString=K={}));function se(we){return U(we)?we.map(Se=>({range:d.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?K.fromMany(Se.hoverMessage):Se.hoverMessage?K.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):we.map(Se=>({range:d.from(Se)}))}function ce(we){return typeof we>"u"?we:typeof we=="string"?s.URI.file(we):we}var ve;(function(we){function Se(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?ce(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}we.from=Se})(ve||(e.ThemableDecorationAttachmentRenderOptions=ve={}));var Ie;(function(we){function Se(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ce(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?ve.from(ae.before):void 0,after:ae.after?ve.from(ae.after):void 0}}we.from=Se})(Ie||(e.ThemableDecorationRenderOptions=Ie={}));var ue;(function(we){function Se(ae){if(typeof ae>"u")return ae;switch(ae){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Se})(ue||(e.DecorationRangeBehavior=ue={}));var be;(function(we){function Se(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?ue.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?Ie.from(ae.light):void 0,dark:ae.dark?Ie.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ce(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?ve.from(ae.before):void 0,after:ae.after?ve.from(ae.after):void 0}}we.from=Se})(be||(e.DecorationRenderOptions=be={}));var ie;(function(we){function Se(Q){return{text:Q.newText,eol:Q.newEol&&at.from(Q.newEol),range:d.from(Q.range)}}we.from=Se;function ae(Q){const Ee=new l.$ZM(d.to(Q.range),Q.text);return Ee.newEol=typeof Q.eol>"u"?void 0:at.to(Q.eol),Ee}we.to=ae})(ie||(e.TextEdit=ie={}));var Ce;(function(we){function Se(Q,Ee){const We={edits:[]};if(Q instanceof l.$3M){const Ze=new p.$Cc;for(const qe of Q._allEntries())qe._type===1&&s.URI.isUri(qe.to)&&qe.from===void 0&&Ze.add(qe.to);for(const qe of Q._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,T.$We)(T.$Ce.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),We.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?We.edits.push({resource:qe.uri,textEdit:ie.from(qe.edit),versionId:Ze.has(qe.uri)?void 0:Ee?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?We.edits.push({resource:qe.uri,textEdit:{range:d.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ze.has(qe.uri)?void 0:Ee?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?We.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&We.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Ut.from)}})}return We}we.from=Se;function ae(Q){const Ee=new l.$3M,We=new p.$Bc;for(const Ze of Q.edits)if(Ze.textEdit){const qe=Ze,ut=s.URI.revive(qe.resource),kt=d.to(qe.textEdit.range),Ft=qe.textEdit.text,Wt=qe.textEdit.insertAsSnippet;let ct;Wt?ct=l.$2M.replace(kt,new l.$4M(Ft)):ct=l.$ZM.replace(kt,Ft);const ri=We.get(ut);ri?ri.push(ct):We.set(ut,[ct])}else Ee.renameFile(s.URI.revive(Ze.oldResource),s.URI.revive(Ze.newResource),Ze.options);for(const[Ze,qe]of We)Ee.set(Ze,qe);return Ee}we.to=ae})(Ce||(e.WorkspaceEdit=Ce={}));var Fe;(function(we){const Se=Object.create(null);Se[l.SymbolKind.File]=0,Se[l.SymbolKind.Module]=1,Se[l.SymbolKind.Namespace]=2,Se[l.SymbolKind.Package]=3,Se[l.SymbolKind.Class]=4,Se[l.SymbolKind.Method]=5,Se[l.SymbolKind.Property]=6,Se[l.SymbolKind.Field]=7,Se[l.SymbolKind.Constructor]=8,Se[l.SymbolKind.Enum]=9,Se[l.SymbolKind.Interface]=10,Se[l.SymbolKind.Function]=11,Se[l.SymbolKind.Variable]=12,Se[l.SymbolKind.Constant]=13,Se[l.SymbolKind.String]=14,Se[l.SymbolKind.Number]=15,Se[l.SymbolKind.Boolean]=16,Se[l.SymbolKind.Array]=17,Se[l.SymbolKind.Object]=18,Se[l.SymbolKind.Key]=19,Se[l.SymbolKind.Null]=20,Se[l.SymbolKind.EnumMember]=21,Se[l.SymbolKind.Struct]=22,Se[l.SymbolKind.Event]=23,Se[l.SymbolKind.Operator]=24,Se[l.SymbolKind.TypeParameter]=25;function ae(Ee){return typeof Se[Ee]=="number"?Se[Ee]:6}we.from=ae;function Q(Ee){for(const We in Se)if(Se[We]===Ee)return Number(We);return l.SymbolKind.Property}we.to=Q})(Fe||(e.SymbolKind=Fe={}));var ne;(function(we){function Se(Q){switch(Q){case l.SymbolTag.Deprecated:return 1}}we.from=Se;function ae(Q){switch(Q){case 1:return l.SymbolTag.Deprecated}}we.to=ae})(ne||(e.SymbolTag=ne={}));var j;(function(we){function Se(Q){return{name:Q.name,kind:Fe.from(Q.kind),tags:Q.tags&&Q.tags.map(ne.from),containerName:Q.containerName,location:$e.from(Q.location)}}we.from=Se;function ae(Q){const Ee=new l.$$M(Q.name,Fe.to(Q.kind),Q.containerName,$e.to(Q.location));return Ee.tags=Q.tags&&Q.tags.map(ne.to),Ee}we.to=ae})(j||(e.WorkspaceSymbol=j={}));var x;(function(we){function Se(Q){const Ee={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:d.from(Q.range),selectionRange:d.from(Q.selectionRange),kind:Fe.from(Q.kind),tags:Q.tags?.map(ne.from)??[]};return Q.children&&(Ee.children=Q.children.map(Se)),Ee}we.from=Se;function ae(Q){const Ee=new l.$_M(Q.name,Q.detail,Fe.to(Q.kind),d.to(Q.range),d.to(Q.selectionRange));return(0,I.$Lb)(Q.tags)&&(Ee.tags=Q.tags.map(ne.to)),Q.children&&(Ee.children=Q.children.map(ae)),Ee}we.to=ae})(x||(e.DocumentSymbol=x={}));var pe;(function(we){function Se(Q){const Ee=new l.$dN(Fe.to(Q.kind),Q.name,Q.detail||"",s.URI.revive(Q.uri),d.to(Q.range),d.to(Q.selectionRange));return Ee._sessionId=Q._sessionId,Ee._itemId=Q._itemId,Ee}we.to=Se;function ae(Q,Ee,We){if(Ee=Ee??Q._sessionId,We=We??Q._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,name:Q.name,detail:Q.detail,kind:Fe.from(Q.kind),uri:Q.uri,range:d.from(Q.range),selectionRange:d.from(Q.selectionRange),tags:Q.tags?.map(ne.from)}}we.from=ae})(pe||(e.CallHierarchyItem=pe={}));var Oe;(function(we){function Se(ae){return new l.$eN(pe.to(ae.from),ae.fromRanges.map(Q=>d.to(Q)))}we.to=Se})(Oe||(e.CallHierarchyIncomingCall=Oe={}));var ke;(function(we){function Se(ae){return new l.$fN(pe.to(ae.to),ae.fromRanges.map(Q=>d.to(Q)))}we.to=Se})(ke||(e.CallHierarchyOutgoingCall=ke={}));var $e;(function(we){function Se(Q){return{range:Q.range&&d.from(Q.range),uri:Q.uri}}we.from=Se;function ae(Q){return new l.$5M(s.URI.revive(Q.uri),d.to(Q.range))}we.to=ae})($e||(e.location=$e={}));var fe;(function(we){function Se(Q){const Ee=Q,We=Q;return{originSelectionRange:Ee.originSelectionRange?d.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:We.uri,range:d.from(Ee.targetRange?Ee.targetRange:We.range),targetSelectionRange:Ee.targetSelectionRange?d.from(Ee.targetSelectionRange):void 0}}we.from=Se;function ae(Q){return{targetUri:s.URI.revive(Q.uri),targetRange:d.to(Q.range),targetSelectionRange:Q.targetSelectionRange?d.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?d.to(Q.originSelectionRange):void 0}}we.to=ae})(fe||(e.DefinitionLink=fe={}));var J;(function(we){function Se(Q){return{range:d.from(Q.range),contents:K.fromMany(Q.contents)}}we.from=Se;function ae(Q){return new l.$8M(Q.contents.map(K.to),d.to(Q.range))}we.to=ae})(J||(e.Hover=J={}));var Y;(function(we){function Se(Q){return{range:d.from(Q.range),expression:Q.expression}}we.from=Se;function ae(Q){return new l.$3N(d.to(Q.range),Q.expression)}we.to=ae})(Y||(e.EvaluatableExpression=Y={}));var he;(function(we){function Se(Q){if(Q instanceof l.$4N)return{type:"text",range:d.from(Q.range),text:Q.text};if(Q instanceof l.$5N)return{type:"variable",range:d.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof l.$6N)return{type:"expression",range:d.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Se;function ae(Q){switch(Q.type){case"text":return{range:d.to(Q.range),text:Q.text};case"variable":return{range:d.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:d.to(Q.range),expression:Q.expression}}}we.to=ae})(he||(e.InlineValue=he={}));var le;(function(we){function Se(Q){return{frameId:Q.frameId,stoppedLocation:d.from(Q.stoppedLocation)}}we.from=Se;function ae(Q){return new l.$7N(Q.frameId,d.to(Q.stoppedLocation))}we.to=ae})(le||(e.InlineValueContext=le={}));var Te;(function(we){function Se(Q){return{range:d.from(Q.range),kind:Q.kind}}we.from=Se;function ae(Q){return new l.$9M(d.to(Q.range),Q.kind)}we.to=ae})(Te||(e.DocumentHighlight=Te={}));var de;(function(we){function Se(Q){return{uri:Q.uri,highlights:Q.highlights.map(Te.from)}}we.from=Se;function ae(Q){return new l.$0M(s.URI.revive(Q.uri),Q.highlights.map(Te.to))}we.to=ae})(de||(e.MultiDocumentHighlight=de={}));var Pe;(function(we){function Se(ae){switch(ae){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}we.to=Se})(Pe||(e.CompletionTriggerKind=Pe={}));var Me;(function(we){function Se(ae){return{triggerKind:Pe.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}we.to=Se})(Me||(e.CompletionContext=Me={}));var ze;(function(we){function Se(Q){switch(Q){case l.CompletionItemTag.Deprecated:return 1}}we.from=Se;function ae(Q){switch(Q){case 1:return l.CompletionItemTag.Deprecated}}we.to=ae})(ze||(e.CompletionItemTag=ze={}));var z;(function(we){const Se=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function ae(We){return Se.get(We)??9}we.from=ae;const Q=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ee(We){return Q.get(We)??l.CompletionItemKind.Property}we.to=Ee})(z||(e.CompletionItemKind=z={}));var L;(function(we){function Se(ae,Q){const Ee=new l.$nN(ae.label);return Ee.insertText=ae.insertText,Ee.kind=z.to(ae.kind),Ee.tags=ae.tags?.map(ze.to),Ee.detail=ae.detail,Ee.documentation=M.$Pk(ae.documentation)?K.to(ae.documentation):ae.documentation,Ee.sortText=ae.sortText,Ee.filterText=ae.filterText,Ee.preselect=ae.preselect,Ee.commitCharacters=ae.commitCharacters,o.$kt.isIRange(ae.range)?Ee.range=d.to(ae.range):typeof ae.range=="object"&&(Ee.range={inserting:d.to(ae.range.insert),replacing:d.to(ae.range.replace)}),Ee.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?Ee.insertText=new l.$4M(ae.insertText):(Ee.insertText=ae.insertText,Ee.textEdit=Ee.range instanceof l.$UM?new l.$ZM(Ee.range,Ee.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Ee.additionalTextEdits=ae.additionalTextEdits.map(We=>ie.to(We))),Ee.command=Q&&ae.command?Q.fromInternal(ae.command):void 0,Ee}we.to=Se})(L||(e.CompletionItem=L={}));var G;(function(we){function Se(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:K.fromStrict(Q.documentation)}}we.from=Se;function ae(Q){return{label:Q.label,documentation:M.$Pk(Q.documentation)?K.to(Q.documentation):Q.documentation}}we.to=ae})(G||(e.ParameterInformation=G={}));var H;(function(we){function Se(Q){return{label:Q.label,documentation:K.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(G.from):[],activeParameter:Q.activeParameter}}we.from=Se;function ae(Q){return{label:Q.label,documentation:M.$Pk(Q.documentation)?K.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(G.to):[],activeParameter:Q.activeParameter}}we.to=ae})(H||(e.SignatureInformation=H={}));var ee;(function(we){function Se(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(H.from):[]}}we.from=Se;function ae(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(H.to):[]}}we.to=ae})(ee||(e.SignatureHelp=ee={}));var re;(function(we){function Se(ae,Q){const Ee=new l.$mN(E.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(Ne.to.bind(void 0,ae)),Q.kind&&Be.to(Q.kind));return Ee.textEdits=Q.textEdits&&Q.textEdits.map(ie.to),Ee.tooltip=M.$Pk(Q.tooltip)?K.to(Q.tooltip):Q.tooltip,Ee.paddingLeft=Q.paddingLeft,Ee.paddingRight=Q.paddingRight,Ee}we.to=Se})(re||(e.InlayHint=re={}));var Ne;(function(we){function Se(ae,Q){const Ee=new l.$lN(Q.label);return Ee.tooltip=M.$Pk(Q.tooltip)?K.to(Q.tooltip):Q.tooltip,r.Command.is(Q.command)&&(Ee.command=ae.fromInternal(Q.command)),Q.location&&(Ee.location=$e.to(Q.location)),Ee}we.to=Se})(Ne||(e.InlayHintLabelPart=Ne={}));var Be;(function(we){function Se(Q){return Q}we.from=Se;function ae(Q){return Q}we.to=ae})(Be||(e.InlayHintKind=Be={}));var Qe;(function(we){function Se(Q){return{range:d.from(Q.range),url:Q.target,tooltip:Q.tooltip}}we.from=Se;function ae(Q){let Ee;if(Q.url)try{Ee=typeof Q.url=="string"?s.URI.parse(Q.url,!0):s.URI.revive(Q.url)}catch{}return new l.$sN(d.to(Q.range),Ee)}we.to=ae})(Qe||(e.DocumentLink=Qe={}));var _e;(function(we){function Se(Q){const Ee=new l.$vN(Q.label);return Q.textEdit&&(Ee.textEdit=ie.to(Q.textEdit)),Q.additionalTextEdits&&(Ee.additionalTextEdits=Q.additionalTextEdits.map(We=>ie.to(We))),Ee}we.to=Se;function ae(Q){return{label:Q.label,textEdit:Q.textEdit?ie.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Ee=>ie.from(Ee)):void 0}}we.from=ae})(_e||(e.ColorPresentation=_e={}));var et;(function(we){function Se(Q){return new l.$tN(Q[0],Q[1],Q[2],Q[3])}we.to=Se;function ae(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}we.from=ae})(et||(e.Color=et={}));var tt;(function(we){function Se(Q){return{range:d.from(Q.range)}}we.from=Se;function ae(Q){return new l.$cN(d.to(Q.range))}we.to=ae})(tt||(e.SelectionRange=tt={}));var it;(function(we){function Se(ae){switch(ae){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}we.to=Se})(it||(e.TextDocumentSaveReason=it={}));var nt;(function(we){function Se(Q){switch(Q){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.Interval:return 3;case l.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Se;function ae(Q){switch(Q){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 3:return l.TextEditorLineNumbersStyle.Interval;case 1:default:return l.TextEditorLineNumbersStyle.On}}we.to=ae})(nt||(e.TextEditorLineNumbersStyle=nt={}));var at;(function(we){function Se(Q){if(Q===l.EndOfLine.CRLF)return 1;if(Q===l.EndOfLine.LF)return 0}we.from=Se;function ae(Q){if(Q===1)return l.EndOfLine.CRLF;if(Q===0)return l.EndOfLine.LF}we.to=ae})(at||(e.EndOfLine=at={}));var mt;(function(we){function Se(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Se})(mt||(e.ProgressLocation=mt={}));var je;(function(we){function Se(Q){const Ee={start:Q.start+1,end:Q.end+1};return Q.kind&&(Ee.kind=st.from(Q.kind)),Ee}we.from=Se;function ae(Q){const Ee={start:Q.start-1,end:Q.end-1};return Q.kind&&(Ee.kind=st.to(Q.kind)),Ee}we.to=ae})(je||(e.FoldingRange=je={}));var st;(function(we){function Se(Q){if(Q)switch(Q){case l.FoldingRangeKind.Comment:return r.$6t.Comment;case l.FoldingRangeKind.Imports:return r.$6t.Imports;case l.FoldingRangeKind.Region:return r.$6t.Region}}we.from=Se;function ae(Q){if(Q)switch(Q.value){case r.$6t.Comment.value:return l.FoldingRangeKind.Comment;case r.$6t.Imports.value:return l.FoldingRangeKind.Imports;case r.$6t.Region.value:return l.FoldingRangeKind.Region}}we.to=ae})(st||(e.FoldingRangeKind=st={}));var X;(function(we){function Se(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?d.from(ae.selection):void 0,override:typeof ae.override=="boolean"?c.$eF.id:void 0}}we.from=Se})(X||(e.TextEditorOpenOptions=X={}));var Z;(function(we){function Se(We){return We instanceof l.$QN?We.toJSON():typeof We=="string"?We:ae(We)||Q(We)?new l.$QN(We.baseUri??We.base,We.pattern).toJSON():We}we.from=Se;function ae(We){const Ze=We;return Ze?s.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function Q(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Ee(We){return typeof We=="string"?We:new l.$QN(s.URI.revive(We.baseUri),We.pattern)}we.to=Ee})(Z||(e.GlobPattern=Z={}));var me;(function(we){function Se(ae){if(ae){if(Array.isArray(ae))return ae.map(Se);if(typeof ae=="string")return ae;{const Q=ae;return{language:Q.language,scheme:Q.scheme,pattern:Z.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}we.from=Se})(me||(e.LanguageSelector=me={}));var He;(function(we){function Se(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(We=>We&&typeof We=="object"&&"uri"in We&&s.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ze=>Ze instanceof l.$UM)))}we.is=Se;function ae(Q){return{documents:Q.documents.map(Ee=>Ee.map(We=>({uri:s.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ze=>d.from(Ze))})))}}we.from=ae})(He||(e.MappedEditsContext=He={}));var ye;(function(we){function Se(Q){return{start:Q.start,end:Q.end}}we.from=Se;function ae(Q){return new l.$hO(Q.start,Q.end)}we.to=ae})(ye||(e.NotebookRange=ye={}));var ot;(function(we){function Se(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}we.to=Se;function ae(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}we.from=ae})(ot||(e.NotebookCellExecutionSummary=ot={}));var dt;(function(we){function Se(ae){if(ae===i.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(ae===i.NotebookCellExecutionState.Pending)return;if(ae===i.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}we.to=Se})(dt||(e.NotebookCellExecutionState=dt={}));var It;(function(we){function Se(Q){switch(Q){case l.NotebookCellKind.Markup:return i.CellKind.Markup;case l.NotebookCellKind.Code:default:return i.CellKind.Code}}we.from=Se;function ae(Q){switch(Q){case i.CellKind.Markup:return l.NotebookCellKind.Markup;case i.CellKind.Code:default:return l.NotebookCellKind.Code}}we.to=ae})(It||(e.NotebookCellKind=It={}));var Qt;(function(we){function Se(Q){const Ee={metadata:Q.metadata??Object.create(null),cells:[]};for(const We of Q.cells)l.$iO.validate(We),Ee.cells.push(Ut.from(We));return Ee}we.from=Se;function ae(Q){const Ee=new l.$jO(Q.cells.map(Ut.to));return(0,m.$eg)(Q.metadata)||(Ee.metadata=Q.metadata),Ee}we.to=ae})(Qt||(e.NotebookData=Qt={}));var Ut;(function(we){function Se(Q){return{cellKind:It.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:ot.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(_t.from):[]}}we.from=Se;function ae(Q){return new l.$iO(It.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(_t.to):void 0,Q.metadata,Q.internalMetadata?ot.to(Q.internalMetadata):void 0)}we.to=ae})(Ut||(e.NotebookCellData=Ut={}));var xt;(function(we){function Se(Q){return{mime:Q.mime,valueBytes:T.$Ce.wrap(Q.data)}}we.from=Se;function ae(Q){return new l.$kO(Q.valueBytes.buffer,Q.mime)}we.to=ae})(xt||(e.NotebookCellOutputItem=xt={}));var _t;(function(we){function Se(Q){return{outputId:Q.id,items:Q.items.map(xt.from),metadata:Q.metadata}}we.from=Se;function ae(Q){const Ee=Q.items.map(xt.to);return new l.$lO(Ee,Q.outputId,Q.metadata)}we.to=ae})(_t||(e.NotebookCellOutput=_t={}));var Ct;(function(we){function Se(Ee){return Q(Ee)?{include:Z.from(Ee.include)??void 0,exclude:Z.from(Ee.exclude)??void 0}:Z.from(Ee)??void 0}we.from=Se;function ae(Ee){return Q(Ee)?{include:Z.to(Ee.include),exclude:Z.to(Ee.exclude)}:Z.to(Ee)}we.to=ae;function Q(Ee){const We=Ee;return We?!(0,m.$ag)(We.include)&&!(0,m.$ag)(We.exclude):!1}})(Ct||(e.NotebookExclusiveDocumentPattern=Ct={}));var Vt;(function(we){function Se(ae,Q,Ee){const We=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(We,Ee),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}we.from=Se})(Vt||(e.NotebookStatusBarItem=Vt={}));var Zt;(function(we){function Se(ae,Q,Ee){const We=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:Q.toInternal(We,Ee),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}we.from=Se})(Zt||(e.NotebookKernelSourceAction=Zt={}));var Xe;(function(we){function Se(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}we.from=Se})(Xe||(e.NotebookDocumentContentOptions=Xe={}));var si;(function(we){function Se(Q){return{uri:Q.uri,provides:Q.provides}}we.from=Se;function ae(Q){return new l.$nO(s.URI.revive(Q.uri),Q.provides)}we.to=ae})(si||(e.NotebookRendererScript=si={}));var Xt;(function(we){function Se(Q){return{message:K.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:d.from(Q.location.range),uri:Q.location.uri}}}we.from=Se;function ae(Q){const Ee=new l.$tO(typeof Q.message=="string"?Q.message:K.to(Q.message));return Ee.actualOutput=Q.actual,Ee.expectedOutput=Q.expected,Ee.contextValue=Q.contextValue,Ee.location=Q.location?$e.to(Q.location):void 0,Ee}we.to=ae})(Xt||(e.TestMessage=Xt={}));var lt;(function(we){we.namespace=a.$HL,we.denamespace=a.$IL})(lt||(e.TestTag=lt={}));var vt;(function(we){function Se(Q){const Ee=(0,t.$_O)(Q).controllerId;return{extId:b.$CL.fromExtHostTestItem(Q,Ee).toString(),label:Q.label,uri:s.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(We=>lt.namespace(Ee,We.id)),range:o.$kt.lift(d.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&K.fromStrict(Q.error)||null}}we.from=Se;function ae(Q){return{parent:void 0,error:void 0,id:b.$CL.fromString(Q.extId).localId,label:Q.label,uri:s.URI.revive(Q.uri),tags:(Q.tags||[]).map(Ee=>{const{tagId:We}=lt.denamespace(Ee);return new l.$uO(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}we.toPlain=ae})(vt||(e.TestItem=vt={})),function(we){function Se(Q){return{id:Q.id}}we.from=Se;function ae(Q){return new l.$uO(Q.id)}we.to=ae}(lt||(e.TestTag=lt={}));var ti;(function(we){const Se=(Q,Ee)=>{const We=Q.value;if(!We)return;const Ze={...vt.toPlain(We.item),parent:Ee,taskStates:We.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(Xt.to)})),children:[]};if(Q.children)for(const qe of Q.children.values()){const ut=Se(qe,Ze);ut&&Ze.children.push(ut)}return Ze};function ae(Q){const Ee=new u.$5O;for(const qe of Q.items)Ee.insert(b.$CL.fromString(qe.item.extId).path,qe);const We=[Ee.nodes],Ze=[];for(;We.length;)for(const qe of We.pop())qe.value?Ze.push(qe):qe.children&&We.push(qe.children.values());return{completedAt:Q.completedAt,results:Ze.map(qe=>Se(qe)).filter(m.$_f)}}we.to=ae})(ti||(e.TestResults=ti={}));var Yt;(function(we){function Se(We){return{covered:We.covered,total:We.total}}function ae(We){return"line"in We?E.from(We):d.from(We)}function Q(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:ae(We.location),type:1,branches:We.branches.length?We.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ae(Ze.location),label:Ze.label})):void 0}:{type:0,name:We.name,count:We.executed,location:ae(We.location)}}we.fromDetails=Q;function Ee(We,Ze){return l.$wO(Ze.statementCoverage),l.$wO(Ze.branchCoverage),l.$wO(Ze.declarationCoverage),{id:We,uri:Ze.uri,statement:Se(Ze.statementCoverage),branch:Ze.branchCoverage&&Se(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Se(Ze.declarationCoverage)}}we.fromFile=Ee})(Yt||(e.TestCoverage=Yt={}));var Lt;(function(we){function Se(ae){switch(ae){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}we.to=Se})(Lt||(e.CodeActionTriggerKind=Lt={}));var ft;(function(we){function Se(Q){const Ee=new l.$BO(Fe.to(Q.kind),Q.name,Q.detail||"",s.URI.revive(Q.uri),d.to(Q.range),d.to(Q.selectionRange));return Ee._sessionId=Q._sessionId,Ee._itemId=Q._itemId,Ee}we.to=Se;function ae(Q,Ee,We){if(Ee=Ee??Q._sessionId,We=We??Q._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,kind:Fe.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:d.from(Q.range),selectionRange:d.from(Q.selectionRange),tags:Q.tags?.map(ne.from)}}we.from=ae})(ft||(e.TypeHierarchyItem=ft={}));var jt;(function(we){function Se(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}we.from=Se})(jt||(e.ViewBadge=jt={}));var Bt;(function(we){function Se(We,Ze,qe){const ut=Ze.fileData;return ut?new l.$IN(new l.$JN(ut.name,s.URI.revive(ut.uri),ut.id,(0,O.$db)(()=>qe(ut.id)))):We===N.$Hs.uriList&&Ze.uriListData?new l.$HN(Ee(Ze.uriListData)):new l.$HN(Ze.asString)}we.to=Se;async function ae(We,Ze){const qe=await Ze.asString();if(We===N.$Hs.uriList)return{asString:qe,fileData:void 0,uriListData:Q(qe)};const ut=Ze.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}we.from=ae;function Q(We){return R.$Kt.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return s.URI.parse(Ze)}catch{}return Ze})}function Ee(We){return R.$Kt.create(We.map(Ze=>typeof Ze=="string"?Ze:s.URI.revive(Ze)))}})(Bt||(e.DataTransferItem=Bt={}));var qt;(function(we){function Se(Q,Ee){const We=Q.items.map(([Ze,qe])=>[Ze,Bt.to(Ze,qe,Ee)]);return new l.$KN(We)}we.toDataTransfer=Se;async function ae(Q){const Ee={items:[]},We=[];for(const[Ze,qe]of Q)We.push((async()=>{Ee.items.push([Ze,await Bt.from(Ze,qe)])})());return await Promise.all(We),Ee}we.from=ae})(qt||(e.DataTransfer=qt={}));var Ge;(function(we){function Se(Q,Ee){return{kind:"reply",agentId:Q.participant??Ee?.agentId??"",subCommand:Q.command??Ee?.command,message:Q.prompt,title:Q.label}}we.from=Se;function ae(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}we.to=ae})(Ge||(e.ChatFollowup=Ge={}));var ui;(function(we){function Se(ae){return"commandId"in ae?{kind:"command",title:ae.title??"",commandId:ae.commandId??"",when:ae.when??"",args:ae.args}:{kind:"reply",message:ae.message,title:ae.title,tooltip:ae.tooltip}}we.from=Se})(ui||(e.ChatInlineFollowup=ui={}));var Ht;(function(we){function Se(Q){switch(Q.role){case 0:return new l.$ZO(Q.content);case 1:return new l.$1O(Q.content);case 2:return new l.$2O(Q.content)}}we.to=Se;function ae(Q){if(Q instanceof l.$ZO)return{role:0,content:Q.content};if(Q instanceof l.$1O)return{role:1,content:Q.content};if(Q instanceof l.$2O)return{role:2,content:Q.content};throw new Error("Invalid LanguageModelMessage")}we.from=ae})(Ht||(e.LanguageModelMessage=Ht={}));var zt;(function(we){function Se(Ee){const We={};for(const Ze of Object.keys(Ee))We[Ze]=Ee[Ze].map(we.to);return We}we.objectTo=Se;function ae(Ee){return{level:gt.to(Ee.level),kind:Ee.kind,value:(0,s.$wc)(Ee.value)?s.URI.revive(Ee.value):Ee.value,description:Ee.description}}we.to=ae;function Q(Ee){return{level:gt.from(Ee.level),kind:Ee.kind,value:Ee.value,description:Ee.description}}we.from=Q})(zt||(e.ChatVariable=zt={}));var gt;(function(we){function Se(Q){switch(Q){case"short":return l.ChatVariableLevel.Short;case"medium":return l.ChatVariableLevel.Medium;case"full":default:return l.ChatVariableLevel.Full}}we.to=Se;function ae(Q){switch(Q){case l.ChatVariableLevel.Short:return"short";case l.ChatVariableLevel.Medium:return"medium";case l.ChatVariableLevel.Full:default:return"full"}}we.from=ae})(gt||(e.ChatVariableLevel=gt={}));var Nt;(function(we){function Se(ae){switch(ae){case 1:return l.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return l.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return l.InteractiveEditorResponseFeedbackKind.Undone;case 3:return l.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return l.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Se})(Nt||(e.InteractiveEditorResponseFeedbackKind=Nt={}));var Rt;(function(we){function Se(Q){return{kind:"markdownContent",content:K.from(Q.value)}}we.from=Se;function ae(Q){return new l.$OO(K.to(Q.content))}we.to=ae})(Rt||(e.ChatResponseMarkdownPart=Rt={}));var Ot;(function(we){function Se(Q){return{kind:"markdownVuln",content:K.from(Q.value),vulnerabilities:Q.vulnerabilities}}we.from=Se;function ae(Q){return new l.$PO(K.to(Q.content),Q.vulnerabilities)}we.to=ae})(Ot||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ot={}));var ii;(function(we){function Se(Q){return{kind:"agentDetection",agentId:Q.participant,command:Q.command}}we.from=Se;function ae(Q){return new l.$QO(Q.agentId,Q.command)}we.to=ae})(ii||(e.ChatResponseDetectedParticipantPart=ii={}));var Gt;(function(we){function Se(Q){const{value:Ee,baseUri:We}=Q;function Ze(qe,ut){return qe.map(kt=>{const Ft=s.URI.joinPath(ut,kt.name);return{label:kt.name,uri:Ft,children:kt.children&&Ze(kt.children,Ft)}})}return{kind:"treeData",treeData:{label:(0,v.$1g)(We),uri:We,children:Ze(Ee,We)}}}we.from=Se;function ae(Q){const Ee=(0,k.$Zh)(Q.treeData);function We(ut){return ut.map(kt=>({name:kt.label,children:kt.children&&We(kt.children)}))}const Ze=Ee.uri,qe=Ee.children?We(Ee.children):[];return new l.$RO(qe,Ze)}we.to=ae})(Gt||(e.ChatResponseFilesPart=Gt={}));var ni;(function(we){function Se(Q){return{kind:"inlineReference",name:Q.title,inlineReference:s.URI.isUri(Q.value)?Q.value:D.from(Q.value)}}we.from=Se;function ae(Q){const Ee=(0,k.$Zh)(Q);return new l.$SO(s.URI.isUri(Ee.inlineReference)?Ee.inlineReference:D.to(Ee.inlineReference),Q.name)}we.to=ae})(ni||(e.ChatResponseAnchorPart=ni={}));var Mt;(function(we){function Se(Q){return{kind:"progressMessage",content:K.from(Q.value)}}we.from=Se;function ae(Q){return new l.$TO(Q.content.value)}we.to=ae})(Mt||(e.ChatResponseProgressPart=Mt={}));var Tt;(function(we){function Se(Q,Ee,We){return{kind:"command",command:Ee.toInternal(Q.value,We)??{command:Q.value.command,title:Q.value.title}}}we.from=Se;function ae(Q,Ee){return new l.$UO(Ee.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}we.to=ae})(Tt||(e.ChatResponseCommandButtonPart=Tt={}));var Pt;(function(we){function Se(Q){return{kind:"textEdit",uri:Q.uri,edits:Q.edits.map(Ee=>ie.from(Ee))}}we.from=Se;function ae(Q){return new l.$WO(s.URI.revive(Q.uri),Q.edits.map(Ee=>ie.to(Ee)))}we.to=ae})(Pt||(e.ChatResponseTextEditPart=Pt={}));var Dt;(function(we){function Se(Q){return"variableName"in Q.value?{kind:"reference",reference:{variableName:Q.value.variableName,value:s.URI.isUri(Q.value.value)||!Q.value.value?Q.value.value:D.from(Q.value.value)}}:{kind:"reference",reference:s.URI.isUri(Q.value)?Q.value:D.from(Q.value)}}we.from=Se;function ae(Q){const Ee=(0,k.$Zh)(Q),We=Ze=>s.URI.isUri(Ze)?Ze:D.to(Ze);return new l.$VO("variableName"in Ee.reference?{variableName:Ee.reference.variableName,value:Ee.reference.value&&We(Ee.reference.value)}:We(Ee.reference))}we.to=ae})(Dt||(e.ChatResponseReferencePart=Dt={}));var pt;(function(we){function Se(Ee,We,Ze){return Ee instanceof l.$OO?Rt.from(Ee):Ee instanceof l.$SO?ni.from(Ee):Ee instanceof l.$VO?Dt.from(Ee):Ee instanceof l.$TO?Mt.from(Ee):Ee instanceof l.$RO?Gt.from(Ee):Ee instanceof l.$UO?Tt.from(Ee,We,Ze):Ee instanceof l.$WO?Pt.from(Ee):Ee instanceof l.$PO?Ot.from(Ee):Ee instanceof l.$QO?ii.from(Ee):{kind:"markdownContent",content:K.from("")}}we.from=Se;function ae(Ee,We){switch(Ee.kind){case"reference":return Dt.to(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(Ee,We)}}we.to=ae;function Q(Ee,We){switch(Ee.kind){case"markdownContent":return Rt.to(Ee);case"inlineReference":return ni.to(Ee);case"progressMessage":return;case"treeData":return Gt.to(Ee);case"command":return Tt.to(Ee,We)}}we.toContent=Q})(pt||(e.ChatResponsePart=pt={}));var St;(function(we){function Se(ae){return{prompt:ae.message,command:ae.command,attempt:ae.attempt??0,enableCommandDetection:ae.enableCommandDetection??!0,variables:ae.variables.variables.map(Et.to),location:li.to(ae.location)}}we.to=Se})(St||(e.ChatAgentRequest=St={}));var li;(function(we){function Se(ae){switch(ae){case h.ChatAgentLocation.Notebook:return l.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return l.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return l.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return l.ChatLocation.Editor}}we.to=Se})(li||(e.ChatLocation=li={}));var Et;(function(we){function Se(ae){return{name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],values:ae.values.map(zt.to)}}we.to=Se})(Et||(e.ChatAgentResolvedVariable=Et={}));var hi;(function(we){function Se(ae){return{label:ae.label,values:ae.values.map(zt.from),insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation}}we.from=Se})(hi||(e.ChatAgentCompletionItem=hi={}));var Kt;(function(we){function Se(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}we.to=Se})(Kt||(e.ChatAgentResult=Kt={}));var vi;(function(we){function Se(ae,Q,Ee){if(Q.action.kind==="vote")return;const We=Kt.to(ae);if(Q.action.kind==="command"){const Ze=Q.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ee.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:We}}else return Q.action.kind==="followUp"?{action:{kind:"followUp",followup:Ge.to(Q.action.followup)},result:We}:Q.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Q.action.action==="accepted"},result:We}:{action:Q.action,result:We}}we.to=Se})(vi||(e.ChatAgentUserActionEvent=vi={}));var ei;(function(we){function Se(ae,Q,Ee){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:Q.toInternal(ae,Ee)}we.from=Se})(ei||(e.TerminalQuickFix=ei={}));var wi;(function(we){function Se(ae){return{kind:yt.to(ae.kind)}}we.to=Se})(wi||(e.PartialAcceptInfo=wi={}));var yt;(function(we){function Se(ae){switch(ae){case 0:return l.PartialAcceptTriggerKind.Word;case 1:return l.PartialAcceptTriggerKind.Line;case 2:return l.PartialAcceptTriggerKind.Suggest;default:return l.PartialAcceptTriggerKind.Unknown}}we.to=Se})(yt||(e.PartialAcceptTriggerKind=yt={}));var $i;(function(we){function Se(ae,Q){return{id:Q,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}we.from=Se})($i||(e.DebugTreeItem=$i={}))}),define(Re[251],Ae([1,0,4,16,8,34]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;let M=class{constructor(g,k){this.a=g.getProxy(I.$QM.MainThreadBulkEdits),this.b={getTextDocumentVersion:N=>k.getDocument(N)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,k,N){const y=new O.$mw(R.WorkspaceEdit.from(g,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,N?.isRefactoring??!1)}};e.$tkc=M,e.$tkc=M=Je([Ve(0,T.$dP)],M)}),define(Re[252],Ae([1,0,18,11,43,5,40,6,65,17,2,20,4,8,7,214,25]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;class r{constructor(h,i,b,a,$){this.i=h,this.j=i,this.k=b,this.l=a,this.m=$,this.b=g.$0d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(a){if(h.c){const $=new Error("Response stream has been closed");throw Error.captureStackTrace($,a),$}};const h=this;this.b.reset();const b=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,a)};this.g={markdown(a){i(this.markdown);const $=new m.$OO(a),l=v.ChatResponseMarkdownPart.from($);return b(l),this},markdownWithVulnerabilities(a,$){i(this.markdown),$&&(0,o.$yG)(h.i,"chatParticipantAdditions");const l=new m.$PO(a,$),S=v.ChatResponseMarkdownWithVulnerabilitiesPart.from(l);return b(S),this},filetree(a,$){i(this.filetree);const l=new m.$RO(a,$),S=v.ChatResponseFilesPart.from(l);return b(S),this},anchor(a,$){i(this.anchor);const l=new m.$SO(a,$),S=v.ChatResponseAnchorPart.from(l);return b(S),this},button(a){i(this.anchor);const $=new m.$UO(a),l=v.ChatResponseCommandButtonPart.from($,h.l,h.m);return b(l),this},progress(a){i(this.progress);const $=new m.$TO(a),l=v.ChatResponseProgressPart.from($);return b(l),this},reference(a){if(i(this.reference),"variableName"in a&&!a.value){const $=h.j.variables.variables.find(l=>l.name===a.variableName);if($){let l;if($.references?.length)l=$.references.map(S=>({kind:"reference",reference:{variableName:a.variableName,value:S.reference}}));else{const S=new m.$VO(a);l=[v.ChatResponseReferencePart.from(S)]}return l.forEach(S=>b(S)),this}}else{const $=new m.$VO(a),l=v.ChatResponseReferencePart.from($);b(l)}return this},textEdit(a,$){i(this.textEdit),(0,o.$yG)(h.i,"chatParticipantAdditions");const l=new m.$WO(a,$),S=v.ChatResponseTextEditPart.from(l);return b(S),this},detectedParticipant(a,$){i(this.detectedParticipant),(0,o.$yG)(h.i,"chatParticipantAdditions");const l=new m.$QO(a,$),S=v.ChatResponseDetectedParticipantPart.from(l);return b(S),this},push(a){if(i(this.push),(a instanceof m.$WO||a instanceof m.$PO||a instanceof m.$QO)&&(0,o.$yG)(h.i,"chatParticipantAdditions"),a instanceof m.$VO)this.reference(a.value);else{const $=v.ChatResponsePart.from(a,h.l,h.m);b($)}return this}}}return this.g}}class n{static{this.b=0}constructor(h,i,b){this.i=i,this.j=b,this.c=new Map,this.g=new p.$4c,this.d=h.getProxy(u.$QM.MainThreadChatAgents2)}transferActiveChat(h){this.d.$transferActiveChatSession(h)}createChatAgent(h,i,b){const a=n.b++,$=new t(h,i,this.d,a,b);return this.c.set(a,$),this.d.$registerAgent(a,h.identifier,i,{},void 0),$.apiAgent}createDynamicChatAgent(h,i,b,a,$){const l=n.b++,S=new t(h,i,this.d,l,$);return this.c.set(l,S),this.d.$registerAgent(l,h.identifier,i,{isSticky:!0},{name:b,description:a}),S.apiAgent}async $invokeAgent(h,i,b,a){const $=this.c.get(h);if(!$)throw new Error(`[CHAT](${h}) CANNOT invoke agent because the agent is not registered`);let l=this.g.get(i.sessionId);l||(l=new p.$Tc,this.g.set(i.sessionId,l));const S=new r($.extension,i,this.d,this.j.converter,l);try{const d=await this.k(i.agentId,b),D=$.invoke(v.ChatAgentRequest.to(i),{history:d},S.apiObject,a);return await(0,T.$eh)(Promise.resolve(D).then(f=>{if(f?.metadata)try{JSON.stringify(f.metadata)}catch(E){const w=`result.metadata MUST be JSON.stringify-able. Got error: ${E.message}`;return this.i.error(`[${$.extension.identifier.value}] [@${$.id}] ${w}`,$.extension),{errorDetails:{message:w},timings:S.timings}}return{errorDetails:f?.errorDetails,timings:S.timings,metadata:f?.metadata}}),a)}catch(d){return this.i.error(d,$.extension),{errorDetails:{message:(0,R.$bj)(d),responseIsIncomplete:!0}}}finally{S.close()}}async k(h,i){const b=[];for(const a of i.history){const $=v.ChatAgentResult.to(a.result),l=h===a.request.agentId?$:{...$,metadata:void 0};b.push(new m.$XO(a.request.message,a.request.command,a.request.variables.variables.map(v.ChatAgentResolvedVariable.to),a.request.agentId));const S=(0,I.$Hb)(a.response.map(d=>v.ChatResponsePart.toContent(d,this.j.converter)));b.push(new m.$YO(S,l,a.request.agentId,a.request.command))}return b}$releaseSession(h){this.g.deleteAndDispose(h)}async $provideFollowups(h,i,b,a,$){const l=this.c.get(i);if(!l)return Promise.resolve([]);const S=await this.k(l.id,a),d=v.ChatAgentResult.to(b);return(await l.provideFollowups(d,{history:S},$)).filter(D=>{const f=!D.participant||M.Iterable.some(this.c.values(),E=>E.id===D.participant&&y.$Lm.equals(E.extension.identifier,l.extension.identifier));return f||this.i.warn(`[@${l.id}] ChatFollowup refers to an unknown participant: ${D.participant}`),f}).map(D=>v.ChatFollowup.from(D,h))}$acceptFeedback(h,i,b,a){const $=this.c.get(h);if(!$)return;const l=v.ChatAgentResult.to(i);let S;switch(b){case s.InteractiveSessionVoteDirection.Down:S=m.ChatResultFeedbackKind.Unhelpful;break;case s.InteractiveSessionVoteDirection.Up:S=m.ChatResultFeedbackKind.Helpful;break}$.acceptFeedback(Object.freeze(a?{result:l,kind:S,reportIssue:a}:{result:l,kind:S}))}$acceptAction(h,i,b){const a=this.c.get(h);if(!a||b.action.kind==="vote")return;const $=v.ChatAgentUserActionEvent.to(i,b,this.j.converter);$&&a.acceptAction(Object.freeze($))}async $invokeCompletionProvider(h,i,b){const a=this.c.get(h);return a?(await a.invokeCompletionProvider(i,b)).map(v.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(h,i,b){const a=this.c.get(h);if(a)return await a.provideWelcomeMessage(v.ChatLocation.to(i),b)}async $provideSampleQuestions(h,i,b){const a=this.c.get(h);if(a)return(await a.provideSampleQuestions(v.ChatLocation.to(i),b)).map($=>v.ChatFollowup.from($,void 0))}}e.$ukc=n;class t{constructor(h,i,b,a,$){this.extension=h,this.id=i,this.t=b,this.u=a,this.w=$,this.m=new O.$be,this.n=new O.$be}acceptFeedback(h){this.m.fire(h)}acceptAction(h){this.n.fire(h)}async invokeCompletionProvider(h,i){return this.p?await this.p.provider.provideCompletionItems(h,i)??[]:[]}async provideFollowups(h,i,b){if(!this.b)return[];const a=await this.b.provideFollowups(h,i,b);return a?a.filter($=>!($&&"commandId"in $)).filter($=>!($&&"message"in $)):[]}async provideWelcomeMessage(h,i){if(!this.q)return[];const b=await this.q.provideWelcomeMessage(h,i);return b?b.map(a=>typeof a=="string"?a:v.MarkdownString.from(a)):[]}async provideSampleQuestions(h,i){if(!this.q||!this.q.provideSampleQuestions)return[];const b=await this.q.provideSampleQuestions(h,i);return b||[]}get apiAgent(){let h=!1,i=!1;const b=()=>{h||i||(i=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{fullName:this.c,icon:this.d?this.d instanceof N.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof m.$ON?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:v.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.s}),i=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,o.$yG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName($){(0,o.$yG)(a.extension,"defaultChatParticipant"),a.c=$,b()},get iconPath(){return a.d},set iconPath($){a.d=$,b()},get requestHandler(){return a.w},set requestHandler($){(0,k.$bg)(typeof $=="function","Invalid request handler"),a.w=$},get followupProvider(){return a.b},set followupProvider($){a.b=$,b()},get isDefault(){return(0,o.$yG)(a.extension,"defaultChatParticipant"),a.g},set isDefault($){(0,o.$yG)(a.extension,"defaultChatParticipant"),a.g=$,b()},get helpTextPrefix(){return(0,o.$yG)(a.extension,"defaultChatParticipant"),a.i},set helpTextPrefix($){(0,o.$yG)(a.extension,"defaultChatParticipant"),a.i=$,b()},get helpTextVariablesPrefix(){return(0,o.$yG)(a.extension,"defaultChatParticipant"),a.j},set helpTextVariablesPrefix($){(0,o.$yG)(a.extension,"defaultChatParticipant"),a.j=$,b()},get helpTextPostfix(){return(0,o.$yG)(a.extension,"defaultChatParticipant"),a.k},set helpTextPostfix($){(0,o.$yG)(a.extension,"defaultChatParticipant"),a.k=$,b()},get isSecondary(){return(0,o.$yG)(a.extension,"defaultChatParticipant"),a.l},set isSecondary($){(0,o.$yG)(a.extension,"defaultChatParticipant"),a.l=$,b()},get supportIssueReporting(){return(0,o.$yG)(a.extension,"chatParticipantAdditions"),a.o},set supportIssueReporting($){(0,o.$yG)(a.extension,"chatParticipantAdditions"),a.o=$,b()},get onDidReceiveFeedback(){return a.m.event},set participantVariableProvider($){if((0,o.$yG)(a.extension,"chatParticipantAdditions"),a.p=$,$){if(!$.triggerCharacters.length)throw new Error("triggerCharacters are required");a.t.$registerAgentCompletionsProvider(a.u,$.triggerCharacters)}else a.t.$unregisterAgentCompletionsProvider(a.u)},get participantVariableProvider(){return(0,o.$yG)(a.extension,"chatParticipantAdditions"),a.p},set welcomeMessageProvider($){(0,o.$yG)(a.extension,"defaultChatParticipant"),a.q=$,b()},get welcomeMessageProvider(){return(0,o.$yG)(a.extension,"defaultChatParticipant"),a.q},onDidPerformAction:(0,o.$xG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester($){a.s=$,b()},get requester(){return a.s},dispose(){h=!0,a.b=void 0,a.m.dispose(),a.t.$unregisterAgent(a.u)}}}invoke(h,i,b,a){return this.w(h,i,b,a)}}}),define(Re[253],Ae([1,0,14,6,4,8,7,25]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=void 0;class g{static{this.a=0}constructor(y){this.b=new Map,this.c=y.getProxy(R.$QM.MainThreadChatVariables)}async $resolveVariable(y,u,v,m){const s=this.b.get(y);if(s)try{if(s.resolver.resolve2){(0,p.$yG)(s.extension,"chatParticipantAdditions");const o=new k(u,this.c),r=await s.resolver.resolve2(s.data.name,{prompt:v},o.apiObject,m);if(r)return r.map(O.ChatVariable.from)}else{const o=await s.resolver.resolve(s.data.name,{prompt:v},m);if(o)return o.map(O.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(y,u,v,m){const s=g.a++;return this.b.set(s,{extension:y,data:{name:u,description:v},resolver:m}),this.c.$registerVariable(s,{name:u,description:v}),(0,T.$Sc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$vkc=g;class k{constructor(y,u){this.c=y,this.d=u,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let u=function(m){if(y.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,m),s}};const y=this,v=m=>{this.d.$handleProgressChunk(this.c,m)};this.b={progress(m){u(this.progress);const s=new M.$TO(m),o=O.ChatResponseProgressPart.from(s);return v(o),this},reference(m){u(this.reference);const s=new M.$VO(m),o=O.ChatResponseReferencePart.from(s);return v(o),this},push(m){return u(this.push),m instanceof M.$VO?v(O.ChatResponseReferencePart.from(m)):m instanceof M.$TO&&v(O.ChatResponseProgressPart.from(m)),this}}}return this.b}}}),define(Re[254],Ae([1,0,11,68,5,6,2,87,20,8,7,4,25]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=v;function v(m,s,o){const r=m.getProxy(y.$QM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$Nm,s.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const D=this.b.get(d.handle);return D?D.value:d}else if(d&&d.$mid===7){const D=d,f=this.b.get(D.commentControlHandle);if(!f)return D;const E=f.getCommentThread(D.commentThreadHandle);return E?E.value:D}else if(d&&(d.$mid===9||d.$mid===8)){const D=this.b.get(d.thread.commentControlHandle);if(!D)return d;const f=D.getCommentThread(d.thread.commentThreadHandle);return f?d.$mid===8?f.value:{thread:f.value,text:d.text}:d}else if(d&&d.$mid===10){const D=this.b.get(d.thread.commentControlHandle);if(!D)return d;const f=D.getCommentThread(d.thread.commentThreadHandle);if(!f)return d;const E=d.commentUniqueId,w=f.getCommentByUniqueId(E);return w||d}else if(d&&d.$mid===11){const D=this.b.get(d.thread.commentControlHandle);if(!D)return d;const f=D.getCommentThread(d.thread.commentThreadHandle);if(!f)return d;const E=d.text,w=d.commentUniqueId,P=f.getCommentByUniqueId(w);return P?(typeof P.body=="string"?P.body=E:P.body=new N.$hN(E),P):d}return d}})}createCommentController(d,D,f){const E=n.a++,w=new c(d,E,D,f);this.b.set(w.handle,w);const P=this.c.get(d.identifier)||[];return P.push(w),this.c.set(d.identifier,P),w.value}async $createCommentThreadTemplate(d,D,f){const E=this.b.get(d);E&&E.$createCommentThreadTemplate(D,f)}async $setActiveComment(d,D){const f=this.b.get(d);f&&f.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(d,D,f){const E=this.b.get(d);E&&E.$updateCommentThreadTemplate(D,f)}$deleteCommentThread(d,D){this.b.get(d)?.$deleteCommentThread(D)}async $provideCommentingRanges(d,D,f){const E=this.b.get(d);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const w=await o.ensureDocumentData(M.URI.revive(D));return(0,I.$ih)(async()=>{const P=await E.commentingRangeProvider.provideCommentingRanges(w.document,f);let C;return Array.isArray(P)?C={ranges:P,fileComments:!1}:P?C={ranges:P.ranges||[],fileComments:P.fileComments||!1}:C=P??void 0,C}).then(P=>{let C;return P&&(C={ranges:P.ranges.map(V=>k.Range.from(V)),fileComments:P.fileComments}),C})}$toggleReaction(d,D,f,E,w){const P=this.b.get(d);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,I.$ih)(()=>{const C=P.getCommentThread(D);if(C){const V=C.getCommentByUniqueId(E.uniqueIdInThread);if(P!==void 0&&V&&P.reactionHandler)return P.reactionHandler(V,b(w))}return Promise.resolve(void 0)})}}class t{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,typeof d=="object"?((0,u.$yG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=d.resolved,this.b.applicability=d.applicability):this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,D,f,E,w,P,C,V){this.m=D,this.n=f,this.o=E,this.p=w,this.q=P,this.extensionDescription=C,this.r=V,this.handle=t.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$be,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Vc,this.l.value=new O.$Tc,this.n===void 0&&(this.n=`${d}.${this.handle}`),r.$createCommentThread(D,this.handle,this.n,this.o,k.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{r.$deleteCommentThread(D,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(q){W.range=q},get comments(){return W.comments},set comments(q){W.comments=q},get collapsibleState(){return W.collapsibleState},set collapsibleState(q){W.collapsibleState=q},get canReply(){return W.canReply},set canReply(q){W.canReply=q},get contextValue(){return W.contextValue},set contextValue(q){W.contextValue=q},get label(){return W.label},set label(q){W.label=q},get state(){return W.state},set state(q){W.state=q},dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Tc);const d=f=>Object.prototype.hasOwnProperty.call(this.b,f),D={};d("range")&&(D.range=k.Range.from(this.p)),d("label")&&(D.label=this.label),d("contextValue")&&(D.contextValue=this.contextValue??null),d("comments")&&(D.comments=this.q.map(f=>h(this,f,this.k,this.extensionDescription))),d("collapsibleState")&&(D.collapseState=a(this.g)),d("canReply")&&(D.canReply=this.canReply),d("state")&&(D.state=$(this.h)),d("applicability")&&(D.applicability=l(this.h)),d("isTemplate")&&(D.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(d){for(const D of this.k){const f=D[0],E=D[1];if(d===E)return f}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Je([(0,T.$Vh)(100)],t.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,d?.resourceHints&&(0,u.$yG)(this.h,"commentingRangeHint"),r.$updateCommentingRanges(this.handle,d?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,u.$yG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,u.$yG)(this.h,"activeComment"),this.f}constructor(d,D,f,E){this.h=d,this.i=D,this.j=f,this.k=E,this.a=new Map,r.$registerCommentController(this.handle,f,E,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(P){w.options=P},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(P){w.commentingRangeProvider=P},get reactionHandler(){return w.reactionHandler},set reactionHandler(P){w.reactionHandler=P},get activeCommentThread(){return w.activeCommentThread},createCommentThread(P,C,V){return w.createCommentThread(P,C,V).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(d,D,f){D===void 0&&(0,u.$yG)(this.h,"fileComments");const E=new t(this.id,this.handle,void 0,d,D,f,this.h,!1);return this.a.set(E.handle,E),E}$setActiveComment(d){if(!d){this.e=void 0,this.f=void 0;return}const D=this.a.get(d.commentThreadHandle);D&&(this.e=d.uniqueIdInThread?D.getCommentByUniqueId(d.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(d,D){const f=new t(this.id,this.handle,void 0,M.URI.revive(d),k.Range.to(D),[],this.h,!0);return f.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(d,D){const f=this.a.get(d);f&&(f.range=k.Range.to(D))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.g.forEach(d=>d.dispose())}}function h(S,d,D,f){let E=D.get(d);return E||(E=++S.commentHandle,D.set(d,E)),d.state!==void 0&&(0,u.$yG)(f,"commentsDraftState"),d.reactions?.some(w=>w.reactors!==void 0)&&(0,u.$yG)(f,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:E,body:typeof d.body=="string"?d.body:k.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(w=>i(w)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function i(S){return{label:S.label,iconPath:S.iconPath?k.$cP(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(d=>d.name):S.reactors}}function b(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?M.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(d=>({name:d}))}}function a(S){if(S!==void 0)switch(S){case N.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function $(S){let d;if(typeof S=="object"?d=S.resolved:d=S,d!==void 0)switch(d){case N.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function l(S){let d;if(typeof S=="object"&&(d=S.applicability),d!==void 0)switch(d){case N.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case N.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(Re[255],Ae([1,0,22,99,6,12,24,2,8,63,74,4,7]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=void 0;class v{constructor(b,a){this.document=b,this.b=a,this.a=1,this.c=new N.$fkc("custom documents")}addEdit(b){return this.c.add([b])}async undo(b,a){await this.f(b).undo(),a||this.disposeBackup()}async redo(b,a){await this.f(b).redo(),a||this.disposeBackup()}disposeEdits(b){for(const a of b)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const b=h(this.document.uri)+this.a++;return(0,M.$4g)(this.b,b)}updateBackup(b){this.d?.delete(),this.d=b}disposeBackup(){this.d?.delete(),this.d=void 0}f(b){const a=this.c.get(b,0);if(!a)throw new Error("No edit found");return a}}class m{constructor(){this.a=new Map}get(b,a){return this.a.get(this.b(b,a))}add(b,a,$){const l=this.b(b,a.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${b} resource:${a.uri}`);const S=new v(a,$);return this.a.set(l,S),S}delete(b,a){const $=this.b(b,a.uri);this.a.delete($)}b(b,a){return`${b}@@@${a}`}}var s;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(s||(s={}));class o{constructor(){this.a=new Map}addTextProvider(b,a,$){return this.b(0,b,a,$)}addCustomProvider(b,a,$){return this.b(1,b,a,$)}get(b){return this.a.get(b)}b(b,a,$,l){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:b,extension:$,provider:l}),new u.$SM(()=>this.a.delete(a))}}class r{constructor(b,a,$,l,S){this.d=a,this.f=$,this.g=l,this.h=S,this.b=new o,this.c=new m,this.a=b.getProxy(y.$QM.MainThreadCustomEditors)}registerCustomEditorProvider(b,a,$,l){const S=new R.$Tc;return t($)?(S.add(this.b.addTextProvider(a,b,$)),this.a.$registerTextEditorProvider((0,k.$Okc)(b),a,l.webviewOptions||{},{supportsMove:!!$.moveCustomTextEditor},(0,k.$Mkc)(b))):(S.add(this.b.addCustomProvider(a,b,$)),n($)&&S.add($.onDidChangeCustomDocument(d=>{const D=this.i(a,d.document.uri);if(c(d)){const f=D.addEdit(d);this.a.$onDidEdit(d.document.uri,a,f,d.label)}else this.a.$onContentChange(d.document.uri,a)})),this.a.$registerCustomEditorProvider((0,k.$Okc)(b),a,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,k.$Mkc)(b))),u.$SM.from(S,new u.$SM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(b,a,$,l,S){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${a}'`);const D=p.URI.revive(b),f=await d.provider.openCustomDocument(D,{backupId:$,untitledDocumentData:l?.buffer},S);let E;return n(d.provider)&&this.f&&(E=this.f.workspaceValue(d.extension)??this.f.globalValue(d.extension)),this.c.add(a,f,E),{editable:n(d.provider)}}async $disposeCustomDocument(b,a){const $=this.b.get(a);if(!$)throw new Error(`No provider found for '${a}'`);if($.type!==1)throw new Error(`Invalid provider type for '${a}'`);const l=p.URI.revive(b),{document:S}=this.i(a,l);this.c.delete(a,S),S.dispose()}async $resolveCustomEditor(b,a,$,l,S,d){const D=this.b.get($);if(!D)throw new Error(`No provider found for '${$}'`);const f=g.ViewColumn.to(S),E=this.g.createNewWebview(a,l.contentOptions,D.extension),w=this.h.createNewWebviewPanel(a,$,l.title,f,l.options,E,l.active),P=p.URI.revive(b);switch(D.type){case 1:{const{document:C}=this.i($,P);return D.provider.resolveCustomEditor(C,w,d)}case 0:{const C=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(C,w,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(b,a,$){this.i(a,b).disposeEdits($)}async $onMoveCustomEditor(b,a,$){const l=this.b.get($);if(!l)throw new Error(`No provider found for '${$}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${$}'`);const S=this.h.getWebviewPanel(b);if(!S)throw new Error("No webview found");const d=p.URI.revive(a),D=this.d.getDocument(d);await l.provider.moveCustomTextEditor(D,S,I.CancellationToken.None)}async $undo(b,a,$,l){return this.i(a,b).undo($,l)}async $redo(b,a,$,l){return this.i(a,b).redo($,l)}async $revert(b,a,$){const l=this.i(a,b);await this.j(a).revertCustomDocument(l.document,$),l.disposeBackup()}async $onSave(b,a,$){const l=this.i(a,b);await this.j(a).saveCustomDocument(l.document,$),l.disposeBackup()}async $onSaveAs(b,a,$,l){const S=this.i(a,b);return this.j(a).saveCustomDocumentAs(S.document,p.URI.revive($),l)}async $backup(b,a,$){const l=this.i(a,b),d=await this.j(a).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},$);return l.updateBackup(d),d.id}i(b,a){const $=this.c.get(b,p.URI.revive(a));if(!$)throw new Error("No custom document found");return $}j(b){const $=this.b.get(b)?.provider;if(!$||!n($))throw new Error("Custom document is not editable");return $}}e.$Rkc=r;function n(i){return!!i.onDidChangeCustomDocument}function t(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const b=i.scheme===O.Schemas.file||i.scheme===O.Schemas.untitled?i.fsPath:i.toString();return(0,T.$ej)(b)+""}}),define(Re[256],Ae([1,0,163,100,2,4,7,8,5,13,28,45]),function(ge,e,I,T,R,O,M,p,g,k,N,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=e.$mkc=void 0;class v{#e;#t;#i;constructor(o,r,n,t,c,h,i,b){this.d=o,this.e=r,this.f=n,this.g=t,this.h=c,this.c=!1,this.f=Math.max(t,n),this.#i=new N.$Bc(a=>h.getComparisonKey(a)),this.#e=i,this.#t=b}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,r){if(!o){this.clear();return}this.j();let n=[];if(R.URI.isUri(o)){if(!r){this.delete(o);return}this.#i.set(o,r.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(v.k);for(const i of o){const[b,a]=i;if((!h||b.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=b,n.push(b),this.#i.set(b,[])),a)this.#i.get(b)?.push(...a);else{const $=this.#i.get(b);$&&($.length=0)}}}if(this.#t.fire(n),!this.#e)return;const t=[];let c=0;for(const h of n){let i=[];const b=this.#i.get(h);if(b)if(b.length>this.g){i=[];const a=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let $=0;$<4;$++)for(const l of b)if(l.severity===a[$]&&i.push({...p.Diagnostic.from(l),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,I.localize)(0,null,b.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=b.map(a=>({...p.Diagnostic.from(a),modelVersionId:this.h(h)}));if(t.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,t)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,r){this.j();for(const[n,t]of this)o.call(r,n,t,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const r=this.#i.get(o);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,r){return o[0].toString()<r[0].toString()?-1:o[0].toString()>r[0].toString()?1:0}}e.$mkc=v;let m=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const r=new N.$Bc;for(const n of o)r.set(n,n);return{uris:Object.freeze(Array.from(r.values()))}}constructor(o,r,n,t){this.j=r,this.k=n,this.l=t,this.g=new Map,this.h=new g.$fe({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,u._mapper),this.f=o.getProxy(O.$QM.MainThreadDiagnostics)}createDiagnosticCollection(o,r){const{g:n,f:t,h:c,j:h,k:i,l:b}=this,a=new class{$changeMany(S,d){t.$changeMany(S,d),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,S,d.length===0?"CLEARING":d)}$clear(S){t.$clear(S),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,S)}dispose(){t.dispose()}};let $;if(!r)r="_generated_diagnostic_collection_name_#"+u.c++,$=r;else if(!n.has(r))$=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do $=r+u.c++;while(n.has($))}return new class extends v{constructor(){super(r,$,u.e,u.d,S=>b.getDocument(S)?.version,i.extUri,a,c),n.set($,this)}dispose(){super.dispose(),n.delete($)}}}getDiagnostics(o){if(o)return this.m(o);{const r=new Map,n=[];for(const t of this.g.values())t.forEach((c,h)=>{let i=r.get(c.toString());typeof i>"u"&&(i=n.length,r.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...h)});return n}}m(o){let r=[];for(const n of this.g.values())n.has(o)&&(r=r.concat(n.get(o)));return r}$acceptMarkersChange(o){if(!this.n){const r="_generated_mirror",n=new v(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(r,n),this.n=n}for(const[r,n]of o)this.n.set(R.URI.revive(r),n.map(p.Diagnostic.to))}};e.$nkc=m,e.$nkc=m=u=Je([Ve(1,k.$Wj),Ve(2,y.$lkc)],m)}),define(Re[257],Ae([1,0,2,14,7,8,192,34]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class g{constructor(N,y,u,v={timeout:1500,errors:3}){this.c=N,this.d=y,this.f=u,this.g=v,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(N){return(y,u,v)=>{const s={dispose:this.a.push([y,u,N])};return Array.isArray(v)&&v.push(s),s}}async $participateInSave(N,y){const u=I.URI.revive(N);let v=!1;const m=setTimeout(()=>v=!0,this.g.timeout),s=[];try{for(const o of[...this.a]){if(v)break;const r=this.d.getDocument(u),n=await this.h(o,{document:r,reason:O.TextDocumentSaveReason.to(y)});s.push(n)}}finally{clearTimeout(m)}return s}h([N,y,u],v){const m=this.b.get(N);return typeof m=="number"&&m>this.g.errors?Promise.resolve(!1):this.i(u,N,y,v).then(()=>!0,s=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const o=this.b.get(N);this.b.set(N,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(N,y,u,v){const m=[],s=Date.now(),{document:o,reason:r}=v,{version:n}=o,t=Object.freeze({document:o,reason:r,waitUntil(c){if(Object.isFrozen(m))throw(0,T.$8)("waitUntil can not be called async");m.push(Promise.resolve(c))}});try{y.apply(u,[t])}catch(c){return Promise.reject(c)}return Object.freeze(m),new Promise((c,h)=>{const i=setTimeout(()=>h(new Error("timeout")),this.g.timeout);return Promise.all(m).then(b=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${N.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(i),c(b)}).catch(b=>{clearTimeout(i),h(b)})}).then(c=>{const h={edits:[]};for(const i of c)if(Array.isArray(i)&&i.every(b=>b instanceof R.$ZM))for(const{newText:b,newEol:a,range:$}of i)h.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:$&&O.Range.from($),text:b,eol:a&&O.EndOfLine.from(a)}});if(h.edits.length!==0)return n===o.version?this.f.$tryApplyWorkspaceEdit(new p.$mw(h)):Promise.reject(new Error("concurrent_edits"))})}}e.$vlc=g}),define(Re[258],Ae([1,0,5,6,2,4,111,8,17,26,7]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=void 0;class y{constructor(v,m){this.a=new I.$be,this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Tc,this.h=new Map,this.f=v.getProxy(O.$QM.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const m=this.g.getDocument(v);if(m)return m}getDocument(v){const m=this.getDocumentData(v);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return m.document}ensureDocumentData(v){const m=this.g.getDocument(v);if(m)return Promise.resolve(m);let s=this.h.get(v.toString());return s||(s=this.f.$tryOpenDocument(v).then(o=>{this.h.delete(v.toString());const r=R.URI.revive(o);return(0,g.$cg)(this.g.getDocument(r))},o=>(this.h.delete(v.toString()),Promise.reject(o))),this.h.set(v.toString(),s)),s}createDocumentData(v){return this.f.$tryCreateDocument(v).then(m=>R.URI.revive(m))}$acceptModelLanguageChanged(v,m){const s=R.URI.revive(v),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(m),this.a.fire(o.document)}$acceptModelSaved(v){const m=R.URI.revive(v),s=this.g.getDocument(m);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(v,m){const s=R.URI.revive(v),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,m,s){const o=R.URI.revive(v),r=this.g.getDocument(o);if(!r)throw new Error("unknown document");r._acceptIsDirty(s),r.onEvents(m);let n;m.isUndoing?n=N.TextDocumentChangeReason.Undo:m.isRedoing&&(n=N.TextDocumentChangeReason.Redo),this.c.fire((0,k.$Xn)({document:r.document,contentChanges:m.changes.map(t=>({range:p.Range.to(t.range),rangeOffset:t.rangeOffset,rangeLength:t.rangeLength,text:t.text})),reason:n}))}setWordDefinitionFor(v,m){(0,M.$fP)(v,m)}}e.$okc=y}),define(Re[66],Ae([1,0,259,5,17,2,3,4,16,8,7]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=e.$Skc=void 0,e.$Skc=(0,M.$qi)("IExtHostEditorTabs");class y{constructor(o,r,n){this.e=n,this.d=r,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,r={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new N.$CO(O.URI.revive(this.b.input.uri));case 2:return new N.$DO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case 3:return new N.$EO(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case 6:return new N.$FO(O.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new N.$GO(this.b.input.viewType);case 4:return new N.$HO(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new N.$IO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new N.$JO;case 9:return new N.$KO(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case 10:return new N.$LO;case 11:return new N.$MO(this.b.input.diffEditors.map(o=>new N.$DO(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class u{constructor(o,r){this.c=[],this.d="",this.b=o,this.e=r;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new y(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,r={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return k.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const r=this.c.find(n=>n.tabId===o.tabDto.id);if(!r)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(o.tabDto),r}activeTabId(){return this.d}}let v=class{constructor(o){this.b=new T.$be,this.c=new T.$be,this.e=[],this.a=o.getProxy(p.$QM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,r={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,R.$cg)(o.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,t)=>{const c=Array.isArray(n)?n:[n];return c.length?m(c[0])?this.j(c,t):this.i(c,t):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(o){const r=new Set(this.e.map(a=>a.groupId)),n=new Set(o.map(a=>a.groupId)),t=(0,I.$L)(r,n),c=this.e.filter(a=>t.removed.includes(a.groupId)).map(a=>a.apiObject),h=[],i=[];this.e=o.map(a=>{const $=new u(a,()=>this.d);return t.added.includes($.groupId)?h.push($.apiObject):i.push($.apiObject),$});const b=(0,R.$cg)(o.find(a=>a.isActive===!0)?.groupId);b!==void 0&&this.d!==b&&(this.d=b),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const r=this.e.find(n=>n.groupId===o.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const r=this.e.find(t=>t.groupId===o.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const n=r.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const r of this.e)for(const n of r.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(r=>r.apiObject===o)}async i(o,r){const n=[];for(const t of o){const c=this.g(t);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,r)}async j(o,r){const n=[];for(const t of o){const c=this.h(t);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,r)}};e.$Tkc=v,e.$Tkc=v=Je([Ve(0,g.$dP)],v);function m(s){return s.tabs!==void 0}}),define(Re[260],Ae([1,0,2,4,6,7,8,303,15,23,25,54]),function(ge,e,I,T,R,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class u{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const o=this.a.indexOf(s);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),o=[];let r,n,t=14,c=14;for(const h of s){let i=r?(0,g.$vf)(r,h):0;for(i===0?n=1:n=c;i<h.length;i++)i+1===h.length?(t=c,c=9):c+=1,o.push([n,h.toUpperCase().charCodeAt(i),c]),o.push([n,h.toLowerCase().charCodeAt(i),c]),n=c;r=h,c=t}o.push([9,58,10]),o.push([10,47,12]),this.b=new p.$42(o)}}provideDocumentLinks(s){this.c();const o=[],r=p.$52.computeLinks({getLineContent(n){return s.lineAt(n-1).text},getLineCount(){return s.lineCount}},this.b);for(const n of r){const t=M.DocumentLink.to(n);t.target&&o.push(t)}return o}}class v{constructor(s,o){this.i=o,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(T.$QM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,o,r,n={}){if(v.j(r),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const t=this.h++;this.b.add(o),this.d.add(o),this.c.set(t,r);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof r.copy=="function"&&(c+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,N.$yG)(s,"fsChunks"),c+=4);let h;n.isReadonly&&(0,y.$Pk)(n.isReadonly)&&n.isReadonly.value!==""&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,o,c,h).catch(b=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${o}`),console.error(b)});const i=r.onDidChangeFile(b=>{const a=[];for(const $ of b){const{uri:l,type:S}=$;if(l.scheme!==o)continue;let d;switch(S){case O.FileChangeType.Changed:d=0;break;case O.FileChangeType.Created:d=1;break;case O.FileChangeType.Deleted:d=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:l,type:d})}this.a.$onFileSystemChange(t,a)});return(0,R.$Sc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:o,ctime:r,mtime:n,size:t,permissions:c}=s;return{type:o,ctime:r,mtime:n,size:t,permissions:c}}$stat(s,o){return Promise.resolve(this.l(s).stat(I.URI.revive(o))).then(r=>v.k(r))}$readdir(s,o){return Promise.resolve(this.l(s).readDirectory(I.URI.revive(o)))}$readFile(s,o){return Promise.resolve(this.l(s).readFile(I.URI.revive(o))).then(r=>k.$Ce.wrap(r))}$writeFile(s,o,r,n){return Promise.resolve(this.l(s).writeFile(I.URI.revive(o),r.buffer,n))}$delete(s,o,r){return Promise.resolve(this.l(s).delete(I.URI.revive(o),r))}$rename(s,o,r,n){return Promise.resolve(this.l(s).rename(I.URI.revive(o),I.URI.revive(r),n))}$copy(s,o,r,n){const t=this.l(s);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(I.URI.revive(o),I.URI.revive(r),n))}$mkdir(s,o){return Promise.resolve(this.l(s).createDirectory(I.URI.revive(o)))}$watch(s,o,r,n){const t=this.l(s).watch(I.URI.revive(r),n);this.f.set(o,t)}$unwatch(s,o){const r=this.f.get(o);r&&(r.dispose(),this.f.delete(o))}$open(s,o,r){const n=this.l(s);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(I.URI.revive(o),r))}$close(s,o){const r=this.l(s);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(o))}$read(s,o,r,n){const t=this.l(s);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const c=k.$Ce.alloc(n);return Promise.resolve(t.read(o,r,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(s,o,r,n){const t=this.l(s);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(o,r,n.buffer,0,n.byteLength))}l(s){const o=this.c.get(s);if(!o){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return o}}e.$xlc=v}),define(Re[261],Ae([1,0,5,36,2,4,8,7,41]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,m,s,o,r,n){this.a=Math.random(),this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const t=(0,T.$kk)(r),c=typeof r=="string",h=n?.correlate,i=o(b=>{if(!(typeof b.session=="number"&&b.session!==this.a)&&!(h&&typeof b.session>"u")){if(!n?.ignoreCreateEvents)for(const a of b.created){const $=R.URI.revive(a);t($.fsPath)&&(!c||m.getWorkspaceFolder($))&&this.b.fire($)}if(!n?.ignoreChangeEvents)for(const a of b.changed){const $=R.URI.revive(a);t($.fsPath)&&(!c||m.getWorkspaceFolder($))&&this.c.fire($)}if(!n?.ignoreDeleteEvents)for(const a of b.deleted){const $=R.URI.revive(a);t($.fsPath)&&(!c||m.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=p.$SM.from(this.i(v,s,r,n,n?.correlate),this.b,this.c,this.d,i)}i(v,m,s,o,r){const n=p.$SM.from();if(typeof s=="string")return n;const t=v.getProxy(O.$QM.MainThreadFileSystemEventService);let c=!1;return(s.pattern.includes(T.$gk)||s.pattern.includes(T.$hk))&&(c=!0),t.$watch(m.identifier.value,this.a,s.baseUri,{recursive:c,excludes:o?.excludes??[]},!!r),p.$SM.from({dispose:()=>t.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class N{constructor(v){this.a=v,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(R.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class y{constructor(v,m,s){this.j=v,this.k=m,this.l=s,this.a=new I.$be,this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.g=new I.$de,this.h=new I.$de,this.i=new I.$de,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,m,s,o){return new k(this.j,v,m,this.a.event,M.GlobPattern.from(s),o)}$onFileEvent(v){this.a.fire(new N(v))}$onDidRunFileOperation(v,m){switch(v){case 2:this.b.fire(Object.freeze({files:m.map(s=>({oldUri:R.URI.revive(s.source),newUri:R.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(s=>R.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(s=>R.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,m){return(s,o,r)=>{const n=function(c){s.call(o,c)};return n.extension=v,m.event(n,void 0,r)}}async $onWillRunFileOperation(v,m,s,o){switch(v){case 2:return await this.n(this.g,{files:m.map(r=>({oldUri:R.URI.revive(r.source),newUri:R.URI.revive(r.target)}))},s,o);case 1:return await this.n(this.i,{files:m.map(r=>R.URI.revive(r.target))},s,o);case 0:case 3:return await this.n(this.h,{files:m.map(r=>R.URI.revive(r.target))},s,o)}}async n(v,m,s,o){const r=new Set,n=[];if(await v.fireAsync(m,o,async(c,h)=>{const i=Date.now(),b=await Promise.resolve(c);b instanceof p.$3M&&(n.push([h.extension,b]),r.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>s&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const t={edits:[]};for(const[,c]of n){const{edits:h}=M.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});t.edits=t.edits.concat(h)}return{edit:t,extensionNames:Array.from(r)}}}e.$ylc=y}),define(Re[262],Ae([1,0,18,11,22,14,90,6,26,65,15,17,2,29,304,87,97,165,20,8,7,25,74,4]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=void 0;class a{constructor(z,L){this.d=z,this.e=L}async provideDocumentSymbols(z,L){const G=this.d.getDocument(z),H=await this.e.provideDocumentSymbols(G,L);if(!(0,I.$Kb)(H))return H[0]instanceof c.$_M?H.map(t.DocumentSymbol.from):a.f(H)}static f(z){z=z.slice(0).sort((H,ee)=>{let re=H.location.range.start.compareTo(ee.location.range.start);return re===0&&(re=ee.location.range.end.compareTo(H.location.range.end)),re});const L=[],G=[];for(const H of z){const ee={name:H.name||"!!MISSING: name!!",kind:t.SymbolKind.from(H.kind),tags:H.tags?.map(t.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:t.Range.from(H.location.range),selectionRange:t.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),L.push(ee);break}const re=G[G.length-1];if(v.$kt.containsRange(re.range,ee.range)&&!v.$kt.equalsRange(re.range,ee.range)){re.children?.push(ee),G.push(ee);break}G.pop()}}return L}}class ${constructor(z,L,G,H,ee,re){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.l=re,this.d=new i.$fkc("CodeLens"),this.e=new Map}async provideCodeLenses(z,L){const G=this.f.getDocument(z),H=await this.h.provideCodeLenses(G,L);if(!H||L.isCancellationRequested)return;const ee=this.d.add(H),re=new p.$Tc;this.e.set(ee,re);const Ne={cacheId:ee,lenses:[]};for(let Be=0;Be<H.length;Be++)Ne.lenses.push({cacheId:[ee,Be],range:t.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,re)});return Ne}async resolveCodeLens(z,L){const G=z.cacheId&&this.d.get(...z.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,L),H||(H=G),L.isCancellationRequested)return;const ee=z.cacheId&&this.e.get(z.cacheId[0]);if(ee){if(!H.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return z.command=this.g.toInternal(H.command,ee),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function l(ze){return Array.isArray(ze)?ze.map(t.DefinitionLink.from):ze?[t.DefinitionLink.from(ze)]:[]}class S{constructor(z,L){this.d=z,this.e=L}async provideDefinition(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideDefinition(H,ee,G);return l(re)}}class d{constructor(z,L){this.d=z,this.e=L}async provideDeclaration(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideDeclaration(H,ee,G);return l(re)}}class D{constructor(z,L){this.d=z,this.e=L}async provideImplementation(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideImplementation(H,ee,G);return l(re)}}class f{constructor(z,L){this.d=z,this.e=L}async provideTypeDefinition(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideTypeDefinition(H,ee,G);return l(re)}}class E{constructor(z,L){this.d=z,this.e=L}async provideHover(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideHover(H,ee,G);if(!(!re||(0,I.$Kb)(re.contents)))return re.range||(re.range=H.getWordRangeAtPosition(ee)),re.range||(re.range=new c.$UM(ee,ee)),t.Hover.from(re)}}class w{constructor(z,L){this.d=z,this.e=L}async provideEvaluatableExpression(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideEvaluatableExpression(H,ee,G);if(re)return t.EvaluatableExpression.from(re)}}class P{constructor(z,L){this.d=z,this.e=L}async provideInlineValues(z,L,G,H){const ee=this.d.getDocument(z),re=await this.e.provideInlineValues(ee,t.Range.to(L),t.InlineValueContext.to(G),H);if(Array.isArray(re))return re.map(Ne=>t.InlineValue.from(Ne))}}class C{constructor(z,L){this.d=z,this.e=L}async provideDocumentHighlights(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideDocumentHighlights(H,ee,G);if(Array.isArray(re))return re.map(t.DocumentHighlight.from)}}class V{constructor(z,L){this.d=z,this.e=L}async provideMultiDocumentHighlights(z,L,G,H){const ee=this.d.getDocument(z),re=G.map(Qe=>this.d.getDocument(Qe)),Ne=t.Position.to(L),Be=await this.e.provideMultiDocumentHighlights(ee,Ne,re,H);if(Array.isArray(Be))return Be.map(t.MultiDocumentHighlight.from)}}class W{constructor(z,L){this.d=z,this.e=L}async provideLinkedEditingRanges(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideLinkedEditingRanges(H,ee,G);if(re&&Array.isArray(re.ranges))return{ranges:(0,I.$Hb)(re.ranges.map(t.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(z,L){this.d=z,this.e=L}async provideReferences(z,L,G,H){const ee=this.d.getDocument(z),re=t.Position.to(L),Ne=await this.e.provideReferences(ee,re,G,H);if(Array.isArray(Ne))return Ne.map(t.location.from)}}class A{static{this.d=1e3}constructor(z,L,G,H,ee,re,Ne){this.g=z,this.h=L,this.j=G,this.k=H,this.l=ee,this.m=re,this.n=Ne,this.e=new i.$fkc("CodeAction"),this.f=new Map}async provideCodeActions(z,L,G,H){const ee=this.g.getDocument(z),re=m.$mt.isISelection(L)?t.Selection.to(L):t.Range.to(L),Ne=[];for(const it of this.j.getDiagnostics(z))if(re.intersection(it.range)&&Ne.push(it)>A.d)break;const Be={diagnostics:Ne,only:G.only?new c.$bN(G.only):void 0,triggerKind:t.CodeActionTriggerKind.to(G.trigger)},Qe=await this.k.provideCodeActions(ee,re,Be,H);if(!(0,I.$Lb)(Qe)||H.isCancellationRequested)return;const _e=this.e.add(Qe),et=new p.$Tc;this.f.set(_e,et);const tt=[];for(let it=0;it<Qe.length;it++){const nt=Qe[it];if(nt)if(A.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,et)});else{Be.only&&(nt.kind?Be.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=nt.ranges??[];tt.push({cacheId:[_e,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,et),diagnostics:nt.diagnostics&&nt.diagnostics.map(t.Diagnostic.from),edit:nt.edit&&t.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,h.$xG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,h.$xG)(this.m,"codeActionRanges")?(0,I.$Hb)(at.map(t.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:_e,actions:tt}}async resolveCodeAction(z,L){const[G,H]=z,ee=this.e.get(G,H);if(!ee||A.o(ee))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(ee,L)??ee;let Ne;re.edit&&(Ne=t.WorkspaceEdit.from(re.edit,void 0));let Be;if(re.command){const Qe=this.f.get(G);Qe&&(Be=this.h.toInternal(re.command,Qe))}return{edit:Ne,command:Be}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class U{constructor(z,L,G,H,ee){this.e=z,this.f=L,this.g=G,this.h=H,this.j=ee,this.d=new i.$fkc("DocumentPasteEdit")}async prepareDocumentPaste(z,L,G,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(z),re=L.map(Qe=>t.Range.to(Qe)),Ne=t.DataTransfer.toDataTransfer(G,()=>{throw new O.$$});if(await this.g.prepareDocumentPaste(ee,re,Ne,H),H.isCancellationRequested)return;const Be=Array.from(Ne).filter(([,Qe])=>!(Qe instanceof c.$HN));return t.DataTransfer.from(Be)}async providePasteEdits(z,L,G,H,ee,re){if(!this.g.provideDocumentPasteEdits)return[];const Ne=this.f.getDocument(L),Be=G.map(tt=>t.Range.to(tt)),Qe=t.DataTransfer.toDataTransfer(H,async tt=>(await this.e.$resolvePasteFileData(this.h,z,tt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ne,Be,Qe,{only:ee.only?new c.$MN(ee.only):void 0,triggerKind:ee.triggerKind},re);if(!_e||re.isCancellationRequested)return[];const et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,r.localize)(0,null,this.j.displayName||this.j.name),kind:tt.kind,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?t.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,L){const[G,H]=z,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(ee,L)??ee;return{additionalEdit:re.additionalEdit?t.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class K{constructor(z,L){this.d=z,this.e=L}async provideDocumentFormattingEdits(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideDocumentFormattingEdits(H,L,G);if(Array.isArray(ee))return ee.map(t.TextEdit.from)}}class se{constructor(z,L){this.d=z,this.e=L}async provideDocumentRangeFormattingEdits(z,L,G,H){const ee=this.d.getDocument(z),re=t.Range.to(L),Ne=await this.e.provideDocumentRangeFormattingEdits(ee,re,G,H);if(Array.isArray(Ne))return Ne.map(t.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,L,G,H){(0,y.$bg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(z),re=L.map(t.Range.to),Ne=await this.e.provideDocumentRangesFormattingEdits(ee,re,G,H);if(Array.isArray(Ne))return Ne.map(t.TextEdit.from)}}class ce{constructor(z,L){this.d=z,this.e=L,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,L,G,H,ee){const re=this.d.getDocument(z),Ne=t.Position.to(L),Be=await this.e.provideOnTypeFormattingEdits(re,Ne,G,H,ee);if(Array.isArray(Be))return Be.map(t.TextEdit.from)}}class ve{constructor(z,L){this.e=z,this.f=L,this.d=new i.$fkc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,L){const G=await this.e.provideWorkspaceSymbols(z,L);if(!(0,I.$Lb)(G))return{symbols:[]};const H=this.d.add(G),ee={cacheId:H,symbols:[]};for(let re=0;re<G.length;re++){const Ne=G[re];if(!Ne||!Ne.name){this.f.warn("INVALID SymbolInformation",Ne);continue}ee.symbols.push({...t.WorkspaceSymbol.from(Ne),cacheId:[H,re]})}return ee}async resolveWorkspaceSymbol(z,L){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const G=this.d.get(...z.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,L);return H&&(0,g.$Zn)(z,t.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class Ie{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideRenameEdits(z,L,G,H){const ee=this.d.getDocument(z),re=t.Position.to(L);try{const Ne=await this.e.provideRenameEdits(ee,re,G,H);return Ne?t.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Be=Ie.g(Ne);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(z,L,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(z),ee=t.Position.to(L);try{const re=await this.e.prepareRename(H,ee,G);let Ne,Be;if(c.$UM.isRange(re)?(Ne=re,Be=H.getText(re)):(0,y.$6f)(re)&&(Ne=re.range,Be=re.placeholder),!Ne||!Be)return;if(Ne.start.line>ee.line||Ne.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:t.Range.from(Ne),text:Be}}catch(re){const Ne=Ie.g(re);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(re)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ue{constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideNewSymbolNames(z,L,G){const H=this.d.getDocument(z),ee=t.Range.to(L);try{const re=await this.e.provideNewSymbolNames(H,ee,G);return re?re.map(Ne=>typeof Ne=="string"?{newSymbolName:Ne}:{newSymbolName:Ne.newSymbolName,tags:Ne.tags}):void 0}catch(re){this.f.error(ue.g(re)??JSON.stringify(re,null,"	"));return}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class be{constructor(z,L){this.resultId=z,this.tokens=L}}class ie{constructor(z,L){this.f=z,this.g=L,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,L,G){const H=this.f.getDocument(z),ee=L!==0?this.d.get(L):null;let re=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ee&&this.d.delete(L),re?(re=ie.h(re),this.o(ie.n(ee,re),re)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return ie.j(z)?ie.k(z)?z:new c.$aO(new Uint32Array(z.data),z.resultId):ie.l(z)?ie.m(z)?z:new c.$cO(z.edits.map(L=>new c.$bO(L.start,L.deleteCount,L.data?new Uint32Array(L.data):L.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const L of z.edits)if(!(L.data instanceof Uint32Array))return!1;return!0}static n(z,L){if(!ie.j(L)||!z||!z.tokens)return L;const G=z.tokens,H=G.length,ee=L.data,re=ee.length;let Ne=0;const Be=Math.min(H,re);for(;Ne<Be&&G[Ne]===ee[Ne];)Ne++;if(Ne===H&&Ne===re)return new c.$cO([],L.resultId);let Qe=0;const _e=Be-Ne;for(;Qe<_e&&G[H-Qe-1]===ee[re-Qe-1];)Qe++;return new c.$cO([{start:Ne,deleteCount:H-Ne-Qe,data:ee.subarray(Ne,re-Qe)}],L.resultId)}o(z,L){if(ie.j(z)){const G=this.e++;return this.d.set(G,new be(z.resultId,z.data)),(0,o.$wbb)({id:G,type:"full",data:z.data})}if(ie.l(z)){const G=this.e++;return ie.j(L)?this.d.set(G,new be(L.resultId,L.data)):this.d.set(G,new be(z.resultId)),(0,o.$wbb)({id:G,type:"delta",deltas:(z.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class Ce{constructor(z,L){this.d=z,this.e=L}async provideDocumentRangeSemanticTokens(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideDocumentRangeSemanticTokens(H,t.Range.to(L),G);return ee?this.f(ee):null}f(z){return(0,o.$wbb)({id:0,type:"full",data:z.data})}}class Fe{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,L,G,H,ee){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.d=new i.$fkc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,L,G,H){const ee=this.f.getDocument(z),re=t.Position.to(L),Ne=ee.getWordRangeAtPosition(re)||new c.$UM(re,re),Be=Ne.with({end:re}),Qe=new k.$0d,_e=await this.h.provideCompletionItems(ee,re,H,t.CompletionContext.to(G));if(!_e||H.isCancellationRequested)return;const et=Array.isArray(_e)?new c.$oN(_e):_e,tt=Fe.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),it=new p.$Tc;this.e.set(tt,it);const nt=[],at={x:tt,b:nt,a:{replace:t.Range.from(Ne),insert:t.Range.from(Be)},c:et.isIncomplete||void 0,d:Qe.elapsed()};for(let mt=0;mt<et.items.length;mt++){const je=et.items[mt],st=this.l(je,[tt,mt],Be,Ne);nt.push(st)}return at}async resolveCompletionItem(z,L){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...z);if(!G)return;const H=this.l(G,z),ee=await this.h.resolveCompletionItem(G,L);if(!ee)return;const re=this.l(ee,z);return(H.h!==re.h||H.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==re.n||H.o!==re.o||!(0,g.$1n)(H.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,L,G,H){const ee=this.e.get(L[0]);if(!ee)throw Error("DisposableStore is missing...");const re=this.g.toInternal(z.command,ee),Ne={x:L,a:z.label,b:z.kind!==void 0?t.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(t.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:t.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(t.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne.h=z.textEdit.newText):typeof z.insertText=="string"?Ne.h=z.insertText:z.insertText instanceof c.$4M&&(Ne.h=z.insertText.value,Ne.i|=4);let Be;return z.textEdit?Be=z.textEdit.range:z.range&&(Be=z.range),c.$UM.isRange(Be)?Ne.j=t.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Ne.j={insert:t.Range.from(Be.inserting),replace:t.Range.from(Be.replacing)}),Ne}}class ne{async provideInlineCompletions(z,L,G,H){}disposeCompletions(z){}handleDidShowCompletionItem(z,L,G){}handlePartialAccept(z,L,G,H){}}class j extends ne{constructor(z,L,G,H){super(),this.f=z,this.g=L,this.h=G,this.j=H,this.d=new pe,this.e=(0,h.$xG)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$xG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,L,G,H){const ee=this.g.getDocument(z),re=t.Position.to(L),Ne=await this.h.provideInlineCompletionItems(ee,re,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:t.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Ne||H.isCancellationRequested)return;const Be=Array.isArray(Ne)?Ne:Ne.items,Qe=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],_e=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Be}),items:Be.map((it,nt)=>{let at;it.command&&(et||(et=new p.$Tc),at=this.j.toInternal(it.command,et));const mt=it.insertText;return{insertText:typeof mt=="string"?mt:{snippet:mt.value},filterText:it.filterText,range:it.range?t.Range.from(it.range):void 0,command:at,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Qe.map(it=>(et||(et=new p.$Tc),this.j.toInternal(it,et))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,L,G){const H=this.d.get(z)?.items[L];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(z,L,G,H){const ee=this.d.get(z)?.items[L];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,t.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(z,L,G){const H=this.f.getDocument(z),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[L.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let re;const Ne=this.d.createReferenceId({dispose(){re?.dispose()},item:ee});let Be;ee.accepted&&(re||(re=new p.$Tc),Be=this.h.toInternal(ee.accepted,re));let Qe;return ee.rejected&&(re||(re=new p.$Tc),Qe=this.h.toInternal(ee.rejected,re)),{pid:Ne,text:ee.text,range:t.Range.from(ee.range),accepted:Be,rejected:Qe}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,L,G,H){this.f=L,this.g=G,this.h=H,this.d=new pe,this.e={[s.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class pe{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const L=this.e++;return this.d.set(L,z),L}disposeReferenceId(z){const L=this.d.get(z);return this.d.delete(z),L}get(z){return this.d.get(z)}}class Oe{constructor(z,L){this.e=z,this.f=L,this.d=new i.$fkc("SignatureHelp")}async provideSignatureHelp(z,L,G,H){const ee=this.e.getDocument(z),re=t.Position.to(L),Ne=this.g(G),Be=await this.f.provideSignatureHelp(ee,re,H,Ne);if(Be){const Qe=this.d.add([Be]);return{...t.SignatureHelp.from(Be),id:Qe}}}g(z){let L;if(z.activeSignatureHelp){const G=t.SignatureHelp.to(z.activeSignatureHelp),H=this.d.get(z.activeSignatureHelp.id,0);H?(L=H,L.activeSignature=G.activeSignature,L.activeParameter=G.activeParameter):L=G}return{...z,activeSignatureHelp:L}}releaseSignatureHelp(z){this.d.delete(z)}}class ke{constructor(z,L,G,H,ee){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.d=new i.$fkc("InlayHints"),this.e=new Map}async provideInlayHints(z,L,G){const H=this.f.getDocument(z),ee=t.Range.to(L),re=await this.h.provideInlayHints(H,ee,G);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`);return}if(G.isCancellationRequested)return;const Ne=this.d.add(re);this.e.set(Ne,new p.$Tc);const Be={hints:[],cacheId:Ne};for(let Qe=0;Qe<re.length;Qe++)this.l(re[Qe],ee)&&Be.hints.push(this.m(re[Qe],[Ne,Qe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`),Be}async resolveInlayHint(z,L){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...z);if(!G)return;const H=await this.h.resolveInlayHint(G,L);if(H&&this.l(H))return this.m(H,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,L){return z.label.length===0||Array.isArray(z.label)&&z.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(L&&!L.contains(z.position))}m(z,L){const G=this.e.get(L[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:L,tooltip:t.MarkdownString.fromStrict(z.tooltip),position:t.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(t.TextEdit.from),kind:z.kind&&t.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")H.label=z.label;else{const ee=[];H.label=ee;for(const re of z.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ne={label:re.value,tooltip:t.MarkdownString.fromStrict(re.tooltip)};c.$5M.isLocation(re.location)&&(Ne.location=t.location.from(re.location)),re.command&&(Ne.command=this.g.toInternal(re.command,G)),ee.push(Ne)}}return H}}class $e{constructor(z,L){this.e=z,this.f=L,this.d=new i.$fkc("DocumentLink")}async provideLinks(z,L){const G=this.e.getDocument(z),H=await this.f.provideDocumentLinks(G,L);if(!(!Array.isArray(H)||H.length===0)&&!L.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter($e.g).map(t.DocumentLink.from)};{const ee=this.d.add(H),re={links:[],cacheId:ee};for(let Ne=0;Ne<H.length;Ne++){if(!$e.g(H[Ne]))continue;const Be=t.DocumentLink.from(H[Ne]);Be.cacheId=[ee,Ne],re.links.push(Be)}return re}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,L){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...z);if(!G)return;const H=await this.f.resolveDocumentLink(G,L);if(!(!H||!$e.g(H)))return t.DocumentLink.from(H)}releaseLinks(z){this.d.delete(z)}}class fe{constructor(z,L){this.d=z,this.e=L}async provideColors(z,L){const G=this.d.getDocument(z),H=await this.e.provideDocumentColors(G,L);return Array.isArray(H)?H.map(re=>({color:t.Color.from(re.color),range:t.Range.from(re.range)})):[]}async provideColorPresentations(z,L,G){const H=this.d.getDocument(z),ee=t.Range.to(L.range),re=t.Color.to(L.color),Ne=await this.e.provideColorPresentations(re,{document:H,range:ee},G);if(Array.isArray(Ne))return Ne.map(t.ColorPresentation.from)}}class J{constructor(z,L){this.d=z,this.e=L}async provideFoldingRanges(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideFoldingRanges(H,L,G);if(Array.isArray(ee))return ee.map(t.FoldingRange.from)}}class Y{constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideSelectionRanges(z,L,G){const H=this.d.getDocument(z),ee=L.map(t.Position.to),re=await this.e.provideSelectionRanges(H,ee,G);if(!(0,I.$Lb)(re))return[];if(re.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Be=0;Be<ee.length;Be++){const Qe=[];Ne.push(Qe);let _e=ee[Be],et=re[Be];for(;;){if(!et.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(t.SelectionRange.from(et)),!et.parent)break;_e=et.range,et=et.parent}}return Ne}}class he{constructor(z,L){this.f=z,this.g=L,this.d=new M.$iP(""),this.e=new Map}async prepareSession(z,L,G){const H=this.f.getDocument(z),ee=t.Position.to(L),re=await this.g.prepareCallHierarchy(H,ee,G);if(!re)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(re)?re.map(Be=>this.h(Ne,Be)):[this.h(Ne,re)]}async provideCallsTo(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ee)return ee.map(re=>({from:this.h(z,re.from),fromRanges:re.fromRanges.map(Ne=>t.Range.from(Ne))}))}async provideCallsFrom(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ee)return ee.map(re=>({to:this.h(z,re.to),fromRanges:re.fromRanges.map(Ne=>t.Range.from(Ne))}))}releaseSession(z){this.e.delete(z)}h(z,L){const G=this.e.get(z),H=t.CallHierarchyItem.from(L,z,G.size.toString(36));return G.set(H._itemId,L),H}j(z,L){return this.e.get(z)?.get(L)}}class le{constructor(z,L){this.f=z,this.g=L,this.d=new M.$iP(""),this.e=new Map}async prepareSession(z,L,G){const H=this.f.getDocument(z),ee=t.Position.to(L),re=await this.g.prepareTypeHierarchy(H,ee,G);if(!re)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(re)?re.map(Be=>this.h(Ne,Be)):[this.h(Ne,re)]}async provideSupertypes(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,G);if(ee)return ee.map(re=>this.h(z,re))}async provideSubtypes(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,G);if(ee)return ee.map(re=>this.h(z,re))}releaseSession(z){this.e.delete(z)}h(z,L){const G=this.e.get(z),H=t.TypeHierarchyItem.from(L,z,G.size.toString(36));return G.set(H._itemId,L),H}j(z,L){return this.e.get(z)?.get(L)}}class Te{constructor(z,L,G,H,ee){this.e=z,this.f=L,this.g=G,this.h=H,this.j=ee,this.d=new i.$fkc("DocumentDropEdit")}async provideDocumentOnDropEdits(z,L,G,H,ee){const re=this.f.getDocument(L),Ne=t.Position.to(G),Be=t.DataTransfer.toDataTransfer(H,async tt=>(await this.e.$resolveDocumentOnDropFileData(this.h,z,tt)).buffer),Qe=await this.g.provideDocumentDropEdits(re,Ne,Be,ee);if(!Qe)return;const _e=(0,I.$3b)(Qe),et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,r.localize)(1,null,this.j.displayName||this.j.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?t.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,L){const[G,H]=z,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentDropEdit)return{};const re=await this.g.resolveDocumentDropEdit(ee,L)??ee;return{additionalEdit:re.additionalEdit?t.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(z){this.d.delete(z)}}class de{constructor(z,L){this.d=z,this.e=L}async provideMappedEdits(z,L,G,H){const ee=u.URI.revive(z),re=this.d.getDocument(ee),Ne=G.documents.map(_e=>_e.map(et=>({uri:u.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(tt=>t.Range.to(tt))}))),Be={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(re,L,Be,H);return Qe?t.WorkspaceEdit.from(Qe):null}}class Pe{constructor(z,L){this.adapter=z,this.extension=L}}class Me{static{this.d=0}constructor(z,L,G,H,ee,re,Ne,Be){this.g=L,this.h=G,this.j=H,this.k=ee,this.l=re,this.m=Ne,this.n=Be,this.f=new Map,this.e=z.getProxy(b.$QM.MainThreadLanguageFeatures)}o(z,L){return t.DocumentSelector.from(z,this.g,L)}p(z){return new c.$SM(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Me.d++}async s(z,L,G,H,ee,re=!1){const Ne=this.f.get(z);if(!Ne||!(Ne.adapter instanceof L))return H;const Be=Date.now();re||this.l.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Qe=G(Ne.adapter,Ne.extension);return Promise.resolve(Qe).catch(_e=>{(0,O.$4)(_e)||(this.l.error(`[${Ne.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ne.extension.identifier,_e))}).finally(()=>{re||this.l.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),R.CancellationToken.isCancellationToken(ee)?(0,T.$fh)(Qe,ee):Qe}t(z,L){const G=this.q();return this.f.set(G,new Pe(z,L)),G}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,L,G,H){const ee=this.t(new a(this.h,G),z),re=H&&H.label||Me.u(z);return this.e.$registerDocumentSymbolProvider(ee,this.o(L,z),re),this.p(ee)}$provideDocumentSymbols(z,L,G){return this.s(z,a,H=>H.provideDocumentSymbols(u.URI.revive(L),G),void 0,G)}registerCodeLensProvider(z,L,G){const H=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Pe(new $(this.h,this.j.converter,G,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(H,this.o(L,z),ee);let re=this.p(H);if(ee!==void 0){const Ne=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));re=c.$SM.from(re,Ne)}return re}$provideCodeLenses(z,L,G){return this.s(z,$,H=>H.provideCodeLenses(u.URI.revive(L),G),void 0,G)}$resolveCodeLens(z,L,G){return this.s(z,$,H=>H.resolveCodeLens(L,G),void 0,void 0)}$releaseCodeLenses(z,L){this.s(z,$,G=>Promise.resolve(G.releaseCodeLenses(L)),void 0,void 0)}registerDefinitionProvider(z,L,G){const H=this.t(new S(this.h,G),z);return this.e.$registerDefinitionSupport(H,this.o(L,z)),this.p(H)}$provideDefinition(z,L,G,H){return this.s(z,S,ee=>ee.provideDefinition(u.URI.revive(L),G,H),[],H)}registerDeclarationProvider(z,L,G){const H=this.t(new d(this.h,G),z);return this.e.$registerDeclarationSupport(H,this.o(L,z)),this.p(H)}$provideDeclaration(z,L,G,H){return this.s(z,d,ee=>ee.provideDeclaration(u.URI.revive(L),G,H),[],H)}registerImplementationProvider(z,L,G){const H=this.t(new D(this.h,G),z);return this.e.$registerImplementationSupport(H,this.o(L,z)),this.p(H)}$provideImplementation(z,L,G,H){return this.s(z,D,ee=>ee.provideImplementation(u.URI.revive(L),G,H),[],H)}registerTypeDefinitionProvider(z,L,G){const H=this.t(new f(this.h,G),z);return this.e.$registerTypeDefinitionSupport(H,this.o(L,z)),this.p(H)}$provideTypeDefinition(z,L,G,H){return this.s(z,f,ee=>ee.provideTypeDefinition(u.URI.revive(L),G,H),[],H)}registerHoverProvider(z,L,G,H){const ee=this.t(new E(this.h,G),z);return this.e.$registerHoverProvider(ee,this.o(L,z)),this.p(ee)}$provideHover(z,L,G,H){return this.s(z,E,ee=>ee.provideHover(u.URI.revive(L),G,H),void 0,H)}registerEvaluatableExpressionProvider(z,L,G,H){const ee=this.t(new w(this.h,G),z);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(L,z)),this.p(ee)}$provideEvaluatableExpression(z,L,G,H){return this.s(z,w,ee=>ee.provideEvaluatableExpression(u.URI.revive(L),G,H),void 0,H)}registerInlineValuesProvider(z,L,G,H){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new P(this.h,G),z);this.e.$registerInlineValuesProvider(re,this.o(L,z),ee);let Ne=this.p(re);if(ee!==void 0){const Be=G.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(ee));Ne=c.$SM.from(Ne,Be)}return Ne}$provideInlineValues(z,L,G,H,ee){return this.s(z,P,re=>re.provideInlineValues(u.URI.revive(L),G,H,ee),void 0,ee)}registerDocumentHighlightProvider(z,L,G){const H=this.t(new C(this.h,G),z);return this.e.$registerDocumentHighlightProvider(H,this.o(L,z)),this.p(H)}registerMultiDocumentHighlightProvider(z,L,G){const H=this.t(new V(this.h,G),z);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(L,z)),this.p(H)}$provideDocumentHighlights(z,L,G,H){return this.s(z,C,ee=>ee.provideDocumentHighlights(u.URI.revive(L),G,H),void 0,H)}$provideMultiDocumentHighlights(z,L,G,H,ee){return this.s(z,V,re=>re.provideMultiDocumentHighlights(u.URI.revive(L),G,H.map(Ne=>u.URI.revive(Ne)),ee),void 0,ee)}registerLinkedEditingRangeProvider(z,L,G){const H=this.t(new W(this.h,G),z);return this.e.$registerLinkedEditingRangeProvider(H,this.o(L,z)),this.p(H)}$provideLinkedEditingRanges(z,L,G,H){return this.s(z,W,async ee=>{const re=await ee.provideLinkedEditingRanges(u.URI.revive(L),G,H);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Me.w(re.wordPattern):void 0}},void 0,H)}registerReferenceProvider(z,L,G){const H=this.t(new q(this.h,G),z);return this.e.$registerReferenceSupport(H,this.o(L,z)),this.p(H)}$provideReferences(z,L,G,H,ee){return this.s(z,q,re=>re.provideReferences(u.URI.revive(L),G,H,ee),void 0,ee)}registerCodeActionProvider(z,L,G,H){const ee=new p.$Tc,re=this.t(new A(this.h,this.j.converter,this.k,G,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(re,this.o(L,z),{providedKinds:H?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:H?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this.j.converter.toInternal(Ne.command,ee)}))},Me.u(z),!!G.resolveCodeAction),ee.add(this.p(re)),ee}$provideCodeActions(z,L,G,H,ee){return this.s(z,A,re=>re.provideCodeActions(u.URI.revive(L),G,H,ee),void 0,ee)}$resolveCodeAction(z,L,G){return this.s(z,A,H=>H.resolveCodeAction(L,G),{},void 0)}$releaseCodeActions(z,L){this.s(z,A,G=>Promise.resolve(G.releaseCodeActions(L)),void 0,void 0)}registerDocumentFormattingEditProvider(z,L,G){const H=this.t(new K(this.h,G),z);return this.e.$registerDocumentFormattingSupport(H,this.o(L,z),z.identifier,z.displayName||z.name),this.p(H)}$provideDocumentFormattingEdits(z,L,G,H){return this.s(z,K,ee=>ee.provideDocumentFormattingEdits(u.URI.revive(L),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(z,L,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new se(this.h,G),z);return this.e.$registerRangeFormattingSupport(ee,this.o(L,z),z.identifier,z.displayName||z.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(z,L,G,H,ee){return this.s(z,se,re=>re.provideDocumentRangeFormattingEdits(u.URI.revive(L),G,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(z,L,G,H,ee){return this.s(z,se,re=>re.provideDocumentRangesFormattingEdits(u.URI.revive(L),G,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(z,L,G,H){const ee=this.t(new ce(this.h,G),z);return this.e.$registerOnTypeFormattingSupport(ee,this.o(L,z),H,z.identifier),this.p(ee)}$provideOnTypeFormattingEdits(z,L,G,H,ee,re){return this.s(z,ce,Ne=>Ne.provideOnTypeFormattingEdits(u.URI.revive(L),G,H,ee,re),void 0,re)}registerWorkspaceSymbolProvider(z,L){const G=this.t(new ve(L,this.l),z);return this.e.$registerNavigateTypeSupport(G,typeof L.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(z,L,G){return this.s(z,ve,H=>H.provideWorkspaceSymbols(L,G),{symbols:[]},G)}$resolveWorkspaceSymbol(z,L,G){return this.s(z,ve,H=>H.resolveWorkspaceSymbol(L,G),void 0,void 0)}$releaseWorkspaceSymbols(z,L){this.s(z,ve,G=>G.releaseWorkspaceSymbols(L),void 0,void 0)}registerRenameProvider(z,L,G){const H=this.t(new Ie(this.h,G,this.l),z);return this.e.$registerRenameSupport(H,this.o(L,z),Ie.supportsResolving(G)),this.p(H)}$provideRenameEdits(z,L,G,H,ee){return this.s(z,Ie,re=>re.provideRenameEdits(u.URI.revive(L),G,H,ee),void 0,ee)}$resolveRenameLocation(z,L,G,H){return this.s(z,Ie,ee=>ee.resolveRenameLocation(u.URI.revive(L),G,H),void 0,H)}registerNewSymbolNamesProvider(z,L,G){const H=this.t(new ue(this.h,G,this.l),z);return this.e.$registerNewSymbolNamesProvider(H,this.o(L,z)),this.p(H)}$provideNewSymbolNames(z,L,G,H){return this.s(z,ue,ee=>ee.provideNewSymbolNames(u.URI.revive(L),G,H),void 0,H)}registerDocumentSemanticTokensProvider(z,L,G,H){const ee=this.t(new ie(this.h,G),z),re=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(L,z),H,re);let Ne=this.p(ee);if(re){const Be=G.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(re));Ne=c.$SM.from(Ne,Be)}return Ne}$provideDocumentSemanticTokens(z,L,G,H){return this.s(z,ie,ee=>ee.provideDocumentSemanticTokens(u.URI.revive(L),G,H),null,H)}$releaseDocumentSemanticTokens(z,L){this.s(z,ie,G=>G.releaseDocumentSemanticColoring(L),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,L,G,H){const ee=this.t(new Ce(this.h,G),z);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(L,z),H),this.p(ee)}$provideDocumentRangeSemanticTokens(z,L,G,H){return this.s(z,Ce,ee=>ee.provideDocumentRangeSemanticTokens(u.URI.revive(L),G,H),null,H)}registerCompletionItemProvider(z,L,G,H){const ee=this.t(new Fe(this.h,this.j.converter,G,this.m,z),z);return this.e.$registerCompletionsProvider(ee,this.o(L,z),H,Fe.supportsResolving(G),z.identifier),this.p(ee)}$provideCompletionItems(z,L,G,H,ee){return this.s(z,Fe,re=>re.provideCompletionItems(u.URI.revive(L),G,H,ee),void 0,ee)}$resolveCompletionItem(z,L,G){return this.s(z,Fe,H=>H.resolveCompletionItem(L,G),void 0,G)}$releaseCompletionItems(z,L){this.s(z,Fe,G=>G.releaseCompletionItems(L),void 0,void 0)}registerInlineCompletionsProvider(z,L,G,H){const ee=new j(z,this.h,G,this.j.converter),re=this.t(ee,z);return this.e.$registerInlineCompletionsSupport(re,this.o(L,z),ee.supportsHandleEvents,n.$Lm.toKey(z.identifier.value),H?.yieldTo?.map(Ne=>n.$Lm.toKey(Ne))||[]),this.p(re)}$provideInlineCompletions(z,L,G,H,ee){return this.s(z,ne,re=>re.provideInlineCompletions(u.URI.revive(L),G,H,ee),void 0,ee)}$handleInlineCompletionDidShow(z,L,G,H){this.s(z,ne,async ee=>{ee.handleDidShowCompletionItem(L,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,L,G,H,ee){this.s(z,ne,async re=>{re.handlePartialAccept(L,G,H,ee)},void 0,void 0)}$freeInlineCompletionsList(z,L){this.s(z,ne,async G=>{G.disposeCompletions(L)},void 0,void 0)}registerInlineEditProvider(z,L,G){const H=new x(z,this.h,G,this.j.converter),ee=this.t(H,z);return this.e.$registerInlineEditProvider(ee,this.o(L,z),z.identifier),this.p(ee)}$provideInlineEdit(z,L,G,H){return this.s(z,x,ee=>ee.provideInlineEdits(u.URI.revive(L),G,H),void 0,H)}$freeInlineEdit(z,L){this.s(z,x,async G=>{G.disposeEdit(L)},void 0,void 0)}registerSignatureHelpProvider(z,L,G,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,re=this.t(new Oe(this.h,G),z);return this.e.$registerSignatureHelpProvider(re,this.o(L,z),ee),this.p(re)}$provideSignatureHelp(z,L,G,H,ee){return this.s(z,Oe,re=>re.provideSignatureHelp(u.URI.revive(L),G,H,ee),void 0,ee)}$releaseSignatureHelp(z,L){this.s(z,Oe,G=>G.releaseSignatureHelp(L),void 0,void 0)}registerInlayHintsProvider(z,L,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ke(this.h,this.j.converter,G,this.l,z),z);this.e.$registerInlayHintsProvider(ee,this.o(L,z),typeof G.resolveInlayHint=="function",H,Me.u(z));let re=this.p(ee);if(H!==void 0){const Ne=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));re=c.$SM.from(re,Ne)}return re}$provideInlayHints(z,L,G,H){return this.s(z,ke,ee=>ee.provideInlayHints(u.URI.revive(L),G,H),void 0,H)}$resolveInlayHint(z,L,G){return this.s(z,ke,H=>H.resolveInlayHint(L,G),void 0,G)}$releaseInlayHints(z,L){this.s(z,ke,G=>G.releaseHints(L),void 0,void 0)}registerDocumentLinkProvider(z,L,G){const H=this.t(new $e(this.h,G),z);return this.e.$registerDocumentLinkProvider(H,this.o(L,z),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(z,L,G){return this.s(z,$e,H=>H.provideLinks(u.URI.revive(L),G),void 0,G,L.scheme==="output")}$resolveDocumentLink(z,L,G){return this.s(z,$e,H=>H.resolveLink(L,G),void 0,void 0,!0)}$releaseDocumentLinks(z,L){this.s(z,$e,G=>G.releaseLinks(L),void 0,void 0,!0)}registerColorProvider(z,L,G){const H=this.t(new fe(this.h,G),z);return this.e.$registerDocumentColorProvider(H,this.o(L,z)),this.p(H)}$provideDocumentColors(z,L,G){return this.s(z,fe,H=>H.provideColors(u.URI.revive(L),G),[],G)}$provideColorPresentations(z,L,G,H){return this.s(z,fe,ee=>ee.provideColorPresentations(u.URI.revive(L),G,H),void 0,H)}registerFoldingRangeProvider(z,L,G){const H=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Pe(new J(this.h,G),z)),this.e.$registerFoldingRangeProvider(H,this.o(L,z),z.identifier,ee);let re=this.p(H);if(ee!==void 0){const Ne=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));re=c.$SM.from(re,Ne)}return re}$provideFoldingRanges(z,L,G,H){return this.s(z,J,ee=>ee.provideFoldingRanges(u.URI.revive(L),G,H),void 0,H)}registerSelectionRangeProvider(z,L,G){const H=this.t(new Y(this.h,G,this.l),z);return this.e.$registerSelectionRangeProvider(H,this.o(L,z)),this.p(H)}$provideSelectionRanges(z,L,G,H){return this.s(z,Y,ee=>ee.provideSelectionRanges(u.URI.revive(L),G,H),[],H)}registerCallHierarchyProvider(z,L,G){const H=this.t(new he(this.h,G),z);return this.e.$registerCallHierarchyProvider(H,this.o(L,z)),this.p(H)}$prepareCallHierarchy(z,L,G,H){return this.s(z,he,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(L),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(z,L,G,H){return this.s(z,he,ee=>ee.provideCallsTo(L,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(z,L,G,H){return this.s(z,he,ee=>ee.provideCallsFrom(L,G,H),void 0,H)}$releaseCallHierarchy(z,L){this.s(z,he,G=>Promise.resolve(G.releaseSession(L)),void 0,void 0)}registerTypeHierarchyProvider(z,L,G){const H=this.t(new le(this.h,G),z);return this.e.$registerTypeHierarchyProvider(H,this.o(L,z)),this.p(H)}$prepareTypeHierarchy(z,L,G,H){return this.s(z,le,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(L),G,H)),void 0,H)}$provideTypeHierarchySupertypes(z,L,G,H){return this.s(z,le,ee=>ee.provideSupertypes(L,G,H),void 0,H)}$provideTypeHierarchySubtypes(z,L,G,H){return this.s(z,le,ee=>ee.provideSubtypes(L,G,H),void 0,H)}$releaseTypeHierarchy(z,L){this.s(z,le,G=>Promise.resolve(G.releaseSession(L)),void 0,void 0)}registerDocumentOnDropEditProvider(z,L,G,H){const ee=this.q();return this.f.set(ee,new Pe(new Te(this.e,this.h,G,ee,z),z)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(L,z),(0,h.$xG)(z,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(z,L,G,H,ee,re){return this.s(z,Te,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(L,u.URI.revive(G),H,ee,re)),void 0,void 0)}$resolveDropEdit(z,L,G){return this.s(z,Te,H=>H.resolveDropEdit(L,G),{},void 0)}$releaseDropEdits(z,L){this.s(z,Te,G=>Promise.resolve(G.releaseDropEdits(L)),void 0,void 0)}registerMappedEditsProvider(z,L,G){const H=this.t(new de(this.h,G),z);return this.e.$registerMappedEditsProvider(H,this.o(L,z)),this.p(H)}$provideMappedEdits(z,L,G,H,ee){return this.s(z,de,re=>Promise.resolve(re.provideMappedEdits(L,G,H,ee)),null,ee)}registerDocumentPasteEditProvider(z,L,G,H){const ee=this.q();return this.f.set(ee,new Pe(new U(this.e,this.h,G,ee,z),z)),this.e.$registerPasteEditProvider(ee,this.o(L,z),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(z,L,G,H,ee){return this.s(z,U,re=>re.prepareDocumentPaste(u.URI.revive(L),G,H,ee),void 0,ee)}$providePasteEdits(z,L,G,H,ee,re,Ne){return this.s(z,U,Be=>Be.providePasteEdits(L,u.URI.revive(G),H,ee,re,Ne),void 0,Ne)}$resolvePasteEdit(z,L,G){return this.s(z,U,H=>H.resolvePasteEdit(L,G),{},void 0)}$releasePasteEdits(z,L){this.s(z,U,G=>Promise.resolve(G.releasePasteEdits(L)),void 0,void 0)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:Me.w(z.decreaseIndentPattern),increaseIndentPattern:Me.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Me.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Me.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:Me.w(z.beforeText),afterText:z.afterText?Me.w(z.afterText):void 0,previousLineText:z.previousLineText?Me.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(Me.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(L=>c.SyntaxTokenType.toString(L)):void 0}}static D(z){return z.map(Me.C)}setLanguageConfiguration(z,L,G){const{wordPattern:H}=G;if(H&&(0,N.$ff)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(L,H):this.h.setWordDefinitionFor(L,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ee=this.q(),re={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Me.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Me.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Me.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Me.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,L,re),this.p(ee)}$setWordDefinitions(z){for(const L of z)this.h.setWordDefinitionFor(L.languageId,new RegExp(L.regexSource,L.regexFlags))}}e.$pkc=Me}),define(Re[88],Ae([1,0,22,6,4,8,7,101,20,11,5,166,106,14,3,16,84,13,40]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=e.$9kc=void 0,e.$9kc=(0,m.$qi)("IExtHostLanguageModels");class c{constructor(a,$){this.option=a,this.stream=new k.$Th,this.stream=$??new k.$Th}}class h{constructor(){this.a=new Map,this.b=new k.$Th,this.c=!1,this.d=!1;const a=this;this.apiObject={stream:a.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,a]of this.a)yield a.stream;else yield this.b}handleFragment(a){if(this.c)return;this.d=!0;let $=this.a.get(a.index);$||(this.a.size===0?$=new c(a.index,this.b):$=new c(a.index),this.a.set(a.index,$)),$.stream.emitOne(a.part)}get isStreaming(){return this.d}reject(a){this.c=!0;for(const $ of this.f())$.reject(a)}resolve(){this.c=!0;for(const a of this.f())a.resolve()}}let i=class{static{t=this}static{this.a=1}constructor(a,$,l){this.j=$,this.k=l,this.c=new N.$be,this.d=new N.$be,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new g.$Nm,this.i=new Map,this.o=new Set,this.b=a.getProxy(R.$QM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(a,$,l,S){const d=t.a++;this.f.set(d,{extension:a.identifier,provider:l,languageModelId:$});let D;return S.auth&&(D={providerLabel:a.displayName||a.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(d,$,{extension:a.identifier,identifier:$,model:S.name??"",auth:D}),(0,T.$Sc)(()=>{this.f.delete(d),this.b.$unregisterProvider(d)})}async $provideLanguageModelResponse(a,$,l,S,d,D){const f=this.f.get(a);if(!f)return;const E=new p.$Zv(async w=>{if(D.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk($,{index:w.index,part:w.part})});return f.provider.provideLanguageModelResponse2(S.map(O.LanguageModelMessage.to),d,g.$Lm.toKey(l),E,D)}$provideTokenLength(a,$,l){const S=this.f.get(a);return S?Promise.resolve(S.provider.provideTokenCount($,l)):Promise.resolve(0)}$updateLanguageModels(a){const $=[],l=[];if(a.added)for(const S of a.added)this.g.set(S.identifier,S),$.push(S.model);if(a.removed)for(const S of a.removed){this.g.delete(S),l.push(S);for(const[d,D]of this.i)D.languageModelId===S&&(D.res.reject(new v.$5),this.i.delete(d))}this.d.fire(Object.freeze({added:Object.freeze($),removed:Object.freeze(l)})),a.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(a){const $=new Array;for(const{from:l,to:S,enabled:d}of a){const D=this.h.get(l)??new g.$Mm;if(D.has(S)!==d){d?D.add(S):D.delete(S),this.h.set(l,D);const E={from:l,to:S};$.push(E),this.c.fire(E)}}}async sendChatRequest(a,$,l,S,d){const D=a.identifier,f=await this.b.$prepareChatAccess(D,$,S.justification);if(!f||!this.g.has($))throw M.$3O.NotFound(`Language model '${$}' is unknown.`);if(this.m(D,f)&&(!await this.l(a,{identifier:f.extension,displayName:f.auth.providerLabel},S.justification,S.silent)||!this.h.get(D)?.has(f.extension)))throw M.$3O.NoPermissions(`Language model '${$}' cannot be used by '${D.value}'.`);const E=Math.random()*1e6|0,w=this.b.$fetchResponse(D,$,E,l.map(O.LanguageModelMessage.from),S.modelOptions??{},d),P=new k.$ph,C=new h;this.i.set(E,{languageModelId:$,res:C});let V;if(w.catch(W=>{P.isOpen()?C.reject(W):V=W}).finally(()=>{this.i.delete(E),C.resolve(),P.open()}),await P.wait(),V)throw new M.$3O(`Language model '${$}' errored, check cause for more details`,"Unknown",V);return C.apiObject}async $handleResponseFragment(a,$){const l=this.i.get(a);l&&l.res.handleFragment($)}async l(a,$,l,S){const d=u.$SL+$.identifier.value;if(await this.k.getSession(a,d,[],{silent:!0}))return this.$updateModelAccesslist([{from:a.identifier,to:$.identifier,enabled:!0}]),!0;if(S)return!1;try{const f=l?(0,y.localize)(0,null,$.displayName,l):(0,y.localize)(1,null,$.displayName);return await this.k.getSession(a,d,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:a.identifier,to:$.identifier,enabled:!0}]),!0}catch{return!1}}m(a,$){return!!$.auth&&!g.$Lm.equals($.extension,a)}async n(a){for(const $ of this.o)try{await this.l($,{identifier:a.extension,displayName:""},void 0,!0)}catch(l){this.j.error("Fake Auth request failed"),this.j.error(l)}}createLanguageModelAccessInformation(a){this.o.add(a);const $=this,l=N.Event.signal(N.Event.filter(this.c.event,d=>g.$Lm.equals(d.from,a.identifier))),S=N.Event.signal(this.d.event);return{get onDidChange(){return N.Event.any(l,S)},canSendRequest(d){const D=$.g.get(d);if(!D)return;if(!$.m(a.identifier,D))return!0;const f=$.h.get(a.identifier);if(f)return f.has(D.extension)},async computeTokenLength(d,D,f){f??=I.CancellationToken.None;const E=$.g.get(d);if(!E)throw M.$3O.NotFound(`Language model '${d}' is unknown.`);const w=n.Iterable.find($.f.values(),P=>P.languageModelId===d);return w?w.provider.provideTokenCount(D,f):$.b.$countTokens(E.identifier,D,f)}}}};e.$0kc=i,e.$0kc=i=t=Je([Ve(0,s.$dP),Ve(1,r.$Wj),Ve(2,o.$rkc)],i)}),define(Re[263],Ae([1,0,4,8,7,33,11,6,25]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=void 0;class k{constructor(y,u,v,m){this.c=u,this.d=v,this.e=m,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(I.$QM.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const v=this.c.getDocumentData(y);if(!v)throw new Error(`document '${y.toString()}' NOT found`);return v.document}async tokenAtPosition(y,u){const v=y.version,m=T.Position.from(u),s=await this.a.$tokensAtPosition(y.uri,m),o={type:R.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new R.$UM(u.line,u.character,u.line,u.character)};if(!s)return o;const r={range:T.Range.to(s.range),type:T.TokenType.to(s.type)};return!r.range.contains(u)||v!==y.version?o:r}createLanguageStatusItem(y,u,v){const m=this.f++,s=this.a,o=this.g,r=`${y.identifier.value}/${u}`;if(o.has(r))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(r);const n={selector:v,id:u,name:y.displayName??y.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let t;const c=new p.$Tc,h=()=>{if(t?.dispose(),!o.has(r)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}t=(0,M.$sh)(()=>{c.clear(),this.a.$setLanguageStatus(m,{id:r,name:n.name??y.displayName??y.name,source:y.displayName??y.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===R.LanguageStatusSeverity.Error?O.default.Error:n.severity===R.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),t?.dispose(),s.$removeLanguageStatus(m),o.delete(r)},get id(){return n.id},get name(){return n.name},set name(b){n.name=b,h()},get selector(){return n.selector},set selector(b){n.selector=b,h()},get text(){return n.text},set text(b){n.text=b,h()},set text2(b){(0,g.$yG)(y,"languageStatusText"),n.text=b,h()},get text2(){return(0,g.$yG)(y,"languageStatusText"),n.text},get detail(){return n.detail},set detail(b){n.detail=b,h()},get severity(){return n.severity},set severity(b){n.severity=b,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(b){n.accessibilityInformation=b,h()},get command(){return n.command},set command(b){n.command=b,h()},get busy(){return n.busy},set busy(b){n.busy=b,h()}};return h(),i}}e.$Olc=k}),define(Re[264],Ae([1,0,12,2,8,7,83]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=void 0;class p{constructor(y,u,v,m){this.start=y,this.deletedCount=u,this.deletedItems=v,this.items=m}asApiEvent(){return{range:new O.$hO(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,v){this.notebook=y,this.h=u,this.j=v,this.handle=v.handle,this.uri=T.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(R.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(m){y.g=m},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(v)}return this.f}setOutputs(y){this.a=y.map(R.NotebookCellOutput.to)}setOutputItems(y,u,v){const m=v.map(R.NotebookCellOutputItem.to),s=this.a.find(o=>o.id===y);if(s&&(u||(s.items.length=0),s.items.push(...m),s.items.length>1&&s.items.every(o=>M.$NK(o.mime)))){const o=new Map,r=[];s.items.forEach(n=>{let t;o.has(n.mime)?t=o.get(n.mime):(t=[],o.set(n.mime,t),r.push(n.mime)),t.push(n.data)}),s.items.length=0,r.forEach(n=>{const t=M.$OK(o.get(n));s.items.push({mime:n,data:t.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$Alc=g;class k{static{this.a=0}constructor(y,u,v,m,s){this.k=y,this.l=u,this.m=v,this.uri=m,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===I.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(v){return v=y.n(v),y.b[v].apiCell},getCells(v){return(v?y.p(v):y.b).map(s=>s.apiCell)},save(){return y.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,v){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:v});const m={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},s=[];for(const r of y.rawEvents)r.kind===M.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,m.contentChanges):r.kind===M.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,m.contentChanges):r.kind===M.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===M.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===M.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),s.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),s.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const o=new Map;for(let r=0;r<s.length;r++){const n=s[r],t=o.get(n.cell);if(t===void 0){const c=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,c-1)}else m.cellChanges[t]={...m.cellChanges[t],...n}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,v=y.end|0;return u<0&&(u=0),v>this.b.length&&(v=this.b.length),y.with({start:u,end:v})}p(y){y=this.o(y);const u=[];for(let v=y.start;v<y.end;v++)u.push(this.b[v]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,v){if(this.j)return;const m=[],s=[],o=[];if(y.reverse().forEach(r=>{const t=r[2].map(i=>{const b=new g(this,this.l,i);return u||s.push(g.asModelAddData(i)),b}),c=new p(r[0],r[1],[],t),h=this.b.splice(r[0],r[1],...t);for(const i of h)o.push(i.uri),c.deletedItems.push(i.apiCell);m.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:o}),v)for(const r of m)v.push(r.asApiEvent())}s(y,u,v,m){const s=this.b.splice(y,u);this.b.splice(v,0,...s);const o=[new p(y,u,s.map(r=>r.apiCell),[]),new p(v,0,[],s)];for(const r of o)m.push(r.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,v,m){this.b[y].setOutputItems(u,v,m)}v(y,u){const v=this.b[y];v.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(v.uri,u)}w(y,u){const v=this.b[y];v.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$Blc=k}),define(Re[265],Ae([1,0,5,2,8,7,34]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=void 0;class p{constructor(k,N,y,u={timeout:1500,errors:3}){this.b=k,this.c=N,this.d=y,this.f=u,this.a=new I.$de}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(N,y,u)=>{const v=function(s){N.call(y,s)};return v.extension=k,this.a.event(v,void 0,u)}}async $participateInSave(k,N,y){const u=T.URI.revive(k),v=this.c.getNotebookDocument(u);if(!v)throw new Error("Unable to resolve notebook document");const m=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:R.TextDocumentSaveReason.to(N)},y,async(o,r)=>{const n=Date.now(),t=await await Promise.resolve(o);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier),!y.isCancellationRequested&&t&&(t instanceof O.$3M?m.push(t):this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(m.length===0)return!0;const s={edits:[]};for(const o of m){const{edits:r}=R.WorkspaceEdit.from(o);s.edits=s.edits.concat(r)}return this.d.$tryApplyWorkspaceEdit(new M.$mw(s))}}e.$Qlc=p}),define(Re[112],Ae([1,0,14,8,7]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,g,k,N,y,u){this.id=p,this.f=g,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=N,this.c=u}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(g){this.selections=[g]},get selections(){return p.a},set selections(g){if(!Array.isArray(g)||!g.every(R.$hO.isNotebookRange))throw(0,I.$7)("selections");p.a=g,p.g(g)},get visibleRanges(){return p.b},revealRange(g,k){p.f.$tryRevealRange(p.id,T.NotebookRange.from(g),k??R.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(T.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$Clc=O}),define(Re[266],Ae([1,0,5,13,8]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=void 0;let O=class{constructor(p,g){this.c=p,this.d=g,this.a=new I.$be,this.b=new I.$be,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,g);const k=this.d.getEditorById(p);g.visibleRanges&&k._acceptVisibleRanges(g.visibleRanges.ranges.map(R.NotebookRange.to)),g.selections&&k._acceptSelections(g.selections.selections.map(R.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const g in p)this.d.getEditorById(g)._acceptViewColumn(R.ViewColumn.to(p[g]))}};e.$Slc=O,e.$Slc=O=Je([Ve(0,T.$Wj)],O)}),define(Re[267],Ae([1,0,5,4,112]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=void 0;class O{constructor(p,g){this.c=g,this.a=new Map,this.b=p.getProxy(T.$QM.MainThreadNotebookRenderers)}$postRendererMessage(p,g,k){const N=this.c.getEditorById(p);this.a.get(g)?.fire({editor:N.apiEditor,message:k})}createRendererMessaging(p,g){if(!p.contributes?.notebookRenderer?.some(N=>N.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(N,y,u)=>this.d(g).event(N,y,u),postMessage:(N,y)=>{R.$Clc.apiEditorsToExtHost.has(N)&&([N,y]=[y,N]);const u=y&&R.$Clc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,g,N)}}}d(p){let g=this.a.get(p);return g||(g=new I.$be({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(p)}}),this.a.set(p,g),g)}}e.$Vlc=O}),define(Re[268],Ae([1,0,8,101,22,68,14]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=void 0;class p{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,v){const m=this.b++,{title:s,location:o,cancellable:r}=u,n={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(m,{location:I.ProgressLocation.from(o),title:s,source:n,cancellable:r},y.isUnderDevelopment?void 0:y.identifier.value).catch(M.$2),this.d(m,v,!!r)}d(y,u,v){let m;v&&(m=new R.$me,this.c.set(y,m));const s=r=>{this.a.$progressEnd(r),this.c.delete(r),m?.dispose()};let o;try{o=u(new k(this.a,y),v&&m?m.token:R.CancellationToken.None)}catch(r){throw s(y),r}return o.then(r=>s(y),r=>s(y)),o}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$Zlc=p;function g(N,y){return N.message=y.message,typeof y.increment=="number"&&(typeof N.increment=="number"?N.increment+=y.increment:N.increment=y.increment),N}class k extends T.$Zv{constructor(y,u){super(v=>this.throttledReport(v)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,O.$Wh)(100,(N,y)=>g(N,y),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Re[269],Ae([1,0,2,4,11,8]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;class M{static{this.a=0}constructor(g,k){this.d=k,this.c=new Map,this.b=g.getProxy(T.$QM.MainThreadQuickDiff)}$provideOriginalResource(g,k,N){const y=I.URI.revive(k),u=this.c.get(g);return u?(0,R.$ih)(()=>u.provideOriginalResource(y,N)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(g,k,N,y){const u=M.a++;return this.c.set(u,k),this.b.$registerQuickDiffProvider(u,O.DocumentSelector.from(g,this.d),N,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$1lc=M}),define(Re[270],Ae([1,0,22,5,6,4,2,7,14,18,33,42,25,8]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=m;function m(s,o,r){const n=s.getProxy(O.$QM.MainThreadQuickOpen);class t{constructor(d,D){this.e=new Map,this.f=0,this.a=d,this.b=D}showQuickPick(d,D,f,E=I.CancellationToken.None){this.c=void 0;const w=Promise.resolve(D),P=++this.f,C=n.$show(P,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},E),V={},W=C.then(()=>V);return Promise.race([W,w]).then(q=>{if(q===V)return;const A=(0,u.$xG)(d,"quickPickItemTooltip");return w.then(U=>{const K=[];for(let se=0;se<U.length;se++){const ce=U[se];if(typeof ce=="string")K.push({label:ce,handle:se});else if(ce.kind===p.QuickPickItemKind.Separator)K.push({type:"separator",label:ce.label});else{ce.tooltip&&!A&&console.warn(`Extension '${d.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`);const ve=ce.iconPath?a(ce.iconPath):void 0;K.push({label:ce.label,iconPath:ve?.iconPath,iconClass:ve?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:A?v.MarkdownString.fromStrict(ce.tooltip):void 0,handle:se})}}return f&&typeof f.onDidSelectItem=="function"&&(this.c=se=>{f.onDidSelectItem(U[se])}),n.$setItems(P,K),C.then(se=>{if(typeof se=="number")return U[se];if(Array.isArray(se))return se.map(ce=>U[ce])})})}).then(void 0,q=>{if(!(0,g.$4)(q))return n.$setError(P,q),Promise.reject(q)})}$onItemSelected(d){this.c?.(d)}showInput(d,D=I.CancellationToken.None){return this.d=d?.validateInput,n.$input(d,typeof this.d=="function",D).then(void 0,f=>{if(!(0,g.$4)(f))return Promise.reject(f)})}async $validateInput(d){if(!this.d)return;const D=await this.d(d);if(!D||typeof D=="string")return D;let f;switch(D.severity){case p.InputBoxValidationSeverity.Info:f=N.default.Info;break;case p.InputBoxValidationSeverity.Warning:f=N.default.Warning;break;case p.InputBoxValidationSeverity.Error:f=N.default.Error;break;default:f=D.message?N.default.Error:N.default.Ignore;break}return{content:D.message,severity:f}}async showWorkspaceFolderPick(d,D=I.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!f)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(w=>w.uri.toString()===f.uri.toString())}createQuickPick(d){const D=new $(d,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(d){const D=new l(d,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(d,D){this.e.get(d)?._fireDidChangeValue(D)}$onDidAccept(d){this.e.get(d)?._fireDidAccept()}$onDidChangeActive(d,D){const f=this.e.get(d);f instanceof $&&f._fireDidChangeActive(D)}$onDidChangeSelection(d,D){const f=this.e.get(d);f instanceof $&&f._fireDidChangeSelection(D)}$onDidTriggerButton(d,D){this.e.get(d)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(d,D,f){const E=this.e.get(d);E instanceof $&&E._fireDidTriggerItemButton(D,f)}$onDidHide(d){this.e.get(d)?._fireDidHide()}}class c{static{this.a=1}constructor(d,D){this.x=d,this.y=D,this._id=$.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$be,this.q=new T.$be,this.r=new T.$be,this.s=new T.$be,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(d){this.b=d,this.z({title:d})}get step(){return this.c}set step(d){this.c=d,this.z({step:d})}get totalSteps(){return this.d}set totalSteps(d){this.d=d,this.z({totalSteps:d})}get enabled(){return this.g}set enabled(d){this.g=d,this.z({enabled:d})}get busy(){return this.j}set busy(d){this.j=d,this.z({busy:d})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(d){this.k=d,this.z({ignoreFocusOut:d})}get value(){return this.l}set value(d){this.l=d,this.z({value:d})}get placeholder(){return this.m}set placeholder(d){this.m=d,this.z({placeholder:d})}get buttons(){return this.n}set buttons(d){this.n=d.slice(),this.o.clear(),d.forEach((D,f)=>{const E=D===p.$eO.Back?-1:f;this.o.set(E,D)}),this.z({buttons:d.map((D,f)=>({...a(D.iconPath),tooltip:D.tooltip,handle:D===p.$eO.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(d){this.l=d,this.q.fire(d)}_fireDidTriggerButton(d){const D=this.o.get(d);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(d){if(!this.v){for(const D of Object.keys(d)){const f=d[D];this.u[D]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(S){if(S instanceof p.$ON)return{id:S.id};const d=b(S),D=i(S);return{dark:typeof d=="string"?M.URI.file(d):d,light:typeof D=="string"?M.URI.file(D):D}}function i(S){return typeof S=="object"&&"light"in S?S.light:S}function b(S){return typeof S=="object"&&"dark"in S?S.dark:S}function a(S){const d=h(S);let D,f;return"id"in d?f=y.ThemeIcon.asClassName(d):D=d,{iconPath:D,iconClass:f}}class $ extends c{constructor(d,D){super(d.identifier,D),this.O=d,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$be,this.L=[],this.M=new T.$be,this.N=new T.$be,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(d){this.B=d.slice(),this.C.clear(),this.D.clear(),d.forEach((E,w)=>{this.C.set(w,E),this.D.set(E,w)});const D=(0,u.$xG)(this.O,"quickPickItemTooltip"),f=[];for(let E=0;E<d.length;E++){const w=d[E];if(w.kind===p.QuickPickItemKind.Separator)f.push({type:"separator",label:w.label});else{w.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=w.iconPath?a(w.iconPath):void 0;f.push({handle:E,label:w.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:D?v.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((C,V)=>({...a(C.iconPath),tooltip:C.tooltip,handle:V}))})}}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(d){this.E=d,this.z({canSelectMany:d})}get matchOnDescription(){return this.F}set matchOnDescription(d){this.F=d,this.z({matchOnDescription:d})}get matchOnDetail(){return this.G}set matchOnDetail(d){this.G=d,this.z({matchOnDetail:d})}get sortByLabel(){return this.H}set sortByLabel(d){this.H=d,this.z({sortByLabel:d})}get keepScrollPosition(){return this.I}set keepScrollPosition(d){this.I=d,this.z({keepScrollPosition:d})}get activeItems(){return this.J}set activeItems(d){this.J=d.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(d){this.L=d.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(d){const D=(0,k.$Hb)(d.map(f=>this.C.get(f)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(d){const D=(0,k.$Hb)(d.map(f=>this.C.get(f)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(d,D){const f=this.C.get(d);if(!f||!f.buttons||!f.buttons.length)return;const E=f.buttons[D];E&&this.N.fire({button:E,item:f})}}class l extends c{constructor(d,D){super(d.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(d){this.B=d,this.z({password:d})}get prompt(){return this.C}set prompt(d){this.C=d,this.z({prompt:d})}get valueSelection(){return this.D}set valueSelection(d){this.D=d,this.z({valueSelection:d})}get validationMessage(){return this.E}set validationMessage(d){this.E=d,d?typeof d=="string"?this.z({validationMessage:d,severity:N.default.Error}):this.z({validationMessage:d.message,severity:d.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new t(o,r)}}),define(Re[271],Ae([1,0,2,5,68,6,11,4,18,143,13,20,42,8,25,12,21]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=e.$3lc=void 0;function n(P){return P instanceof I.URI}function t(P,C){return P.scheme===s.Schemas.file&&C.scheme===s.Schemas.file&&o.$k?P.toString()===C.toString():P.toString().toLowerCase()===C.toString().toLowerCase()}function c(P){if(P)return typeof P.iconPath=="string"?I.URI.file(P.iconPath):I.URI.isUri(P.iconPath)||u.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function h(P){if(P.icon){if(I.URI.isUri(P.icon))return P.icon;if(u.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const C=P.icon;return{light:C.light,dark:C.dark}}}else return}function i(P,C){if(!P.iconPath&&!C.iconPath)return 0;if(P.iconPath){if(!C.iconPath)return 1}else return-1;const V=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,W=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,k.$ir)(V,W)}function b(P,C){let V=0;if(P.strikeThrough!==C.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==C.faded)return P.faded?1:-1;if(P.tooltip!==C.tooltip)return(P.tooltip||"").localeCompare(C.tooltip||"");if(V=i(P,C),V!==0)return V;if(P.light&&C.light)V=i(P.light,C.light);else{if(P.light)return 1;if(C.light)return-1}if(V!==0)return V;if(P.dark&&C.dark)V=i(P.dark,C.dark);else{if(P.dark)return 1;if(C.dark)return-1}return V}function a(P,C){if(P.command!==C.command)return P.command<C.command?-1:1;if(P.title!==C.title)return P.title<C.title?-1:1;if(P.tooltip!==C.tooltip){if(P.tooltip!==void 0&&C.tooltip!==void 0)return P.tooltip<C.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(P.arguments===C.arguments)return 0;if(P.arguments)if(C.arguments){if(P.arguments.length!==C.arguments.length)return P.arguments.length-C.arguments.length}else return 1;else return-1;for(let V=0;V<P.arguments.length;V++){const W=P.arguments[V],q=C.arguments[V];if(W!==q&&!(n(W)&&n(q)&&t(W,q)))return W<q?-1:1}return 0}function $(P,C){let V=(0,k.$ir)(P.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(V!==0)return V;if(P.command&&C.command)V=a(P.command,C.command);else{if(P.command)return 1;if(C.command)return-1}if(V!==0)return V;if(P.decorations&&C.decorations)V=b(P.decorations,C.decorations);else{if(P.decorations)return 1;if(C.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&C.multiFileDiffEditorModifiedUri)V=(0,k.$ir)(P.multiFileDiffEditorModifiedUri.fsPath,C.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(C.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&C.multiDiffEditorOriginalUri)V=(0,k.$ir)(P.multiDiffEditorOriginalUri.fsPath,C.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(C.multiDiffEditorOriginalUri)return-1}return V}function l(P,C){for(let V=0;V<P.length;V++)if(P[V]!==C[V])return!1;return!0}function S(P,C){return P.command===C.command&&P.title===C.title&&P.tooltip===C.tooltip&&(P.arguments&&C.arguments?l(P.arguments,C.arguments):P.arguments===C.arguments)}function d(P,C){return(0,g.$ub)(P,C,S)}class D{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.l,C),this.n(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.l,C),this.f=C}get validateInput(){return(0,m.$yG)(this.k,"scmValidation"),this.g}set validateInput(C){if((0,m.$yG)(this.k,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.l,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.l,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.l,C))}get document(){return(0,m.$yG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(C,V,W,q,A){this.k=C,this.l=q,this.m=A,this.d="",this.e=new T.$be,this.f="",this.h=!0,this.j=!0,this.#t=V,this.#e=W}showValidationMessage(C,V){(0,m.$yG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,C,V)}$onInputBoxValueChange(C){this.n(C)}n(C){this.d=C,this.e.fire(C)}}e.$3lc=D;class f{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,V,W,q,A,U,K){this.q=C,this.s=V,this.t=W,this.u=q,this.v=A,this.multiDiffEditorEnableViewChanges=U,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$be,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$be,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=f.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,V){const W=this.h.get(C);return W?(0,M.$ih)(()=>this.s.executeCommand(W.command,...W.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort($),W=(0,g.$Db)(this.o,C,$).map(U=>{const K=U.toInsert.map(se=>{const ce=this.e++;this.g.set(ce,se);const ve=se.resourceUri;let Ie;if(se.command)if(se.command.command==="vscode.open"||se.command.command==="vscode.diff"||se.command.command==="vscode.changes"){const fe=new O.$Tc;Ie=this.s.converter.toInternal(se.command,fe),this.j.set(ce,fe)}else this.h.set(ce,se.command);const ue=(0,m.$xG)(this.w,"scmMultiDiffEditor"),be=ue?se.multiDiffEditorOriginalUri:void 0,ie=ue?se.multiFileDiffEditorModifiedUri:void 0,Ce=c(se.decorations),Fe=se.decorations&&c(se.decorations.light)||Ce,ne=se.decorations&&c(se.decorations.dark)||Ce,j=[Fe,ne],x=se.decorations&&se.decorations.tooltip||"",pe=se.decorations&&!!se.decorations.strikeThrough,Oe=se.decorations&&!!se.decorations.faded,ke=se.contextValue||"";return{rawResource:[ce,ve,j,x,pe,Oe,ke,Ie,be,ie],handle:ce}});return{start:U.start,deleteCount:U.deleteCount,toInsert:K}}),q=W.map(({start:U,deleteCount:K,toInsert:se})=>[U,K,se.map(ce=>ce.rawResource)]),A=W.reverse();for(const{start:U,deleteCount:K,toInsert:se}of A){const ce=se.map(Ie=>Ie.handle),ve=this.n.splice(U,K,...ce);for(const Ie of ve)this.g.delete(Ie),this.h.delete(Ie),this.j.get(Ie)?.dispose(),this.j.delete(Ie)}return this.o=C,q}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.w,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let V;(0,m.$xG)(this.x,"quickDiffProvider")&&(V=C?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!C,quickDiffLabel:V})}get historyProvider(){return(0,m.$yG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(C){(0,m.$yG)(this.x,"scmHistoryProvider"),this.j=C,this.k.value=new O.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!C}),C&&this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(C){C!==this.m&&(this.m=C,this.#e.$updateSourceControl(this.w,{commitTemplate:C}))}get acceptInputCommand(){return this.o}set acceptInputCommand(C){this.n.value=new O.$Tc,this.o=C;const V=this.y.converter.toInternal(C,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:V})}get actionButton(){return(0,m.$yG)(this.x,"scmActionButton"),this.q}set actionButton(C){(0,m.$yG)(this.x,"scmActionButton"),this.p.value=new O.$Tc,this.q=C;const V=C!==void 0?{command:this.y.converter.toInternal(C.command,this.p.value),secondaryCommands:C.secondaryCommands?.map(W=>W.map(q=>this.y.converter.toInternal(q,this.p.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:V??null})}get statusBarCommands(){return this.t}set statusBarCommands(C){if(this.t&&C&&d(this.t,C))return;this.s.value=new O.$Tc,this.t=C;const V=(C||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:V})}get selected(){return this.u}constructor(C,V,W,q,A,U,K){this.x=C,this.y=q,this.z=A,this.A=U,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Vc,this.m=void 0,this.n=new O.$Vc,this.o=void 0,this.p=new O.$Vc,this.s=new O.$Vc,this.t=void 0,this.u=!1,this.v=new T.$be,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=W;const se=I.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${A}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new D(C,V,this.#e,this.w,se),this.#e.$registerSourceControl(this.w,A,U,K,se)}createResourceGroup(C,V,W){const q=(0,m.$xG)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,A=new f(this.#e,this.y,this.w,C,V,q,this.x),U=T.Event.once(A.onDidDispose)(()=>this.C.delete(A));return this.C.set(A,U),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const C=[],V=[];for(const[W,q]of this.C){q.dispose();const A=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});T.Event.once(W.onDidDispose)(()=>{this.D.delete(W),A.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),C.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const U=W._takeResourceStateSnapshot();U.length>0&&V.push([W.handle,U]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,C,V),this.C.clear()}eventuallyUpdateResourceStates(){const C=[];this.D.forEach(V=>{const W=V._takeResourceStateSnapshot();W.length!==0&&C.push([V.handle,W])}),C.length>0&&this.#e.$spliceResourceStates(this.w,C),this.D.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.u=C,this.v.fire(C)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$Vh)(100)],E.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$Vh)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,V,W,q){this.l=V,this.m=W,this.n=q,this.g=new Map,this.h=new y.$Nm,this.j=new T.$be,this.e=C.getProxy(p.$QM.MainThreadSCM),this.f=C.getProxy(p.$QM.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const U=this.g.get(A.sourceControlHandle);if(!U)return A;const K=U.getResourceGroup(A.groupHandle);return K?K.getResourceState(A.handle):A}else if(A&&A.$mid===4){const U=this.g.get(A.sourceControlHandle);return U?U.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const U=this.g.get(A.handle);return U||A}return A}})}createSourceControl(C,V,W,q){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,V,W,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const A=r.d++,U=new E(C,this.m,this.e,this.l,V,W,q);this.g.set(A,U);const K=this.h.get(C.identifier)||[];return K.push(U),this.h.set(C.identifier,K),U}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const V=this.h.get(C.identifier),W=V&&V[V.length-1];return W&&W.inputBox}$provideOriginalResource(C,V,W){const q=I.URI.revive(V);this.n.trace("ExtHostSCM#$provideOriginalResource",C,q.toString());const A=this.g.get(C);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$ih)(()=>A.quickDiffProvider.provideOriginalResource(q,W)).then(U=>U||null)}$onInputBoxValueChange(C,V){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const W=this.g.get(C);return W&&W.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(C,V,W,q){this.n.trace("ExtHostSCM#$executeResourceCommand",C,V,W);const A=this.g.get(C);if(!A)return Promise.resolve(void 0);const U=A.getResourceGroup(V);return U?U.$executeResourceCommand(W,q):Promise.resolve(void 0)}$validateInput(C,V,W){this.n.trace("ExtHostSCM#$validateInput",C);const q=this.g.get(C);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,M.$ih)(()=>q.inputBox.validateInput(V,W)).then(A=>{if(!A)return Promise.resolve(void 0);const U=v.MarkdownString.fromStrict(A.message);return U?Promise.resolve([U,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(C,V,W,q){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,W,q)??void 0}async $provideHistoryItems(C,V,W,q){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(V,W,q))?.map(K=>({...K,icon:h(K)}))??void 0}async $provideHistoryItemSummary(C,V,W,q){const A=this.g.get(C)?.historyProvider;if(typeof A?.provideHistoryItemSummary!="function")return;const U=await A.provideHistoryItemSummary(V,W,q);return U?{...U,icon:h(U)}:void 0}async $provideHistoryItemChanges(C,V,W,q){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(V,W,q)??void 0}};e.$4lc=w,e.$4lc=w=r=Je([Ve(3,N.$Wj)],w)}),define(Re[272],Ae([1,0,4,8,2]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;class O{static{this.a=0}constructor(p,g){this.d=g,this.c=new Map,this.b=p.getProxy(I.$QM.MainThreadShare)}async $provideShare(p,g,k){return await this.c.get(p)?.provideShare({selection:T.Range.to(g.selection),resourceUri:R.URI.revive(g.resourceUri)},k)??void 0}registerShareProvider(p,g){const k=O.a++;return this.c.set(k,g),this.b.$registerShareProvider(k,T.DocumentSelector.from(p,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$5lc=O}),define(Re[273],Ae([1,0,7,4,169,6,8,17]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=e.$7lc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$PN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$PN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,v,m,s,o,r=I.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new O.$Tc,this.#e=u,this.#t=v,o&&s){this.c=(0,I.$rN)(s.identifier,o);const t=m.get(this.c);t&&(r=t.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,n=t.priority,this.j=!0,this.name=t.name,this.text=t.text,this.tooltip=t.tooltip,this.command=t.command,this.accessibilityInformation=t.accessibilityInformation)}else this.c=String(g.a++);this.e=s,this.f=o,this.g=r,this.h=this.u(n)}u(u){if((0,p.$8f)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!g.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new O.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let v;this.m?v=this.m:v=(0,R.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=g.b.get(this.o.id));const s=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,v,this.k,s,this.r?.internal,m,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$7lc=g;class k{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const v={message:u};return this.b.unshift(v),this.c(),new I.$SM(()=>{const m=this.b.indexOf(v);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class N{constructor(u,v){this.e=new Map,this.a=u.getProxy(T.$QM.MainThreadStatusBar),this.b=v,this.c=new k(this)}$acceptStaticEntries(u){for(const v of u)this.e.set(v.entryId,v)}createStatusBarEntry(u,v,m,s){return new g(this.a,this.b,this.e,u,v,m,s)}setStatusBarMessage(u,v){const m=this.c.setMessage(u);let s;return typeof v=="number"?s=setTimeout(()=>m.dispose(),v):typeof v<"u"&&v.then(()=>m.dispose(),()=>m.dispose()),new I.$SM(()=>{m.dispose(),clearTimeout(s)})}}e.$8lc=N}),define(Re[113],Ae([1,0,29,105,50,75,61,8,2]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=e.$rP=e.$qP=e.$pP=void 0;const k=(t,c,h,i)=>{let b=c;return{enumerable:!0,configurable:!1,get(){return b},set(a){if(!h(b,a)){const $=b;b=a,t.listener?.(i(a,$))}}}},N=(t,c)=>t===c,y={range:(t,c)=>t===c?!0:!t||!c?!1:t.isEqual(c),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(t,c)=>!(t.length!==c.length||t.some(h=>!c.find(i=>h.id===i.id)))},u=t=>c=>({op:4,update:t(c)}),v=(t,c)=>({range:(()=>{let h;const i=u(b=>({range:I.$kt.lift(p.Range.from(b))}));return{enumerable:!0,configurable:!1,get(){return h},set(b){t.listener?.({op:6}),y.range(h,b)||(h=b,t.listener?.(i(b)))}}})(),label:k(t,c,y.label,u(h=>({label:h}))),description:k(t,void 0,y.description,u(h=>({description:h}))),sortText:k(t,void 0,y.sortText,u(h=>({sortText:h}))),canResolveChildren:k(t,!1,y.canResolveChildren,h=>({op:2,state:h})),busy:k(t,!1,y.busy,u(h=>({busy:h}))),error:k(t,void 0,y.error,u(h=>({error:p.MarkdownString.fromStrict(h)||null}))),tags:k(t,[],y.tags,(h,i)=>({op:1,new:h.map(p.TestTag.from),old:i.map(p.TestTag.from)}))}),m=t=>{const c=R.$CL.fromString(t.extId),h=new o(c.controllerId,c.localId,t.label,g.URI.revive(t.uri)||void 0);return h.range=p.Range.to(t.range||void 0),h.description=t.description||void 0,h.sortText=t.sortText||void 0,h.tags=t.tags.map(i=>p.TestTag.to({id:(0,M.$IL)(i).tagId})),h},s=t=>{let c;for(const h of t.tests){const i=m(h.item);(0,T.$_O)(i).parent=c,c=i}return c};e.$pP=s;class o{constructor(c,h,i,b){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const a=(0,T.$$O)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:b,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof r?void 0:a.parent}},children:{value:(0,O.$0O)(a,T.$_O,o),enumerable:!0,writable:!1},...v(a,i)})}}e.$qP=o;class r extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$rP=r;class n extends O.$6O{constructor(c,h,i){super({controllerId:c,getDocumentVersion:b=>b&&i.getDocument(b)?.version,getApiFor:T.$_O,getChildren:b=>b.children,root:new r(c,h),toITestItem:p.TestItem.from})}}e.$sP=n}),define(Re[32],Ae([1,0,17,7,8,26,4,18,13,53,29,93,2,6,3,16,113,23,34,43,65,59,62,35]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=void 0;let a=class{#e;#t;#i;constructor(f,E,w){this.b=new Map,this.c=new Map,this.#e=f.getProxy(M.$QM.MainThreadCommands),this.d=E,this.#i=w,this.#t=f.getProxy(M.$QM.MainThreadTelemetry),this.converter=new $(this,P=>{const C=this.c.get(P);return C?.result===S.Void?C:void 0},E),this.f=[{processArgument(P){return(0,k.$Zh)(P)}},{processArgument(P){return(0,O.$Yn)(P,function(C){if(N.$kt.isIRange(C))return R.Range.to(C);if(y.$jt.isIPosition(C))return R.Position.to(C);if(N.$kt.isIRange(C.range)&&u.URI.isUri(C.uri))return R.location.to(C);if(C instanceof r.$Ce)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const E=this.registerCommand(!1,f.id,async(...w)=>{const P=f.args.map((V,W)=>{if(!V.validate(w[W]))throw new Error(`Invalid argument '${V.name}' when running '${f.id}', received: ${typeof w[W]=="object"?JSON.stringify(w[W],null,"	"):w[W]} `);return V.convert(w[W])}),C=await this.executeCommand(f.internalId,...P);return f.result.convert(C,w,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new T.$SM(()=>{E.dispose(),this.c.delete(f.id)})}registerCommand(f,E,w,P,C,V){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:w,thisArg:P,metadata:C,extension:V}),f&&this.#e.$registerCommand(E),new T.$SM(()=>{this.b.delete(E)&&f&&this.#e.$unregisterCommand(E)})}executeCommand(f,...E){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,E,!0)}async g(f,E,w){if(this.b.has(f))return this.#e.$fireCommandActivationEvent(f),this.h(f,E,!1);{let P=!1;const C=(0,O.$Yn)(E,function(V){if(V instanceof T.$TM)return R.Position.from(V);if(V instanceof T.$UM)return R.Range.from(V);if(V instanceof T.$5M)return R.location.from(V);if(T.$hO.isNotebookRange(V))return R.NotebookRange.from(V);if(V instanceof ArrayBuffer)return P=!0,r.$Ce.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return P=!0,r.$Ce.wrap(V);if(V instanceof r.$Ce)return P=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(f,P?new n.$mw(C):C,w);return(0,k.$Zh)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(f,E,!1);throw V}}}async h(f,E,w){const P=this.b.get(f);if(!P)throw new Error("Unknown command");const{callback:C,thisArg:V,metadata:W}=P;if(W?.args)for(let A=0;A<W.args.length;A++)try{(0,I.$ig)(E[A],W.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${W.args[A].name}' - ${W.args[A].description}`)}const q=c.$0d.create();try{return await C.apply(V,E)}catch(A){if(f===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...E);U&&(f=U.command)}if(this.d.error(A,f,P.extension?.identifier),!w)throw A;if(P.extension?.identifier){const U=this.#i.onExtensionError(P.extension.identifier,A);this.d.trace("forwarded error to extension?",U,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,t.$bj)(A)),this.id=f,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,f,q.elapsed())}}j(f,E,w){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new h.$_o(E),duration:w})}$executeContributedCommand(f,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const w=this.b.get(f);return w?(E=E.map(P=>this.f.reduce((C,V)=>V.processArgument(C,w.extension?.identifier),P)),this.h(f,E,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(E=>(f&&(E=E.filter(w=>w[0]!=="_")),E))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[E,w]of this.b){const{metadata:P}=w;P&&(f[E]=P)}return Promise.resolve(f)}};e.$yP=a,e.$yP=a=Je([Ve(0,s.$dP),Ve(1,g.$Wj),Ve(2,i.$xP)],a),e.$zP=(0,m.$qi)("IExtHostCommands");class ${constructor(f,E,w){this.d=f,this.f=E,this.g=w,this.delegatingCommandId=`__vsc${(0,b.$Mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,E){if(!f)return;const w={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return w;const P=this.f(f.command);if(P)w.id=P.internalId,w.arguments=P.args.map((C,V)=>C.convert(f.arguments&&f.arguments[V]));else if((0,p.$Lb)(f.arguments)){const C=`${f.command} /${++this.c}`;this.b.set(C,f),E.add((0,v.$Sc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),w.$ident=C,w.id=this.delegatingCommandId,w.arguments=[C],this.g.trace("CommandsConverter#CREATE",f.command,C)}return w}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const E=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$AP=$;class l{static{this.Uri=new l("uri","Uri of a text document",f=>u.URI.isUri(f),f=>f)}static{this.Position=new l("position","A position in a text document",f=>T.$TM.isPosition(f),R.Position.from)}static{this.Range=new l("range","A range in a text document",f=>T.$UM.isRange(f),R.Range.from)}static{this.Selection=new l("selection","A selection in a text document",f=>T.$VM.isSelection(f),R.Selection.from)}static{this.Number=new l("number","",f=>typeof f=="number",f=>f)}static{this.String=new l("string","",f=>typeof f=="string",f=>f)}static{this.StringArray=l.Arr(l.String)}static Arr(f){return new l(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,E=>Array.isArray(E)&&E.every(w=>f.validate(w)),E=>E.map(w=>f.convert(w)))}static{this.CallHierarchyItem=new l("item","A call hierarchy item",f=>f instanceof T.$dN,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new l("item","A type hierarchy item",f=>f instanceof T.$BO,R.TypeHierarchyItem.from)}static{this.TestItem=new l("testItem","A VS Code TestItem",f=>f instanceof o.$qP,R.TestItem.from)}constructor(f,E,w,P){this.name=f,this.description=E,this.validate=w,this.convert=P}optional(){return new l(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,E){return new l(f??this.name,E??this.description,this.validate,this.convert)}}e.$BP=l;class S{static{this.Void=new S("no result",f=>f)}constructor(f,E){this.description=f,this.convert=E}}e.$CP=S;class d{constructor(f,E,w,P,C){this.id=f,this.internalId=E,this.description=w,this.args=P,this.result=C}}e.$DP=d}),define(Re[274],Ae([1,0,18,12,2,87,97,31,32,8,7]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=void 0;const y=[new g.$DP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$BP.Uri,g.$BP.Position],new g.$CP("A promise that resolves to an array of DocumentHighlight-instances.",v(k.DocumentHighlight.to))),new g.$DP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$BP.Uri],new g.$CP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,I.$Kb)(s))return;class r extends N.$$M{static to(t){const c=new r(t.name,k.SymbolKind.to(t.kind),t.containerName||"",new N.$5M(o[0],k.Range.to(t.range)));return c.detail=t.detail,c.range=c.location.range,c.selectionRange=k.Range.to(t.selectionRange),c.children=t.children?t.children.map(r.to):[],c}}return s.map(r.to)})),new g.$DP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$BP.Uri,new g.$BP("options","Formatting options",s=>!0,s=>s)],new g.$CP("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new g.$DP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$BP.Uri,g.$BP.Range,new g.$BP("options","Formatting options",s=>!0,s=>s)],new g.$CP("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new g.$DP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$BP.Uri,g.$BP.Position,new g.$BP("ch","Trigger character",s=>typeof s=="string",s=>s),new g.$BP("options","Formatting options",s=>!0,s=>s)],new g.$CP("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new g.$DP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$BP.Uri,g.$BP.Position],new g.$CP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$DP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$BP.Uri,g.$BP.Position],new g.$CP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$DP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$BP.Uri,g.$BP.Position],new g.$CP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$DP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$BP.Uri,g.$BP.Position],new g.$CP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$DP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$BP.Uri,g.$BP.Position],new g.$CP("A promise that resolves to an array of Location-instances.",v(k.location.to))),new g.$DP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$BP.Uri,g.$BP.Position],new g.$CP("A promise that resolves to an array of Hover-instances.",v(k.Hover.to))),new g.$DP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$BP.Uri,new g.$BP("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>N.$TM.isPosition(o)),s=>s.map(k.Position.from))],new g.$CP("A promise that resolves to an array of ranges.",s=>s.map(o=>{let r;for(const n of o.reverse())r=new N.$cN(k.Range.to(n),r);return r}))),new g.$DP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$BP.String.with("query","Search string")],new g.$CP("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(k.WorkspaceSymbol.to))),new g.$DP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$BP.Uri,g.$BP.Position],new g.$CP("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(k.CallHierarchyItem.to))),new g.$DP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$BP.CallHierarchyItem],new g.$CP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(k.CallHierarchyIncomingCall.to))),new g.$DP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$BP.CallHierarchyItem],new g.$CP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(k.CallHierarchyOutgoingCall.to))),new g.$DP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$BP.Uri,g.$BP.Position],new g.$CP("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:k.Range.to(s.range),placeholder:s.text}})),new g.$DP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$BP.Uri,g.$BP.Position,g.$BP.String.with("newName","The new symbol name")],new g.$CP("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return k.WorkspaceEdit.to(s)}})),new g.$DP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$BP.Uri,g.$BP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$CP("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(k.DocumentLink.to))),new g.$DP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$BP.Uri],new g.$CP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new N.$$N(s.tokenTypes,s.tokenModifiers)})),new g.$DP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$BP.Uri],new g.$CP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$xbb)(s);if(o.type==="full")return new N.$aO(o.data,void 0)})),new g.$DP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$BP.Uri,g.$BP.Range.optional()],new g.$CP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new N.$$N(s.tokenTypes,s.tokenModifiers)})),new g.$DP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$BP.Uri,g.$BP.Range],new g.$CP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$xbb)(s);if(o.type==="full")return new N.$aO(o.data,void 0)})),new g.$DP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$BP.Uri,g.$BP.Position,g.$BP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$BP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$CP("A promise that resolves to a CompletionList-instance.",(s,o,r)=>{if(!s)return new N.$oN([]);const n=s.suggestions.map(t=>k.CompletionItem.to(t,r));return new N.$oN(n,s.incomplete)})),new g.$DP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$BP.Uri,g.$BP.Position,g.$BP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$CP("A promise that resolves to SignatureHelp.",s=>{if(s)return k.SignatureHelp.to(s)})),new g.$DP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$BP.Uri,g.$BP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$CP("A promise that resolves to an array of CodeLens-instances.",(s,o,r)=>v(n=>new N.$gN(k.Range.to(n.range),n.command&&r.fromInternal(n.command)))(s))),new g.$DP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$BP.Uri,new g.$BP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>N.$UM.isRange(s),s=>N.$VM.isSelection(s)?k.Selection.from(s):k.Range.from(s)),g.$BP.String.with("kind","Code action kind to return code actions for").optional(),g.$BP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$CP("A promise that resolves to an array of Command-instances.",(s,o,r)=>v(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(n.command)}else{const t=new N.$aN(n.title,n.kind?new N.$bN(n.kind):void 0);return n.edit&&(t.edit=k.WorkspaceEdit.to(n.edit)),n.command&&(t.command=r.fromInternal(n.command)),t.isPreferred=n.isPreferred,t}})(s))),new g.$DP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$BP.Uri],new g.$CP("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new N.$uN(k.Range.to(o.range),k.Color.to(o.color))):[])),new g.$DP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$BP("color","The color to show and insert",s=>s instanceof N.$tN,k.Color.from),new g.$BP("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:k.Range.from(s.range)}))],new g.$CP("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(k.ColorPresentation.to):[])),new g.$DP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$BP.Uri,g.$BP.Range],new g.$CP("A promise that resolves to an array of Inlay objects",(s,o,r)=>s.map(k.InlayHint.to.bind(void 0,r)))),new g.$DP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$BP.Uri],new g.$CP("A promise that resolves to an array of FoldingRange objects",(s,o)=>{if(s)return s.map(k.FoldingRange.to)})),new g.$DP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$CP("A promise that resolves to an array of NotebookContentProvider static info objects.",v(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new g.$DP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$BP.Uri,g.$BP.Range,new g.$BP("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof N.$UM,s=>k.InlineValueContext.from(s))],new g.$CP("A promise that resolves to an array of InlineValue objects",s=>s.map(k.InlineValue.to))),new g.$DP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$BP("uriOrString","Uri-instance or string (only http/https)",s=>R.URI.isUri(s)||typeof s=="string"&&(0,T.$Ag)(s,T.Schemas.http,T.Schemas.https),s=>s),new g.$BP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional(),g.$BP.String.with("label","").optional()],g.$CP.Void),new g.$DP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$BP.Uri.with("resource","Resource to open"),g.$BP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$BP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional()],g.$CP.Void),new g.$DP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$BP.Uri.with("left","Left-hand side resource of the diff editor"),g.$BP.Uri.with("right","Right-hand side resource of the diff editor"),g.$BP.String.with("title","Human readable title for the diff editor").optional(),new g.$BP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)]).optional()],g.$CP.Void),new g.$DP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$BP.String.with("title","Human readable title for the changes editor"),new g.$BP("resourceList","List of resources to compare",s=>{for(const o of s){if(o.length!==3)return!1;const[r,n,t]=o;if(!R.URI.isUri(r)||!R.URI.isUri(n)&&n!==void 0&&n!==null||!R.URI.isUri(t)&&t!==void 0&&t!==null)return!1}return!0},s=>s)],g.$CP.Void),new g.$DP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$BP.Uri,g.$BP.Position],new g.$CP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new g.$DP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$BP.TypeHierarchyItem],new g.$CP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new g.$DP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$BP.TypeHierarchyItem],new g.$CP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new g.$DP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$BP.TestItem],g.$CP.Void),new g.$DP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$BP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$CP.Void),new g.$DP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$BP.String.with("name","The context key name"),new g.$BP("value","The context key value",()=>!0,s=>s)],g.$CP.Void),new g.$DP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$BP.Uri,g.$BP.StringArray,new g.$BP("MappedEditsContext","Mapped Edits Context",s=>k.MappedEditsContext.is(s),s=>k.MappedEditsContext.from(s))],new g.$CP("A promise that resolves to a workspace edit or null",s=>s?k.WorkspaceEdit.to(s):null))];class u{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",p.$pj)}}e.$qkc=u;function v(s){return o=>{if(Array.isArray(o))return o.map(s)}}function m(s){if(!Array.isArray(s))return;const o=[];for(const r of s)O.$2t(r)?o.push(k.DefinitionLink.to(r)):o.push(k.location.to(r));return o}}),define(Re[275],Ae([1,0,11,6,2,4,32,8,7]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;class k{static{this.a=0}constructor(v,m){this.extension=v,this.provider=m,this.handle=k.a++}}class N{constructor(v){this.session=v,this.responses=[]}}class y{static{this.a=0}constructor(v,m,s,o){this.f=s,this.g=o,this.b=new Map,this.d=new Map,this.e=v.getProxy(O.$QM.MainThreadInlineChat),m.registerApiCommand(new M.$DP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$BP("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?p.Range.from(r.initialRange):void 0,initialSelection:g.$VM.isSelection(r.initialSelection)?p.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?p.Position.from(r.position):void 0}})],M.$CP.Void))}registerProvider(v,m,s){const o=new k(v,m);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,s?.label??v.displayName??v.name,v.identifier,typeof m.handleInteractiveEditorResponseFeedback=="function",typeof m.provideFollowups=="function",s?.supportReportIssue??!1),(0,T.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(v,m,s,o){const r=this.b.get(v);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(R.URI.revive(m)),t=p.Selection.to(s),c=await r.provider.prepareInteractiveEditorSession({document:n,selection:t},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(t))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=y.a++;return this.d.set(h,new N(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:p.Range.from(c.wholeRange),message:c.message}}async $provideResponse(v,m,s,o){const r=this.b.get(v);if(!r)return;const n=this.d.get(m.id);if(!n)return;const t={prompt:s.prompt,selection:p.Selection.to(s.selection),wholeRange:p.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(R.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let c=!1;const h={report:async D=>{if(!s.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:D.message,edits:D.edits?.map(p.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:g.$hN.isMarkdownString(D.content)?D.content.value:D.content})}},i=Promise.resolve(r.provider.provideInteractiveEditorResponse(n.session,t,h,o));let b;try{b=await(0,I.$eh)(i,o)}finally{c=!0}if(!b)return;const a=n.responses.push(b)-1,$={wholeRange:p.Range.from(b.wholeRange),placeholder:b.placeholder};if(!y.h(b))return{...$,id:a,type:"editorEdit",message:p.MarkdownString.from(b.contents),edits:[]};const{edits:l,contents:S}=b,d=S!==void 0?p.MarkdownString.from(S):void 0;return l instanceof g.$3M?{...$,id:a,type:"bulkEdit",edits:p.WorkspaceEdit.from(l),message:d}:{...$,id:a,type:"editorEdit",edits:l.map(p.TextEdit.from),message:d}}async $provideFollowups(v,m,s,o){const r=this.b.get(v),n=this.d.get(m),t=n?.responses[s];if(r&&t&&r.provider.provideFollowups){const c=Promise.resolve(r.provider.provideFollowups(n.session,t,o));return(await(0,I.$eh)(c,o))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(v,m,s,o){const r=this.b.get(v),n=this.d.get(m),t=n?.responses[s];if(r&&t){const c=p.InteractiveEditorResponseFeedbackKind.to(o);r.provider.handleInteractiveEditorResponseFeedback?.(n.session,t,c)}}$releaseSession(v,m){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$zlc=y}),define(Re[276],Ae([1,0,2,32]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class R{constructor(M,p,g,k,N){this.a=p,this.b=g,this.c=k;const y=new T.$DP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$BP("showOptions","Show Options",u=>!0,u=>u),new T.$BP("resource","Interactive resource Uri",u=>!0,u=>u),new T.$BP("controllerId","Notebook controller Id",u=>!0,u=>u),new T.$BP("title","Interactive editor title",u=>!0,u=>u)],new T.$CP("Notebook and input URI",u=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const v=this.a.getEditorById(u.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:v.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(M,p,g,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:g,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$Mlc=R}),define(Re[277],Ae([1,0,18,11,22,5,6,28,2,20,13,4,32,8,7,76,218,25,34,219]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=void 0,e.$Ulc=l;let c=class{constructor(d,D,f,E,w){this.m=D,this.n=f,this.o=E,this.q=w,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$be,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=d.getProxy(y.$QM.MainThreadNotebookKernels);const P=new u.$DP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$BP("options","Select kernel options",V=>!0,V=>{if(V&&"notebookEditor"in V&&"id"in V){const W=this.n.getIdByEditor(V.notebookEditor);return{id:V.id,extension:V.extension,notebookEditorId:W}}else if(V&&"notebookEditor"in V){const W=this.n.getIdByEditor(V.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${V.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return V})],u.$CP.Void),C=new u.$DP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$BP.Uri],new u.$CP("A promise that resolves to an array of variables",(V,W)=>V.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(C)}createNotebookController(d,D,f,E,w,P){for(const Ce of this.j.values())if(Ce.controller.id===D&&k.$Lm.equals(d.identifier,Ce.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const C=this.k++,V=this;this.q.trace(`NotebookController[${C}], CREATED by ${d.identifier.value}, ${D}`);const W=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${d.identifier}'`);let q=!1;const A=new O.$be,U=new O.$be,K={id:l(d.identifier,D),notebookType:f,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:E||d.identifier.value,preloads:P?P.map(v.NotebookRendererScript.from):[]};let se=w??W,ce,ve;this.a.$addKernel(C,K).catch(Ce=>{console.log(Ce),q=!0});let Ie=0;const ue=()=>{if(q)return;const Ce=++Ie;Promise.resolve().then(()=>{Ce===Ie&&this.a.$updateKernel(C,K)})},be=new p.$Bc,ie={get id(){return D},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return K.label},set label(Ce){K.label=Ce??d.displayName??d.name,ue()},get detail(){return K.detail??""},set detail(Ce){K.detail=Ce,ue()},get description(){return K.description??""},set description(Ce){K.description=Ce,ue()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(Ce){K.supportedLanguages=Ce,ue()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(Ce){K.supportsExecutionOrder=Ce,ue()},get rendererScripts(){return K.preloads?K.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return se},set executeHandler(Ce){se=Ce??W},get interruptHandler(){return ce},set interruptHandler(Ce){ce=Ce,K.supportsInterrupt=!!Ce,ue()},set variableProvider(Ce){(0,r.$yG)(d,"notebookVariableProvider"),ve=Ce,K.hasVariableProvider=!!Ce,Ce?.onDidChangeVariables(Fe=>V.a.$variablesUpdated(Fe.uri)),ue()},get variableProvider(){return ve},createNotebookCellExecution(Ce){if(q)throw new Error("notebook controller is DISPOSED");if(!be.has(Ce.notebook.uri))throw V.q.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(be.keys()).map(Fe=>Fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ce.notebook.uri.toString()}`);return V._createNotebookCellExecution(Ce,l(d.identifier,this.id))},createNotebookExecution(Ce){if((0,r.$yG)(d,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!be.has(Ce.uri))throw V.q.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(be.keys()).map(Fe=>Fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ce.uri.toString()}`);return V._createNotebookExecution(Ce,l(d.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${C}], DISPOSED`),q=!0,this.j.delete(C),A.dispose(),U.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(Ce,Fe){Fe===m.NotebookControllerAffinity2.Hidden&&(0,r.$yG)(d,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(C,Ce.uri,Fe)},onDidReceiveMessage:U.event,postMessage(Ce,Fe){return(0,r.$yG)(d,"notebookMessaging"),V.a.$postMessage(C,Fe&&V.n.getIdByEditor(Fe),Ce)},asWebviewUri(Ce){return(0,r.$yG)(d,"notebookMessaging"),(0,s.$Uxb)(Ce,V.m.remote)}};return this.j.set(C,{extensionId:d.identifier,controller:ie,onDidReceiveMessage:U,onDidChangeSelection:A,associatedNotebooks:be}),ie}getIdByController(d){for(const[D,f]of this.j)if(f.controller===d)return l(f.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,D){const f=this.g++,E=this;this.q.trace(`NotebookControllerDetectionTask[${f}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(f,D);const w={dispose:()=>{this.f.delete(f),E.a.$removeKernelDetectionTask(f)}};return this.f.set(f,w),w}registerKernelSourceActionProvider(d,D,f){const E=this.i++,w=typeof f.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,P=this;this.h.set(E,f),this.q.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(E,E,D);let C;return w!==void 0&&(C=f.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(E),P.a.$removeKernelSourceActionProvider(E,E),C?.dispose()}}}async $provideKernelSourceActions(d,D){const f=this.h.get(d);if(f){const E=new M.$Tc;return(await f.provideNotebookKernelSourceActions(D)??[]).map(P=>v.NotebookKernelSourceAction.from(P,this.o.converter,E))}return[]}$acceptNotebookAssociation(d,D,f){const E=this.j.get(d);if(E){const w=this.n.getNotebookDocument(g.URI.revive(D));f?E.associatedNotebooks.set(w.uri,!0):E.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,w.uri.toString(),f),E.onDidChangeSelection.fire({selected:f,notebook:w.apiNotebook})}}async $executeCells(d,D,f){const E=this.j.get(d);if(!E)return;const w=this.n.getNotebookDocument(g.URI.revive(D)),P=[];for(const C of f){const V=w.getCell(C);V&&P.push(V.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,w.uri.toString(),P.length),await E.controller.executeHandler.call(E.controller,P,w.apiNotebook,E.controller)}catch(C){this.q.error(`NotebookController[${d}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(d,D,f){const E=this.j.get(d);if(!E)return;const w=this.n.getNotebookDocument(g.URI.revive(D));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,w.apiNotebook);else for(const P of f){const C=w.getCell(P);C&&this.b.get(C.uri)?.cancel()}if(E.controller.interruptHandler){const P=this.c.get(w.uri);f.length&&Array.isArray(P)&&P.length&&P.forEach(C=>C.dispose())}}async $provideVariables(d,D,f,E,w,P,C){const V=this.j.get(d);if(!V)return;const W=this.n.getNotebookDocument(g.URI.revive(f)),q=V.controller.variableProvider;if(!q)return;let A;if(E!==void 0){if(A=this.s[E],!A)return}else this.s={};const U=w==="named"?m.NotebookVariablesRequestKind.Named:m.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(W.apiNotebook,A,U,P,C);let se=0;for await(const ce of K){if(C.isCancellationRequested)return;const ve={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:V.extensionId.value};if(this.s[ve.id]=ce.variable,this.a.$receiveVariable(D,ve),se++>=t.$zib)return}}$acceptKernelMessageFromRenderer(d,D,f){const E=this.j.get(d);if(!E)return;const w=this.n.getEditorById(D);E.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:f}))}$cellExecutionChanged(d,D,f){const w=this.n.getNotebookDocument(g.URI.revive(d)).getCell(D);if(w){const P=f?v.NotebookCellExecutionState.to(f):m.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:w.apiCell,state:P})}}_createNotebookCellExecution(d,D){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!E)throw new Error("invalid cell");if(this.b.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const w=new i(D,E,this.a);this.b.set(E.uri,w);const P=w.onDidChangeState(()=>{w.state===h.Resolved&&(w.dispose(),P.dispose(),this.b.delete(E.uri))});return w.asApiObject()}_createNotebookExecution(d,D){const f=this.n.getNotebookDocument(d.uri),E=d.getCells().find(C=>{const V=f.getCellFromApiCell(C);return V&&this.b.has(V.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this.c.has(f.uri))throw new Error(`duplicate notebook execution for ${f.uri}`);const w=new a(D,f,this.a),P=w.onDidChangeState(()=>{w.state===b.Resolved&&(w.dispose(),P.dispose(),this.c.delete(f.uri))});return this.c.set(f.uri,[w,P]),w.asApiObject()}};e.$Tlc=c,e.$Tlc=c=Je([Ve(4,N.$Wj)],c);var h;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(h||(h={}));class i extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(d,D,f){super(),this.m=D,this.n=f,this.b=i.a++,this.c=new O.$be,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new R.$me),this.h=new $(10,E=>this.s(E)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const D=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new n.$mw(D))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let D=this.m;if(d&&(D=this.m.notebook.getCellFromApiCell(d)),!D)throw new Error("INVALID cell");return D.handle}y(d){return d.map(D=>{const f=m.$lO.ensureUniqueMimeTypes(D.items,!0);return f===D.items?v.NotebookCellOutput.from(D):v.NotebookCellOutput.from({items:f,id:D.id,metadata:D.metadata})})}async z(d,D,f){const E=this.w(D),w=this.y((0,I.$3b)(d));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:E,append:f,outputs:w})}async C(d,D,f){return d=m.$lO.ensureUniqueMimeTypes((0,I.$3b)(d),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:d.map(v.NotebookCellOutputItem.from),outputId:D.id,append:f})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(f){d.j=f,d.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(f){if(d.f===h.Resolved||d.f===h.Started)throw new Error("Cannot call start again");d.f=h.Started,d.c.fire(),d.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,E,w){if(d.f===h.Resolved)throw new Error("Cannot call resolve twice");d.f=h.Resolved,d.c.fire(),d.h.flush();const P=w?{message:w.message,stack:w.stack,location:w?.location?{startLineNumber:w.location.start.line,startColumn:w.location.start.character,endLineNumber:w.location.end.line,endColumn:w.location.end.character}:void 0,uri:w.uri}:void 0;d.n.$completeExecution(d.b,new n.$mw({runEndTime:E,lastRunSuccess:f,error:P}))},clearOutput(f){return d.t(),d.z([],f,!1)},appendOutput(f,E){return d.t(),d.z(f,E,!0)},replaceOutput(f,E){return d.t(),d.z(f,E,!1)},appendOutputItems(f,E){return d.t(),d.C(f,E,!0)},replaceOutputItems(f,E){return d.t(),d.C(f,E,!1)}})}}var b;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(b||(b={}));class a extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(d,D,f){super(),this.h=D,this.j=f,this.b=a.a++,this.c=new O.$be,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new R.$me),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===b.Resolved||this.f===b.Started)throw new Error("Cannot call start again");this.f=b.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===b.Resolved)throw new Error("Cannot call resolve twice");this.f=b.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class ${constructor(d,D){this.f=d,this.g=D,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new T.$Nh,this.b=Date.now(),(0,T.$rh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>d.complete())}}function l(S,d){return`${S.value}/${d}`}}),define(Re[51],Ae([1,0,5,4,3,2,16,6,7,171,14,200,22,35,201,42,11,8,32]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=e.$7kc=e.$6kc=e.$5kc=void 0,e.$5kc=(0,R.$qi)("IExtHostTerminalService");class t extends p.$Uc{constructor(f,E,w,P){super(),this.u=f,this._id=E,this.w=w,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new I.$be),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(V=>this.g=V);const C=this;this.value={get name(){return C.y||""},get processId(){return C.b},get creationOptions(){return C.w},get exitStatus(){return C.j},get state(){return C.m},get selection(){return C.n},get shellIntegration(){return C.shellIntegration},sendText(V,W=!0){C.C(),C.u.$sendText(C._id,V,W)},show(V){C.C(),C.u.$show(C._id,V)},hide(){C.C(),C.u.$hide(C._id)},dispose(){C.a||(C.a=!0,C.u.$dispose(C._id))},get dimensions(){if(!(C.f===void 0||C.h===void 0))return{columns:C.f,rows:C.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??E?.cwd??void 0,env:f.env??void 0,icon:l(f.iconPath)??void 0,color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.z(f.location,E?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,E,w,P,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:s.ThemeColor.isThemeColor(C)?C.id:void 0,location:E?.location||this.z(f,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,E){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in f?{viewColumn:r.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,E){this.j=Object.freeze({code:f,reason:E})}setDimensions(f,E){return f===this.f&&E===this.h||f===0||E===0?!1:(this.f=f,this.h=E,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(E=>{E!==f&&(this.b=Promise.resolve(f))})}}e.$6kc=t;class c{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new I.$be,this.onProcessData=this.a.event,this.b=new I.$be,this.d=new I.$be,this.onDidChangeProperty=this.d.event,this.f=new I.$be,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,E){this.g.setDimensions?.({columns:f,rows:E})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,E,w){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$be,this.onDidCloseTerminal=this.H.event,this.I=new I.$be,this.onDidOpenTerminal=this.I.event,this.J=new I.$be,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$be,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$be,this.onDidChangeTerminalState=this.M.event,this.N=new I.$be,this.onDidChangeShell=this.N.event,this.O=new I.$be({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$be({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(T.$QM.MainThreadTerminalService),this.y=new m.$Usb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:P=>{const C=V=>{const W=V;return this.getTerminalById(W.instanceId)?.value};switch(P?.$mid){case 15:return C(P);default:{if(Array.isArray(P))for(let V=0;V<P.length&&P[V].$mid===15;V++)P[V]=C(P[V]);return P}}}}),this.B({dispose:()=>{for(const[P,C]of this.g)C.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,E){const w=new t(this.a,(0,v.$Mg)(),f,f.name),P=new c(f.pty);return w.createExtensionTerminal(f.location,E,this.R(f,E).resolvedExtHostIdentifier,l(f.iconPath),S(f.color)).then(C=>{const V=this.S(C,P);this.h[C]=V}),this.f.push(w),w.value}R(f,E){if(E=E||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const w=f.location.parentTerminal;if(w){const P=this.f.find(C=>C.value===w);P&&(E.resolvedExtHostIdentifier=P._id)}}else f.location&&typeof f.location!="object"?E.location=f.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(f,E){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const P=new c(E),C=this.S(f,P);this.h[f]=C}async $acceptActiveTerminalChanged(f){const E=this.b;if(f===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const w=this.getTerminalById(f);w&&(this.b=w,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,E){const w=this.getTerminalById(f);w&&this.O.fire({terminal:w.value,data:E})}async $acceptTerminalDimensions(f,E,w){const P=this.getTerminalById(f);P&&P.setDimensions(E,w)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(f,E){const w=this.getTerminalById(f);w&&this.P.fire({terminal:w.value,...E})}async $acceptTerminalMaximumDimensions(f,E,w){this.g.get(f)?.resize(E,w)}async $acceptTerminalTitleChange(f,E){const w=this.getTerminalById(f);w&&(w.name=E)}async $acceptTerminalClosed(f,E,w){const P=this.X(this.f,f);if(P!==null){const C=this.f.splice(P,1)[0];C.setExitStatus(E,w),this.H.fire(C.value)}}$acceptTerminalOpened(f,E,w,P){if(E){const W=this.X(this.f,E);if(W!==null){this.f[W]._id=f,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const C={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:O.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},V=new t(this.a,f,C,w);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(f,E){this.getTerminalById(f)?._setProcessId(E)}async $startExtensionTerminal(f,E){const w=this.getTerminalById(f);if(!w)return{message:(0,k.localize)(0,null,f)};w.isOpen||await new Promise(C=>{const V=this.onDidOpenTerminal(async W=>{W===w.value&&(V.dispose(),C())})});const P=this.g.get(f);P?P.startSendingEvents(E):this.j[f]={initialDimensions:E}}S(f,E){const w=new p.$Tc;w.add(E.onProcessReady(C=>this.a.$sendProcessReady(f,C.pid,C.cwd,C.windowsPty))),w.add(E.onDidChangeProperty(C=>this.a.$sendProcessProperty(f,C))),this.y.startBuffering(f,E.onProcessData),w.add(E.onProcessExit(C=>this.U(f,C))),this.g.set(f,E);const P=this.j[f];return P&&E instanceof c&&(E.startSendingEvents(P.initialDimensions),delete this.j[f]),w}$acceptProcessAckDataEvent(f,E){this.g.get(f)?.acknowledgeDataEvent(E)}$acceptProcessInput(f,E){this.g.get(f)?.input(E)}$acceptTerminalInteraction(f){const E=this.getTerminalById(f);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(f,E){this.getTerminalById(f)?.setSelection(E)}$acceptProcessResize(f,E,w){try{this.g.get(f)?.resize(E,w)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(f,E){this.g.get(f)?.shutdown(E)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(f,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(E=>this.a.$sendProcessProperty(f,{type:"cwd",value:E}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new g.$SM(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,E,w){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,w),this.a.$registerProfileProvider(E,f.identifier.value),new g.$SM(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(f,E,w){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,w),this.a.$registerQuickFixProvider(f,E),new g.$SM(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,E){const w=new u.$me().token;if(w.isCancellationRequested)return;const P=this.D.get(f);if(!P)return;const C=await P.provideTerminalQuickFixes(E,w);if(C===null||Array.isArray(C)&&C.length===0)return;const V=new p.$Tc;if(this.w.value=V,!Array.isArray(C))return C?r.TerminalQuickFix.from(C,this.Q.converter,V):void 0;const W=[];for(const q of C){const A=r.TerminalQuickFix.from(q,this.Q.converter,V);A&&W.push(A)}return W}async $createContributedProfileTerminal(f,E){const w=new u.$me().token;let P=await this.C.get(f)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,E);return}this.createTerminalFromOptions(P.options,E)}}async $provideLinks(f,E){const w=this.getTerminalById(f);if(!w)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const C=new u.$me;this.G.set(f,C);const V=[],W={terminal:w.value,line:E},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async se=>{C.token.onCancellationRequested(()=>se({provider:K,links:[]}));const ce=await K.provideTerminalLinks(W,C.token)||[];C.token.isCancellationRequested||se({provider:K,links:ce})}));const A=await Promise.all(q);if(C.token.isCancellationRequested)return[];const U=new Map;for(const K of A)K&&K.links.length>0&&V.push(...K.links.map(se=>{const ce={id:h++,startIndex:se.startIndex,length:se.length,label:se.tooltip};return U.set(ce.id,{provider:K.provider,link:se}),ce}));return this.F.set(f,U),V}$activateLink(f,E){const w=this.F.get(f)?.get(E);w&&w.provider.handleTerminalLink(w.link)}U(f,E){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const w=this.h[f];w&&(w.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,E)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const E=this.f.findIndex(w=>w.value===f);return E>=0?E:null}W(f,E){const w=this.X(f,E);return w!==null?f[w]:null}X(f,E){const w=f.findIndex(P=>P._id===E);return w>=0?w:null}getEnvironmentVariableCollection(f){let E=this.n.get(f.identifier.value);return E||(E=new b,this.Z(f.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Y(f,E){const w=(0,y.$cs)(E.map),P=(0,y.$ds)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(f,E.persistent,w.length===0?void 0:w,P)}$initEnvironmentVariableCollections(f){f.forEach(E=>{const w=E[0],P=new b(E[1]);this.Z(w,P)})}$acceptDefaultProfile(f,E){const w=this.s;this.s=f,this.u=E,w?.path!==f.path&&this.N.fire(f.path)}Z(f,E){this.n.set(f,E),E.onDidChangeCollection(()=>{this.Y(f,E)})}};e.$7kc=i,e.$7kc=i=Je([Ve(1,n.$zP),Ve(2,M.$dP)],i);class b{get persistent(){return this.b}set persistent(f){this.b=f,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(f){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$be,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const E=this.h(f);let w=this.a.get(E);return w||(w=new a(this,f),this.a.set(E,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(f,E,w,P){this.f(f,{value:E,type:g.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:P})}append(f,E,w,P){this.f(f,{value:E,type:g.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:P})}prepend(f,E,w,P){this.f(f,{value:E,type:g.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:P})}f(f,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(f,E.scope),P=this.map.get(w),C=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==E.value||P.type!==E.type||P.options?.applyAtProcessCreation!==C.applyAtProcessCreation||P.options?.applyAtShellIntegration!==C.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const V=this.g(f,E.scope),W={variable:f,...E,options:C};this.map.set(V,W),this.d.fire()}}get(f,E){const w=this.g(f,E),P=this.map.get(w);return P?d(P):void 0}g(f,E){const w=this.h(E);return w.length?`${f}:::${w}`:f}h(f){return this.j(f?.workspaceFolder)??""}j(f){return f?f.uri.toString():void 0}getVariableMap(f){const E=new Map;for(const[w,P]of this.map)this.h(P.scope)===this.h(f)&&E.set(P.variable,d(P));return E}delete(f,E){const w=this.g(f,E);this.map.delete(w),this.d.fire()}clear(f){if(f?.workspaceFolder){for(const[E,w]of this.map)w.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(E);this.k(f)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(f,E){const w=this.h(E),P=this.descriptionMap.get(w);if(!P||P.description!==f){let C;typeof f=="string"?C=f:C=f?.value.split(`

`)[0];const V={description:C,scope:E};this.descriptionMap.set(w,V),this.d.fire()}}getDescription(f){const E=this.h(f);return this.descriptionMap.get(E)?.description}k(f){const E=this.h(f);this.descriptionMap.delete(E)}}class a{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,E){this.b=f,this.d=E,this.a=new I.$be}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,E,w){this.b.replace(f,E,w,this.d)}append(f,E,w){this.b.append(f,E,w,this.d)}prepend(f,E,w){this.b.prepend(f,E,w,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,E){this.b.getVariableMap(this.d).forEach((w,P)=>f.call(E,P,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let $=class extends i{constructor(f,E){super(!1,f,E)}createTerminal(f,E,w){throw new N.$_}createTerminalFromOptions(f,E){throw new N.$_}};e.$8kc=$,e.$8kc=$=Je([Ve(0,n.$zP),Ve(1,M.$dP)],$);function l(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function S(D){return s.ThemeColor.isThemeColor(D)?D:void 0}function d(D){const f={...D};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Re[114],Ae([1,0,7,6,3,4,16,51,5,2,11]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=e.$_lc=void 0,e.$_lc=(0,R.$qi)("IExtHostTerminalShellIntegration");let y=class extends T.$Uc{constructor(o,r){super(),this.h=r,this.b=new Map,this.c=new g.$be,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new g.$be,this.onDidStartTerminalShellExecution=this.f.event,this.g=new g.$be,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$QM.MainThreadTerminalShellIntegration),this.B((0,T.$Sc)(()=>{for(const[n,t]of this.b)t.dispose();this.b.clear()}))}$shellIntegrationChange(o){const r=this.h.getTerminalById(o);if(!r)return;const n=r.value;let t=this.b.get(o);t||(t=new u(r.value,this.f),this.b.set(o,t),t.store.add(r.onWillDispose(()=>this.b.get(o)?.dispose())),t.store.add(t.onDidRequestShellExecution(c=>this.a.$executeCommand(o,c))),t.store.add(t.onDidRequestEndExecution(c=>this.g.fire(c))),t.store.add(t.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),r.shellIntegration=t.value),this.c.fire({terminal:n,shellIntegration:t.value})}$shellExecutionStart(o,r,n,t,c){this.b.has(o)||this.$shellIntegrationChange(o);const h={value:r,confidence:n,isTrusted:t};this.b.get(o)?.startShellExecution(h,c)}$shellExecutionEnd(o,r,n,t,c){const h={value:r,confidence:n,isTrusted:t};this.b.get(o)?.endShellExecution(h,c)}$shellExecutionData(o,r){this.b.get(o)?.emitData(r)}$cwdChange(o,r){this.b.get(o)?.setCwd((0,k.$wc)(r)?k.URI.revive(r):r)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$amc=y,e.$amc=y=Je([Ve(0,M.$dP),Ve(1,p.$5kc)],y);class u extends T.$Uc{get currentExecution(){return this.a}constructor(o,r){super(),this.j=o,this.m=r,this.b=!1,this.store=this.B(new T.$Tc),this.f=this.B(new g.$be),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new g.$be),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new g.$be),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(t,c){let h=t;c&&(h+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(h);const i={value:h,confidence:I.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},b=n.startShellExecution(i,n.c,!0).value;return n.b=!0,b}}}startShellExecution(o,r,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const t=this.a=new v(o,r);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:t.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,r){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:r}),this.a=void 0)}setCwd(o){let r=!1;k.URI.isUri(this.c)?r=!k.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(r=!0),r&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class v{constructor(o,r){this.c=o,this.cwd=r,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return N.$Qh.EMPTY;this.a=new m}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class m extends T.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const o=this.a=new N.$ph;return new N.$Qh(async n=>{this.b.push(n),await o.wait()})}emitData(o){for(const r of this.b)r.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Re[278],Ae([1,0,11,23,22,5,250,99,6,17,35,13,4,16,113,8,7,50,75,61]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=e.$dmc=e.$cmc=e.$bmc=void 0;let c=class extends g.$Uc{constructor(C,V,W,q){super(),this.w=q,this.f=this.B(new O.$be),this.g=new Map,this.s=this.B(new O.$be),this.onResultsChanged=this.f.event,this.results=[],this.h=C.getProxy(u.$QM.MainThreadTesting),this.m=new D(this.h),this.j=new a(this.h,V),W.registerArgumentProcessor({processArgument:A=>{switch(A?.$mid){case 16:{const U=A,K=U.tests[U.tests.length-1].item.extId;return this.g.get(r.$CL.root(K))?.collection.tree.get(K)?.actual??(0,m.$pP)(A)}case 18:{const{test:U,message:K}=A,se=U.item.extId;return{test:this.g.get(r.$CL.root(se))?.collection.tree.get(se)?.actual??(0,m.$pP)({$mid:16,tests:[U]}),message:s.TestMessage.to(K)}}default:return A}}}),W.registerCommand(!1,"testing.getExplorerSelection",async()=>{const A=await W.executeCommand("_testing.getExplorerSelection"),U=K=>{const se=this.g.get(r.$CL.root(K));if(se)return r.$CL.isRoot(K)?se.controller:se.collection.tree.get(K)?.actual};return{include:A?.include.map(U).filter(k.$_f)||[],exclude:A?.exclude.map(U).filter(k.$_f)||[]}})}createTestController(C,V,W,q){if(this.g.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const A=new g.$Tc,U=A.add(new m.$sP(V,W,this.w));U.root.label=W;const K=new Map,se=new Set,ce=this.h,ve={items:U.root.children,get label(){return W},set label(ue){W=ue,U.root.label=ue,ce.$updateController(V,{label:W})},get refreshHandler(){return q},set refreshHandler(ue){q=ue,ce.$updateController(V,{canRefresh:!!ue})},get id(){return V},createRunProfile:(ue,be,ie,Ce,Fe,ne)=>{let j=(0,p.$ej)(ue);for(;K.has(j);)j++;return new E(this.h,K,se,this.s.event,V,j,ue,be,ie,Ce,Fe,ne)},createTestItem(ue,be,ie){return new m.$qP(V,ue,be,ie)},createTestRun:(ue,be,ie=!0)=>this.j.createTestRun(V,U,ue,be,ie),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const be=ue instanceof Array?ue:[ue];this.h.$markTestRetired(be.map(ie=>r.$CL.fromExtHostTestItem(ie,V).toString()))}},set resolveHandler(ue){U.resolveHandler=ue},get resolveHandler(){return U.resolveHandler},dispose:()=>{A.dispose()}};ce.$registerTestController(V,W,!!q),A.add((0,g.$Sc)(()=>ce.$unregisterTestController(V)));const Ie={controller:ve,collection:U,profiles:K,extension:C,activeProfiles:se};return this.g.set(V,Ie),A.add((0,g.$Sc)(()=>this.g.delete(V))),A.add(U.onDidGenerateDiff(ue=>ce.$publishDiff(V,ue.map(t.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(C,V=R.CancellationToken.None){const W=$(C);if(!W)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(W.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:C.include?.map(A=>r.$CL.fromExtHostTestItem(A,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:w[W.kind],profileId:W.profileId,controllerId:W.controllerId}],exclude:C.exclude?.map(A=>A.id)},V)}$syncTests(){for(const{collection:C}of this.g.values())C.flushDiff();return Promise.resolve()}async $getCoverageDetails(C,V){return(await this.j.getCoverageDetails(C,V))?.map(s.TestCoverage.fromDetails)}async $disposeRun(C){this.j.disposeTestRun(C)}$configureRunProfile(C,V){this.g.get(C)?.profiles.get(V)?.configureHandler?.()}$setDefaultRunProfiles(C){const V=new Map;for(const[W,q]of Object.entries(C)){const A=this.g.get(W);if(!A)continue;const U=new Map,K=q.filter(ce=>!A.activeProfiles.has(ce)),se=[...A.activeProfiles].filter(ce=>!q.includes(ce));for(const ce of K)U.set(ce,!0),A.activeProfiles.add(ce);for(const ce of se)U.set(ce,!1),A.activeProfiles.delete(ce);U.size&&V.set(W,U)}this.s.fire(V)}async $refreshTests(C,V){await this.g.get(C)?.controller.refreshHandler?.(V)}$publishTestResults(C){this.results=Object.freeze(C.map(s.TestResults.to).concat(this.results).sort((V,W)=>W.completedAt-V.completedAt).slice(0,32)),this.f.fire()}async $expandTest(C,V){const W=this.g.get(r.$CL.fromString(C).controllerId)?.collection;W&&(await W.expand(C,V<0?1/0:V),W.flushDiff())}$acceptDiff(C){this.m.applyDiff(C.map(V=>t.TestsDiffOp.deserialize({asCanonicalUri:W=>W},V)))}async $runControllerTests(C,V){return Promise.all(C.map(W=>this.y(W,!1,V)))}async $startContinuousRun(C,V){const W=new R.$me(V),q=await Promise.all(C.map(A=>this.y(A,!0,W.token)));return!V.isCancellationRequested&&!q.some(A=>A.error)&&await new Promise(A=>V.onCancellationRequested(A)),W.dispose(!0),q}async y(C,V,W){const q=this.g.get(C.controllerId);if(!q)return{};const{collection:A,profiles:U}=q,K=U.get(C.profileId);if(!K)return{};const se=C.testIds.map(ue=>A.tree.get(ue)).filter(k.$_f),ce=C.excludeExtIds.map(ue=>q.collection.tree.get(ue)).filter(k.$_f).filter(ue=>se.some(be=>be.fullId.compare(ue.fullId)===2));if(!se.length)return{};const ve=new o.$sO(se.some(ue=>ue.actual instanceof m.$rP)?void 0:se.map(ue=>ue.actual),ce.map(ue=>ue.actual),K,V),Ie=(0,t.$FL)(C)&&this.j.prepareForMainThreadTestRun(ve,l.fromInternal(C,q.collection),K,W);try{return await K.runHandler(ve,W),{}}catch(ue){return{error:String(ue)}}finally{Ie&&Ie.hasRunningTasks&&!W.isCancellationRequested&&await O.Event.toPromise(Ie.onEnd)}}$cancelExtensionTestRun(C){C===void 0?this.j.cancelAllRuns():this.j.cancelRunById(C)}};e.$bmc=c,e.$bmc=c=Je([Ve(0,v.$dP),Ve(1,y.$Wj)],c);const h=1e4;var i;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(i||(i={}));class b extends g.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(C,V,W,q,A){super(),this.y=C,this.z=V,this.C=W,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$be),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new R.$me(A));const U=this.B(new I.$Ch(()=>this.F(),h));this.B(this.j.token.onCancellationRequested(()=>U.schedule()));const K=new O.$be;this.s=K.event,this.B((0,g.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(C,V){const[,W,q]=r.$CL.fromString(C).path,A=this.w.get(q);if(!A)return[];const U=this.g.get(W);if(!U)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(U.run,A,V)??[]}createRun(C){const V=this.y.id,W=this.y.controllerId,q=(0,N.$Mg)(),A=ce=>(ve,...Ie)=>{if(K){this.C.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ve)&&(this.H(ve),ce(ve,...Ie))},U=(ce,ve)=>{const Ie=ve instanceof Array?ve.map(s.TestMessage.from):[s.TestMessage.from(ve)];if(ce.uri&&ce.range){const ue={range:s.Range.from(ce.range),uri:ce.uri};for(const be of Ie)be.location=be.location||ue}this.z.$appendTestMessagesInRun(V,q,r.$CL.fromExtHostTestItem(ce,W).toString(),Ie)};let K=!1;const se={isPersisted:this.y.isPersisted,token:this.j.token,name:C,onDidDispose:this.s,addCoverage:ce=>{const ve=ce.uri.toString(),Ie=new r.$CL([V,q,ve]).toString();this.w.set(ve,ce),this.z.$appendCoverage(V,q,s.TestCoverage.fromFile(Ie,ce))},enqueued:A(ce=>{this.z.$updateTestStateInRun(V,q,r.$CL.fromExtHostTestItem(ce,W).toString(),1)}),skipped:A(ce=>{this.z.$updateTestStateInRun(V,q,r.$CL.fromExtHostTestItem(ce,W).toString(),5)}),started:A(ce=>{this.z.$updateTestStateInRun(V,q,r.$CL.fromExtHostTestItem(ce,W).toString(),2)}),errored:A((ce,ve,Ie)=>{U(ce,ve),this.z.$updateTestStateInRun(V,q,r.$CL.fromExtHostTestItem(ce,W).toString(),6,Ie)}),failed:A((ce,ve,Ie)=>{U(ce,ve),this.z.$updateTestStateInRun(V,q,r.$CL.fromExtHostTestItem(ce,W).toString(),4,Ie)}),passed:A((ce,ve)=>{this.z.$updateTestStateInRun(V,q,r.$CL.fromExtHostTestItem(ce,this.y.controllerId).toString(),3,ve)}),appendOutput:(ce,ve,Ie)=>{K||(Ie&&(this.y.isIncluded(Ie)?this.H(Ie):Ie=void 0),this.z.$appendOutputToRun(V,q,T.$Ce.fromString(ce),ve&&s.location.from(ve),Ie&&r.$CL.fromExtHostTestItem(Ie,W).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(V,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:se}),this.z.$startedTestRunTask(V,{id:q,name:C,running:!0}),se}F(){for(const{run:C}of this.g.values())C.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(C){if(!(C instanceof m.$qP))throw new n.$8O(C.id);if(this.h.has(r.$CL.fromExtHostTestItem(C,this.y.controllerId).toString()))return;const V=[],W=this.y.colllection.root;for(;;){const q=s.TestItem.from(C);if(V.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),C===W))break;C=C.parent||W}this.z.$addTestsToRun(this.y.controllerId,this.y.id,V)}dispose(){this.G(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(C,V){this.g=C,this.h=V,this.c=new Map,this.f=new Map}getCoverageDetails(C,V){const W=r.$CL.root(C);return this.f.get(W)?.getCoverageDetails(C,V)||[]}disposeTestRun(C){this.f.get(C)?.dispose(),this.f.delete(C);for(const[V,{id:W}]of this.c)W===C&&this.c.delete(V)}prepareForMainThreadTestRun(C,V,W,q){return this.j(C,V,W,q)}cancelRunById(C){this.f.get(C)?.cancel()}cancelAllRuns(){for(const C of this.c.values())C.cancel()}createTestRun(C,V,W,q,A){const U=this.c.get(W);if(U)return U.createRun(q);const K=l.fromPublic(C,V,W,A),se=$(W);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!W.continuous,profile:se&&{group:w[se.kind],id:se.profileId},exclude:W.exclude?.map(ve=>r.$CL.fromExtHostTestItem(ve,V.root.id).toString())??[],id:K.id,include:W.include?.map(ve=>r.$CL.fromExtHostTestItem(ve,V.root.id).toString())??[V.root.id],persist:A});const ce=this.j(W,K,W.profile);return O.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ce.createRun(q)}j(C,V,W,q){const A=new b(V,this.g,this.h,W,q);return this.c.set(C,A),this.f.set(A.id,A),A}}e.$cmc=a;const $=P=>{if(P.profile){if(!(P.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class l{static fromPublic(C,V,W,q){return new l(C,(0,N.$Mg)(),W.include?.map(A=>r.$CL.fromExtHostTestItem(A,C).toString())??[C],W.exclude?.map(A=>r.$CL.fromExtHostTestItem(A,C).toString())??[],q,V)}static fromInternal(C,V){return new l(C.controllerId,C.runId,C.testIds,C.excludeExtIds,!0,V)}constructor(C,V,W,q,A,U){this.controllerId=C,this.id=V,this.isPersisted=A,this.colllection=U,this.c=W.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(C){const V=r.$CL.fromExtHostTestItem(C,this.controllerId).toString()+"\0";for(const W of this.f)if(V===W||V.startsWith(W))return!1;for(const W of this.c)if(V===W||V.startsWith(W))return!0;return!1}}e.$dmc=l;class S{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(C){this.j=C,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(C){this.c.add(C)}update(C){Object.assign(C.revived,s.TestItem.toPlain(C.item)),this.c.has(C)||this.f.add(C)}remove(C){if(this.c.has(C)){this.c.delete(C);return}this.f.delete(C);const V=r.$CL.parentId(C.item.extId);if(V&&this.h.has(V.toString())){this.h.add(C.item.extId);return}this.g.add(C)}getChangeEvent(){const{c:C,f:V,g:W}=this;return{get added(){return[...C].map(q=>q.revived)},get updated(){return[...V].map(q=>q.revived)},get removed(){return[...W].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class d extends t.$LL{constructor(){super(...arguments),this.s=new O.$be,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(C){return this.f.get(C)}getMirroredTestDataByReference(C){return this.f.get(C.id)}w(C,V){return{...C,revived:s.TestItem.toPlain(C.item),depth:V?V.depth+1:0,children:new Set}}v(){return new S(this.s)}}class D{constructor(C){this.f=C}checkout(){this.c||(this.c=this.g());const C=this.c;return C.observers++,{onDidChangeTest:C.tests.onDidChangeTests,get tests(){return[...C.tests.rootTests].map(V=>V.revived)},dispose:(0,M.$db)(()=>{--C.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(C){return this.c?.tests.getMirroredTestDataByReference(C)}applyDiff(C){this.c?.tests.apply(C)}g(){const C=new d({asCanonicalUri:V=>V});return this.f.$subscribeToDiffs(),{observers:0,tests:C}}}const f=(P,C,V,W)=>{V?Object.assign(V,W):C.$updateTestRunConfig(P.controllerId,P.profileId,W)};class E{#e;#t;#i;#n;#s;get label(){return this.f}set label(C){C!==this.f&&(this.f=C,f(this,this.#e,this.#n,{label:C}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(C){C!==this.g&&(this.g=C,f(this,this.#e,this.#n,{supportsContinuousRun:C}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(C){C!==this.isDefault&&(C?this.#t.add(this.profileId):this.#t.delete(this.profileId),f(this,this.#e,this.#n,{isDefault:C}))}get tag(){return this._tag}set tag(C){C?.id!==this._tag?.id&&(this._tag=C,f(this,this.#e,this.#n,{tag:C?s.TestTag.namespace(this.controllerId,C.id):null}))}get configureHandler(){return this.c}set configureHandler(C){C!==this.c&&(this.c=C,f(this,this.#e,this.#n,{hasConfigurationHandler:!!C}))}get onDidChangeDefault(){return O.Event.chain(this.#i,C=>C.map(V=>V.get(this.controllerId)?.get(this.profileId)).filter(k.$_f))}constructor(C,V,W,q,A,U,K,se,ce,ve=!1,Ie=void 0,ue=!1){this.controllerId=A,this.profileId=U,this.f=K,this.kind=se,this.runHandler=ce,this._tag=Ie,this.g=ue,this.#e=C,this.#s=V,this.#t=W,this.#i=q,V.set(U,this);const be=w[se];if(typeof be!="number")throw new Error(`Unknown TestRunProfile.group ${se}`);ve&&W.add(U),this.#n={profileId:U,controllerId:A,tag:Ie?s.TestTag.namespace(this.controllerId,Ie.id):null,label:K,group:be,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:ue},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$emc=E;const w={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Re[115],Ae([1,0,56,14,90,8,7]),function(ge,e,I,T,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=e.$lP=e.$kP=void 0;class p{static{this.c=new R.$iP("TextEditorDecorationType")}constructor(u,v,m){const s=p.c.nextId();u.$registerTextEditorDecorationType(v.identifier,s,O.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:s,dispose(){u.$removeTextEditorDecorationType(s)}})}}e.$kP=p;class g{constructor(u,v){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,v){this.k();let m=null;if(u instanceof M.$TM)m=new M.$UM(u,u);else if(u instanceof M.$UM)m=u;else throw new Error("Unrecognized location");this.l(m,v,!1)}insert(u,v){this.k(),this.l(new M.$UM(u,u),v,!0)}delete(u){this.k();let v=null;if(u instanceof M.$UM)v=u;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(u,v,m){const s=this.c.validateRange(u);this.g.push({range:s,text:v,forceMoveMarkers:m})}setEndOfLine(u){if(this.k(),u!==M.EndOfLine.LF&&u!==M.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=u}}class k{constructor(u,v,m,s){this.c=u,this.d=v,this._accept(m),this.e=s;const o=this;this.value={get tabSize(){return o.f},set tabSize(r){o.n(r)},get indentSize(){return o.g},set indentSize(r){o.p(r)},get insertSpaces(){return o.j},set insertSpaces(r){o.s(r)},get cursorStyle(){return o.k},set cursorStyle(r){o.t(r)},get lineNumbers(){return o.l},set lineNumbers(r){o.u(r)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const v=Math.floor(u);return v>0?v:null}if(typeof u=="string"){const v=parseInt(u,10);return isNaN(v)?null:v>0?v:null}return null}n(u){const v=this.m(u);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const v=Math.floor(u);return v>0?v:null}if(typeof u=="string"){const v=parseInt(u,10);return isNaN(v)?null:v>0?v:null}return null}p(u){const v=this.o(u);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const v=this.q(u);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(u)})))}assign(u){const v={};let m=!1;if(typeof u.tabSize<"u"){const s=this.m(u.tabSize);s==="auto"?(m=!0,v.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,m=!0,v.tabSize=s)}if(typeof u.indentSize<"u"){const s=this.o(u.indentSize);s==="tabSize"?(m=!0,v.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,m=!0,v.indentSize=s)}if(typeof u.insertSpaces<"u"){const s=this.q(u.insertSpaces);s==="auto"?(m=!0,v.insertSpaces=s):this.j!==s&&(this.j=s,m=!0,v.insertSpaces=s)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,m=!0,v.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,m=!0,v.lineNumbers=O.TextEditorLineNumbersStyle.from(u.lineNumbers)),m&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(u,v){v.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(m)})}}e.$lP=k;class N{constructor(u,v,m,s,o,r,n,t){this.id=u,this.j=v,this.k=m,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,r,m),this.e=n,this.f=t;const c=this;this.value=Object.freeze({get document(){return s.value},set document(h){throw new T.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof M.$VM))throw(0,T.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof M.$VM)))throw(0,T.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const b=new g(s.value,i);return h(b),c.m(b)},insertSnippet(h,i,b={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=c.c.map($=>O.Range.from($));else if(i instanceof M.$TM){const{lineNumber:$,column:l}=O.Position.from(i);a=[{startLineNumber:$,startColumn:l,endLineNumber:$,endColumn:l}]}else if(i instanceof M.$UM)a=[O.Range.from(i)];else{a=[];for(const $ of i)if($ instanceof M.$UM)a.push(O.Range.from($));else{const{lineNumber:l,column:S}=O.Position.from($);a.push({startLineNumber:l,startColumn:S,endLineNumber:l,endColumn:S})}}return v.$tryInsertSnippet(u,s.value.version,h.value,a,b)},setDecorations(h,i){const b=i.length===0;b&&!c.h.has(h.key)||(b?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(O.$aP(i))return v.$trySetDecorations(u,h.key,O.$bP(i));{const a=new Array(4*i.length);for(let $=0,l=i.length;$<l;$++){const S=i[$];a[4*$]=S.start.line+1,a[4*$+1]=S.start.character+1,a[4*$+2]=S.end.line+1,a[4*$+3]=S.end.character+1}return v.$trySetDecorationsFast(u,h.key,a)}}))},revealRange(h,i){c.n(()=>v.$tryRevealRange(u,O.Range.from(h),i||M.TextEditorRevealType.Default))},show(h){v.$tryShowEditor(u,O.ViewColumn.from(h))},hide(){v.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,I.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,I.ok)(!this.g),this.f=u}_acceptSelections(u){(0,I.ok)(!this.g),this.c=u}async l(){const u=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const v=u.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const m=v.edits.map(o=>o.range);m.sort((o,r)=>o.end.line===r.end.line?o.end.character===r.end.character?o.start.line===r.start.line?o.start.character-r.start.character:o.start.line-r.start.line:o.end.character-r.end.character:o.end.line-r.end.line);for(let o=0,r=m.length-1;o<r;o++){const n=m[o].end;if(m[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=v.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,s,{setEndOfLine:typeof v.setEndOfLine=="number"?O.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$mP=N}),define(Re[67],Ae([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,40,41]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=e.$nP=void 0;class r{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new v.$Bc,this.d=new T.$be,this.e=new T.$be,this.f=new T.$be,this.g=new T.$be,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],b=[];if(c.removedDocuments)for(const a of c.removedDocuments){const $=O.URI.revive(a),l=this.c.get($);l?.unref()&&(this.c.delete($),h.push(l.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const $=O.URI.revive(a.uri);let l=this.c.get($);if(l&&$.scheme!==m.Schemas.vscodeNotebookCell&&$.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${$} already exists!'`);l||(l=new r(new g.$gP(this.h.getProxy(p.$QM.MainThreadDocuments),$,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set($,l),i.push(l.value)),l.ref()}if(c.removedEditors)for(const a of c.removedEditors){const $=this.b.get(a);this.b.delete(a),$&&b.push($)}if(c.addedEditors)for(const a of c.addedEditors){const $=O.URI.revive(a.documentUri);I.ok(this.c.has($),`document '${$}' does not exist`),I.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const l=this.c.get($).value,S=new N.$mP(a.id,this.h.getProxy(p.$QM.MainThreadTextEditors),this.i,new o.$V(()=>l.document),a.selections.map(y.Selection.to),a.options,a.visibleRanges.map(d=>y.Range.to(d)),typeof a.editorPosition=="number"?y.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,S)}c.newActiveEditor!==void 0&&(I.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,R.$Pc)(h),(0,R.$Pc)(b),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$nP=n,e.$nP=n=Je([Ve(0,k.$dP),Ve(1,u.$Wj)],n),e.$oP=(0,M.$qi)("IExtHostDocumentsAndEditors")}),define(Re[279],Ae([1,0,18,5,4,115,8,7]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=void 0;class g{constructor(N,y){this.i=y,this.a=new T.$be,this.b=new T.$be,this.c=new T.$be,this.d=new T.$be,this.f=new T.$be,this.g=new T.$be,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(R.$QM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const y=this.i.allEditors();return N?y:y.map(u=>u.value)}async showTextDocument(N,y,u){let v;typeof y=="number"?v={position:M.ViewColumn.from(y),preserveFocus:u}:typeof y=="object"?v={position:M.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?M.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:v={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(N.uri,v),s=m&&this.i.getEditor(m);if(s)return s.value;throw m?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,y){return new O.$kP(this.h,N,y).value}$acceptEditorPropertiesChanged(N,y){const u=this.i.getEditor(N);if(!u)throw new Error("unknown text editor");if(y.options&&u._acceptOptions(y.options),y.selections){const v=y.selections.selections.map(M.Selection.to);u._acceptSelections(v)}if(y.visibleRanges){const v=I.$Hb(y.visibleRanges.map(M.Range.to));u._acceptVisibleRanges(v)}if(y.options&&this.b.fire({textEditor:u.value,options:{...y.options,lineNumbers:M.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const v=p.TextEditorSelectionChangeKind.fromValue(y.selections.source),m=y.selections.selections.map(M.Selection.to);this.a.fire({textEditor:u.value,selections:m,kind:v})}if(y.visibleRanges){const v=I.$Hb(y.visibleRanges.map(M.Range.to));this.c.fire({textEditor:u.value,visibleRanges:v})}}$acceptEditorPositionData(N){for(const y in N){const u=this.i.getEditor(y);if(!u)throw new Error("Unknown text editor");const v=M.ViewColumn.to(N[y]);u.value.viewColumn!==v&&(u._acceptViewColumn(v),this.d.fire({textEditor:u.value,viewColumn:v}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.$xkc=g}),define(Re[280],Ae([1,0,2,3,4,6,7,8,20,17]),function(ge,e,I,T,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=e.$gmc=void 0,e.$gmc=(0,T.$qi)("IExtHostTimeline");class N{constructor(v,m){this.b=new Map,this.c=new Map,this.a=v.getProxy(R.$QM.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&g.$Lm.equals(o,this.b.get(s.source)?.extension)){const r=s.uri===void 0?void 0:I.URI.revive(s.uri);return this.c.get(s.source)?.get(y(r))?.get(s.handle)}else return;return s}})}async $getTimeline(v,m,s,o){return this.b.get(v)?.provider.provideTimeline(I.URI.revive(m),s,o)}registerTimelineProvider(v,m,s,o){const r=new O.$Tc,n=this.d(m.id,o,r).bind(this);let t;m.onDidChange&&(t=m.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:m.id}),this));const c=this.c;return this.f({...m,scheme:v,onDidChange:void 0,async provideTimeline(h,i,b){i?.resetCache&&(r.clear(),c.get(m.id)?.clear());const a=await m.provideTimeline(h,i,b);if(a==null)return;const $=n(h,i);return{...a,source:m.id,items:a.items.map($)}},dispose(){for(const h of c.values())h.get(m.id)?.clear();t?.dispose(),r.dispose()}},s)}d(v,m,s){return(o,r)=>{let n;if(r?.cacheResults){let t=this.c.get(v);t===void 0&&(t=new Map,this.c.set(v,t));const c=y(o);n=t.get(c),n===void 0&&(n=new Map,t.set(c,n))}return t=>{const{iconPath:c,...h}=t,i=`${v}|${t.id??t.timestamp}`;n?.set(i,t);let b,a,$;t.iconPath&&(c instanceof M.$ON?$={id:c.id,color:c.color}:I.URI.isUri(c)?(b=c,a=c):{light:b,dark:a}=c);let l;return M.$hN.isMarkdownString(h.tooltip)?l=p.MarkdownString.from(h.tooltip):(0,k.$4f)(h.tooltip)?l=h.tooltip:M.$hN.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=p.MarkdownString.from(h.detail)):(0,k.$4f)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=h.detail),{...h,id:h.id??void 0,handle:i,source:v,command:t.command?m.toInternal(t.command,s):void 0,icon:b,iconDark:a,themeIcon:$,tooltip:l,accessibilityInformation:t.accessibilityInformation}}}}f(v,m){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:m}),(0,O.$Sc)(()=>{for(const o of this.c.values())o.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$hmc=N;function y(u){return u?.toString()}}),define(Re[281],Ae([1,0,172,24,2,5,6,211,11,7,17,18,8,54,22,137,25]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=void 0;function r(c,h){if((0,N.$4f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(b=>b.length===2&&typeof b[0]=="number"&&typeof b[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends M.$Uc{constructor(h,i,b){super(),this.f=h,this.g=i,this.h=b,this.a=new Map,this.b=new s.$e9;function a($){return $&&$.$treeViewId&&($.$treeItemHandle||$.$selectedTreeItems||$.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:$=>a($)?this.r($):Array.isArray($)&&$.length>0?$.map(l=>a(l)?this.r(l):l):$})}registerTreeDataProvider(h,i,b){const a=this.createTreeView(h,{treeDataProvider:i},b);return{dispose:()=>a.dispose()}}createTreeView(h,i,b){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=i.dragAndDropController?.dropMimeTypes??[],$=i.dragAndDropController?.dragMimeTypes??[],l=!!i.dragAndDropController?.handleDrag,S=!!i.dragAndDropController?.handleDrop,d=this.m(h,i,b),D={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:a,dragMimeTypes:$,hasHandleDrag:l,hasHandleDrop:S,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},f=this.f.$registerTreeViewDataProvider(h,D),E={get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get activeItem(){return(0,o.$yG)(b,"treeViewActiveItem"),d.focusedElement},get onDidChangeActiveItem(){return(0,o.$yG)(b,"treeViewActiveItem"),d.onDidChangeActiveItem},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return d.onDidChangeCheckboxState},get message(){return d.message},set message(w){(0,v.$Pk)(w)&&(0,o.$yG)(b,"treeViewMarkdownMessage"),d.message=w},get title(){return d.title},set title(w){d.title=w},get description(){return d.description},set description(w){d.description=w},get badge(){return d.badge},set badge(w){w!==void 0&&k.ViewBadge.isViewBadge(w)?d.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(d.badge=void 0)},reveal:(w,P)=>d.reveal(w,P),dispose:async()=>{await f,this.a.delete(h),d.dispose()}};return this.B(E),E}$getChildren(h,i){const b=this.a.get(h);return b?b.getChildren(i):Promise.reject(new p.$NF(h))}async $handleDrop(h,i,b,a,$,l,S,d){const D=this.a.get(h);if(!D)return Promise.reject(new p.$NF(h));const f=u.DataTransfer.toDataTransfer(b,async E=>(await this.f.$resolveDropFileData(h,i,E)).buffer);return S===h&&d&&await this.j(f,D,d,$,l),D.onDrop(f,a,$)}async j(h,i,b,a,$){const l=this.b.removeDragOperationTransfer($);if(l)(await l)?.forEach((S,d)=>{S&&h.set(d,S)});else if($&&i.handleDrag){const S=i.handleDrag(b,h,a);this.b.addDragOperationTransfer($,S),await S}return h}async $handleDrag(h,i,b,a){const $=this.a.get(h);if(!$)return Promise.reject(new p.$NF(h));const l=await this.j(new k.$KN,$,i,a,b);if(!(!l||a.isCancellationRequested))return u.DataTransfer.from(l)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new p.$NF(h);return i.hasResolve}$resolve(h,i,b){const a=this.a.get(h);if(!a)throw new p.$NF(h);return a.resolveTreeItem(i,b)}$setExpanded(h,i,b){const a=this.a.get(h);if(!a)throw new p.$NF(h);a.setExpanded(i,b)}$setSelectionAndFocus(h,i,b){const a=this.a.get(h);if(!a)throw new p.$NF(h);a.setSelectionAndFocus(i,b)}$setVisible(h,i){const b=this.a.get(h);if(!b){if(!i)return;throw new p.$NF(h)}b.setVisible(i)}$changeCheckboxState(h,i){const b=this.a.get(h);if(!b)throw new p.$NF(h);b.setCheckboxState(i)}m(h,i,b){const a=this.B(new t(h,i,this.f,this.g.converter,this.h,b));return this.a.set(h,a),a}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$imc=n;class t extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,N.$ag)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,b,a,$,l){if(super(),this.I=h,this.J=b,this.L=a,this.M=$,this.N=l,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$be),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$be),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$be),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$be),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$be),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$be),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$be),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$me,l.contributes&&l.contributes.views)for(const f in l.contributes.views)for(const E of l.contributes.views[f])E.id===h&&(this.P=E.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(f=>this.F.fire({message:!1,element:f})));let S,d;const D=O.Event.debounce(this.F.event,(f,E)=>(f||(f={message:!1,elements:[]}),E.element!==!1&&(S||(S=new Promise(w=>d=w),this.G=this.G.then(()=>S)),Array.isArray(E.element)?f.elements.push(...E.element):f.elements.push(E.element)),E.message&&(f.message=!0),f),200,!0);this.B(D(({message:f,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const w=d;return S=null,this.$(E).then(()=>w())})),f&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let b=this.X(h);return b||(b=await this.Y(i)),b?b.map(a=>a.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const b=(0,N.$ag)(i.select)?!0:i.select,a=(0,N.$ag)(i.focus)?!1:i.focus,$=(0,N.$ag)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(l=>this.W(h,l[l.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:l.map(d=>d.item)},{select:b,focus:a,expand:$})),l=>this.M.error(l)):this.J.$reveal(this.I,void 0,{select:b,focus:a,expand:$})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=u.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const b=this.getExtensionElement(h);b&&(i?this.u.fire(Object.freeze({element:b})):this.w.fire(Object.freeze({element:b})))}setSelectionAndFocus(h,i){const b=!(0,y.$ub)(this.s,h);this.s=h;const a=this.t!==i;this.t=i,b&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async b=>{const a=this.getExtensionElement(b.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:b.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(b=>b!==void 0);i.forEach(b=>{b.treeItem.checkboxState=b.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(b=>[b.extensionItem,b.newState])})}async handleDrag(h,i,b){const a=[];for(const $ of h){const l=this.getExtensionElement($);l&&a.push(l)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,i,b),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,b){const a=i?this.getExtensionElement(i):void 0;if(!(!a&&i||!this.g?.handleDrop))return(0,g.$ih)(()=>this.g?.handleDrop?this.g.handleDrop(a,h,b):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const b=this.j.get(h);if(b){const a=this.m.get(b);if(a){const $=await this.f.resolveTreeItem(a.extensionItem,b,i)??a.extensionItem;return this.hb($),a.item.tooltip=this.eb($.tooltip),a.item.command=this.fb(a.disposableStore,$.command),a.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(b=>this.W(i,b[b.length-1]).then(a=>(b.push(a),b))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$ih)(()=>this.f.getParent(h))}W(h,i){const b=this.m.get(h);return b?Promise.resolve(b):(0,g.$ih)(()=>this.f.getTreeItem(h)).then(a=>this.kb(h,a,i,!0)).then(a=>this.getChildren(i?i.item.handle:void 0).then(()=>{const $=this.getExtensionElement(a);if($){const l=this.m.get($);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const b=this.getExtensionElement(h);i=b?this.m.get(b):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new m.$me(this.Z.token);try{const b=h?this.m.get(h):void 0,a=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const $=(0,y.$Hb)(a||[]),l=await Promise.all((0,y.$Hb)($).map(d=>this.f.getTreeItem(d)));if(i.token.isCancellationRequested)return;const S=l.map((d,D)=>d?this.db($[D],d,b):null);return(0,y.$Hb)(S)}finally{i.dispose()}}$(h){if(h.some(b=>!b))return this.Z.dispose(!0),this.Z=new m.$me,this.tb(),this.J.$refresh(this.I);{const b=this.ab(h);if(b.length)return this.bb(b)}return Promise.resolve(void 0)}ab(h){const i=new Set,b=h.map($=>this.m.get($));for(const $ of b)if($&&!i.has($.item.handle)){let l=$;for(;l&&l.parent&&b.findIndex(S=>l&&l.parent&&S&&S.item.handle===l.parent.item.handle)===-1;){const S=this.j.get(l.parent.item.handle);l=S?this.m.get(S):void 0}l&&!l.parent&&i.add($.item.handle)}const a=[];return i.forEach($=>{const l=this.j.get($);if(l){const S=this.m.get(l);S&&(!S.parent||!i.has(S.parent.item.handle))&&a.push($)}}),a}bb(h){const i={};return Promise.all(h.map(b=>this.cb(b).then(a=>{a&&(i[b]=a.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const b=this.m.get(i);if(b)return this.rb(i),(0,g.$ih)(()=>this.f.getTreeItem(i)).then(a=>{if(a){const $=this.ib(i,a,b.parent);return this.pb(i,$,b,b.parent),b.dispose(),$}return null})}return Promise.resolve(null)}db(h,i,b){const a=this.ib(h,i,b);if(i.id&&this.j.has(a.item.handle))throw new Error((0,I.localize)(0,null,i.id));return this.ob(h,a),this.qb(a,b),a}eb(h){return k.$hN.isMarkdownString(h)?u.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,b,a;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,b=h.checkboxState.tooltip,a=h.checkboxState.accessibilityInformation),{isChecked:i===k.TreeItemCheckboxState.Checked,tooltip:b,accessibilityInformation:a}}hb(h){if(!k.$FN.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,b){this.hb(i);const a=this.B(new M.$Tc),$=this.kb(h,i,b),l=this.lb(i);return{item:{handle:$,parentHandle:b?b.item.handle:void 0,label:r(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(a,i.command),contextValue:i.contextValue,icon:l,iconDark:this.mb(i)||l,themeIcon:this.jb(i),collapsibleState:(0,N.$ag)(i.collapsibleState)?k.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:b,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(h){return h.iconPath instanceof k.$ON?h.iconPath:void 0}kb(h,{id:i,label:b,resourceUri:a},$,l){if(i)return`${t.b}/${i}`;const S=r(b,this.N),d=$?$.item.handle:t.a;let D=S?S.label:a?(0,T.$1g)(a):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const f=this.m.has(h)?this.m.get(h).item.handle:void 0,E=this.X($)||[];let w,P=0;do{if(w=`${d}/${P}:${D}`,l||!this.j.has(w)||f===w)break;P++}while(P<=E.length);return w}lb(h){if(h.iconPath&&!(h.iconPath instanceof k.$ON))return typeof h.iconPath=="string"||R.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof k.$ON)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return R.URI.isUri(h)?h:R.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,b,a){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==b.item.handle&&this.j.delete(b.item.handle),this.ob(h,i);const $=this.X(a)||[],l=$.filter(S=>S.item.handle===b.item.handle)[0];l&&$.splice($.indexOf(l),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const b of i.children){const a=this.j.get(b.item.handle);a&&this.sb(a)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const b of i.children){const a=this.j.get(b.item.handle);a&&this.sb(a)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[282],Ae([1,0,5,6,2,35,8,63,4,7]),function(ge,e,I,T,R,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0;class N extends T.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(m,s,o,r){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$be),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$be),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=s,this.#n=o,this.#i=r.viewType,this.#s=r.panelOptions,this.#o=r.viewColumn,this.#r=r.title,this.#u=r.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(m){this.c(),this.#r!==m&&(this.#r=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#a}set iconPath(m){this.c(),this.#a!==m&&(this.#a=m,this.#t.$setIconPath(this.#e,R.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(m){this.#l||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#u=m.active,this.#c=m.visible,this.#o=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:M.ViewColumn.from(m),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends T.$Uc{static c(){return(0,O.$Mg)()}constructor(m,s,o){super(),this.j=s,this.m=o,this.g=new Map,this.h=new Map,this.f=m.getProxy(g.$QM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,s,o,r,n={}){const t=typeof r=="object"?r.viewColumn:r,c={viewColumn:M.ViewColumn.from(t),preserveFocus:typeof r=="object"&&!!r.preserveFocus},h=(0,p.$Mkc)(m),i=y.c();this.f.$createWebviewPanel((0,p.$Okc)(m),i,s,{title:o,panelOptions:u(n),webviewOptions:(0,p.$Pkc)(m,this.m,n),serializeBuffersForPostMessage:h},c);const b=this.j.createNewWebview(i,n,m);return this.createNewWebviewPanel(i,s,o,t,n,b,!0)}$onDidChangeWebviewPanelViewStates(m){const s=Object.keys(m);s.sort((o,r)=>{const n=m[o],t=m[r];return n.active?1:t.active?-1:+n.visible-+t.visible});for(const o of s){const r=this.getWebviewPanel(o);if(!r)continue;const n=m[o];r._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,s,o){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:o,extension:m}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,p.$Mkc)(m)}),new k.$SM(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(m,s,o,r){const n=this.h.get(s);if(!n)throw new Error(`No serializer found for '${s}'`);const{serializer:t,extension:c}=n,h=this.j.createNewWebview(m,o.webviewOptions,c),i=this.createNewWebviewPanel(m,s,o.title,r,o.panelOptions,h,o.active);await t.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(m,s,o,r,n,t,c){const h=new N(m,this.f,t,{viewType:s,title:o,viewColumn:r,panelOptions:n,active:c});return this.g.set(m,h),h}getWebviewPanel(m){return this.g.get(m)}}e.$Qkc=y;function u(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Re[283],Ae([1,0,5,6,63,8,4,7]),function(ge,e,I,T,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=void 0;class g extends T.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,v,m,s,o){super(),this.#s=!1,this.#u=this.B(new I.$be),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$be),this.onDidDispose=this.#l.event,this.#i=v,this.#a=m,this.#e=y,this.#t=u,this.#n=s,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(M.$QM.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,v,m){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:v,extension:y}),this.a.$registerWebviewViewProvider((0,R.$Okc)(y),u,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$Mkc)(y)}),new p.$SM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,v,m,s){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:r,extension:n}=o,t=this.d.createNewWebview(y,{},n),c=new g(y,this.a,u,v,t,!0);this.c.set(y,c),await r.resolveWebviewView(c,{state:m},s)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$lmc=k}),define(Re[284],Ae([1,0,5,30,31,3]),function(ge,e,I,T,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=e.OutputChannelUpdateMode=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=void 0,e.$YL="text/x-code-output",e.$ZL="output",e.$1L="Log",e.$2L="text/x-code-log-output",e.$3L="log",e.$4L="workbench.panel.output",e.$5L=new R.$Hj("inOutput",!1),e.$6L=new R.$Hj("activeLogOutput",!1),e.$7L=new R.$Hj("activeLogOutput.levelSettable",!1),e.$8L=new R.$Hj("activeLogOutput.level",""),e.$9L=new R.$Hj("activeLogOutput.levelIsDefault",!1),e.$0L=new R.$Hj("outputView.scrollLock",!1),e.$$L=(0,O.$qi)("outputService");var M;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$_L={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new I.$be,this.onDidRegisterChannel=this.b.event,this.c=new I.$be,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(N=>k.push(N)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}T.$9n.add(e.$_L.OutputChannels,new p),e.$aM=new R.$Hj("activeOutputChannel","")}),define(Re[116],Ae([1,0,4,3,16,20,13,284,64,27,45,141,23,17,44,5,6]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=e.$Wlc=void 0;class r extends M.$3j{get disposed(){return this.n}constructor(h,i,b,a,$){super(),this.id=h,this.name=i,this.r=b,this.s=a,this.extension=$,this.m=0,this.n=!1,this.visible=!1,this.setLevel(b.getLevel()),this.B(b.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=u.$Ce.fromString(i).byteLength,(0,M.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends r{appendLine(h){this.append(h)}}let t=class{constructor(h,i,b,a,$,l){this.i=i,this.j=b,this.k=a,this.l=$,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(I.$QM.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,y.$Xm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,b]of this.g)b.visible=i===this.h}createOutputChannel(h,i,b){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const a=typeof i=="object"&&i.log,$=(0,v.$4f)(i)?i:void 0;if((0,v.$4f)($)&&!$.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const S=this.i.environment.extensionLogLevel?.find(([D])=>O.$Lm.equals(b.identifier,D))?.[1];S&&(l=(0,M.$bk)(S));const d=a?this.o(h,l,b):this.n(h,$,b);return d.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),a?this.r(h,l??this.m.getLevel(),d):this.q(h,d)}async n(h,i,b){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,$=this.k.extUri.joinPath(a,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger($,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(h,$,i,b.identifier.value);return new r(S,h,l,this.a,b)}async o(h,i,b){const a=await this.p(b),$=h.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(a,`${$}.log`),S=`${b.identifier.value}.${$}`,d=this.l.createLogger(l,{id:S,name:h,logLevel:i,extensionId:b.identifier.value});return new n(S,h,d,this.a,b)}p(h){let i=this.d.get(h.identifier.value);if(!i){const b=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(b)}catch(a){if((0,m.$al)(a)!==m.FileSystemProviderErrorCode.FileExists)throw a}return b})())}return i}q(h,i){let b=!1;const a=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return h},append($){a(),i.then(l=>l.append($))},appendLine($){a(),i.then(l=>l.appendLine($))},clear(){a(),i.then($=>$.clear())},replace($){a(),i.then(l=>l.replace($))},show($,l){a(),i.then(S=>S.show($,l))},hide(){a(),i.then($=>$.hide())},dispose(){b=!0,i.then($=>$.dispose())}}}r(h,i,b){const a=new o.$Tc,$=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},l=a.add(new s.$be);function S(d){i=d,l.fire(d)}return b.then(d=>{a.add(d),d.logLevel!==i&&S(d.logLevel),a.add(d.onDidChangeLogLevel(D=>S(D)))}),{...this.q(h,b),get logLevel(){return i},onDidChangeLogLevel:l.event,trace(d,...D){$(),b.then(f=>f.trace(d,...D))},debug(d,...D){$(),b.then(f=>f.debug(d,...D))},info(d,...D){$(),b.then(f=>f.info(d,...D))},warn(d,...D){$(),b.then(f=>f.warn(d,...D))},error(d,...D){$(),b.then(f=>f.error(d,...D))},dispose(){a.dispose()}}}};e.$Wlc=t,e.$Wlc=t=Je([Ve(0,R.$dP),Ve(1,k.$tP),Ve(2,g.$Ikc),Ve(3,N.$lkc),Ve(4,M.$Xj),Ve(5,M.$Wj)],t),e.$Xlc=(0,T.$qi)("IExtHostOutputService")}),define(Re[117],Ae([1,0,3,11]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=void 0,e.$an=(0,I.$qi)("remoteAgentService"),e.$bn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let O=1/0;for(let p=0;p<this.maxSampleCount;p++){const g=await R.getRoundTripTime();if(g===void 0)return;O=Math.min(O,g/2),await(0,T.$rh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(O):M=this.initial.reduce((p,g)=>p+g,0)/this.initial.length,this.lastMeasurement={initial:M,current:O,average:this.average.reduce((p,g)=>p+g,0)/this.average.length,high:typeof M>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[285],Ae([1,0,175,57,30,49,48,6,5,117,21,26,11]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=void 0,e.$rJ=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$sJ=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$tJ=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$uJ=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$vJ={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new g.$be,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const m=new v;R.$9n.add(e.$vJ.ConfigurationMigration,m);let s=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const h of c.added)await this.f(h,m.migrations)})),this.c(m.migrations),this.B(m.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(c=>this.g(c,n?.uri))])}async g(n,t){const c=this.a.inspect(n.key,{resource:t}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[i,b]of h){const a=c[i];if(!a)continue;const $=[];if(a.value!==void 0){const l=await this.h(n,i,a.value,t,void 0);for(const S of l??[])$.push([S,[]])}for(const{identifiers:l,value:S}of a.overrides??[])if(S!==void 0){const d=await this.h(n,i,S,t,l);for(const D of d??[])$.push([D,l])}$.length&&await Promise.allSettled($.map(async([[l,S],d])=>this.a.updateValue(l,S.value,{resource:t,overrideIdentifiers:d},b)))}}async h(n,t,c,h,i){const b=$=>{const S=this.a.inspect($,{resource:h})[t];if(S)return i?S.overrides?.find(({identifiers:d})=>(0,y.$1n)(d,i))?.value:S.value},a=await n.migrateFn(c,b);return Array.isArray(a)?a:[[n.key,a]]}};e.$wJ=s,e.$wJ=s=Je([Ve(0,M.$Wi),Ve(1,O.$zi)],s);let o=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new u.$Nh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!N.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$9n.as(T.$bo.Configuration).registerConfiguration({...e.$tJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$xJ=o,e.$xJ=o=Je([Ve(0,k.$an)],o)}),define(Re[286],Ae([1,0,36,12,19,24,184,285,57,3,30]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$zgb=e.$ygb=void 0,e.$Agb=s,e.$Bgb=o,e.$ygb=(0,k.$qi)("editorResolverService"),e.$zgb="workbench.editorAssociations";const y=N.$9n.as(g.$bo.Configuration),u={...p.$sJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var v;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})(v||(e.RegisteredEditorPriority=v={}));var m;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})(m||(e.ResolvedStatus=m={}));function s(r){switch(r){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}function o(r,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof r=="string"&&r.indexOf(R.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,O.$1g)(n);return I.$jk(typeof r=="string"?r.toLowerCase():r,h.toLowerCase())}}),define(Re[287],Ae([1,0,47,12,19,21,24,2,3,205,49,225,117]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=void 0,e.$sM=(0,g.$qi)("pathService");let m=v=class{constructor(o,r,n,t){this.d=o,this.e=r,this.f=n,this.g=t,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,r,n){return typeof r=="string"||typeof r>"u"?this.a.then(t=>this.h(o,t,r)):this.h(o,r,n)}h(o,r,n){return o.scheme===T.Schemas.file||o.scheme===T.Schemas.vscodeRemote?(0,I.$og)(n??(0,M.$1g)(o),r===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,r){if(o.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,k.$pM)(r.getWorkspace());if(n)return n;const t=r.getWorkspace().folders[0];if(t)return t.uri.scheme;const c=r.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?R.$gc:R.$hc)}async fileURI(o){let r="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const t=o.indexOf("/",2);t===-1?(r=o.substring(2),o="/"):(r=o.substring(2,t),o=o.substring(t)||"/")}return p.URI.from({scheme:T.Schemas.file,authority:r,path:o,query:"",fragment:""})}};e.$tM=m,e.$tM=m=v=Je([Ve(1,u.$an),Ve(2,y.$bM),Ve(3,N.$zi)],m)}),define(Re[118],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$YK=e.$XK=void 0;class I{constructor(M,p){this.line=M,this.character=p}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,p){return new I(0,0)}with(M){return new I(0,0)}}e.$XK=I;class T{constructor(M,p,g,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(M,p),this.end=new I(g,k)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new T(0,0,0,0)}with(M){return new T(0,0,0,0)}}e.$YK=T;var R;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Re[46],Ae([1,0,18,36,26,47,15,3,19,14,118,11]),function(ge,e,I,T,R,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lL=e.$jL=e.$cL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$_K=e.$$K=e.$0K=e.$9K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.TextSearchCompleteMessageType=void 0,e.$6K=r,e.$7K=n,e.$8K=t,e.$aL=d,e.$bL=D,e.$dL=w,e.$eL=P,e.$fL=C,e.$gL=V,e.$hL=W,e.$iL=q,e.$kL=U,e.$mL=ce,e.$nL=ve,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.$ZK="workbench.view.search",e.$1K="workbench.panel.search",e.$2K="workbench.view.search",e.$3K="search-result",e.$4K="search.exclude";const u="\u27EA ",v=" characters skipped \u27EB",m=(u.length+v.length+5)*2;e.$5K=(0,p.$qi)("searchService");var s;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text",ue[ue.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var o;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text",ue[ue.aiText=3]="aiText"})(o||(e.QueryType=o={}));function r(ue){return!!ue.preview}function n(ue){return!!ue.resource}function t(ue){return!!ue.message}var c;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(be){this.resource=be,this.results=[]}}e.$9K=h;class i{constructor(be,ie,Ce,Fe){this.ranges=ie,this.webviewIndex=Fe;const ne=Array.isArray(ie)?ie:[ie];if(Ce&&Ce.matchLines===1&&b(ne)){be=(0,M.$Wf)(be,Ce.matchLines);let j="",x=0,pe=0;const Oe=Math.floor(Ce.charsPerLine/5),ke=[];for(const $e of ne){const fe=Math.max($e.startColumn-Oe,0),J=$e.startColumn+Ce.charsPerLine;if(fe>pe+Oe+m){const Y=u+(fe-pe)+v;j+=Y+be.slice(fe,J),x+=fe-(pe+Y.length)}else j+=be.slice(pe,J);ke.push(new $(0,$e.startColumn-x,$e.endColumn-x)),pe=J}this.preview={text:j,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const j=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:be,matches:(0,I.$2b)(ie,x=>new a(x.startLineNumber-j,x.startColumn,x.endLineNumber-j,x.endColumn))}}}}e.$0K=i;function b(ue){const be=ue[0].startLineNumber;for(const ie of ue)if(ie.startLineNumber!==be||ie.endLineNumber!==be)return!1;return!0}class a{constructor(be,ie,Ce,Fe){this.startLineNumber=be,this.startColumn=ie,this.endLineNumber=Ce,this.endColumn=Fe}}e.$$K=a;class $ extends a{constructor(be,ie,Ce){super(be,ie,be,Ce)}}e.$_K=$;var l;(function(ue){ue.List="list",ue.Tree="tree"})(l||(e.ViewMode=l={}));var S;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function d(ue,be=!0){const ie=ue&&ue.files&&ue.files.exclude,Ce=be&&ue&&ue.search&&ue.search.exclude;if(!ie&&!Ce)return;if(!ie||!Ce)return ie||Ce;let Fe=Object.create(null);return Fe=R.$Zn(Fe,R.$Wn(ie)),Fe=R.$Zn(Fe,R.$Wn(Ce),!0),Fe}function D(ue,be){return ue.excludePattern&&T.$jk(ue.excludePattern,be)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&T.$jk(ue.includePattern,be)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(ie=>{const Ce=ie.folder.fsPath;if(O.$qg(be,Ce)){const Fe=g.$mc(Ce,be);return!ie.includePattern||!!T.$jk(ie.includePattern,Fe)}else return!1}):!1:!0}var f;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(f||(e.SearchErrorCode=f={}));class E extends Error{constructor(be,ie){super(be),this.code=ie}}e.$cL=E;function w(ue){const be=ue.message;if((0,k.$4)(ue))return new E(be,f.canceled);try{const ie=JSON.parse(be);return new E(ie.message,ie.code)}catch{return new E(be,f.other)}}function P(ue){const be={message:ue.message,code:ue.code};return new Error(JSON.stringify(be))}function C(ue){return ue.type==="error"?!0:ue.type==="success"}function V(ue){return ue.type==="success"}function W(ue){return!!ue.path}function q(ue,be,ie=!0){const Ce=ue.searchPath?ue.searchPath:ue.relativePath;return ie?(0,M.$Tf)(Ce,be):T.$jk(be,Ce)}class A{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$jL=A;function U(ue,be){const ie={...ue||{},...be||{}};return Object.keys(ie).filter(Ce=>{const Fe=ie[Ce];return typeof Fe=="boolean"&&Fe})}class K{constructor(be,ie){this.c=null,this.a={...be.excludePattern||{},...ie.excludePattern||{}},this.b=T.$kk(this.a);let Ce=be.includePattern;ie.includePattern&&(Ce?Ce={...Ce,...ie.includePattern}:Ce=ie.includePattern),Ce&&(this.c=T.$kk(Ce))}matchesExcludesSync(be,ie,Ce){return!!(this.b&&this.b(be,ie,Ce))}includedInQuerySync(be,ie,Ce){return!(this.b&&this.b(be,ie,Ce)||this.c&&!this.c(be,ie,Ce))}includedInQuery(be,ie,Ce){const Fe=this.b(be,ie,Ce),ne=()=>this.c?!!this.c(be,ie,Ce):!0;return(0,y.$ch)(Fe)?Fe.then(j=>j?!1:ne()):ne()}hasSiblingExcludeClauses(){return se(this.a)}}e.$lL=K;function se(ue){for(const be in ue)if(typeof ue[be]!="boolean")return!0;return!1}function ce(ue){if(!ue)return;let be;return ie=>(be||(be=(ue()||Promise.resolve([])).then(Ce=>Ce?Ie(Ce):{})),be.then(Ce=>!!Ce[ie]))}function ve(ue){if(!ue)return;let be;return ie=>{if(!be){const Ce=ue();be=Ce?Ie(Ce):{}}return!!be[ie]}}function Ie(ue){const be={};for(const ie of ue)be[ie]=!0;return be}}),define(Re[37],Ae([1,0,18,11,22,5,6,52,12,126,24,15,2,174,3,13,194,49,45,27,16,8,7,60,46,4,53]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b,a,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=e.$Ckc=void 0;function S(V,W,q){return new N.$Sg(A=>E(A,q)).isEqual(V,W)}function d(V,W,q){return S(V.uri,W.uri,q)?0:(0,y.$mf)(V.uri.toString(),W.uri.toString())}function D(V,W,q){return V.index!==W.index?V.index<W.index?-1:1:S(V.uri,W.uri,q)?(0,y.$mf)(V.name,W.name):(0,y.$mf)(V.uri.toString(),W.uri.toString())}function f(V,W,q,A){const U=V.slice(0).sort((se,ce)=>q(se,ce,A)),K=W.slice(0).sort((se,ce)=>q(se,ce,A));return(0,I.$Eb)(U,K,(se,ce)=>q(se,ce,A))}function E(V,W){const q=W.getCapabilities(V.scheme);return!(q&&q&1024)}class w extends r.$Ji{static toExtHostWorkspace(W,q,A,U){if(!W)return{workspace:null,added:[],removed:[]};const{id:K,name:se,folders:ce,configuration:ve,transient:Ie,isUntitled:ue}=W,be=[],ie=q;q?ce.forEach((j,x)=>{const pe=u.URI.revive(j.uri),Oe=w.o(A||q,pe,U);Oe?(Oe.name=j.name,Oe.index=j.index,be.push(Oe)):be.push({uri:pe,name:j.name,index:x})}):be.push(...ce.map(({uri:j,name:x,index:pe})=>({uri:u.URI.revive(j),name:x,index:pe}))),be.sort((j,x)=>j.index<x.index?-1:1);const Ce=new w(K,se,be,!!Ie,ve?u.URI.revive(ve):null,!!ue,j=>E(j,U)),{added:Fe,removed:ne}=f(ie?ie.workspaceFolders:[],Ce.workspaceFolders,d,U);return{workspace:Ce,added:Fe,removed:ne}}static o(W,q,A){for(let U=0;U<W.folders.length;U++){const K=W.workspaceFolders[U];if(S(K.uri,q,A))return K}}constructor(W,q,A,U,K,se,ce){super(W,A.map(ve=>new r.$Ki(ve)),U,K,ce),this.t=q,this.u=se,this.q=[],this.s=p.$wi.forUris(ce),A.forEach(ve=>{this.q.push(ve),this.s.set(ve.uri,ve)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,q){return q&&this.s.get(W)&&(W=(0,N.$3g)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let P=class{constructor(W,q,A,U,K){this.c=new O.$be,this.onDidChangeWorkspace=this.c.event,this.g=new O.$be,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$de,this.C=new Map,this.h=U,this.s=A,this.t=K,this.j=new k.$xm,this.k=new T.$ph,this.o=W.getProxy($.$QM.MainThreadWorkspace),this.q=W.getProxy($.$QM.MainThreadMessageService);const se=q.workspace;this.l=se?new w(se.id,se.name,[],!!se.transient,se.configuration?u.URI.revive(se.configuration):null,!!se.isUntitled,ce=>E(ce,A)):void 0}$initializeWorkspace(W,q){this.v=q,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:g.Schemas.untitled,path:(0,N.$1g)((0,N.$3g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,q,A,...U){const K=[];if(Array.isArray(U)&&U.forEach(ue=>{u.URI.isUri(ue.uri)&&!K.some(be=>S(be.uri,ue.uri,this.s))&&K.push({uri:ue.uri,name:ue.name||(0,N.$Zg)(ue.uri)})}),this.n||[q,A].some(ue=>typeof ue!="number"||ue<0)||A===0&&K.length===0)return!1;const se=this.x?this.x.workspaceFolders:[];if(q+A>se.length)return!1;const ce=se.slice(0);ce.splice(q,A,...K.map(ue=>({uri:ue.uri,name:ue.name||(0,N.$Zg)(ue.uri),index:void 0})));for(let ue=0;ue<ce.length;ue++){const be=ce[ue];if(ce.some((ie,Ce)=>Ce!==ue&&S(be.uri,ie.uri,this.s)))return!1}ce.forEach((ue,be)=>ue.index=be);const{added:ve,removed:Ie}=f(se,ce,D,this.s);if(ve.length===0&&Ie.length===0)return!1;if(this.o){const ue=W.displayName||W.name;this.o.$updateWorkspaceFolders(ue,q,A,K).then(void 0,be=>{this.n=void 0;const ie={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(o.Severity.Error,(0,v.localize)(0,null,ue,be.toString()),ie,[])})}return this.y(ce),!0}getWorkspaceFolder(W,q){if(this.x)return this.x.getWorkspaceFolder(W,q)}async getWorkspaceFolder2(W,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,q)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,q){let A,U="";if(typeof W=="string"?(A=u.URI.file(W),U=W):typeof W<"u"&&(A=W,U=W.fsPath),!A)return U;const K=this.getWorkspaceFolder(A,!0);if(!K)return U;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let se=(0,N.$6g)(K.uri,A);return q&&K.name&&(se=`${K.name}/${se}`),se}y(W){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:q,added:A,removed:U}=w.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:U}))}findFiles(W,q,A,U,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let se="",ce=!0;return q===null?ce=!1:q!==void 0&&(typeof q=="string"?se=q:se=q.pattern),this.z(W,void 0,{exclude:se,maxResults:A,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(W,q={},A,U=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,W,q,U)}async z(W,q,A,U=R.CancellationToken.None){if(U&&U.isCancellationRequested)return Promise.resolve([]);const K=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,se={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:K,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let ce;if(W){const{includePattern:ve,folder:Ie}=C(h.GlobPattern.from(W));ce=Ie,se.includePattern=ve}else{const{includePattern:ve,folder:Ie}=C(h.GlobPattern.from(q));ce=Ie,se.filePattern=ve}return this.o.$startFileSearch(ce??null,se,U).then(ve=>Array.isArray(ve)?ve.map(Ie=>u.URI.revive(Ie)):[])}async findTextInFiles(W,q,A,U,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const se=this.j.getNext(),ce=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ve,folder:Ie}=C(h.GlobPattern.from(q.include)),ue=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,be={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ce,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ve,excludePattern:ue},ie=!1;if(this.u[se]=Ce=>{if(ie)return;const Fe=u.URI.revive(Ce.resource);Ce.results.forEach(ne=>{const j=(0,l.$Zh)(ne);(0,a.$6K)(j)?A({uri:Fe,preview:{text:j.preview.text,matches:(0,I.$2b)(j.preview.matches,x=>new i.$UM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,I.$2b)(j.ranges,x=>new i.$UM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):A({uri:Fe,text:j.text,lineNumber:j.lineNumber})})},K.isCancellationRequested)return{};try{const Ce=await this.o.$startTextSearch(W,Ie??null,be,se,K);return delete this.u[se],Ce||{}}catch(Ce){throw delete this.u[se],Ce}}$handleTextSearchResult(W,q){this.u[q]?.(W)}async save(W){const q=await this.o.$save(W,{saveAs:!1});return u.URI.revive(q)}async saveAs(W){const q=await this.o.$save(W,{saveAs:!0});return u.URI.revive(q)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,q){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,q);const A=this.t.transformOutgoingScheme(W),U=this.A++;return this.o.$registerEditSessionIdentityProvider(U,A),(0,M.$Sc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(W,q){this.h.info("Getting edit session identifier for workspaceFolder",W);const A=await this.resolveWorkspaceFolder(u.URI.revive(W));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const U=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!U),!U)return;const K=await U.provideEditSessionIdentity(A,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(W,q,A,U){this.h.info("Getting edit session identifier for workspaceFolder",W);const K=await this.resolveWorkspaceFolder(u.URI.revive(W));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const se=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!se),!se)return;const ce=await se.provideEditSessionIdentityMatch?.(q,A,U);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(W){return(q,A,U)=>{const K=function(ce){q.call(A,ce)};return K.extension=W,this.B.event(K,void 0,U)}}async $onWillCreateEditSessionIdentity(W,q,A){const U=await this.resolveWorkspaceFolder(u.URI.revive(W));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:U},q,async(K,se)=>{const ce=Date.now();await Promise.resolve(K),Date.now()-ce>A&&this.h.warn("SLOW edit session create-participant",se.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(W,q){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,q);const A=this.t.transformOutgoingScheme(W),U=this.A++;return this.o.$registerCanonicalUriProvider(U,A),(0,M.$Sc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(W,q,A){const U=this.C.get(W.scheme);if(!U)return;const K=await U.provideCanonicalUri?.(u.URI.revive(W),q,A);if(K)return K}async $provideCanonicalUri(W,q,A){return this.provideCanonicalUri(u.URI.revive(W),{targetScheme:q},A)}};e.$Ckc=P,e.$Ckc=P=Je([Ve(0,c.$dP),Ve(1,t.$tP),Ve(2,n.$lkc),Ve(3,s.$Wj),Ve(4,b.$Akc)],P),e.$Dkc=(0,m.$qi)("IExtHostWorkspace");function C(V){let W,q;return V&&(typeof V=="string"?W=V:(W=V.pattern,q=u.URI.revive(V.baseUri))),{includePattern:W,folder:q}}}),define(Re[38],Ae([1,0,26,5,37,4,7,196,57,17,11,3,16,13,2]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=e.$Fkc=e.$Ekc=void 0;function s(b,a){if(a){const $=a.split(".");let l=b;for(let S=0;l&&S<$.length;S++)l=l[$[S]];return l}}function o(b){return b instanceof m.URI}function r(b){return b&&b.uri instanceof m.URI&&b.languageId&&typeof b.languageId=="string"}function n(b){return b&&!b.uri&&b.languageId&&typeof b.languageId=="string"}function t(b){return b&&b.uri instanceof m.URI&&(!b.name||typeof b.name=="string")&&(!b.index||typeof b.index=="number")}function c(b){if(o(b))return{resource:b};if(r(b))return{resource:b.uri,overrideIdentifier:b.languageId};if(n(b))return{overrideIdentifier:b.languageId};if(t(b))return{resource:b.uri};if(b===null)return{resource:null}}let h=class{constructor(a,$,l){this.a=a.getProxy(O.$QM.MainThreadConfiguration),this.c=$,this.b=l,this.d=new N.$ph,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new i(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,$){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(a,$))}};e.$Ekc=h,e.$Ekc=h=Je([Ve(0,u.$dP),Ve(1,R.$Dkc),Ve(2,v.$Wj)],h);class i{constructor(a,$,l,S){this.a=new T.$be,this.b=a,this.f=S,this.c=$,this.e=p.$uo.parse(l,S),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,$){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$uo.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j($,l))}getConfiguration(a,$,l){const S=c($)||{},d=this.g(a?s(this.e.getValue(void 0,S,this.c.workspace),a):this.e.getValue(void 0,S,this.c.workspace));a&&this.h(a,S,l?.identifier);function D(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(E){return typeof s(d,E)<"u"},get:(E,w)=>{this.h(a?`${a}.${E}`:E,S,l?.identifier);let P=s(d,E);if(typeof P>"u")P=w;else{let C;const V=(W,q)=>{if((0,k.$6f)(W)){let A;const U=()=>{C=C||(0,I.$Wn)(d),A=A||s(C,q)};return new Proxy(W,{get:(K,se)=>{if(typeof se=="string"&&se.toLowerCase()==="tojson")return U(),()=>A;if(C)return A=A||s(C,q),A[se];const ce=K[se];return typeof se=="string"?V(ce,`${q}.${se}`):ce},set:(K,se,ce)=>(U(),A&&(A[se]=ce),!0),deleteProperty:(K,se)=>(U(),A&&delete A[se],!0),defineProperty:(K,se,ce)=>(U(),A&&Object.defineProperty(A,se,ce),!0)})}return Array.isArray(W)?(0,I.$Wn)(W):W};P=V(P,E)}return P},update:(E,w,P,C)=>{E=a?`${a}.${E}`:E;const V=D(P);return w!==void 0?this.b.$updateConfigurationOption(V,E,w,S,C):this.b.$removeConfigurationOption(V,E,S,C)},inspect:E=>{E=a?`${a}.${E}`:E;const w=this.e.inspect(E,S,this.c.workspace);if(w)return{key:E,defaultValue:(0,I.$Wn)(w.policy?.value??w.default?.value),globalValue:(0,I.$Wn)(w.user?.value??w.application?.value),workspaceValue:(0,I.$Wn)(w.workspace?.value),workspaceFolderValue:(0,I.$Wn)(w.workspaceFolder?.value),defaultLanguageValue:(0,I.$Wn)(w.default?.override),globalLanguageValue:(0,I.$Wn)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,I.$Wn)(w.workspace?.override),workspaceFolderLanguageValue:(0,I.$Wn)(w.workspaceFolder?.override),languageIds:(0,I.$Wn)(w.overrideIdentifiers)}}};return typeof d=="object"&&(0,I.$Zn)(f,d,!1),Object.freeze(f)}g(a){const $=l=>(0,k.$6f)(l)?new Proxy(l,{get:(S,d)=>$(S[d]),set:(S,d,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(S,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(S,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return $(a)}h(a,$,l){const S=g.$lo.test(a)?4:this.d.get(a),d=l?`[${l.value}] `:"";if(S===4){typeof $?.resource>"u"&&this.f.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(S===3){$?.resource&&this.f.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,$){const l=new p.$wo(a,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,d)=>l.affectsConfiguration(S,c(d))})}k(a){return a.reduce(($,l)=>($.set(l[0],l[1]),$),new Map)}}e.$Fkc=i,e.$Gkc=(0,y.$qi)("IExtHostConfiguration")}),define(Re[119],Ae([1,0,2,11,5,4,7,37,67,38,22,51,16,27,3,12,21,13,78,230,14]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=e.$0lc=e.$9lc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(h||(h={}));var i;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(i||(i={}));var b;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(b||(b={}));var a;(function(V){function W(U){if(U){const K=U;return K&&!!K.process}else return!1}V.is=W;function q(U){if(U==null)return;const K={process:U.process,args:U.args};return U.options&&(K.options=b.from(U.options)),K}V.from=q;function A(U){if(U!=null)return new M.$BN(U.process,U.args,U.options)}V.to=A})(a||(a={}));var $;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})($||($={}));var l;(function(V){function W(U){if(U){const K=U;return K&&(!!K.commandLine||!!K.command)}else return!1}V.is=W;function q(U){if(U==null)return;const K={};return U.commandLine!==void 0?K.commandLine=U.commandLine:(K.command=U.command,K.args=U.args),U.options&&(K.options=$.from(U.options)),K}V.from=q;function A(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new M.$CN(U.commandLine,U.options):new M.$CN(U.command,U.args?U.args:[],U.options)}V.to=A})(l||(l={}));var S;(function(V){function W(U){if(U){const K=U;return K&&K.customExecution==="customExecution"}else return!1}V.is=W;function q(U){return{customExecution:"customExecution"}}V.from=q;function A(U,K){return K.get(U)}V.to=A})(S||(e.CustomExecutionDTO=S={}));var d;(function(V){function W(q,A){let U;return q.scope!==void 0&&typeof q.scope!="number"?U=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===M.TaskScope.Workspace&&A&&A.workspaceFile?U=A.workspaceFile:U=t.$WH),{id:q._id,workspaceFolder:U}}V.from=W})(d||(e.TaskHandleDTO=d={}));var D;(function(V){function W(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}V.from=W})(D||(D={}));var f;(function(V){function W(U,K){if(U==null)return[];const se=[];for(const ce of U){const ve=q(ce,K);ve&&se.push(ve)}return se}V.fromMany=W;function q(U,K){if(U==null)return;let se;U.execution instanceof M.$BN?se=a.from(U.execution):U.execution instanceof M.$CN?se=l.from(U.execution):U.execution&&U.execution instanceof M.$DN&&(se=S.from(U.execution));const ce=h.from(U.definition);let ve;return U.scope?typeof U.scope=="number"?ve=U.scope:ve=U.scope.uri:ve=M.TaskScope.Workspace,!ce||!ve?void 0:{_id:U._id,definition:ce,name:U.name,source:{extensionId:K.identifier.value,label:U.source,scope:ve},execution:se,isBackground:U.isBackground,group:D.from(U.group),presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}V.from=q;async function A(U,K,se){if(U==null)return;let ce;a.is(U.execution)?ce=a.to(U.execution):l.is(U.execution)?ce=l.to(U.execution):S.is(U.execution)&&(ce=S.to(U._id,se));const ve=h.to(U.definition);let Ie;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Ie=U.source.scope:Ie=await K.resolveWorkspaceFolder(I.URI.revive(U.source.scope)):Ie=M.TaskScope.Workspace),!ve||!Ie)return;const ue=new M.$EN(ve,Ie,U.name,U.source.label,ce,U.problemMatchers);return U.isBackground!==void 0&&(ue.isBackground=U.isBackground),U.group!==void 0&&(ue.group=M.$AN.from(U.group._id),ue.group&&U.group.isDefault&&(ue.group=new M.$AN(ue.group.id,ue.group.label),U.group.isDefault===!0&&(ue.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ue.presentationOptions=i.to(U.presentationOptions)),U._id&&(ue._id=U._id),U.detail&&(ue.detail=U.detail),ue}V.to=A})(f||(e.TaskDTO=f={}));var E;(function(V){function W(A){return A}V.from=W;function q(A){if(A)return Object.assign(Object.create(null),A)}V.to=q})(E||(E={}));class w{#e;constructor(W,q,A){this._id=q,this.a=A,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let P=class{constructor(W,q,A,U,K,se,ce,ve){this.q=new R.$be,this.r=new R.$be,this.s=new R.$be,this.u=new R.$be,this.a=W.getProxy(O.$QM.MainThreadTask),this.b=A,this.c=U,this.d=K,this.e=se,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ve,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,q,A){if(!A)return new M.$SM(()=>{});const U=this.x();return this.j.set(U,{type:q,provider:A,extension:W}),this.a.$registerTaskProvider(U,q),new M.$SM(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(W,q){this.a.$registerTaskSystem(W,q)}fetchTasks(W){return this.a.$fetchTasks(E.from(W)).then(async q=>{const A=[];for(const U of q){const K=await f.to(U,this.b,this.m);K&&A.push(K)}return A})}get taskExecutions(){const W=[];return this.k.forEach(q=>W.push(q)),W}terminateTask(W){if(!(W instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,q,A){const U=this.m.get(W.id);U&&(this.o.set(W.id,U),this.e.attachPtyToTerminal(q,await U.callback(A))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const q=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const q=await this.z(W.id);this.s.fire({execution:q,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const q=await this.z(W.id);this.u.fire({execution:q,exitCode:W.exitCode})}$provideTasks(W,q){const A=this.j.get(W);if(!A)return Promise.reject(new Error("no handler found"));const U=[],K=(0,T.$ih)(()=>A.provider.provideTasks(N.CancellationToken.None)).then(se=>this.v(q,U,A,se));return new Promise(se=>{K.then(ce=>{Promise.all(U).then(()=>{se(ce)})})})}async $resolveTask(W,q){const A=this.j.get(W);if(!A)return Promise.reject(new Error("no handler found"));if(q.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${A.type}].`);const U=await f.to(q,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const K=await A.provider.resolveTask(U,N.CancellationToken.None);if(!K)return;this.A(K,A);const se=f.from(K,A.extension);if(!se)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(se.execution)&&await this.y(se,K,!0),await this.w(se)}x(){return this.h++}async y(W,q,A){const U=await this.a.$createTaskId(W);!A&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,q.execution)),this.m.set(U,q.execution)}async z(W,q){if(typeof W=="string"){const K=this.l.get(W);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const A=this.l.get(W.id);if(A)return A;let U;return q?U=Promise.resolve(new w(this,W.id,q)):U=f.to(W.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new w(this,W.id,K)}),this.l.set(W.id,U),U.then(K=>(this.k.set(W.id,K),K))}A(W,q){W._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const A=this.n.values();let U=A.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=A.next()}};e.$9lc=P,e.$9lc=P=Je([Ve(0,u.$dP),Ve(1,v.$tP),Ve(2,p.$Dkc),Ve(3,g.$oP),Ve(4,k.$Gkc),Ve(5,y.$5kc),Ve(6,r.$Wj),Ve(7,n.$hkc)],P);let C=class extends P{constructor(W,q,A,U,K,se,ce,ve){super(W,q,A,U,K,se,ce,ve),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(W,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const A=f.from(q,W);if(A===void 0)throw new Error("Task is not valid");if(S.is(A.execution))await this.y(A,q,!1);else throw new c.$_;const U=await this.z(await this.a.$getTaskExecution(A),q);return this.a.$executeTask(A).catch(K=>{throw new Error(K)}),U}v(W,q,A,U){const K=[];if(U)for(const se of U){if(this.A(se,A),!se.definition||!W[se.definition.type]){const ve=se.source?se.source:"No task source";this.f.warn(`The task [${ve}, ${se.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=f.from(se,A.extension);ce&&S.is(ce.execution)?(K.push(ce),q.push(this.y(ce,se,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:A.extension}}async w(W){if(S.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,q,A){}};e.$0lc=C,e.$0lc=C=Je([Ve(0,u.$dP),Ve(1,v.$tP),Ve(2,p.$Dkc),Ve(3,g.$oP),Ve(4,k.$Gkc),Ve(5,y.$5kc),Ve(6,r.$Wj),Ve(7,n.$hkc)],C),e.$$lc=(0,m.$qi)("IExtHostTask")}),define(Re[288],Ae([1,0,46,29]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uL=void 0,e.$tL=R,e.$vL=O;function R(M){return"cellResults"in M}e.$uL="rawCell#";function O(M,p){let g=-1;const k=[];let N=[];return M.forEach(u=>{u.range.startLineNumber!==g&&N.length>0&&(k.push([...N]),N=[]),N.push(u),g=u.range.endLineNumber}),N.length>0&&k.push([...N]),k.map(u=>{const v=[],m=u[0].range.startLineNumber,s=u[u.length-1].range.endLineNumber;for(let o=m;o<=s;o++)v.push(p.getLineContent(o));return new I.$0K(v.join(`
`)+`
`,u.map(o=>new T.$kt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Re[289],Ae([1,0,168,23,5,6,28,15,17,2,44,74,4,32,8,7,34,264,112,26,12,220,288,286]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(l=>l.apiEditor)}constructor(l,S,d,D,f,E){this.q=d,this.r=D,this.s=f,this.t=E,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new R.$be,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$be,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$be,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$be,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new y.$fkc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=l.getProxy(u.$QM.MainThreadNotebook),this.c=l.getProxy(u.$QM.MainThreadNotebookDocuments),this.d=l.getProxy(u.$QM.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===13){const P=w.notebookEditor?.notebookUri,C=w.cell.handle,W=this.g.get(P)?.getCell(C);if(W)return W.apiCell}if(w&&w.$mid===14){const P=w.uri,C=this.g.get(P);if(C)return C.apiNotebook}return w}}),a.B(S)}getEditorById(l){const S=this.h.get(l);if(!S)throw new Error(`unknown text editor: ${l}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(l){for(const[S,d]of this.h)if(d.apiEditor===l)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(l,S){const d=this.g.get(l);if(!d&&!S)throw new Error(`NO notebook document for '${l}'`);return d}static u(l,S){if(!S)return;const d=S.filenamePattern.map(D=>m.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(S.filenamePattern&&!d){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:S.displayName,filenamePattern:d,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,S,d){const D=a.a++,f=typeof d.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(D,d),this.b.$registerNotebookCellStatusBarItemProvider(D,f,S);let E;return f!==void 0&&(E=d.onDidChangeCellStatusBarItems(w=>this.b.$emitCellStatusBarEvent(f))),new s.$SM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,f),E?.dispose()})}async createNotebookDocument(l){const S=await this.c.$tryCreateNotebook({viewType:l.viewType,content:l.content&&m.NotebookData.from(l.content)});return k.URI.revive(S)}async openNotebookDocument(l){const S=this.g.get(l);if(S)return S.apiNotebook;const d=await this.c.$tryOpenNotebook(l),D=this.g.get(k.URI.revive(d));return(0,g.$cg)(D?.apiNotebook)}async showNotebookDocument(l,S){k.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let d;typeof S=="object"?d={position:m.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(m.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:d={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(l.uri,l.notebookType,d),f=D&&this.h.get(D)?.apiEditor;if(f)return f;throw D?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,S,d,D){const f=this.f.get(l),E=k.URI.revive(S),w=this.g.get(E);if(!w||!f)return;const P=w.getCellFromIndex(d);if(!P)return;const C=await f.provideCellStatusBarItems(P.apiCell,D);if(!C)return;const V=new O.$Tc,W=this.p.add([V]),A=(Array.isArray(C)?C:[C]).map(U=>m.NotebookStatusBarItem.from(U,this.i,V));return{cacheId:W,items:A}}$releaseNotebookCellStatusBarItems(l){this.p.delete(l)}registerNotebookSerializer(l,S,d,D,f){if((0,p.$3e)(S))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:S,serializer:d,options:D}),this.b.$registerNotebookSerializer(E,{id:l.identifier,location:l.extensionLocation},S,m.NotebookDocumentContentOptions.from(D),a.u(l,f)),(0,O.$Sc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(l,S,d){const D=this.x.get(l);if(!D)throw new Error("NO serializer found");const f=await D.serializer.deserializeNotebook(S.buffer,d);return new o.$mw(m.NotebookData.from(f))}async $notebookToData(l,S,d){const D=this.x.get(l);if(!D)throw new Error("NO serializer found");const f=await D.serializer.serializeNotebook(m.NotebookData.to(S.value),d);return T.$Ce.wrap(f)}async $saveNotebook(l,S,d,D,f){const E=k.URI.revive(S),w=this.x.get(l);if(!w)throw new Error("NO serializer found");const P=this.g.get(E);if(!P)throw new Error("Document NOT found");if(P.versionId!==d)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new N.$fl((0,I.localize)(0,null,this.z(E)),6);await this.y(E,D);const C={metadata:(0,t.$5n)(P.apiNotebook.metadata,U=>!(w.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of P.apiNotebook.getCells()){const K=new s.$iO(U.kind,U.document.getText(),U.document.languageId,U.mime,w.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);K.metadata=(0,t.$5n)(U.metadata,se=>!(w.options?.transientCellMetadata??{})[se]),C.cells.push(K)}const V=await w.serializer.serializeNotebook(C,f);await this.s.value.writeFile(E,V);const W=this.s.getFileSystemProviderExtUri(E.scheme),q=await this.s.value.stat(E);return{name:W.basename(E),isFile:(q.type&N.FileType.File)!==0,isDirectory:(q.type&N.FileType.Directory)!==0,isSymbolicLink:(q.type&N.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&N.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((q.permissions??0)&N.FilePermission.Locked),etag:N.$ql({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(l,S,d,D,f){const E=this.x.get(l)?.serializer;if(!E)return{limitHit:!1,results:[]};const w=new M.$Cc;await(async(q,A,U)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(se=>{const ce={_reason:U._reason,folderQueries:U.folderQueries,includePattern:U.includePattern,excludePattern:U.excludePattern,maxResults:U.maxResults,type:1,filePattern:se};return this.t.doInternalFileSearchWithCustomCallback(ce,A,ve=>{ve.forEach(Ie=>{w.has(Ie)||D.some(be=>K.isFromSettings&&!be.isFromSettings?!1:be.filenamePatterns.some(ie=>(0,b.$Bgb)(ie,Ie)))||w.add(Ie)})}).catch(ve=>{if(ve.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ve})}))))})(d,f,S);const C=new M.$Bc;let V=!1;const W=Array.from(w).map(async q=>{const A=[];try{if(f.isCancellationRequested)return;if(S.maxResults&&[...C.values()].reduce((ce,ve)=>ce+ve.cellResults.length,0)>S.maxResults){V=!0;return}const U=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ve=>U.push({input:ve.document.getText(),outputs:ve.outputs.flatMap(Ie=>Ie.items.map(ue=>ue.data.toString()))}));else{const ce=await this.s.value.readFile(q),ve=T.$Ce.fromString(ce.toString()),Ie=await E.deserializeNotebook(ve.buffer,f);if(f.isCancellationRequested)return;m.NotebookData.from(Ie).cells.forEach(be=>U.push({input:be.source,outputs:be.outputs.flatMap(ie=>ie.items.map(Ce=>Ce.valueBytes.toString()))}))}if(f.isCancellationRequested)return;U.forEach((ce,ve)=>{const Ie=S.contentPattern.pattern,ue=new h.$oWb(ce.input,void 0,ce.outputs),be=ue.findInInputs(Ie),ie=ue.findInOutputs(Ie),Ce=ie.flatMap(Fe=>(0,i.$vL)(Fe.matches,Fe.textBuffer)).map((Fe,ne)=>(Fe.webviewIndex=ne,Fe));if(be.length>0||ie.length>0){const Fe={index:ve,contentResults:(0,i.$vL)(be,ue.inputTextBuffer),webviewResults:Ce};A.push(Fe)}});const se={resource:q,cellResults:A};C.set(q,se);return}catch{return}});return await Promise.all(W),{limitHit:V,results:[...C.values()]}}async y(l,S){const d=await this.s.value.stat(l);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==N.$pl&&typeof d.mtime=="number"&&typeof d.size=="number"&&S.mtime<d.mtime&&S.etag!==N.$ql({mtime:S.mtime,size:d.size}))throw new N.$fl((0,I.localize)(1,null),3,S)}z(l){return l.scheme===c.Schemas.file?l.fsPath:l.toString()}A(l,S,d){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const D=new n.$Clc(S,this.d,l,d.visibleRanges.map(m.NotebookRange.to),d.selections.map(m.NotebookRange.to),typeof d.viewColumn=="number"?m.ViewColumn.to(d.viewColumn):void 0);this.h.set(S,D)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const d of l.value.removedDocuments){const D=k.URI.revive(d),f=this.g.get(D);f&&(f.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(f.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===D.toString()&&this.h.delete(E.id)}if(l.value.addedDocuments){const d=[];for(const D of l.value.addedDocuments){const f=k.URI.revive(D.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const E=new r.$Blc(this.c,this.q,this.r,f,D);d.push(...D.cells.map(w=>r.$Alc.asModelAddData(w))),this.g.get(f)?.dispose(),this.g.set(f,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:d}),this.m.fire(E.apiNotebook)}}if(l.value.addedEditors)for(const d of l.value.addedEditors){if(this.h.has(d.id))return;const D=k.URI.revive(d.documentUri),f=this.g.get(D);f&&this.A(f,d.id,d)}const S=[];if(l.value.removedEditors)for(const d of l.value.removedEditors){const D=this.h.get(d);D&&(this.h.delete(d),this.k?.id===D.id&&(this.k=void 0),S.push(D))}if(l.value.visibleEditors){this.l=l.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const d=new Set;this.l.forEach(D=>d.add(D.id));for(const D of this.h.values()){const f=d.has(D.id);D._acceptVisibility(f)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this.k=void 0:l.value.newActiveEditor&&(this.h.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this.k=this.h.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(l){const S=v.$BP.String.with("notebookType","A notebook type"),d=new v.$DP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new v.$BP("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>T.$Ce.wrap(f))],new v.$CP("Notebook Data",f=>m.NotebookData.to(f.value))),D=new v.$DP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new v.$BP("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new o.$mw(m.NotebookData.from(f)))],new v.$CP("Bytes",f=>f.buffer));l.registerApiCommand(d),l.registerApiCommand(D)}}e.$Llc=a}),define(Re[290],Ae([1,0,19,22,43,36,24,65,46]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0;class k{constructor(u,v,m){this.k=u,this.l=v,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&O.$kk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&O.$kk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const v=this.k.folderQueries||[];return new Promise((m,s)=>{const o=r=>{this.f++,u(r)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const n=r.toString(),t=I.$oc(n);this.j&&this.j(n,t)||this.v(o,{base:r,basename:t})}),Promise.all(v.map(r=>this.p(r,o))).then(r=>{m({limitHit:this.e,stats:r[0]||void 0})},r=>{s(new Error((0,R.$bj)(r)))})})}async p(u,v){const m=new T.$me,s=this.q(u),o=this.r(),r=new g.$lL(this.k,u),n=!r.hasSiblingExcludeClauses();let t;try{this.h.add(m),t=p.$0d.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,m.token),h=t.elapsed(),i=p.$0d.create();return this.g&&!this.e||(c&&c.forEach(b=>{const a=I.$hc.relative(u.folder.path,b.path);if(n){const $=I.$oc(b.path);this.v(v,{base:u.folder,relativePath:a,basename:$});return}this.s(o,u.folder,a,v)}),this.g&&!this.e)?null:(this.u(o,r,v),{providerTime:h,postProcessTime:i.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(u){const v=(0,g.$kL)(this.k.includePattern,u.includePattern),m=(0,g.$kL)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:m,includes:v,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},v,m,s){if(m===this.a){const r=I.$oc(this.a);this.v(s,{base:v,relativePath:this.a,basename:r})}function o(r){const n=I.$oc(r),t=I.$nc(r);let c=u[t];c||(c=u[t]=[],o(t)),c.push({base:v,relativePath:r,basename:n})}o(m)}u({rootEntries:u,pathToEntries:v},m,s){const o=this,r=this.a;function n(t){const c=(0,g.$nL)(()=>t.map(h=>h.basename));for(let h=0,i=t.length;h<i;h++){const b=t[h],{relativePath:a,basename:$}=b;if(m.matchesExcludesSync(a,$,r!==$?c:void 0))continue;const l=v[a];if(l)n(l);else{if(a===r)continue;o.v(s,b)}if(o.e)break}}n(u)}v(u,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(v))}}class N{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,v,m,s){const o=this.c(u.cacheKey),r=new k(u,v,o&&o.token);let n=0;const t=c=>{n+=c.length,m(c.map(h=>this.d(h)))};return this.e(r,N.a,t,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new T.$me),this.b.get(u)}d(u){return u.relativePath?{resource:M.$4g(u.base,u.relativePath)}:{resource:u.base}}e(u,v,m,s){const o=s.onCancellationRequested(()=>{u.cancel()}),r=t=>{t&&(n.push(t),v>0&&n.length>=v&&(m(n),n=[]))};let n=[];return u.search(r).then(t=>(n.length&&m(n),o.dispose(),t),t=>(n.length&&m(n),o.dispose(),Promise.reject(t)))}}e.$Dlc=N}),define(Re[291],Ae([1,0,18,259,36,96,28,12,19,24,15,17,2,95,186,48,13,49,107,287,46]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=void 0,e.$vM=D;let h=class{constructor(E,w,P,C,V){this.a=E,this.b=w,this.c=P,this.d=C,this.e=V}text(E,w,P={}){E=this.f(E,P);const C=this.a.getValue(),V=w&&w.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(w?.map(r.$Li),P),type:2,contentPattern:E,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:C.search.usePCRE2||V||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(E,w){const P=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const C={...E,wordSeparators:P.editor.wordSeparators};return this.j(E,w)&&(C.isCaseSensitive=!0),this.k(E)&&(C.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),C}file(E,w={}){return{...this.h(E,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey,shouldGlobMatchFilePattern:w.shouldGlobSearch}}g(E,w){return E?(E=Array.isArray(E)?E.map(l):l(E),w?this.parseSearchPaths(E):{pattern:b(...Array.isArray(E)?E:[E])}):{}}h(E=[],w={}){const P=this.g(w.includePattern,w.expandPatterns),C=this.g(w.excludePattern,w.expandPatterns),V=E.length>1,W=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(U=>this.q(U,w,C)):E.map(U=>this.r(U,w,C,V))).filter(U=>!!U),q={_reason:w._reason,folderQueries:W,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:C.pattern,includePattern:P.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const U=I.$Hb(I.$Rb(this.c.groups.map(ce=>ce.editors.map(ve=>ve.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const K=U.filter(ce=>(0,c.$bL)(q,ce.fsPath)),se=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(se)),{...q,...se}}const A=w.extraFileResources&&w.extraFileResources.filter(U=>(0,c.$bL)(q,U.fsPath));return q.extraFileResources=A&&A.length?A:void 0,q}i(E){const w=[],P=new M.$Bc,C={};let V=!1;return E.forEach(W=>{if(W.scheme===p.Schemas.walkThrough)return;if((0,k.$8g)(W)){const A=this.b.getWorkspaceFolder(W)?.uri??W.with({path:g.$nc(W.fsPath)});let U=P.get(A);U||(V=!0,U={folder:A,includePattern:{}},w.push(U),P.set(A,U));const K=g.$mc(A.fsPath,W.fsPath);(0,y.$cg)(U.includePattern)[K.replace(/\\/g,"/")]=!0}else W.fsPath&&(V=!0,C[W.fsPath]=!0)}),{folderQueries:w,includePattern:C,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(E,w){if(w.isSmartCase){if(E.isRegExp){if(N.$Uf(E.pattern,!0))return!0}else if(N.$Uf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,v.$BC)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const w=se=>g.$jc(se)||/^\.\.?([\/\\]|$)/.test(se),C=(Array.isArray(E)?E:a(E)).map(se=>{const ce=this.e.resolvedUserHome;return ce?(0,O.$rw)(se,ce.scheme===p.Schemas.file?ce.fsPath:ce.path):se}),V=T.$K(C,se=>w(se)?"searchPaths":"exprSegments"),W=(V.exprSegments||[]).map(se=>N.$bf(se,"/")).map(se=>N.$bf(se,"\\")).map(se=>(se[0]==="."&&(se="*"+se),$(se))),q={},A=this.m(V.searchPaths||[]);A&&A.length&&(q.searchPaths=A);const U=I.$Rb(W),K=b(...U);return K&&(q.pattern=K),q}l(E,w){return w.disregardExcludeSettings?void 0:(0,c.$aL)(E,!w.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const w=E.flatMap(C=>{let{pathPortion:V,globPortion:W}=i(C);return W&&(W=S(W)),this.n(V).flatMap(A=>this.o(A,W))}),P=new Map;return w.forEach(C=>{const V=C.searchPath.toString(),W=P.get(V);W?C.pattern&&(W.pattern=W.pattern||{},W.pattern[C.pattern]=!0):P.set(V,{searchPath:C.searchPath,pattern:C.pattern?b(C.pattern):void 0})}),Array.from(P.values())}n(E){if(g.$jc(E)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==p.Schemas.file?[{searchPath:w[0].uri.with({path:E})}]:[{searchPath:u.URI.file(g.$ic(E))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(E=l(E),E.startsWith("../")||E===".."){const C=g.$hc.resolve(w.path,E);return[{searchPath:w.with({path:C})}]}const P=S(E);return[{searchPath:w,pattern:P}]}else{if(E==="./"||E===".\\")return[];{const w=E.replace(/^\.[\/\\]/,""),C=this.b.getWorkspace().folders.map(V=>{const W=w.match(new RegExp(`^${N.$8e(V.name)}(?:/(.*)|$)`));return W?{match:W,folder:V}:null}).filter(y.$_f);if(C.length)return C.map(V=>{const W=V.match[1];return{searchPath:V.folder.uri,pattern:W&&S(W)}});{const V=E.match(/\.[\/\\](.+)[\/\\]?/),W=V?V[1]:E,q=m.localize(0,null,W);throw new Error(q)}}}}o(E,w){const P=E.pattern&&w?`${E.pattern}/${w}`:E.pattern||w,C=[{searchPath:E.searchPath,pattern:P}];return P&&!P.endsWith("**")&&C.push({searchPath:E.searchPath,pattern:P+"/**"}),C}q(E,w,P){const C=this.r((0,r.$Li)(E.searchPath),w,P,!1);return C?{...C,includePattern:E.pattern}:null}r(E,w,P,C){let V;const W=u.URI.isUri(E)?E:E.uri;if(P.searchPaths){const se=P.searchPaths.filter(ce=>(0,k.$Wg)(ce.searchPath,W))[0];if(se&&!se.pattern)return null;se&&(V=se.pattern)}const q=this.a.getValue({resource:W}),U={...this.l(q,w)||{},...V||{}},K=u.URI.isUri(E)?(0,k.$1g)(E):E.name;return{folder:W,folderName:C?K:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!q.search.followSymlinks}}};e.$uM=h,e.$uM=h=Je([Ve(0,s.$Wi),Ve(1,r.$zi),Ve(2,n.$ID),Ve(3,o.$Wj),Ve(4,t.$sM)],h);function i(f){const E=f.match(/[\*\{\}\(\)\[\]\?]/);if(E){const w=E.index,P=f.substr(0,w).match(/[/|\\][^/\\]*$/);if(P){let C=f.substr(0,P.index);return C.match(/[/\\]/)||(C+="/"),{pathPortion:C,globPortion:f.substr((P.index||0)+1)}}}return{pathPortion:f}}function b(...f){return f.length?f.reduce((E,w)=>(E[w]=!0,E),Object.create(null)):void 0}function a(f){return R.$ik(f,",").map(E=>E.trim()).filter(E=>!!E.length)}function $(f){return[`**/${f}/**`,`**/${f}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function l(f){return f.replace(/\\/g,"/")}function S(f){return l(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(f){return f.replace(/([?*[\]])/g,"[$1]")}function D(f,E){f=I.$Mb(f,C=>C.toString());const w=[],P=E.getWorkspace();return f&&f.forEach(C=>{let V;if(E.getWorkbenchState()===2)V=(0,k.$6g)(P.folders[0].uri,C),V&&V!=="."&&(V="./"+V);else{const W=E.getWorkspaceFolder(C);if(W){const q=W.name;if(P.folders.filter(U=>U.name===q).length===1){const U=(0,k.$6g)(W.uri,C);U===""?V=`./${W.name}`:V=`./${W.name}/${U}`}else V=C.fsPath}}V&&w.push(d(V))}),w}}),define(Re[292],Ae([1,0,24,2,22,14,3,291,46,49,11]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Btb=u,e.$Ctb=s;const y=7e3;function u(o,r){const n=r.activationEvents;if(!n)return Promise.resolve(void 0);const t=[],c=[];for(const l of n)if(/^workspaceContains:/.test(l)){const S=l.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||o.forceUsingSearch?c.push(S):t.push(S)}if(t.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:h,resolve:i}=(0,N.$jh)(),b=l=>i({activationEvent:l}),a=Promise.all(t.map(l=>v(o,l,b))).then(()=>{}),$=m(o,r.identifier,c,b);return Promise.all([a,$]).then(()=>{i(void 0)}),h}async function v(o,r,n){for(const t of o.folders)if(await o.exists(I.$4g(T.URI.revive(t),r))){n(`workspaceContains:${r}`);return}}async function m(o,r,n,t){if(n.length===0)return Promise.resolve(void 0);const c=new R.$me,h=o.checkExists(o.folders,n,c.token),i=setTimeout(async()=>{c.cancel(),o.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},y);let b=!1;try{b=await h}catch(a){O.$4(a)||O.$1(a)}c.dispose(),clearTimeout(i),b&&t(`workspaceContains:${n.join(",")}`)}function s(o,r,n,t){const c=o.get(M.$pi),h=o.get(g.$5K),b=c.createInstance(p.$uM).file(r.map(a=>(0,k.$Li)(T.URI.revive(a))),{_reason:"checkExists",includePattern:n,exists:!0});return h.fileSearch(b,t).then(a=>!!a.limitHit,a=>O.$4(a)?!1:Promise.reject(a))}}),define(Re[39],Ae([1,0,164,19,89,24,11,6,52,2,13,4,38,226,82,37,25,108,14,20,23,207,7,102,3,27,85,16,71,86,51,88,5,292,81,209,12,79,65,21,80]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b,a,$,l,S,d,D,f,E,w,P,C,V,W,q,A,U,K){"use strict";var se;Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=e.$ilc=e.$hlc=e.$glc=e.$flc=void 0,e.$flc=(0,a.$qi)("IHostUtils");let ce=se=class extends p.$Uc{constructor(j,x,pe,Oe,ke,$e,fe,J,Y,he,le,Te,de){super(),this.Y=Te,this.Z=de,this.a=this.B(new w.$be),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=pe,this.f=fe,this.j=Oe,this.m=ke,this.s=$e,this.t=Y,this.u=he,this.w=le,this.y=this.g.getProxy(y.$QM.MainThreadWorkspace),this.z=this.g.getProxy(y.$QM.MainThreadTelemetry),this.C=this.g.getProxy(y.$QM.MainThreadExtensionService),this.D=new M.$ph,this.F=new M.$ph,this.G=new M.$ph,this.H=new M.$ph,this.I=new Fe(this.f.extensions.activationEvents),this.L=new r.$T$b(this.I,this.f.extensions.allExtensions);const Pe=new t.$Mm(this.f.extensions.myExtensions);this.J=new r.$T$b(this.I,ie(this.L,Pe)),U.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ue(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ue(this.J)}`)),this.M=new m.$1kc(this.g,this.s),this.N=new C.$$kc(this.g),this.O=J,this.h=j.createChild(new d.$oi([m.$2kc,this.M],[C.$_kc,this.N])),this.P=this.B(new v.$Zkc(this.J,this.L,{onExtensionActivationError:(Me,ze,z)=>{this.C.$onExtensionActivationError(Me,n.$3(ze),z)},actualActivateExtension:async(Me,ze)=>{if(r.$T$b.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,ze),new v.$Ykc;const z=this.J.getExtensionDescription(Me);return this.fb(z,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(j){n.$1(j)}}async $(){this.O.onWillDeactivateAll();let j=[];try{j=this.J.getAllExtensionDescriptions().map(ke=>ke.identifier).filter(ke=>this.isActivated(ke)).map(ke=>this.eb(ke))}catch{}await Promise.all(j)}terminate(j,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${j}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Oe=>{this.s.error(Oe)}),this.g.dispose();const pe=this.$();Promise.race([(0,M.$rh)(5e3),pe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(j){return this.G.isOpen()?this.P.isActivated(j):!1}async getExtension(j){const x=await this.C.$getExtension(j);return x&&{...x,identifier:new t.$Lm(x.identifier.value),extensionLocation:k.URI.revive(x.extensionLocation)}}ab(j,x){return this.P.activateByEvent(j,x)}bb(j,x){return this.P.activateById(j,x)}activateByIdWithErrors(j,x){return this.bb(j,x).then(()=>{const pe=this.P.getActivatedExtension(j);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(j=>this.J)}getExtensionExports(j){if(this.G.isOpen())return this.P.getActivatedExtension(j).exports;try{return this.P.getActivatedExtension(j).exports}catch{return null}}async cb(j){if(j.scheme===W.Schemas.file&&this.c.fsRealpath){const x=j.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const pe=await this.R.get(x);return k.URI.file(pe)}return j}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(j=>new Ce(j))),this.Q}async db(j){const x=g.$wi.forUris(pe=>O.$Ug.ignorePathCasing(pe));return await Promise.all(j.map(async pe=>{if(this.wb(pe)){const Oe=await this.cb(pe.extensionLocation);x.set(Oe,pe)}})),x}eb(j){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(j))return x;const pe=this.P.getActivatedExtension(j);if(!pe)return x;try{typeof pe.module.deactivate=="function"&&(x=Promise.resolve(pe.module.deactivate()).then(void 0,Oe=>(this.s.error(Oe),Promise.resolve(void 0))))}catch(Oe){this.s.error(`An error occurred when deactivating the extension '${j.value}':`),this.s.error(Oe)}try{(0,p.$Pc)(pe.subscriptions)}catch(Oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${j.value}':`),this.s.error(Oe)}return x}async fb(j,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(j.identifier):await this.C.$onWillActivateExtension(j.identifier),this.hb(j,x).then(pe=>{const Oe=pe.activationTimes;return this.C.$onDidActivateExtension(j.identifier,Oe.codeLoadingTime,Oe.activateCallTime,Oe.activateResolvedTime,x),this.gb(j,x,"success",Oe),pe},pe=>{throw this.gb(j,x,"failure"),pe})}gb(j,x,pe,Oe){const ke=Ie(j,x);this.z.$publicLog2("extensionActivationTimes",{...ke,...Oe||{},outcome:pe})}hb(j,x){const pe=Ie(j,x);this.z.$publicLog2("activatePlugin",pe);const Oe=this.wb(j);if(!Oe)return Promise.resolve(new v.$Xkc(v.$Ukc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${j.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const ke=new v.$Vkc(x.startup);return Promise.all([this.xb(j,(0,O.$4g)(j.extensionLocation,Oe),ke),this.ib(j)]).then($e=>(R.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),se.jb(this.s,j.identifier,$e[0],$e[1],ke))).then($e=>(R.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),$e))}ib(j){const x=this.Z.createLanguageModelAccessInformation(j),pe=new h.$4kc(j,this.M),Oe=new h.$3kc(j.identifier.value,!1,this.M),ke=new V.$alc(j,this.N),$e=j.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,fe=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([pe.whenReady,Oe.whenReady,this.O.whenReady]).then(()=>{const J=this;let Y,he;const le=(0,o.$xG)(j,"ipc")?this.f.messagePorts?.get(t.$Lm.toKey(j.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:Oe,secrets:ke,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(Te){return T.$kc(j.extensionLocation.fsPath,Te)},get storagePath(){return J.O.workspaceValue(j)?.fsPath},get globalStoragePath(){return J.O.globalValue(j).fsPath},get logPath(){return T.$kc(J.f.logsLocation.fsPath,j.identifier.value)},get logUri(){return k.URI.joinPath(J.f.logsLocation,j.identifier.value)},get storageUri(){return J.O.workspaceValue(j)},get globalStorageUri(){return J.O.globalValue(j)},get extensionMode(){return $e},get extension(){return Y===void 0&&(Y=new be(J,j.identifier,j,fe,!1)),Y},get extensionRuntime(){return(0,o.$yG)(j,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(j)},get messagePassingProtocol(){if(!he){if(!le)return;const Te=w.Event.buffer(w.Event.fromDOMEventEmitter(le,"message",de=>de.data));le.start(),he={onDidReceiveMessage:Te,postMessage:le.postMessage.bind(le)}}return he}})})}static jb(j,x,pe,Oe,ke){return pe=pe||{activate:void 0,deactivate:void 0},this.kb(j,x,pe,Oe,ke).then($e=>new v.$Wkc(!1,null,ke.build(),pe,$e,Oe.subscriptions))}static kb(j,x,pe,Oe,ke){if(typeof pe.activate=="function")try{ke.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${x.value}`);const $e=typeof global=="object"?global:self,fe=pe.activate.apply($e,[Oe]);return ke.activateCallStop(),ke.activateResolveStart(),Promise.resolve(fe).then(J=>(ke.activateResolveStop(),J))}catch($e){return Promise.reject($e)}else return Promise.resolve(pe)}lb(j,x){this.bb(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:x}).then(void 0,pe=>{this.s.error(pe)})}mb(j,x=0){const Oe=Date.now();(0,U.$B)(()=>{for(let ke=x;ke<j.length;ke+=1){const $e=j[ke];for(const fe of $e.activationEvents??[])if(fe==="onStartupFinished")if(Date.now()-Oe>50){this.mb(j,ke);break}else this.lb($e,fe)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(j=>{const x=j.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.J.getAllExtensionDescriptions();if(x)this.mb(pe);else for(const Oe of pe)if(Oe.activationEvents)for(const ke of Oe.activationEvents)ke==="onStartupFinished"&&this.lb(Oe,ke)})}ob(){const j=this.ab("*",!0).then(void 0,$e=>{this.s.error($e)});this.B(this.j.onDidChangeWorkspace($e=>this.pb($e.added)));const x=this.j.workspace?this.j.workspace.folders:[],pe=this.pb(x),Oe=this.rb(),ke=Promise.all([Oe,j,pe]).then(()=>{});return Promise.race([ke,(0,M.$rh)(1e4)]).then(()=>{this.nb()}),ke}pb(j){return j.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(j,x))).then(()=>{})}async qb(j,x){if(this.isActivated(x.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,Oe={logService:this.s,folders:j.map($e=>$e.uri),forceUsingSearch:pe||!this.c.fsExists,exists:$e=>this.c.fsExists($e.fsPath),checkExists:($e,fe,J)=>this.y.$checkExists($e,fe,J)},ke=await(0,P.$Btb)(Oe,x);if(ke)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:ke.activationEvent}).then(void 0,$e=>this.s.error($e))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(j){throw console.error(j),j}}async sb(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:x}=this.f.environment;if(!j||!x)throw new Error(I.localize(0,null));const pe=await this.xb(null,x,new v.$Vkc(!1));if(!pe||typeof pe.run!="function")throw new Error(I.localize(1,null,x.toString()));return new Promise((Oe,ke)=>{const $e=(Y,he)=>{Y?(U.$t&&this.s.error("Test runner called back with error",Y),ke(Y)):(U.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Oe(typeof he=="number"&&he>0?1:0))},fe=(0,O.$Rg)(x),J=pe.run(fe,$e);J&&J.then&&J.then(()=>{U.$t&&this.s.info("Test runner finished successfully."),Oe(0)}).catch(Y=>{U.$t&&this.s.error("Test runner finished with error",Y),ke(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$rh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,x){return this.S[j]=x,(0,p.$Sc)(()=>{delete this.S[j]})}async getRemoteExecServer(j){const{resolver:x}=await this.ub(j);return x?.resolveExecServer?.(j,{resolveAttempt:0})}async ub(j){const x=j.indexOf("+");if(x===-1)throw new i.$YM("Not an authority that can be resolved!",b.RemoteAuthorityResolverErrorCode.InvalidAuthority);const pe=j.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.S[pe]}}async $resolveAuthority(j,x){const pe=A.$0d.create(!1),Oe=()=>`[resolveAuthority(${(0,b.$Fl)(j)},${x})][${pe.elapsed()}ms] `,ke=L=>this.s.info(`${Oe()}${L}`),$e=L=>this.s.warn(`${Oe()}${L}`),fe=(L,G=void 0)=>this.s.error(`${Oe()}${L}`,G),J=L=>{if(L instanceof i.$YM)return{type:"error",error:{code:L._code,message:L._message,detail:L._detail}};throw L},Y=async L=>{ke(`activating resolver for ${L}...`);const{resolver:G,authorityPrefix:H}=await this.ub(L);if(!G)throw fe(`no resolver for ${H}`),new i.$YM(`No remote extension installed to resolve ${H}.`,b.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:L}},he=j.split(/@|%40/g).reverse();ke(`activating remote resolvers ${he.join(" -> ")}`);let le;try{le=await Promise.all(he.map(Y)).catch(async L=>{if(!(L instanceof i.$YM)||L._code!==b.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw L;return $e(`resolving nested authorities failed: ${L.message}`),[await Y(j)]})}catch(L){return J(L)}const Te=new M.$Bh;Te.cancelAndSet(()=>ke("waiting..."),1e3);let de,Pe;for(const[L,{authorityPrefix:G,resolver:H,remoteAuthority:ee}]of le.entries())try{if(L===le.length-1)ke("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${G}`),de=await H.resolve(ee,{resolveAttempt:x,execServer:Pe}),R.mark(`code/extHost/didResolveAuthorityOK/${G}`),ke("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,i.$XM.isManagedResolvedAuthority(de)?de:void 0));else{if(ke(`invoking resolveExecServer() for ${ee}`),R.mark(`code/extHost/willResolveExecServer/${G}`),Pe=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Pe}),!Pe)throw new i.$YM(`Exec server was not available for ${ee}`,b.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(re){return R.mark(`code/extHost/didResolveAuthorityError/${G}`),fe("returned an error",re),Te.dispose(),J(re)}Te.dispose();const Me={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};ke(`returned ${i.$XM.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let z;if(i.$XM.isManagedResolvedAuthority(de)){const L=x;this.Y.setFactory(L,de.makeConnection),z={authority:j,connectTo:new b.$Cl(L),connectionToken:de.connectionToken}}else z={authority:j,connectTo:new b.$Dl(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:z,options:ze,tunnelInformation:Me}}}async $getCanonicalURI(j,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,b.$Fl)(j)})`);const{resolver:pe}=await this.ub(j);if(!pe)return null;const Oe=k.URI.revive(x);if(typeof pe.getCanonicalURI>"u")return Oe;const ke=await(0,M.$ih)(()=>pe.getCanonicalURI(Oe));return ke||Oe}async $startExtensionHost(j){j.toAdd.forEach($e=>$e.extensionLocation=k.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:pe}=ve(this.I,this.L,this.J,j),Oe=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Oe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(pe),U.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ue(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ue(this.J)}`)),this.tb()}$activateByEvent(j,x){return x===1?this.D.wait().then(pe=>this.ab(j,!1)):this.G.wait().then(pe=>this.ab(j,!1))}async $activate(j,x){return await this.G.wait(),this.J.getExtensionDescription(j)?(await this.bb(j,x),!0):!1}async $deltaExtensions(j){j.toAdd.forEach($e=>$e.extensionLocation=k.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:pe}=ve(this.I,this.L,this.J,j),Oe=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Oe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(pe),U.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ue(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ue(this.J)}`)),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){const x=c.$Ce.alloc(j),pe=Math.random()%256;for(let Oe=0;Oe<j;Oe++)x.writeUInt8(pe,Oe);return x}async $updateRemoteConnectionData(j){this.X=j,this.a.fire()}};e.$glc=ce,e.$glc=ce=se=Je([Ve(0,a.$pi),Ve(1,e.$flc),Ve(2,S.$dP),Ve(3,s.$Dkc),Ve(4,u.$Gkc),Ve(5,N.$Wj),Ve(6,$.$tP),Ve(7,l.$Jkc),Ve(8,D.$DCb),Ve(9,f.$5kc),Ve(10,q.$clc),Ve(11,K.$dlc),Ve(12,E.$9kc)],ce);function ve(ne,j,x,pe){ne.addActivationEvents(pe.addActivationEvents);const Oe=new r.$T$b(ne,j.getAllExtensionDescriptions());Oe.deltaExtensions(pe.toAdd,pe.toRemove);const ke=new t.$Mm(x.getAllExtensionDescriptions().map(fe=>fe.identifier));for(const fe of pe.myToRemove)ke.delete(fe);for(const fe of pe.myToAdd)ke.add(fe);const $e=ie(Oe,ke);return{globalRegistry:Oe,myExtensions:$e}}function Ie(ne,j){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}function ue(ne){return ne.getAllExtensionDescriptions().map(j=>j.identifier.value).join(",")}e.$hlc=(0,a.$qi)("IExtHostExtensionService");class be{#e;#t;#i;constructor(j,x,pe,Oe,ke){this.#e=j,this.#t=x,this.#i=pe.identifier,this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=T.$ic((0,O.$Rg)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=Oe,this.isFromDifferentExtensionHost=ke}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$ilc=be;function ie(ne,j){return ne.getAllExtensionDescriptions().filter(x=>j.has(x.identifier))}class Ce{constructor(j){this.a=j}setSearchTree(j){this.a=j}findSubstr(j){return this.a.findSubstr(j)}forEach(j){return this.a.forEach(j)}}e.$jlc=Ce;class Fe{constructor(j){this.a=new t.$Nm,this.addActivationEvents(j)}readActivationEvents(j){return this.a.get(j.identifier)??[]}addActivationEvents(j){for(const x of Object.keys(j))this.a.set(x,j[x])}}}),define(Re[293],Ae([1,0,89,2,4,38,25,20,16,27,3,39,13,15]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=void 0;let s=class{constructor(c,h,i,b,a,$,l){this.c=c,this.d=h,this.e=i,this.f=b,this.g=a,this.h=$,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new r(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$smc=s,e.$smc=s=Je([Ve(2,N.$pi),Ve(3,O.$Gkc),Ve(4,y.$hlc),Ve(5,k.$tP),Ve(6,u.$Wj)],s);let o=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&m.a.size){const h=(0,v.$8e)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",b=`@${i}+\\/${i}+|${i}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${a}\\/)(${b})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,b,a]=h,$=m.a.get(b);if($!==void 0)return console.warn(`${b} as been renamed to ${$}, please update your imports`),i+$+a}c(c){return c.replace(/\\/g,"/")}};o=m=Je([Ve(0,k.$tP)],o);class r{constructor(c,h,i,b,a){this.c=c,this.d=h,this.e=i,this.f=b,this.g=a,this.nodeModuleName="vscode",this.a=new p.$Nm}load(c,h){const i=this.d.findSubstr(h);if(i){let b=this.a.get(i.identifier);return b||(b=this.c(i,this.e,this.f),this.a.set(i.identifier,b)),b}if(!this.b){let b="";this.d.forEach((a,$)=>b+=`	${$} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${b}`),this.b=this.c(M.$sG,this.e,this.f)}return this.b}}let n=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(R.$QM.MainThreadTelemetry);const b=i.getProxy(R.$QM.MainThreadWindow);this.c=(a,$)=>{const l=T.URI.parse(a);return $?this.g(a,$):l.scheme==="http"||l.scheme==="https"?b.$openUri(l,a,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?b.$openUri(l,a,{}):this.g(a,$)}}load(c,h,i){const b=this.e.findSubstr(h);return b&&(this.a=b.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([Ve(2,g.$dP)],n)}),define(Re[120],Ae([1,0,41,6,19,73,3,67,66,39,7,37,223,38]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=e.$klc=void 0,e.$klc=(0,M.$qi)("IExtHostVariableResolverProvider");class m extends u.$fQ{constructor(r,n,t,c,h,i,b){function a(){if(t){const $=t.activeEditor();if($)return $.document.uri;const l=c.tabGroups.all.find(S=>S.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof N.$DO||l.input instanceof N.$IO)return l.input.modified;if(l.input instanceof N.$CO||l.input instanceof N.$HO||l.input instanceof N.$FO)return l.input.uri}}}super({getFolderUri:$=>{const l=i.folders.filter(S=>S.name===$);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:($,l)=>h.getConfiguration(void 0,$).get(l),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=a();if($)return R.$ic($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const $=a();if($){const l=n.getWorkspaceFolder($);if(l)return R.$ic(l.uri.fsPath)}}},getSelectedText:()=>{if(t){const $=t.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(t){const $=t.activeEditor();if($)return String($.selection.end.line+1)}},getExtension:$=>r.getExtension($)},void 0,b?Promise.resolve(b):void 0,Promise.resolve(O.env))}}let s=class extends T.$Uc{constructor(r,n,t,c,h){super(),this.b=r,this.c=n,this.g=t,this.h=c,this.j=h,this.a=new I.$V(async()=>{const i=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async $=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,i,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$llc=s,e.$llc=s=Je([Ve(0,k.$hlc),Ve(1,y.$Dkc),Ve(2,p.$oP),Ve(3,v.$Gkc),Ve(4,g.$Skc)],s)}),define(Re[121],Ae([1,0,11,5,2,20,3,4,66,39,16,7,37,215,217,38,120,6,42,32,8]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=e.$plc=e.$olc=e.$nlc=e.$mlc=void 0,e.$mlc=(0,M.$qi)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(d,D,f,E,w,P,C){this.N=D,this.O=f,this.P=E,this.Q=w,this.R=P,this.S=C,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new T.$be,this.o=new T.$be,this.q=new T.$be,this.w=new T.$be,this.l=d.getProxy(p.$QM.MainThreadDebugService),this.A=new T.$be,this.C=new T.$be,this.y=new b(this.l),this.z=new Map,this.O.getExtensionRegistry().then(V=>{V.onDidChange(W=>{this.V(V)}),this.V(V)})}async $getVisualizerTreeItem(d,D){const f=this.W(D);if(!f)return;const E=await this.H.get(d)?.getTreeItem?.(f);return E?this.U(d,E):void 0}registerDebugVisualizationTree(d,D,f){const E=O.$Lm.toKey(d.identifier),w=this.jb(E,D);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(w,f),this.l.$registerDebugVisualizerTree(w,!!f.editItem),(0,r.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(w),this.H.delete(D)})}async $getVisualizerTreeItemChildren(d,D){const f=this.J.get(D)?.item;return f?(await this.H.get(d)?.getChildren?.(f))?.map(w=>this.U(d,w))||[]:[]}async $editVisualizerTreeItem(d,D){const f=this.J.get(d);if(!f)return;const E=await this.H.get(f.provider)?.editItem?.(f.item,D);return this.U(f.provider,E||f.item)}$disposeVisualizedTree(d){const D=this.J.get(d);if(!D)return;const f=[D.children];for(const E of f)if(E)for(const w of E)f.push(this.J.get(w)?.children),this.J.delete(w)}U(d,D){let f=this.I.get(D);return f||(f=this.F++,this.I.set(D,f),this.J.set(f,{provider:d,item:D})),c.DebugTreeItem.from(D,f)}asDebugSourceUri(d,D){const f=d;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let E=`debug:${encodeURIComponent(f.path||"")}`,w="?";return D&&(E+=`${w}session=${encodeURIComponent(D.id)}`,w="&"),E+=`${w}ref=${f.sourceReference}`,R.URI.parse(E)}else{if(f.path)return R.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(d){const D=[];for(const f of d.getAllExtensionDescriptions())if(f.contributes){const E=f.contributes.debuggers;if(E&&E.length>0)for(const w of E)(0,m.$aH)(w)&&D.push(w.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const d=[];return this.z.forEach(D=>d.push(D)),d}async $resolveDebugVisualizer(d,D){const f=this.L.get(d);if(!f)throw new Error(`No debug visualizer found with id '${d}'`);let{v:E,provider:w,extensionId:P}=f;if(E.visualization||(E=await w.resolveDebugVisualization?.(E,D)||E,f.v=E),!E.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${w}'`);return this.kb(P,E.visualization)}async $executeDebugVisualizerCommand(d){const D=this.L.get(d);if(!D)throw new Error(`No debug visualizer found with id '${d}'`);const f=D.v.visualization;f&&"command"in f&&this.S.executeCommand(f.command,...f.arguments||[])}W(d){const D=this.m.get(d.sessionId);return D&&{session:D.api,variable:d.variable,containerId:d.containerId,frameId:d.frameId,threadId:d.threadId}}async $provideDebugVisualizers(d,D,f,E){const w=this.W(f),P=this.jb(d,D),C=this.G.get(P);if(!w||!C)return[];const V=await C.provideDebugVisualization(w,E);return V?V.map(W=>{const q=++this.M;this.L.set(q,{v:W,provider:C,extensionId:d});const A=W.iconPath?this.lb(W.iconPath):void 0;return{id:q,name:W.name,iconClass:A?.iconClass,iconPath:A?.iconPath,visualization:this.kb(d,W.visualization)}}):[]}$disposeDebugVisualizers(d){for(const D of d)this.L.delete(D)}registerDebugVisualizationProvider(d,D,f){if(!d.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const E=O.$Lm.toKey(d.identifier),w=this.jb(E,D);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(w,f),this.l.$registerDebugVisualizer(E,D),(0,r.$Sc)(()=>{this.l.$unregisterDebugVisualizer(E,D),this.G.delete(D)})}addBreakpoints(d){const D=d.filter(w=>{const P=w.id;return this.z.has(P)?!1:(this.z.set(P,w),!0)});this.gb(D,[],[]);const f=[],E=new Map;for(const w of D)if(w instanceof y.$TN){let P=E.get(w.location.uri.toString());P||(P={type:"sourceMulti",uri:w.location.uri,lines:[]},E.set(w.location.uri.toString(),P),f.push(P)),P.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character,mode:w.mode})}else w instanceof y.$UN&&f.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName,mode:w.mode});return this.l.$registerBreakpoints(f)}removeBreakpoints(d){const D=d.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const f=D.filter(P=>P instanceof y.$TN).map(P=>P.id),E=D.filter(P=>P instanceof y.$UN).map(P=>P.id),w=D.filter(P=>P instanceof y.$VN).map(P=>P.id);return this.l.$unregisterBreakpoints(f,E,w)}startDebugging(d,D,f){return this.l.$startDebugging(d?d.uri:void 0,D,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(d){return this.l.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,D,f){if(!D)return new y.$SM(()=>{});const E=this.d++;return this.f.push({type:d,handle:E,provider:D}),this.l.$registerDebugConfigurationProvider(d,f,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,E),new y.$SM(()=>{this.f=this.f.filter(w=>w.provider!==D),this.l.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(d,D,f){if(!f)return new y.$SM(()=>{});if(!this.cb(d,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this.g++;return this.h.push({type:D,handle:E,factory:f}),this.l.$registerDebugAdapterDescriptorFactory(D,E),new y.$SM(()=>{this.h=this.h.filter(w=>w.factory!==f),this.l.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(d,D){if(!D)return new y.$SM(()=>{});const f=this.j++;return this.k.push({type:d,handle:f,factory:D}),new y.$SM(()=>{this.k=this.k.filter(E=>E.factory!==D)})}async $runInTerminal(d,D){return Promise.resolve(void 0)}async $substituteVariables(d,D){let f;const E=await this.ib(d);return E&&(f={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(f,D)}X(d,D){if(d.type==="implementation")return new $(d.implementation)}Y(){}async $startDASession(d,D){const f=this,E=await this.hb(D);return this.eb(this.$(E.type),E).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const P=this.Z(w),C=this.X(P,E);if(!C)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const V=C;return this.D.set(d,V),this.db(E).then(W=>(W&&this.E.set(d,W),V.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const A=q,U={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(A.arguments.value);U.body={signature:K},V.sendResponse(U)}else throw new Error("no signer")}catch(K){U.success=!1,U.message=K.message,V.sendResponse(U)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(q),q=(0,m.$fH)(q,!0),f.l.$acceptDAMessage(d,q)}),V.onError(q=>{W&&W.onError&&W.onError(q),this.l.$acceptDAError(d,q.name,q.message,q.stack)}),V.onExit(q=>{W&&W.onExit&&W.onExit(q??void 0,void 0),this.l.$acceptDAExit(d,q??void 0,void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),V.startSession()))})}$sendDAMessage(d,D){D=(0,m.$eH)(D,!1);const f=this.E.get(d);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(D),this.D.get(d)?.sendMessage(D)}$stopDASession(d){const D=this.E.get(d);this.E.delete(d),D&&D.onWillStopSession&&D.onWillStopSession();const f=this.D.get(d);return this.D.delete(d),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const D=[],f=[],E=[];if(d.added)for(const w of d.added){const P=w.id;if(P&&!this.z.has(P)){let C;if(w.type==="function")C=new y.$UN(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode);else if(w.type==="data")C=new y.$VN(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage,w.mode);else{const V=R.URI.revive(w.uri);C=new y.$TN(new y.$5M(V,new y.$TM(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode)}(0,y.$RN)(C,P),this.z.set(P,C),D.push(C)}}if(d.removed)for(const w of d.removed){const P=this.z.get(w);P&&(this.z.delete(w),f.push(P))}if(d.changed){for(const w of d.changed)if(w.id){const P=this.z.get(w.id);if(P){if(P instanceof y.$UN&&w.type==="function"){const C=P;C.enabled=w.enabled,C.condition=w.condition,C.hitCondition=w.hitCondition,C.logMessage=w.logMessage,C.functionName=w.functionName}else if(P instanceof y.$TN&&w.type==="source"){const C=P;C.enabled=w.enabled,C.condition=w.condition,C.hitCondition=w.hitCondition,C.logMessage=w.logMessage,C.location=new y.$5M(R.URI.revive(w.uri),new y.$TM(w.line,w.character))}E.push(P)}}}this.gb(D,f,E)}async $acceptStackFrameFocus(d){let D;if(d){const f=await this.hb(d.sessionId);d.kind==="thread"?D=new y.$2N(f.api,d.threadId):D=new y.$1N(f.api,d.threadId,d.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(d,D,f){return(0,I.$ih)(async()=>{const E=this.bb(d);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.ib(D);return E.provideDebugConfigurations(w,f)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(d,D,f,E){return(0,I.$ih)(async()=>{const w=this.bb(d);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return w.resolveDebugConfiguration(P,f,E)})}$resolveDebugConfigurationWithSubstitutedVariables(d,D,f,E){return(0,I.$ih)(async()=>{const w=this.bb(d);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return w.resolveDebugConfigurationWithSubstitutedVariables(P,f,E)})}async $provideDebugAdapter(d,D){const f=this.ab(d);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.hb(D);return this.eb(f,E).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.Z(w)})}async $acceptDebugSessionStarted(d){const D=await this.hb(d);this.n.fire(D.api)}async $acceptDebugSessionTerminated(d){const D=await this.hb(d);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(d){this.u=d?await this.hb(d):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(d,D){(await this.hb(d))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(d,D){const E={session:(await this.hb(d)).api,event:D.event,body:D.body};this.w.fire(E)}Z(d){if(d instanceof y.$WN)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof y.$XN)return{type:"server",port:d.port,host:d.host};if(d instanceof y.$YN)return{type:"pipeServer",path:d.path};if(d instanceof y.$ZN)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}$(d){const D=this.h.filter(f=>f.type===d);if(D.length>0)return D[0].factory}ab(d){const D=this.h.filter(f=>f.handle===d);if(D.length>0)return D[0].factory}bb(d){const D=this.f.filter(f=>f.handle===d);if(D.length>0)return D[0].provider}cb(d,D){if(d.contributes){const f=d.contributes.debuggers;if(f&&f.length>0){for(const E of f)if(E.label&&E.type&&E.type===D)return!0}}return!1}db(d){const f=d.configuration.type,E=this.k.filter(w=>w.type===f||w.type==="*").map(w=>(0,I.$ih)(()=>w.factory.createDebugAdapterTracker(d.api)).then(P=>P,P=>null));return Promise.race([Promise.all(E).then(w=>{const P=w.filter(C=>!!C);if(P.length>0)return new a(P)}),new Promise(w=>setTimeout(()=>w(void 0),1e3))]).catch(w=>{})}async eb(d,D){const f=D.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new y.$XN(f));if(d){const w=await this.O.getExtensionRegistry();return(0,I.$ih)(()=>d.createDebugAdapterDescriptor(D.api,this.fb(D,w))).then(P=>{if(P)return P})}const E=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,E))}fb(d,D){}gb(d,D,f){(d.length>0||D.length>0||f.length>0)&&this.A.fire(Object.freeze({added:d,removed:D,changed:f}))}async hb(d){if(d)if(typeof d=="string"){const D=this.m.get(d);if(D)return D}else{let D=this.m.get(d.id);if(!D){const f=await this.ib(d.folderUri),E=d.parent?this.m.get(d.parent):void 0;D=new i(this.l,d.id,d.type,d.name,f,d.configuration,E?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(d){if(d){const D=R.URI.revive(d);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(d,D){return`${d}\0${D}`}kb(d,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${d}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(d){const D=this.mb(d);let f,E;return"id"in D?E=n.ThemeIcon.asClassName(D):f=D,{iconPath:f,iconClass:E}}mb(d){if(d instanceof y.$ON)return{id:d.id};const D=typeof d=="object"&&"dark"in d?d.dark:d,f=typeof d=="object"&&"light"in d?d.light:d;return{dark:typeof D=="string"?R.URI.file(D):D,light:typeof f=="string"?R.URI.file(f):f}}};e.$nlc=h,e.$nlc=h=Je([Ve(0,N.$dP),Ve(1,u.$Dkc),Ve(2,k.$hlc),Ve(3,s.$Gkc),Ve(4,g.$Skc),Ve(5,o.$klc),Ve(6,t.$zP)],h);class i{constructor(d,D,f,E,w,P,C){this.f=d,this.g=D,this.h=f,this.j=E,this.k=w,this.l=P,this.m=C}get api(){const d=this;return this.d??=Object.freeze({id:d.g,type:d.h,get name(){return d.j},set name(D){d.j=D,d.f.$setDebugSessionName(d.g,D)},parentSession:d.m,workspaceFolder:d.k,configuration:d.l,customRequest(D,f){return d.f.$customDebugAdapterRequest(d.g,D,f)},getDebugProtocolBreakpoint(D){return d.f.$getDebugProtocolBreakpoint(d.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(d){this.j=d}get configuration(){return this.l}}e.$olc=i;class b{constructor(d){this.value=Object.freeze({append(D){d.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$plc=b;class a{constructor(d){this.d=d}onWillStartSession(){this.d.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(d):void 0)}onWillStopSession(){this.d.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.d.forEach(D=>D.onError?D.onError(d):void 0)}onExit(d,D){this.d.forEach(f=>f.onExit?f.onExit(d,D):void 0)}}class $ extends v.$Hob{constructor(d){super(),this.h=d,d.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.h.handleMessage(d)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends h{constructor(d,D,f,E,w,P,C){super(d,D,f,E,w,P,C)}};e.$qlc=l,e.$qlc=l=Je([Ve(0,N.$dP),Ve(1,u.$Dkc),Ve(2,k.$hlc),Ve(3,s.$Gkc),Ve(4,g.$Skc),Ve(5,o.$klc),Ve(6,t.$zP)],l)}),define(Re[294],Ae([1,0,14,89,2,4,243,13,55,71,27,191,16,60,39,62]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=void 0;class o{static async installEarlyHandler(t){Error.stackTraceLimit=100;const c=t.get(p.$Wj),i=t.get(u.$dP).getProxy(O.$QM.MainThreadErrors);I.setUnexpectedErrorHandler(b=>{c.error(b);const a=I.$3(b);i.$onUnexpectedError(a)})}static async installFullHandler(t){const c=t.get(p.$Wj),h=t.get(u.$dP),i=t.get(m.$hlc),b=t.get(s.$xP),a=h.getProxy(O.$QM.MainThreadExtensionService),$=h.getProxy(O.$QM.MainThreadErrors),l=await i.getExtensionPathIndex(),S=new WeakMap;function d(E,w){if(S.has(E))return S.get(E).stack;let P="",C,V;for(const q of w)P+=`
	at ${q.toString()}`,V=q.getFileName(),!C&&V&&(C=l.findSubstr(R.URI.file(V)));const W=`${E.name||"Error"}: ${E.message||""}${P}`;return S.set(E,{extensionIdentifier:C?.identifier,stack:W}),W}const D=Symbol("prepareStackTrace wrapped");let f=d;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return f},set(E){if(E===d||!E||E[D]){f=E||d;return}f=function(w,P){return d(w,P),E.call(Error,w,P)},Object.assign(f,{[D]:!0})}}),I.setUnexpectedErrorHandler(E=>{c.error(E);const w=I.$3(E),P=S.get(E);if(!P?.extensionIdentifier){$.$onUnexpectedError(w);return}a.$onExtensionRuntimeError(P.extensionIdentifier,w);const C=b.onExtensionError(P.extensionIdentifier,E);c.trace("forwarded error to extension?",C,P)})}}e.$tmc=o;class r{constructor(t,c,h,i,b){this.a=h,this.b=new M.$2$b(t,null,i),c=r.e(c,this.b);const a=new k.$oi(...(0,g.$ps)());a.set(N.$tP,{_serviceBrand:void 0,...c,messagePorts:b}),a.set(u.$dP,new u.$eP(this.b)),a.set(v.$Akc,new v.$Bkc(i)),a.set(m.$flc,h);const $=new y.$7q(a,!0);$.invokeFunction(o.installEarlyHandler),this.d=$.invokeFunction(l=>l.get(p.$Wj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=$.invokeFunction(l=>l.get(m.$hlc)),this.c.initialize(),$.invokeFunction(o.installFullHandler)}async asBrowserUri(t){const c=this.b.getProxy(O.$QM.MainThreadExtensionService);return R.URI.revive(await c.$asBrowserUri(t))}terminate(t){this.c.terminate(t)}static e(t,c){t.extensions.allExtensions.forEach(i=>{i.extensionLocation=R.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),t.environment.appRoot=R.URI.revive(c.transformIncomingURIs(t.environment.appRoot));const h=t.environment.extensionDevelopmentLocationURI;return h&&(t.environment.extensionDevelopmentLocationURI=h.map(i=>R.URI.revive(c.transformIncomingURIs(i)))),t.environment.extensionTestsLocationURI=R.URI.revive(c.transformIncomingURIs(t.environment.extensionTestsLocationURI)),t.environment.globalStorageHome=R.URI.revive(c.transformIncomingURIs(t.environment.globalStorageHome)),t.environment.workspaceStorageHome=R.URI.revive(c.transformIncomingURIs(t.environment.workspaceStorageHome)),t.environment.extensionTelemetryLogResource=R.URI.revive(c.transformIncomingURIs(t.environment.extensionTelemetryLogResource)),t.nlsBaseUrl=R.URI.revive(c.transformIncomingURIs(t.nlsBaseUrl)),t.logsLocation=R.URI.revive(c.transformIncomingURIs(t.logsLocation)),t.workspace=c.transformIncomingURIs(t.workspace),t}}e.$umc=r}),define(Re[295],Ae([1,0,18,11,22,43,12,19,24,2,46]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=e.$Flc=e.$Elc=void 0,e.$Glc=s;class y{constructor(n,t,c){this.d=n,this.e=t,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,t){const c=this.g.folderQueries||[],h=new R.$me(t);return new Promise((i,b)=>{this.a=new v(n);let a=!1;const $=(l,S)=>{if(!a&&!this.b){const d=this.h(l);s(l)&&typeof this.g.maxResults=="number"&&this.c+d>this.g.maxResults&&(this.b=!0,a=!0,h.cancel(),l=this.j(l,this.g.maxResults-this.c));const D=this.h(l);this.c+=D,(D>0||!s(l))&&this.a.add(l,S)}};Promise.all(c.map((l,S)=>this.k(l,d=>$(d,S),h.token))).then(l=>{h.dispose(),this.a.flush();const S=l.some(d=>!!d&&!!d.limitHit);i({limitHit:this.b||S,messages:(0,I.$Rb)(l.map(d=>d?.message?Array.isArray(d.message)?d.message:[d.message]:[])),stats:{type:this.f}})},l=>{h.dispose();const S=(0,O.$bj)(l);b(new Error(S))})})}h(n){return s(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,t){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,t),preview:{matches:h.slice(0,t),text:n.preview.text},uri:n.uri}}async k(n,t,c){const h=new N.$lL(this.g,n),i=[],b={report:l=>{if(!this.l(l))return;const S=n.folder.scheme===M.Schemas.file?(0,N.$mL)(()=>this.e.readdir(g.$3g(l.uri))):void 0,d=g.$6g(n.folder,l.uri);if(d){const D=h.includedInQuery(d,p.$oc(d),S);(0,T.$ch)(D)?i.push(D.then(f=>{f&&t(l)})):D&&t(l)}}},a=this.n(n);let $;return this.d.query.type===3?$=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,b,c):$=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),a,b,c),i.length&&await Promise.all(i),$}l(n){if(s(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const t=(0,N.$kL)(this.g.includePattern,n.includePattern),c=(0,N.$kL)(this.g.excludePattern,n.excludePattern),h={folder:k.URI.from(n.folder),excludes:c,includes:t,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$Elc=y;function u(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class v{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,t=>this.g(t))}add(n,t){this.d&&(this.b!==t||!g.$Wg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=t,this.d={resource:n.uri,results:[]}),this.d.results.push(m(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Flc=v;function m(r){return s(r)?{preview:{matches:(0,I.$2b)(r.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:r.preview.text},ranges:(0,I.$2b)(r.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function s(r){return!!r.preview}class o{static{this.a=4e3}static{this.b=50}constructor(n,t){this.g=n,this.h=t,this.c=0,this.d=[],this.e=0}addItem(n,t){n&&this.j(n,t)}addItems(n,t){n&&this.k(n,t)}j(n,t){this.d.push(n),this.e+=t,this.l()}k(n,t){this.d=this.d.concat(n),this.e+=t,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Hlc=o}),define(Re[122],Ae([1,0,6,4,3,290,16,60,13,2,295]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=e.$Ilc=void 0,e.$Klc=u,e.$Ilc=(0,R.$qi)("IExtHostSearch");let y=class{constructor(s,o,r){this.n=s,this.o=o,this.q=r,this.c=this.n.getProxy(T.$QM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Dlc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,o){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const r=this.d++;return this.e.set(r,o),this.c.$registerTextSearchProvider(r,this.s(s)),(0,I.$Sc)(()=>{this.g.delete(s),this.e.delete(r),this.c.$unregisterProvider(r)})}registerAITextSearchProvider(s,o){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const r=this.d++;return this.h.set(r,o),this.c.$registerAITextSearchProvider(r,this.s(s)),(0,I.$Sc)(()=>{this.i.delete(s),this.h.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(s,o){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const r=this.d++;return this.j.set(r,o),this.c.$registerFileSearchProvider(r,this.s(s)),(0,I.$Sc)(()=>{this.k.delete(s),this.j.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(s,o,r,n){const t=u(r),c=this.j.get(s);if(c)return this.l.fileSearch(t,c,h=>{this.c.$handleFileMatch(s,o,h.map(i=>i.resource))},n);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,o,r){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,o,r,n){const t=this.e.get(s);if(!t||!t.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const c=u(r);return this.t(c,t).search(i=>this.c.$handleTextMatch(s,o,i),n)}$provideAITextSearchResults(s,o,r,n){const t=this.h.get(s);if(!t||!t.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const c=u(r);return this.v(c,t).search(i=>this.c.$handleTextMatch(s,o,i),n)}$enableExtensionHostSearch(){}t(s,o){return new N.$Elc({query:s,provider:o},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}v(s,o){return new N.$Elc({query:s,provider:o},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"aiTextSearchProvider")}};e.$Jlc=y,e.$Jlc=y=Je([Ve(0,M.$dP),Ve(1,p.$Akc),Ve(2,g.$Wj)],y);function u(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(v),extraFileResources:m.extraFileResources&&m.extraFileResources.map(s=>k.URI.revive(s))}}function v(m){return{...m,folder:k.URI.revive(m.folder)}}}),define(Re[296],Ae([1,0,22,14,5,6,12,33,2,151,147,135,94,20,44,13,58,59,204,4,246,274,78,84,251,252,253,232,221,32,254,38,255,121,110,256,234,247,257,258,67,66,248,39,260,64,261,45,27,275,276,235,262,88,263,79,80,237,289,265,208,266,277,267,116,238,268,269,270,16,271,122,81,272,239,273,82,85,119,62,51,114,278,279,249,280,281,86,8,7,240,60,241,63,282,283,109,37,216,77,25,118]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b,a,$,l,S,d,D,f,E,w,P,C,V,W,q,A,U,K,se,ce,ve,Ie,ue,be,ie,Ce,Fe,ne,j,x,pe,Oe,ke,$e,fe,J,Y,he,le,Te,de,Pe,Me,ze,z,L,G,H,ee,re,Ne,Be,Qe,_e,et,tt,it,nt,at,mt,je,st,X,Z,me,He,ye,ot,dt,It,Qt,Ut,xt,_t,Ct,Vt,Zt,Xe,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=Xt;function Xt(lt){const vt=lt.get(Ce.$tP),ti=lt.get(ie.$lkc),Yt=lt.get(ue.$Ikc),Lt=lt.get(ve.$hlc),ft=lt.get(Ct.$Dkc),jt=lt.get(it.$xP),Bt=lt.get(E.$Gkc),qt=lt.get(dt.$Akc),Ge=lt.get(G.$dP),ui=lt.get(_e.$2kc),Ht=lt.get(et.$Jkc),zt=lt.get(s.$Xj),gt=lt.get(s.$Wj),Nt=lt.get(me.$DCb),Rt=lt.get(i.$hkc),Ot=lt.get(_t.$nmc),ii=lt.get(re.$_kc),Gt=lt.get(se.$Skc),ni=lt.get($e.$dlc),Mt=lt.get(b.$rkc),Tt=lt.get(pe.$9kc);Ge.set(t.$RM.ExtHostFileSystemInfo,ti),Ge.set(t.$RM.ExtHostLogLevelServiceShape,zt),Ge.set(t.$RM.ExtHostWorkspace,ft),Ge.set(t.$RM.ExtHostConfiguration,Bt),Ge.set(t.$RM.ExtHostExtensionService,Lt),Ge.set(t.$RM.ExtHostStorage,ui),Ge.set(t.$RM.ExtHostTunnelService,Nt),Ge.set(t.$RM.ExtHostWindow,Ot),Ge.set(t.$RM.ExtHostSecretState,ii),Ge.set(t.$RM.ExtHostTelemetry,jt),Ge.set(t.$RM.ExtHostEditorTabs,Gt),Ge.set(t.$RM.ExtHostManagedSockets,ni),Ge.set(t.$RM.ExtHostAuthentication,Mt),Ge.set(t.$RM.ExtHostChatProvider,Tt);const Pt=Ge.set(t.$RM.ExtHostDecorations,lt.get(C.$slc)),Dt=Ge.set(t.$RM.ExtHostDocumentsAndEditors,lt.get(K.$oP)),pt=Ge.set(t.$RM.ExtHostCommands,lt.get(D.$zP)),St=Ge.set(t.$RM.ExtHostTerminalService,lt.get(nt.$5kc)),li=Ge.set(t.$RM.ExtHostTerminalShellIntegration,lt.get(at.$_lc)),Et=Ge.set(t.$RM.ExtHostDebugService,lt.get(P.$mlc)),hi=Ge.set(t.$RM.ExtHostSearch,lt.get(ee.$Ilc)),Kt=Ge.set(t.$RM.ExtHostTask,lt.get(tt.$$lc)),vi=Ge.set(t.$RM.ExtHostOutputService,lt.get(Pe.$Xlc)),ei=Ge.set(t.$RM.ExtHostLocalization,lt.get(ke.$clc)),wi=Ge.set(t.$RM.ExtHostUrls,new It.$kmc(Ge)),yt=Ge.set(t.$RM.ExtHostDocuments,new U.$okc(Ge,Dt)),$i=Ge.set(t.$RM.ExtHostDocumentContentProviders,new q.$ulc(Ge,Dt,gt)),we=Ge.set(t.$RM.ExtHostDocumentSaveParticipant,new A.$vlc(gt,yt,Ge.getProxy(t.$QM.MainThreadBulkEdits))),Se=Ge.set(t.$RM.ExtHostNotebook,new J.$Llc(Ge,pt,Dt,yt,Yt,hi)),ae=Ge.set(t.$RM.ExtHostNotebookDocuments,new he.$Rlc(Se)),Q=Ge.set(t.$RM.ExtHostNotebookEditors,new le.$Slc(gt,Se)),Ee=Ge.set(t.$RM.ExtHostNotebookKernels,new Te.$Tlc(Ge,vt,Se,pt,gt)),We=Ge.set(t.$RM.ExtHostNotebookRenderers,new de.$Vlc(Ge,Se)),Ze=Ge.set(t.$RM.ExtHostNotebookDocumentSaveParticipant,new Y.$Qlc(gt,Se,Ge.getProxy(t.$QM.MainThreadBulkEdits))),qe=Ge.set(t.$RM.ExtHostEditors,new je.$xkc(Ge,Dt)),ut=Ge.set(t.$RM.ExtHostTreeViews,new Z.$imc(Ge.getProxy(t.$QM.MainThreadTreeViews),pt,gt)),kt=Ge.set(t.$RM.ExtHostEditorInsets,new d.$ykc(Ge.getProxy(t.$QM.MainThreadEditorInsets),qe,vt.remote)),Ft=Ge.set(t.$RM.ExtHostDiagnostics,new V.$nkc(Ge,gt,ti,Dt)),Wt=Ge.set(t.$RM.ExtHostLanguages,new Oe.$Olc(Ge,yt,pt.converter,qt)),ct=Ge.set(t.$RM.ExtHostLanguageFeatures,new x.$pkc(Ge,qt,yt,pt,Ft,gt,Rt,jt)),ri=Ge.set(t.$RM.ExtHostFileSystem,new Ie.$xlc(Ge,ct)),di=Ge.set(t.$RM.ExtHostFileSystemEventService,new be.$ylc(Ge,gt,Dt)),pi=Ge.set(t.$RM.ExtHostQuickOpen,(0,L.$2lc)(Ge,ft,pt)),Si=Ge.set(t.$RM.ExtHostSCM,new H.$4lc(Ge,pt,yt,gt)),Ai=Ge.set(t.$RM.ExtHostQuickDiff,new z.$1lc(Ge,qt)),Mi=Ge.set(t.$RM.ExtHostShare,new Ne.$5lc(Ge,qt)),Ti=Ge.set(t.$RM.ExtHostComments,(0,f.$zkc)(Ge,pt,yt)),Ni=Ge.set(t.$RM.ExtHostProgress,new ze.$Zlc(Ge.getProxy(t.$QM.MainThreadProgress))),cn=Ge.set(t.$RM.ExtHostLabelService,new j.$Nlc(Ge)),Oi=Ge.set(t.$RM.ExtHostTheming,new st.$fmc(Ge)),Fi=Ge.set(t.$RM.ExtHostTimeline,new X.$hmc(Ge,pt)),yi=Ge.set(t.$RM.ExtHostWebviews,new Qt.$Nkc(Ge,vt.remote,ft,gt,Rt)),Ii=Ge.set(t.$RM.ExtHostWebviewPanels,new Ut.$Qkc(Ge,yi,ft)),Gi=Ge.set(t.$RM.ExtHostCustomEditors,new w.$Rkc(Ge,yt,Ht,yi,Ii)),Ki=Ge.set(t.$RM.ExtHostWebviewViews,new xt.$lmc(Ge,yi)),bi=Ge.set(t.$RM.ExtHostTesting,new mt.$bmc(Ge,gt,pt,Dt)),Ji=Ge.set(t.$RM.ExtHostUriOpeners,new ot.$jmc(Ge)),Qi=Ge.set(t.$RM.ExtHostProfileContentHandlers,new Me.$Ylc(Ge));Ge.set(t.$RM.ExtHostInteractive,new ne.$Mlc(Ge,Se,Dt,pt,gt));const un=Ge.set(t.$RM.ExtHostInlineChat,new Fe.$zlc(Ge,pt,yt,gt)),Li=Ge.set(t.$RM.ExtHostChatAgents2,new $.$ukc(Ge,gt,pt)),zi=Ge.set(t.$RM.ExtHostChatVariables,new l.$vkc(Ge)),Ci=Ge.set(t.$RM.ExtHostAiRelatedInformation,new c.$gkc(Ge)),ln=Ge.set(t.$RM.ExtHostAiEmbeddingVector,new ce.$wlc(Ge)),Zi=Ge.set(t.$RM.ExtHostStatusBar,new Qe.$8lc(Ge,pt.converter)),Xi=Ge.set(t.$RM.ExtHostSpeech,new Be.$6lc(Ge)),hn=Object.values(t.$RM);Ge.assertRegistered(hn);const Ui=new a.$tkc(Ge,Dt),Yi=new S.$wkc(Ge),Pi=new fe.$Plc(Ge,gt),ji=new W.$tlc(Ge);return h.$qkc.register(pt),function(Ue,oi,Bi){function xe(_){return(oe,Le,rt)=>{const wt=_(At=>{try{oe.call(Le,At)}catch(Ei){T.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Ei.toString()}`,{cause:Ei})),jt.onExtensionError(Ue.identifier,Ei)}});return rt?.push(wt),wt}}const bt=function(){let _=!Ue.isUnderDevelopment;function oe(){_||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")oe();else{const wt=rt;typeof wt.scheme>"u"&&oe(),typeof wt.exclusive=="boolean"&&(0,Xe.$yG)(Ue,"documentFiltersExclusive")}return rt}}(),dn={getSession(_,oe,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Xe.$yG)(Ue,"authLearnMore"),Mt.getSession(Ue,_,oe,Le)},getSessions(_,oe){return(0,Xe.$yG)(Ue,"authGetSessions"),Mt.getSessions(Ue,_,oe)},async hasSession(_,oe){return(0,Xe.$yG)(Ue,"authSession"),!!await Mt.getSession(Ue,_,oe,{silent:!0})},get onDidChangeSessions(){return xe(Mt.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Le,rt){return Mt.registerAuthenticationProvider(_,oe,Le,rt)}},ai={registerCommand(_,oe,Le){return pt.registerCommand(!0,_,oe,Le,void 0,Ue)},registerTextEditorCommand(_,oe,Le){return pt.registerCommand(!0,_,(...rt)=>{const wt=qe.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}return wt.edit(At=>{oe.apply(Le,[wt,At,...rt])}).then(At=>{At||gt.warn("Edits from command "+_+" were not applied.")},At=>{gt.warn("An error occurred while running command "+_,At)})},void 0,void 0,Ue)},registerDiffInformationCommand:(_,oe,Le)=>((0,Xe.$yG)(Ue,"diffCommand"),pt.registerCommand(!0,_,async(...rt)=>{const wt=Dt.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}const At=await qe.getDiffInformation(wt.id);oe.apply(Le,[At,...rt])},void 0,void 0,Ue)),executeCommand(_,...oe){return pt.executeCommand(_,...oe)},getCommands(_=!1){return pt.getCommands(_)}},ki={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Yi.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return xe(St.onDidChangeShell)},get isTelemetryEnabled(){return jt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return xe(jt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$yG)(Ue,"telemetry"),jt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$yG)(Ue,"telemetry"),xe(jt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$wP)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return it.$vP.validateSender(_),jt.instantiateLogger(Ue,_,oe)},openExternal(_,oe){return Ot.openUri(_,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===vt.environment.appUriScheme)return wi.createAppUri(_);try{return await Ot.asExternalUri(_,{allowTunneling:!!vt.remote.authority})}catch(oe){if((0,M.$zg)(_,M.Schemas.http)||(0,M.$zg)(_,M.Schemas.https))return _;throw oe}},get remoteName(){return(0,o.$Cm)(vt.remote.authority)},get remoteAuthority(){return(0,Xe.$yG)(Ue,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return xe(gt.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$yG)(Ue,"resolvers"),vt.quality},get appCommit(){return(0,Xe.$yG)(Ue,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(ki);const xi={createTestController(_,oe,Le){return bi.createTestController(Ue,_,oe,Le)},createTestObserver(){return(0,Xe.$yG)(Ue,"testObserver"),bi.createTestObserver()},runTests(_){return(0,Xe.$yG)(Ue,"testObserver"),bi.runTests(_)},get onDidChangeTestResults(){return(0,Xe.$yG)(Ue,"testObserver"),xe(bi.onResultsChanged)},get testResults(){return(0,Xe.$yG)(Ue,"testObserver"),bi.results}},Di=vt.remote.isRemote?ye.ExtensionKind.Workspace:ye.ExtensionKind.UI,_i={getExtension(_,oe){(0,Xe.$xG)(Ue,"extensionsAny")||(oe=!1);const Le=oi.mine.getExtensionDescription(_);if(Le)return new ve.$ilc(Lt,Ue.identifier,Le,Di,!1);if(oe){const rt=oi.all.getExtensionDescription(_);if(rt)return new ve.$ilc(Lt,Ue.identifier,rt,Di,!0)}},get all(){const _=[];for(const oe of oi.mine.getAllExtensionDescriptions())_.push(new ve.$ilc(Lt,Ue.identifier,oe,Di,!1));return _},get allAcrossExtensionHosts(){(0,Xe.$yG)(Ue,"extensionsAny");const _=new v.$Mm(oi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),oe=[];for(const Le of oi.all.getAllExtensionDescriptions()){const rt=!_.has(Le.identifier);oe.push(new ve.$ilc(Lt,Ue.identifier,Le,Di,rt))}return oe},get onDidChange(){return(0,Xe.$xG)(Ue,"extensionsAny")?xe(R.Event.any(oi.mine.onDidChange,oi.all.onDidChange)):xe(oi.mine.onDidChange)}},en={createDiagnosticCollection(_){return Ft.createDiagnosticCollection(Ue.identifier,_)},get onDidChangeDiagnostics(){return xe(Ft.onDidChangeDiagnostics)},getDiagnostics:_=>Ft.getDiagnostics(_),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(_,oe){return Wt.changeLanguage(_.uri,oe)},match(_,oe){const Le=He.LanguageSelector.from(_);let rt;return(0,N.$Vt)(Le)&&(rt=Se.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(At=>At.document===oe))?.apiNotebook),(0,N.$Ut)(Le,oe.uri,oe.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(_,oe,Le){return ct.registerCodeActionProvider(Ue,bt(_),oe,Le)},registerDocumentPasteEditProvider(_,oe,Le){return(0,Xe.$yG)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,bt(_),oe,Le)},registerCodeLensProvider(_,oe){return ct.registerCodeLensProvider(Ue,bt(_),oe)},registerDefinitionProvider(_,oe){return ct.registerDefinitionProvider(Ue,bt(_),oe)},registerDeclarationProvider(_,oe){return ct.registerDeclarationProvider(Ue,bt(_),oe)},registerImplementationProvider(_,oe){return ct.registerImplementationProvider(Ue,bt(_),oe)},registerTypeDefinitionProvider(_,oe){return ct.registerTypeDefinitionProvider(Ue,bt(_),oe)},registerHoverProvider(_,oe){return ct.registerHoverProvider(Ue,bt(_),oe,Ue.identifier)},registerEvaluatableExpressionProvider(_,oe){return ct.registerEvaluatableExpressionProvider(Ue,bt(_),oe,Ue.identifier)},registerInlineValuesProvider(_,oe){return ct.registerInlineValuesProvider(Ue,bt(_),oe,Ue.identifier)},registerDocumentHighlightProvider(_,oe){return ct.registerDocumentHighlightProvider(Ue,bt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return ct.registerMultiDocumentHighlightProvider(Ue,bt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return ct.registerLinkedEditingRangeProvider(Ue,bt(_),oe)},registerReferenceProvider(_,oe){return ct.registerReferenceProvider(Ue,bt(_),oe)},registerRenameProvider(_,oe){return ct.registerRenameProvider(Ue,bt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Xe.$yG)(Ue,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(Ue,bt(_),oe)},registerDocumentSymbolProvider(_,oe,Le){return ct.registerDocumentSymbolProvider(Ue,bt(_),oe,Le)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(Ue,_)},registerDocumentFormattingEditProvider(_,oe){return ct.registerDocumentFormattingEditProvider(Ue,bt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return ct.registerDocumentRangeFormattingEditProvider(Ue,bt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Le,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,bt(_),oe,[Le].concat(rt))},registerDocumentSemanticTokensProvider(_,oe,Le){return ct.registerDocumentSemanticTokensProvider(Ue,bt(_),oe,Le)},registerDocumentRangeSemanticTokensProvider(_,oe,Le){return ct.registerDocumentRangeSemanticTokensProvider(Ue,bt(_),oe,Le)},registerSignatureHelpProvider(_,oe,Le,...rt){return typeof Le=="object"?ct.registerSignatureHelpProvider(Ue,bt(_),oe,Le):ct.registerSignatureHelpProvider(Ue,bt(_),oe,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(_,oe,...Le){return ct.registerCompletionItemProvider(Ue,bt(_),oe,Le)},registerInlineCompletionItemProvider(_,oe,Le){return oe.handleDidShowCompletionItem&&(0,Xe.$yG)(Ue,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$yG)(Ue,"inlineCompletionsAdditions"),Le&&(0,Xe.$yG)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,bt(_),oe,Le)},registerInlineEditProvider(_,oe){return(0,Xe.$yG)(Ue,"inlineEdit"),ct.registerInlineEditProvider(Ue,bt(_),oe)},registerDocumentLinkProvider(_,oe){return ct.registerDocumentLinkProvider(Ue,bt(_),oe)},registerColorProvider(_,oe){return ct.registerColorProvider(Ue,bt(_),oe)},registerFoldingRangeProvider(_,oe){return ct.registerFoldingRangeProvider(Ue,bt(_),oe)},registerSelectionRangeProvider(_,oe){return ct.registerSelectionRangeProvider(Ue,_,oe)},registerCallHierarchyProvider(_,oe){return ct.registerCallHierarchyProvider(Ue,_,oe)},registerTypeHierarchyProvider(_,oe){return ct.registerTypeHierarchyProvider(Ue,_,oe)},setLanguageConfiguration:(_,oe)=>ct.setLanguageConfiguration(Ue,_,oe),getTokenInformationAtPosition(_,oe){return(0,Xe.$yG)(Ue,"tokenInformation"),Wt.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return ct.registerInlayHintsProvider(Ue,_,oe)},createLanguageStatusItem(_,oe){return Wt.createLanguageStatusItem(Ue,_,oe)},registerDocumentDropEditProvider(_,oe,Le){return ct.registerDocumentOnDropEditProvider(Ue,_,oe,(0,Xe.$xG)(Ue,"documentPaste")?Le:void 0)}},fn={get activeTextEditor(){return qe.getActiveTextEditor()},get visibleTextEditors(){return qe.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(_,oe,Le){g.URI.isUri(_)&&_.scheme===M.Schemas.vscodeRemote&&!_.authority&&Rt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(g.URI.isUri(_)?Promise.resolve(Wi.openTextDocument(_)):Promise.resolve(_));return qe.showTextDocument(rt,oe,Le)},createTextEditorDecorationType(_){return qe.createTextEditorDecorationType(Ue,_)},onDidChangeActiveTextEditor(_,oe,Le){return xe(qe.onDidChangeActiveTextEditor)(_,oe,Le)},onDidChangeVisibleTextEditors(_,oe,Le){return xe(qe.onDidChangeVisibleTextEditors)(_,oe,Le)},onDidChangeTextEditorSelection(_,oe,Le){return xe(qe.onDidChangeTextEditorSelection)(_,oe,Le)},onDidChangeTextEditorOptions(_,oe,Le){return xe(qe.onDidChangeTextEditorOptions)(_,oe,Le)},onDidChangeTextEditorVisibleRanges(_,oe,Le){return xe(qe.onDidChangeTextEditorVisibleRanges)(_,oe,Le)},onDidChangeTextEditorViewColumn(_,oe,Le){return xe(qe.onDidChangeTextEditorViewColumn)(_,oe,Le)},onDidCloseTerminal(_,oe,Le){return xe(St.onDidCloseTerminal)(_,oe,Le)},onDidOpenTerminal(_,oe,Le){return xe(St.onDidOpenTerminal)(_,oe,Le)},onDidChangeActiveTerminal(_,oe,Le){return xe(St.onDidChangeActiveTerminal)(_,oe,Le)},onDidChangeTerminalDimensions(_,oe,Le){return(0,Xe.$yG)(Ue,"terminalDimensions"),xe(St.onDidChangeTerminalDimensions)(_,oe,Le)},onDidChangeTerminalState(_,oe,Le){return xe(St.onDidChangeTerminalState)(_,oe,Le)},onDidWriteTerminalData(_,oe,Le){return(0,Xe.$yG)(Ue,"terminalDataWriteEvent"),xe(St.onDidWriteTerminalData)(_,oe,Le)},onDidExecuteTerminalCommand(_,oe,Le){return(0,Xe.$yG)(Ue,"terminalExecuteCommandEvent"),xe(St.onDidExecuteTerminalCommand)(_,oe,Le)},onDidChangeTerminalShellIntegration(_,oe,Le){return(0,Xe.$yG)(Ue,"terminalShellIntegration"),xe(li.onDidChangeTerminalShellIntegration)(_,oe,Le)},onDidStartTerminalShellExecution(_,oe,Le){return(0,Xe.$yG)(Ue,"terminalShellIntegration"),xe(li.onDidStartTerminalShellExecution)(_,oe,Le)},onDidEndTerminalShellExecution(_,oe,Le){return(0,Xe.$yG)(Ue,"terminalShellIntegration"),xe(li.onDidEndTerminalShellExecution)(_,oe,Le)},get state(){return Ot.getState(Ue)},onDidChangeWindowState(_,oe,Le){return xe(Ot.onDidChangeWindowState)(_,oe,Le)},showInformationMessage(_,...oe){return Pi.showMessage(Ue,p.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return Pi.showMessage(Ue,p.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return Pi.showMessage(Ue,p.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Le){return pi.showQuickPick(Ue,_,oe,Le)},showWorkspaceFolderPick(_){return pi.showWorkspaceFolderPick(_)},showInputBox(_,oe){return pi.showInput(_,oe)},showOpenDialog(_){return ji.showOpenDialog(Ue,_)},showSaveDialog(_){return ji.showSaveDialog(_)},createStatusBarItem(_,oe,Le){let rt,wt,At;return typeof _=="string"?(rt=_,wt=oe,At=Le):(wt=_,At=oe),Zi.createStatusBarEntry(Ue,rt,wt,At)},setStatusBarMessage(_,oe){return Zi.setStatusBarMessage(_,oe)},withScmProgress(_){return Rt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Ni.withProgress(Ue,{location:ye.ProgressLocation.SourceControl},(oe,Le)=>_({report(rt){}}))},withProgress(_,oe){return Ni.withProgress(Ue,_,oe)},createOutputChannel(_,oe){return vi.createOutputChannel(_,oe,Ue)},createWebviewPanel(_,oe,Le,rt){return Ii.createWebviewPanel(Ue,_,oe,Le,rt)},createWebviewTextEditorInset(_,oe,Le,rt){return(0,Xe.$yG)(Ue,"editorInsets"),kt.createWebviewEditorInset(_,oe,Le,rt,Ue)},createTerminal(_,oe,Le){return typeof _=="object"?"pty"in _?St.createExtensionTerminal(_):St.createTerminalFromOptions(_):St.createTerminal(_,oe,Le)},registerTerminalLinkProvider(_){return St.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return St.registerProfileProvider(Ue,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Xe.$yG)(Ue,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(_,Ue.identifier.value,oe)},registerTreeDataProvider(_,oe){return ut.registerTreeDataProvider(_,oe,Ue)},createTreeView(_,oe){return ut.createTreeView(_,oe,Ue)},registerWebviewPanelSerializer:(_,oe)=>Ii.registerWebviewPanelSerializer(Ue,_,oe),registerCustomEditorProvider:(_,oe,Le={})=>Gi.registerCustomEditorProvider(Ue,_,oe,Le),registerFileDecorationProvider(_){return Pt.registerFileDecorationProvider(_,Ue)},registerUriHandler(_){return wi.registerUriHandler(Ue,_)},createQuickPick(){return pi.createQuickPick(Ue)},createInputBox(){return pi.createInputBox(Ue)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Le){return xe(Oi.onDidChangeActiveColorTheme)(_,oe,Le)},registerWebviewViewProvider(_,oe,Le){return Ki.registerWebviewViewProvider(Ue,_,oe,Le?.webviewOptions)},get activeNotebookEditor(){return Se.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Le){return xe(Se.onDidChangeActiveNotebookEditor)(_,oe,Le)},get visibleNotebookEditors(){return Se.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return xe(Se.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Le){return xe(Q.onDidChangeNotebookEditorSelection)(_,oe,Le)},onDidChangeNotebookEditorVisibleRanges(_,oe,Le){return xe(Q.onDidChangeNotebookEditorVisibleRanges)(_,oe,Le)},showNotebookDocument(_,oe){return Se.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Le){return(0,Xe.$yG)(Ue,"externalUriOpener"),Ji.registerExternalUriOpener(Ue.identifier,_,oe,Le)},registerProfileContentHandler(_,oe){return(0,Xe.$yG)(Ue,"profileContentHandlers"),Qi.registerProfileContentHandler(Ue,_,oe)},registerQuickDiffProvider(_,oe,Le,rt){return(0,Xe.$yG)(Ue,"quickDiffProvider"),Ai.registerQuickDiffProvider(bt(_),oe,Le,rt)},get tabGroups(){return Gt.tabGroups},registerShareProvider(_,oe){return(0,Xe.$yG)(Ue,"shareProvider"),Mi.registerShareProvider(bt(_),oe)}},Wi={get rootPath(){return Rt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new T.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new T.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Le)=>ft.updateWorkspaceFolders(Ue,_,oe||0,...Le),onDidChangeWorkspaceFolders:function(_,oe,Le){return xe(ft.onDidChangeWorkspace)(_,oe,Le)},asRelativePath:(_,oe)=>ft.getRelativePath(_,oe),findFiles:(_,oe,Le,rt)=>ft.findFiles(_,oe,Le,Ue.identifier,rt),findFiles2:(_,oe,Le)=>((0,Xe.$yG)(Ue,"findFiles2"),ft.findFiles2(_,oe,Ue.identifier,Le)),findTextInFiles:(_,oe,Le,rt)=>{(0,Xe.$yG)(Ue,"findTextInFiles");let wt,At;return typeof oe=="object"?(wt=oe,At=Le):(wt={},At=oe,rt=Le),ft.findTextInFiles(_,wt||{},At,Ue.identifier,rt)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,oe){return Ui.applyWorkspaceEdit(_,Ue,oe)},createFileSystemWatcher:(_,oe,Le,rt)=>{let wt;return typeof oe=="boolean"?wt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!rt,correlate:!1}:oe&&((0,Xe.$yG)(Ue,"createFileSystemWatcher"),wt={...oe,correlate:!0}),di.createFileSystemWatcher(ft,Ue,_,wt)},get textDocuments(){return yt.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new T.$9("textDocuments")},openTextDocument(_){let oe;const Le=_;if(typeof _=="string")oe=Promise.resolve(g.URI.file(_));else if(g.URI.isUri(_))oe=Promise.resolve(_);else if(!Le||typeof Le=="object")oe=yt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(rt=>(rt.scheme===M.Schemas.vscodeRemote&&!rt.authority&&Rt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),yt.ensureDocumentData(rt).then(wt=>wt.document)))},onDidOpenTextDocument:(_,oe,Le)=>xe(yt.onDidAddDocument)(_,oe,Le),onDidCloseTextDocument:(_,oe,Le)=>xe(yt.onDidRemoveDocument)(_,oe,Le),onDidChangeTextDocument:(_,oe,Le)=>xe(yt.onDidChangeDocument)(_,oe,Le),onDidSaveTextDocument:(_,oe,Le)=>xe(yt.onDidSaveDocument)(_,oe,Le),onWillSaveTextDocument:(_,oe,Le)=>xe(we.getOnWillSaveTextDocumentEvent(Ue))(_,oe,Le),get notebookDocuments(){return Se.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Le;if(g.URI.isUri(_))Le=_,await Se.openNotebookDocument(_);else if(typeof _=="string")Le=g.URI.revive(await Se.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return Se.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,oe,Le){return xe(ae.onDidSaveNotebookDocument)(_,oe,Le)},onDidChangeNotebookDocument(_,oe,Le){return xe(ae.onDidChangeNotebookDocument)(_,oe,Le)},onWillSaveNotebookDocument(_,oe,Le){return xe(Ze.getOnWillSaveNotebookDocumentEvent(Ue))(_,oe,Le)},get onDidOpenNotebookDocument(){return xe(Se.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return xe(Se.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Le,rt){return Se.registerNotebookSerializer(Ue,_,oe,Le,(0,Xe.$xG)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(_,oe,Le)=>xe(Bi.onDidChangeConfiguration)(_,oe,Le),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,Bi.getConfiguration(_,oe,Ue)},registerTextDocumentContentProvider(_,oe){return $i.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(Rt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Ue,_,oe)),registerFileSystemProvider(_,oe,Le){return(0,O.$Rc)(ri.registerFileSystemProvider(Ue,_,oe,Le),Yt.addFileSystemProvider(_,oe,Le))},get fs(){return Yt.value},registerFileSearchProvider:(_,oe)=>((0,Xe.$yG)(Ue,"fileSearchProvider"),hi.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Xe.$yG)(Ue,"textSearchProvider"),hi.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Xe.$yG)(Ue,"aiTextSearchProvider"),(0,Xe.$yG)(Ue,"textSearchProvider"),hi.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Xe.$yG)(Ue,"resolvers"),Lt.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Xe.$yG)(Ue,"resolvers"),cn.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Xe.$yG)(Ue,"resolvers"),Lt.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Le)=>xe(di.onDidCreateFile)(_,oe,Le),onDidDeleteFiles:(_,oe,Le)=>xe(di.onDidDeleteFile)(_,oe,Le),onDidRenameFiles:(_,oe,Le)=>xe(di.onDidRenameFile)(_,oe,Le),onWillCreateFiles:(_,oe,Le)=>xe(di.getOnWillCreateFileEvent(Ue))(_,oe,Le),onWillDeleteFiles:(_,oe,Le)=>xe(di.getOnWillDeleteFileEvent(Ue))(_,oe,Le),onWillRenameFiles:(_,oe,Le)=>xe(di.getOnWillRenameFileEvent(Ue))(_,oe,Le),openTunnel:_=>((0,Xe.$yG)(Ue,"tunnels"),Nt.openTunnel(Ue,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Xe.$yG)(Ue,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:(_,oe,Le)=>((0,Xe.$yG)(Ue,"tunnels"),xe(Nt.onDidChangeTunnels)(_,oe,Le)),registerPortAttributesProvider:(_,oe)=>((0,Xe.$yG)(Ue,"portsAttributes"),Nt.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Xe.$yG)(Ue,"tunnelFactory"),Nt.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Xe.$yG)(Ue,"timeline"),Fi.registerTimelineProvider(_,oe,Ue.identifier,pt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Xe.$yG)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Le)=>xe(ft.onDidGrantWorkspaceTrust)(_,oe,Le),registerEditSessionIdentityProvider:(_,oe)=>((0,Xe.$yG)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Le)=>((0,Xe.$yG)(Ue,"editSessionIdentityProvider"),xe(ft.getOnWillCreateEditSessionIdentityEvent(Ue))(_,oe,Le)),registerCanonicalUriProvider:(_,oe)=>((0,Xe.$yG)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Le)=>((0,Xe.$yG)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri(_,oe,Le))},tn={get inputBox(){return Rt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(Ue)},createSourceControl(_,oe,Le){return Si.createSourceControl(Ue,_,oe,Le)}},gn={createCommentController(_,oe){return Ti.createCommentController(Ue,_,oe)}},mn={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){if((0,Xe.$xG)(Ue,"debugFocus"))return Et.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Xe.$yG)(Ue,"debugVisualization"),Et.registerDebugVisualizationProvider(Ue,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Xe.$yG)(Ue,"debugVisualization"),Et.registerDebugVisualizationTree(Ue,_,oe)},onDidStartDebugSession(_,oe,Le){return xe(Et.onDidStartDebugSession)(_,oe,Le)},onDidTerminateDebugSession(_,oe,Le){return xe(Et.onDidTerminateDebugSession)(_,oe,Le)},onDidChangeActiveDebugSession(_,oe,Le){return xe(Et.onDidChangeActiveDebugSession)(_,oe,Le)},onDidReceiveDebugSessionCustomEvent(_,oe,Le){return xe(Et.onDidReceiveDebugSessionCustomEvent)(_,oe,Le)},onDidChangeBreakpoints(_,oe,Le){return xe(Et.onDidChangeBreakpoints)(_,oe,Le)},onDidChangeActiveStackItem(_,oe,Le){return(0,Xe.$yG)(Ue,"debugFocus"),xe(Et.onDidChangeActiveStackItem)(_,oe,Le)},registerDebugConfigurationProvider(_,oe,Le){return Et.registerDebugConfigurationProvider(_,oe,Le||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return Et.registerDebugAdapterDescriptorFactory(Ue,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return Et.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?Et.startDebugging(_,oe,{parentSession:Le}):Et.startDebugging(_,oe,Le||{})},stopDebugging(_){return Et.stopDebugging(_)},addBreakpoints(_){return Et.addBreakpoints(_)},removeBreakpoints(_){return Et.removeBreakpoints(_)},asDebugSourceUri(_,oe){return Et.asDebugSourceUri(_,oe)}},nn={registerTaskProvider:(_,oe)=>Kt.registerTaskProvider(Ue,_,oe),fetchTasks:_=>Kt.fetchTasks(_),executeTask:_=>Kt.executeTask(Ue,_),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(_,oe,Le)=>xe(Kt.onDidStartTask)(_,oe,Le),onDidEndTask:(_,oe,Le)=>xe(Kt.onDidEndTask)(_,oe,Le),onDidStartTaskProcess:(_,oe,Le)=>xe(Kt.onDidStartTaskProcess)(_,oe,Le),onDidEndTaskProcess:(_,oe,Le)=>xe(Kt.onDidEndTaskProcess)(_,oe,Le)},Vi={createNotebookController(_,oe,Le,rt,wt){return Ee.createNotebookController(Ue,_,oe,Le,rt,(0,Xe.$xG)(Ue,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>Se.registerNotebookCellStatusBarItemProvider(Ue,_,oe),createRendererMessaging(_){return We.createRendererMessaging(Ue,_)},createNotebookControllerDetectionTask(_){return(0,Xe.$yG)(Ue,"notebookKernelSource"),Ee.createNotebookControllerDetectionTask(Ue,_)},registerKernelSourceActionProvider(_,oe){return(0,Xe.$yG)(Ue,"notebookKernelSource"),Ee.registerKernelSourceActionProvider(Ue,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Le){return(0,Xe.$yG)(Ue,"notebookCellExecutionState"),xe(Ee.onDidChangeNotebookCellExecutionState)(_,oe,Le)}},rn={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return ei.getMessage(Ue.identifier.value,{message:oe,args:Le})}return ei.getMessage(Ue.identifier.value,_[0])},get bundle(){return ei.getBundle(Ue.identifier.value)},get uri(){return ei.getBundleUri(Ue.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(_,oe){return(0,Xe.$yG)(Ue,"interactive"),un.registerProvider(Ue,_,oe)},transferActiveChat(_){return(0,Xe.$yG)(Ue,"interactive"),Li.transferActiveChat(_)}},on={getRelatedInformation(_,oe){return(0,Xe.$yG)(Ue,"aiRelatedInformation"),Ci.getRelatedInformation(Ue,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Xe.$yG)(Ue,"aiRelatedInformation"),Ci.registerRelatedInformationProvider(Ue,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Xe.$yG)(Ue,"aiRelatedInformation"),ln.registerEmbeddingVectorProvider(Ue,_,oe)}},$n={registerChatResponseProvider(_,oe,Le){return(0,Xe.$yG)(Ue,"chatProvider"),Tt.registerLanguageModel(Ue,_,oe,Le)},registerChatVariableResolver(_,oe,Le){return(0,Xe.$yG)(Ue,"chatVariableResolver"),zi.registerVariableResolver(Ue,_,oe,Le)},registerMappedEditsProvider(_,oe){return(0,Xe.$yG)(Ue,"mappedEditsProvider"),ct.registerMappedEditsProvider(Ue,_,oe)},createChatParticipant(_,oe){return(0,Xe.$yG)(Ue,"chatParticipant"),Li.createChatAgent(Ue,_,oe)},createDynamicChatParticipant(_,oe,Le,rt){return(0,Xe.$yG)(Ue,"chatParticipantAdditions"),Li.createDynamicChatAgent(Ue,_,oe,Le,rt)}},pn={get languageModels(){return(0,Xe.$yG)(Ue,"languageModels"),Tt.getLanguageModelIds()},onDidChangeLanguageModels:(_,oe,Le)=>((0,Xe.$yG)(Ue,"languageModels"),Tt.onDidChangeProviders(_,oe,Le)),sendChatRequest(_,oe,Le,rt){return(0,Xe.$yG)(Ue,"languageModels"),Tt.sendChatRequest(Ue,_,oe,Le,rt)}},an={registerSpeechProvider(_,oe){return(0,Xe.$yG)(Ue,"speech"),Xi.registerProvider(Ue.identifier,_,oe)}};return{version:vt.version,ai:on,authentication:dn,commands:ai,comments:gn,chat:$n,debug:mn,env:ki,extensions:_i,interactive:sn,l10n:rn,languages:en,lm:pn,notebooks:Vi,scm:tn,speech:an,tasks:nn,tests:xi,window:fn,workspace:Wi,Breakpoint:ye.$SN,TerminalOutputAnchor:ye.TerminalOutputAnchor,ChatResultFeedbackKind:ye.ChatResultFeedbackKind,ChatVariableLevel:ye.ChatVariableLevel,ChatCompletionItem:ye.$NO,CallHierarchyIncomingCall:ye.$eN,CallHierarchyItem:ye.$dN,CallHierarchyOutgoingCall:ye.$fN,CancellationError:T.$5,CancellationTokenSource:I.$me,CandidatePortSource:t.CandidatePortSource,CodeAction:ye.$aN,CodeActionKind:ye.$bN,CodeActionTriggerKind:ye.CodeActionTriggerKind,CodeLens:ye.$gN,Color:ye.$tN,ColorInformation:ye.$uN,ColorPresentation:ye.$vN,ColorThemeKind:ye.ColorThemeKind,CommentMode:ye.CommentMode,CommentState:ye.CommentState,CommentThreadCollapsibleState:ye.CommentThreadCollapsibleState,CommentThreadState:ye.CommentThreadState,CommentThreadApplicability:ye.CommentThreadApplicability,CompletionItem:ye.$nN,CompletionItemKind:ye.CompletionItemKind,CompletionItemTag:ye.CompletionItemTag,CompletionList:ye.$oN,CompletionTriggerKind:ye.CompletionTriggerKind,ConfigurationTarget:ye.ConfigurationTarget,CustomExecution:ye.$DN,DebugAdapterExecutable:ye.$WN,DebugAdapterInlineImplementation:ye.$ZN,DebugAdapterNamedPipeServer:ye.$YN,DebugAdapterServer:ye.$XN,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:ye.DebugConsoleMode,DebugVisualization:ye.$dO,DecorationRangeBehavior:ye.DecorationRangeBehavior,Diagnostic:ye.$7M,DiagnosticRelatedInformation:ye.$6M,DiagnosticSeverity:ye.DiagnosticSeverity,DiagnosticTag:ye.DiagnosticTag,Disposable:ye.$SM,DocumentHighlight:ye.$9M,DocumentHighlightKind:ye.DocumentHighlightKind,MultiDocumentHighlight:ye.$0M,DocumentLink:ye.$sN,DocumentSymbol:ye.$_M,EndOfLine:ye.EndOfLine,EnvironmentVariableMutatorType:ye.EnvironmentVariableMutatorType,EvaluatableExpression:ye.$3N,InlineValueText:ye.$4N,InlineValueVariableLookup:ye.$5N,InlineValueEvaluatableExpression:ye.$6N,InlineCompletionTriggerKind:ye.InlineCompletionTriggerKind,EventEmitter:R.$be,ExtensionKind:ye.ExtensionKind,ExtensionMode:ye.ExtensionMode,ExternalUriOpenerPriority:ye.ExternalUriOpenerPriority,FileChangeType:ye.FileChangeType,FileDecoration:ye.$fO,FileDecoration2:ye.$fO,FileSystemError:ye.$9N,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:ye.$0N,FoldingRangeKind:ye.FoldingRangeKind,FunctionBreakpoint:ye.$UN,InlineCompletionItem:ye.$pN,InlineCompletionList:ye.$qN,Hover:ye.$8M,IndentAction:y.IndentAction,Location:ye.$5M,MarkdownString:ye.$hN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:ye.$iN,PortAutoForwardAction:ye.PortAutoForwardAction,Position:ye.$TM,ProcessExecution:ye.$BN,ProgressLocation:ye.ProgressLocation,QuickInputButtons:ye.$eO,Range:ye.$UM,RelativePattern:ye.$QN,Selection:ye.$VM,SelectionRange:ye.$cN,SemanticTokens:ye.$aO,SemanticTokensBuilder:ye.$_N,SemanticTokensEdit:ye.$bO,SemanticTokensEdits:ye.$cO,SemanticTokensLegend:ye.$$N,ShellExecution:ye.$CN,ShellQuoting:ye.ShellQuoting,SignatureHelp:ye.$kN,SignatureHelpTriggerKind:ye.SignatureHelpTriggerKind,SignatureInformation:ye.$jN,SnippetString:ye.$4M,SourceBreakpoint:ye.$TN,StandardTokenType:ye.StandardTokenType,StatusBarAlignment:ye.StatusBarAlignment,SymbolInformation:ye.$$M,SymbolKind:ye.SymbolKind,SymbolTag:ye.SymbolTag,Task:ye.$EN,TaskGroup:ye.$AN,TaskPanelKind:ye.TaskPanelKind,TaskRevealKind:ye.TaskRevealKind,TaskScope:ye.TaskScope,TerminalLink:ye.$wN,TerminalQuickFixTerminalCommand:ye.$yN,TerminalQuickFixOpener:ye.$xN,TerminalLocation:ye.TerminalLocation,TerminalProfile:ye.$zN,TerminalExitReason:ye.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:ye.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:ye.TextDocumentSaveReason,TextEdit:ye.$ZM,SnippetTextEdit:ye.$2M,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:ye.TextEditorLineNumbersStyle,TextEditorRevealType:ye.TextEditorRevealType,TextEditorSelectionChangeKind:ye.TextEditorSelectionChangeKind,SyntaxTokenType:ye.SyntaxTokenType,TextDocumentChangeReason:ye.TextDocumentChangeReason,ThemeColor:ye.$PN,ThemeIcon:ye.$ON,TreeItem:ye.$FN,TreeItemCheckboxState:ye.TreeItemCheckboxState,TreeItemCollapsibleState:ye.TreeItemCollapsibleState,TypeHierarchyItem:ye.$BO,UIKind:Zt.UIKind,Uri:g.URI,ViewColumn:ye.ViewColumn,WorkspaceEdit:ye.$3M,DocumentPasteTriggerKind:ye.DocumentPasteTriggerKind,DocumentDropEdit:ye.$LN,DocumentDropOrPasteEditKind:ye.$MN,DocumentPasteEdit:ye.$NN,InlayHint:ye.$mN,InlayHintLabelPart:ye.$lN,InlayHintKind:ye.InlayHintKind,RemoteAuthorityResolverError:ye.$YM,ResolvedAuthority:ye.$WM,ManagedResolvedAuthority:ye.$XM,SourceControlInputBoxValidationType:ye.SourceControlInputBoxValidationType,ExtensionRuntime:ye.ExtensionRuntime,TimelineItem:ye.$pO,NotebookRange:ye.$hO,NotebookCellKind:ye.NotebookCellKind,NotebookCellExecutionState:ye.NotebookCellExecutionState,NotebookCellData:ye.$iO,NotebookData:ye.$jO,NotebookRendererScript:ye.$nO,NotebookCellStatusBarAlignment:ye.NotebookCellStatusBarAlignment,NotebookEditorRevealType:ye.NotebookEditorRevealType,NotebookCellOutput:ye.$lO,NotebookCellOutputItem:ye.$kO,NotebookCellStatusBarItem:ye.$mO,NotebookControllerAffinity:ye.NotebookControllerAffinity,NotebookControllerAffinity2:ye.NotebookControllerAffinity2,NotebookEdit:ye.$1M,NotebookKernelSourceAction:ye.$oO,NotebookVariablesRequestKind:ye.NotebookVariablesRequestKind,PortAttributes:ye.$rO,LinkedEditingRanges:ye.$qO,TestResultState:ye.TestResultState,TestRunRequest:ye.$sO,TestMessage:ye.$tO,TestTag:ye.$uO,TestRunProfileKind:ye.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:ye.$KN,DataTransferItem:ye.$GN,TestCoverageCount:ye.$vO,FileCoverage:ye.$xO,StatementCoverage:ye.$yO,BranchCoverage:ye.$zO,DeclarationCoverage:ye.$AO,WorkspaceTrustState:ye.WorkspaceTrustState,LanguageStatusSeverity:ye.LanguageStatusSeverity,QuickPickItemKind:ye.QuickPickItemKind,InputBoxValidationSeverity:ye.InputBoxValidationSeverity,TabInputText:ye.$CO,TabInputTextDiff:ye.$DO,TabInputTextMerge:ye.$EO,TabInputCustom:ye.$FO,TabInputNotebook:ye.$HO,TabInputNotebookDiff:ye.$IO,TabInputWebview:ye.$GO,TabInputTerminal:ye.$JO,TabInputInteractiveWindow:ye.$KO,TabInputChat:ye.$LO,TabInputTextMultiDiff:ye.$MO,TelemetryTrustedValue:r.$_o,LogLevel:s.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:ye.InteractiveSessionVoteDirection,ChatCopyKind:ye.ChatCopyKind,InteractiveEditorResponseFeedbackKind:ye.InteractiveEditorResponseFeedbackKind,StackFrame:ye.$1N,Thread:ye.$2N,RelatedInformationType:ye.RelatedInformationType,SpeechToTextStatus:ye.SpeechToTextStatus,PartialAcceptTriggerKind:ye.PartialAcceptTriggerKind,KeywordRecognitionStatus:ye.KeywordRecognitionStatus,ChatResponseMarkdownPart:ye.$OO,ChatResponseFileTreePart:ye.$RO,ChatResponseAnchorPart:ye.$SO,ChatResponseProgressPart:ye.$TO,ChatResponseReferencePart:ye.$VO,ChatResponseTextEditPart:ye.$WO,ChatResponseMarkdownWithVulnerabilitiesPart:ye.$PO,ChatResponseCommandButtonPart:ye.$UO,ChatResponseDetectedParticipantPart:ye.$QO,ChatRequestTurn:ye.$XO,ChatResponseTurn:ye.$YO,ChatLocation:ye.ChatLocation,LanguageModelChatSystemMessage:ye.$ZO,LanguageModelChatUserMessage:ye.$1O,LanguageModelChatAssistantMessage:ye.$2O,LanguageModelSystemMessage:ye.$ZO,LanguageModelUserMessage:ye.$1O,LanguageModelAssistantMessage:ye.$2O,LanguageModelError:ye.$3O,NewSymbolName:ye.$8N,NewSymbolNameTag:ye.NewSymbolNameTag,InlineEdit:ye.$4O,InlineEditTriggerKind:ye.InlineEditTriggerKind}}}}),define(Re[297],Ae([1,0,55,116,37,110,38,32,67,51,119,121,122,82,86,78,109,64,45,81,62,66,236,13,120,79,80,84,88,114]),function(ge,e,I,T,R,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b,a,$,l,S,d,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$os)($.$clc,$.$blc,1),(0,I.$os)(b.$Xj,i.$pmc,1),(0,I.$os)(s.$hkc,s.$ikc,1),(0,I.$os)(p.$zP,p.$yP,0),(0,I.$os)(S.$rkc,S.$skc,0),(0,I.$os)(d.$9kc,d.$0kc,0),(0,I.$os)(M.$Gkc,M.$Ekc,0),(0,I.$os)(r.$Ikc,r.$Hkc,0),(0,I.$os)(y.$mlc,y.$qlc,0),(0,I.$os)(O.$slc,O.$rlc,0),(0,I.$os)(g.$oP,g.$nP,0),(0,I.$os)(l.$dlc,l.$elc,0),(0,I.$os)(n.$lkc,n.$kkc,0),(0,I.$os)(T.$Xlc,T.$Wlc,1),(0,I.$os)(u.$Ilc,u.$Jlc,0),(0,I.$os)(v.$2kc,v.$1kc,0),(0,I.$os)(N.$$lc,N.$0lc,0),(0,I.$os)(k.$5kc,k.$8kc,0),(0,I.$os)(D.$_lc,D.$amc,0),(0,I.$os)(m.$DCb,m.$ECb,0),(0,I.$os)(o.$nmc,o.$mmc,0),(0,I.$os)(R.$Dkc,R.$Ckc,0),(0,I.$os)(t.$_kc,t.$$kc,0),(0,I.$os)(c.$xP,c.$uP,0),(0,I.$os)(h.$Skc,h.$Tkc,0),(0,I.$os)(a.$klc,a.$llc,0)}),define(Re[298],Ae([1,0,296,39,2,293,7,11,242]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0;class k extends O.$smc{j(){}getModule(v,m){for(const s of this.b){const o=s(v);if(o){v=o;break}}if(this.a.has(v))return this.a.get(v).load(v,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends T.$glc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(g.$yoc);const v=this.h.invokeFunction(I.$omc);this.r=this.h.createInstance(k,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(v){return v.browser}async xb(v,m,s){m=m.with({path:y(m.path,".js")});const o=v?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const r=R.URI.revive(await this.C.$asBrowserUri(m)),n=await fetch(r.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const t=await n.text(),c=`${m.toString(!0)}#vscode-extension`,h=`${t}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(l){throw console.error(o?`Loading code for extension ${o} failed: ${l.message}`:`Loading code failed: ${l.message}`),console.error(`${m.toString(!0)}${typeof l.line=="number"?` line ${l.line}`:""}${typeof l.column=="number"?` column ${l.column}`:""}`),console.error(l),l}v&&await this.w.initializeLocalizedMessages(v);const b={},a={exports:b},$=l=>{const S=this.r.getModule(l,m);if(S===void 0)throw new Error(`Cannot load module '${l}'`);return S};try{return s.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(a,b,$),a.exports!==b?a.exports:b}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}}async $setRemoteEnvironment(v){}async Bb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+v;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,p.$rh)(10)}}e.$zoc=N;function y(u,v){return u.endsWith(v)?u:u+v}}),define(Re[299],Ae([1,0,70,55,13,39,206,85,298]),function(ge,e,I,T,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$os)(R.$Wj,new I.$ni(M.$rmc,[!0],!0)),(0,T.$os)(O.$hlc,g.$zoc,0),(0,T.$os)(p.$Jkc,p.$Kkc,0)}),define(Re[305],Ae([1,0,23,5,77,294,244,19,89,12,2,297,299]),function(ge,e,I,T,R,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(i){return/^(file|vscode-remote):/i.test(i)}const m=fetch.bind(self);function s(i){self.fetch=async function(b,a){return b instanceof Request||v(String(b))&&(b=(await i(N.URI.parse(String(b)))).toString(!0)),m(b,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(b,a,$,l,S){(async()=>(v(a.toString())&&(a=(await i(N.URI.parse(a.toString()))).toString(!0)),super.open(b,a,$??!0,l,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(b,a){if(/^file:/i.test(b.toString()))b=k.$Kg.uriToBrowserUri(N.URI.parse(b.toString())).toString(!0);else if(/^vscode-remote:/i.test(b.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const l=`(${function(f){function E(C){return typeof C=="string"||C instanceof URL?String(C).replace(/^file:\/\//i,"vscode-file://vscode-app"):C}const w=fetch.bind(self);self.fetch=function(C,V){return C instanceof Request?w(C,V):w(E(C),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(C,V,W,q,A){return super.open(C,E(V),W??!0,q,A)}};const P=importScripts.bind(self);self.importScripts=(...C)=>{P(...C.map(E))},P(f)}.toString()}('${b}'))`;a=a||{},a.name=`${name} -> ${a.name||p.$oc(b.toString())}`;const S=new Blob([l],{type:"application/javascript"}),d=URL.createObjectURL(S);return new i(d,a)}}else self.Worker=class extends M.$Aoc{constructor(i,b){super(u,i,{name:p.$oc(i.toString()),...b})}};const o=new class{constructor(){this.pid=void 0}exit(i){y()}};class r{constructor(){const b=new MessageChannel,a=new T.$be;let $=!1;u(b.port2,[b.port2]),b.port1.onmessage=l=>{const{data:S}=l;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const d=I.$Ce.wrap(new Uint8Array(S,0,S.byteLength));if((0,R.$Um)(d,2)){$=!0,t("received terminate message from renderer");return}a.fire(d)},this.protocol={onMessage:a.event,send:l=>{if(!$){const S=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);b.port1.postMessage(S,[S])}}}}}function n(i){return new Promise(b=>{const a=i.onMessage($=>{a.dispose();const l=JSON.parse($.toString());i.send((0,R.$Tm)(0)),b({protocol:i,initData:l})});i.send((0,R.$Tm)(1))})}let t=i=>y();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new r;return{onmessage(b){c(b)&&n(i.protocol).then(a=>{g.mark("code/extHost/didWaitForInitData");const $=new O.$umc(a.protocol,a.initData,o,null,b.data);s(l=>$.asBrowserUri(l)),t=l=>$.terminate(l)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d49050825fb0bbc6778a6e1a5db51fab5578abd6/core/vs/workbench/api/worker/extensionHostWorker.js.map
